// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Advisor.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The details of the snoozed or dismissed rule; for example, the
    /// duration, name, and GUID associated with the rule.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class SuppressionContract : Resource
    {
        /// <summary>
        /// Initializes a new instance of the SuppressionContract class.
        /// </summary>
        public SuppressionContract()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SuppressionContract class.
        /// </summary>
        /// <param name="id">The resource ID.</param>
        /// <param name="name">The name of the resource.</param>
        /// <param name="type">The type of the resource.</param>
        /// <param name="suppressionId">The GUID of the suppression.</param>
        /// <param name="ttl">The duration for which the suppression is
        /// valid.</param>
        public SuppressionContract(string id = default(string), string name = default(string), string type = default(string), string suppressionId = default(string), string ttl = default(string))
            : base(id, name, type)
        {
            SuppressionId = suppressionId;
            Ttl = ttl;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the GUID of the suppression.
        /// </summary>
        [JsonProperty(PropertyName = "properties.suppressionId")]
        public string SuppressionId { get; set; }

        /// <summary>
        /// Gets or sets the duration for which the suppression is valid.
        /// </summary>
        [JsonProperty(PropertyName = "properties.ttl")]
        public string Ttl { get; set; }

    }
}
