// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.AlertsManagement.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Target scope for a given action rule. By default scope will be the
    /// subscription. User can also provide list of resource groups or list of
    /// resources from the scope subscription as well.
    /// </summary>
    public partial class Scope
    {
        /// <summary>
        /// Initializes a new instance of the Scope class.
        /// </summary>
        public Scope()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Scope class.
        /// </summary>
        /// <param name="scopeType">type of target scope. Possible values
        /// include: 'ResourceGroup', 'Resource'</param>
        /// <param name="values">list of ARM IDs of the given scope type which
        /// will be the target of the given action rule.</param>
        public Scope(string scopeType = default(string), IList<string> values = default(IList<string>))
        {
            ScopeType = scopeType;
            Values = values;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets type of target scope. Possible values include:
        /// 'ResourceGroup', 'Resource'
        /// </summary>
        [JsonProperty(PropertyName = "scopeType")]
        public string ScopeType { get; set; }

        /// <summary>
        /// Gets or sets list of ARM IDs of the given scope type which will be
        /// the target of the given action rule.
        /// </summary>
        [JsonProperty(PropertyName = "values")]
        public IList<string> Values { get; set; }

    }
}
