// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Analysis
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ServersOperations.
    /// </summary>
    public static partial class ServersOperationsExtensions
    {
            /// <summary>
            /// Gets details about the specified Analysis Services server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be a minimum of 3
            /// characters, and a maximum of 63.
            /// </param>
            public static AnalysisServicesServer GetDetails(this IServersOperations operations, string resourceGroupName, string serverName)
            {
                return operations.GetDetailsAsync(resourceGroupName, serverName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets details about the specified Analysis Services server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be a minimum of 3
            /// characters, and a maximum of 63.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AnalysisServicesServer> GetDetailsAsync(this IServersOperations operations, string resourceGroupName, string serverName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetDetailsWithHttpMessagesAsync(resourceGroupName, serverName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Provisions the specified Analysis Services server based on the
            /// configuration specified in the request.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be a minimum of 3
            /// characters, and a maximum of 63.
            /// </param>
            /// <param name='serverParameters'>
            /// Contains the information used to provision the Analysis Services server.
            /// </param>
            public static AnalysisServicesServer Create(this IServersOperations operations, string resourceGroupName, string serverName, AnalysisServicesServer serverParameters)
            {
                return operations.CreateAsync(resourceGroupName, serverName, serverParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Provisions the specified Analysis Services server based on the
            /// configuration specified in the request.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be a minimum of 3
            /// characters, and a maximum of 63.
            /// </param>
            /// <param name='serverParameters'>
            /// Contains the information used to provision the Analysis Services server.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AnalysisServicesServer> CreateAsync(this IServersOperations operations, string resourceGroupName, string serverName, AnalysisServicesServer serverParameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateWithHttpMessagesAsync(resourceGroupName, serverName, serverParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the specified Analysis Services server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            public static void Delete(this IServersOperations operations, string resourceGroupName, string serverName)
            {
                operations.DeleteAsync(resourceGroupName, serverName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the specified Analysis Services server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IServersOperations operations, string resourceGroupName, string serverName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, serverName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Updates the current state of the specified Analysis Services server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='serverUpdateParameters'>
            /// Request object that contains the updated information for the server.
            /// </param>
            public static AnalysisServicesServer Update(this IServersOperations operations, string resourceGroupName, string serverName, AnalysisServicesServerUpdateParameters serverUpdateParameters)
            {
                return operations.UpdateAsync(resourceGroupName, serverName, serverUpdateParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates the current state of the specified Analysis Services server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='serverUpdateParameters'>
            /// Request object that contains the updated information for the server.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AnalysisServicesServer> UpdateAsync(this IServersOperations operations, string resourceGroupName, string serverName, AnalysisServicesServerUpdateParameters serverUpdateParameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(resourceGroupName, serverName, serverUpdateParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Supends operation of the specified Analysis Services server instance.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            public static void Suspend(this IServersOperations operations, string resourceGroupName, string serverName)
            {
                operations.SuspendAsync(resourceGroupName, serverName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Supends operation of the specified Analysis Services server instance.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task SuspendAsync(this IServersOperations operations, string resourceGroupName, string serverName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.SuspendWithHttpMessagesAsync(resourceGroupName, serverName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Resumes operation of the specified Analysis Services server instance.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            public static void Resume(this IServersOperations operations, string resourceGroupName, string serverName)
            {
                operations.ResumeAsync(resourceGroupName, serverName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Resumes operation of the specified Analysis Services server instance.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task ResumeAsync(this IServersOperations operations, string resourceGroupName, string serverName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.ResumeWithHttpMessagesAsync(resourceGroupName, serverName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Gets all the Analysis Services servers for the given resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            public static IEnumerable<AnalysisServicesServer> ListByResourceGroup(this IServersOperations operations, string resourceGroupName)
            {
                return operations.ListByResourceGroupAsync(resourceGroupName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets all the Analysis Services servers for the given resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IEnumerable<AnalysisServicesServer>> ListByResourceGroupAsync(this IServersOperations operations, string resourceGroupName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByResourceGroupWithHttpMessagesAsync(resourceGroupName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists all the Analysis Services servers for the given subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static IEnumerable<AnalysisServicesServer> List(this IServersOperations operations)
            {
                return operations.ListAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists all the Analysis Services servers for the given subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IEnumerable<AnalysisServicesServer>> ListAsync(this IServersOperations operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists eligible SKUs for Analysis Services resource provider.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static SkuEnumerationForNewResourceResult ListSkusForNew(this IServersOperations operations)
            {
                return operations.ListSkusForNewAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists eligible SKUs for Analysis Services resource provider.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<SkuEnumerationForNewResourceResult> ListSkusForNewAsync(this IServersOperations operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListSkusForNewWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists eligible SKUs for an Analysis Services resource.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            public static SkuEnumerationForExistingResourceResult ListSkusForExisting(this IServersOperations operations, string resourceGroupName, string serverName)
            {
                return operations.ListSkusForExistingAsync(resourceGroupName, serverName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists eligible SKUs for an Analysis Services resource.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<SkuEnumerationForExistingResourceResult> ListSkusForExistingAsync(this IServersOperations operations, string resourceGroupName, string serverName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListSkusForExistingWithHttpMessagesAsync(resourceGroupName, serverName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Return the gateway status of the specified Analysis Services server
            /// instance.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server.
            /// </param>
            public static GatewayListStatusLive ListGatewayStatus(this IServersOperations operations, string resourceGroupName, string serverName)
            {
                return operations.ListGatewayStatusAsync(resourceGroupName, serverName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Return the gateway status of the specified Analysis Services server
            /// instance.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<GatewayListStatusLive> ListGatewayStatusAsync(this IServersOperations operations, string resourceGroupName, string serverName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListGatewayStatusWithHttpMessagesAsync(resourceGroupName, serverName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Dissociates a Unified Gateway associated with the server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            public static void DissociateGateway(this IServersOperations operations, string resourceGroupName, string serverName)
            {
                operations.DissociateGatewayAsync(resourceGroupName, serverName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Dissociates a Unified Gateway associated with the server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DissociateGatewayAsync(this IServersOperations operations, string resourceGroupName, string serverName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DissociateGatewayWithHttpMessagesAsync(resourceGroupName, serverName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Check the name availability in the target location.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The region name which the operation will lookup into.
            /// </param>
            /// <param name='serverParameters'>
            /// Contains the information used to provision the Analysis Services server.
            /// </param>
            public static CheckServerNameAvailabilityResult CheckNameAvailability(this IServersOperations operations, string location, CheckServerNameAvailabilityParameters serverParameters)
            {
                return operations.CheckNameAvailabilityAsync(location, serverParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Check the name availability in the target location.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The region name which the operation will lookup into.
            /// </param>
            /// <param name='serverParameters'>
            /// Contains the information used to provision the Analysis Services server.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<CheckServerNameAvailabilityResult> CheckNameAvailabilityAsync(this IServersOperations operations, string location, CheckServerNameAvailabilityParameters serverParameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CheckNameAvailabilityWithHttpMessagesAsync(location, serverParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// List the result of the specified operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The region name which the operation will lookup into.
            /// </param>
            /// <param name='operationId'>
            /// The target operation Id.
            /// </param>
            public static void ListOperationResults(this IServersOperations operations, string location, string operationId)
            {
                operations.ListOperationResultsAsync(location, operationId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List the result of the specified operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The region name which the operation will lookup into.
            /// </param>
            /// <param name='operationId'>
            /// The target operation Id.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task ListOperationResultsAsync(this IServersOperations operations, string location, string operationId, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.ListOperationResultsWithHttpMessagesAsync(location, operationId, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// List the status of operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The region name which the operation will lookup into.
            /// </param>
            /// <param name='operationId'>
            /// The target operation Id.
            /// </param>
            public static OperationStatus ListOperationStatuses(this IServersOperations operations, string location, string operationId)
            {
                return operations.ListOperationStatusesAsync(location, operationId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List the status of operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The region name which the operation will lookup into.
            /// </param>
            /// <param name='operationId'>
            /// The target operation Id.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<OperationStatus> ListOperationStatusesAsync(this IServersOperations operations, string location, string operationId, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListOperationStatusesWithHttpMessagesAsync(location, operationId, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Provisions the specified Analysis Services server based on the
            /// configuration specified in the request.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be a minimum of 3
            /// characters, and a maximum of 63.
            /// </param>
            /// <param name='serverParameters'>
            /// Contains the information used to provision the Analysis Services server.
            /// </param>
            public static AnalysisServicesServer BeginCreate(this IServersOperations operations, string resourceGroupName, string serverName, AnalysisServicesServer serverParameters)
            {
                return operations.BeginCreateAsync(resourceGroupName, serverName, serverParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Provisions the specified Analysis Services server based on the
            /// configuration specified in the request.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be a minimum of 3
            /// characters, and a maximum of 63.
            /// </param>
            /// <param name='serverParameters'>
            /// Contains the information used to provision the Analysis Services server.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AnalysisServicesServer> BeginCreateAsync(this IServersOperations operations, string resourceGroupName, string serverName, AnalysisServicesServer serverParameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateWithHttpMessagesAsync(resourceGroupName, serverName, serverParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the specified Analysis Services server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            public static void BeginDelete(this IServersOperations operations, string resourceGroupName, string serverName)
            {
                operations.BeginDeleteAsync(resourceGroupName, serverName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the specified Analysis Services server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginDeleteAsync(this IServersOperations operations, string resourceGroupName, string serverName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginDeleteWithHttpMessagesAsync(resourceGroupName, serverName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Updates the current state of the specified Analysis Services server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='serverUpdateParameters'>
            /// Request object that contains the updated information for the server.
            /// </param>
            public static AnalysisServicesServer BeginUpdate(this IServersOperations operations, string resourceGroupName, string serverName, AnalysisServicesServerUpdateParameters serverUpdateParameters)
            {
                return operations.BeginUpdateAsync(resourceGroupName, serverName, serverUpdateParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates the current state of the specified Analysis Services server.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='serverUpdateParameters'>
            /// Request object that contains the updated information for the server.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AnalysisServicesServer> BeginUpdateAsync(this IServersOperations operations, string resourceGroupName, string serverName, AnalysisServicesServerUpdateParameters serverUpdateParameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginUpdateWithHttpMessagesAsync(resourceGroupName, serverName, serverUpdateParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Supends operation of the specified Analysis Services server instance.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            public static void BeginSuspend(this IServersOperations operations, string resourceGroupName, string serverName)
            {
                operations.BeginSuspendAsync(resourceGroupName, serverName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Supends operation of the specified Analysis Services server instance.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginSuspendAsync(this IServersOperations operations, string resourceGroupName, string serverName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginSuspendWithHttpMessagesAsync(resourceGroupName, serverName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Resumes operation of the specified Analysis Services server instance.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            public static void BeginResume(this IServersOperations operations, string resourceGroupName, string serverName)
            {
                operations.BeginResumeAsync(resourceGroupName, serverName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Resumes operation of the specified Analysis Services server instance.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource group of which a given Analysis Services
            /// server is part. This name must be at least 1 character in length, and no
            /// more than 90.
            /// </param>
            /// <param name='serverName'>
            /// The name of the Analysis Services server. It must be at least 3 characters
            /// in length, and no more than 63.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginResumeAsync(this IServersOperations operations, string resourceGroupName, string serverName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginResumeWithHttpMessagesAsync(resourceGroupName, serverName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

    }
}
