// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// API Export result.
    /// </summary>
    public partial class ApiExportResult
    {
        /// <summary>
        /// Initializes a new instance of the ApiExportResult class.
        /// </summary>
        public ApiExportResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ApiExportResult class.
        /// </summary>
        /// <param name="id">ResourceId of the API which was exported.</param>
        /// <param name="exportResultFormat">Format in which the Api Details
        /// are exported to the Storage Blob with Sas Key valid for 5 minutes.
        /// Possible values include: 'Swagger', 'Wsdl', 'Wadl',
        /// 'OpenApi'</param>
        /// <param name="value">The object defining the schema of the exported
        /// Api Detail</param>
        public ApiExportResult(string id = default(string), string exportResultFormat = default(string), ApiExportResultValue value = default(ApiExportResultValue))
        {
            Id = id;
            ExportResultFormat = exportResultFormat;
            Value = value;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets resourceId of the API which was exported.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets format in which the Api Details are exported to the
        /// Storage Blob with Sas Key valid for 5 minutes. Possible values
        /// include: 'Swagger', 'Wsdl', 'Wadl', 'OpenApi'
        /// </summary>
        [JsonProperty(PropertyName = "format")]
        public string ExportResultFormat { get; set; }

        /// <summary>
        /// Gets or sets the object defining the schema of the exported Api
        /// Detail
        /// </summary>
        [JsonProperty(PropertyName = "value")]
        public ApiExportResultValue Value { get; set; }

    }
}
