// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Parameters supplied to the Backup/Restore of an API Management service
    /// operation.
    /// </summary>
    public partial class ApiManagementServiceBackupRestoreParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ApiManagementServiceBackupRestoreParameters class.
        /// </summary>
        public ApiManagementServiceBackupRestoreParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ApiManagementServiceBackupRestoreParameters class.
        /// </summary>
        /// <param name="storageAccount">Azure Cloud Storage account (used to
        /// place/retrieve the backup) name.</param>
        /// <param name="accessKey">Azure Cloud Storage account (used to
        /// place/retrieve the backup) access key.</param>
        /// <param name="containerName">Azure Cloud Storage blob container name
        /// used to place/retrieve the backup.</param>
        /// <param name="backupName">The name of the backup file to
        /// create.</param>
        public ApiManagementServiceBackupRestoreParameters(string storageAccount, string accessKey, string containerName, string backupName)
        {
            StorageAccount = storageAccount;
            AccessKey = accessKey;
            ContainerName = containerName;
            BackupName = backupName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets azure Cloud Storage account (used to place/retrieve
        /// the backup) name.
        /// </summary>
        [JsonProperty(PropertyName = "storageAccount")]
        public string StorageAccount { get; set; }

        /// <summary>
        /// Gets or sets azure Cloud Storage account (used to place/retrieve
        /// the backup) access key.
        /// </summary>
        [JsonProperty(PropertyName = "accessKey")]
        public string AccessKey { get; set; }

        /// <summary>
        /// Gets or sets azure Cloud Storage blob container name used to
        /// place/retrieve the backup.
        /// </summary>
        [JsonProperty(PropertyName = "containerName")]
        public string ContainerName { get; set; }

        /// <summary>
        /// Gets or sets the name of the backup file to create.
        /// </summary>
        [JsonProperty(PropertyName = "backupName")]
        public string BackupName { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (StorageAccount == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "StorageAccount");
            }
            if (AccessKey == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AccessKey");
            }
            if (ContainerName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ContainerName");
            }
            if (BackupName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "BackupName");
            }
        }
    }
}
