// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// API Management service resource SKU properties.
    /// </summary>
    public partial class ApiManagementServiceSkuProperties
    {
        /// <summary>
        /// Initializes a new instance of the ApiManagementServiceSkuProperties
        /// class.
        /// </summary>
        public ApiManagementServiceSkuProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ApiManagementServiceSkuProperties
        /// class.
        /// </summary>
        /// <param name="name">Name of the Sku. Possible values include:
        /// 'Developer', 'Standard', 'Premium', 'Basic', 'Consumption'</param>
        /// <param name="capacity">Capacity of the SKU (number of deployed
        /// units of the SKU).</param>
        public ApiManagementServiceSkuProperties(string name, int? capacity = default(int?))
        {
            Name = name;
            Capacity = capacity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the Sku. Possible values include: 'Developer',
        /// 'Standard', 'Premium', 'Basic', 'Consumption'
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets capacity of the SKU (number of deployed units of the
        /// SKU).
        /// </summary>
        [JsonProperty(PropertyName = "capacity")]
        public int? Capacity { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
        }
    }
}
