// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Object used to create an API Revision or Version based on an existing
    /// API Revision
    /// </summary>
    public partial class ApiRevisionInfoContract
    {
        /// <summary>
        /// Initializes a new instance of the ApiRevisionInfoContract class.
        /// </summary>
        public ApiRevisionInfoContract()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ApiRevisionInfoContract class.
        /// </summary>
        /// <param name="sourceApiId">Resource identifier of API to be used to
        /// create the revision from.</param>
        /// <param name="apiVersionName">Version identifier for the new API
        /// Version.</param>
        /// <param name="apiRevisionDescription">Description of new API
        /// Revision.</param>
        /// <param name="apiVersionSet">Version set details</param>
        public ApiRevisionInfoContract(string sourceApiId = default(string), string apiVersionName = default(string), string apiRevisionDescription = default(string), ApiVersionSetContractDetails apiVersionSet = default(ApiVersionSetContractDetails))
        {
            SourceApiId = sourceApiId;
            ApiVersionName = apiVersionName;
            ApiRevisionDescription = apiRevisionDescription;
            ApiVersionSet = apiVersionSet;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets resource identifier of API to be used to create the
        /// revision from.
        /// </summary>
        [JsonProperty(PropertyName = "sourceApiId")]
        public string SourceApiId { get; set; }

        /// <summary>
        /// Gets or sets version identifier for the new API Version.
        /// </summary>
        [JsonProperty(PropertyName = "apiVersionName")]
        public string ApiVersionName { get; set; }

        /// <summary>
        /// Gets or sets description of new API Revision.
        /// </summary>
        [JsonProperty(PropertyName = "apiRevisionDescription")]
        public string ApiRevisionDescription { get; set; }

        /// <summary>
        /// Gets or sets version set details
        /// </summary>
        [JsonProperty(PropertyName = "apiVersionSet")]
        public ApiVersionSetContractDetails ApiVersionSet { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ApiVersionName != null)
            {
                if (ApiVersionName.Length > 100)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "ApiVersionName", 100);
                }
            }
            if (ApiRevisionDescription != null)
            {
                if (ApiRevisionDescription.Length > 256)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "ApiRevisionDescription", 256);
                }
            }
        }
    }
}
