// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// SSL certificate information.
    /// </summary>
    public partial class CertificateInformation
    {
        /// <summary>
        /// Initializes a new instance of the CertificateInformation class.
        /// </summary>
        public CertificateInformation()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CertificateInformation class.
        /// </summary>
        /// <param name="expiry">Expiration date of the certificate. The date
        /// conforms to the following format: `yyyy-MM-ddTHH:mm:ssZ` as
        /// specified by the ISO 8601 standard.</param>
        /// <param name="thumbprint">Thumbprint of the certificate.</param>
        /// <param name="subject">Subject of the certificate.</param>
        public CertificateInformation(System.DateTime expiry, string thumbprint, string subject)
        {
            Expiry = expiry;
            Thumbprint = thumbprint;
            Subject = subject;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets expiration date of the certificate. The date conforms
        /// to the following format: `yyyy-MM-ddTHH:mm:ssZ` as specified by the
        /// ISO 8601 standard.
        /// </summary>
        [JsonProperty(PropertyName = "expiry")]
        public System.DateTime Expiry { get; set; }

        /// <summary>
        /// Gets or sets thumbprint of the certificate.
        /// </summary>
        [JsonProperty(PropertyName = "thumbprint")]
        public string Thumbprint { get; set; }

        /// <summary>
        /// Gets or sets subject of the certificate.
        /// </summary>
        [JsonProperty(PropertyName = "subject")]
        public string Subject { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Thumbprint == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Thumbprint");
            }
            if (Subject == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Subject");
            }
        }
    }
}
