// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{

    /// <summary>
    /// Defines values for ContentFormat.
    /// </summary>
    public static class ContentFormat
    {
        /// <summary>
        /// The contents are inline and Content type is a WADL document.
        /// </summary>
        public const string WadlXml = "wadl-xml";
        /// <summary>
        /// The WADL document is hosted on a publicly accessible internet
        /// address.
        /// </summary>
        public const string WadlLinkJson = "wadl-link-json";
        /// <summary>
        /// The contents are inline and Content Type is a OpenApi 2.0 Document.
        /// </summary>
        public const string SwaggerJson = "swagger-json";
        /// <summary>
        /// The Open Api 2.0 document is hosted on a publicly accessible
        /// internet address.
        /// </summary>
        public const string SwaggerLinkJson = "swagger-link-json";
        /// <summary>
        /// The contents are inline and the document is a WSDL/Soap document.
        /// </summary>
        public const string Wsdl = "wsdl";
        /// <summary>
        /// The WSDL document is hosted on a publicly accessible internet
        /// address.
        /// </summary>
        public const string WsdlLink = "wsdl-link";
        /// <summary>
        /// The contents are inline and Content Type is a OpenApi 3.0 Document
        /// in YAML format.
        /// </summary>
        public const string Openapi = "openapi";
        /// <summary>
        /// The contents are inline and Content Type is a OpenApi 3.0 Document
        /// in JSON format.
        /// </summary>
        public const string Openapijson = "openapi+json";
        /// <summary>
        /// The Open Api 3.0 document is hosted on a publicly accessible
        /// internet address.
        /// </summary>
        public const string OpenapiLink = "openapi-link";
    }
}
