// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Email Template Parameter contract.
    /// </summary>
    public partial class EmailTemplateParametersContractProperties
    {
        /// <summary>
        /// Initializes a new instance of the
        /// EmailTemplateParametersContractProperties class.
        /// </summary>
        public EmailTemplateParametersContractProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// EmailTemplateParametersContractProperties class.
        /// </summary>
        /// <param name="name">Template parameter name.</param>
        /// <param name="title">Template parameter title.</param>
        /// <param name="description">Template parameter description.</param>
        public EmailTemplateParametersContractProperties(string name = default(string), string title = default(string), string description = default(string))
        {
            Name = name;
            Title = title;
            Description = description;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets template parameter name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets template parameter title.
        /// </summary>
        [JsonProperty(PropertyName = "title")]
        public string Title { get; set; }

        /// <summary>
        /// Gets or sets template parameter description.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name != null)
            {
                if (Name.Length > 256)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "Name", 256);
                }
                if (Name.Length < 1)
                {
                    throw new ValidationException(ValidationRules.MinLength, "Name", 1);
                }
                if (!System.Text.RegularExpressions.Regex.IsMatch(Name, "^[A-Za-z0-9-._]+$"))
                {
                    throw new ValidationException(ValidationRules.Pattern, "Name", "^[A-Za-z0-9-._]+$");
                }
            }
            if (Title != null)
            {
                if (Title.Length > 4096)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "Title", 4096);
                }
                if (Title.Length < 1)
                {
                    throw new ValidationException(ValidationRules.MinLength, "Title", 1);
                }
            }
            if (Description != null)
            {
                if (Description.Length > 256)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "Description", 256);
                }
                if (Description.Length < 1)
                {
                    throw new ValidationException(ValidationRules.MinLength, "Description", 1);
                }
                if (!System.Text.RegularExpressions.Regex.IsMatch(Description, "^[A-Za-z0-9-._]+$"))
                {
                    throw new ValidationException(ValidationRules.Pattern, "Description", "^[A-Za-z0-9-._]+$");
                }
            }
        }
    }
}
