// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Email Template update Parameters.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class EmailTemplateUpdateParameters
    {
        /// <summary>
        /// Initializes a new instance of the EmailTemplateUpdateParameters
        /// class.
        /// </summary>
        public EmailTemplateUpdateParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EmailTemplateUpdateParameters
        /// class.
        /// </summary>
        /// <param name="subject">Subject of the Template.</param>
        /// <param name="title">Title of the Template.</param>
        /// <param name="description">Description of the Email
        /// Template.</param>
        /// <param name="body">Email Template Body. This should be a valid
        /// XDocument</param>
        /// <param name="parameters">Email Template Parameter values.</param>
        public EmailTemplateUpdateParameters(string subject = default(string), string title = default(string), string description = default(string), string body = default(string), IList<EmailTemplateParametersContractProperties> parameters = default(IList<EmailTemplateParametersContractProperties>))
        {
            Subject = subject;
            Title = title;
            Description = description;
            Body = body;
            Parameters = parameters;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets subject of the Template.
        /// </summary>
        [JsonProperty(PropertyName = "properties.subject")]
        public string Subject { get; set; }

        /// <summary>
        /// Gets or sets title of the Template.
        /// </summary>
        [JsonProperty(PropertyName = "properties.title")]
        public string Title { get; set; }

        /// <summary>
        /// Gets or sets description of the Email Template.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets email Template Body. This should be a valid XDocument
        /// </summary>
        [JsonProperty(PropertyName = "properties.body")]
        public string Body { get; set; }

        /// <summary>
        /// Gets or sets email Template Parameter values.
        /// </summary>
        [JsonProperty(PropertyName = "properties.parameters")]
        public IList<EmailTemplateParametersContractProperties> Parameters { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Subject != null)
            {
                if (Subject.Length > 1000)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "Subject", 1000);
                }
                if (Subject.Length < 1)
                {
                    throw new ValidationException(ValidationRules.MinLength, "Subject", 1);
                }
            }
            if (Body != null)
            {
                if (Body.Length < 1)
                {
                    throw new ValidationException(ValidationRules.MinLength, "Body", 1);
                }
            }
            if (Parameters != null)
            {
                foreach (var element in Parameters)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
