// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Http message diagnostic settings.
    /// </summary>
    public partial class HttpMessageDiagnostic
    {
        /// <summary>
        /// Initializes a new instance of the HttpMessageDiagnostic class.
        /// </summary>
        public HttpMessageDiagnostic()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the HttpMessageDiagnostic class.
        /// </summary>
        /// <param name="headers">Array of HTTP Headers to log.</param>
        /// <param name="body">Body logging settings.</param>
        public HttpMessageDiagnostic(IList<string> headers = default(IList<string>), BodyDiagnosticSettings body = default(BodyDiagnosticSettings))
        {
            Headers = headers;
            Body = body;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets array of HTTP Headers to log.
        /// </summary>
        [JsonProperty(PropertyName = "headers")]
        public IList<string> Headers { get; set; }

        /// <summary>
        /// Gets or sets body logging settings.
        /// </summary>
        [JsonProperty(PropertyName = "body")]
        public BodyDiagnosticSettings Body { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Body != null)
            {
                Body.Validate();
            }
        }
    }
}
