// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Issue Comment Contract details.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class IssueCommentContract : Resource
    {
        /// <summary>
        /// Initializes a new instance of the IssueCommentContract class.
        /// </summary>
        public IssueCommentContract()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IssueCommentContract class.
        /// </summary>
        /// <param name="text">Comment text.</param>
        /// <param name="userId">A resource identifier for the user who left
        /// the comment.</param>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type for API Management
        /// resource.</param>
        /// <param name="createdDate">Date and time when the comment was
        /// created.</param>
        public IssueCommentContract(string text, string userId, string id = default(string), string name = default(string), string type = default(string), System.DateTime? createdDate = default(System.DateTime?))
            : base(id, name, type)
        {
            Text = text;
            CreatedDate = createdDate;
            UserId = userId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets comment text.
        /// </summary>
        [JsonProperty(PropertyName = "properties.text")]
        public string Text { get; set; }

        /// <summary>
        /// Gets or sets date and time when the comment was created.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdDate")]
        public System.DateTime? CreatedDate { get; set; }

        /// <summary>
        /// Gets or sets a resource identifier for the user who left the
        /// comment.
        /// </summary>
        [JsonProperty(PropertyName = "properties.userId")]
        public string UserId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Text == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Text");
            }
            if (UserId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "UserId");
            }
        }
    }
}
