// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Operation Result.
    /// </summary>
    public partial class OperationResultContract
    {
        /// <summary>
        /// Initializes a new instance of the OperationResultContract class.
        /// </summary>
        public OperationResultContract()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OperationResultContract class.
        /// </summary>
        /// <param name="id">Operation result identifier.</param>
        /// <param name="status">Status of an async operation. Possible values
        /// include: 'Started', 'InProgress', 'Succeeded', 'Failed'</param>
        /// <param name="started">Start time of an async operation. The date
        /// conforms to the following format: `yyyy-MM-ddTHH:mm:ssZ` as
        /// specified by the ISO 8601 standard.
        /// </param>
        /// <param name="updated">Last update time of an async operation. The
        /// date conforms to the following format: `yyyy-MM-ddTHH:mm:ssZ` as
        /// specified by the ISO 8601 standard.
        /// </param>
        /// <param name="resultInfo">Optional result info.</param>
        /// <param name="error">Error Body Contract</param>
        /// <param name="actionLog">This property if only provided as part of
        /// the TenantConfiguration_Validate operation. It contains the log the
        /// entities which will be updated/created/deleted as part of the
        /// TenantConfiguration_Deploy operation.</param>
        public OperationResultContract(string id = default(string), AsyncOperationStatus? status = default(AsyncOperationStatus?), System.DateTime? started = default(System.DateTime?), System.DateTime? updated = default(System.DateTime?), string resultInfo = default(string), ErrorResponseBody error = default(ErrorResponseBody), IList<OperationResultLogItemContract> actionLog = default(IList<OperationResultLogItemContract>))
        {
            Id = id;
            Status = status;
            Started = started;
            Updated = updated;
            ResultInfo = resultInfo;
            Error = error;
            ActionLog = actionLog;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets operation result identifier.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets status of an async operation. Possible values include:
        /// 'Started', 'InProgress', 'Succeeded', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public AsyncOperationStatus? Status { get; set; }

        /// <summary>
        /// Gets or sets start time of an async operation. The date conforms to
        /// the following format: `yyyy-MM-ddTHH:mm:ssZ` as specified by the
        /// ISO 8601 standard.
        ///
        /// </summary>
        [JsonProperty(PropertyName = "started")]
        public System.DateTime? Started { get; set; }

        /// <summary>
        /// Gets or sets last update time of an async operation. The date
        /// conforms to the following format: `yyyy-MM-ddTHH:mm:ssZ` as
        /// specified by the ISO 8601 standard.
        ///
        /// </summary>
        [JsonProperty(PropertyName = "updated")]
        public System.DateTime? Updated { get; set; }

        /// <summary>
        /// Gets or sets optional result info.
        /// </summary>
        [JsonProperty(PropertyName = "resultInfo")]
        public string ResultInfo { get; set; }

        /// <summary>
        /// Gets or sets error Body Contract
        /// </summary>
        [JsonProperty(PropertyName = "error")]
        public ErrorResponseBody Error { get; set; }

        /// <summary>
        /// Gets this property if only provided as part of the
        /// TenantConfiguration_Validate operation. It contains the log the
        /// entities which will be updated/created/deleted as part of the
        /// TenantConfiguration_Deploy operation.
        /// </summary>
        [JsonProperty(PropertyName = "actionLog")]
        public IList<OperationResultLogItemContract> ActionLog { get; private set; }

    }
}
