// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Operation Entity contract Properties.
    /// </summary>
    public partial class OperationTagResourceContractProperties
    {
        /// <summary>
        /// Initializes a new instance of the
        /// OperationTagResourceContractProperties class.
        /// </summary>
        public OperationTagResourceContractProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// OperationTagResourceContractProperties class.
        /// </summary>
        /// <param name="id">Identifier of the operation in form
        /// /operations/{operationId}.</param>
        /// <param name="name">Operation name.</param>
        /// <param name="apiName">Api Name.</param>
        /// <param name="apiRevision">Api Revision.</param>
        /// <param name="apiVersion">Api Version.</param>
        /// <param name="description">Operation Description.</param>
        /// <param name="method">A Valid HTTP Operation Method. Typical Http
        /// Methods like GET, PUT, POST but not limited by only them.</param>
        /// <param name="urlTemplate">Relative URL template identifying the
        /// target resource for this operation. May include parameters.
        /// Example: /customers/{cid}/orders/{oid}/?date={date}</param>
        public OperationTagResourceContractProperties(string id = default(string), string name = default(string), string apiName = default(string), string apiRevision = default(string), string apiVersion = default(string), string description = default(string), string method = default(string), string urlTemplate = default(string))
        {
            Id = id;
            Name = name;
            ApiName = apiName;
            ApiRevision = apiRevision;
            ApiVersion = apiVersion;
            Description = description;
            Method = method;
            UrlTemplate = urlTemplate;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets identifier of the operation in form
        /// /operations/{operationId}.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets operation name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets api Name.
        /// </summary>
        [JsonProperty(PropertyName = "apiName")]
        public string ApiName { get; private set; }

        /// <summary>
        /// Gets api Revision.
        /// </summary>
        [JsonProperty(PropertyName = "apiRevision")]
        public string ApiRevision { get; private set; }

        /// <summary>
        /// Gets api Version.
        /// </summary>
        [JsonProperty(PropertyName = "apiVersion")]
        public string ApiVersion { get; private set; }

        /// <summary>
        /// Gets operation Description.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; private set; }

        /// <summary>
        /// Gets a Valid HTTP Operation Method. Typical Http Methods like GET,
        /// PUT, POST but not limited by only them.
        /// </summary>
        [JsonProperty(PropertyName = "method")]
        public string Method { get; private set; }

        /// <summary>
        /// Gets relative URL template identifying the target resource for this
        /// operation. May include parameters. Example:
        /// /customers/{cid}/orders/{oid}/?date={date}
        /// </summary>
        [JsonProperty(PropertyName = "urlTemplate")]
        public string UrlTemplate { get; private set; }

    }
}
