// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Sign-Up settings for a developer portal.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class PortalSignupSettings : Resource
    {
        /// <summary>
        /// Initializes a new instance of the PortalSignupSettings class.
        /// </summary>
        public PortalSignupSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PortalSignupSettings class.
        /// </summary>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type for API Management
        /// resource.</param>
        /// <param name="enabled">Allow users to sign up on a developer
        /// portal.</param>
        /// <param name="termsOfService">Terms of service contract
        /// properties.</param>
        public PortalSignupSettings(string id = default(string), string name = default(string), string type = default(string), bool? enabled = default(bool?), TermsOfServiceProperties termsOfService = default(TermsOfServiceProperties))
            : base(id, name, type)
        {
            Enabled = enabled;
            TermsOfService = termsOfService;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets allow users to sign up on a developer portal.
        /// </summary>
        [JsonProperty(PropertyName = "properties.enabled")]
        public bool? Enabled { get; set; }

        /// <summary>
        /// Gets or sets terms of service contract properties.
        /// </summary>
        [JsonProperty(PropertyName = "properties.termsOfService")]
        public TermsOfServiceProperties TermsOfService { get; set; }

    }
}
