// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes an available API Management service SKU.
    /// </summary>
    public partial class ResourceSkuResult
    {
        /// <summary>
        /// Initializes a new instance of the ResourceSkuResult class.
        /// </summary>
        public ResourceSkuResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceSkuResult class.
        /// </summary>
        /// <param name="resourceType">The type of resource the SKU applies
        /// to.</param>
        /// <param name="sku">Specifies API Management SKU.</param>
        /// <param name="capacity">Specifies the number of API Management
        /// units.</param>
        public ResourceSkuResult(string resourceType = default(string), ResourceSku sku = default(ResourceSku), ResourceSkuCapacity capacity = default(ResourceSkuCapacity))
        {
            ResourceType = resourceType;
            Sku = sku;
            Capacity = capacity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the type of resource the SKU applies to.
        /// </summary>
        [JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; private set; }

        /// <summary>
        /// Gets specifies API Management SKU.
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public ResourceSku Sku { get; private set; }

        /// <summary>
        /// Gets specifies the number of API Management units.
        /// </summary>
        [JsonProperty(PropertyName = "capacity")]
        public ResourceSkuCapacity Capacity { get; private set; }

    }
}
