// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Operation response details.
    /// </summary>
    public partial class ResponseContract
    {
        /// <summary>
        /// Initializes a new instance of the ResponseContract class.
        /// </summary>
        public ResponseContract()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResponseContract class.
        /// </summary>
        /// <param name="statusCode">Operation response HTTP status
        /// code.</param>
        /// <param name="description">Operation response description.</param>
        /// <param name="representations">Collection of operation response
        /// representations.</param>
        /// <param name="headers">Collection of operation response
        /// headers.</param>
        public ResponseContract(int statusCode, string description = default(string), IList<RepresentationContract> representations = default(IList<RepresentationContract>), IList<ParameterContract> headers = default(IList<ParameterContract>))
        {
            StatusCode = statusCode;
            Description = description;
            Representations = representations;
            Headers = headers;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets operation response HTTP status code.
        /// </summary>
        [JsonProperty(PropertyName = "statusCode")]
        public int StatusCode { get; set; }

        /// <summary>
        /// Gets or sets operation response description.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets collection of operation response representations.
        /// </summary>
        [JsonProperty(PropertyName = "representations")]
        public IList<RepresentationContract> Representations { get; set; }

        /// <summary>
        /// Gets or sets collection of operation response headers.
        /// </summary>
        [JsonProperty(PropertyName = "headers")]
        public IList<ParameterContract> Headers { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Representations != null)
            {
                foreach (var element in Representations)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (Headers != null)
            {
                foreach (var element1 in Headers)
                {
                    if (element1 != null)
                    {
                        element1.Validate();
                    }
                }
            }
        }
    }
}
