// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Contract details.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class TagDescriptionContract : Resource
    {
        /// <summary>
        /// Initializes a new instance of the TagDescriptionContract class.
        /// </summary>
        public TagDescriptionContract()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TagDescriptionContract class.
        /// </summary>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type for API Management
        /// resource.</param>
        /// <param name="description">Description of the Tag.</param>
        /// <param name="externalDocsUrl">Absolute URL of external resources
        /// describing the tag.</param>
        /// <param name="externalDocsDescription">Description of the external
        /// resources describing the tag.</param>
        /// <param name="displayName">Tag name.</param>
        public TagDescriptionContract(string id = default(string), string name = default(string), string type = default(string), string description = default(string), string externalDocsUrl = default(string), string externalDocsDescription = default(string), string displayName = default(string))
            : base(id, name, type)
        {
            Description = description;
            ExternalDocsUrl = externalDocsUrl;
            ExternalDocsDescription = externalDocsDescription;
            DisplayName = displayName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets description of the Tag.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets absolute URL of external resources describing the tag.
        /// </summary>
        [JsonProperty(PropertyName = "properties.externalDocsUrl")]
        public string ExternalDocsUrl { get; set; }

        /// <summary>
        /// Gets or sets description of the external resources describing the
        /// tag.
        /// </summary>
        [JsonProperty(PropertyName = "properties.externalDocsDescription")]
        public string ExternalDocsDescription { get; set; }

        /// <summary>
        /// Gets or sets tag name.
        /// </summary>
        [JsonProperty(PropertyName = "properties.displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ExternalDocsUrl != null)
            {
                if (ExternalDocsUrl.Length > 2000)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "ExternalDocsUrl", 2000);
                }
            }
            if (DisplayName != null)
            {
                if (DisplayName.Length > 160)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "DisplayName", 160);
                }
                if (DisplayName.Length < 1)
                {
                    throw new ValidationException(ValidationRules.MinLength, "DisplayName", 1);
                }
            }
        }
    }
}
