// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// TagResource contract properties.
    /// </summary>
    public partial class TagResourceContract
    {
        /// <summary>
        /// Initializes a new instance of the TagResourceContract class.
        /// </summary>
        public TagResourceContract()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TagResourceContract class.
        /// </summary>
        /// <param name="tag">Tag associated with the resource.</param>
        /// <param name="api">Api associated with the tag.</param>
        /// <param name="operation">Operation associated with the tag.</param>
        /// <param name="product">Product associated with the tag.</param>
        public TagResourceContract(TagTagResourceContractProperties tag, ApiTagResourceContractProperties api = default(ApiTagResourceContractProperties), OperationTagResourceContractProperties operation = default(OperationTagResourceContractProperties), ProductTagResourceContractProperties product = default(ProductTagResourceContractProperties))
        {
            Tag = tag;
            Api = api;
            Operation = operation;
            Product = product;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets tag associated with the resource.
        /// </summary>
        [JsonProperty(PropertyName = "tag")]
        public TagTagResourceContractProperties Tag { get; set; }

        /// <summary>
        /// Gets or sets api associated with the tag.
        /// </summary>
        [JsonProperty(PropertyName = "api")]
        public ApiTagResourceContractProperties Api { get; set; }

        /// <summary>
        /// Gets or sets operation associated with the tag.
        /// </summary>
        [JsonProperty(PropertyName = "operation")]
        public OperationTagResourceContractProperties Operation { get; set; }

        /// <summary>
        /// Gets or sets product associated with the tag.
        /// </summary>
        [JsonProperty(PropertyName = "product")]
        public ProductTagResourceContractProperties Product { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Tag == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Tag");
            }
            if (Tag != null)
            {
                Tag.Validate();
            }
            if (Api != null)
            {
                Api.Validate();
            }
            if (Product != null)
            {
                Product.Validate();
            }
        }
    }
}
