// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// User Entity Base Parameters set.
    /// </summary>
    public partial class UserEntityBaseParameters
    {
        /// <summary>
        /// Initializes a new instance of the UserEntityBaseParameters class.
        /// </summary>
        public UserEntityBaseParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the UserEntityBaseParameters class.
        /// </summary>
        /// <param name="state">Account state. Specifies whether the user is
        /// active or not. Blocked users are unable to sign into the developer
        /// portal or call any APIs of subscribed products. Default state is
        /// Active. Possible values include: 'active', 'blocked', 'pending',
        /// 'deleted'</param>
        /// <param name="note">Optional note about a user set by the
        /// administrator.</param>
        /// <param name="identities">Collection of user identities.</param>
        public UserEntityBaseParameters(string state = default(string), string note = default(string), IList<UserIdentityContract> identities = default(IList<UserIdentityContract>))
        {
            State = state;
            Note = note;
            Identities = identities;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets account state. Specifies whether the user is active or
        /// not. Blocked users are unable to sign into the developer portal or
        /// call any APIs of subscribed products. Default state is Active.
        /// Possible values include: 'active', 'blocked', 'pending', 'deleted'
        /// </summary>
        [JsonProperty(PropertyName = "state")]
        public string State { get; set; }

        /// <summary>
        /// Gets or sets optional note about a user set by the administrator.
        /// </summary>
        [JsonProperty(PropertyName = "note")]
        public string Note { get; set; }

        /// <summary>
        /// Gets or sets collection of user identities.
        /// </summary>
        [JsonProperty(PropertyName = "identities")]
        public IList<UserIdentityContract> Identities { get; set; }

    }
}
