// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Get User Token parameters.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class UserTokenParameters
    {
        /// <summary>
        /// Initializes a new instance of the UserTokenParameters class.
        /// </summary>
        public UserTokenParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the UserTokenParameters class.
        /// </summary>
        /// <param name="keyType">The Key to be used to generate token for
        /// user. Possible values include: 'primary', 'secondary'</param>
        /// <param name="expiry">The Expiry time of the Token. Maximum token
        /// expiry time is set to 30 days. The date conforms to the following
        /// format: `yyyy-MM-ddTHH:mm:ssZ` as specified by the ISO 8601
        /// standard.
        /// </param>
        public UserTokenParameters(KeyType keyType, System.DateTime expiry)
        {
            KeyType = keyType;
            Expiry = expiry;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Key to be used to generate token for user.
        /// Possible values include: 'primary', 'secondary'
        /// </summary>
        [JsonProperty(PropertyName = "properties.keyType")]
        public KeyType KeyType { get; set; }

        /// <summary>
        /// Gets or sets the Expiry time of the Token. Maximum token expiry
        /// time is set to 30 days. The date conforms to the following format:
        /// `yyyy-MM-ddTHH:mm:ssZ` as specified by the ISO 8601 standard.
        ///
        /// </summary>
        [JsonProperty(PropertyName = "properties.expiry")]
        public System.DateTime Expiry { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
