// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.ApplicationInsights.Query.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The exception info
    /// </summary>
    public partial class EventsExceptionInfo
    {
        /// <summary>
        /// Initializes a new instance of the EventsExceptionInfo class.
        /// </summary>
        public EventsExceptionInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EventsExceptionInfo class.
        /// </summary>
        /// <param name="severityLevel">The severity level of the
        /// exception</param>
        /// <param name="problemId">The problem ID of the exception</param>
        /// <param name="handledAt">Indicates where the exception was handled
        /// at</param>
        /// <param name="assembly">The assembly which threw the
        /// exception</param>
        /// <param name="method">The method that threw the exception</param>
        /// <param name="message">The message of the exception</param>
        /// <param name="type">The type of the exception</param>
        /// <param name="outerType">The outer type of the exception</param>
        /// <param name="outerMethod">The outer method of the exception</param>
        /// <param name="outerAssembly">The outer assmebly of the
        /// exception</param>
        /// <param name="outerMessage">The outer message of the
        /// exception</param>
        /// <param name="innermostType">The inner most type of the
        /// exception</param>
        /// <param name="innermostMessage">The inner most message of the
        /// exception</param>
        /// <param name="innermostMethod">The inner most method of the
        /// exception</param>
        /// <param name="innermostAssembly">The inner most assembly of the
        /// exception</param>
        /// <param name="details">The details of the exception</param>
        public EventsExceptionInfo(int? severityLevel = default(int?), string problemId = default(string), string handledAt = default(string), string assembly = default(string), string method = default(string), string message = default(string), string type = default(string), string outerType = default(string), string outerMethod = default(string), string outerAssembly = default(string), string outerMessage = default(string), string innermostType = default(string), string innermostMessage = default(string), string innermostMethod = default(string), string innermostAssembly = default(string), IList<EventsExceptionDetail> details = default(IList<EventsExceptionDetail>))
        {
            SeverityLevel = severityLevel;
            ProblemId = problemId;
            HandledAt = handledAt;
            Assembly = assembly;
            Method = method;
            Message = message;
            Type = type;
            OuterType = outerType;
            OuterMethod = outerMethod;
            OuterAssembly = outerAssembly;
            OuterMessage = outerMessage;
            InnermostType = innermostType;
            InnermostMessage = innermostMessage;
            InnermostMethod = innermostMethod;
            InnermostAssembly = innermostAssembly;
            Details = details;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the severity level of the exception
        /// </summary>
        [JsonProperty(PropertyName = "severityLevel")]
        public int? SeverityLevel { get; set; }

        /// <summary>
        /// Gets or sets the problem ID of the exception
        /// </summary>
        [JsonProperty(PropertyName = "problemId")]
        public string ProblemId { get; set; }

        /// <summary>
        /// Gets or sets indicates where the exception was handled at
        /// </summary>
        [JsonProperty(PropertyName = "handledAt")]
        public string HandledAt { get; set; }

        /// <summary>
        /// Gets or sets the assembly which threw the exception
        /// </summary>
        [JsonProperty(PropertyName = "assembly")]
        public string Assembly { get; set; }

        /// <summary>
        /// Gets or sets the method that threw the exception
        /// </summary>
        [JsonProperty(PropertyName = "method")]
        public string Method { get; set; }

        /// <summary>
        /// Gets or sets the message of the exception
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

        /// <summary>
        /// Gets or sets the type of the exception
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets the outer type of the exception
        /// </summary>
        [JsonProperty(PropertyName = "outerType")]
        public string OuterType { get; set; }

        /// <summary>
        /// Gets or sets the outer method of the exception
        /// </summary>
        [JsonProperty(PropertyName = "outerMethod")]
        public string OuterMethod { get; set; }

        /// <summary>
        /// Gets or sets the outer assmebly of the exception
        /// </summary>
        [JsonProperty(PropertyName = "outerAssembly")]
        public string OuterAssembly { get; set; }

        /// <summary>
        /// Gets or sets the outer message of the exception
        /// </summary>
        [JsonProperty(PropertyName = "outerMessage")]
        public string OuterMessage { get; set; }

        /// <summary>
        /// Gets or sets the inner most type of the exception
        /// </summary>
        [JsonProperty(PropertyName = "innermostType")]
        public string InnermostType { get; set; }

        /// <summary>
        /// Gets or sets the inner most message of the exception
        /// </summary>
        [JsonProperty(PropertyName = "innermostMessage")]
        public string InnermostMessage { get; set; }

        /// <summary>
        /// Gets or sets the inner most method of the exception
        /// </summary>
        [JsonProperty(PropertyName = "innermostMethod")]
        public string InnermostMethod { get; set; }

        /// <summary>
        /// Gets or sets the inner most assembly of the exception
        /// </summary>
        [JsonProperty(PropertyName = "innermostAssembly")]
        public string InnermostAssembly { get; set; }

        /// <summary>
        /// Gets or sets the details of the exception
        /// </summary>
        [JsonProperty(PropertyName = "details")]
        public IList<EventsExceptionDetail> Details { get; set; }

    }
}
