// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.ApplicationInsights.Query.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Events query result data.
    /// </summary>
    [Newtonsoft.Json.JsonObject("eventsResultData")]
    public partial class EventsResultData
    {
        /// <summary>
        /// Initializes a new instance of the EventsResultData class.
        /// </summary>
        public EventsResultData()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EventsResultData class.
        /// </summary>
        /// <param name="id">The unique ID for this event.</param>
        /// <param name="count">Count of the event</param>
        /// <param name="timestamp">Timestamp of the event</param>
        /// <param name="customDimensions">Custom dimensions of the
        /// event</param>
        /// <param name="customMeasurements">Custom measurements of the
        /// event</param>
        /// <param name="operation">Operation info of the event</param>
        /// <param name="session">Session info of the event</param>
        /// <param name="user">User info of the event</param>
        /// <param name="cloud">Cloud info of the event</param>
        /// <param name="ai">AI info of the event</param>
        /// <param name="application">Application info of the event</param>
        /// <param name="client">Client info of the event</param>
        public EventsResultData(string id = default(string), long? count = default(long?), System.DateTime? timestamp = default(System.DateTime?), EventsResultDataCustomDimensions customDimensions = default(EventsResultDataCustomDimensions), EventsResultDataCustomMeasurements customMeasurements = default(EventsResultDataCustomMeasurements), EventsOperationInfo operation = default(EventsOperationInfo), EventsSessionInfo session = default(EventsSessionInfo), EventsUserInfo user = default(EventsUserInfo), EventsCloudInfo cloud = default(EventsCloudInfo), EventsAiInfo ai = default(EventsAiInfo), EventsApplicationInfo application = default(EventsApplicationInfo), EventsClientInfo client = default(EventsClientInfo))
        {
            Id = id;
            Count = count;
            Timestamp = timestamp;
            CustomDimensions = customDimensions;
            CustomMeasurements = customMeasurements;
            Operation = operation;
            Session = session;
            User = user;
            Cloud = cloud;
            Ai = ai;
            Application = application;
            Client = client;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the unique ID for this event.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets count of the event
        /// </summary>
        [JsonProperty(PropertyName = "count")]
        public long? Count { get; set; }

        /// <summary>
        /// Gets or sets timestamp of the event
        /// </summary>
        [JsonProperty(PropertyName = "timestamp")]
        public System.DateTime? Timestamp { get; set; }

        /// <summary>
        /// Gets or sets custom dimensions of the event
        /// </summary>
        [JsonProperty(PropertyName = "customDimensions")]
        public EventsResultDataCustomDimensions CustomDimensions { get; set; }

        /// <summary>
        /// Gets or sets custom measurements of the event
        /// </summary>
        [JsonProperty(PropertyName = "customMeasurements")]
        public EventsResultDataCustomMeasurements CustomMeasurements { get; set; }

        /// <summary>
        /// Gets or sets operation info of the event
        /// </summary>
        [JsonProperty(PropertyName = "operation")]
        public EventsOperationInfo Operation { get; set; }

        /// <summary>
        /// Gets or sets session info of the event
        /// </summary>
        [JsonProperty(PropertyName = "session")]
        public EventsSessionInfo Session { get; set; }

        /// <summary>
        /// Gets or sets user info of the event
        /// </summary>
        [JsonProperty(PropertyName = "user")]
        public EventsUserInfo User { get; set; }

        /// <summary>
        /// Gets or sets cloud info of the event
        /// </summary>
        [JsonProperty(PropertyName = "cloud")]
        public EventsCloudInfo Cloud { get; set; }

        /// <summary>
        /// Gets or sets AI info of the event
        /// </summary>
        [JsonProperty(PropertyName = "ai")]
        public EventsAiInfo Ai { get; set; }

        /// <summary>
        /// Gets or sets application info of the event
        /// </summary>
        [JsonProperty(PropertyName = "application")]
        public EventsApplicationInfo Application { get; set; }

        /// <summary>
        /// Gets or sets client info of the event
        /// </summary>
        [JsonProperty(PropertyName = "client")]
        public EventsClientInfo Client { get; set; }

    }
}
