// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.ApplicationInsights.Query
{
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for QueryOperations.
    /// </summary>
    public static partial class QueryOperationsExtensions
    {
            /// <summary>
            /// Execute an Analytics query
            /// </summary>
            /// <remarks>
            /// Executes an Analytics query for data.
            /// [Here](https://dev.applicationinsights.io/documentation/Using-the-API/Query)
            /// is an example for using POST with an Analytics query.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='appId'>
            /// ID of the application. This is Application ID from the API Access settings
            /// blade in the Azure portal.
            /// </param>
            /// <param name='query'>
            /// The query to execute.
            /// </param>
            /// <param name='timespan'>
            /// Optional. The timespan over which to query data. This is an ISO8601 time
            /// period value.  This timespan is applied in addition to any that are
            /// specified in the query expression.
            /// </param>
            /// <param name='applications'>
            /// A list of Application IDs for cross-application queries.
            /// </param>
            public static QueryResults Execute(this IQueryOperations operations, string appId, string query, string timespan = default(string), IList<string> applications = default(IList<string>))
            {
                return operations.ExecuteAsync(appId, query, timespan, applications).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute an Analytics query
            /// </summary>
            /// <remarks>
            /// Executes an Analytics query for data.
            /// [Here](https://dev.applicationinsights.io/documentation/Using-the-API/Query)
            /// is an example for using POST with an Analytics query.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='appId'>
            /// ID of the application. This is Application ID from the API Access settings
            /// blade in the Azure portal.
            /// </param>
            /// <param name='query'>
            /// The query to execute.
            /// </param>
            /// <param name='timespan'>
            /// Optional. The timespan over which to query data. This is an ISO8601 time
            /// period value.  This timespan is applied in addition to any that are
            /// specified in the query expression.
            /// </param>
            /// <param name='applications'>
            /// A list of Application IDs for cross-application queries.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<QueryResults> ExecuteAsync(this IQueryOperations operations, string appId, string query, string timespan = default(string), IList<string> applications = default(IList<string>), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ExecuteWithHttpMessagesAsync(appId, query, timespan, applications, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
