// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApplicationInsights.Management
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// Composite Swagger for Application Insights Management Client
    /// </summary>
    public partial interface IApplicationInsightsManagementClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// The API version to use for this operation.
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// The ID of the target subscription.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IOperations.
        /// </summary>
        IOperations Operations { get; }

        /// <summary>
        /// Gets the IAnnotationsOperations.
        /// </summary>
        IAnnotationsOperations Annotations { get; }

        /// <summary>
        /// Gets the IAPIKeysOperations.
        /// </summary>
        IAPIKeysOperations APIKeys { get; }

        /// <summary>
        /// Gets the IExportConfigurationsOperations.
        /// </summary>
        IExportConfigurationsOperations ExportConfigurations { get; }

        /// <summary>
        /// Gets the IComponentCurrentBillingFeaturesOperations.
        /// </summary>
        IComponentCurrentBillingFeaturesOperations ComponentCurrentBillingFeatures { get; }

        /// <summary>
        /// Gets the IComponentQuotaStatusOperations.
        /// </summary>
        IComponentQuotaStatusOperations ComponentQuotaStatus { get; }

        /// <summary>
        /// Gets the IComponentFeatureCapabilitiesOperations.
        /// </summary>
        IComponentFeatureCapabilitiesOperations ComponentFeatureCapabilities { get; }

        /// <summary>
        /// Gets the IComponentAvailableFeaturesOperations.
        /// </summary>
        IComponentAvailableFeaturesOperations ComponentAvailableFeatures { get; }

        /// <summary>
        /// Gets the IProactiveDetectionConfigurationsOperations.
        /// </summary>
        IProactiveDetectionConfigurationsOperations ProactiveDetectionConfigurations { get; }

        /// <summary>
        /// Gets the IComponentsOperations.
        /// </summary>
        IComponentsOperations Components { get; }

        /// <summary>
        /// Gets the IWorkItemConfigurationsOperations.
        /// </summary>
        IWorkItemConfigurationsOperations WorkItemConfigurations { get; }

        /// <summary>
        /// Gets the IFavoritesOperations.
        /// </summary>
        IFavoritesOperations Favorites { get; }

        /// <summary>
        /// Gets the IWebTestLocationsOperations.
        /// </summary>
        IWebTestLocationsOperations WebTestLocations { get; }

        /// <summary>
        /// Gets the IWebTestsOperations.
        /// </summary>
        IWebTestsOperations WebTests { get; }

        /// <summary>
        /// Gets the IAnalyticsItemsOperations.
        /// </summary>
        IAnalyticsItemsOperations AnalyticsItems { get; }

        /// <summary>
        /// Gets the IWorkbooksOperations.
        /// </summary>
        IWorkbooksOperations Workbooks { get; }

    }
}
