// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApplicationInsights.Management.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Properties that define an API key of an Application Insights Component.
    /// </summary>
    public partial class ApplicationInsightsComponentAPIKey
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationInsightsComponentAPIKey class.
        /// </summary>
        public ApplicationInsightsComponentAPIKey()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationInsightsComponentAPIKey class.
        /// </summary>
        /// <param name="id">The unique ID of the API key inside an Application
        /// Insights component. It is auto generated when the API key is
        /// created.</param>
        /// <param name="apiKey">The API key value. It will be only return once
        /// when the API Key was created.</param>
        /// <param name="createdDate">The create date of this API key.</param>
        /// <param name="name">The name of the API key.</param>
        /// <param name="linkedReadProperties">The read access rights of this
        /// API Key.</param>
        /// <param name="linkedWriteProperties">The write access rights of this
        /// API Key.</param>
        public ApplicationInsightsComponentAPIKey(string id = default(string), string apiKey = default(string), string createdDate = default(string), string name = default(string), IList<string> linkedReadProperties = default(IList<string>), IList<string> linkedWriteProperties = default(IList<string>))
        {
            Id = id;
            ApiKey = apiKey;
            CreatedDate = createdDate;
            Name = name;
            LinkedReadProperties = linkedReadProperties;
            LinkedWriteProperties = linkedWriteProperties;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the unique ID of the API key inside an Application Insights
        /// component. It is auto generated when the API key is created.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets the API key value. It will be only return once when the API
        /// Key was created.
        /// </summary>
        [JsonProperty(PropertyName = "apiKey")]
        public string ApiKey { get; private set; }

        /// <summary>
        /// Gets or sets the create date of this API key.
        /// </summary>
        [JsonProperty(PropertyName = "createdDate")]
        public string CreatedDate { get; set; }

        /// <summary>
        /// Gets or sets the name of the API key.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the read access rights of this API Key.
        /// </summary>
        [JsonProperty(PropertyName = "linkedReadProperties")]
        public IList<string> LinkedReadProperties { get; set; }

        /// <summary>
        /// Gets or sets the write access rights of this API Key.
        /// </summary>
        [JsonProperty(PropertyName = "linkedWriteProperties")]
        public IList<string> LinkedWriteProperties { get; set; }

    }
}
