// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApplicationInsights.Management.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Properties that define an Analytics item that is associated to an
    /// Application Insights component.
    /// </summary>
    public partial class ApplicationInsightsComponentAnalyticsItem
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationInsightsComponentAnalyticsItem class.
        /// </summary>
        public ApplicationInsightsComponentAnalyticsItem()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationInsightsComponentAnalyticsItem class.
        /// </summary>
        /// <param name="id">Internally assigned unique id of the item
        /// definition.</param>
        /// <param name="name">The user-defined name of the item.</param>
        /// <param name="content">The content of this item</param>
        /// <param name="version">This instance's version of the data model.
        /// This can change as new features are added.</param>
        /// <param name="scope">Enum indicating if this item definition is
        /// owned by a specific user or is shared between all users with access
        /// to the Application Insights component. Possible values include:
        /// 'shared', 'user'</param>
        /// <param name="type">Enum indicating the type of the Analytics item.
        /// Possible values include: 'query', 'function', 'folder',
        /// 'recent'</param>
        /// <param name="timeCreated">Date and time in UTC when this item was
        /// created.</param>
        /// <param name="timeModified">Date and time in UTC of the last
        /// modification that was made to this item.</param>
        public ApplicationInsightsComponentAnalyticsItem(string id = default(string), string name = default(string), string content = default(string), string version = default(string), string scope = default(string), string type = default(string), string timeCreated = default(string), string timeModified = default(string), ApplicationInsightsComponentAnalyticsItemProperties properties = default(ApplicationInsightsComponentAnalyticsItemProperties))
        {
            Id = id;
            Name = name;
            Content = content;
            Version = version;
            Scope = scope;
            Type = type;
            TimeCreated = timeCreated;
            TimeModified = timeModified;
            Properties = properties;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets internally assigned unique id of the item definition.
        /// </summary>
        [JsonProperty(PropertyName = "Id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the user-defined name of the item.
        /// </summary>
        [JsonProperty(PropertyName = "Name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the content of this item
        /// </summary>
        [JsonProperty(PropertyName = "Content")]
        public string Content { get; set; }

        /// <summary>
        /// Gets this instance's version of the data model. This can change as
        /// new features are added.
        /// </summary>
        [JsonProperty(PropertyName = "Version")]
        public string Version { get; private set; }

        /// <summary>
        /// Gets or sets enum indicating if this item definition is owned by a
        /// specific user or is shared between all users with access to the
        /// Application Insights component. Possible values include: 'shared',
        /// 'user'
        /// </summary>
        [JsonProperty(PropertyName = "Scope")]
        public string Scope { get; set; }

        /// <summary>
        /// Gets or sets enum indicating the type of the Analytics item.
        /// Possible values include: 'query', 'function', 'folder', 'recent'
        /// </summary>
        [JsonProperty(PropertyName = "Type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets date and time in UTC when this item was created.
        /// </summary>
        [JsonProperty(PropertyName = "TimeCreated")]
        public string TimeCreated { get; private set; }

        /// <summary>
        /// Gets date and time in UTC of the last modification that was made to
        /// this item.
        /// </summary>
        [JsonProperty(PropertyName = "TimeModified")]
        public string TimeModified { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "Properties")]
        public ApplicationInsightsComponentAnalyticsItemProperties Properties { get; set; }

    }
}
