// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApplicationInsights.Management.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Properties that define a favorite that is associated to an Application
    /// Insights component.
    /// </summary>
    public partial class ApplicationInsightsComponentFavorite
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationInsightsComponentFavorite class.
        /// </summary>
        public ApplicationInsightsComponentFavorite()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationInsightsComponentFavorite class.
        /// </summary>
        /// <param name="name">The user-defined name of the favorite.</param>
        /// <param name="config">Configuration of this particular favorite,
        /// which are driven by the Azure portal UX. Configuration data is a
        /// string containing valid JSON</param>
        /// <param name="version">This instance's version of the data model.
        /// This can change as new features are added that can be marked
        /// favorite. Current examples include MetricsExplorer (ME) and
        /// Search.</param>
        /// <param name="favoriteId">Internally assigned unique id of the
        /// favorite definition.</param>
        /// <param name="favoriteType">Enum indicating if this favorite
        /// definition is owned by a specific user or is shared between all
        /// users with access to the Application Insights component. Possible
        /// values include: 'shared', 'user'</param>
        /// <param name="sourceType">The source of the favorite
        /// definition.</param>
        /// <param name="timeModified">Date and time in UTC of the last
        /// modification that was made to this favorite definition.</param>
        /// <param name="tags">A list of 0 or more tags that are associated
        /// with this favorite definition</param>
        /// <param name="category">Favorite category, as defined by the user at
        /// creation time.</param>
        /// <param name="isGeneratedFromTemplate">Flag denoting whether or not
        /// this favorite was generated from a template.</param>
        /// <param name="userId">Unique user id of the specific user that owns
        /// this favorite.</param>
        public ApplicationInsightsComponentFavorite(string name = default(string), string config = default(string), string version = default(string), string favoriteId = default(string), FavoriteType? favoriteType = default(FavoriteType?), string sourceType = default(string), string timeModified = default(string), IList<string> tags = default(IList<string>), string category = default(string), bool? isGeneratedFromTemplate = default(bool?), string userId = default(string))
        {
            Name = name;
            Config = config;
            Version = version;
            FavoriteId = favoriteId;
            FavoriteType = favoriteType;
            SourceType = sourceType;
            TimeModified = timeModified;
            Tags = tags;
            Category = category;
            IsGeneratedFromTemplate = isGeneratedFromTemplate;
            UserId = userId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the user-defined name of the favorite.
        /// </summary>
        [JsonProperty(PropertyName = "Name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets configuration of this particular favorite, which are
        /// driven by the Azure portal UX. Configuration data is a string
        /// containing valid JSON
        /// </summary>
        [JsonProperty(PropertyName = "Config")]
        public string Config { get; set; }

        /// <summary>
        /// Gets or sets this instance's version of the data model. This can
        /// change as new features are added that can be marked favorite.
        /// Current examples include MetricsExplorer (ME) and Search.
        /// </summary>
        [JsonProperty(PropertyName = "Version")]
        public string Version { get; set; }

        /// <summary>
        /// Gets internally assigned unique id of the favorite definition.
        /// </summary>
        [JsonProperty(PropertyName = "FavoriteId")]
        public string FavoriteId { get; private set; }

        /// <summary>
        /// Gets or sets enum indicating if this favorite definition is owned
        /// by a specific user or is shared between all users with access to
        /// the Application Insights component. Possible values include:
        /// 'shared', 'user'
        /// </summary>
        [JsonProperty(PropertyName = "FavoriteType")]
        public FavoriteType? FavoriteType { get; set; }

        /// <summary>
        /// Gets or sets the source of the favorite definition.
        /// </summary>
        [JsonProperty(PropertyName = "SourceType")]
        public string SourceType { get; set; }

        /// <summary>
        /// Gets date and time in UTC of the last modification that was made to
        /// this favorite definition.
        /// </summary>
        [JsonProperty(PropertyName = "TimeModified")]
        public string TimeModified { get; private set; }

        /// <summary>
        /// Gets or sets a list of 0 or more tags that are associated with this
        /// favorite definition
        /// </summary>
        [JsonProperty(PropertyName = "Tags")]
        public IList<string> Tags { get; set; }

        /// <summary>
        /// Gets or sets favorite category, as defined by the user at creation
        /// time.
        /// </summary>
        [JsonProperty(PropertyName = "Category")]
        public string Category { get; set; }

        /// <summary>
        /// Gets or sets flag denoting whether or not this favorite was
        /// generated from a template.
        /// </summary>
        [JsonProperty(PropertyName = "IsGeneratedFromTemplate")]
        public bool? IsGeneratedFromTemplate { get; set; }

        /// <summary>
        /// Gets unique user id of the specific user that owns this favorite.
        /// </summary>
        [JsonProperty(PropertyName = "UserId")]
        public string UserId { get; private set; }

    }
}
