// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApplicationInsights.Management.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// An Application Insights component feature capabilities
    /// </summary>
    public partial class ApplicationInsightsComponentFeatureCapabilities
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationInsightsComponentFeatureCapabilities class.
        /// </summary>
        public ApplicationInsightsComponentFeatureCapabilities()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationInsightsComponentFeatureCapabilities class.
        /// </summary>
        /// <param name="supportExportData">Whether allow to use continuous
        /// export feature.</param>
        /// <param name="burstThrottlePolicy">Reserved, not used now.</param>
        /// <param name="metadataClass">Reserved, not used now.</param>
        /// <param name="liveStreamMetrics">Reserved, not used now.</param>
        /// <param name="applicationMap">Reserved, not used now.</param>
        /// <param name="workItemIntegration">Whether allow to use work item
        /// integration feature.</param>
        /// <param name="powerBIIntegration">Reserved, not used now.</param>
        /// <param name="openSchema">Reserved, not used now.</param>
        /// <param name="proactiveDetection">Reserved, not used now.</param>
        /// <param name="analyticsIntegration">Reserved, not used now.</param>
        /// <param name="multipleStepWebTest">Whether allow to use multiple
        /// steps web test feature.</param>
        /// <param name="apiAccessLevel">Reserved, not used now.</param>
        /// <param name="trackingType">The application insights component used
        /// tracking type.</param>
        /// <param name="dailyCap">Daily data volume cap in GB.</param>
        /// <param name="dailyCapResetTime">Daily data volume cap UTC reset
        /// hour.</param>
        /// <param name="throttleRate">Reserved, not used now.</param>
        public ApplicationInsightsComponentFeatureCapabilities(bool? supportExportData = default(bool?), string burstThrottlePolicy = default(string), string metadataClass = default(string), bool? liveStreamMetrics = default(bool?), bool? applicationMap = default(bool?), bool? workItemIntegration = default(bool?), bool? powerBIIntegration = default(bool?), bool? openSchema = default(bool?), bool? proactiveDetection = default(bool?), bool? analyticsIntegration = default(bool?), bool? multipleStepWebTest = default(bool?), string apiAccessLevel = default(string), string trackingType = default(string), double? dailyCap = default(double?), double? dailyCapResetTime = default(double?), double? throttleRate = default(double?))
        {
            SupportExportData = supportExportData;
            BurstThrottlePolicy = burstThrottlePolicy;
            MetadataClass = metadataClass;
            LiveStreamMetrics = liveStreamMetrics;
            ApplicationMap = applicationMap;
            WorkItemIntegration = workItemIntegration;
            PowerBIIntegration = powerBIIntegration;
            OpenSchema = openSchema;
            ProactiveDetection = proactiveDetection;
            AnalyticsIntegration = analyticsIntegration;
            MultipleStepWebTest = multipleStepWebTest;
            ApiAccessLevel = apiAccessLevel;
            TrackingType = trackingType;
            DailyCap = dailyCap;
            DailyCapResetTime = dailyCapResetTime;
            ThrottleRate = throttleRate;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets whether allow to use continuous export feature.
        /// </summary>
        [JsonProperty(PropertyName = "SupportExportData")]
        public bool? SupportExportData { get; private set; }

        /// <summary>
        /// Gets reserved, not used now.
        /// </summary>
        [JsonProperty(PropertyName = "BurstThrottlePolicy")]
        public string BurstThrottlePolicy { get; private set; }

        /// <summary>
        /// Gets reserved, not used now.
        /// </summary>
        [JsonProperty(PropertyName = "MetadataClass")]
        public string MetadataClass { get; private set; }

        /// <summary>
        /// Gets reserved, not used now.
        /// </summary>
        [JsonProperty(PropertyName = "LiveStreamMetrics")]
        public bool? LiveStreamMetrics { get; private set; }

        /// <summary>
        /// Gets reserved, not used now.
        /// </summary>
        [JsonProperty(PropertyName = "ApplicationMap")]
        public bool? ApplicationMap { get; private set; }

        /// <summary>
        /// Gets whether allow to use work item integration feature.
        /// </summary>
        [JsonProperty(PropertyName = "WorkItemIntegration")]
        public bool? WorkItemIntegration { get; private set; }

        /// <summary>
        /// Gets reserved, not used now.
        /// </summary>
        [JsonProperty(PropertyName = "PowerBIIntegration")]
        public bool? PowerBIIntegration { get; private set; }

        /// <summary>
        /// Gets reserved, not used now.
        /// </summary>
        [JsonProperty(PropertyName = "OpenSchema")]
        public bool? OpenSchema { get; private set; }

        /// <summary>
        /// Gets reserved, not used now.
        /// </summary>
        [JsonProperty(PropertyName = "ProactiveDetection")]
        public bool? ProactiveDetection { get; private set; }

        /// <summary>
        /// Gets reserved, not used now.
        /// </summary>
        [JsonProperty(PropertyName = "AnalyticsIntegration")]
        public bool? AnalyticsIntegration { get; private set; }

        /// <summary>
        /// Gets whether allow to use multiple steps web test feature.
        /// </summary>
        [JsonProperty(PropertyName = "MultipleStepWebTest")]
        public bool? MultipleStepWebTest { get; private set; }

        /// <summary>
        /// Gets reserved, not used now.
        /// </summary>
        [JsonProperty(PropertyName = "ApiAccessLevel")]
        public string ApiAccessLevel { get; private set; }

        /// <summary>
        /// Gets the application insights component used tracking type.
        /// </summary>
        [JsonProperty(PropertyName = "TrackingType")]
        public string TrackingType { get; private set; }

        /// <summary>
        /// Gets daily data volume cap in GB.
        /// </summary>
        [JsonProperty(PropertyName = "DailyCap")]
        public double? DailyCap { get; private set; }

        /// <summary>
        /// Gets daily data volume cap UTC reset hour.
        /// </summary>
        [JsonProperty(PropertyName = "DailyCapResetTime")]
        public double? DailyCapResetTime { get; private set; }

        /// <summary>
        /// Gets reserved, not used now.
        /// </summary>
        [JsonProperty(PropertyName = "ThrottleRate")]
        public double? ThrottleRate { get; private set; }

    }
}
