// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApplicationInsights.Management.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Properties that define a ProactiveDetection configuration.
    /// </summary>
    public partial class ApplicationInsightsComponentProactiveDetectionConfiguration : IResource
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationInsightsComponentProactiveDetectionConfiguration class.
        /// </summary>
        public ApplicationInsightsComponentProactiveDetectionConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationInsightsComponentProactiveDetectionConfiguration class.
        /// </summary>
        /// <param name="name">The rule name</param>
        /// <param name="enabled">A flag that indicates whether this rule is
        /// enabled by the user</param>
        /// <param name="sendEmailsToSubscriptionOwners">A flag that indicated
        /// whether notifications on this rule should be sent to subscription
        /// owners</param>
        /// <param name="customEmails">Custom email addresses for this rule
        /// notifications</param>
        /// <param name="lastUpdatedTime">The last time this rule was
        /// updated</param>
        /// <param name="ruleDefinitions">Static definitions of the
        /// ProactiveDetection configuration rule (same values for all
        /// components).</param>
        public ApplicationInsightsComponentProactiveDetectionConfiguration(string name = default(string), bool? enabled = default(bool?), bool? sendEmailsToSubscriptionOwners = default(bool?), IList<string> customEmails = default(IList<string>), string lastUpdatedTime = default(string), ApplicationInsightsComponentProactiveDetectionConfigurationRuleDefinitions ruleDefinitions = default(ApplicationInsightsComponentProactiveDetectionConfigurationRuleDefinitions))
        {
            Name = name;
            Enabled = enabled;
            SendEmailsToSubscriptionOwners = sendEmailsToSubscriptionOwners;
            CustomEmails = customEmails;
            LastUpdatedTime = lastUpdatedTime;
            RuleDefinitions = ruleDefinitions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the rule name
        /// </summary>
        [JsonProperty(PropertyName = "Name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets a flag that indicates whether this rule is enabled by
        /// the user
        /// </summary>
        [JsonProperty(PropertyName = "Enabled")]
        public bool? Enabled { get; set; }

        /// <summary>
        /// Gets or sets a flag that indicated whether notifications on this
        /// rule should be sent to subscription owners
        /// </summary>
        [JsonProperty(PropertyName = "SendEmailsToSubscriptionOwners")]
        public bool? SendEmailsToSubscriptionOwners { get; set; }

        /// <summary>
        /// Gets or sets custom email addresses for this rule notifications
        /// </summary>
        [JsonProperty(PropertyName = "CustomEmails")]
        public IList<string> CustomEmails { get; set; }

        /// <summary>
        /// Gets or sets the last time this rule was updated
        /// </summary>
        [JsonProperty(PropertyName = "LastUpdatedTime")]
        public string LastUpdatedTime { get; set; }

        /// <summary>
        /// Gets or sets static definitions of the ProactiveDetection
        /// configuration rule (same values for all components).
        /// </summary>
        [JsonProperty(PropertyName = "RuleDefinitions")]
        public ApplicationInsightsComponentProactiveDetectionConfigurationRuleDefinitions RuleDefinitions { get; set; }

    }
}
