// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ApplicationInsights.Management.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes the body of a purge request for an App Insights component
    /// </summary>
    public partial class ComponentPurgeBody
    {
        /// <summary>
        /// Initializes a new instance of the ComponentPurgeBody class.
        /// </summary>
        public ComponentPurgeBody()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ComponentPurgeBody class.
        /// </summary>
        /// <param name="table">Table from which to purge data.</param>
        /// <param name="filters">The set of columns and filters (queries) to
        /// run over them to purge the resulting data.</param>
        public ComponentPurgeBody(string table, IList<ComponentPurgeBodyFilters> filters)
        {
            Table = table;
            Filters = filters;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets table from which to purge data.
        /// </summary>
        [JsonProperty(PropertyName = "table")]
        public string Table { get; set; }

        /// <summary>
        /// Gets or sets the set of columns and filters (queries) to run over
        /// them to purge the resulting data.
        /// </summary>
        [JsonProperty(PropertyName = "filters")]
        public IList<ComponentPurgeBodyFilters> Filters { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Table == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Table");
            }
            if (Filters == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Filters");
            }
        }
    }
}
