// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.AppPlatform.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Binding resource properties payload
    /// </summary>
    public partial class BindingResourceProperties
    {
        /// <summary>
        /// Initializes a new instance of the BindingResourceProperties class.
        /// </summary>
        public BindingResourceProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BindingResourceProperties class.
        /// </summary>
        /// <param name="resourceName">The name of the bound resource</param>
        /// <param name="resourceType">The standard Azure resource type of the
        /// bound resource</param>
        /// <param name="resourceId">The Azure resource id of the bound
        /// resource</param>
        /// <param name="key">The key of the bound resource</param>
        /// <param name="bindingParameters">Binding parameters of the Binding
        /// resource</param>
        /// <param name="generatedProperties">The generated Spring Boot
        /// property file for this binding. The secret will be
        /// deducted.</param>
        /// <param name="createdAt">Creation time of the Binding
        /// resource</param>
        /// <param name="updatedAt">Update time of the Binding resource</param>
        public BindingResourceProperties(string resourceName = default(string), string resourceType = default(string), string resourceId = default(string), string key = default(string), IDictionary<string, object> bindingParameters = default(IDictionary<string, object>), string generatedProperties = default(string), string createdAt = default(string), string updatedAt = default(string))
        {
            ResourceName = resourceName;
            ResourceType = resourceType;
            ResourceId = resourceId;
            Key = key;
            BindingParameters = bindingParameters;
            GeneratedProperties = generatedProperties;
            CreatedAt = createdAt;
            UpdatedAt = updatedAt;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the bound resource
        /// </summary>
        [JsonProperty(PropertyName = "resourceName")]
        public string ResourceName { get; set; }

        /// <summary>
        /// Gets or sets the standard Azure resource type of the bound resource
        /// </summary>
        [JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; set; }

        /// <summary>
        /// Gets or sets the Azure resource id of the bound resource
        /// </summary>
        [JsonProperty(PropertyName = "resourceId")]
        public string ResourceId { get; set; }

        /// <summary>
        /// Gets or sets the key of the bound resource
        /// </summary>
        [JsonProperty(PropertyName = "key")]
        public string Key { get; set; }

        /// <summary>
        /// Gets or sets binding parameters of the Binding resource
        /// </summary>
        [JsonProperty(PropertyName = "bindingParameters")]
        public IDictionary<string, object> BindingParameters { get; set; }

        /// <summary>
        /// Gets the generated Spring Boot property file for this binding. The
        /// secret will be deducted.
        /// </summary>
        [JsonProperty(PropertyName = "generatedProperties")]
        public string GeneratedProperties { get; private set; }

        /// <summary>
        /// Gets creation time of the Binding resource
        /// </summary>
        [JsonProperty(PropertyName = "createdAt")]
        public string CreatedAt { get; private set; }

        /// <summary>
        /// Gets update time of the Binding resource
        /// </summary>
        [JsonProperty(PropertyName = "updatedAt")]
        public string UpdatedAt { get; private set; }

    }
}
