// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.AppPlatform.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Service properties payload
    /// </summary>
    public partial class ClusterResourceProperties
    {
        /// <summary>
        /// Initializes a new instance of the ClusterResourceProperties class.
        /// </summary>
        public ClusterResourceProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ClusterResourceProperties class.
        /// </summary>
        /// <param name="provisioningState">Provisioning state of the Service.
        /// Possible values include: 'Creating', 'Updating', 'Deleting',
        /// 'Deleted', 'Succeeded', 'Failed', 'Moving', 'Moved',
        /// 'MoveFailed'</param>
        /// <param name="configServerProperties">Config server git properties
        /// of the Service</param>
        /// <param name="trace">Trace properties of the Service</param>
        /// <param name="version">Version of the Service</param>
        /// <param name="serviceId">ServiceInstanceEntity GUID which uniquely
        /// identifies a created resource</param>
        public ClusterResourceProperties(string provisioningState = default(string), ConfigServerProperties configServerProperties = default(ConfigServerProperties), TraceProperties trace = default(TraceProperties), int? version = default(int?), string serviceId = default(string))
        {
            ProvisioningState = provisioningState;
            ConfigServerProperties = configServerProperties;
            Trace = trace;
            Version = version;
            ServiceId = serviceId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets provisioning state of the Service. Possible values include:
        /// 'Creating', 'Updating', 'Deleting', 'Deleted', 'Succeeded',
        /// 'Failed', 'Moving', 'Moved', 'MoveFailed'
        /// </summary>
        [JsonProperty(PropertyName = "provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets config server git properties of the Service
        /// </summary>
        [JsonProperty(PropertyName = "configServerProperties")]
        public ConfigServerProperties ConfigServerProperties { get; set; }

        /// <summary>
        /// Gets or sets trace properties of the Service
        /// </summary>
        [JsonProperty(PropertyName = "trace")]
        public TraceProperties Trace { get; set; }

        /// <summary>
        /// Gets version of the Service
        /// </summary>
        [JsonProperty(PropertyName = "version")]
        public int? Version { get; private set; }

        /// <summary>
        /// Gets serviceInstanceEntity GUID which uniquely identifies a created
        /// resource
        /// </summary>
        [JsonProperty(PropertyName = "serviceId")]
        public string ServiceId { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ConfigServerProperties != null)
            {
                ConfigServerProperties.Validate();
            }
        }
    }
}
