// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.AppPlatform.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Trace properties payload
    /// </summary>
    public partial class TraceProperties
    {
        /// <summary>
        /// Initializes a new instance of the TraceProperties class.
        /// </summary>
        public TraceProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TraceProperties class.
        /// </summary>
        /// <param name="state">State of the trace proxy. Possible values
        /// include: 'NotAvailable', 'Failed', 'Succeeded', 'Updating'</param>
        /// <param name="error">Error when apply trace proxy changes.</param>
        /// <param name="enabled">Indicates whether enable the tracing
        /// functionality</param>
        /// <param name="appInsightInstrumentationKey">Target application
        /// insight instrumentation key</param>
        public TraceProperties(string state = default(string), Error error = default(Error), bool? enabled = default(bool?), string appInsightInstrumentationKey = default(string))
        {
            State = state;
            Error = error;
            Enabled = enabled;
            AppInsightInstrumentationKey = appInsightInstrumentationKey;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets state of the trace proxy. Possible values include:
        /// 'NotAvailable', 'Failed', 'Succeeded', 'Updating'
        /// </summary>
        [JsonProperty(PropertyName = "state")]
        public string State { get; private set; }

        /// <summary>
        /// Gets or sets error when apply trace proxy changes.
        /// </summary>
        [JsonProperty(PropertyName = "error")]
        public Error Error { get; set; }

        /// <summary>
        /// Gets or sets indicates whether enable the tracing functionality
        /// </summary>
        [JsonProperty(PropertyName = "enabled")]
        public bool? Enabled { get; set; }

        /// <summary>
        /// Gets or sets target application insight instrumentation key
        /// </summary>
        [JsonProperty(PropertyName = "appInsightInstrumentationKey")]
        public string AppInsightInstrumentationKey { get; set; }

    }
}
