// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Attestation
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for MetadataConfigurationOperations.
    /// </summary>
    public static partial class MetadataConfigurationOperationsExtensions
    {
            /// <summary>
            /// Retrieves the OpenID Configuration data for the Azure Attestation Service
            /// </summary>
            /// <remarks>
            /// Retrieves metadata about the attestation signing keys in use by the
            /// attestation service
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='tenantBaseUrl'>
            /// The tenant name, for example https://mytenant.attest.azure.net.
            /// </param>
            public static object Get(this IMetadataConfigurationOperations operations, string tenantBaseUrl)
            {
                return operations.GetAsync(tenantBaseUrl).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the OpenID Configuration data for the Azure Attestation Service
            /// </summary>
            /// <remarks>
            /// Retrieves metadata about the attestation signing keys in use by the
            /// attestation service
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='tenantBaseUrl'>
            /// The tenant name, for example https://mytenant.attest.azure.net.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetAsync(this IMetadataConfigurationOperations operations, string tenantBaseUrl, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(tenantBaseUrl, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
