// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Attestation
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for PolicyOperations.
    /// </summary>
    public static partial class PolicyOperationsExtensions
    {
            /// <summary>
            /// Accepts a new policy document and returns a JWT which expresses  used in
            /// preparation to set attestation policy.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='tenantBaseUrl'>
            /// The tenant name, for example https://mytenant.attest.azure.net.
            /// </param>
            /// <param name='tee'>
            /// Specifies the trusted execution environment to be used to validate the
            /// evidence. Possible values include: 'SgxEnclave', 'OpenEnclave',
            /// 'CyResComponent', 'AzureGuest'
            /// </param>
            /// <param name='policyJws'>
            /// JSON Web Signature (See RFC7515) expressing the new policy
            /// </param>
            public static object PrepareToSet(this IPolicyOperations operations, string tenantBaseUrl, string tee, string policyJws)
            {
                return operations.PrepareToSetAsync(tenantBaseUrl, tee, policyJws).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Accepts a new policy document and returns a JWT which expresses  used in
            /// preparation to set attestation policy.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='tenantBaseUrl'>
            /// The tenant name, for example https://mytenant.attest.azure.net.
            /// </param>
            /// <param name='tee'>
            /// Specifies the trusted execution environment to be used to validate the
            /// evidence. Possible values include: 'SgxEnclave', 'OpenEnclave',
            /// 'CyResComponent', 'AzureGuest'
            /// </param>
            /// <param name='policyJws'>
            /// JSON Web Signature (See RFC7515) expressing the new policy
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> PrepareToSetAsync(this IPolicyOperations operations, string tenantBaseUrl, string tee, string policyJws, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.PrepareToSetWithHttpMessagesAsync(tenantBaseUrl, tee, policyJws, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the current policy for a given kind of TEE.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='tenantBaseUrl'>
            /// The tenant name, for example https://mytenant.attest.azure.net.
            /// </param>
            /// <param name='tee'>
            /// Specifies the trusted execution environment to be used to validate the
            /// evidence. Possible values include: 'SgxEnclave', 'OpenEnclave',
            /// 'CyResComponent', 'AzureGuest'
            /// </param>
            public static object Get(this IPolicyOperations operations, string tenantBaseUrl, string tee)
            {
                return operations.GetAsync(tenantBaseUrl, tee).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the current policy for a given kind of TEE.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='tenantBaseUrl'>
            /// The tenant name, for example https://mytenant.attest.azure.net.
            /// </param>
            /// <param name='tee'>
            /// Specifies the trusted execution environment to be used to validate the
            /// evidence. Possible values include: 'SgxEnclave', 'OpenEnclave',
            /// 'CyResComponent', 'AzureGuest'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetAsync(this IPolicyOperations operations, string tenantBaseUrl, string tee, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(tenantBaseUrl, tee, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Sets the policy for a given kind of TEE.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='tenantBaseUrl'>
            /// The tenant name, for example https://mytenant.attest.azure.net.
            /// </param>
            /// <param name='tee'>
            /// Specifies the trusted execution environment to be used to validate the
            /// evidence. Possible values include: 'SgxEnclave', 'OpenEnclave',
            /// 'CyResComponent', 'AzureGuest'
            /// </param>
            /// <param name='newAttestationPolicy'>
            /// JWT Expressing the new policy
            /// </param>
            public static object Set(this IPolicyOperations operations, string tenantBaseUrl, string tee, string newAttestationPolicy)
            {
                return operations.SetAsync(tenantBaseUrl, tee, newAttestationPolicy).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Sets the policy for a given kind of TEE.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='tenantBaseUrl'>
            /// The tenant name, for example https://mytenant.attest.azure.net.
            /// </param>
            /// <param name='tee'>
            /// Specifies the trusted execution environment to be used to validate the
            /// evidence. Possible values include: 'SgxEnclave', 'OpenEnclave',
            /// 'CyResComponent', 'AzureGuest'
            /// </param>
            /// <param name='newAttestationPolicy'>
            /// JWT Expressing the new policy
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> SetAsync(this IPolicyOperations operations, string tenantBaseUrl, string tee, string newAttestationPolicy, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.SetWithHttpMessagesAsync(tenantBaseUrl, tee, newAttestationPolicy, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Resets the attestation policy for the specified tenant and reverts to the
            /// default policy.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='tenantBaseUrl'>
            /// The tenant name, for example https://mytenant.attest.azure.net.
            /// </param>
            /// <param name='tee'>
            /// Specifies the trusted execution environment to be used to validate the
            /// evidence. Possible values include: 'SgxEnclave', 'OpenEnclave',
            /// 'CyResComponent', 'AzureGuest'
            /// </param>
            /// <param name='policyJws'>
            /// JSON Web Signature with an empty policy document
            /// </param>
            public static object Reset(this IPolicyOperations operations, string tenantBaseUrl, string tee, string policyJws)
            {
                return operations.ResetAsync(tenantBaseUrl, tee, policyJws).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Resets the attestation policy for the specified tenant and reverts to the
            /// default policy.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='tenantBaseUrl'>
            /// The tenant name, for example https://mytenant.attest.azure.net.
            /// </param>
            /// <param name='tee'>
            /// Specifies the trusted execution environment to be used to validate the
            /// evidence. Possible values include: 'SgxEnclave', 'OpenEnclave',
            /// 'CyResComponent', 'AzureGuest'
            /// </param>
            /// <param name='policyJws'>
            /// JSON Web Signature with an empty policy document
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> ResetAsync(this IPolicyOperations operations, string tenantBaseUrl, string tee, string policyJws, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ResetWithHttpMessagesAsync(tenantBaseUrl, tee, policyJws, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
