// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Attestation.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Client supplied parameters passed to attestation service.
    /// </summary>
    public partial class AttestationServiceCreationParams
    {
        /// <summary>
        /// Initializes a new instance of the AttestationServiceCreationParams
        /// class.
        /// </summary>
        public AttestationServiceCreationParams()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AttestationServiceCreationParams
        /// class.
        /// </summary>
        /// <param name="attestationPolicy">Name of attestation policy.</param>
        /// <param name="policySigningCertificates">JSON Web Key Set defining a
        /// set of X.509 Certificates that will represent the parent
        /// certificate for the signing certificate used for policy
        /// operations</param>
        public AttestationServiceCreationParams(string attestationPolicy = default(string), JSONWebKeySet policySigningCertificates = default(JSONWebKeySet))
        {
            AttestationPolicy = attestationPolicy;
            PolicySigningCertificates = policySigningCertificates;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of attestation policy.
        /// </summary>
        [JsonProperty(PropertyName = "attestationPolicy")]
        public string AttestationPolicy { get; set; }

        /// <summary>
        /// Gets or sets JSON Web Key Set defining a set of X.509 Certificates
        /// that will represent the parent certificate for the signing
        /// certificate used for policy operations
        /// </summary>
        [JsonProperty(PropertyName = "policySigningCertificates")]
        public JSONWebKeySet PolicySigningCertificates { get; set; }

    }
}
