// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Azure.OData;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for DscCompilationJobOperations.
    /// </summary>
    public static partial class DscCompilationJobOperationsExtensions
    {
            /// <summary>
            /// Creates the Dsc compilation job of the configuration.
            /// <see href="http://aka.ms/azureautomationsdk/dscconfigurationcompilejoboperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='compilationJobName'>
            /// The the DSC configuration Id.
            /// </param>
            /// <param name='parameters'>
            /// The parameters supplied to the create compilation job operation.
            /// </param>
            public static DscCompilationJob Create(this IDscCompilationJobOperations operations, string resourceGroupName, string automationAccountName, string compilationJobName, DscCompilationJobCreateParameters parameters)
            {
                return operations.CreateAsync(resourceGroupName, automationAccountName, compilationJobName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates the Dsc compilation job of the configuration.
            /// <see href="http://aka.ms/azureautomationsdk/dscconfigurationcompilejoboperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='compilationJobName'>
            /// The the DSC configuration Id.
            /// </param>
            /// <param name='parameters'>
            /// The parameters supplied to the create compilation job operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DscCompilationJob> CreateAsync(this IDscCompilationJobOperations operations, string resourceGroupName, string automationAccountName, string compilationJobName, DscCompilationJobCreateParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateWithHttpMessagesAsync(resourceGroupName, automationAccountName, compilationJobName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieve the Dsc configuration compilation job identified by job id.
            /// <see href="http://aka.ms/azureautomationsdk/dsccompilationjoboperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='compilationJobName'>
            /// The the DSC configuration Id.
            /// </param>
            public static DscCompilationJob Get(this IDscCompilationJobOperations operations, string resourceGroupName, string automationAccountName, string compilationJobName)
            {
                return operations.GetAsync(resourceGroupName, automationAccountName, compilationJobName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve the Dsc configuration compilation job identified by job id.
            /// <see href="http://aka.ms/azureautomationsdk/dsccompilationjoboperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='compilationJobName'>
            /// The the DSC configuration Id.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DscCompilationJob> GetAsync(this IDscCompilationJobOperations operations, string resourceGroupName, string automationAccountName, string compilationJobName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, automationAccountName, compilationJobName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieve a list of dsc compilation jobs.
            /// <see href="http://aka.ms/azureautomationsdk/compilationjoboperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            public static IPage<DscCompilationJob> ListByAutomationAccount(this IDscCompilationJobOperations operations, string resourceGroupName, string automationAccountName, ODataQuery<DscCompilationJob> odataQuery = default(ODataQuery<DscCompilationJob>))
            {
                return operations.ListByAutomationAccountAsync(resourceGroupName, automationAccountName, odataQuery).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve a list of dsc compilation jobs.
            /// <see href="http://aka.ms/azureautomationsdk/compilationjoboperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<DscCompilationJob>> ListByAutomationAccountAsync(this IDscCompilationJobOperations operations, string resourceGroupName, string automationAccountName, ODataQuery<DscCompilationJob> odataQuery = default(ODataQuery<DscCompilationJob>), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByAutomationAccountWithHttpMessagesAsync(resourceGroupName, automationAccountName, odataQuery, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieve the job stream identified by job stream id.
            /// <see href="http://aka.ms/azureautomationsdk/jobstreamoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='jobId'>
            /// The job id.
            /// </param>
            /// <param name='jobStreamId'>
            /// The job stream id.
            /// </param>
            public static JobStream GetStream(this IDscCompilationJobOperations operations, string resourceGroupName, string automationAccountName, System.Guid jobId, string jobStreamId)
            {
                return operations.GetStreamAsync(resourceGroupName, automationAccountName, jobId, jobStreamId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve the job stream identified by job stream id.
            /// <see href="http://aka.ms/azureautomationsdk/jobstreamoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='jobId'>
            /// The job id.
            /// </param>
            /// <param name='jobStreamId'>
            /// The job stream id.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<JobStream> GetStreamAsync(this IDscCompilationJobOperations operations, string resourceGroupName, string automationAccountName, System.Guid jobId, string jobStreamId, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetStreamWithHttpMessagesAsync(resourceGroupName, automationAccountName, jobId, jobStreamId, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Creates the Dsc compilation job of the configuration.
            /// <see href="http://aka.ms/azureautomationsdk/dscconfigurationcompilejoboperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='compilationJobName'>
            /// The the DSC configuration Id.
            /// </param>
            /// <param name='parameters'>
            /// The parameters supplied to the create compilation job operation.
            /// </param>
            public static DscCompilationJob BeginCreate(this IDscCompilationJobOperations operations, string resourceGroupName, string automationAccountName, string compilationJobName, DscCompilationJobCreateParameters parameters)
            {
                return operations.BeginCreateAsync(resourceGroupName, automationAccountName, compilationJobName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates the Dsc compilation job of the configuration.
            /// <see href="http://aka.ms/azureautomationsdk/dscconfigurationcompilejoboperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='compilationJobName'>
            /// The the DSC configuration Id.
            /// </param>
            /// <param name='parameters'>
            /// The parameters supplied to the create compilation job operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DscCompilationJob> BeginCreateAsync(this IDscCompilationJobOperations operations, string resourceGroupName, string automationAccountName, string compilationJobName, DscCompilationJobCreateParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateWithHttpMessagesAsync(resourceGroupName, automationAccountName, compilationJobName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieve a list of dsc compilation jobs.
            /// <see href="http://aka.ms/azureautomationsdk/compilationjoboperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<DscCompilationJob> ListByAutomationAccountNext(this IDscCompilationJobOperations operations, string nextPageLink)
            {
                return operations.ListByAutomationAccountNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve a list of dsc compilation jobs.
            /// <see href="http://aka.ms/azureautomationsdk/compilationjoboperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<DscCompilationJob>> ListByAutomationAccountNextAsync(this IDscCompilationJobOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByAutomationAccountNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
