// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Azure.OData;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for DscNodeOperations.
    /// </summary>
    public static partial class DscNodeOperationsExtensions
    {
            /// <summary>
            /// Delete the dsc node identified by node id.
            /// <see href="http://aka.ms/azureautomationsdk/dscnodeoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='nodeId'>
            /// The node id.
            /// </param>
            public static DscNode Delete(this IDscNodeOperations operations, string resourceGroupName, string automationAccountName, string nodeId)
            {
                return operations.DeleteAsync(resourceGroupName, automationAccountName, nodeId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete the dsc node identified by node id.
            /// <see href="http://aka.ms/azureautomationsdk/dscnodeoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='nodeId'>
            /// The node id.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DscNode> DeleteAsync(this IDscNodeOperations operations, string resourceGroupName, string automationAccountName, string nodeId, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteWithHttpMessagesAsync(resourceGroupName, automationAccountName, nodeId, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieve the dsc node identified by node id.
            /// <see href="http://aka.ms/azureautomationsdk/dscnodeoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='nodeId'>
            /// The node id.
            /// </param>
            public static DscNode Get(this IDscNodeOperations operations, string resourceGroupName, string automationAccountName, string nodeId)
            {
                return operations.GetAsync(resourceGroupName, automationAccountName, nodeId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve the dsc node identified by node id.
            /// <see href="http://aka.ms/azureautomationsdk/dscnodeoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='nodeId'>
            /// The node id.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DscNode> GetAsync(this IDscNodeOperations operations, string resourceGroupName, string automationAccountName, string nodeId, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, automationAccountName, nodeId, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Update the dsc node.
            /// <see href="http://aka.ms/azureautomationsdk/dscnodeoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='nodeId'>
            /// Parameters supplied to the update dsc node.
            /// </param>
            /// <param name='dscNodeUpdateParameters'>
            /// Parameters supplied to the update dsc node.
            /// </param>
            public static DscNode Update(this IDscNodeOperations operations, string resourceGroupName, string automationAccountName, string nodeId, DscNodeUpdateParameters dscNodeUpdateParameters)
            {
                return operations.UpdateAsync(resourceGroupName, automationAccountName, nodeId, dscNodeUpdateParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Update the dsc node.
            /// <see href="http://aka.ms/azureautomationsdk/dscnodeoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='nodeId'>
            /// Parameters supplied to the update dsc node.
            /// </param>
            /// <param name='dscNodeUpdateParameters'>
            /// Parameters supplied to the update dsc node.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DscNode> UpdateAsync(this IDscNodeOperations operations, string resourceGroupName, string automationAccountName, string nodeId, DscNodeUpdateParameters dscNodeUpdateParameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(resourceGroupName, automationAccountName, nodeId, dscNodeUpdateParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieve a list of dsc nodes.
            /// <see href="http://aka.ms/azureautomationsdk/dscnodeoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='inlinecount'>
            /// Return total rows.
            /// </param>
            public static IPage<DscNode> ListByAutomationAccount(this IDscNodeOperations operations, string resourceGroupName, string automationAccountName, ODataQuery<DscNode> odataQuery = default(ODataQuery<DscNode>), string inlinecount = default(string))
            {
                return operations.ListByAutomationAccountAsync(resourceGroupName, automationAccountName, odataQuery, inlinecount).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve a list of dsc nodes.
            /// <see href="http://aka.ms/azureautomationsdk/dscnodeoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='inlinecount'>
            /// Return total rows.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<DscNode>> ListByAutomationAccountAsync(this IDscNodeOperations operations, string resourceGroupName, string automationAccountName, ODataQuery<DscNode> odataQuery = default(ODataQuery<DscNode>), string inlinecount = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByAutomationAccountWithHttpMessagesAsync(resourceGroupName, automationAccountName, odataQuery, inlinecount, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieve a list of dsc nodes.
            /// <see href="http://aka.ms/azureautomationsdk/dscnodeoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<DscNode> ListByAutomationAccountNext(this IDscNodeOperations operations, string nextPageLink)
            {
                return operations.ListByAutomationAccountNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve a list of dsc nodes.
            /// <see href="http://aka.ms/azureautomationsdk/dscnodeoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<DscNode>> ListByAutomationAccountNextAsync(this IDscNodeOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByAutomationAccountNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
