// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties of the create Advanced Schedule.
    /// </summary>
    public partial class AdvancedSchedule
    {
        /// <summary>
        /// Initializes a new instance of the AdvancedSchedule class.
        /// </summary>
        public AdvancedSchedule()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AdvancedSchedule class.
        /// </summary>
        /// <param name="weekDays">Days of the week that the job should execute
        /// on.</param>
        /// <param name="monthDays">Days of the month that the job should
        /// execute on. Must be between 1 and 31.</param>
        /// <param name="monthlyOccurrences">Occurrences of days within a
        /// month.</param>
        public AdvancedSchedule(IList<string> weekDays = default(IList<string>), IList<int> monthDays = default(IList<int>), IList<AdvancedScheduleMonthlyOccurrence> monthlyOccurrences = default(IList<AdvancedScheduleMonthlyOccurrence>))
        {
            WeekDays = weekDays;
            MonthDays = monthDays;
            MonthlyOccurrences = monthlyOccurrences;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets days of the week that the job should execute on.
        /// </summary>
        [JsonProperty(PropertyName = "weekDays")]
        public IList<string> WeekDays { get; set; }

        /// <summary>
        /// Gets or sets days of the month that the job should execute on. Must
        /// be between 1 and 31.
        /// </summary>
        [JsonProperty(PropertyName = "monthDays")]
        public IList<int> MonthDays { get; set; }

        /// <summary>
        /// Gets or sets occurrences of days within a month.
        /// </summary>
        [JsonProperty(PropertyName = "monthlyOccurrences")]
        public IList<AdvancedScheduleMonthlyOccurrence> MonthlyOccurrences { get; set; }

    }
}
