// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// object returned when requesting a collection of software update
    /// configuration
    /// </summary>
    public partial class CollectionItemUpdateConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the CollectionItemUpdateConfiguration
        /// class.
        /// </summary>
        public CollectionItemUpdateConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CollectionItemUpdateConfiguration
        /// class.
        /// </summary>
        /// <param name="azureVirtualMachines">List of azure resource Ids for
        /// azure virtual machines targeted by the software update
        /// configuration.</param>
        /// <param name="duration">Maximum time allowed for the software update
        /// configuration run. Duration needs to be specified using the format
        /// PT[n]H[n]M[n]S as per ISO8601</param>
        public CollectionItemUpdateConfiguration(IList<string> azureVirtualMachines = default(IList<string>), System.TimeSpan? duration = default(System.TimeSpan?))
        {
            AzureVirtualMachines = azureVirtualMachines;
            Duration = duration;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets list of azure resource Ids for azure virtual machines
        /// targeted by the software update configuration.
        /// </summary>
        [JsonProperty(PropertyName = "azureVirtualMachines")]
        public IList<string> AzureVirtualMachines { get; set; }

        /// <summary>
        /// Gets or sets maximum time allowed for the software update
        /// configuration run. Duration needs to be specified using the format
        /// PT[n]H[n]M[n]S as per ISO8601
        /// </summary>
        [JsonProperty(PropertyName = "duration")]
        public System.TimeSpan? Duration { get; set; }

    }
}
