// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Definition of the connection.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class Connection : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the Connection class.
        /// </summary>
        public Connection()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Connection class.
        /// </summary>
        /// <param name="id">Fully qualified resource Id for the
        /// resource</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="type">The type of the resource.</param>
        /// <param name="connectionType">Gets or sets the connectionType of the
        /// connection.</param>
        /// <param name="fieldDefinitionValues">Gets the field definition
        /// values of the connection.</param>
        /// <param name="creationTime">Gets the creation time.</param>
        /// <param name="lastModifiedTime">Gets the last modified time.</param>
        /// <param name="description">Gets or sets the description.</param>
        public Connection(string id = default(string), string name = default(string), string type = default(string), ConnectionTypeAssociationProperty connectionType = default(ConnectionTypeAssociationProperty), IDictionary<string, string> fieldDefinitionValues = default(IDictionary<string, string>), System.DateTimeOffset creationTime = default(System.DateTimeOffset), System.DateTimeOffset lastModifiedTime = default(System.DateTimeOffset), string description = default(string))
            : base(id, name, type)
        {
            ConnectionType = connectionType;
            FieldDefinitionValues = fieldDefinitionValues;
            CreationTime = creationTime;
            LastModifiedTime = lastModifiedTime;
            Description = description;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the connectionType of the connection.
        /// </summary>
        [JsonProperty(PropertyName = "properties.connectionType")]
        public ConnectionTypeAssociationProperty ConnectionType { get; set; }

        /// <summary>
        /// Gets the field definition values of the connection.
        /// </summary>
        [JsonProperty(PropertyName = "properties.fieldDefinitionValues")]
        public IDictionary<string, string> FieldDefinitionValues { get; private set; }

        /// <summary>
        /// Gets the creation time.
        /// </summary>
        [JsonProperty(PropertyName = "properties.creationTime")]
        public System.DateTimeOffset CreationTime { get; private set; }

        /// <summary>
        /// Gets the last modified time.
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastModifiedTime")]
        public System.DateTimeOffset LastModifiedTime { get; private set; }

        /// <summary>
        /// Gets or sets the description.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

    }
}
