// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Definition of hybrid runbook worker group.
    /// </summary>
    public partial class HybridRunbookWorkerGroup
    {
        /// <summary>
        /// Initializes a new instance of the HybridRunbookWorkerGroup class.
        /// </summary>
        public HybridRunbookWorkerGroup()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the HybridRunbookWorkerGroup class.
        /// </summary>
        /// <param name="id">Gets or sets the id of the resource.</param>
        /// <param name="name">Gets or sets the name of the group.</param>
        /// <param name="hybridRunbookWorkers">Gets or sets the list of hybrid
        /// runbook workers.</param>
        /// <param name="credential">Sets the credential of a worker
        /// group.</param>
        /// <param name="groupType">Type of the HybridWorkerGroup. Possible
        /// values include: 'User', 'System'</param>
        public HybridRunbookWorkerGroup(string id = default(string), string name = default(string), IList<HybridRunbookWorker> hybridRunbookWorkers = default(IList<HybridRunbookWorker>), RunAsCredentialAssociationProperty credential = default(RunAsCredentialAssociationProperty), string groupType = default(string))
        {
            Id = id;
            Name = name;
            HybridRunbookWorkers = hybridRunbookWorkers;
            Credential = credential;
            GroupType = groupType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the id of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the name of the group.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the list of hybrid runbook workers.
        /// </summary>
        [JsonProperty(PropertyName = "hybridRunbookWorkers")]
        public IList<HybridRunbookWorker> HybridRunbookWorkers { get; set; }

        /// <summary>
        /// Gets or sets sets the credential of a worker group.
        /// </summary>
        [JsonProperty(PropertyName = "credential")]
        public RunAsCredentialAssociationProperty Credential { get; set; }

        /// <summary>
        /// Gets or sets type of the HybridWorkerGroup. Possible values
        /// include: 'User', 'System'
        /// </summary>
        [JsonProperty(PropertyName = "groupType")]
        public string GroupType { get; set; }

    }
}
