// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Job collection item properties.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class JobCollectionItem : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the JobCollectionItem class.
        /// </summary>
        public JobCollectionItem()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JobCollectionItem class.
        /// </summary>
        /// <param name="id">Fully qualified resource Id for the
        /// resource</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="type">The type of the resource.</param>
        /// <param name="runbook">The runbook association.</param>
        /// <param name="jobId">The id of the job.</param>
        /// <param name="creationTime">The creation time of the job.</param>
        /// <param name="status">The status of the job. Possible values
        /// include: 'New', 'Activating', 'Running', 'Completed', 'Failed',
        /// 'Stopped', 'Blocked', 'Suspended', 'Disconnected', 'Suspending',
        /// 'Stopping', 'Resuming', 'Removing'</param>
        /// <param name="startTime">The start time of the job.</param>
        /// <param name="endTime">The end time of the job.</param>
        /// <param name="lastModifiedTime">The last modified time of the
        /// job.</param>
        /// <param name="provisioningState">The provisioning state of a
        /// resource.</param>
        /// <param name="runOn">Specifies the runOn group name where the job
        /// was executed.</param>
        public JobCollectionItem(string id = default(string), string name = default(string), string type = default(string), RunbookAssociationProperty runbook = default(RunbookAssociationProperty), System.Guid jobId = default(System.Guid), System.DateTimeOffset creationTime = default(System.DateTimeOffset), string status = default(string), System.DateTimeOffset? startTime = default(System.DateTimeOffset?), System.DateTimeOffset? endTime = default(System.DateTimeOffset?), System.DateTimeOffset? lastModifiedTime = default(System.DateTimeOffset?), string provisioningState = default(string), string runOn = default(string))
            : base(id, name, type)
        {
            Runbook = runbook;
            JobId = jobId;
            CreationTime = creationTime;
            Status = status;
            StartTime = startTime;
            EndTime = endTime;
            LastModifiedTime = lastModifiedTime;
            ProvisioningState = provisioningState;
            RunOn = runOn;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the runbook association.
        /// </summary>
        [JsonProperty(PropertyName = "properties.runbook")]
        public RunbookAssociationProperty Runbook { get; private set; }

        /// <summary>
        /// Gets the id of the job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.jobId")]
        public System.Guid JobId { get; private set; }

        /// <summary>
        /// Gets the creation time of the job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.creationTime")]
        public System.DateTimeOffset CreationTime { get; private set; }

        /// <summary>
        /// Gets the status of the job. Possible values include: 'New',
        /// 'Activating', 'Running', 'Completed', 'Failed', 'Stopped',
        /// 'Blocked', 'Suspended', 'Disconnected', 'Suspending', 'Stopping',
        /// 'Resuming', 'Removing'
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public string Status { get; private set; }

        /// <summary>
        /// Gets the start time of the job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.startTime")]
        public System.DateTimeOffset? StartTime { get; private set; }

        /// <summary>
        /// Gets the end time of the job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.endTime")]
        public System.DateTimeOffset? EndTime { get; private set; }

        /// <summary>
        /// Gets the last modified time of the job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastModifiedTime")]
        public System.DateTimeOffset? LastModifiedTime { get; private set; }

        /// <summary>
        /// Gets the provisioning state of a resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets specifies the runOn group name where the job was
        /// executed.
        /// </summary>
        [JsonProperty(PropertyName = "properties.runOn")]
        public string RunOn { get; set; }

    }
}
