// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Automation key which is used to register a DSC Node
    /// </summary>
    public partial class Key
    {
        /// <summary>
        /// Initializes a new instance of the Key class.
        /// </summary>
        public Key()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Key class.
        /// </summary>
        /// <param name="keyName">Automation key name. Possible values include:
        /// 'Primary', 'Secondary'</param>
        /// <param name="permissions">Automation key permissions. Possible
        /// values include: 'Read', 'Full'</param>
        /// <param name="value">Value of the Automation Key used for
        /// registration.</param>
        public Key(string keyName = default(string), string permissions = default(string), string value = default(string))
        {
            KeyName = keyName;
            Permissions = permissions;
            Value = value;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets automation key name. Possible values include: 'Primary',
        /// 'Secondary'
        /// </summary>
        [JsonProperty(PropertyName = "KeyName")]
        public string KeyName { get; private set; }

        /// <summary>
        /// Gets automation key permissions. Possible values include: 'Read',
        /// 'Full'
        /// </summary>
        [JsonProperty(PropertyName = "Permissions")]
        public string Permissions { get; private set; }

        /// <summary>
        /// Gets value of the Automation Key used for registration.
        /// </summary>
        [JsonProperty(PropertyName = "Value")]
        public string Value { get; private set; }

    }
}
