// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Linux specific update configuration.
    /// </summary>
    public partial class LinuxProperties
    {
        /// <summary>
        /// Initializes a new instance of the LinuxProperties class.
        /// </summary>
        public LinuxProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the LinuxProperties class.
        /// </summary>
        /// <param name="includedPackageClassifications">Update classifications
        /// included in the software update configuration. Possible values
        /// include: 'Unclassified', 'Critical', 'Security', 'Other'</param>
        /// <param name="excludedPackageNameMasks">packages excluded from the
        /// software update configuration.</param>
        /// <param name="includedPackageNameMasks">packages included from the
        /// software update configuration.</param>
        /// <param name="rebootSetting">Reboot setting for the software update
        /// configuration.</param>
        public LinuxProperties(string includedPackageClassifications = default(string), IList<string> excludedPackageNameMasks = default(IList<string>), IList<string> includedPackageNameMasks = default(IList<string>), string rebootSetting = default(string))
        {
            IncludedPackageClassifications = includedPackageClassifications;
            ExcludedPackageNameMasks = excludedPackageNameMasks;
            IncludedPackageNameMasks = includedPackageNameMasks;
            RebootSetting = rebootSetting;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets update classifications included in the software update
        /// configuration. Possible values include: 'Unclassified', 'Critical',
        /// 'Security', 'Other'
        /// </summary>
        [JsonProperty(PropertyName = "includedPackageClassifications")]
        public string IncludedPackageClassifications { get; set; }

        /// <summary>
        /// Gets or sets packages excluded from the software update
        /// configuration.
        /// </summary>
        [JsonProperty(PropertyName = "excludedPackageNameMasks")]
        public IList<string> ExcludedPackageNameMasks { get; set; }

        /// <summary>
        /// Gets or sets packages included from the software update
        /// configuration.
        /// </summary>
        [JsonProperty(PropertyName = "includedPackageNameMasks")]
        public IList<string> IncludedPackageNameMasks { get; set; }

        /// <summary>
        /// Gets or sets reboot setting for the software update configuration.
        /// </summary>
        [JsonProperty(PropertyName = "rebootSetting")]
        public string RebootSetting { get; set; }

    }
}
