// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Definition of the runbook type.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class Runbook : TrackedResource
    {
        /// <summary>
        /// Initializes a new instance of the Runbook class.
        /// </summary>
        public Runbook()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Runbook class.
        /// </summary>
        /// <param name="id">Fully qualified resource Id for the
        /// resource</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="type">The type of the resource.</param>
        /// <param name="tags">Resource tags.</param>
        /// <param name="location">The Azure Region where the resource
        /// lives</param>
        /// <param name="runbookType">Gets or sets the type of the runbook.
        /// Possible values include: 'Script', 'Graph', 'PowerShellWorkflow',
        /// 'PowerShell', 'GraphPowerShellWorkflow', 'GraphPowerShell'</param>
        /// <param name="publishContentLink">Gets or sets the published runbook
        /// content link.</param>
        /// <param name="state">Gets or sets the state of the runbook. Possible
        /// values include: 'New', 'Edit', 'Published'</param>
        /// <param name="logVerbose">Gets or sets verbose log option.</param>
        /// <param name="logProgress">Gets or sets progress log option.</param>
        /// <param name="logActivityTrace">Gets or sets the option to log
        /// activity trace of the runbook.</param>
        /// <param name="jobCount">Gets or sets the job count of the
        /// runbook.</param>
        /// <param name="parameters">Gets or sets the runbook
        /// parameters.</param>
        /// <param name="outputTypes">Gets or sets the runbook output
        /// types.</param>
        /// <param name="draft">Gets or sets the draft runbook
        /// properties.</param>
        /// <param name="provisioningState">Gets or sets the provisioning state
        /// of the runbook. Possible values include: 'Succeeded'</param>
        /// <param name="lastModifiedBy">Gets or sets the last modified
        /// by.</param>
        /// <param name="creationTime">Gets or sets the creation time.</param>
        /// <param name="lastModifiedTime">Gets or sets the last modified
        /// time.</param>
        /// <param name="description">Gets or sets the description.</param>
        /// <param name="etag">Gets or sets the etag of the resource.</param>
        public Runbook(string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string location = default(string), string runbookType = default(string), ContentLink publishContentLink = default(ContentLink), string state = default(string), bool? logVerbose = default(bool?), bool? logProgress = default(bool?), int? logActivityTrace = default(int?), int? jobCount = default(int?), IDictionary<string, RunbookParameter> parameters = default(IDictionary<string, RunbookParameter>), IList<string> outputTypes = default(IList<string>), RunbookDraft draft = default(RunbookDraft), RunbookProvisioningState? provisioningState = default(RunbookProvisioningState?), string lastModifiedBy = default(string), System.DateTimeOffset creationTime = default(System.DateTimeOffset), System.DateTimeOffset lastModifiedTime = default(System.DateTimeOffset), string description = default(string), string etag = default(string))
            : base(id, name, type, tags, location)
        {
            RunbookType = runbookType;
            PublishContentLink = publishContentLink;
            State = state;
            LogVerbose = logVerbose;
            LogProgress = logProgress;
            LogActivityTrace = logActivityTrace;
            JobCount = jobCount;
            Parameters = parameters;
            OutputTypes = outputTypes;
            Draft = draft;
            ProvisioningState = provisioningState;
            LastModifiedBy = lastModifiedBy;
            CreationTime = creationTime;
            LastModifiedTime = lastModifiedTime;
            Description = description;
            Etag = etag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the type of the runbook. Possible values include:
        /// 'Script', 'Graph', 'PowerShellWorkflow', 'PowerShell',
        /// 'GraphPowerShellWorkflow', 'GraphPowerShell'
        /// </summary>
        [JsonProperty(PropertyName = "properties.runbookType")]
        public string RunbookType { get; set; }

        /// <summary>
        /// Gets or sets the published runbook content link.
        /// </summary>
        [JsonProperty(PropertyName = "properties.publishContentLink")]
        public ContentLink PublishContentLink { get; set; }

        /// <summary>
        /// Gets or sets the state of the runbook. Possible values include:
        /// 'New', 'Edit', 'Published'
        /// </summary>
        [JsonProperty(PropertyName = "properties.state")]
        public string State { get; set; }

        /// <summary>
        /// Gets or sets verbose log option.
        /// </summary>
        [JsonProperty(PropertyName = "properties.logVerbose")]
        public bool? LogVerbose { get; set; }

        /// <summary>
        /// Gets or sets progress log option.
        /// </summary>
        [JsonProperty(PropertyName = "properties.logProgress")]
        public bool? LogProgress { get; set; }

        /// <summary>
        /// Gets or sets the option to log activity trace of the runbook.
        /// </summary>
        [JsonProperty(PropertyName = "properties.logActivityTrace")]
        public int? LogActivityTrace { get; set; }

        /// <summary>
        /// Gets or sets the job count of the runbook.
        /// </summary>
        [JsonProperty(PropertyName = "properties.jobCount")]
        public int? JobCount { get; set; }

        /// <summary>
        /// Gets or sets the runbook parameters.
        /// </summary>
        [JsonProperty(PropertyName = "properties.parameters")]
        public IDictionary<string, RunbookParameter> Parameters { get; set; }

        /// <summary>
        /// Gets or sets the runbook output types.
        /// </summary>
        [JsonProperty(PropertyName = "properties.outputTypes")]
        public IList<string> OutputTypes { get; set; }

        /// <summary>
        /// Gets or sets the draft runbook properties.
        /// </summary>
        [JsonProperty(PropertyName = "properties.draft")]
        public RunbookDraft Draft { get; set; }

        /// <summary>
        /// Gets or sets the provisioning state of the runbook. Possible values
        /// include: 'Succeeded'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public RunbookProvisioningState? ProvisioningState { get; set; }

        /// <summary>
        /// Gets or sets the last modified by.
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastModifiedBy")]
        public string LastModifiedBy { get; set; }

        /// <summary>
        /// Gets or sets the creation time.
        /// </summary>
        [JsonProperty(PropertyName = "properties.creationTime")]
        public System.DateTimeOffset CreationTime { get; set; }

        /// <summary>
        /// Gets or sets the last modified time.
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastModifiedTime")]
        public System.DateTimeOffset LastModifiedTime { get; set; }

        /// <summary>
        /// Gets or sets the description.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets the etag of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (PublishContentLink != null)
            {
                PublishContentLink.Validate();
            }
            if (Draft != null)
            {
                Draft.Validate();
            }
        }
    }
}
