// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters supplied to the create or update draft runbook
    /// properties.
    /// </summary>
    public partial class RunbookCreateOrUpdateDraftProperties
    {
        /// <summary>
        /// Initializes a new instance of the
        /// RunbookCreateOrUpdateDraftProperties class.
        /// </summary>
        public RunbookCreateOrUpdateDraftProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// RunbookCreateOrUpdateDraftProperties class.
        /// </summary>
        /// <param name="runbookType">Gets or sets the type of the runbook.
        /// Possible values include: 'Script', 'Graph', 'PowerShellWorkflow',
        /// 'PowerShell', 'GraphPowerShellWorkflow', 'GraphPowerShell'</param>
        /// <param name="draft">Gets or sets the draft runbook
        /// properties.</param>
        /// <param name="logVerbose">Gets or sets verbose log option.</param>
        /// <param name="logProgress">Gets or sets progress log option.</param>
        /// <param name="description">Gets or sets the description of the
        /// runbook.</param>
        /// <param name="logActivityTrace">Gets or sets the activity-level
        /// tracing options of the runbook.</param>
        public RunbookCreateOrUpdateDraftProperties(string runbookType, RunbookDraft draft, bool? logVerbose = default(bool?), bool? logProgress = default(bool?), string description = default(string), int? logActivityTrace = default(int?))
        {
            LogVerbose = logVerbose;
            LogProgress = logProgress;
            RunbookType = runbookType;
            Draft = draft;
            Description = description;
            LogActivityTrace = logActivityTrace;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets verbose log option.
        /// </summary>
        [JsonProperty(PropertyName = "logVerbose")]
        public bool? LogVerbose { get; set; }

        /// <summary>
        /// Gets or sets progress log option.
        /// </summary>
        [JsonProperty(PropertyName = "logProgress")]
        public bool? LogProgress { get; set; }

        /// <summary>
        /// Gets or sets the type of the runbook. Possible values include:
        /// 'Script', 'Graph', 'PowerShellWorkflow', 'PowerShell',
        /// 'GraphPowerShellWorkflow', 'GraphPowerShell'
        /// </summary>
        [JsonProperty(PropertyName = "runbookType")]
        public string RunbookType { get; set; }

        /// <summary>
        /// Gets or sets the draft runbook properties.
        /// </summary>
        [JsonProperty(PropertyName = "draft")]
        public RunbookDraft Draft { get; set; }

        /// <summary>
        /// Gets or sets the description of the runbook.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets the activity-level tracing options of the runbook.
        /// </summary>
        [JsonProperty(PropertyName = "logActivityTrace")]
        public int? LogActivityTrace { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (RunbookType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "RunbookType");
            }
            if (Draft == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Draft");
            }
            if (Draft != null)
            {
                Draft.Validate();
            }
        }
    }
}
