// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class RunbookDraft
    {
        /// <summary>
        /// Initializes a new instance of the RunbookDraft class.
        /// </summary>
        public RunbookDraft()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RunbookDraft class.
        /// </summary>
        /// <param name="inEdit">Gets or sets whether runbook is in edit
        /// mode.</param>
        /// <param name="draftContentLink">Gets or sets the draft runbook
        /// content link.</param>
        /// <param name="creationTime">Gets or sets the creation time of the
        /// runbook draft.</param>
        /// <param name="lastModifiedTime">Gets or sets the last modified time
        /// of the runbook draft.</param>
        /// <param name="parameters">Gets or sets the runbook draft
        /// parameters.</param>
        /// <param name="outputTypes">Gets or sets the runbook output
        /// types.</param>
        public RunbookDraft(bool? inEdit = default(bool?), ContentLink draftContentLink = default(ContentLink), System.DateTimeOffset creationTime = default(System.DateTimeOffset), System.DateTimeOffset lastModifiedTime = default(System.DateTimeOffset), IDictionary<string, RunbookParameter> parameters = default(IDictionary<string, RunbookParameter>), IList<string> outputTypes = default(IList<string>))
        {
            InEdit = inEdit;
            DraftContentLink = draftContentLink;
            CreationTime = creationTime;
            LastModifiedTime = lastModifiedTime;
            Parameters = parameters;
            OutputTypes = outputTypes;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets whether runbook is in edit mode.
        /// </summary>
        [JsonProperty(PropertyName = "inEdit")]
        public bool? InEdit { get; set; }

        /// <summary>
        /// Gets or sets the draft runbook content link.
        /// </summary>
        [JsonProperty(PropertyName = "draftContentLink")]
        public ContentLink DraftContentLink { get; set; }

        /// <summary>
        /// Gets or sets the creation time of the runbook draft.
        /// </summary>
        [JsonProperty(PropertyName = "creationTime")]
        public System.DateTimeOffset CreationTime { get; set; }

        /// <summary>
        /// Gets or sets the last modified time of the runbook draft.
        /// </summary>
        [JsonProperty(PropertyName = "lastModifiedTime")]
        public System.DateTimeOffset LastModifiedTime { get; set; }

        /// <summary>
        /// Gets or sets the runbook draft parameters.
        /// </summary>
        [JsonProperty(PropertyName = "parameters")]
        public IDictionary<string, RunbookParameter> Parameters { get; set; }

        /// <summary>
        /// Gets or sets the runbook output types.
        /// </summary>
        [JsonProperty(PropertyName = "outputTypes")]
        public IList<string> OutputTypes { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (DraftContentLink != null)
            {
                DraftContentLink.Validate();
            }
        }
    }
}
