// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Definition of the source control sync job.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class SourceControlSyncJobById
    {
        /// <summary>
        /// Initializes a new instance of the SourceControlSyncJobById class.
        /// </summary>
        public SourceControlSyncJobById()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SourceControlSyncJobById class.
        /// </summary>
        /// <param name="id">The id of the job.</param>
        /// <param name="sourceControlSyncJobId">The source control sync job
        /// id.</param>
        /// <param name="creationTime">The creation time of the job.</param>
        /// <param name="provisioningState">The provisioning state of the job.
        /// Possible values include: 'Completed', 'Failed', 'Running'</param>
        /// <param name="startTime">The start time of the job.</param>
        /// <param name="endTime">The end time of the job.</param>
        /// <param name="syncType">The sync type. Possible values include:
        /// 'PartialSync', 'FullSync'</param>
        /// <param name="exception">The exceptions that occurred while running
        /// the sync job.</param>
        public SourceControlSyncJobById(string id = default(string), string sourceControlSyncJobId = default(string), System.DateTimeOffset creationTime = default(System.DateTimeOffset), string provisioningState = default(string), System.DateTimeOffset? startTime = default(System.DateTimeOffset?), System.DateTimeOffset? endTime = default(System.DateTimeOffset?), string syncType = default(string), string exception = default(string))
        {
            Id = id;
            SourceControlSyncJobId = sourceControlSyncJobId;
            CreationTime = creationTime;
            ProvisioningState = provisioningState;
            StartTime = startTime;
            EndTime = endTime;
            SyncType = syncType;
            Exception = exception;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the id of the job.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the source control sync job id.
        /// </summary>
        [JsonProperty(PropertyName = "properties.sourceControlSyncJobId")]
        public string SourceControlSyncJobId { get; set; }

        /// <summary>
        /// Gets the creation time of the job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.creationTime")]
        public System.DateTimeOffset CreationTime { get; private set; }

        /// <summary>
        /// Gets or sets the provisioning state of the job. Possible values
        /// include: 'Completed', 'Failed', 'Running'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets the start time of the job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.startTime")]
        public System.DateTimeOffset? StartTime { get; private set; }

        /// <summary>
        /// Gets the end time of the job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.endTime")]
        public System.DateTimeOffset? EndTime { get; private set; }

        /// <summary>
        /// Gets or sets the sync type. Possible values include: 'PartialSync',
        /// 'FullSync'
        /// </summary>
        [JsonProperty(PropertyName = "properties.syncType")]
        public string SyncType { get; set; }

        /// <summary>
        /// Gets or sets the exceptions that occurred while running the sync
        /// job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.exception")]
        public string Exception { get; set; }

    }
}
