// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for NodeCountInformationOperations.
    /// </summary>
    public static partial class NodeCountInformationOperationsExtensions
    {
            /// <summary>
            /// Retrieve counts for Dsc Nodes.
            /// <see href="http://aka.ms/azureautomationsdk/nodecounts" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='countType'>
            /// The type of counts to retrieve. Possible values include: 'status',
            /// 'nodeconfiguration'
            /// </param>
            public static NodeCounts Get(this INodeCountInformationOperations operations, string resourceGroupName, string automationAccountName, string countType)
            {
                return operations.GetAsync(resourceGroupName, automationAccountName, countType).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve counts for Dsc Nodes.
            /// <see href="http://aka.ms/azureautomationsdk/nodecounts" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='countType'>
            /// The type of counts to retrieve. Possible values include: 'status',
            /// 'nodeconfiguration'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<NodeCounts> GetAsync(this INodeCountInformationOperations operations, string resourceGroupName, string automationAccountName, string countType, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, automationAccountName, countType, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
