// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Automation
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for Python2PackageOperations.
    /// </summary>
    public static partial class Python2PackageOperationsExtensions
    {
            /// <summary>
            /// Delete the python 2 package by name.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='packageName'>
            /// The python package name.
            /// </param>
            public static void Delete(this IPython2PackageOperations operations, string resourceGroupName, string automationAccountName, string packageName)
            {
                operations.DeleteAsync(resourceGroupName, automationAccountName, packageName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete the python 2 package by name.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='packageName'>
            /// The python package name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IPython2PackageOperations operations, string resourceGroupName, string automationAccountName, string packageName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, automationAccountName, packageName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Retrieve the python 2 package identified by package name.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='packageName'>
            /// The python package name.
            /// </param>
            public static Module Get(this IPython2PackageOperations operations, string resourceGroupName, string automationAccountName, string packageName)
            {
                return operations.GetAsync(resourceGroupName, automationAccountName, packageName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve the python 2 package identified by package name.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='packageName'>
            /// The python package name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Module> GetAsync(this IPython2PackageOperations operations, string resourceGroupName, string automationAccountName, string packageName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, automationAccountName, packageName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Create or Update the python 2 package identified by package name.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='packageName'>
            /// The name of python package.
            /// </param>
            /// <param name='parameters'>
            /// The create or update parameters for python package.
            /// </param>
            public static Module CreateOrUpdate(this IPython2PackageOperations operations, string resourceGroupName, string automationAccountName, string packageName, PythonPackageCreateParameters parameters)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, automationAccountName, packageName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or Update the python 2 package identified by package name.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='packageName'>
            /// The name of python package.
            /// </param>
            /// <param name='parameters'>
            /// The create or update parameters for python package.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Module> CreateOrUpdateAsync(this IPython2PackageOperations operations, string resourceGroupName, string automationAccountName, string packageName, PythonPackageCreateParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, automationAccountName, packageName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Update the python 2 package identified by package name.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='packageName'>
            /// The name of python package.
            /// </param>
            /// <param name='parameters'>
            /// The update parameters for python package.
            /// </param>
            public static Module Update(this IPython2PackageOperations operations, string resourceGroupName, string automationAccountName, string packageName, PythonPackageUpdateParameters parameters)
            {
                return operations.UpdateAsync(resourceGroupName, automationAccountName, packageName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Update the python 2 package identified by package name.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='packageName'>
            /// The name of python package.
            /// </param>
            /// <param name='parameters'>
            /// The update parameters for python package.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Module> UpdateAsync(this IPython2PackageOperations operations, string resourceGroupName, string automationAccountName, string packageName, PythonPackageUpdateParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(resourceGroupName, automationAccountName, packageName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieve a list of python 2 packages.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            public static IPage<Module> ListByAutomationAccount(this IPython2PackageOperations operations, string resourceGroupName, string automationAccountName)
            {
                return operations.ListByAutomationAccountAsync(resourceGroupName, automationAccountName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve a list of python 2 packages.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of an Azure Resource group.
            /// </param>
            /// <param name='automationAccountName'>
            /// The name of the automation account.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Module>> ListByAutomationAccountAsync(this IPython2PackageOperations operations, string resourceGroupName, string automationAccountName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByAutomationAccountWithHttpMessagesAsync(resourceGroupName, automationAccountName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieve a list of python 2 packages.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<Module> ListByAutomationAccountNext(this IPython2PackageOperations operations, string nextPageLink)
            {
                return operations.ListByAutomationAccountNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieve a list of python 2 packages.
            /// <see href="http://aka.ms/azureautomationsdk/moduleoperations" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Module>> ListByAutomationAccountNextAsync(this IPython2PackageOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByAutomationAccountNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
