// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.AzureBridge.Admin.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Base object for all product classes.
    /// </summary>
    public partial class ProductBase
    {
        /// <summary>
        /// Initializes a new instance of the ProductBase class.
        /// </summary>
        public ProductBase()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ProductBase class.
        /// </summary>
        /// <param name="displayName">Name displayed for the product.</param>
        /// <param name="description">Description of the product.</param>
        /// <param name="publisherDisplayName">Name of publisher.</param>
        /// <param name="publisherIdentifier">Publisher identifier.</param>
        /// <param name="offer">Offer name.</param>
        /// <param name="offerVersion">Offer version.</param>
        /// <param name="sku">Product SKU.</param>
        /// <param name="billingPartNumber">Billing part number.</param>
        /// <param name="galleryItemIdentity">Gallery item identity.</param>
        /// <param name="iconUris">Information about gallery icons.</param>
        /// <param name="payloadLength">Size in bytes.</param>
        /// <param name="productKind">The kind. E.g.
        /// VirtualMachineProductProperties.ProductKind or WebApp,
        /// SolutionTemplate.</param>
        /// <param name="productProperties">the product properties. At the
        /// moment only VirtualMachineProductProperties is allowed.</param>
        public ProductBase(string displayName = default(string), string description = default(string), string publisherDisplayName = default(string), string publisherIdentifier = default(string), string offer = default(string), string offerVersion = default(string), string sku = default(string), string billingPartNumber = default(string), string galleryItemIdentity = default(string), GalleryIcons iconUris = default(GalleryIcons), long? payloadLength = default(long?), string productKind = default(string), ProductProperties productProperties = default(ProductProperties))
        {
            DisplayName = displayName;
            Description = description;
            PublisherDisplayName = publisherDisplayName;
            PublisherIdentifier = publisherIdentifier;
            Offer = offer;
            OfferVersion = offerVersion;
            Sku = sku;
            BillingPartNumber = billingPartNumber;
            GalleryItemIdentity = galleryItemIdentity;
            IconUris = iconUris;
            PayloadLength = payloadLength;
            ProductKind = productKind;
            ProductProperties = productProperties;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name displayed for the product.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets description of the product.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets name of publisher.
        /// </summary>
        [JsonProperty(PropertyName = "publisherDisplayName")]
        public string PublisherDisplayName { get; set; }

        /// <summary>
        /// Gets or sets publisher identifier.
        /// </summary>
        [JsonProperty(PropertyName = "publisherIdentifier")]
        public string PublisherIdentifier { get; set; }

        /// <summary>
        /// Gets or sets offer name.
        /// </summary>
        [JsonProperty(PropertyName = "offer")]
        public string Offer { get; set; }

        /// <summary>
        /// Gets or sets offer version.
        /// </summary>
        [JsonProperty(PropertyName = "offerVersion")]
        public string OfferVersion { get; set; }

        /// <summary>
        /// Gets or sets product SKU.
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public string Sku { get; set; }

        /// <summary>
        /// Gets or sets billing part number.
        /// </summary>
        [JsonProperty(PropertyName = "billingPartNumber")]
        public string BillingPartNumber { get; set; }

        /// <summary>
        /// Gets or sets gallery item identity.
        /// </summary>
        [JsonProperty(PropertyName = "galleryItemIdentity")]
        public string GalleryItemIdentity { get; set; }

        /// <summary>
        /// Gets or sets information about gallery icons.
        /// </summary>
        [JsonProperty(PropertyName = "iconUris")]
        public GalleryIcons IconUris { get; set; }

        /// <summary>
        /// Gets or sets size in bytes.
        /// </summary>
        [JsonProperty(PropertyName = "payloadLength")]
        public long? PayloadLength { get; set; }

        /// <summary>
        /// Gets or sets the kind. E.g.
        /// VirtualMachineProductProperties.ProductKind or WebApp,
        /// SolutionTemplate.
        /// </summary>
        [JsonProperty(PropertyName = "productKind")]
        public string ProductKind { get; set; }

        /// <summary>
        /// Gets or sets the product properties. At the moment only
        /// VirtualMachineProductProperties is allowed.
        /// </summary>
        [JsonProperty(PropertyName = "productProperties")]
        public ProductProperties ProductProperties { get; set; }

    }
}
