// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Compute.Admin
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// VMExtensionsOperations operations.
    /// </summary>
    public partial interface IVMExtensionsOperations
    {
        /// <summary>
        /// Returns requested Virtual Machine Extension Image.
        /// </summary>
        /// <remarks>
        /// Returns requested Virtual Machine Extension Image matching
        /// publisher, type, version.
        /// </remarks>
        /// <param name='location'>
        /// Location of the resource.
        /// </param>
        /// <param name='publisher'>
        /// Name of the publisher.
        /// </param>
        /// <param name='type'>
        /// Type of extension.
        /// </param>
        /// <param name='version'>
        /// The version of the resource.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<VMExtension>> GetWithHttpMessagesAsync(string location, string publisher, string type, string version, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Create a Virtual Machine Extension Image.
        /// </summary>
        /// <remarks>
        /// Create a Virtual Machine Extension Image with publisher, version.
        /// </remarks>
        /// <param name='location'>
        /// Location of the resource.
        /// </param>
        /// <param name='publisher'>
        /// Name of the publisher.
        /// </param>
        /// <param name='type'>
        /// Type of extension.
        /// </param>
        /// <param name='version'>
        /// The version of the resource.
        /// </param>
        /// <param name='extension'>
        /// Virtual Machine Extension Image creation properties.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<VMExtension>> CreateWithHttpMessagesAsync(string location, string publisher, string type, string version, VMExtensionParameters extension, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Deletes a Virtual Machine Extension Image.
        /// </summary>
        /// <remarks>
        /// Deletes specified Virtual Machine Extension Image.
        /// </remarks>
        /// <param name='location'>
        /// Location of the resource.
        /// </param>
        /// <param name='publisher'>
        /// Name of the publisher.
        /// </param>
        /// <param name='type'>
        /// Type of extension.
        /// </param>
        /// <param name='version'>
        /// The version of the resource.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse> DeleteWithHttpMessagesAsync(string location, string publisher, string type, string version, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Returns a list of all Virtual Machine Extension Images.
        /// </summary>
        /// <remarks>
        /// List of all Virtual Machine Extension Images for the current
        /// location are returned.
        /// </remarks>
        /// <param name='location'>
        /// Location of the resource.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<IList<VMExtension>>> ListWithHttpMessagesAsync(string location, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
    }
}
