// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Compute.Admin.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Parameters used to create a new platform image.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class PlatformImageParameters
    {
        /// <summary>
        /// Initializes a new instance of the PlatformImageParameters class.
        /// </summary>
        public PlatformImageParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PlatformImageParameters class.
        /// </summary>
        /// <param name="osDisk">Operating system used for this platform
        /// image.</param>
        /// <param name="dataDisks">Data disks used by the platform
        /// image.</param>
        /// <param name="details">Information about the image.</param>
        /// <param name="provisioningState">Provisioning status of the platform
        /// image. Possible values include: 'Creating', 'Failed', 'Succeeded',
        /// 'Canceled'</param>
        public PlatformImageParameters(OsDisk osDisk = default(OsDisk), IList<DataDisk> dataDisks = default(IList<DataDisk>), ImageDetails details = default(ImageDetails), ProvisioningState? provisioningState = default(ProvisioningState?))
        {
            OsDisk = osDisk;
            DataDisks = dataDisks;
            Details = details;
            ProvisioningState = provisioningState;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets operating system used for this platform image.
        /// </summary>
        [JsonProperty(PropertyName = "properties.osDisk")]
        public OsDisk OsDisk { get; set; }

        /// <summary>
        /// Gets or sets data disks used by the platform image.
        /// </summary>
        [JsonProperty(PropertyName = "properties.dataDisks")]
        public IList<DataDisk> DataDisks { get; set; }

        /// <summary>
        /// Gets or sets information about the image.
        /// </summary>
        [JsonProperty(PropertyName = "properties.details")]
        public ImageDetails Details { get; set; }

        /// <summary>
        /// Gets or sets provisioning status of the platform image. Possible
        /// values include: 'Creating', 'Failed', 'Succeeded', 'Canceled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public ProvisioningState? ProvisioningState { get; set; }

    }
}
