// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Fabric.Admin
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Serialization;
    using Models;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;
    using System.Net;
    using System.Net.Http;

    /// <summary>
    /// Fabric Admin Client
    /// </summary>
    public partial class FabricAdminClient : ServiceClient<FabricAdminClient>, IFabricAdminClient, IAzureClient
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        public System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        public JsonSerializerSettings SerializationSettings { get; private set; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        public JsonSerializerSettings DeserializationSettings { get; private set; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        public ServiceClientCredentials Credentials { get; private set; }

        /// <summary>
        /// Subscription credentials that uniquely identify Microsoft Azure
        /// subscription. The subscription ID forms part of the URI for every service
        /// call.
        /// </summary>
        public string SubscriptionId { get; set; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        public string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default value is
        /// 30.
        /// </summary>
        public int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When set to
        /// true a unique x-ms-client-request-id value is generated and included in
        /// each request. Default is true.
        /// </summary>
        public bool? GenerateClientRequestId { get; set; }

        /// <summary>
        /// Gets the IApplicationOperationResultsOperations.
        /// </summary>
        public virtual IApplicationOperationResultsOperations ApplicationOperationResults { get; private set; }

        /// <summary>
        /// Gets the IComputeOperationResultsOperations.
        /// </summary>
        public virtual IComputeOperationResultsOperations ComputeOperationResults { get; private set; }

        /// <summary>
        /// Gets the IFabricOperations.
        /// </summary>
        public virtual IFabricOperations Fabric { get; private set; }

        /// <summary>
        /// Gets the IEdgeGatewaysOperations.
        /// </summary>
        public virtual IEdgeGatewaysOperations EdgeGateways { get; private set; }

        /// <summary>
        /// Gets the IEdgeGatewayPoolsOperations.
        /// </summary>
        public virtual IEdgeGatewayPoolsOperations EdgeGatewayPools { get; private set; }

        /// <summary>
        /// Gets the IFabricLocationsOperations.
        /// </summary>
        public virtual IFabricLocationsOperations FabricLocations { get; private set; }

        /// <summary>
        /// Gets the IFileSharesOperations.
        /// </summary>
        public virtual IFileSharesOperations FileShares { get; private set; }

        /// <summary>
        /// Gets the IInfraRolesOperations.
        /// </summary>
        public virtual IInfraRolesOperations InfraRoles { get; private set; }

        /// <summary>
        /// Gets the IInfraRoleInstancesOperations.
        /// </summary>
        public virtual IInfraRoleInstancesOperations InfraRoleInstances { get; private set; }

        /// <summary>
        /// Gets the IIpPoolsOperations.
        /// </summary>
        public virtual IIpPoolsOperations IpPools { get; private set; }

        /// <summary>
        /// Gets the ILogicalNetworksOperations.
        /// </summary>
        public virtual ILogicalNetworksOperations LogicalNetworks { get; private set; }

        /// <summary>
        /// Gets the ILogicalSubnetsOperations.
        /// </summary>
        public virtual ILogicalSubnetsOperations LogicalSubnets { get; private set; }

        /// <summary>
        /// Gets the IMacAddressPoolsOperations.
        /// </summary>
        public virtual IMacAddressPoolsOperations MacAddressPools { get; private set; }

        /// <summary>
        /// Gets the INetworkOperationResultsOperations.
        /// </summary>
        public virtual INetworkOperationResultsOperations NetworkOperationResults { get; private set; }

        /// <summary>
        /// Gets the IScaleUnitsOperations.
        /// </summary>
        public virtual IScaleUnitsOperations ScaleUnits { get; private set; }

        /// <summary>
        /// Gets the IScaleUnitNodesOperations.
        /// </summary>
        public virtual IScaleUnitNodesOperations ScaleUnitNodes { get; private set; }

        /// <summary>
        /// Gets the ISlbMuxInstancesOperations.
        /// </summary>
        public virtual ISlbMuxInstancesOperations SlbMuxInstances { get; private set; }

        /// <summary>
        /// Gets the IStorageOperationResultsOperations.
        /// </summary>
        public virtual IStorageOperationResultsOperations StorageOperationResults { get; private set; }

        /// <summary>
        /// Gets the IStorageSubSystemsOperations.
        /// </summary>
        public virtual IStorageSubSystemsOperations StorageSubSystems { get; private set; }

        /// <summary>
        /// Gets the IDrivesOperations.
        /// </summary>
        public virtual IDrivesOperations Drives { get; private set; }

        /// <summary>
        /// Gets the IVolumesOperations.
        /// </summary>
        public virtual IVolumesOperations Volumes { get; private set; }

        /// <summary>
        /// Initializes a new instance of the FabricAdminClient class.
        /// </summary>
        /// <param name='httpClient'>
        /// HttpClient to be used
        /// </param>
        /// <param name='disposeHttpClient'>
        /// True: will dispose the provided httpClient on calling FabricAdminClient.Dispose(). False: will not dispose provided httpClient</param>
        protected FabricAdminClient(HttpClient httpClient, bool disposeHttpClient) : base(httpClient, disposeHttpClient)
        {
            Initialize();
        }

        /// <summary>
        /// Initializes a new instance of the FabricAdminClient class.
        /// </summary>
        /// <param name='handlers'>
        /// Optional. The delegating handlers to add to the http client pipeline.
        /// </param>
        protected FabricAdminClient(params DelegatingHandler[] handlers) : base(handlers)
        {
            Initialize();
        }

        /// <summary>
        /// Initializes a new instance of the FabricAdminClient class.
        /// </summary>
        /// <param name='rootHandler'>
        /// Optional. The http client handler used to handle http transport.
        /// </param>
        /// <param name='handlers'>
        /// Optional. The delegating handlers to add to the http client pipeline.
        /// </param>
        protected FabricAdminClient(HttpClientHandler rootHandler, params DelegatingHandler[] handlers) : base(rootHandler, handlers)
        {
            Initialize();
        }

        /// <summary>
        /// Initializes a new instance of the FabricAdminClient class.
        /// </summary>
        /// <param name='baseUri'>
        /// Optional. The base URI of the service.
        /// </param>
        /// <param name='handlers'>
        /// Optional. The delegating handlers to add to the http client pipeline.
        /// </param>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        protected FabricAdminClient(System.Uri baseUri, params DelegatingHandler[] handlers) : this(handlers)
        {
            if (baseUri == null)
            {
                throw new System.ArgumentNullException("baseUri");
            }
            BaseUri = baseUri;
        }

        /// <summary>
        /// Initializes a new instance of the FabricAdminClient class.
        /// </summary>
        /// <param name='baseUri'>
        /// Optional. The base URI of the service.
        /// </param>
        /// <param name='rootHandler'>
        /// Optional. The http client handler used to handle http transport.
        /// </param>
        /// <param name='handlers'>
        /// Optional. The delegating handlers to add to the http client pipeline.
        /// </param>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        protected FabricAdminClient(System.Uri baseUri, HttpClientHandler rootHandler, params DelegatingHandler[] handlers) : this(rootHandler, handlers)
        {
            if (baseUri == null)
            {
                throw new System.ArgumentNullException("baseUri");
            }
            BaseUri = baseUri;
        }

        /// <summary>
        /// Initializes a new instance of the FabricAdminClient class.
        /// </summary>
        /// <param name='credentials'>
        /// Required. Credentials needed for the client to connect to Azure.
        /// </param>
        /// <param name='handlers'>
        /// Optional. The delegating handlers to add to the http client pipeline.
        /// </param>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        public FabricAdminClient(ServiceClientCredentials credentials, params DelegatingHandler[] handlers) : this(handlers)
        {
            if (credentials == null)
            {
                throw new System.ArgumentNullException("credentials");
            }
            Credentials = credentials;
            if (Credentials != null)
            {
                Credentials.InitializeServiceClient(this);
            }
        }

        /// <summary>
        /// Initializes a new instance of the FabricAdminClient class.
        /// </summary>
        /// <param name='credentials'>
        /// Required. Credentials needed for the client to connect to Azure.
        /// </param>
        /// <param name='httpClient'>
        /// HttpClient to be used
        /// </param>
        /// <param name='disposeHttpClient'>
        /// True: will dispose the provided httpClient on calling FabricAdminClient.Dispose(). False: will not dispose provided httpClient</param>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        public FabricAdminClient(ServiceClientCredentials credentials, HttpClient httpClient, bool disposeHttpClient) : this(httpClient, disposeHttpClient)
        {
            if (credentials == null)
            {
                throw new System.ArgumentNullException("credentials");
            }
            Credentials = credentials;
            if (Credentials != null)
            {
                Credentials.InitializeServiceClient(this);
            }
        }

        /// <summary>
        /// Initializes a new instance of the FabricAdminClient class.
        /// </summary>
        /// <param name='credentials'>
        /// Required. Credentials needed for the client to connect to Azure.
        /// </param>
        /// <param name='rootHandler'>
        /// Optional. The http client handler used to handle http transport.
        /// </param>
        /// <param name='handlers'>
        /// Optional. The delegating handlers to add to the http client pipeline.
        /// </param>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        public FabricAdminClient(ServiceClientCredentials credentials, HttpClientHandler rootHandler, params DelegatingHandler[] handlers) : this(rootHandler, handlers)
        {
            if (credentials == null)
            {
                throw new System.ArgumentNullException("credentials");
            }
            Credentials = credentials;
            if (Credentials != null)
            {
                Credentials.InitializeServiceClient(this);
            }
        }

        /// <summary>
        /// Initializes a new instance of the FabricAdminClient class.
        /// </summary>
        /// <param name='baseUri'>
        /// Optional. The base URI of the service.
        /// </param>
        /// <param name='credentials'>
        /// Required. Credentials needed for the client to connect to Azure.
        /// </param>
        /// <param name='handlers'>
        /// Optional. The delegating handlers to add to the http client pipeline.
        /// </param>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        public FabricAdminClient(System.Uri baseUri, ServiceClientCredentials credentials, params DelegatingHandler[] handlers) : this(handlers)
        {
            if (baseUri == null)
            {
                throw new System.ArgumentNullException("baseUri");
            }
            if (credentials == null)
            {
                throw new System.ArgumentNullException("credentials");
            }
            BaseUri = baseUri;
            Credentials = credentials;
            if (Credentials != null)
            {
                Credentials.InitializeServiceClient(this);
            }
        }

        /// <summary>
        /// Initializes a new instance of the FabricAdminClient class.
        /// </summary>
        /// <param name='baseUri'>
        /// Optional. The base URI of the service.
        /// </param>
        /// <param name='credentials'>
        /// Required. Credentials needed for the client to connect to Azure.
        /// </param>
        /// <param name='rootHandler'>
        /// Optional. The http client handler used to handle http transport.
        /// </param>
        /// <param name='handlers'>
        /// Optional. The delegating handlers to add to the http client pipeline.
        /// </param>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        public FabricAdminClient(System.Uri baseUri, ServiceClientCredentials credentials, HttpClientHandler rootHandler, params DelegatingHandler[] handlers) : this(rootHandler, handlers)
        {
            if (baseUri == null)
            {
                throw new System.ArgumentNullException("baseUri");
            }
            if (credentials == null)
            {
                throw new System.ArgumentNullException("credentials");
            }
            BaseUri = baseUri;
            Credentials = credentials;
            if (Credentials != null)
            {
                Credentials.InitializeServiceClient(this);
            }
        }

        /// <summary>
        /// An optional partial-method to perform custom initialization.
        /// </summary>
        partial void CustomInitialize();
        /// <summary>
        /// Initializes client properties.
        /// </summary>
        private void Initialize()
        {
            ApplicationOperationResults = new ApplicationOperationResultsOperations(this);
            ComputeOperationResults = new ComputeOperationResultsOperations(this);
            Fabric = new FabricOperations(this);
            EdgeGateways = new EdgeGatewaysOperations(this);
            EdgeGatewayPools = new EdgeGatewayPoolsOperations(this);
            FabricLocations = new FabricLocationsOperations(this);
            FileShares = new FileSharesOperations(this);
            InfraRoles = new InfraRolesOperations(this);
            InfraRoleInstances = new InfraRoleInstancesOperations(this);
            IpPools = new IpPoolsOperations(this);
            LogicalNetworks = new LogicalNetworksOperations(this);
            LogicalSubnets = new LogicalSubnetsOperations(this);
            MacAddressPools = new MacAddressPoolsOperations(this);
            NetworkOperationResults = new NetworkOperationResultsOperations(this);
            ScaleUnits = new ScaleUnitsOperations(this);
            ScaleUnitNodes = new ScaleUnitNodesOperations(this);
            SlbMuxInstances = new SlbMuxInstancesOperations(this);
            StorageOperationResults = new StorageOperationResultsOperations(this);
            StorageSubSystems = new StorageSubSystemsOperations(this);
            Drives = new DrivesOperations(this);
            Volumes = new VolumesOperations(this);
            BaseUri = new System.Uri("https://adminmanagement.local.azurestack.external");
            AcceptLanguage = "en-US";
            LongRunningOperationRetryTimeout = 30;
            GenerateClientRequestId = true;
            SerializationSettings = new JsonSerializerSettings
            {
                Formatting = Newtonsoft.Json.Formatting.Indented,
                DateFormatHandling = Newtonsoft.Json.DateFormatHandling.IsoDateFormat,
                DateTimeZoneHandling = Newtonsoft.Json.DateTimeZoneHandling.Utc,
                NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore,
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Serialize,
                ContractResolver = new ReadOnlyJsonContractResolver(),
                Converters = new List<JsonConverter>
                    {
                        new Iso8601TimeSpanConverter()
                    }
            };
            SerializationSettings.Converters.Add(new TransformationJsonConverter());
            DeserializationSettings = new JsonSerializerSettings
            {
                DateFormatHandling = Newtonsoft.Json.DateFormatHandling.IsoDateFormat,
                DateTimeZoneHandling = Newtonsoft.Json.DateTimeZoneHandling.Utc,
                NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore,
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Serialize,
                ContractResolver = new ReadOnlyJsonContractResolver(),
                Converters = new List<JsonConverter>
                    {
                        new Iso8601TimeSpanConverter()
                    }
            };
            CustomInitialize();
            DeserializationSettings.Converters.Add(new TransformationJsonConverter());
            DeserializationSettings.Converters.Add(new CloudErrorJsonConverter());
        }
    }
}
