// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Fabric.Admin.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A list of input data that allows for creating the new scale unit.
    /// </summary>
    public partial class CreateFromJsonScaleUnitParametersList
    {
        /// <summary>
        /// Initializes a new instance of the
        /// CreateFromJsonScaleUnitParametersList class.
        /// </summary>
        public CreateFromJsonScaleUnitParametersList()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// CreateFromJsonScaleUnitParametersList class.
        /// </summary>
        /// <param name="clusterName">Cluster name for the new scale
        /// unit.</param>
        /// <param name="physicalNodes">List of nodes in the scale
        /// unit.</param>
        /// <param name="torSwitchBgpAsn">The ASN for the cluster's rack
        /// TOR.</param>
        /// <param name="softwareBgpAsn">The software ASN for the cluster's
        /// rack.</param>
        /// <param name="torSwitchBgpPeerIp">The list of IP addresses used for
        /// TOR communication.</param>
        /// <param name="infrastructureNetwork">The information associated with
        /// the infrastructure network that will be subdivided into
        /// subnets.</param>
        /// <param name="storageNetwork">The information associated with the
        /// storage network that will be subdivided into subnets.</param>
        /// <param name="netQosPriority">The network QOS priority
        /// setting.</param>
        public CreateFromJsonScaleUnitParametersList(string clusterName = default(string), IList<DeploymentJsonPhysicalNodeParameters> physicalNodes = default(IList<DeploymentJsonPhysicalNodeParameters>), string torSwitchBgpAsn = default(string), string softwareBgpAsn = default(string), IList<string> torSwitchBgpPeerIp = default(IList<string>), NetworkDefinitionParameter infrastructureNetwork = default(NetworkDefinitionParameter), NetworkDefinitionParameter storageNetwork = default(NetworkDefinitionParameter), int? netQosPriority = default(int?))
        {
            ClusterName = clusterName;
            PhysicalNodes = physicalNodes;
            TorSwitchBgpAsn = torSwitchBgpAsn;
            SoftwareBgpAsn = softwareBgpAsn;
            TorSwitchBgpPeerIp = torSwitchBgpPeerIp;
            InfrastructureNetwork = infrastructureNetwork;
            StorageNetwork = storageNetwork;
            NetQosPriority = netQosPriority;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets cluster name for the new scale unit.
        /// </summary>
        [JsonProperty(PropertyName = "clusterName")]
        public string ClusterName { get; set; }

        /// <summary>
        /// Gets or sets list of nodes in the scale unit.
        /// </summary>
        [JsonProperty(PropertyName = "physicalNodes")]
        public IList<DeploymentJsonPhysicalNodeParameters> PhysicalNodes { get; set; }

        /// <summary>
        /// Gets or sets the ASN for the cluster's rack TOR.
        /// </summary>
        [JsonProperty(PropertyName = "torSwitchBgpAsn")]
        public string TorSwitchBgpAsn { get; set; }

        /// <summary>
        /// Gets or sets the software ASN for the cluster's rack.
        /// </summary>
        [JsonProperty(PropertyName = "softwareBgpAsn")]
        public string SoftwareBgpAsn { get; set; }

        /// <summary>
        /// Gets or sets the list of IP addresses used for TOR communication.
        /// </summary>
        [JsonProperty(PropertyName = "torSwitchBgpPeerIp")]
        public IList<string> TorSwitchBgpPeerIp { get; set; }

        /// <summary>
        /// Gets or sets the information associated with the infrastructure
        /// network that will be subdivided into subnets.
        /// </summary>
        [JsonProperty(PropertyName = "infrastructureNetwork")]
        public NetworkDefinitionParameter InfrastructureNetwork { get; set; }

        /// <summary>
        /// Gets or sets the information associated with the storage network
        /// that will be subdivided into subnets.
        /// </summary>
        [JsonProperty(PropertyName = "storageNetwork")]
        public NetworkDefinitionParameter StorageNetwork { get; set; }

        /// <summary>
        /// Gets or sets the network QOS priority setting.
        /// </summary>
        [JsonProperty(PropertyName = "netQosPriority")]
        public int? NetQosPriority { get; set; }

    }
}
