// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Fabric.Admin.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Object that contains properties of the file share resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class FileShare : Resource
    {
        /// <summary>
        /// Initializes a new instance of the FileShare class.
        /// </summary>
        public FileShare()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the FileShare class.
        /// </summary>
        /// <param name="id">URI of the resource.</param>
        /// <param name="name">Name of the resource.</param>
        /// <param name="type">Type of resource.</param>
        /// <param name="location">The region where the resource is
        /// located.</param>
        /// <param name="tags">List of key-value pairs.</param>
        /// <param name="associatedVolume">Associated volume ID.</param>
        /// <param name="uncPath">The UNCPath for the fileshare.</param>
        public FileShare(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string associatedVolume = default(string), string uncPath = default(string))
            : base(id, name, type, location, tags)
        {
            AssociatedVolume = associatedVolume;
            UncPath = uncPath;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets associated volume ID.
        /// </summary>
        [JsonProperty(PropertyName = "properties.associatedVolume")]
        public string AssociatedVolume { get; set; }

        /// <summary>
        /// Gets or sets the UNCPath for the fileshare.
        /// </summary>
        [JsonProperty(PropertyName = "properties.uncPath")]
        public string UncPath { get; set; }

    }
}
