// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Fabric.Admin.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Infrastructure role description.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class InfraRole : Resource
    {
        /// <summary>
        /// Initializes a new instance of the InfraRole class.
        /// </summary>
        public InfraRole()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the InfraRole class.
        /// </summary>
        /// <param name="id">URI of the resource.</param>
        /// <param name="name">Name of the resource.</param>
        /// <param name="type">Type of resource.</param>
        /// <param name="location">The region where the resource is
        /// located.</param>
        /// <param name="tags">List of key-value pairs.</param>
        /// <param name="instances">List of infrastructure role
        /// instances.</param>
        /// <param name="displayName">Display name for the infrastructure
        /// role.</param>
        /// <param name="restartable">Value indicating whether the
        /// infrastructure role can be restarted.</param>
        public InfraRole(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), IList<string> instances = default(IList<string>), string displayName = default(string), bool? restartable = default(bool?))
            : base(id, name, type, location, tags)
        {
            Instances = instances;
            DisplayName = displayName;
            Restartable = restartable;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets list of infrastructure role instances.
        /// </summary>
        [JsonProperty(PropertyName = "properties.instances")]
        public IList<string> Instances { get; set; }

        /// <summary>
        /// Gets or sets display name for the infrastructure role.
        /// </summary>
        [JsonProperty(PropertyName = "properties.displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets value indicating whether the infrastructure role can
        /// be restarted.
        /// </summary>
        [JsonProperty(PropertyName = "properties.restartable")]
        public bool? Restartable { get; set; }

    }
}
