// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Gallery.Admin.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents a product item read from the gallery item package.
    /// </summary>
    public partial class Product
    {
        /// <summary>
        /// Initializes a new instance of the Product class.
        /// </summary>
        public Product()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Product class.
        /// </summary>
        /// <param name="displayName">Display name of the product.</param>
        /// <param name="publisherDisplayName">Publisher display name of the
        /// product.</param>
        /// <param name="pricingDetailsUri">URI to the pricing details of the
        /// product.</param>
        /// <param name="offerDetails">Offer details of the product.</param>
        /// <param name="legalTerms">Legal terms of the product.</param>
        /// <param name="privacyPolicy">Privacy policy of the product.</param>
        /// <param name="legalTermsUri">URI to the legal terms of the
        /// product.</param>
        /// <param name="privacyPolicyUri">URI to the privacy policy of the
        /// product.</param>
        public Product(string displayName = default(string), string publisherDisplayName = default(string), string pricingDetailsUri = default(string), OfferDetails offerDetails = default(OfferDetails), string legalTerms = default(string), string privacyPolicy = default(string), string legalTermsUri = default(string), string privacyPolicyUri = default(string))
        {
            DisplayName = displayName;
            PublisherDisplayName = publisherDisplayName;
            PricingDetailsUri = pricingDetailsUri;
            OfferDetails = offerDetails;
            LegalTerms = legalTerms;
            PrivacyPolicy = privacyPolicy;
            LegalTermsUri = legalTermsUri;
            PrivacyPolicyUri = privacyPolicyUri;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets display name of the product.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets publisher display name of the product.
        /// </summary>
        [JsonProperty(PropertyName = "publisherDisplayName")]
        public string PublisherDisplayName { get; set; }

        /// <summary>
        /// Gets or sets URI to the pricing details of the product.
        /// </summary>
        [JsonProperty(PropertyName = "pricingDetailsUri")]
        public string PricingDetailsUri { get; set; }

        /// <summary>
        /// Gets or sets offer details of the product.
        /// </summary>
        [JsonProperty(PropertyName = "offerDetails")]
        public OfferDetails OfferDetails { get; set; }

        /// <summary>
        /// Gets or sets legal terms of the product.
        /// </summary>
        [JsonProperty(PropertyName = "legalTerms")]
        public string LegalTerms { get; set; }

        /// <summary>
        /// Gets or sets privacy policy of the product.
        /// </summary>
        [JsonProperty(PropertyName = "privacyPolicy")]
        public string PrivacyPolicy { get; set; }

        /// <summary>
        /// Gets or sets URI to the legal terms of the product.
        /// </summary>
        [JsonProperty(PropertyName = "legalTermsUri")]
        public string LegalTermsUri { get; set; }

        /// <summary>
        /// Gets or sets URI to the privacy policy of the product.
        /// </summary>
        [JsonProperty(PropertyName = "privacyPolicyUri")]
        public string PrivacyPolicyUri { get; set; }

    }
}
