// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.InfrastructureInsights.Admin
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Azure.OData;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ResourceHealthsOperations.
    /// </summary>
    public static partial class ResourceHealthsOperationsExtensions
    {
            /// <summary>
            /// Returns a list of each resource's health under a service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='location'>
            /// Name of the region
            /// </param>
            /// <param name='serviceRegistrationId'>
            /// Service registration ID.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            public static IPage<ResourceHealth> List(this IResourceHealthsOperations operations, string resourceGroupName, string location, string serviceRegistrationId, ODataQuery<ResourceHealth> odataQuery = default(ODataQuery<ResourceHealth>))
            {
                return operations.ListAsync(resourceGroupName, location, serviceRegistrationId, odataQuery).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns a list of each resource's health under a service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='location'>
            /// Name of the region
            /// </param>
            /// <param name='serviceRegistrationId'>
            /// Service registration ID.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ResourceHealth>> ListAsync(this IResourceHealthsOperations operations, string resourceGroupName, string location, string serviceRegistrationId, ODataQuery<ResourceHealth> odataQuery = default(ODataQuery<ResourceHealth>), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroupName, location, serviceRegistrationId, odataQuery, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns the requested health information about a resource.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='location'>
            /// Name of the region
            /// </param>
            /// <param name='serviceRegistrationId'>
            /// Service registration ID.
            /// </param>
            /// <param name='resourceRegistrationId'>
            /// Resource registration ID.
            /// </param>
            /// <param name='filter'>
            /// OData filter parameter.
            /// </param>
            public static ResourceHealth Get(this IResourceHealthsOperations operations, string resourceGroupName, string location, string serviceRegistrationId, string resourceRegistrationId, string filter = default(string))
            {
                return operations.GetAsync(resourceGroupName, location, serviceRegistrationId, resourceRegistrationId, filter).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns the requested health information about a resource.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='location'>
            /// Name of the region
            /// </param>
            /// <param name='serviceRegistrationId'>
            /// Service registration ID.
            /// </param>
            /// <param name='resourceRegistrationId'>
            /// Resource registration ID.
            /// </param>
            /// <param name='filter'>
            /// OData filter parameter.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ResourceHealth> GetAsync(this IResourceHealthsOperations operations, string resourceGroupName, string location, string serviceRegistrationId, string resourceRegistrationId, string filter = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, location, serviceRegistrationId, resourceRegistrationId, filter, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns a list of each resource's health under a service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<ResourceHealth> ListNext(this IResourceHealthsOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns a list of each resource's health under a service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ResourceHealth>> ListNextAsync(this IResourceHealthsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
