// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Storage.Admin
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for StorageQuotasOperations.
    /// </summary>
    public static partial class StorageQuotasOperationsExtensions
    {
            /// <summary>
            /// Create or update an existing storage quota.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='quotaName'>
            /// The name of the storage quota.
            /// </param>
            /// <param name='quotaObject'>
            /// The properties of quota being created or updated.
            /// </param>
            public static StorageQuota CreateOrUpdate(this IStorageQuotasOperations operations, string location, string quotaName, StorageQuota quotaObject)
            {
                return operations.CreateOrUpdateAsync(location, quotaName, quotaObject).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or update an existing storage quota.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='quotaName'>
            /// The name of the storage quota.
            /// </param>
            /// <param name='quotaObject'>
            /// The properties of quota being created or updated.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<StorageQuota> CreateOrUpdateAsync(this IStorageQuotasOperations operations, string location, string quotaName, StorageQuota quotaObject, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(location, quotaName, quotaObject, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete an existing quota
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='quotaName'>
            /// The name of the storage quota.
            /// </param>
            public static void Delete(this IStorageQuotasOperations operations, string location, string quotaName)
            {
                operations.DeleteAsync(location, quotaName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete an existing quota
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='quotaName'>
            /// The name of the storage quota.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IStorageQuotasOperations operations, string location, string quotaName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(location, quotaName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Returns the specified storage quota.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='quotaName'>
            /// The name of the storage quota.
            /// </param>
            public static StorageQuota Get(this IStorageQuotasOperations operations, string location, string quotaName)
            {
                return operations.GetAsync(location, quotaName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns the specified storage quota.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='quotaName'>
            /// The name of the storage quota.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<StorageQuota> GetAsync(this IStorageQuotasOperations operations, string location, string quotaName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(location, quotaName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns a list of storage quotas at the given location.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            public static StorageQuotaList List(this IStorageQuotasOperations operations, string location)
            {
                return operations.ListAsync(location).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns a list of storage quotas at the given location.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<StorageQuotaList> ListAsync(this IStorageQuotasOperations operations, string location, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(location, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
