// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Storage.Admin
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for StorageSettingsOperations.
    /// </summary>
    public static partial class StorageSettingsOperationsExtensions
    {
            /// <summary>
            /// Update storage resource provider settings.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='retentionPeriodForDeletedStorageAccountsInDays'>
            /// The number of days a deleted storage account is kept before being
            /// permanently deleted.
            /// </param>
            public static Settings Update(this IStorageSettingsOperations operations, string location, int? retentionPeriodForDeletedStorageAccountsInDays = default(int?))
            {
                return operations.UpdateAsync(location, retentionPeriodForDeletedStorageAccountsInDays).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Update storage resource provider settings.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='retentionPeriodForDeletedStorageAccountsInDays'>
            /// The number of days a deleted storage account is kept before being
            /// permanently deleted.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Settings> UpdateAsync(this IStorageSettingsOperations operations, string location, int? retentionPeriodForDeletedStorageAccountsInDays = default(int?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(location, retentionPeriodForDeletedStorageAccountsInDays, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns the storage resource provider settings.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            public static Settings Get(this IStorageSettingsOperations operations, string location)
            {
                return operations.GetAsync(location).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns the storage resource provider settings.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Settings> GetAsync(this IStorageSettingsOperations operations, string location, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(location, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
