// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Subscription.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// List of supported operations.
    /// </summary>
    public partial class SubscriptionModel
    {
        /// <summary>
        /// Initializes a new instance of the SubscriptionModel class.
        /// </summary>
        public SubscriptionModel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SubscriptionModel class.
        /// </summary>
        /// <param name="displayName">Subscription name.</param>
        /// <param name="id">Fully qualified identifier.</param>
        /// <param name="offerId">Identifier of the offer under the scope of a
        /// delegated provider.</param>
        /// <param name="state">Subscription state. Possible values include:
        /// 'NotDefined', 'Enabled', 'Warned', 'PastDue', 'Disabled',
        /// 'Deleted'</param>
        /// <param name="subscriptionId">Subscription identifier.</param>
        /// <param name="tenantId">Directory tenant identifier.</param>
        public SubscriptionModel(string displayName = default(string), string id = default(string), string offerId = default(string), string state = default(string), string subscriptionId = default(string), string tenantId = default(string))
        {
            DisplayName = displayName;
            Id = id;
            OfferId = offerId;
            State = state;
            SubscriptionId = subscriptionId;
            TenantId = tenantId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets subscription name.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets fully qualified identifier.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets identifier of the offer under the scope of a delegated
        /// provider.
        /// </summary>
        [JsonProperty(PropertyName = "offerId")]
        public string OfferId { get; set; }

        /// <summary>
        /// Gets or sets subscription state. Possible values include:
        /// 'NotDefined', 'Enabled', 'Warned', 'PastDue', 'Disabled', 'Deleted'
        /// </summary>
        [JsonProperty(PropertyName = "state")]
        public string State { get; set; }

        /// <summary>
        /// Gets or sets subscription identifier.
        /// </summary>
        [JsonProperty(PropertyName = "subscriptionId")]
        public string SubscriptionId { get; set; }

        /// <summary>
        /// Gets or sets directory tenant identifier.
        /// </summary>
        [JsonProperty(PropertyName = "tenantId")]
        public string TenantId { get; set; }

    }
}
