// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Subscriptions.Admin.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The resource metric set that represents the metrics for a particular
    /// resource.
    /// </summary>
    public partial class Metric
    {
        /// <summary>
        /// Initializes a new instance of the Metric class.
        /// </summary>
        public Metric()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Metric class.
        /// </summary>
        /// <param name="metricUnit">Unit of metrics. Possible values include:
        /// 'Count', 'Bytes', 'Seconds', 'CountPerSecond',
        /// 'BytesPerSecond'</param>
        /// <param name="timeGrain">Timespan of the metric.</param>
        /// <param name="startTime">Start time of the metric.</param>
        /// <param name="endTime">End time of the metric.</param>
        /// <param name="metricValues">Collected metric values in the
        /// timespan.</param>
        public Metric(string metricUnit = default(string), string timeGrain = default(string), System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), IList<MetricValue> metricValues = default(IList<MetricValue>))
        {
            MetricUnit = metricUnit;
            TimeGrain = timeGrain;
            StartTime = startTime;
            EndTime = endTime;
            MetricValues = metricValues;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets unit of metrics. Possible values include: 'Count',
        /// 'Bytes', 'Seconds', 'CountPerSecond', 'BytesPerSecond'
        /// </summary>
        [JsonProperty(PropertyName = "metricUnit")]
        public string MetricUnit { get; set; }

        /// <summary>
        /// Gets or sets timespan of the metric.
        /// </summary>
        [JsonProperty(PropertyName = "timeGrain")]
        public string TimeGrain { get; set; }

        /// <summary>
        /// Gets or sets start time of the metric.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; set; }

        /// <summary>
        /// Gets or sets end time of the metric.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; set; }

        /// <summary>
        /// Gets or sets collected metric values in the timespan.
        /// </summary>
        [JsonProperty(PropertyName = "metricValues")]
        public IList<MetricValue> MetricValues { get; set; }

    }
}
