// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Subscriptions.Admin.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Metric Definition
    /// </summary>
    public partial class MetricDefinition
    {
        /// <summary>
        /// Initializes a new instance of the MetricDefinition class.
        /// </summary>
        public MetricDefinition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MetricDefinition class.
        /// </summary>
        /// <param name="name">Metric definition name.</param>
        /// <param name="unit">Unit of metrics. Possible values include:
        /// 'Count', 'Bytes', 'Seconds', 'CountPerSecond',
        /// 'BytesPerSecond'</param>
        /// <param name="primaryAggregationType">Type of the primary
        /// aggregation. Possible values include: 'None', 'Average', 'Total',
        /// 'Minimum', 'Maximum', 'Last'</param>
        /// <param name="metricAvailabilities">Metric availabilities.</param>
        public MetricDefinition(string name = default(string), string unit = default(string), string primaryAggregationType = default(string), IList<MetricAvailability> metricAvailabilities = default(IList<MetricAvailability>))
        {
            Name = name;
            Unit = unit;
            PrimaryAggregationType = primaryAggregationType;
            MetricAvailabilities = metricAvailabilities;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets metric definition name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets unit of metrics. Possible values include: 'Count',
        /// 'Bytes', 'Seconds', 'CountPerSecond', 'BytesPerSecond'
        /// </summary>
        [JsonProperty(PropertyName = "unit")]
        public string Unit { get; set; }

        /// <summary>
        /// Gets or sets type of the primary aggregation. Possible values
        /// include: 'None', 'Average', 'Total', 'Minimum', 'Maximum', 'Last'
        /// </summary>
        [JsonProperty(PropertyName = "primaryAggregationType")]
        public string PrimaryAggregationType { get; set; }

        /// <summary>
        /// Gets or sets metric availabilities.
        /// </summary>
        [JsonProperty(PropertyName = "metricAvailabilities")]
        public IList<MetricAvailability> MetricAvailabilities { get; set; }

    }
}
