// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Subscriptions.Admin.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The move subscriptions action definition
    /// </summary>
    public partial class MoveSubscriptionsDefinition
    {
        /// <summary>
        /// Initializes a new instance of the MoveSubscriptionsDefinition
        /// class.
        /// </summary>
        public MoveSubscriptionsDefinition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MoveSubscriptionsDefinition
        /// class.
        /// </summary>
        /// <param name="resources">A collection of subscriptions to move to
        /// the target delegated provider offer.</param>
        /// <param name="targetDelegatedProviderOffer">The delegated provider
        /// offer identifier (from the Admin context) that the subscriptions to
        /// be moved to.</param>
        public MoveSubscriptionsDefinition(IList<string> resources, string targetDelegatedProviderOffer = default(string))
        {
            TargetDelegatedProviderOffer = targetDelegatedProviderOffer;
            Resources = resources;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the delegated provider offer identifier (from the
        /// Admin context) that the subscriptions to be moved to.
        /// </summary>
        [JsonProperty(PropertyName = "targetDelegatedProviderOffer")]
        public string TargetDelegatedProviderOffer { get; set; }

        /// <summary>
        /// Gets or sets a collection of subscriptions to move to the target
        /// delegated provider offer.
        /// </summary>
        [JsonProperty(PropertyName = "resources")]
        public IList<string> Resources { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Resources == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Resources");
            }
        }
    }
}
