// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Subscriptions.Admin.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Definition for linking and unlinking plans to offers.
    /// </summary>
    public partial class PlanLinkDefinition
    {
        /// <summary>
        /// Initializes a new instance of the PlanLinkDefinition class.
        /// </summary>
        public PlanLinkDefinition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PlanLinkDefinition class.
        /// </summary>
        /// <param name="planName">Name of the plan.</param>
        /// <param name="planLinkType">Type of the plan link. Possible values
        /// include: 'None', 'Base', 'Addon'</param>
        /// <param name="maxAcquisitionCount">The maximum acquisition count by
        /// subscribers</param>
        public PlanLinkDefinition(string planName = default(string), string planLinkType = default(string), int? maxAcquisitionCount = default(int?))
        {
            PlanName = planName;
            PlanLinkType = planLinkType;
            MaxAcquisitionCount = maxAcquisitionCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the plan.
        /// </summary>
        [JsonProperty(PropertyName = "planName")]
        public string PlanName { get; set; }

        /// <summary>
        /// Gets or sets type of the plan link. Possible values include:
        /// 'None', 'Base', 'Addon'
        /// </summary>
        [JsonProperty(PropertyName = "planLinkType")]
        public string PlanLinkType { get; set; }

        /// <summary>
        /// Gets or sets the maximum acquisition count by subscribers
        /// </summary>
        [JsonProperty(PropertyName = "maxAcquisitionCount")]
        public int? MaxAcquisitionCount { get; set; }

    }
}
