// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Update.Admin.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Information related to a location's update status.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class UpdateLocation : Resource
    {
        /// <summary>
        /// Initializes a new instance of the UpdateLocation class.
        /// </summary>
        public UpdateLocation()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the UpdateLocation class.
        /// </summary>
        /// <param name="id">URI of the resource.</param>
        /// <param name="name">Name of the resource.</param>
        /// <param name="type">Type of resource.</param>
        /// <param name="location">Region location of resource.</param>
        /// <param name="tags">List of key-value pairs.</param>
        /// <param name="currentVersion">Current version of your AzureStack
        /// deployment.</param>
        /// <param name="currentOemVersion">Current OEM version of your
        /// AzureStack deployment.</param>
        /// <param name="lastUpdated">Date of last update.</param>
        /// <param name="state">State with respect to the update. Possible
        /// values include: 'Unknown', 'AppliedSuccessfully',
        /// 'AppliedUpdateAvailableSuccessfully', 'UpdateInProgress',
        /// 'UpdateFailed'</param>
        public UpdateLocation(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string currentVersion = default(string), string currentOemVersion = default(string), System.DateTime? lastUpdated = default(System.DateTime?), string state = default(string))
            : base(id, name, type, location, tags)
        {
            CurrentVersion = currentVersion;
            CurrentOemVersion = currentOemVersion;
            LastUpdated = lastUpdated;
            State = state;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets current version of your AzureStack deployment.
        /// </summary>
        [JsonProperty(PropertyName = "properties.currentVersion")]
        public string CurrentVersion { get; set; }

        /// <summary>
        /// Gets or sets current OEM version of your AzureStack deployment.
        /// </summary>
        [JsonProperty(PropertyName = "properties.currentOemVersion")]
        public string CurrentOemVersion { get; set; }

        /// <summary>
        /// Gets or sets date of last update.
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastUpdated")]
        public System.DateTime? LastUpdated { get; set; }

        /// <summary>
        /// Gets or sets state with respect to the update. Possible values
        /// include: 'Unknown', 'AppliedSuccessfully',
        /// 'AppliedUpdateAvailableSuccessfully', 'UpdateInProgress',
        /// 'UpdateFailed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.state")]
        public string State { get; set; }

    }
}
