// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.AzureStack.Management.Update.Admin
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for UpdateRunsOperations.
    /// </summary>
    public static partial class UpdateRunsOperationsExtensions
    {
            /// <summary>
            /// Get the list of update runs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name.
            /// </param>
            /// <param name='updateLocation'>
            /// The name of the update location.
            /// </param>
            /// <param name='updateName'>
            /// Name of the update.
            /// </param>
            public static IPage<UpdateRun> List(this IUpdateRunsOperations operations, string resourceGroupName, string updateLocation, string updateName)
            {
                return operations.ListAsync(resourceGroupName, updateLocation, updateName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get the list of update runs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name.
            /// </param>
            /// <param name='updateLocation'>
            /// The name of the update location.
            /// </param>
            /// <param name='updateName'>
            /// Name of the update.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<UpdateRun>> ListAsync(this IUpdateRunsOperations operations, string resourceGroupName, string updateLocation, string updateName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroupName, updateLocation, updateName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get the list of update locations
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name.
            /// </param>
            /// <param name='updateLocation'>
            /// The name of the update location.
            /// </param>
            /// <param name='updateName'>
            /// Name of the update.
            /// </param>
            /// <param name='runName'>
            /// Update run identifier.
            /// </param>
            public static UpdateRun Get(this IUpdateRunsOperations operations, string resourceGroupName, string updateLocation, string updateName, string runName)
            {
                return operations.GetAsync(resourceGroupName, updateLocation, updateName, runName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get the list of update locations
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name.
            /// </param>
            /// <param name='updateLocation'>
            /// The name of the update location.
            /// </param>
            /// <param name='updateName'>
            /// Name of the update.
            /// </param>
            /// <param name='runName'>
            /// Update run identifier.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<UpdateRun> GetAsync(this IUpdateRunsOperations operations, string resourceGroupName, string updateLocation, string updateName, string runName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, updateLocation, updateName, runName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Resume a failed update.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name.
            /// </param>
            /// <param name='updateLocation'>
            /// The name of the update location.
            /// </param>
            /// <param name='updateName'>
            /// Name of the update.
            /// </param>
            /// <param name='runName'>
            /// Update run identifier.
            /// </param>
            public static void Rerun(this IUpdateRunsOperations operations, string resourceGroupName, string updateLocation, string updateName, string runName)
            {
                operations.RerunAsync(resourceGroupName, updateLocation, updateName, runName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Resume a failed update.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name.
            /// </param>
            /// <param name='updateLocation'>
            /// The name of the update location.
            /// </param>
            /// <param name='updateName'>
            /// Name of the update.
            /// </param>
            /// <param name='runName'>
            /// Update run identifier.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task RerunAsync(this IUpdateRunsOperations operations, string resourceGroupName, string updateLocation, string updateName, string runName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.RerunWithHttpMessagesAsync(resourceGroupName, updateLocation, updateName, runName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Get the list of update runs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<UpdateRun> ListNext(this IUpdateRunsOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get the list of update runs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<UpdateRun>> ListNextAsync(this IUpdateRunsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
