// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

//
// This file was autogenerated by a tool.
// Do not modify it.
//

namespace Microsoft.Azure.Batch
{
    using Models = Microsoft.Azure.Batch.Protocol.Models;
    using System;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Gets the settings required for remote login to a compute node.
    /// </summary>
    public partial class RemoteLoginSettings : IPropertyMetadata
    {
        #region Constructors

        internal RemoteLoginSettings(Models.ComputeNodeGetRemoteLoginSettingsResult protocolObject)
        {
            this.IPAddress = protocolObject.RemoteLoginIPAddress;
            this.Port = protocolObject.RemoteLoginPort;
        }

        #endregion Constructors

        #region RemoteLoginSettings

        /// <summary>
        /// Gets the IP address used for remote login to the compute node.
        /// </summary>
        public string IPAddress { get; }

        /// <summary>
        /// Gets the port used for remote login to the compute node.
        /// </summary>
        public int Port { get; }

        #endregion // RemoteLoginSettings

        #region IPropertyMetadata

        bool IModifiable.HasBeenModified
        {
            //This class is compile time readonly so it cannot have been modified
            get { return false; }
        }

        bool IReadOnly.IsReadOnly
        {
            get { return true; }
            set
            {
                // This class is compile time readonly already
            }
        }

        #endregion // IPropertyMetadata
    }
}