// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The settings for an authentication token that the Task can use to
    /// perform Batch service operations.
    /// </summary>
    public partial class AuthenticationTokenSettings
    {
        /// <summary>
        /// Initializes a new instance of the AuthenticationTokenSettings
        /// class.
        /// </summary>
        public AuthenticationTokenSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AuthenticationTokenSettings
        /// class.
        /// </summary>
        /// <param name="access">The Batch resources to which the token grants
        /// access.</param>
        public AuthenticationTokenSettings(IList<AccessScope> access = default(IList<AccessScope>))
        {
            Access = access;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Batch resources to which the token grants access.
        /// </summary>
        /// <remarks>
        /// The authentication token grants access to a limited set of Batch
        /// service operations. Currently the only supported value for the
        /// access property is 'job', which grants access to all operations
        /// related to the Job which contains the Task.
        /// </remarks>
        [JsonProperty(PropertyName = "access")]
        public IList<AccessScope> Access { get; set; }

    }
}
