// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Options for evaluating an automatic scaling formula on a Pool.
    /// </summary>
    public partial class PoolEvaluateAutoScaleParameter
    {
        /// <summary>
        /// Initializes a new instance of the PoolEvaluateAutoScaleParameter
        /// class.
        /// </summary>
        public PoolEvaluateAutoScaleParameter()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PoolEvaluateAutoScaleParameter
        /// class.
        /// </summary>
        /// <param name="autoScaleFormula">The formula for the desired number
        /// of Compute Nodes in the Pool.</param>
        public PoolEvaluateAutoScaleParameter(string autoScaleFormula)
        {
            AutoScaleFormula = autoScaleFormula;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the formula for the desired number of Compute Nodes in
        /// the Pool.
        /// </summary>
        /// <remarks>
        /// The formula is validated and its results calculated, but it is not
        /// applied to the Pool. To apply the formula to the Pool, 'Enable
        /// automatic scaling on a Pool'. For more information about specifying
        /// this formula, see Automatically scale Compute Nodes in an Azure
        /// Batch Pool
        /// (https://azure.microsoft.com/en-us/documentation/articles/batch-automatic-scaling).
        /// </remarks>
        [JsonProperty(PropertyName = "autoScaleFormula")]
        public string AutoScaleFormula { get; set; }

    }
}
