// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A range of Task IDs that a Task can depend on. All Tasks with IDs in
    /// the range must complete successfully before the dependent Task can be
    /// scheduled.
    /// </summary>
    /// <remarks>
    /// The start and end of the range are inclusive. For example, if a range
    /// has start 9 and end 12, then it represents Tasks '9', '10', '11' and
    /// '12'.
    /// </remarks>
    public partial class TaskIdRange
    {
        /// <summary>
        /// Initializes a new instance of the TaskIdRange class.
        /// </summary>
        public TaskIdRange()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TaskIdRange class.
        /// </summary>
        /// <param name="start">The first Task ID in the range.</param>
        /// <param name="end">The last Task ID in the range.</param>
        public TaskIdRange(int start, int end)
        {
            Start = start;
            End = end;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the first Task ID in the range.
        /// </summary>
        [JsonProperty(PropertyName = "start")]
        public int Start { get; set; }

        /// <summary>
        /// Gets or sets the last Task ID in the range.
        /// </summary>
        [JsonProperty(PropertyName = "end")]
        public int End { get; set; }

    }
}
