// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Billing.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The request parameters for creating a new billing profile.
    /// </summary>
    public partial class BillingProfileCreationRequest
    {
        /// <summary>
        /// Initializes a new instance of the BillingProfileCreationRequest
        /// class.
        /// </summary>
        public BillingProfileCreationRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BillingProfileCreationRequest
        /// class.
        /// </summary>
        /// <param name="displayName">The billing profile name.</param>
        /// <param name="poNumber">Purchase order number.</param>
        /// <param name="address">Billing address.</param>
        /// <param name="invoiceEmailOptIn">If the billing profile is opted in
        /// to receive invoices via email.</param>
        /// <param name="enabledAzurePlans">Enabled azure plans for this
        /// billing profile.</param>
        public BillingProfileCreationRequest(string displayName = default(string), string poNumber = default(string), AddressDetails address = default(AddressDetails), bool? invoiceEmailOptIn = default(bool?), IList<AzurePlan> enabledAzurePlans = default(IList<AzurePlan>))
        {
            DisplayName = displayName;
            PoNumber = poNumber;
            Address = address;
            InvoiceEmailOptIn = invoiceEmailOptIn;
            EnabledAzurePlans = enabledAzurePlans;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the billing profile name.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets purchase order number.
        /// </summary>
        [JsonProperty(PropertyName = "poNumber")]
        public string PoNumber { get; set; }

        /// <summary>
        /// Gets or sets billing address.
        /// </summary>
        [JsonProperty(PropertyName = "address")]
        public AddressDetails Address { get; set; }

        /// <summary>
        /// Gets or sets if the billing profile is opted in to receive invoices
        /// via email.
        /// </summary>
        [JsonProperty(PropertyName = "invoiceEmailOptIn")]
        public bool? InvoiceEmailOptIn { get; set; }

        /// <summary>
        /// Gets or sets enabled azure plans for this billing profile.
        /// </summary>
        [JsonProperty(PropertyName = "enabledAzurePlans")]
        public IList<AzurePlan> EnabledAzurePlans { get; set; }

    }
}
