// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Billing.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// a role assignment
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class BillingRoleAssignment : Resource
    {
        /// <summary>
        /// Initializes a new instance of the BillingRoleAssignment class.
        /// </summary>
        public BillingRoleAssignment()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BillingRoleAssignment class.
        /// </summary>
        /// <param name="id">Resource Id.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="createdOn">the date the role assignment is
        /// created</param>
        /// <param name="createdByPrincipalTenantId">the creator's tenant
        /// Id</param>
        /// <param name="createdByPrincipalId">the creator's principal
        /// Id</param>
        /// <param name="billingRoleAssignmentName">the name of the role
        /// assignment</param>
        /// <param name="principalId">The user's principal id that the role
        /// gets assigned to</param>
        /// <param name="roleDefinitionName">The role definition id</param>
        /// <param name="scope">The scope the role get assigned to</param>
        public BillingRoleAssignment(string id = default(string), string name = default(string), string type = default(string), string createdOn = default(string), string createdByPrincipalTenantId = default(string), string createdByPrincipalId = default(string), string billingRoleAssignmentName = default(string), string principalId = default(string), string roleDefinitionName = default(string), string scope = default(string))
            : base(id, name, type)
        {
            CreatedOn = createdOn;
            CreatedByPrincipalTenantId = createdByPrincipalTenantId;
            CreatedByPrincipalId = createdByPrincipalId;
            BillingRoleAssignmentName = billingRoleAssignmentName;
            PrincipalId = principalId;
            RoleDefinitionName = roleDefinitionName;
            Scope = scope;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the date the role assignment is created
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdOn")]
        public string CreatedOn { get; private set; }

        /// <summary>
        /// Gets the creator's tenant Id
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdByPrincipalTenantId")]
        public string CreatedByPrincipalTenantId { get; private set; }

        /// <summary>
        /// Gets the creator's principal Id
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdByPrincipalId")]
        public string CreatedByPrincipalId { get; private set; }

        /// <summary>
        /// Gets the name of the role assignment
        /// </summary>
        [JsonProperty(PropertyName = "properties.name")]
        public string BillingRoleAssignmentName { get; private set; }

        /// <summary>
        /// Gets the user's principal id that the role gets assigned to
        /// </summary>
        [JsonProperty(PropertyName = "properties.principalId")]
        public string PrincipalId { get; private set; }

        /// <summary>
        /// Gets the role definition id
        /// </summary>
        [JsonProperty(PropertyName = "properties.roleDefinitionName")]
        public string RoleDefinitionName { get; private set; }

        /// <summary>
        /// Gets the scope the role get assigned to
        /// </summary>
        [JsonProperty(PropertyName = "properties.scope")]
        public string Scope { get; private set; }

    }
}
