// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Billing.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A payment method resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class PaymentMethod : Resource
    {
        /// <summary>
        /// Initializes a new instance of the PaymentMethod class.
        /// </summary>
        public PaymentMethod()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PaymentMethod class.
        /// </summary>
        /// <param name="id">Resource Id.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="paymentMethodType">Payment method type. Possible
        /// values include: 'Credits', 'ChequeWire'</param>
        /// <param name="details">Details about the payment method.</param>
        /// <param name="expiration">Expiration month and year.</param>
        /// <param name="currency">The currency associated with the payment
        /// method.</param>
        public PaymentMethod(string id = default(string), string name = default(string), string type = default(string), string paymentMethodType = default(string), string details = default(string), string expiration = default(string), string currency = default(string))
            : base(id, name, type)
        {
            PaymentMethodType = paymentMethodType;
            Details = details;
            Expiration = expiration;
            Currency = currency;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets payment method type. Possible values include:
        /// 'Credits', 'ChequeWire'
        /// </summary>
        [JsonProperty(PropertyName = "properties.paymentMethodType")]
        public string PaymentMethodType { get; set; }

        /// <summary>
        /// Gets details about the payment method.
        /// </summary>
        [JsonProperty(PropertyName = "properties.details")]
        public string Details { get; private set; }

        /// <summary>
        /// Gets expiration month and year.
        /// </summary>
        [JsonProperty(PropertyName = "properties.expiration")]
        public string Expiration { get; private set; }

        /// <summary>
        /// Gets the currency associated with the payment method.
        /// </summary>
        [JsonProperty(PropertyName = "properties.currency")]
        public string Currency { get; private set; }

    }
}
