// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Blueprint.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents underlying deployment detail for each update to the
    /// blueprint assignment.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class AssignmentOperation : AzureResourceBase
    {
        /// <summary>
        /// Initializes a new instance of the AssignmentOperation class.
        /// </summary>
        public AssignmentOperation()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AssignmentOperation class.
        /// </summary>
        /// <param name="id">String Id used to locate any resource on
        /// Azure.</param>
        /// <param name="type">Type of this resource.</param>
        /// <param name="name">Name of this resource.</param>
        /// <param name="blueprintVersion">The published version of the
        /// blueprint definition used for the blueprint assignment
        /// operation.</param>
        /// <param name="assignmentState">State of this blueprint assignment
        /// operation.</param>
        /// <param name="timeCreated">Create time of this blueprint assignment
        /// operation.</param>
        /// <param name="timeStarted">Start time of the underlying
        /// deployment.</param>
        /// <param name="timeFinished">Finish time of the overall underlying
        /// deployments.</param>
        /// <param name="deployments">List of jobs in this blueprint assignment
        /// operation.</param>
        public AssignmentOperation(string id = default(string), string type = default(string), string name = default(string), string blueprintVersion = default(string), string assignmentState = default(string), string timeCreated = default(string), string timeStarted = default(string), string timeFinished = default(string), IList<AssignmentDeploymentJob> deployments = default(IList<AssignmentDeploymentJob>))
            : base(id, type, name)
        {
            BlueprintVersion = blueprintVersion;
            AssignmentState = assignmentState;
            TimeCreated = timeCreated;
            TimeStarted = timeStarted;
            TimeFinished = timeFinished;
            Deployments = deployments;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the published version of the blueprint definition used
        /// for the blueprint assignment operation.
        /// </summary>
        [JsonProperty(PropertyName = "properties.blueprintVersion")]
        public string BlueprintVersion { get; set; }

        /// <summary>
        /// Gets or sets state of this blueprint assignment operation.
        /// </summary>
        [JsonProperty(PropertyName = "properties.assignmentState")]
        public string AssignmentState { get; set; }

        /// <summary>
        /// Gets or sets create time of this blueprint assignment operation.
        /// </summary>
        [JsonProperty(PropertyName = "properties.timeCreated")]
        public string TimeCreated { get; set; }

        /// <summary>
        /// Gets or sets start time of the underlying deployment.
        /// </summary>
        [JsonProperty(PropertyName = "properties.timeStarted")]
        public string TimeStarted { get; set; }

        /// <summary>
        /// Gets or sets finish time of the overall underlying deployments.
        /// </summary>
        [JsonProperty(PropertyName = "properties.timeFinished")]
        public string TimeFinished { get; set; }

        /// <summary>
        /// Gets or sets list of jobs in this blueprint assignment operation.
        /// </summary>
        [JsonProperty(PropertyName = "properties.deployments")]
        public IList<AssignmentDeploymentJob> Deployments { get; set; }

    }
}
