// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Blueprint.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents an Azure resource group.
    /// </summary>
    public partial class ResourceGroupValue
    {
        /// <summary>
        /// Initializes a new instance of the ResourceGroupValue class.
        /// </summary>
        public ResourceGroupValue()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceGroupValue class.
        /// </summary>
        /// <param name="name">Name of the resource group.</param>
        /// <param name="location">Location of the resource group.</param>
        public ResourceGroupValue(string name = default(string), string location = default(string))
        {
            Name = name;
            Location = location;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the resource group.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets location of the resource group.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name != null)
            {
                if (Name.Length > 90)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "Name", 90);
                }
                if (Name.Length < 1)
                {
                    throw new ValidationException(ValidationRules.MinLength, "Name", 1);
                }
            }
        }
    }
}
