// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.BotService
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ChannelsOperations.
    /// </summary>
    public static partial class ChannelsOperationsExtensions
    {
            /// <summary>
            /// Creates a Channel registration for a Bot Service
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='channelName'>
            /// The name of the Channel resource. Possible values include:
            /// 'FacebookChannel', 'EmailChannel', 'KikChannel', 'TelegramChannel',
            /// 'SlackChannel', 'MsTeamsChannel', 'SkypeChannel', 'WebChatChannel',
            /// 'DirectLineChannel', 'SmsChannel'
            /// </param>
            /// <param name='parameters'>
            /// The parameters to provide for the created bot.
            /// </param>
            public static BotChannel Create(this IChannelsOperations operations, string resourceGroupName, string resourceName, ChannelName channelName, BotChannel parameters)
            {
                return operations.CreateAsync(resourceGroupName, resourceName, channelName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates a Channel registration for a Bot Service
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='channelName'>
            /// The name of the Channel resource. Possible values include:
            /// 'FacebookChannel', 'EmailChannel', 'KikChannel', 'TelegramChannel',
            /// 'SlackChannel', 'MsTeamsChannel', 'SkypeChannel', 'WebChatChannel',
            /// 'DirectLineChannel', 'SmsChannel'
            /// </param>
            /// <param name='parameters'>
            /// The parameters to provide for the created bot.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<BotChannel> CreateAsync(this IChannelsOperations operations, string resourceGroupName, string resourceName, ChannelName channelName, BotChannel parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateWithHttpMessagesAsync(resourceGroupName, resourceName, channelName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Updates a Channel registration for a Bot Service
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='channelName'>
            /// The name of the Channel resource. Possible values include:
            /// 'FacebookChannel', 'EmailChannel', 'KikChannel', 'TelegramChannel',
            /// 'SlackChannel', 'MsTeamsChannel', 'SkypeChannel', 'WebChatChannel',
            /// 'DirectLineChannel', 'SmsChannel'
            /// </param>
            /// <param name='location'>
            /// Specifies the location of the resource.
            /// </param>
            /// <param name='tags'>
            /// Contains resource tags defined as key/value pairs.
            /// </param>
            /// <param name='sku'>
            /// Gets or sets the SKU of the resource.
            /// </param>
            /// <param name='kind'>
            /// Required. Gets or sets the Kind of the resource. Possible values include:
            /// 'sdk', 'designer', 'bot', 'function'
            /// </param>
            /// <param name='etag'>
            /// Entity Tag
            /// </param>
            /// <param name='properties'>
            /// The set of properties specific to bot channel resource
            /// </param>
            public static BotChannel Update(this IChannelsOperations operations, string resourceGroupName, string resourceName, ChannelName channelName, string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), Sku sku = default(Sku), string kind = default(string), string etag = default(string), Channel properties = default(Channel))
            {
                return operations.UpdateAsync(resourceGroupName, resourceName, channelName, location, tags, sku, kind, etag, properties).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates a Channel registration for a Bot Service
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='channelName'>
            /// The name of the Channel resource. Possible values include:
            /// 'FacebookChannel', 'EmailChannel', 'KikChannel', 'TelegramChannel',
            /// 'SlackChannel', 'MsTeamsChannel', 'SkypeChannel', 'WebChatChannel',
            /// 'DirectLineChannel', 'SmsChannel'
            /// </param>
            /// <param name='location'>
            /// Specifies the location of the resource.
            /// </param>
            /// <param name='tags'>
            /// Contains resource tags defined as key/value pairs.
            /// </param>
            /// <param name='sku'>
            /// Gets or sets the SKU of the resource.
            /// </param>
            /// <param name='kind'>
            /// Required. Gets or sets the Kind of the resource. Possible values include:
            /// 'sdk', 'designer', 'bot', 'function'
            /// </param>
            /// <param name='etag'>
            /// Entity Tag
            /// </param>
            /// <param name='properties'>
            /// The set of properties specific to bot channel resource
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<BotChannel> UpdateAsync(this IChannelsOperations operations, string resourceGroupName, string resourceName, ChannelName channelName, string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), Sku sku = default(Sku), string kind = default(string), string etag = default(string), Channel properties = default(Channel), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(resourceGroupName, resourceName, channelName, location, tags, sku, kind, etag, properties, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes a Channel registration from a Bot Service
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='channelName'>
            /// The name of the Bot resource.
            /// </param>
            public static void Delete(this IChannelsOperations operations, string resourceGroupName, string resourceName, string channelName)
            {
                operations.DeleteAsync(resourceGroupName, resourceName, channelName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes a Channel registration from a Bot Service
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='channelName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IChannelsOperations operations, string resourceGroupName, string resourceName, string channelName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, resourceName, channelName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Returns a BotService Channel registration specified by the parameters.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='channelName'>
            /// The name of the Bot resource.
            /// </param>
            public static BotChannel Get(this IChannelsOperations operations, string resourceGroupName, string resourceName, string channelName)
            {
                return operations.GetAsync(resourceGroupName, resourceName, channelName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns a BotService Channel registration specified by the parameters.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='channelName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<BotChannel> GetAsync(this IChannelsOperations operations, string resourceGroupName, string resourceName, string channelName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, resourceName, channelName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists a Channel registration for a Bot Service including secrets
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='channelName'>
            /// The name of the Channel resource. Possible values include:
            /// 'FacebookChannel', 'EmailChannel', 'KikChannel', 'TelegramChannel',
            /// 'SlackChannel', 'MsTeamsChannel', 'SkypeChannel', 'WebChatChannel',
            /// 'DirectLineChannel', 'SmsChannel'
            /// </param>
            public static BotChannel ListWithKeys(this IChannelsOperations operations, string resourceGroupName, string resourceName, ChannelName channelName)
            {
                return operations.ListWithKeysAsync(resourceGroupName, resourceName, channelName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists a Channel registration for a Bot Service including secrets
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='channelName'>
            /// The name of the Channel resource. Possible values include:
            /// 'FacebookChannel', 'EmailChannel', 'KikChannel', 'TelegramChannel',
            /// 'SlackChannel', 'MsTeamsChannel', 'SkypeChannel', 'WebChatChannel',
            /// 'DirectLineChannel', 'SmsChannel'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<BotChannel> ListWithKeysAsync(this IChannelsOperations operations, string resourceGroupName, string resourceName, ChannelName channelName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithKeysWithHttpMessagesAsync(resourceGroupName, resourceName, channelName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns all the Channel registrations of a particular BotService resource
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            public static IPage<BotChannel> ListByResourceGroup(this IChannelsOperations operations, string resourceGroupName, string resourceName)
            {
                return operations.ListByResourceGroupAsync(resourceGroupName, resourceName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns all the Channel registrations of a particular BotService resource
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the user's subscription.
            /// </param>
            /// <param name='resourceName'>
            /// The name of the Bot resource.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<BotChannel>> ListByResourceGroupAsync(this IChannelsOperations operations, string resourceGroupName, string resourceName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByResourceGroupWithHttpMessagesAsync(resourceGroupName, resourceName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns all the Channel registrations of a particular BotService resource
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<BotChannel> ListByResourceGroupNext(this IChannelsOperations operations, string nextPageLink)
            {
                return operations.ListByResourceGroupNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns all the Channel registrations of a particular BotService resource
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<BotChannel>> ListByResourceGroupNextAsync(this IChannelsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByResourceGroupNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
