// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.BotService.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters to provide for the Kik channel.
    /// </summary>
    public partial class KikChannelProperties
    {
        /// <summary>
        /// Initializes a new instance of the KikChannelProperties class.
        /// </summary>
        public KikChannelProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the KikChannelProperties class.
        /// </summary>
        /// <param name="userName">The Kik user name</param>
        /// <param name="apiKey">Kik API key. Value only returned through POST
        /// to the action Channel List API, otherwise empty.</param>
        /// <param name="isEnabled">Whether this channel is enabled for the
        /// bot</param>
        /// <param name="isValidated">Whether this channel is validated for the
        /// bot</param>
        public KikChannelProperties(string userName, string apiKey, bool isEnabled, bool? isValidated = default(bool?))
        {
            UserName = userName;
            ApiKey = apiKey;
            IsValidated = isValidated;
            IsEnabled = isEnabled;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Kik user name
        /// </summary>
        [JsonProperty(PropertyName = "userName")]
        public string UserName { get; set; }

        /// <summary>
        /// Gets or sets kik API key. Value only returned through POST to the
        /// action Channel List API, otherwise empty.
        /// </summary>
        [JsonProperty(PropertyName = "apiKey")]
        public string ApiKey { get; set; }

        /// <summary>
        /// Gets or sets whether this channel is validated for the bot
        /// </summary>
        [JsonProperty(PropertyName = "isValidated")]
        public bool? IsValidated { get; set; }

        /// <summary>
        /// Gets or sets whether this channel is enabled for the bot
        /// </summary>
        [JsonProperty(PropertyName = "isEnabled")]
        public bool IsEnabled { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (UserName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "UserName");
            }
            if (ApiKey == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ApiKey");
            }
        }
    }
}
