// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.BotService.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters to provide for the Microsoft Teams channel.
    /// </summary>
    public partial class SkypeChannelProperties
    {
        /// <summary>
        /// Initializes a new instance of the SkypeChannelProperties class.
        /// </summary>
        public SkypeChannelProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SkypeChannelProperties class.
        /// </summary>
        /// <param name="isEnabled">Whether this channel is enabled for the
        /// bot</param>
        /// <param name="enableMessaging">Enable messaging for Skype
        /// channel</param>
        /// <param name="enableMediaCards">Enable media cards for Skype
        /// channel</param>
        /// <param name="enableVideo">Enable video for Skype channel</param>
        /// <param name="enableCalling">Enable calling for Skype
        /// channel</param>
        /// <param name="enableScreenSharing">Enable screen sharing for Skype
        /// channel</param>
        /// <param name="enableGroups">Enable groups for Skype channel</param>
        /// <param name="groupsMode">Group mode for Skype channel</param>
        /// <param name="callingWebHook">Calling web hook for Skype
        /// channel</param>
        public SkypeChannelProperties(bool isEnabled, bool? enableMessaging = default(bool?), bool? enableMediaCards = default(bool?), bool? enableVideo = default(bool?), bool? enableCalling = default(bool?), bool? enableScreenSharing = default(bool?), bool? enableGroups = default(bool?), string groupsMode = default(string), string callingWebHook = default(string))
        {
            EnableMessaging = enableMessaging;
            EnableMediaCards = enableMediaCards;
            EnableVideo = enableVideo;
            EnableCalling = enableCalling;
            EnableScreenSharing = enableScreenSharing;
            EnableGroups = enableGroups;
            GroupsMode = groupsMode;
            CallingWebHook = callingWebHook;
            IsEnabled = isEnabled;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets enable messaging for Skype channel
        /// </summary>
        [JsonProperty(PropertyName = "enableMessaging")]
        public bool? EnableMessaging { get; set; }

        /// <summary>
        /// Gets or sets enable media cards for Skype channel
        /// </summary>
        [JsonProperty(PropertyName = "enableMediaCards")]
        public bool? EnableMediaCards { get; set; }

        /// <summary>
        /// Gets or sets enable video for Skype channel
        /// </summary>
        [JsonProperty(PropertyName = "enableVideo")]
        public bool? EnableVideo { get; set; }

        /// <summary>
        /// Gets or sets enable calling for Skype channel
        /// </summary>
        [JsonProperty(PropertyName = "enableCalling")]
        public bool? EnableCalling { get; set; }

        /// <summary>
        /// Gets or sets enable screen sharing for Skype channel
        /// </summary>
        [JsonProperty(PropertyName = "enableScreenSharing")]
        public bool? EnableScreenSharing { get; set; }

        /// <summary>
        /// Gets or sets enable groups for Skype channel
        /// </summary>
        [JsonProperty(PropertyName = "enableGroups")]
        public bool? EnableGroups { get; set; }

        /// <summary>
        /// Gets or sets group mode for Skype channel
        /// </summary>
        [JsonProperty(PropertyName = "groupsMode")]
        public string GroupsMode { get; set; }

        /// <summary>
        /// Gets or sets calling web hook for Skype channel
        /// </summary>
        [JsonProperty(PropertyName = "callingWebHook")]
        public string CallingWebHook { get; set; }

        /// <summary>
        /// Gets or sets whether this channel is enabled for the bot
        /// </summary>
        [JsonProperty(PropertyName = "isEnabled")]
        public bool IsEnabled { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
