// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.BotService.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters to provide for the Sms channel.
    /// </summary>
    public partial class SmsChannelProperties
    {
        /// <summary>
        /// Initializes a new instance of the SmsChannelProperties class.
        /// </summary>
        public SmsChannelProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SmsChannelProperties class.
        /// </summary>
        /// <param name="phone">The Sms phone</param>
        /// <param name="accountSID">The Sms account SID. Value only returned
        /// through POST to the action Channel List API, otherwise
        /// empty.</param>
        /// <param name="authToken">The Sms auth token. Value only returned
        /// through POST to the action Channel List API, otherwise
        /// empty.</param>
        /// <param name="isEnabled">Whether this channel is enabled for the
        /// bot</param>
        /// <param name="isValidated">Whether this channel is validated for the
        /// bot</param>
        public SmsChannelProperties(string phone, string accountSID, string authToken, bool isEnabled, bool? isValidated = default(bool?))
        {
            Phone = phone;
            AccountSID = accountSID;
            AuthToken = authToken;
            IsValidated = isValidated;
            IsEnabled = isEnabled;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Sms phone
        /// </summary>
        [JsonProperty(PropertyName = "phone")]
        public string Phone { get; set; }

        /// <summary>
        /// Gets or sets the Sms account SID. Value only returned through POST
        /// to the action Channel List API, otherwise empty.
        /// </summary>
        [JsonProperty(PropertyName = "accountSID")]
        public string AccountSID { get; set; }

        /// <summary>
        /// Gets or sets the Sms auth token. Value only returned through POST
        /// to the action Channel List API, otherwise empty.
        /// </summary>
        [JsonProperty(PropertyName = "authToken")]
        public string AuthToken { get; set; }

        /// <summary>
        /// Gets or sets whether this channel is validated for the bot
        /// </summary>
        [JsonProperty(PropertyName = "isValidated")]
        public bool? IsValidated { get; set; }

        /// <summary>
        /// Gets or sets whether this channel is enabled for the bot
        /// </summary>
        [JsonProperty(PropertyName = "isEnabled")]
        public bool IsEnabled { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Phone == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Phone");
            }
            if (AccountSID == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AccountSID");
            }
            if (AuthToken == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AuthToken");
            }
        }
    }
}
