// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Cdn.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the parameters for the cache-key query string action.
    /// </summary>
    public partial class CacheKeyQueryStringActionParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// CacheKeyQueryStringActionParameters class.
        /// </summary>
        public CacheKeyQueryStringActionParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// CacheKeyQueryStringActionParameters class.
        /// </summary>
        /// <param name="queryStringBehavior">Caching behavior for the
        /// requests. Possible values include: 'Include', 'IncludeAll',
        /// 'Exclude', 'ExcludeAll'</param>
        /// <param name="queryParameters">query parameters to include or
        /// exclude (comma separated).</param>
        public CacheKeyQueryStringActionParameters(string queryStringBehavior, string queryParameters = default(string))
        {
            QueryStringBehavior = queryStringBehavior;
            QueryParameters = queryParameters;
            CustomInit();
        }
        /// <summary>
        /// Static constructor for CacheKeyQueryStringActionParameters class.
        /// </summary>
        static CacheKeyQueryStringActionParameters()
        {
            Odatatype = "#Microsoft.Azure.Cdn.Models.DeliveryRuleCacheKeyQueryStringBehaviorActionParameters";
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets caching behavior for the requests. Possible values
        /// include: 'Include', 'IncludeAll', 'Exclude', 'ExcludeAll'
        /// </summary>
        [JsonProperty(PropertyName = "queryStringBehavior")]
        public string QueryStringBehavior { get; set; }

        /// <summary>
        /// Gets or sets query parameters to include or exclude (comma
        /// separated).
        /// </summary>
        [JsonProperty(PropertyName = "queryParameters")]
        public string QueryParameters { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "@odata.type")]
        public static string Odatatype { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (QueryStringBehavior == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "QueryStringBehavior");
            }
        }
    }
}
