// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Cdn.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the parameters for the request header action.
    /// </summary>
    public partial class HeaderActionParameters
    {
        /// <summary>
        /// Initializes a new instance of the HeaderActionParameters class.
        /// </summary>
        public HeaderActionParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the HeaderActionParameters class.
        /// </summary>
        /// <param name="headerAction">Action to perform. Possible values
        /// include: 'Append', 'Overwrite', 'Delete'</param>
        /// <param name="headerName">Name of the header to modify</param>
        /// <param name="value">Value for the specified action</param>
        public HeaderActionParameters(string headerAction, string headerName, string value = default(string))
        {
            HeaderAction = headerAction;
            HeaderName = headerName;
            Value = value;
            CustomInit();
        }
        /// <summary>
        /// Static constructor for HeaderActionParameters class.
        /// </summary>
        static HeaderActionParameters()
        {
            Odatatype = "#Microsoft.Azure.Cdn.Models.DeliveryRuleHeaderActionParameters";
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets action to perform. Possible values include: 'Append',
        /// 'Overwrite', 'Delete'
        /// </summary>
        [JsonProperty(PropertyName = "headerAction")]
        public string HeaderAction { get; set; }

        /// <summary>
        /// Gets or sets name of the header to modify
        /// </summary>
        [JsonProperty(PropertyName = "headerName")]
        public string HeaderName { get; set; }

        /// <summary>
        /// Gets or sets value for the specified action
        /// </summary>
        [JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "@odata.type")]
        public static string Odatatype { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (HeaderAction == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "HeaderAction");
            }
            if (HeaderName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "HeaderName");
            }
        }
    }
}
