// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.FormRecognizer.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Response of the Train API call.
    /// </summary>
    public partial class TrainResult
    {
        /// <summary>
        /// Initializes a new instance of the TrainResult class.
        /// </summary>
        public TrainResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TrainResult class.
        /// </summary>
        /// <param name="modelId">Identifier of the model.</param>
        /// <param name="trainingDocuments">List of documents used to train the
        /// model and the
        /// train operation error reported by each.</param>
        /// <param name="errors">Errors returned during the training
        /// operation.</param>
        public TrainResult(System.Guid modelId = default(System.Guid), IList<FormDocumentReport> trainingDocuments = default(IList<FormDocumentReport>), IList<FormOperationError> errors = default(IList<FormOperationError>))
        {
            ModelId = modelId;
            TrainingDocuments = trainingDocuments;
            Errors = errors;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets identifier of the model.
        /// </summary>
        [JsonProperty(PropertyName = "modelId")]
        public System.Guid ModelId { get; set; }

        /// <summary>
        /// Gets or sets list of documents used to train the model and the
        /// train operation error reported by each.
        /// </summary>
        [JsonProperty(PropertyName = "trainingDocuments")]
        public IList<FormDocumentReport> TrainingDocuments { get; set; }

        /// <summary>
        /// Gets or sets errors returned during the training operation.
        /// </summary>
        [JsonProperty(PropertyName = "errors")]
        public IList<FormOperationError> Errors { get; set; }

    }
}
