// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Knowledge.QnAMaker.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// An object containing more specific information about the error. As per
    /// Microsoft One API guidelines -
    /// https://github.com/Microsoft/api-guidelines/blob/vNext/Guidelines.md#7102-error-condition-responses.
    /// </summary>
    public partial class InnerErrorModel
    {
        /// <summary>
        /// Initializes a new instance of the InnerErrorModel class.
        /// </summary>
        public InnerErrorModel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the InnerErrorModel class.
        /// </summary>
        /// <param name="code">A more specific error code than was provided by
        /// the containing error.</param>
        /// <param name="innerError">An object containing more specific
        /// information than the current object about the error.</param>
        public InnerErrorModel(string code = default(string), InnerErrorModel innerError = default(InnerErrorModel))
        {
            Code = code;
            InnerError = innerError;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a more specific error code than was provided by the
        /// containing error.
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; set; }

        /// <summary>
        /// Gets or sets an object containing more specific information than
        /// the current object about the error.
        /// </summary>
        [JsonProperty(PropertyName = "innerError")]
        public InnerErrorModel InnerError { get; set; }

    }
}
