// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Language.LUIS.Authoring.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Response containing the Application Info.
    /// </summary>
    public partial class ApplicationInfoResponse
    {
        /// <summary>
        /// Initializes a new instance of the ApplicationInfoResponse class.
        /// </summary>
        public ApplicationInfoResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ApplicationInfoResponse class.
        /// </summary>
        /// <param name="id">The ID (GUID) of the application.</param>
        /// <param name="name">The name of the application.</param>
        /// <param name="description">The description of the
        /// application.</param>
        /// <param name="culture">The culture of the application. For example,
        /// "en-us".</param>
        /// <param name="usageScenario">Defines the scenario for the new
        /// application. Optional. For example, IoT.</param>
        /// <param name="domain">The domain for the new application. Optional.
        /// For example, Comics.</param>
        /// <param name="versionsCount">Amount of model versions within the
        /// application.</param>
        /// <param name="createdDateTime">The version's creation
        /// timestamp.</param>
        /// <param name="endpoints">The Runtime endpoint URL for this model
        /// version.</param>
        /// <param name="endpointHitsCount">Number of calls made to this
        /// endpoint.</param>
        /// <param name="activeVersion">The version ID currently marked as
        /// active.</param>
        public ApplicationInfoResponse(System.Guid? id = default(System.Guid?), string name = default(string), string description = default(string), string culture = default(string), string usageScenario = default(string), string domain = default(string), int? versionsCount = default(int?), string createdDateTime = default(string), object endpoints = default(object), int? endpointHitsCount = default(int?), string activeVersion = default(string))
        {
            Id = id;
            Name = name;
            Description = description;
            Culture = culture;
            UsageScenario = usageScenario;
            Domain = domain;
            VersionsCount = versionsCount;
            CreatedDateTime = createdDateTime;
            Endpoints = endpoints;
            EndpointHitsCount = endpointHitsCount;
            ActiveVersion = activeVersion;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the ID (GUID) of the application.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public System.Guid? Id { get; set; }

        /// <summary>
        /// Gets or sets the name of the application.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the description of the application.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets the culture of the application. For example, "en-us".
        /// </summary>
        [JsonProperty(PropertyName = "culture")]
        public string Culture { get; set; }

        /// <summary>
        /// Gets or sets defines the scenario for the new application.
        /// Optional. For example, IoT.
        /// </summary>
        [JsonProperty(PropertyName = "usageScenario")]
        public string UsageScenario { get; set; }

        /// <summary>
        /// Gets or sets the domain for the new application. Optional. For
        /// example, Comics.
        /// </summary>
        [JsonProperty(PropertyName = "domain")]
        public string Domain { get; set; }

        /// <summary>
        /// Gets or sets amount of model versions within the application.
        /// </summary>
        [JsonProperty(PropertyName = "versionsCount")]
        public int? VersionsCount { get; set; }

        /// <summary>
        /// Gets or sets the version's creation timestamp.
        /// </summary>
        [JsonProperty(PropertyName = "createdDateTime")]
        public string CreatedDateTime { get; set; }

        /// <summary>
        /// Gets or sets the Runtime endpoint URL for this model version.
        /// </summary>
        [JsonProperty(PropertyName = "endpoints")]
        public object Endpoints { get; set; }

        /// <summary>
        /// Gets or sets number of calls made to this endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "endpointHitsCount")]
        public int? EndpointHitsCount { get; set; }

        /// <summary>
        /// Gets or sets the version ID currently marked as active.
        /// </summary>
        [JsonProperty(PropertyName = "activeVersion")]
        public string ActiveVersion { get; set; }

    }
}
