// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Language.LUIS.Authoring.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Model Training Details.
    /// </summary>
    public partial class ModelTrainingDetails
    {
        /// <summary>
        /// Initializes a new instance of the ModelTrainingDetails class.
        /// </summary>
        public ModelTrainingDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ModelTrainingDetails class.
        /// </summary>
        /// <param name="statusId">The train request status ID.</param>
        /// <param name="status">Possible values include: 'Queued',
        /// 'InProgress', 'UpToDate', 'Fail', 'Success'</param>
        /// <param name="exampleCount">The count of examples used to train the
        /// model.</param>
        /// <param name="trainingDateTime">When the model was trained.</param>
        /// <param name="failureReason">Reason for the training
        /// failure.</param>
        public ModelTrainingDetails(int? statusId = default(int?), string status = default(string), int? exampleCount = default(int?), System.DateTime? trainingDateTime = default(System.DateTime?), string failureReason = default(string))
        {
            StatusId = statusId;
            Status = status;
            ExampleCount = exampleCount;
            TrainingDateTime = trainingDateTime;
            FailureReason = failureReason;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the train request status ID.
        /// </summary>
        [JsonProperty(PropertyName = "statusId")]
        public int? StatusId { get; set; }

        /// <summary>
        /// Gets or sets possible values include: 'Queued', 'InProgress',
        /// 'UpToDate', 'Fail', 'Success'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets the count of examples used to train the model.
        /// </summary>
        [JsonProperty(PropertyName = "exampleCount")]
        public int? ExampleCount { get; set; }

        /// <summary>
        /// Gets or sets when the model was trained.
        /// </summary>
        [JsonProperty(PropertyName = "trainingDateTime")]
        public System.DateTime? TrainingDateTime { get; set; }

        /// <summary>
        /// Gets or sets reason for the training failure.
        /// </summary>
        [JsonProperty(PropertyName = "failureReason")]
        public string FailureReason { get; set; }

    }
}
