// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Language.TextAnalytics.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class LanguageBatchResultItem
    {
        /// <summary>
        /// Initializes a new instance of the LanguageBatchResultItem class.
        /// </summary>
        public LanguageBatchResultItem()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the LanguageBatchResultItem class.
        /// </summary>
        /// <param name="id">Unique, non-empty document identifier.</param>
        /// <param name="detectedLanguages">A list of extracted
        /// languages.</param>
        /// <param name="statistics">(Optional) if showStats=true was specified
        /// in the request this field will contain information about the
        /// document payload.</param>
        public LanguageBatchResultItem(string id = default(string), IList<DetectedLanguage> detectedLanguages = default(IList<DetectedLanguage>), DocumentStatistics statistics = default(DocumentStatistics))
        {
            Id = id;
            DetectedLanguages = detectedLanguages;
            Statistics = statistics;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets unique, non-empty document identifier.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets a list of extracted languages.
        /// </summary>
        [JsonProperty(PropertyName = "detectedLanguages")]
        public IList<DetectedLanguage> DetectedLanguages { get; set; }

        /// <summary>
        /// Gets or sets (Optional) if showStats=true was specified in the
        /// request this field will contain information about the document
        /// payload.
        /// </summary>
        [JsonProperty(PropertyName = "statistics")]
        public DocumentStatistics Statistics { get; set; }

    }
}
