// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.CognitiveServices
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for CognitiveServicesManagementClient.
    /// </summary>
    public static partial class CognitiveServicesManagementClientExtensions
    {
            /// <summary>
            /// Check available SKUs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='skus'>
            /// The SKU of the resource.
            /// </param>
            /// <param name='kind'>
            /// The Kind of the resource.
            /// </param>
            /// <param name='type'>
            /// The Type of the resource.
            /// </param>
            public static CheckSkuAvailabilityResultList CheckSkuAvailability(this ICognitiveServicesManagementClient operations, string location, IList<string> skus, string kind, string type)
            {
                return operations.CheckSkuAvailabilityAsync(location, skus, kind, type).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Check available SKUs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// Resource location.
            /// </param>
            /// <param name='skus'>
            /// The SKU of the resource.
            /// </param>
            /// <param name='kind'>
            /// The Kind of the resource.
            /// </param>
            /// <param name='type'>
            /// The Type of the resource.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<CheckSkuAvailabilityResultList> CheckSkuAvailabilityAsync(this ICognitiveServicesManagementClient operations, string location, IList<string> skus, string kind, string type, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CheckSkuAvailabilityWithHttpMessagesAsync(location, skus, kind, type, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Check whether a domain is available.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='subdomainName'>
            /// The subdomain name to use.
            /// </param>
            /// <param name='type'>
            /// The Type of the resource.
            /// </param>
            public static CheckDomainAvailabilityResult CheckDomainAvailability(this ICognitiveServicesManagementClient operations, string subdomainName, string type)
            {
                return operations.CheckDomainAvailabilityAsync(subdomainName, type).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Check whether a domain is available.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='subdomainName'>
            /// The subdomain name to use.
            /// </param>
            /// <param name='type'>
            /// The Type of the resource.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<CheckDomainAvailabilityResult> CheckDomainAvailabilityAsync(this ICognitiveServicesManagementClient operations, string subdomainName, string type, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CheckDomainAvailabilityWithHttpMessagesAsync(subdomainName, type, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
