// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Search.EntitySearch.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines a contractual rule for text attribution.
    /// </summary>
    [Newtonsoft.Json.JsonObject("ContractualRules/TextAttribution")]
    public partial class ContractualRulesTextAttribution : ContractualRulesAttribution
    {
        /// <summary>
        /// Initializes a new instance of the ContractualRulesTextAttribution
        /// class.
        /// </summary>
        public ContractualRulesTextAttribution()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ContractualRulesTextAttribution
        /// class.
        /// </summary>
        /// <param name="text">The attribution text. Text attribution applies
        /// to the entity as a whole and should be displayed immediately
        /// following the entity presentation. If there are multiple text or
        /// link attribution rules that do not specify a target, you should
        /// concatenate them and display them using a "Data from:"
        /// label.</param>
        /// <param name="targetPropertyName">The name of the field that the
        /// rule applies to.</param>
        /// <param name="mustBeCloseToContent">A Boolean value that determines
        /// whether the contents of the rule must be placed in close proximity
        /// to the field that the rule applies to. If true, the contents must
        /// be placed in close proximity. If false, or this field does not
        /// exist, the contents may be placed at the caller's
        /// discretion.</param>
        /// <param name="optionalForListDisplay">Indicates whether this
        /// provider's attribution is optional.</param>
        public ContractualRulesTextAttribution(string text, string targetPropertyName = default(string), bool? mustBeCloseToContent = default(bool?), bool? optionalForListDisplay = default(bool?))
            : base(targetPropertyName, mustBeCloseToContent)
        {
            Text = text;
            OptionalForListDisplay = optionalForListDisplay;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the attribution text. Text attribution applies to the
        /// entity as a whole and should be displayed immediately following the
        /// entity presentation. If there are multiple text or link attribution
        /// rules that do not specify a target, you should concatenate them and
        /// display them using a "Data from:" label.
        /// </summary>
        [JsonProperty(PropertyName = "text")]
        public string Text { get; set; }

        /// <summary>
        /// Gets indicates whether this provider's attribution is optional.
        /// </summary>
        [JsonProperty(PropertyName = "optionalForListDisplay")]
        public bool? OptionalForListDisplay { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Text == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Text");
            }
        }
    }
}
