// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Search.ImageSearch.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines a count of the number of websites where you can shop or perform
    /// other actions related to the image.
    /// </summary>
    public partial class ImagesImageMetadata
    {
        /// <summary>
        /// Initializes a new instance of the ImagesImageMetadata class.
        /// </summary>
        public ImagesImageMetadata()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ImagesImageMetadata class.
        /// </summary>
        /// <param name="shoppingSourcesCount">The number of websites that
        /// offer goods of the products seen in the image.</param>
        /// <param name="recipeSourcesCount">The number of websites that offer
        /// recipes of the food seen in the image.</param>
        /// <param name="aggregateOffer">A summary of the online offers of
        /// products found in the image. For example, if the image is of a
        /// dress, the offer might identify the lowest price and the number of
        /// offers found. Only visually similar products insights include this
        /// field. The offer includes the following fields: Name,
        /// AggregateRating, OfferCount, and LowPrice.</param>
        public ImagesImageMetadata(int? shoppingSourcesCount = default(int?), int? recipeSourcesCount = default(int?), AggregateOffer aggregateOffer = default(AggregateOffer))
        {
            ShoppingSourcesCount = shoppingSourcesCount;
            RecipeSourcesCount = recipeSourcesCount;
            AggregateOffer = aggregateOffer;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the number of websites that offer goods of the products seen
        /// in the image.
        /// </summary>
        [JsonProperty(PropertyName = "shoppingSourcesCount")]
        public int? ShoppingSourcesCount { get; private set; }

        /// <summary>
        /// Gets the number of websites that offer recipes of the food seen in
        /// the image.
        /// </summary>
        [JsonProperty(PropertyName = "recipeSourcesCount")]
        public int? RecipeSourcesCount { get; private set; }

        /// <summary>
        /// Gets a summary of the online offers of products found in the image.
        /// For example, if the image is of a dress, the offer might identify
        /// the lowest price and the number of offers found. Only visually
        /// similar products insights include this field. The offer includes
        /// the following fields: Name, AggregateRating, OfferCount, and
        /// LowPrice.
        /// </summary>
        [JsonProperty(PropertyName = "aggregateOffer")]
        public AggregateOffer AggregateOffer { get; private set; }

    }
}
