// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Search.ImageSearch.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Defines a group of previously recognized entities.
    /// </summary>
    public partial class RecognizedEntityGroup
    {
        /// <summary>
        /// Initializes a new instance of the RecognizedEntityGroup class.
        /// </summary>
        public RecognizedEntityGroup()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RecognizedEntityGroup class.
        /// </summary>
        /// <param name="recognizedEntityRegions">The regions of the image that
        /// contain entities.</param>
        /// <param name="name">The name of the group where images of the entity
        /// were also found. The following are possible groups.
        /// CelebRecognitionAnnotations: Similar to CelebrityAnnotations but
        /// provides a higher probability of an accurate match.
        /// CelebrityAnnotations: Contains celebrities such as actors,
        /// politicians, athletes, and historical figures.</param>
        public RecognizedEntityGroup(IList<RecognizedEntityRegion> recognizedEntityRegions, string name)
        {
            RecognizedEntityRegions = recognizedEntityRegions;
            Name = name;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the regions of the image that contain entities.
        /// </summary>
        [JsonProperty(PropertyName = "recognizedEntityRegions")]
        public IList<RecognizedEntityRegion> RecognizedEntityRegions { get; set; }

        /// <summary>
        /// Gets or sets the name of the group where images of the entity were
        /// also found. The following are possible groups.
        /// CelebRecognitionAnnotations: Similar to CelebrityAnnotations but
        /// provides a higher probability of an accurate match.
        /// CelebrityAnnotations: Contains celebrities such as actors,
        /// politicians, athletes, and historical figures.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (RecognizedEntityRegions == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "RecognizedEntityRegions");
            }
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (RecognizedEntityRegions != null)
            {
                foreach (var element in RecognizedEntityRegions)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
