// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Search.VisualSearch.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A JSON object that identities the image to get insights of . It also
    /// includes the optional crop area that you use to identify the region of
    /// interest in the image.
    /// </summary>
    public partial class ImageInfo
    {
        /// <summary>
        /// Initializes a new instance of the ImageInfo class.
        /// </summary>
        public ImageInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ImageInfo class.
        /// </summary>
        /// <param name="imageInsightsToken">An image insights token. To get
        /// the insights token, call one of the Image Search APIs (for example,
        /// /images/search). In the search results, the
        /// [Image](https://docs.microsoft.com/en-us/rest/api/cognitiveservices/bing-images-api-v7-reference#image)
        /// object's
        /// [imageInsightsToken](https://docs.microsoft.com/en-us/rest/api/cognitiveservices/bing-images-api-v7-reference#image-imageinsightstoken)
        /// field contains the token. The imageInsightsToken and url fields
        /// mutually exclusive; do not specify both. Do not specify an insights
        /// token if the request includes the image form data.</param>
        /// <param name="url">The URL of the input image. The
        /// imageInsightsToken and url fields are mutually exclusive; do not
        /// specify both. Do not specify the URL if the request includes the
        /// image form data.</param>
        /// <param name="cropArea">A JSON object consisting of coordinates
        /// specifying the four corners of a cropped rectangle within the input
        /// image. Use the crop area to identify the region of interest in the
        /// image. You can apply the crop area to the images specified using
        /// the imageInsightsToken or url fields, or an image binary specified
        /// in an image form data.</param>
        public ImageInfo(string imageInsightsToken = default(string), string url = default(string), CropArea cropArea = default(CropArea))
        {
            ImageInsightsToken = imageInsightsToken;
            Url = url;
            CropArea = cropArea;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets an image insights token. To get the insights token,
        /// call one of the Image Search APIs (for example, /images/search). In
        /// the search results, the
        /// [Image](https://docs.microsoft.com/en-us/rest/api/cognitiveservices/bing-images-api-v7-reference#image)
        /// object's
        /// [imageInsightsToken](https://docs.microsoft.com/en-us/rest/api/cognitiveservices/bing-images-api-v7-reference#image-imageinsightstoken)
        /// field contains the token. The imageInsightsToken and url fields
        /// mutually exclusive; do not specify both. Do not specify an insights
        /// token if the request includes the image form data.
        /// </summary>
        [JsonProperty(PropertyName = "imageInsightsToken")]
        public string ImageInsightsToken { get; set; }

        /// <summary>
        /// Gets or sets the URL of the input image. The imageInsightsToken and
        /// url fields are mutually exclusive; do not specify both. Do not
        /// specify the URL if the request includes the image form data.
        /// </summary>
        [JsonProperty(PropertyName = "url")]
        public string Url { get; set; }

        /// <summary>
        /// Gets or sets a JSON object consisting of coordinates specifying the
        /// four corners of a cropped rectangle within the input image. Use the
        /// crop area to identify the region of interest in the image. You can
        /// apply the crop area to the images specified using the
        /// imageInsightsToken or url fields, or an image binary specified in
        /// an image form data.
        /// </summary>
        [JsonProperty(PropertyName = "cropArea")]
        public CropArea CropArea { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (CropArea != null)
            {
                CropArea.Validate();
            }
        }
    }
}
