// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Vision.ComputerVision.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Result of AreaOfInterest operation.
    /// </summary>
    public partial class AreaOfInterestResult
    {
        /// <summary>
        /// Initializes a new instance of the AreaOfInterestResult class.
        /// </summary>
        public AreaOfInterestResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AreaOfInterestResult class.
        /// </summary>
        /// <param name="areaOfInterest">A bounding box for an area of interest
        /// inside an image.</param>
        /// <param name="requestId">Id of the REST API request.</param>
        public AreaOfInterestResult(BoundingRect areaOfInterest = default(BoundingRect), string requestId = default(string), ImageMetadata metadata = default(ImageMetadata))
        {
            AreaOfInterest = areaOfInterest;
            RequestId = requestId;
            Metadata = metadata;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets a bounding box for an area of interest inside an image.
        /// </summary>
        [JsonProperty(PropertyName = "areaOfInterest")]
        public BoundingRect AreaOfInterest { get; private set; }

        /// <summary>
        /// Gets or sets id of the REST API request.
        /// </summary>
        [JsonProperty(PropertyName = "requestId")]
        public string RequestId { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "metadata")]
        public ImageMetadata Metadata { get; set; }

    }
}
