// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Vision.ComputerVision.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A bounding box for an area inside an image.
    /// </summary>
    public partial class BoundingRect
    {
        /// <summary>
        /// Initializes a new instance of the BoundingRect class.
        /// </summary>
        public BoundingRect()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BoundingRect class.
        /// </summary>
        /// <param name="x">X-coordinate of the top left point of the area, in
        /// pixels.</param>
        /// <param name="y">Y-coordinate of the top left point of the area, in
        /// pixels.</param>
        /// <param name="w">Width measured from the top-left point of the area,
        /// in pixels.</param>
        /// <param name="h">Height measured from the top-left point of the
        /// area, in pixels.</param>
        public BoundingRect(int x = default(int), int y = default(int), int w = default(int), int h = default(int))
        {
            X = x;
            Y = y;
            W = w;
            H = h;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets x-coordinate of the top left point of the area, in
        /// pixels.
        /// </summary>
        [JsonProperty(PropertyName = "x")]
        public int X { get; set; }

        /// <summary>
        /// Gets or sets y-coordinate of the top left point of the area, in
        /// pixels.
        /// </summary>
        [JsonProperty(PropertyName = "y")]
        public int Y { get; set; }

        /// <summary>
        /// Gets or sets width measured from the top-left point of the area, in
        /// pixels.
        /// </summary>
        [JsonProperty(PropertyName = "w")]
        public int W { get; set; }

        /// <summary>
        /// Gets or sets height measured from the top-left point of the area,
        /// in pixels.
        /// </summary>
        [JsonProperty(PropertyName = "h")]
        public int H { get; set; }

    }
}
