// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Vision.ComputerVision.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// An object describing possible celebrity identification.
    /// </summary>
    public partial class CelebritiesModel
    {
        /// <summary>
        /// Initializes a new instance of the CelebritiesModel class.
        /// </summary>
        public CelebritiesModel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CelebritiesModel class.
        /// </summary>
        /// <param name="name">Name of the celebrity.</param>
        /// <param name="confidence">Confidence level for the celebrity
        /// recognition as a value ranging from 0 to 1.</param>
        /// <param name="faceRectangle">Location of the identified face in the
        /// image.</param>
        public CelebritiesModel(string name = default(string), double confidence = default(double), FaceRectangle faceRectangle = default(FaceRectangle))
        {
            Name = name;
            Confidence = confidence;
            FaceRectangle = faceRectangle;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the celebrity.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets confidence level for the celebrity recognition as a
        /// value ranging from 0 to 1.
        /// </summary>
        [JsonProperty(PropertyName = "confidence")]
        public double Confidence { get; set; }

        /// <summary>
        /// Gets or sets location of the identified face in the image.
        /// </summary>
        [JsonProperty(PropertyName = "faceRectangle")]
        public FaceRectangle FaceRectangle { get; set; }

    }
}
