// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Vision.ComputerVision.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Result of domain-specific classifications for the domain of
    /// celebrities.
    /// </summary>
    public partial class CelebrityResults
    {
        /// <summary>
        /// Initializes a new instance of the CelebrityResults class.
        /// </summary>
        public CelebrityResults()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CelebrityResults class.
        /// </summary>
        /// <param name="celebrities">List of celebrities recognized in the
        /// image.</param>
        /// <param name="requestId">Id of the REST API request.</param>
        public CelebrityResults(IList<CelebritiesModel> celebrities = default(IList<CelebritiesModel>), string requestId = default(string), ImageMetadata metadata = default(ImageMetadata))
        {
            Celebrities = celebrities;
            RequestId = requestId;
            Metadata = metadata;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets list of celebrities recognized in the image.
        /// </summary>
        [JsonProperty(PropertyName = "celebrities")]
        public IList<CelebritiesModel> Celebrities { get; set; }

        /// <summary>
        /// Gets or sets id of the REST API request.
        /// </summary>
        [JsonProperty(PropertyName = "requestId")]
        public string RequestId { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "metadata")]
        public ImageMetadata Metadata { get; set; }

    }
}
