// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Vision.ComputerVision.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// An object providing possible image types and matching confidence
    /// levels.
    /// </summary>
    public partial class ImageType
    {
        /// <summary>
        /// Initializes a new instance of the ImageType class.
        /// </summary>
        public ImageType()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ImageType class.
        /// </summary>
        /// <param name="clipArtType">Confidence level that the image is a clip
        /// art.</param>
        /// <param name="lineDrawingType">Confidence level that the image is a
        /// line drawing.</param>
        public ImageType(int clipArtType = default(int), int lineDrawingType = default(int))
        {
            ClipArtType = clipArtType;
            LineDrawingType = lineDrawingType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets confidence level that the image is a clip art.
        /// </summary>
        [JsonProperty(PropertyName = "clipArtType")]
        public int ClipArtType { get; set; }

        /// <summary>
        /// Gets or sets confidence level that the image is a line drawing.
        /// </summary>
        [JsonProperty(PropertyName = "lineDrawingType")]
        public int LineDrawingType { get; set; }

    }
}
