// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Vision.ComputerVision.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Information on a recognized word.
    /// </summary>
    public partial class OcrWord
    {
        /// <summary>
        /// Initializes a new instance of the OcrWord class.
        /// </summary>
        public OcrWord()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OcrWord class.
        /// </summary>
        /// <param name="boundingBox">Bounding box of a recognized word. The
        /// four integers represent the x-coordinate of the left edge, the
        /// y-coordinate of the top edge, width, and height of the bounding
        /// box, in the coordinate system of the input image, after it has been
        /// rotated around its center according to the detected text angle (see
        /// textAngle property), with the origin at the top-left corner, and
        /// the y-axis pointing down.</param>
        /// <param name="text">String value of a recognized word.</param>
        public OcrWord(string boundingBox = default(string), string text = default(string))
        {
            BoundingBox = boundingBox;
            Text = text;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets bounding box of a recognized word. The four integers
        /// represent the x-coordinate of the left edge, the y-coordinate of
        /// the top edge, width, and height of the bounding box, in the
        /// coordinate system of the input image, after it has been rotated
        /// around its center according to the detected text angle (see
        /// textAngle property), with the origin at the top-left corner, and
        /// the y-axis pointing down.
        /// </summary>
        [JsonProperty(PropertyName = "boundingBox")]
        public string BoundingBox { get; set; }

        /// <summary>
        /// Gets or sets string value of a recognized word.
        /// </summary>
        [JsonProperty(PropertyName = "text")]
        public string Text { get; set; }

    }
}
