// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Vision.ComputerVision.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Result of recognition text operation.
    /// </summary>
    public partial class TextOperationResult
    {
        /// <summary>
        /// Initializes a new instance of the TextOperationResult class.
        /// </summary>
        public TextOperationResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TextOperationResult class.
        /// </summary>
        /// <param name="status">Status of the text operation. Possible values
        /// include: 'NotStarted', 'Running', 'Failed', 'Succeeded'</param>
        /// <param name="recognitionResult">Text recognition result of the text
        /// operation.</param>
        public TextOperationResult(TextOperationStatusCodes status = default(TextOperationStatusCodes), TextRecognitionResult recognitionResult = default(TextRecognitionResult))
        {
            Status = status;
            RecognitionResult = recognitionResult;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets status of the text operation. Possible values include:
        /// 'NotStarted', 'Running', 'Failed', 'Succeeded'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public TextOperationStatusCodes Status { get; set; }

        /// <summary>
        /// Gets or sets text recognition result of the text operation.
        /// </summary>
        [JsonProperty(PropertyName = "recognitionResult")]
        public TextRecognitionResult RecognitionResult { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (RecognitionResult != null)
            {
                RecognitionResult.Validate();
            }
        }
    }
}
