// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Vision.CustomVision.Prediction.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    public partial class CustomVisionError
    {
        /// <summary>
        /// Initializes a new instance of the CustomVisionError class.
        /// </summary>
        public CustomVisionError()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CustomVisionError class.
        /// </summary>
        /// <param name="code">The error code. Possible values include:
        /// 'NoError', 'BadRequest', 'BadRequestExceededBatchSize',
        /// 'BadRequestNotSupported', 'BadRequestInvalidIds',
        /// 'BadRequestProjectName', 'BadRequestProjectNameNotUnique',
        /// 'BadRequestProjectDescription', 'BadRequestProjectUnknownDomain',
        /// 'BadRequestProjectUnknownClassification',
        /// 'BadRequestProjectUnsupportedDomainTypeChange',
        /// 'BadRequestProjectUnsupportedExportPlatform',
        /// 'BadRequestIterationName', 'BadRequestIterationNameNotUnique',
        /// 'BadRequestIterationDescription',
        /// 'BadRequestIterationIsNotTrained',
        /// 'BadRequestWorkspaceCannotBeModified',
        /// 'BadRequestWorkspaceNotDeletable', 'BadRequestTagName',
        /// 'BadRequestTagNameNotUnique', 'BadRequestTagDescription',
        /// 'BadRequestTagType', 'BadRequestMultipleNegativeTag',
        /// 'BadRequestImageTags', 'BadRequestImageRegions',
        /// 'BadRequestNegativeAndRegularTagOnSameImage',
        /// 'BadRequestRequiredParamIsNull', 'BadRequestIterationIsPublished',
        /// 'BadRequestInvalidPublishName', 'BadRequestInvalidPublishTarget',
        /// 'BadRequestUnpublishFailed', 'BadRequestSubscriptionApi',
        /// 'BadRequestExceedProjectLimit',
        /// 'BadRequestExceedIterationPerProjectLimit',
        /// 'BadRequestExceedTagPerProjectLimit',
        /// 'BadRequestExceedTagPerImageLimit', 'BadRequestExceededQuota',
        /// 'BadRequestCannotMigrateProjectWithName',
        /// 'BadRequestNotLimitedTrial', 'BadRequestImageBatch',
        /// 'BadRequestImageStream', 'BadRequestImageUrl',
        /// 'BadRequestImageFormat', 'BadRequestImageSizeBytes',
        /// 'BadRequestImageExceededCount', 'BadRequestTrainingNotNeeded',
        /// 'BadRequestTrainingNotNeededButTrainingPipelineUpdated',
        /// 'BadRequestTrainingValidationFailed',
        /// 'BadRequestClassificationTrainingValidationFailed',
        /// 'BadRequestMultiClassClassificationTrainingValidationFailed',
        /// 'BadRequestMultiLabelClassificationTrainingValidationFailed',
        /// 'BadRequestDetectionTrainingValidationFailed',
        /// 'BadRequestTrainingAlreadyInProgress',
        /// 'BadRequestDetectionTrainingNotAllowNegativeTag',
        /// 'BadRequestInvalidEmailAddress',
        /// 'BadRequestDomainNotSupportedForAdvancedTraining',
        /// 'BadRequestExportPlatformNotSupportedForAdvancedTraining',
        /// 'BadRequestReservedBudgetInHoursNotEnoughForAdvancedTraining',
        /// 'BadRequestExportValidationFailed',
        /// 'BadRequestExportAlreadyInProgress',
        /// 'BadRequestPredictionIdsMissing',
        /// 'BadRequestPredictionIdsExceededCount',
        /// 'BadRequestPredictionTagsExceededCount',
        /// 'BadRequestPredictionResultsExceededCount',
        /// 'BadRequestPredictionInvalidApplicationName',
        /// 'BadRequestPredictionInvalidQueryParameters', 'BadRequestInvalid',
        /// 'UnsupportedMediaType', 'Forbidden', 'ForbiddenUser',
        /// 'ForbiddenUserResource', 'ForbiddenUserSignupDisabled',
        /// 'ForbiddenUserSignupAllowanceExceeded',
        /// 'ForbiddenUserDoesNotExist', 'ForbiddenUserDisabled',
        /// 'ForbiddenUserInsufficientCapability', 'ForbiddenDRModeEnabled',
        /// 'ForbiddenInvalid', 'NotFound', 'NotFoundProject',
        /// 'NotFoundProjectDefaultIteration', 'NotFoundIteration',
        /// 'NotFoundIterationPerformance', 'NotFoundTag', 'NotFoundImage',
        /// 'NotFoundDomain', 'NotFoundApimSubscription', 'NotFoundInvalid',
        /// 'Conflict', 'ConflictInvalid', 'ErrorUnknown',
        /// 'ErrorProjectInvalidWorkspace',
        /// 'ErrorProjectInvalidPipelineConfiguration',
        /// 'ErrorProjectInvalidDomain', 'ErrorProjectTrainingRequestFailed',
        /// 'ErrorProjectExportRequestFailed',
        /// 'ErrorFeaturizationServiceUnavailable',
        /// 'ErrorFeaturizationQueueTimeout',
        /// 'ErrorFeaturizationInvalidFeaturizer',
        /// 'ErrorFeaturizationAugmentationUnavailable',
        /// 'ErrorFeaturizationUnrecognizedJob',
        /// 'ErrorFeaturizationAugmentationError',
        /// 'ErrorExporterInvalidPlatform', 'ErrorExporterInvalidFeaturizer',
        /// 'ErrorExporterInvalidClassifier',
        /// 'ErrorPredictionServiceUnavailable',
        /// 'ErrorPredictionModelNotFound', 'ErrorPredictionModelNotCached',
        /// 'ErrorPrediction', 'ErrorPredictionStorage', 'ErrorRegionProposal',
        /// 'ErrorInvalid'</param>
        /// <param name="message">A message explaining the error reported by
        /// the service.</param>
        public CustomVisionError(string code, string message)
        {
            Code = code;
            Message = message;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the error code. Possible values include: 'NoError',
        /// 'BadRequest', 'BadRequestExceededBatchSize',
        /// 'BadRequestNotSupported', 'BadRequestInvalidIds',
        /// 'BadRequestProjectName', 'BadRequestProjectNameNotUnique',
        /// 'BadRequestProjectDescription', 'BadRequestProjectUnknownDomain',
        /// 'BadRequestProjectUnknownClassification',
        /// 'BadRequestProjectUnsupportedDomainTypeChange',
        /// 'BadRequestProjectUnsupportedExportPlatform',
        /// 'BadRequestIterationName', 'BadRequestIterationNameNotUnique',
        /// 'BadRequestIterationDescription',
        /// 'BadRequestIterationIsNotTrained',
        /// 'BadRequestWorkspaceCannotBeModified',
        /// 'BadRequestWorkspaceNotDeletable', 'BadRequestTagName',
        /// 'BadRequestTagNameNotUnique', 'BadRequestTagDescription',
        /// 'BadRequestTagType', 'BadRequestMultipleNegativeTag',
        /// 'BadRequestImageTags', 'BadRequestImageRegions',
        /// 'BadRequestNegativeAndRegularTagOnSameImage',
        /// 'BadRequestRequiredParamIsNull', 'BadRequestIterationIsPublished',
        /// 'BadRequestInvalidPublishName', 'BadRequestInvalidPublishTarget',
        /// 'BadRequestUnpublishFailed', 'BadRequestSubscriptionApi',
        /// 'BadRequestExceedProjectLimit',
        /// 'BadRequestExceedIterationPerProjectLimit',
        /// 'BadRequestExceedTagPerProjectLimit',
        /// 'BadRequestExceedTagPerImageLimit', 'BadRequestExceededQuota',
        /// 'BadRequestCannotMigrateProjectWithName',
        /// 'BadRequestNotLimitedTrial', 'BadRequestImageBatch',
        /// 'BadRequestImageStream', 'BadRequestImageUrl',
        /// 'BadRequestImageFormat', 'BadRequestImageSizeBytes',
        /// 'BadRequestImageExceededCount', 'BadRequestTrainingNotNeeded',
        /// 'BadRequestTrainingNotNeededButTrainingPipelineUpdated',
        /// 'BadRequestTrainingValidationFailed',
        /// 'BadRequestClassificationTrainingValidationFailed',
        /// 'BadRequestMultiClassClassificationTrainingValidationFailed',
        /// 'BadRequestMultiLabelClassificationTrainingValidationFailed',
        /// 'BadRequestDetectionTrainingValidationFailed',
        /// 'BadRequestTrainingAlreadyInProgress',
        /// 'BadRequestDetectionTrainingNotAllowNegativeTag',
        /// 'BadRequestInvalidEmailAddress',
        /// 'BadRequestDomainNotSupportedForAdvancedTraining',
        /// 'BadRequestExportPlatformNotSupportedForAdvancedTraining',
        /// 'BadRequestReservedBudgetInHoursNotEnoughForAdvancedTraining',
        /// 'BadRequestExportValidationFailed',
        /// 'BadRequestExportAlreadyInProgress',
        /// 'BadRequestPredictionIdsMissing',
        /// 'BadRequestPredictionIdsExceededCount',
        /// 'BadRequestPredictionTagsExceededCount',
        /// 'BadRequestPredictionResultsExceededCount',
        /// 'BadRequestPredictionInvalidApplicationName',
        /// 'BadRequestPredictionInvalidQueryParameters', 'BadRequestInvalid',
        /// 'UnsupportedMediaType', 'Forbidden', 'ForbiddenUser',
        /// 'ForbiddenUserResource', 'ForbiddenUserSignupDisabled',
        /// 'ForbiddenUserSignupAllowanceExceeded',
        /// 'ForbiddenUserDoesNotExist', 'ForbiddenUserDisabled',
        /// 'ForbiddenUserInsufficientCapability', 'ForbiddenDRModeEnabled',
        /// 'ForbiddenInvalid', 'NotFound', 'NotFoundProject',
        /// 'NotFoundProjectDefaultIteration', 'NotFoundIteration',
        /// 'NotFoundIterationPerformance', 'NotFoundTag', 'NotFoundImage',
        /// 'NotFoundDomain', 'NotFoundApimSubscription', 'NotFoundInvalid',
        /// 'Conflict', 'ConflictInvalid', 'ErrorUnknown',
        /// 'ErrorProjectInvalidWorkspace',
        /// 'ErrorProjectInvalidPipelineConfiguration',
        /// 'ErrorProjectInvalidDomain', 'ErrorProjectTrainingRequestFailed',
        /// 'ErrorProjectExportRequestFailed',
        /// 'ErrorFeaturizationServiceUnavailable',
        /// 'ErrorFeaturizationQueueTimeout',
        /// 'ErrorFeaturizationInvalidFeaturizer',
        /// 'ErrorFeaturizationAugmentationUnavailable',
        /// 'ErrorFeaturizationUnrecognizedJob',
        /// 'ErrorFeaturizationAugmentationError',
        /// 'ErrorExporterInvalidPlatform', 'ErrorExporterInvalidFeaturizer',
        /// 'ErrorExporterInvalidClassifier',
        /// 'ErrorPredictionServiceUnavailable',
        /// 'ErrorPredictionModelNotFound', 'ErrorPredictionModelNotCached',
        /// 'ErrorPrediction', 'ErrorPredictionStorage', 'ErrorRegionProposal',
        /// 'ErrorInvalid'
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; set; }

        /// <summary>
        /// Gets or sets a message explaining the error reported by the
        /// service.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Code == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Code");
            }
            if (Message == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Message");
            }
        }
    }
}
