// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.CognitiveServices.Vision.CustomVision.Training.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    public partial class ImageCreateResult
    {
        /// <summary>
        /// Initializes a new instance of the ImageCreateResult class.
        /// </summary>
        public ImageCreateResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ImageCreateResult class.
        /// </summary>
        /// <param name="sourceUrl">Source URL of the image.</param>
        /// <param name="status">Status of the image creation. Possible values
        /// include: 'OK', 'OKDuplicate', 'ErrorSource', 'ErrorImageFormat',
        /// 'ErrorImageSize', 'ErrorStorage', 'ErrorLimitExceed',
        /// 'ErrorTagLimitExceed', 'ErrorRegionLimitExceed', 'ErrorUnknown',
        /// 'ErrorNegativeAndRegularTagOnSameImage'</param>
        /// <param name="image">The image.</param>
        public ImageCreateResult(string sourceUrl = default(string), string status = default(string), Image image = default(Image))
        {
            SourceUrl = sourceUrl;
            Status = status;
            Image = image;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets source URL of the image.
        /// </summary>
        [JsonProperty(PropertyName = "sourceUrl")]
        public string SourceUrl { get; private set; }

        /// <summary>
        /// Gets status of the image creation. Possible values include: 'OK',
        /// 'OKDuplicate', 'ErrorSource', 'ErrorImageFormat', 'ErrorImageSize',
        /// 'ErrorStorage', 'ErrorLimitExceed', 'ErrorTagLimitExceed',
        /// 'ErrorRegionLimitExceed', 'ErrorUnknown',
        /// 'ErrorNegativeAndRegularTagOnSameImage'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; private set; }

        /// <summary>
        /// Gets the image.
        /// </summary>
        [JsonProperty(PropertyName = "image")]
        public Image Image { get; private set; }

    }
}
