// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for DisksOperations.
    /// </summary>
    public static partial class DisksOperationsExtensions
    {
            /// <summary>
            /// Creates or updates a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='disk'>
            /// Disk object supplied in the body of the Put disk operation.
            /// </param>
            public static Disk CreateOrUpdate(this IDisksOperations operations, string resourceGroupName, string diskName, Disk disk)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, diskName, disk).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates or updates a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='disk'>
            /// Disk object supplied in the body of the Put disk operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Disk> CreateOrUpdateAsync(this IDisksOperations operations, string resourceGroupName, string diskName, Disk disk, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, diskName, disk, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Updates (patches) a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='disk'>
            /// Disk object supplied in the body of the Patch disk operation.
            /// </param>
            public static Disk Update(this IDisksOperations operations, string resourceGroupName, string diskName, DiskUpdate disk)
            {
                return operations.UpdateAsync(resourceGroupName, diskName, disk).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates (patches) a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='disk'>
            /// Disk object supplied in the body of the Patch disk operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Disk> UpdateAsync(this IDisksOperations operations, string resourceGroupName, string diskName, DiskUpdate disk, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(resourceGroupName, diskName, disk, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets information about a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            public static Disk Get(this IDisksOperations operations, string resourceGroupName, string diskName)
            {
                return operations.GetAsync(resourceGroupName, diskName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets information about a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Disk> GetAsync(this IDisksOperations operations, string resourceGroupName, string diskName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, diskName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            public static void Delete(this IDisksOperations operations, string resourceGroupName, string diskName)
            {
                operations.DeleteAsync(resourceGroupName, diskName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IDisksOperations operations, string resourceGroupName, string diskName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, diskName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Lists all the disks under a resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            public static IPage<Disk> ListByResourceGroup(this IDisksOperations operations, string resourceGroupName)
            {
                return operations.ListByResourceGroupAsync(resourceGroupName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists all the disks under a resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Disk>> ListByResourceGroupAsync(this IDisksOperations operations, string resourceGroupName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByResourceGroupWithHttpMessagesAsync(resourceGroupName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists all the disks under a subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static IPage<Disk> List(this IDisksOperations operations)
            {
                return operations.ListAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists all the disks under a subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Disk>> ListAsync(this IDisksOperations operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Grants access to a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='grantAccessData'>
            /// Access data object supplied in the body of the get disk access operation.
            /// </param>
            public static AccessUri GrantAccess(this IDisksOperations operations, string resourceGroupName, string diskName, GrantAccessData grantAccessData)
            {
                return operations.GrantAccessAsync(resourceGroupName, diskName, grantAccessData).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Grants access to a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='grantAccessData'>
            /// Access data object supplied in the body of the get disk access operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AccessUri> GrantAccessAsync(this IDisksOperations operations, string resourceGroupName, string diskName, GrantAccessData grantAccessData, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GrantAccessWithHttpMessagesAsync(resourceGroupName, diskName, grantAccessData, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Revokes access to a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            public static void RevokeAccess(this IDisksOperations operations, string resourceGroupName, string diskName)
            {
                operations.RevokeAccessAsync(resourceGroupName, diskName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Revokes access to a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task RevokeAccessAsync(this IDisksOperations operations, string resourceGroupName, string diskName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.RevokeAccessWithHttpMessagesAsync(resourceGroupName, diskName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Creates or updates a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='disk'>
            /// Disk object supplied in the body of the Put disk operation.
            /// </param>
            public static Disk BeginCreateOrUpdate(this IDisksOperations operations, string resourceGroupName, string diskName, Disk disk)
            {
                return operations.BeginCreateOrUpdateAsync(resourceGroupName, diskName, disk).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates or updates a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='disk'>
            /// Disk object supplied in the body of the Put disk operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Disk> BeginCreateOrUpdateAsync(this IDisksOperations operations, string resourceGroupName, string diskName, Disk disk, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateOrUpdateWithHttpMessagesAsync(resourceGroupName, diskName, disk, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Updates (patches) a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='disk'>
            /// Disk object supplied in the body of the Patch disk operation.
            /// </param>
            public static Disk BeginUpdate(this IDisksOperations operations, string resourceGroupName, string diskName, DiskUpdate disk)
            {
                return operations.BeginUpdateAsync(resourceGroupName, diskName, disk).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates (patches) a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='disk'>
            /// Disk object supplied in the body of the Patch disk operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Disk> BeginUpdateAsync(this IDisksOperations operations, string resourceGroupName, string diskName, DiskUpdate disk, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginUpdateWithHttpMessagesAsync(resourceGroupName, diskName, disk, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            public static void BeginDelete(this IDisksOperations operations, string resourceGroupName, string diskName)
            {
                operations.BeginDeleteAsync(resourceGroupName, diskName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginDeleteAsync(this IDisksOperations operations, string resourceGroupName, string diskName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginDeleteWithHttpMessagesAsync(resourceGroupName, diskName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Grants access to a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='grantAccessData'>
            /// Access data object supplied in the body of the get disk access operation.
            /// </param>
            public static AccessUri BeginGrantAccess(this IDisksOperations operations, string resourceGroupName, string diskName, GrantAccessData grantAccessData)
            {
                return operations.BeginGrantAccessAsync(resourceGroupName, diskName, grantAccessData).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Grants access to a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='grantAccessData'>
            /// Access data object supplied in the body of the get disk access operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AccessUri> BeginGrantAccessAsync(this IDisksOperations operations, string resourceGroupName, string diskName, GrantAccessData grantAccessData, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginGrantAccessWithHttpMessagesAsync(resourceGroupName, diskName, grantAccessData, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Revokes access to a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            public static void BeginRevokeAccess(this IDisksOperations operations, string resourceGroupName, string diskName)
            {
                operations.BeginRevokeAccessAsync(resourceGroupName, diskName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Revokes access to a disk.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='diskName'>
            /// The name of the managed disk that is being created. The name can't be
            /// changed after the disk is created. Supported characters for the name are
            /// a-z, A-Z, 0-9 and _. The maximum name length is 80 characters.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginRevokeAccessAsync(this IDisksOperations operations, string resourceGroupName, string diskName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginRevokeAccessWithHttpMessagesAsync(resourceGroupName, diskName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Lists all the disks under a resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<Disk> ListByResourceGroupNext(this IDisksOperations operations, string nextPageLink)
            {
                return operations.ListByResourceGroupNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists all the disks under a resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Disk>> ListByResourceGroupNextAsync(this IDisksOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByResourceGroupNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists all the disks under a subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<Disk> ListNext(this IDisksOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists all the disks under a subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Disk>> ListNextAsync(this IDisksOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
