// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Consumption
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// Consumption management client provides access to consumption resources
    /// for Azure Enterprise Subscriptions.
    /// </summary>
    public partial interface IConsumptionManagementClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// Version of the API to be used with the client request. The current
        /// version is 2019-04-01-preview.
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// Azure Subscription ID.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IUsageDetailsOperations.
        /// </summary>
        IUsageDetailsOperations UsageDetails { get; }

        /// <summary>
        /// Gets the IMarketplacesOperations.
        /// </summary>
        IMarketplacesOperations Marketplaces { get; }

        /// <summary>
        /// Gets the IBudgetsOperations.
        /// </summary>
        IBudgetsOperations Budgets { get; }

        /// <summary>
        /// Gets the ITagsOperations.
        /// </summary>
        ITagsOperations Tags { get; }

        /// <summary>
        /// Gets the IChargesOperations.
        /// </summary>
        IChargesOperations Charges { get; }

        /// <summary>
        /// Gets the IBalancesOperations.
        /// </summary>
        IBalancesOperations Balances { get; }

        /// <summary>
        /// Gets the IReservationsSummariesOperations.
        /// </summary>
        IReservationsSummariesOperations ReservationsSummaries { get; }

        /// <summary>
        /// Gets the IReservationsDetailsOperations.
        /// </summary>
        IReservationsDetailsOperations ReservationsDetails { get; }

        /// <summary>
        /// Gets the IReservationRecommendationsOperations.
        /// </summary>
        IReservationRecommendationsOperations ReservationRecommendations { get; }

        /// <summary>
        /// Gets the IPriceSheetOperations.
        /// </summary>
        IPriceSheetOperations PriceSheet { get; }

        /// <summary>
        /// Gets the IForecastsOperations.
        /// </summary>
        IForecastsOperations Forecasts { get; }

        /// <summary>
        /// Gets the IOperations.
        /// </summary>
        IOperations Operations { get; }

        /// <summary>
        /// Gets the IAggregatedCostOperations.
        /// </summary>
        IAggregatedCostOperations AggregatedCost { get; }

    }
}
