// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Consumption.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties of the price sheet.
    /// </summary>
    public partial class PriceSheetProperties
    {
        /// <summary>
        /// Initializes a new instance of the PriceSheetProperties class.
        /// </summary>
        public PriceSheetProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PriceSheetProperties class.
        /// </summary>
        /// <param name="billingPeriodId">The id of the billing period resource
        /// that the usage belongs to.</param>
        /// <param name="meterId">The meter id (GUID)</param>
        /// <param name="meterDetails">The details about the meter. By default
        /// this is not populated, unless it's specified in $expand.</param>
        /// <param name="unitOfMeasure">Unit of measure</param>
        /// <param name="includedQuantity">Included quality for an
        /// offer</param>
        /// <param name="partNumber">Part Number</param>
        /// <param name="unitPrice">Unit Price</param>
        /// <param name="currencyCode">Currency Code</param>
        /// <param name="offerId">Offer Id</param>
        public PriceSheetProperties(string billingPeriodId = default(string), System.Guid? meterId = default(System.Guid?), MeterDetails meterDetails = default(MeterDetails), string unitOfMeasure = default(string), decimal? includedQuantity = default(decimal?), string partNumber = default(string), decimal? unitPrice = default(decimal?), string currencyCode = default(string), string offerId = default(string))
        {
            BillingPeriodId = billingPeriodId;
            MeterId = meterId;
            MeterDetails = meterDetails;
            UnitOfMeasure = unitOfMeasure;
            IncludedQuantity = includedQuantity;
            PartNumber = partNumber;
            UnitPrice = unitPrice;
            CurrencyCode = currencyCode;
            OfferId = offerId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the id of the billing period resource that the usage belongs
        /// to.
        /// </summary>
        [JsonProperty(PropertyName = "billingPeriodId")]
        public string BillingPeriodId { get; private set; }

        /// <summary>
        /// Gets the meter id (GUID)
        /// </summary>
        [JsonProperty(PropertyName = "meterId")]
        public System.Guid? MeterId { get; private set; }

        /// <summary>
        /// Gets the details about the meter. By default this is not populated,
        /// unless it's specified in $expand.
        /// </summary>
        [JsonProperty(PropertyName = "meterDetails")]
        public MeterDetails MeterDetails { get; private set; }

        /// <summary>
        /// Gets unit of measure
        /// </summary>
        [JsonProperty(PropertyName = "unitOfMeasure")]
        public string UnitOfMeasure { get; private set; }

        /// <summary>
        /// Gets included quality for an offer
        /// </summary>
        [JsonProperty(PropertyName = "includedQuantity")]
        public decimal? IncludedQuantity { get; private set; }

        /// <summary>
        /// Gets part Number
        /// </summary>
        [JsonProperty(PropertyName = "partNumber")]
        public string PartNumber { get; private set; }

        /// <summary>
        /// Gets unit Price
        /// </summary>
        [JsonProperty(PropertyName = "unitPrice")]
        public decimal? UnitPrice { get; private set; }

        /// <summary>
        /// Gets currency Code
        /// </summary>
        [JsonProperty(PropertyName = "currencyCode")]
        public string CurrencyCode { get; private set; }

        /// <summary>
        /// Gets offer Id
        /// </summary>
        [JsonProperty(PropertyName = "offerId")]
        public string OfferId { get; private set; }

    }
}
