// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Consumption.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// reservation detail resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ReservationDetail : Resource
    {
        /// <summary>
        /// Initializes a new instance of the ReservationDetail class.
        /// </summary>
        public ReservationDetail()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ReservationDetail class.
        /// </summary>
        /// <param name="id">Resource Id.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="tags">Resource tags.</param>
        /// <param name="reservationOrderId">The reservation order ID is the
        /// identifier for a reservation purchase. Each reservation order ID
        /// represents a single purchase transaction. A reservation order
        /// contains reservations. The reservation order specifies the VM size
        /// and region for the reservations.</param>
        /// <param name="reservationId">The reservation ID is the identifier of
        /// a reservation within a reservation order. Each reservation is the
        /// grouping for applying the benefit scope and also specifies the
        /// number of instances to which the reservation benefit can be applied
        /// to.</param>
        /// <param name="skuName">This is the ARM Sku name. It can be used to
        /// join with the serviceType field in additional info in usage
        /// records.</param>
        /// <param name="reservedHours">This is the total hours reserved for
        /// the day. E.g. if reservation for 1 instance was made on 1 PM, this
        /// will be 11 hours for that day and 24 hours from subsequent
        /// days.</param>
        /// <param name="usageDate">The date on which consumption
        /// occurred.</param>
        /// <param name="usedHours">This is the total hours used by the
        /// instance.</param>
        /// <param name="instanceId">This identifier is the name of the
        /// resource or the fully qualified Resource ID.</param>
        /// <param name="totalReservedQuantity">This is the total count of
        /// instances that are reserved for the reservationId.</param>
        public ReservationDetail(string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string reservationOrderId = default(string), string reservationId = default(string), string skuName = default(string), decimal? reservedHours = default(decimal?), System.DateTime? usageDate = default(System.DateTime?), decimal? usedHours = default(decimal?), string instanceId = default(string), decimal? totalReservedQuantity = default(decimal?))
            : base(id, name, type, tags)
        {
            ReservationOrderId = reservationOrderId;
            ReservationId = reservationId;
            SkuName = skuName;
            ReservedHours = reservedHours;
            UsageDate = usageDate;
            UsedHours = usedHours;
            InstanceId = instanceId;
            TotalReservedQuantity = totalReservedQuantity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the reservation order ID is the identifier for a reservation
        /// purchase. Each reservation order ID represents a single purchase
        /// transaction. A reservation order contains reservations. The
        /// reservation order specifies the VM size and region for the
        /// reservations.
        /// </summary>
        [JsonProperty(PropertyName = "properties.reservationOrderId")]
        public string ReservationOrderId { get; private set; }

        /// <summary>
        /// Gets the reservation ID is the identifier of a reservation within a
        /// reservation order. Each reservation is the grouping for applying
        /// the benefit scope and also specifies the number of instances to
        /// which the reservation benefit can be applied to.
        /// </summary>
        [JsonProperty(PropertyName = "properties.reservationId")]
        public string ReservationId { get; private set; }

        /// <summary>
        /// Gets this is the ARM Sku name. It can be used to join with the
        /// serviceType field in additional info in usage records.
        /// </summary>
        [JsonProperty(PropertyName = "properties.skuName")]
        public string SkuName { get; private set; }

        /// <summary>
        /// Gets this is the total hours reserved for the day. E.g. if
        /// reservation for 1 instance was made on 1 PM, this will be 11 hours
        /// for that day and 24 hours from subsequent days.
        /// </summary>
        [JsonProperty(PropertyName = "properties.reservedHours")]
        public decimal? ReservedHours { get; private set; }

        /// <summary>
        /// Gets the date on which consumption occurred.
        /// </summary>
        [JsonProperty(PropertyName = "properties.usageDate")]
        public System.DateTime? UsageDate { get; private set; }

        /// <summary>
        /// Gets this is the total hours used by the instance.
        /// </summary>
        [JsonProperty(PropertyName = "properties.usedHours")]
        public decimal? UsedHours { get; private set; }

        /// <summary>
        /// Gets this identifier is the name of the resource or the fully
        /// qualified Resource ID.
        /// </summary>
        [JsonProperty(PropertyName = "properties.instanceId")]
        public string InstanceId { get; private set; }

        /// <summary>
        /// Gets this is the total count of instances that are reserved for the
        /// reservationId.
        /// </summary>
        [JsonProperty(PropertyName = "properties.totalReservedQuantity")]
        public decimal? TotalReservedQuantity { get; private set; }

    }
}
