// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Consumption
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ReservationsDetailsOperations.
    /// </summary>
    public static partial class ReservationsDetailsOperationsExtensions
    {
            /// <summary>
            /// Lists the reservations details for provided date range.
            /// <see href="https://docs.microsoft.com/en-us/rest/api/consumption/" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='reservationOrderId'>
            /// Order Id of the reservation
            /// </param>
            /// <param name='filter'>
            /// Filter reservation details by date range. The properties/UsageDate for
            /// start date and end date. The filter supports 'le' and  'ge'
            /// </param>
            public static IPage<ReservationDetail> ListByReservationOrder(this IReservationsDetailsOperations operations, string reservationOrderId, string filter)
            {
                return operations.ListByReservationOrderAsync(reservationOrderId, filter).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists the reservations details for provided date range.
            /// <see href="https://docs.microsoft.com/en-us/rest/api/consumption/" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='reservationOrderId'>
            /// Order Id of the reservation
            /// </param>
            /// <param name='filter'>
            /// Filter reservation details by date range. The properties/UsageDate for
            /// start date and end date. The filter supports 'le' and  'ge'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ReservationDetail>> ListByReservationOrderAsync(this IReservationsDetailsOperations operations, string reservationOrderId, string filter, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByReservationOrderWithHttpMessagesAsync(reservationOrderId, filter, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists the reservations details for provided date range.
            /// <see href="https://docs.microsoft.com/en-us/rest/api/consumption/" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='reservationOrderId'>
            /// Order Id of the reservation
            /// </param>
            /// <param name='reservationId'>
            /// Id of the reservation
            /// </param>
            /// <param name='filter'>
            /// Filter reservation details by date range. The properties/UsageDate for
            /// start date and end date. The filter supports 'le' and  'ge'
            /// </param>
            public static IPage<ReservationDetail> ListByReservationOrderAndReservation(this IReservationsDetailsOperations operations, string reservationOrderId, string reservationId, string filter)
            {
                return operations.ListByReservationOrderAndReservationAsync(reservationOrderId, reservationId, filter).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists the reservations details for provided date range.
            /// <see href="https://docs.microsoft.com/en-us/rest/api/consumption/" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='reservationOrderId'>
            /// Order Id of the reservation
            /// </param>
            /// <param name='reservationId'>
            /// Id of the reservation
            /// </param>
            /// <param name='filter'>
            /// Filter reservation details by date range. The properties/UsageDate for
            /// start date and end date. The filter supports 'le' and  'ge'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ReservationDetail>> ListByReservationOrderAndReservationAsync(this IReservationsDetailsOperations operations, string reservationOrderId, string reservationId, string filter, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByReservationOrderAndReservationWithHttpMessagesAsync(reservationOrderId, reservationId, filter, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists the reservations details for provided date range.
            /// <see href="https://docs.microsoft.com/en-us/rest/api/consumption/" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<ReservationDetail> ListByReservationOrderNext(this IReservationsDetailsOperations operations, string nextPageLink)
            {
                return operations.ListByReservationOrderNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists the reservations details for provided date range.
            /// <see href="https://docs.microsoft.com/en-us/rest/api/consumption/" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ReservationDetail>> ListByReservationOrderNextAsync(this IReservationsDetailsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByReservationOrderNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists the reservations details for provided date range.
            /// <see href="https://docs.microsoft.com/en-us/rest/api/consumption/" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<ReservationDetail> ListByReservationOrderAndReservationNext(this IReservationsDetailsOperations operations, string nextPageLink)
            {
                return operations.ListByReservationOrderAndReservationNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists the reservations details for provided date range.
            /// <see href="https://docs.microsoft.com/en-us/rest/api/consumption/" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ReservationDetail>> ListByReservationOrderAndReservationNextAsync(this IReservationsDetailsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByReservationOrderAndReservationNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
