// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.ContainerRegistry
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// Metadata API definition for the Azure Container Registry runtime
    /// </summary>
    public partial interface IAzureContainerRegistryClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// Registry login URL
        /// </summary>
        string LoginUri { get; set; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IV2SupportOperations.
        /// </summary>
        IV2SupportOperations V2Support { get; }

        /// <summary>
        /// Gets the IManifestsOperations.
        /// </summary>
        IManifestsOperations Manifests { get; }

        /// <summary>
        /// Gets the IBlobOperations.
        /// </summary>
        IBlobOperations Blob { get; }

        /// <summary>
        /// Gets the IRepositoryOperations.
        /// </summary>
        IRepositoryOperations Repository { get; }

        /// <summary>
        /// Gets the ITagOperations.
        /// </summary>
        ITagOperations Tag { get; }

        /// <summary>
        /// Gets the IRefreshTokensOperations.
        /// </summary>
        IRefreshTokensOperations RefreshTokens { get; }

        /// <summary>
        /// Gets the IAccessTokensOperations.
        /// </summary>
        IAccessTokensOperations AccessTokens { get; }

    }
}
