// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.ContainerRegistry
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// RefreshTokensOperations operations.
    /// </summary>
    public partial interface IRefreshTokensOperations
    {
        /// <summary>
        /// Exchange AAD tokens for an ACR refresh Token
        /// </summary>
        /// <param name='grantType'>
        /// Can take a value of access_token_refresh_token, or access_token, or
        /// refresh_token. Possible values include:
        /// 'access_token_refresh_token', 'access_token', 'refresh_token'
        /// </param>
        /// <param name='service'>
        /// Indicates the name of your Azure container registry.
        /// </param>
        /// <param name='tenant'>
        /// AAD tenant associated to the AAD credentials.
        /// </param>
        /// <param name='refreshToken'>
        /// AAD refresh token, mandatory when grant_type is
        /// access_token_refresh_token or refresh_token
        /// </param>
        /// <param name='accessToken'>
        /// AAD access token, mandatory when grant_type is
        /// access_token_refresh_token or access_token.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="AcrErrorsException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<RefreshToken>> GetFromExchangeWithHttpMessagesAsync(string grantType, string service, string tenant = default(string), string refreshToken = default(string), string accessToken = default(string), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
    }
}
