// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.ContainerRegistry.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines headers for EndUpload operation.
    /// </summary>
    public partial class BlobEndUploadHeaders
    {
        /// <summary>
        /// Initializes a new instance of the BlobEndUploadHeaders class.
        /// </summary>
        public BlobEndUploadHeaders()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BlobEndUploadHeaders class.
        /// </summary>
        /// <param name="location">Provided location for blob</param>
        /// <param name="range">Range indicating the current progress of the
        /// upload.</param>
        /// <param name="dockerContentDigest">Digest of the targeted content
        /// for the request.</param>
        public BlobEndUploadHeaders(string location = default(string), string range = default(string), string dockerContentDigest = default(string))
        {
            Location = location;
            Range = range;
            DockerContentDigest = dockerContentDigest;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets provided location for blob
        /// </summary>
        [JsonProperty(PropertyName = "Location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets range indicating the current progress of the upload.
        /// </summary>
        [JsonProperty(PropertyName = "Range")]
        public string Range { get; set; }

        /// <summary>
        /// Gets or sets digest of the targeted content for the request.
        /// </summary>
        [JsonProperty(PropertyName = "Docker-Content-Digest")]
        public string DockerContentDigest { get; set; }

    }
}
