// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.ContainerRegistry.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Docker V2 image layer descriptor including config and layers
    /// </summary>
    public partial class Descriptor
    {
        /// <summary>
        /// Initializes a new instance of the Descriptor class.
        /// </summary>
        public Descriptor()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Descriptor class.
        /// </summary>
        /// <param name="mediaType">Layer media type</param>
        /// <param name="size">Layer size</param>
        /// <param name="digest">Layer digest</param>
        /// <param name="urls">Specifies a list of URIs from which this object
        /// may be downloaded.</param>
        public Descriptor(string mediaType = default(string), long? size = default(long?), string digest = default(string), IList<string> urls = default(IList<string>), Annotations annotations = default(Annotations))
        {
            MediaType = mediaType;
            Size = size;
            Digest = digest;
            Urls = urls;
            Annotations = annotations;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets layer media type
        /// </summary>
        [JsonProperty(PropertyName = "mediaType")]
        public string MediaType { get; set; }

        /// <summary>
        /// Gets or sets layer size
        /// </summary>
        [JsonProperty(PropertyName = "size")]
        public long? Size { get; set; }

        /// <summary>
        /// Gets or sets layer digest
        /// </summary>
        [JsonProperty(PropertyName = "digest")]
        public string Digest { get; set; }

        /// <summary>
        /// Gets or sets specifies a list of URIs from which this object may be
        /// downloaded.
        /// </summary>
        [JsonProperty(PropertyName = "urls")]
        public IList<string> Urls { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "annotations")]
        public Annotations Annotations { get; set; }

    }
}
