// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.ContainerRegistry.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines headers for Create operation.
    /// </summary>
    public partial class ManifestsCreateHeaders
    {
        /// <summary>
        /// Initializes a new instance of the ManifestsCreateHeaders class.
        /// </summary>
        public ManifestsCreateHeaders()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ManifestsCreateHeaders class.
        /// </summary>
        /// <param name="dockerContentDigest">Identifies the docker upload uuid
        /// for the current request.</param>
        /// <param name="location">The canonical location url of the uploaded
        /// manifest.</param>
        /// <param name="contentLength">The length of the requested blob
        /// content.</param>
        public ManifestsCreateHeaders(string dockerContentDigest = default(string), string location = default(string), long? contentLength = default(long?))
        {
            DockerContentDigest = dockerContentDigest;
            Location = location;
            ContentLength = contentLength;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets identifies the docker upload uuid for the current
        /// request.
        /// </summary>
        [JsonProperty(PropertyName = "Docker-Content-Digest")]
        public string DockerContentDigest { get; set; }

        /// <summary>
        /// Gets or sets the canonical location url of the uploaded manifest.
        /// </summary>
        [JsonProperty(PropertyName = "Location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets the length of the requested blob content.
        /// </summary>
        [JsonProperty(PropertyName = "Content-Length")]
        public long? ContentLength { get; set; }

    }
}
