// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The parameters that describes a set of credentials that will be used
    /// when a run is invoked.
    /// </summary>
    public partial class Credentials
    {
        /// <summary>
        /// Initializes a new instance of the Credentials class.
        /// </summary>
        public Credentials()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Credentials class.
        /// </summary>
        /// <param name="sourceRegistry">Describes the credential parameters
        /// for accessing the source registry.</param>
        /// <param name="customRegistries">Describes the credential parameters
        /// for accessing other custom registries. The key
        /// for the dictionary item will be the registry login server
        /// (myregistry.azurecr.io) and
        /// the value of the item will be the registry credentials for
        /// accessing the registry.</param>
        public Credentials(SourceRegistryCredentials sourceRegistry = default(SourceRegistryCredentials), IDictionary<string, CustomRegistryCredentials> customRegistries = default(IDictionary<string, CustomRegistryCredentials>))
        {
            SourceRegistry = sourceRegistry;
            CustomRegistries = customRegistries;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets describes the credential parameters for accessing the
        /// source registry.
        /// </summary>
        [JsonProperty(PropertyName = "sourceRegistry")]
        public SourceRegistryCredentials SourceRegistry { get; set; }

        /// <summary>
        /// Gets or sets describes the credential parameters for accessing
        /// other custom registries. The key
        /// for the dictionary item will be the registry login server
        /// (myregistry.azurecr.io) and
        /// the value of the item will be the registry credentials for
        /// accessing the registry.
        /// </summary>
        [JsonProperty(PropertyName = "customRegistries")]
        public IDictionary<string, CustomRegistryCredentials> CustomRegistries { get; set; }

    }
}
