// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The policies for a container registry.
    /// </summary>
    public partial class Policies
    {
        /// <summary>
        /// Initializes a new instance of the Policies class.
        /// </summary>
        public Policies()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Policies class.
        /// </summary>
        /// <param name="quarantinePolicy">The quarantine policy for a
        /// container registry.</param>
        /// <param name="trustPolicy">The content trust policy for a container
        /// registry.</param>
        /// <param name="retentionPolicy">The retention policy for a container
        /// registry.</param>
        public Policies(QuarantinePolicy quarantinePolicy = default(QuarantinePolicy), TrustPolicy trustPolicy = default(TrustPolicy), RetentionPolicy retentionPolicy = default(RetentionPolicy))
        {
            QuarantinePolicy = quarantinePolicy;
            TrustPolicy = trustPolicy;
            RetentionPolicy = retentionPolicy;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the quarantine policy for a container registry.
        /// </summary>
        [JsonProperty(PropertyName = "quarantinePolicy")]
        public QuarantinePolicy QuarantinePolicy { get; set; }

        /// <summary>
        /// Gets or sets the content trust policy for a container registry.
        /// </summary>
        [JsonProperty(PropertyName = "trustPolicy")]
        public TrustPolicy TrustPolicy { get; set; }

        /// <summary>
        /// Gets or sets the retention policy for a container registry.
        /// </summary>
        [JsonProperty(PropertyName = "retentionPolicy")]
        public RetentionPolicy RetentionPolicy { get; set; }

    }
}
