// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The access keys for the given database account.
    /// </summary>
    public partial class DatabaseAccountListKeysResult : DatabaseAccountListReadOnlyKeysResult
    {
        /// <summary>
        /// Initializes a new instance of the DatabaseAccountListKeysResult
        /// class.
        /// </summary>
        public DatabaseAccountListKeysResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DatabaseAccountListKeysResult
        /// class.
        /// </summary>
        /// <param name="primaryReadonlyMasterKey">Base 64 encoded value of the
        /// primary read-only key.</param>
        /// <param name="secondaryReadonlyMasterKey">Base 64 encoded value of
        /// the secondary read-only key.</param>
        /// <param name="primaryMasterKey">Base 64 encoded value of the primary
        /// read-write key.</param>
        /// <param name="secondaryMasterKey">Base 64 encoded value of the
        /// secondary read-write key.</param>
        public DatabaseAccountListKeysResult(string primaryReadonlyMasterKey = default(string), string secondaryReadonlyMasterKey = default(string), string primaryMasterKey = default(string), string secondaryMasterKey = default(string))
            : base(primaryReadonlyMasterKey, secondaryReadonlyMasterKey)
        {
            PrimaryMasterKey = primaryMasterKey;
            SecondaryMasterKey = secondaryMasterKey;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets base 64 encoded value of the primary read-write key.
        /// </summary>
        [JsonProperty(PropertyName = "primaryMasterKey")]
        public string PrimaryMasterKey { get; private set; }

        /// <summary>
        /// Gets base 64 encoded value of the secondary read-write key.
        /// </summary>
        [JsonProperty(PropertyName = "secondaryMasterKey")]
        public string SecondaryMasterKey { get; private set; }

    }
}
