// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Cosmos DB resource throughput object
    /// </summary>
    public partial class ThroughputSettingsResource
    {
        /// <summary>
        /// Initializes a new instance of the ThroughputSettingsResource class.
        /// </summary>
        public ThroughputSettingsResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ThroughputSettingsResource class.
        /// </summary>
        /// <param name="throughput">Value of the Cosmos DB resource
        /// throughput</param>
        /// <param name="minimumThroughput">The minimum throughput of the
        /// resource</param>
        /// <param name="offerReplacePending">The throughput replace is
        /// pending</param>
        public ThroughputSettingsResource(int throughput, string minimumThroughput = default(string), string offerReplacePending = default(string))
        {
            Throughput = throughput;
            MinimumThroughput = minimumThroughput;
            OfferReplacePending = offerReplacePending;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets value of the Cosmos DB resource throughput
        /// </summary>
        [JsonProperty(PropertyName = "throughput")]
        public int Throughput { get; set; }

        /// <summary>
        /// Gets the minimum throughput of the resource
        /// </summary>
        [JsonProperty(PropertyName = "minimumThroughput")]
        public string MinimumThroughput { get; private set; }

        /// <summary>
        /// Gets the throughput replace is pending
        /// </summary>
        [JsonProperty(PropertyName = "offerReplacePending")]
        public string OfferReplacePending { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
