// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.CustomerInsights
{
    using Azure;
    using Management;
    using Rest;
    using Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// The Azure Customer Insights management API provides a RESTful set of
    /// web services that interact with Azure Customer Insights service to
    /// manage your resources. The API has entities that capture the
    /// relationship between an end user and the Azure Customer Insights
    /// service.
    /// </summary>
    public partial interface ICustomerInsightsManagementClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// Gets subscription credentials which uniquely identify Microsoft
        /// Azure subscription. The subscription ID forms part of the URI for
        /// every service call.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// Client Api Version.
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// Gets or sets the preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// Gets or sets the retry timeout in seconds for Long Running
        /// Operations. Default value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// When set to true a unique x-ms-client-request-id value is generated
        /// and included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IHubsOperations.
        /// </summary>
        IHubsOperations Hubs { get; }

        /// <summary>
        /// Gets the IProfilesOperations.
        /// </summary>
        IProfilesOperations Profiles { get; }

        /// <summary>
        /// Gets the IInteractionsOperations.
        /// </summary>
        IInteractionsOperations Interactions { get; }

        /// <summary>
        /// Gets the IRelationshipsOperations.
        /// </summary>
        IRelationshipsOperations Relationships { get; }

        /// <summary>
        /// Gets the IRelationshipLinksOperations.
        /// </summary>
        IRelationshipLinksOperations RelationshipLinks { get; }

        /// <summary>
        /// Gets the IAuthorizationPoliciesOperations.
        /// </summary>
        IAuthorizationPoliciesOperations AuthorizationPolicies { get; }

        /// <summary>
        /// Gets the IConnectorsOperations.
        /// </summary>
        IConnectorsOperations Connectors { get; }

        /// <summary>
        /// Gets the IConnectorMappingsOperations.
        /// </summary>
        IConnectorMappingsOperations ConnectorMappings { get; }

        /// <summary>
        /// Gets the IKpiOperations.
        /// </summary>
        IKpiOperations Kpi { get; }

        /// <summary>
        /// Gets the IWidgetTypesOperations.
        /// </summary>
        IWidgetTypesOperations WidgetTypes { get; }

        /// <summary>
        /// Gets the IViewsOperations.
        /// </summary>
        IViewsOperations Views { get; }

        /// <summary>
        /// Gets the ILinksOperations.
        /// </summary>
        ILinksOperations Links { get; }

        /// <summary>
        /// Gets the IRolesOperations.
        /// </summary>
        IRolesOperations Roles { get; }

        /// <summary>
        /// Gets the IRoleAssignmentsOperations.
        /// </summary>
        IRoleAssignmentsOperations RoleAssignments { get; }

        /// <summary>
        /// Gets the IImagesOperations.
        /// </summary>
        IImagesOperations Images { get; }

    }
}

