// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.CustomerInsights.Models
{
    using Azure;
    using Management;
    using CustomerInsights;
    using Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The AssignmentPrincipal
    /// </summary>
    public partial class AssignmentPrincipal
    {
        /// <summary>
        /// Initializes a new instance of the AssignmentPrincipal class.
        /// </summary>
        public AssignmentPrincipal() { }

        /// <summary>
        /// Initializes a new instance of the AssignmentPrincipal class.
        /// </summary>
        /// <param name="principalId">The principal id being assigned
        /// to.</param>
        /// <param name="principalType">The Type of the principal ID.</param>
        /// <param name="principalMetadata">Other metadata for the
        /// principal.</param>
        public AssignmentPrincipal(string principalId, string principalType, IDictionary<string, string> principalMetadata = default(IDictionary<string, string>))
        {
            PrincipalId = principalId;
            PrincipalType = principalType;
            PrincipalMetadata = principalMetadata;
        }

        /// <summary>
        /// Gets or sets the principal id being assigned to.
        /// </summary>
        [JsonProperty(PropertyName = "principalId")]
        public string PrincipalId { get; set; }

        /// <summary>
        /// Gets or sets the Type of the principal ID.
        /// </summary>
        [JsonProperty(PropertyName = "principalType")]
        public string PrincipalType { get; set; }

        /// <summary>
        /// Gets or sets other metadata for the principal.
        /// </summary>
        [JsonProperty(PropertyName = "principalMetadata")]
        public IDictionary<string, string> PrincipalMetadata { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (PrincipalId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PrincipalId");
            }
            if (PrincipalType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PrincipalType");
            }
        }
    }
}

