// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.CustomerInsights.Models
{
    using Azure;
    using Management;
    using CustomerInsights;
    using Rest;
    using Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The authorization policy resource format.
    /// </summary>
    [JsonTransformation]
    public partial class AuthorizationPolicyResourceFormat : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the AuthorizationPolicyResourceFormat
        /// class.
        /// </summary>
        public AuthorizationPolicyResourceFormat() { }

        /// <summary>
        /// Initializes a new instance of the AuthorizationPolicyResourceFormat
        /// class.
        /// </summary>
        /// <param name="permissions">The permissions associated with the
        /// policy.</param>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="policyName">Name of the policy.</param>
        /// <param name="primaryKey">Primary key assiciated with the
        /// policy.</param>
        /// <param name="secondaryKey">Secondary key assiciated with the
        /// policy.</param>
        public AuthorizationPolicyResourceFormat(IList<PermissionTypes?> permissions, string id = default(string), string name = default(string), string type = default(string), string policyName = default(string), string primaryKey = default(string), string secondaryKey = default(string))
            : base(id, name, type)
        {
            PolicyName = policyName;
            Permissions = permissions;
            PrimaryKey = primaryKey;
            SecondaryKey = secondaryKey;
        }

        /// <summary>
        /// Gets name of the policy.
        /// </summary>
        [JsonProperty(PropertyName = "properties.policyName")]
        public string PolicyName { get; protected set; }

        /// <summary>
        /// Gets or sets the permissions associated with the policy.
        /// </summary>
        [JsonProperty(PropertyName = "properties.permissions")]
        public IList<PermissionTypes?> Permissions { get; set; }

        /// <summary>
        /// Gets or sets primary key assiciated with the policy.
        /// </summary>
        [JsonProperty(PropertyName = "properties.primaryKey")]
        public string PrimaryKey { get; set; }

        /// <summary>
        /// Gets or sets secondary key assiciated with the policy.
        /// </summary>
        [JsonProperty(PropertyName = "properties.secondaryKey")]
        public string SecondaryKey { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Permissions == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Permissions");
            }
            if (Permissions != null)
            {
                if (Permissions.Count != Permissions.Distinct().Count())
                {
                    throw new ValidationException(ValidationRules.UniqueItems, "Permissions");
                }
            }
        }
    }
}

