// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.CustomerInsights.Models
{
    using Azure;
    using Management;
    using CustomerInsights;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The complete operation.
    /// </summary>
    public partial class ConnectorMappingCompleteOperation
    {
        /// <summary>
        /// Initializes a new instance of the ConnectorMappingCompleteOperation
        /// class.
        /// </summary>
        public ConnectorMappingCompleteOperation() { }

        /// <summary>
        /// Initializes a new instance of the ConnectorMappingCompleteOperation
        /// class.
        /// </summary>
        /// <param name="completionOperationType">The type of completion
        /// operation. Possible values include: 'DoNothing', 'DeleteFile',
        /// 'MoveFile'</param>
        /// <param name="destinationFolder">The destination folder where files
        /// will be moved to once the import is done.</param>
        public ConnectorMappingCompleteOperation(CompletionOperationTypes? completionOperationType = default(CompletionOperationTypes?), string destinationFolder = default(string))
        {
            CompletionOperationType = completionOperationType;
            DestinationFolder = destinationFolder;
        }

        /// <summary>
        /// Gets or sets the type of completion operation. Possible values
        /// include: 'DoNothing', 'DeleteFile', 'MoveFile'
        /// </summary>
        [JsonProperty(PropertyName = "completionOperationType")]
        public CompletionOperationTypes? CompletionOperationType { get; set; }

        /// <summary>
        /// Gets or sets the destination folder where files will be moved to
        /// once the import is done.
        /// </summary>
        [JsonProperty(PropertyName = "destinationFolder")]
        public string DestinationFolder { get; set; }

    }
}

