// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.CustomerInsights.Models
{
    using Azure;
    using Management;
    using CustomerInsights;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Data Source is a way for us to know the source of instances. A single
    /// type can have data coming in from multiple places. In activities we use
    /// this to determine precedence rules.
    /// </summary>
    public partial class DataSource
    {
        /// <summary>
        /// Initializes a new instance of the DataSource class.
        /// </summary>
        public DataSource() { }

        /// <summary>
        /// Initializes a new instance of the DataSource class.
        /// </summary>
        /// <param name="dataSourceType">The data source type. Possible values
        /// include: 'ConnectorMapping', 'LinkInteraction',
        /// 'SystemDefault'</param>
        /// <param name="id">The data source ID.</param>
        /// <param name="linkId">The Link ID if the data source type is
        /// LinkInteraction.</param>
        /// <param name="connectorMappingId">The Connector Mapping ID if the
        /// data source type is ConnectorMapping.</param>
        public DataSource(string dataSourceType = default(string), string id = default(string), string linkId = default(string), string connectorMappingId = default(string))
        {
            DataSourceType = dataSourceType;
            Id = id;
            LinkId = linkId;
            ConnectorMappingId = connectorMappingId;
        }

        /// <summary>
        /// Gets the data source type. Possible values include:
        /// 'ConnectorMapping', 'LinkInteraction', 'SystemDefault'
        /// </summary>
        [JsonProperty(PropertyName = "dataSourceType")]
        public string DataSourceType { get; protected set; }

        /// <summary>
        /// Gets the data source ID.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; protected set; }

        /// <summary>
        /// Gets the Link ID if the data source type is LinkInteraction.
        /// </summary>
        [JsonProperty(PropertyName = "linkId")]
        public string LinkId { get; protected set; }

        /// <summary>
        /// Gets the Connector Mapping ID if the data source type is
        /// ConnectorMapping.
        /// </summary>
        [JsonProperty(PropertyName = "connectorMappingId")]
        public string ConnectorMappingId { get; protected set; }

    }
}

