// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.CustomerInsights.Models
{
    using Azure;
    using Management;
    using CustomerInsights;
    using Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The KPI alias.
    /// </summary>
    public partial class KpiAlias
    {
        /// <summary>
        /// Initializes a new instance of the KpiAlias class.
        /// </summary>
        public KpiAlias() { }

        /// <summary>
        /// Initializes a new instance of the KpiAlias class.
        /// </summary>
        /// <param name="aliasName">KPI alias name.</param>
        /// <param name="expression">The expression.</param>
        public KpiAlias(string aliasName, string expression)
        {
            AliasName = aliasName;
            Expression = expression;
        }

        /// <summary>
        /// Gets or sets KPI alias name.
        /// </summary>
        [JsonProperty(PropertyName = "aliasName")]
        public string AliasName { get; set; }

        /// <summary>
        /// Gets or sets the expression.
        /// </summary>
        [JsonProperty(PropertyName = "expression")]
        public string Expression { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (AliasName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AliasName");
            }
            if (Expression == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Expression");
            }
        }
    }
}

