// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.CustomerInsights.Models
{
    using Azure;
    using Management;
    using CustomerInsights;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The resource set description.
    /// </summary>
    public partial class ResourceSetDescription
    {
        /// <summary>
        /// Initializes a new instance of the ResourceSetDescription class.
        /// </summary>
        public ResourceSetDescription() { }

        /// <summary>
        /// Initializes a new instance of the ResourceSetDescription class.
        /// </summary>
        /// <param name="elements">The elements included in the set.</param>
        /// <param name="exceptions">The elements that are not included in the
        /// set, in case elements contains '*' indicating 'all'.</param>
        public ResourceSetDescription(IList<string> elements = default(IList<string>), IList<string> exceptions = default(IList<string>))
        {
            Elements = elements;
            Exceptions = exceptions;
        }

        /// <summary>
        /// Gets or sets the elements included in the set.
        /// </summary>
        [JsonProperty(PropertyName = "elements")]
        public IList<string> Elements { get; set; }

        /// <summary>
        /// Gets or sets the elements that are not included in the set, in case
        /// elements contains '*' indicating 'all'.
        /// </summary>
        [JsonProperty(PropertyName = "exceptions")]
        public IList<string> Exceptions { get; set; }

    }
}

