// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.CustomerInsights.Models
{
    using Azure;
    using Management;
    using CustomerInsights;
    using Rest;
    using Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The role resource format.
    /// </summary>
    [JsonTransformation]
    public partial class RoleResourceFormat : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the RoleResourceFormat class.
        /// </summary>
        public RoleResourceFormat() { }

        /// <summary>
        /// Initializes a new instance of the RoleResourceFormat class.
        /// </summary>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="roleName">The role name.</param>
        /// <param name="description">The description of the role.</param>
        public RoleResourceFormat(string id = default(string), string name = default(string), string type = default(string), string roleName = default(string), string description = default(string))
            : base(id, name, type)
        {
            RoleName = roleName;
            Description = description;
        }

        /// <summary>
        /// Gets or sets the role name.
        /// </summary>
        [JsonProperty(PropertyName = "properties.roleName")]
        public string RoleName { get; set; }

        /// <summary>
        /// Gets or sets the description of the role.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

    }
}

