// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.CustomerInsights.Models
{
    using Azure;
    using Management;
    using CustomerInsights;
    using Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The Salesforce connector properties.
    /// </summary>
    public partial class SalesforceConnectorProperties
    {
        /// <summary>
        /// Initializes a new instance of the SalesforceConnectorProperties
        /// class.
        /// </summary>
        public SalesforceConnectorProperties() { }

        /// <summary>
        /// Initializes a new instance of the SalesforceConnectorProperties
        /// class.
        /// </summary>
        /// <param name="usersetting">The user settings.</param>
        /// <param name="salesforcetables">The Salesforce tables.</param>
        public SalesforceConnectorProperties(SalesforceDiscoverSetting usersetting, IList<SalesforceTable> salesforcetables)
        {
            Usersetting = usersetting;
            Salesforcetables = salesforcetables;
        }

        /// <summary>
        /// Gets or sets the user settings.
        /// </summary>
        [JsonProperty(PropertyName = "usersetting")]
        public SalesforceDiscoverSetting Usersetting { get; set; }

        /// <summary>
        /// Gets or sets the Salesforce tables.
        /// </summary>
        [JsonProperty(PropertyName = "salesforcetables")]
        public IList<SalesforceTable> Salesforcetables { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Usersetting == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Usersetting");
            }
            if (Salesforcetables == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Salesforcetables");
            }
            if (Usersetting != null)
            {
                Usersetting.Validate();
            }
            if (Salesforcetables != null)
            {
                foreach (var element in Salesforcetables)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}

