// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.CustomerInsights.Models
{
    using Azure;
    using Management;
    using CustomerInsights;
    using Rest;
    using Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The WidgetTypeResourceFormat
    /// </summary>
    [JsonTransformation]
    public partial class WidgetTypeResourceFormat : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the WidgetTypeResourceFormat class.
        /// </summary>
        public WidgetTypeResourceFormat() { }

        /// <summary>
        /// Initializes a new instance of the WidgetTypeResourceFormat class.
        /// </summary>
        /// <param name="definition">Definition for widget type.</param>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="widgetTypeName">Name of the widget type.</param>
        /// <param name="description">Description for widget type.</param>
        /// <param name="displayName">Localized display name for the widget
        /// type.</param>
        /// <param name="imageUrl">The image URL.</param>
        /// <param name="tenantId">The hub name.</param>
        /// <param name="widgetVersion">The widget version.</param>
        /// <param name="changed">Date time when widget type was last
        /// modified.</param>
        /// <param name="created">Date time when widget type was
        /// created.</param>
        public WidgetTypeResourceFormat(string definition, string id = default(string), string name = default(string), string type = default(string), string widgetTypeName = default(string), string description = default(string), IDictionary<string, string> displayName = default(IDictionary<string, string>), string imageUrl = default(string), string tenantId = default(string), string widgetVersion = default(string), System.DateTime? changed = default(System.DateTime?), System.DateTime? created = default(System.DateTime?))
            : base(id, name, type)
        {
            WidgetTypeName = widgetTypeName;
            Definition = definition;
            Description = description;
            DisplayName = displayName;
            ImageUrl = imageUrl;
            TenantId = tenantId;
            WidgetVersion = widgetVersion;
            Changed = changed;
            Created = created;
        }

        /// <summary>
        /// Gets name of the widget type.
        /// </summary>
        [JsonProperty(PropertyName = "properties.widgetTypeName")]
        public string WidgetTypeName { get; protected set; }

        /// <summary>
        /// Gets or sets definition for widget type.
        /// </summary>
        [JsonProperty(PropertyName = "properties.definition")]
        public string Definition { get; set; }

        /// <summary>
        /// Gets or sets description for widget type.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets localized display name for the widget type.
        /// </summary>
        [JsonProperty(PropertyName = "properties.displayName")]
        public IDictionary<string, string> DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the image URL.
        /// </summary>
        [JsonProperty(PropertyName = "properties.imageUrl")]
        public string ImageUrl { get; set; }

        /// <summary>
        /// Gets the hub name.
        /// </summary>
        [JsonProperty(PropertyName = "properties.tenantId")]
        public string TenantId { get; protected set; }

        /// <summary>
        /// Gets or sets the widget version.
        /// </summary>
        [JsonProperty(PropertyName = "properties.widgetVersion")]
        public string WidgetVersion { get; set; }

        /// <summary>
        /// Gets date time when widget type was last modified.
        /// </summary>
        [JsonProperty(PropertyName = "properties.changed")]
        public System.DateTime? Changed { get; protected set; }

        /// <summary>
        /// Gets date time when widget type was created.
        /// </summary>
        [JsonProperty(PropertyName = "properties.created")]
        public System.DateTime? Created { get; protected set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Definition == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Definition");
            }
        }
    }
}

