// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.CustomProviders.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The route definition for an action implemented by the custom resource
    /// provider.
    /// </summary>
    public partial class CustomRPActionRouteDefinition : CustomRPRouteDefinition
    {
        /// <summary>
        /// Initializes a new instance of the CustomRPActionRouteDefinition
        /// class.
        /// </summary>
        public CustomRPActionRouteDefinition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CustomRPActionRouteDefinition
        /// class.
        /// </summary>
        /// <param name="name">The name of the route definition. This becomes
        /// the name for the ARM extension (e.g.
        /// '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.CustomProviders/resourceProviders/{resourceProviderName}/{name}')</param>
        /// <param name="endpoint">The route definition endpoint URI that the
        /// custom resource provider will proxy requests to. This can be in the
        /// form of a flat URI (e.g. 'https://testendpoint/') or can specify to
        /// route via a path (e.g.
        /// 'https://testendpoint/{requestPath}')</param>
        /// <param name="routingType">The routing types that are supported for
        /// action requests. Possible values include: 'Proxy'</param>
        public CustomRPActionRouteDefinition(string name, string endpoint, string routingType = default(string))
            : base(name, endpoint)
        {
            RoutingType = routingType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the routing types that are supported for action
        /// requests. Possible values include: 'Proxy'
        /// </summary>
        [JsonProperty(PropertyName = "routingType")]
        public string RoutingType { get; set; }

    }
}
