// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.CustomProviders.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A route definition that defines an action or resource that can be
    /// interacted with through the custom resource provider.
    /// </summary>
    public partial class CustomRPRouteDefinition
    {
        /// <summary>
        /// Initializes a new instance of the CustomRPRouteDefinition class.
        /// </summary>
        public CustomRPRouteDefinition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CustomRPRouteDefinition class.
        /// </summary>
        /// <param name="name">The name of the route definition. This becomes
        /// the name for the ARM extension (e.g.
        /// '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.CustomProviders/resourceProviders/{resourceProviderName}/{name}')</param>
        /// <param name="endpoint">The route definition endpoint URI that the
        /// custom resource provider will proxy requests to. This can be in the
        /// form of a flat URI (e.g. 'https://testendpoint/') or can specify to
        /// route via a path (e.g.
        /// 'https://testendpoint/{requestPath}')</param>
        public CustomRPRouteDefinition(string name, string endpoint)
        {
            Name = name;
            Endpoint = endpoint;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the route definition. This becomes the
        /// name for the ARM extension (e.g.
        /// '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.CustomProviders/resourceProviders/{resourceProviderName}/{name}')
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the route definition endpoint URI that the custom
        /// resource provider will proxy requests to. This can be in the form
        /// of a flat URI (e.g. 'https://testendpoint/') or can specify to
        /// route via a path (e.g. 'https://testendpoint/{requestPath}')
        /// </summary>
        [JsonProperty(PropertyName = "endpoint")]
        public string Endpoint { get; set; }

    }
}
