// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBox.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Output of the address validation api.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class AddressValidationOutput
    {
        /// <summary>
        /// Initializes a new instance of the AddressValidationOutput class.
        /// </summary>
        public AddressValidationOutput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AddressValidationOutput class.
        /// </summary>
        /// <param name="error">Error code and message of validation
        /// response.</param>
        /// <param name="validationStatus">The address validation status.
        /// Possible values include: 'Valid', 'Invalid', 'Ambiguous'</param>
        /// <param name="alternateAddresses">List of alternate
        /// addresses.</param>
        public AddressValidationOutput(Error error = default(Error), AddressValidationStatus? validationStatus = default(AddressValidationStatus?), IList<ShippingAddress> alternateAddresses = default(IList<ShippingAddress>))
        {
            Error = error;
            ValidationStatus = validationStatus;
            AlternateAddresses = alternateAddresses;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets error code and message of validation response.
        /// </summary>
        [JsonProperty(PropertyName = "properties.error")]
        public Error Error { get; private set; }

        /// <summary>
        /// Gets the address validation status. Possible values include:
        /// 'Valid', 'Invalid', 'Ambiguous'
        /// </summary>
        [JsonProperty(PropertyName = "properties.validationStatus")]
        public AddressValidationStatus? ValidationStatus { get; private set; }

        /// <summary>
        /// Gets list of alternate addresses.
        /// </summary>
        [JsonProperty(PropertyName = "properties.alternateAddresses")]
        public IList<ShippingAddress> AlternateAddresses { get; private set; }

    }
}
