// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBox.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The address validation output.
    /// </summary>
    [Newtonsoft.Json.JsonObject("ValidateAddress")]
    public partial class AddressValidationProperties : ValidationInputResponse
    {
        /// <summary>
        /// Initializes a new instance of the AddressValidationProperties
        /// class.
        /// </summary>
        public AddressValidationProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AddressValidationProperties
        /// class.
        /// </summary>
        /// <param name="error">Error code and message of validation
        /// response.</param>
        /// <param name="validationStatus">The address validation status.
        /// Possible values include: 'Valid', 'Invalid', 'Ambiguous'</param>
        /// <param name="alternateAddresses">List of alternate
        /// addresses.</param>
        public AddressValidationProperties(Error error = default(Error), AddressValidationStatus? validationStatus = default(AddressValidationStatus?), IList<ShippingAddress> alternateAddresses = default(IList<ShippingAddress>))
            : base(error)
        {
            ValidationStatus = validationStatus;
            AlternateAddresses = alternateAddresses;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the address validation status. Possible values include:
        /// 'Valid', 'Invalid', 'Ambiguous'
        /// </summary>
        [JsonProperty(PropertyName = "validationStatus")]
        public AddressValidationStatus? ValidationStatus { get; private set; }

        /// <summary>
        /// Gets list of alternate addresses.
        /// </summary>
        [JsonProperty(PropertyName = "alternateAddresses")]
        public IList<ShippingAddress> AlternateAddresses { get; private set; }

    }
}
