// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBox.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The filters for showing the available skus.
    /// </summary>
    public partial class AvailableSkuRequest
    {
        /// <summary>
        /// Initializes a new instance of the AvailableSkuRequest class.
        /// </summary>
        public AvailableSkuRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AvailableSkuRequest class.
        /// </summary>
        /// <param name="country">ISO country code. Country for hardware
        /// shipment. For codes check:
        /// https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2#Officially_assigned_code_elements</param>
        /// <param name="location">Location for data transfer. For locations
        /// check:
        /// https://management.azure.com/subscriptions/SUBSCRIPTIONID/locations?api-version=2018-01-01</param>
        /// <param name="skuNames">Sku Names to filter for available
        /// skus</param>
        public AvailableSkuRequest(string country, string location, IList<SkuName?> skuNames = default(IList<SkuName?>))
        {
            Country = country;
            Location = location;
            SkuNames = skuNames;
            CustomInit();
        }
        /// <summary>
        /// Static constructor for AvailableSkuRequest class.
        /// </summary>
        static AvailableSkuRequest()
        {
            TransferType = "ImportToAzure";
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ISO country code. Country for hardware shipment. For
        /// codes check:
        /// https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2#Officially_assigned_code_elements
        /// </summary>
        [JsonProperty(PropertyName = "country")]
        public string Country { get; set; }

        /// <summary>
        /// Gets or sets location for data transfer. For locations check:
        /// https://management.azure.com/subscriptions/SUBSCRIPTIONID/locations?api-version=2018-01-01
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets sku Names to filter for available skus
        /// </summary>
        [JsonProperty(PropertyName = "skuNames")]
        public IList<SkuName?> SkuNames { get; set; }

        /// <summary>
        /// Type of the transfer.
        /// </summary>
        [JsonProperty(PropertyName = "transferType")]
        public static string TransferType { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Country == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Country");
            }
            if (Location == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Location");
            }
        }
    }
}
