// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBox.Models
{
    using Newtonsoft.Json;
    using Newtonsoft.Json.Converters;
    using System.Runtime;
    using System.Runtime.Serialization;

    /// <summary>
    /// Defines values for CopyStatus.
    /// </summary>
    [JsonConverter(typeof(StringEnumConverter))]
    public enum CopyStatus
    {
        /// <summary>
        /// Data copy hasn't started yet.
        /// </summary>
        [EnumMember(Value = "NotStarted")]
        NotStarted,
        /// <summary>
        /// Data copy is in progress.
        /// </summary>
        [EnumMember(Value = "InProgress")]
        InProgress,
        /// <summary>
        /// Data copy completed.
        /// </summary>
        [EnumMember(Value = "Completed")]
        Completed,
        /// <summary>
        /// Data copy completed with errors.
        /// </summary>
        [EnumMember(Value = "CompletedWithErrors")]
        CompletedWithErrors,
        /// <summary>
        /// Data copy failed. No data was copied.
        /// </summary>
        [EnumMember(Value = "Failed")]
        Failed,
        /// <summary>
        /// No copy triggered as device was not returned.
        /// </summary>
        [EnumMember(Value = "NotReturned")]
        NotReturned,
        /// <summary>
        /// The Device has hit hardware issues.
        /// </summary>
        [EnumMember(Value = "HardwareError")]
        HardwareError,
        /// <summary>
        /// Data copy failed. The Device was formatted by user.
        /// </summary>
        [EnumMember(Value = "DeviceFormatted")]
        DeviceFormatted,
        /// <summary>
        /// Data copy failed. Device metadata was modified by user.
        /// </summary>
        [EnumMember(Value = "DeviceMetadataModified")]
        DeviceMetadataModified,
        /// <summary>
        /// Data copy failed. Storage Account was not accessible during copy.
        /// </summary>
        [EnumMember(Value = "StorageAccountNotAccessible")]
        StorageAccountNotAccessible,
        /// <summary>
        /// Data copy failed. The Device data content is not supported.
        /// </summary>
        [EnumMember(Value = "UnsupportedData")]
        UnsupportedData
    }
    internal static class CopyStatusEnumExtension
    {
        internal static string ToSerializedValue(this CopyStatus? value)
        {
            return value == null ? null : ((CopyStatus)value).ToSerializedValue();
        }

        internal static string ToSerializedValue(this CopyStatus value)
        {
            switch( value )
            {
                case CopyStatus.NotStarted:
                    return "NotStarted";
                case CopyStatus.InProgress:
                    return "InProgress";
                case CopyStatus.Completed:
                    return "Completed";
                case CopyStatus.CompletedWithErrors:
                    return "CompletedWithErrors";
                case CopyStatus.Failed:
                    return "Failed";
                case CopyStatus.NotReturned:
                    return "NotReturned";
                case CopyStatus.HardwareError:
                    return "HardwareError";
                case CopyStatus.DeviceFormatted:
                    return "DeviceFormatted";
                case CopyStatus.DeviceMetadataModified:
                    return "DeviceMetadataModified";
                case CopyStatus.StorageAccountNotAccessible:
                    return "StorageAccountNotAccessible";
                case CopyStatus.UnsupportedData:
                    return "UnsupportedData";
            }
            return null;
        }

        internal static CopyStatus? ParseCopyStatus(this string value)
        {
            switch( value )
            {
                case "NotStarted":
                    return CopyStatus.NotStarted;
                case "InProgress":
                    return CopyStatus.InProgress;
                case "Completed":
                    return CopyStatus.Completed;
                case "CompletedWithErrors":
                    return CopyStatus.CompletedWithErrors;
                case "Failed":
                    return CopyStatus.Failed;
                case "NotReturned":
                    return CopyStatus.NotReturned;
                case "HardwareError":
                    return CopyStatus.HardwareError;
                case "DeviceFormatted":
                    return CopyStatus.DeviceFormatted;
                case "DeviceMetadataModified":
                    return CopyStatus.DeviceMetadataModified;
                case "StorageAccountNotAccessible":
                    return CopyStatus.StorageAccountNotAccessible;
                case "UnsupportedData":
                    return CopyStatus.UnsupportedData;
            }
            return null;
        }
    }
}
