// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBox.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// DataBox Disk Copy Progress
    /// </summary>
    public partial class DataBoxDiskCopyProgress
    {
        /// <summary>
        /// Initializes a new instance of the DataBoxDiskCopyProgress class.
        /// </summary>
        public DataBoxDiskCopyProgress()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DataBoxDiskCopyProgress class.
        /// </summary>
        /// <param name="serialNumber">The serial number of the disk</param>
        /// <param name="bytesCopied">Bytes copied during the copy of
        /// disk.</param>
        /// <param name="percentComplete">Indicates the percentage completed
        /// for the copy of the disk.</param>
        /// <param name="status">The Status of the copy. Possible values
        /// include: 'NotStarted', 'InProgress', 'Completed',
        /// 'CompletedWithErrors', 'Failed', 'NotReturned', 'HardwareError',
        /// 'DeviceFormatted', 'DeviceMetadataModified',
        /// 'StorageAccountNotAccessible', 'UnsupportedData'</param>
        public DataBoxDiskCopyProgress(string serialNumber = default(string), long? bytesCopied = default(long?), int? percentComplete = default(int?), CopyStatus? status = default(CopyStatus?))
        {
            SerialNumber = serialNumber;
            BytesCopied = bytesCopied;
            PercentComplete = percentComplete;
            Status = status;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the serial number of the disk
        /// </summary>
        [JsonProperty(PropertyName = "serialNumber")]
        public string SerialNumber { get; private set; }

        /// <summary>
        /// Gets bytes copied during the copy of disk.
        /// </summary>
        [JsonProperty(PropertyName = "bytesCopied")]
        public long? BytesCopied { get; private set; }

        /// <summary>
        /// Gets indicates the percentage completed for the copy of the disk.
        /// </summary>
        [JsonProperty(PropertyName = "percentComplete")]
        public int? PercentComplete { get; private set; }

        /// <summary>
        /// Gets the Status of the copy. Possible values include: 'NotStarted',
        /// 'InProgress', 'Completed', 'CompletedWithErrors', 'Failed',
        /// 'NotReturned', 'HardwareError', 'DeviceFormatted',
        /// 'DeviceMetadataModified', 'StorageAccountNotAccessible',
        /// 'UnsupportedData'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public CopyStatus? Status { get; private set; }

    }
}
