// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBox.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Request to validate data destination details.
    /// </summary>
    [Newtonsoft.Json.JsonObject("ValidateDataDestinationDetails")]
    public partial class DataDestinationDetailsValidationRequest : ValidationInputRequest
    {
        /// <summary>
        /// Initializes a new instance of the
        /// DataDestinationDetailsValidationRequest class.
        /// </summary>
        public DataDestinationDetailsValidationRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// DataDestinationDetailsValidationRequest class.
        /// </summary>
        /// <param name="destinationAccountDetails">Destination account details
        /// list.</param>
        /// <param name="location">Location of stamp or geo.</param>
        public DataDestinationDetailsValidationRequest(IList<DestinationAccountDetails> destinationAccountDetails, string location)
        {
            DestinationAccountDetails = destinationAccountDetails;
            Location = location;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets destination account details list.
        /// </summary>
        [JsonProperty(PropertyName = "destinationAccountDetails")]
        public IList<DestinationAccountDetails> DestinationAccountDetails { get; set; }

        /// <summary>
        /// Gets or sets location of stamp or geo.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (DestinationAccountDetails == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DestinationAccountDetails");
            }
            if (Location == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Location");
            }
        }
    }
}
