// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBox.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Request body to get the availability for scheduling disk orders.
    /// </summary>
    [Newtonsoft.Json.JsonObject("DataBoxDisk")]
    public partial class DiskScheduleAvailabilityRequest : ScheduleAvailabilityRequest
    {
        /// <summary>
        /// Initializes a new instance of the DiskScheduleAvailabilityRequest
        /// class.
        /// </summary>
        public DiskScheduleAvailabilityRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DiskScheduleAvailabilityRequest
        /// class.
        /// </summary>
        /// <param name="storageLocation">Location for data transfer.
        /// For locations check:
        /// https://management.azure.com/subscriptions/SUBSCRIPTIONID/locations?api-version=2018-01-01</param>
        /// <param name="expectedDataSizeInTerabytes">The expected size of the
        /// data, which needs to be transferred in this job, in
        /// terabytes.</param>
        public DiskScheduleAvailabilityRequest(string storageLocation, int expectedDataSizeInTerabytes)
            : base(storageLocation)
        {
            ExpectedDataSizeInTerabytes = expectedDataSizeInTerabytes;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the expected size of the data, which needs to be
        /// transferred in this job, in terabytes.
        /// </summary>
        [JsonProperty(PropertyName = "expectedDataSizeInTerabytes")]
        public int ExpectedDataSizeInTerabytes { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
