// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBox.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Job details.
    /// </summary>
    public partial class JobDetails
    {
        /// <summary>
        /// Initializes a new instance of the JobDetails class.
        /// </summary>
        public JobDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JobDetails class.
        /// </summary>
        /// <param name="contactDetails">Contact details for notification and
        /// shipping.</param>
        /// <param name="shippingAddress">Shipping address of the
        /// customer.</param>
        /// <param name="destinationAccountDetails">Destination account
        /// details.</param>
        /// <param name="expectedDataSizeInTerabytes">The expected size of the
        /// data, which needs to be transferred in this job, in
        /// terabytes.</param>
        /// <param name="jobStages">List of stages that run in the job.</param>
        /// <param name="deliveryPackage">Delivery package shipping
        /// details.</param>
        /// <param name="returnPackage">Return package shipping
        /// details.</param>
        /// <param name="errorDetails">Error details for failure. This is
        /// optional.</param>
        /// <param name="preferences">Preferences for the order.</param>
        /// <param name="copyLogDetails">List of copy log details.</param>
        /// <param name="reverseShipmentLabelSasKey">Shared access key to
        /// download the return shipment label</param>
        /// <param name="chainOfCustodySasKey">Shared access key to download
        /// the chain of custody logs</param>
        public JobDetails(ContactDetails contactDetails, ShippingAddress shippingAddress, IList<DestinationAccountDetails> destinationAccountDetails, int? expectedDataSizeInTerabytes = default(int?), IList<JobStages> jobStages = default(IList<JobStages>), PackageShippingDetails deliveryPackage = default(PackageShippingDetails), PackageShippingDetails returnPackage = default(PackageShippingDetails), IList<JobErrorDetails> errorDetails = default(IList<JobErrorDetails>), Preferences preferences = default(Preferences), IList<CopyLogDetails> copyLogDetails = default(IList<CopyLogDetails>), string reverseShipmentLabelSasKey = default(string), string chainOfCustodySasKey = default(string))
        {
            ExpectedDataSizeInTerabytes = expectedDataSizeInTerabytes;
            JobStages = jobStages;
            ContactDetails = contactDetails;
            ShippingAddress = shippingAddress;
            DeliveryPackage = deliveryPackage;
            ReturnPackage = returnPackage;
            DestinationAccountDetails = destinationAccountDetails;
            ErrorDetails = errorDetails;
            Preferences = preferences;
            CopyLogDetails = copyLogDetails;
            ReverseShipmentLabelSasKey = reverseShipmentLabelSasKey;
            ChainOfCustodySasKey = chainOfCustodySasKey;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the expected size of the data, which needs to be
        /// transferred in this job, in terabytes.
        /// </summary>
        [JsonProperty(PropertyName = "expectedDataSizeInTerabytes")]
        public int? ExpectedDataSizeInTerabytes { get; set; }

        /// <summary>
        /// Gets list of stages that run in the job.
        /// </summary>
        [JsonProperty(PropertyName = "jobStages")]
        public IList<JobStages> JobStages { get; private set; }

        /// <summary>
        /// Gets or sets contact details for notification and shipping.
        /// </summary>
        [JsonProperty(PropertyName = "contactDetails")]
        public ContactDetails ContactDetails { get; set; }

        /// <summary>
        /// Gets or sets shipping address of the customer.
        /// </summary>
        [JsonProperty(PropertyName = "shippingAddress")]
        public ShippingAddress ShippingAddress { get; set; }

        /// <summary>
        /// Gets delivery package shipping details.
        /// </summary>
        [JsonProperty(PropertyName = "deliveryPackage")]
        public PackageShippingDetails DeliveryPackage { get; private set; }

        /// <summary>
        /// Gets return package shipping details.
        /// </summary>
        [JsonProperty(PropertyName = "returnPackage")]
        public PackageShippingDetails ReturnPackage { get; private set; }

        /// <summary>
        /// Gets or sets destination account details.
        /// </summary>
        [JsonProperty(PropertyName = "destinationAccountDetails")]
        public IList<DestinationAccountDetails> DestinationAccountDetails { get; set; }

        /// <summary>
        /// Gets error details for failure. This is optional.
        /// </summary>
        [JsonProperty(PropertyName = "errorDetails")]
        public IList<JobErrorDetails> ErrorDetails { get; private set; }

        /// <summary>
        /// Gets or sets preferences for the order.
        /// </summary>
        [JsonProperty(PropertyName = "preferences")]
        public Preferences Preferences { get; set; }

        /// <summary>
        /// Gets list of copy log details.
        /// </summary>
        [JsonProperty(PropertyName = "copyLogDetails")]
        public IList<CopyLogDetails> CopyLogDetails { get; private set; }

        /// <summary>
        /// Gets shared access key to download the return shipment label
        /// </summary>
        [JsonProperty(PropertyName = "reverseShipmentLabelSasKey")]
        public string ReverseShipmentLabelSasKey { get; private set; }

        /// <summary>
        /// Gets shared access key to download the chain of custody logs
        /// </summary>
        [JsonProperty(PropertyName = "chainOfCustodySasKey")]
        public string ChainOfCustodySasKey { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ContactDetails == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ContactDetails");
            }
            if (ShippingAddress == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ShippingAddress");
            }
            if (DestinationAccountDetails == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DestinationAccountDetails");
            }
            if (ContactDetails != null)
            {
                ContactDetails.Validate();
            }
            if (ShippingAddress != null)
            {
                ShippingAddress.Validate();
            }
            if (Preferences != null)
            {
                Preferences.Validate();
            }
        }
    }
}
