// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBox.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Request body to get the configuration for the region.
    /// </summary>
    public partial class RegionConfigurationRequest
    {
        /// <summary>
        /// Initializes a new instance of the RegionConfigurationRequest class.
        /// </summary>
        public RegionConfigurationRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RegionConfigurationRequest class.
        /// </summary>
        /// <param name="scheduleAvailabilityRequest">Request body to get the
        /// availability for scheduling orders.</param>
        /// <param name="transportAvailabilityRequest">Request body to get the
        /// transport availability for given sku.</param>
        public RegionConfigurationRequest(ScheduleAvailabilityRequest scheduleAvailabilityRequest = default(ScheduleAvailabilityRequest), TransportAvailabilityRequest transportAvailabilityRequest = default(TransportAvailabilityRequest))
        {
            ScheduleAvailabilityRequest = scheduleAvailabilityRequest;
            TransportAvailabilityRequest = transportAvailabilityRequest;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets request body to get the availability for scheduling
        /// orders.
        /// </summary>
        [JsonProperty(PropertyName = "scheduleAvailabilityRequest")]
        public ScheduleAvailabilityRequest ScheduleAvailabilityRequest { get; set; }

        /// <summary>
        /// Gets or sets request body to get the transport availability for
        /// given sku.
        /// </summary>
        [JsonProperty(PropertyName = "transportAvailabilityRequest")]
        public TransportAvailabilityRequest TransportAvailabilityRequest { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ScheduleAvailabilityRequest != null)
            {
                ScheduleAvailabilityRequest.Validate();
            }
        }
    }
}
