// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBox.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Response of pre job creation validations.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ValidationResponse
    {
        /// <summary>
        /// Initializes a new instance of the ValidationResponse class.
        /// </summary>
        public ValidationResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ValidationResponse class.
        /// </summary>
        /// <param name="status">Overall validation status. Possible values
        /// include: 'AllValidToProceed', 'InputsRevisitRequired',
        /// 'CertainInputValidationsSkipped'</param>
        /// <param name="individualResponseDetails">List of response details
        /// contain validationType and its response as key and value
        /// respectively.</param>
        public ValidationResponse(OverallValidationStatus? status = default(OverallValidationStatus?), IList<ValidationInputResponse> individualResponseDetails = default(IList<ValidationInputResponse>))
        {
            Status = status;
            IndividualResponseDetails = individualResponseDetails;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets overall validation status. Possible values include:
        /// 'AllValidToProceed', 'InputsRevisitRequired',
        /// 'CertainInputValidationsSkipped'
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public OverallValidationStatus? Status { get; private set; }

        /// <summary>
        /// Gets list of response details contain validationType and its
        /// response as key and value respectively.
        /// </summary>
        [JsonProperty(PropertyName = "properties.individualResponseDetails")]
        public IList<ValidationInputResponse> IndividualResponseDetails { get; private set; }

    }
}
