// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBoxEdge.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Contains all the contact details of the customer.
    /// </summary>
    public partial class ContactDetails
    {
        /// <summary>
        /// Initializes a new instance of the ContactDetails class.
        /// </summary>
        public ContactDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ContactDetails class.
        /// </summary>
        /// <param name="contactPerson">The contact person name.</param>
        /// <param name="companyName">The name of the company.</param>
        /// <param name="phone">The phone number.</param>
        /// <param name="emailList">The email list.</param>
        public ContactDetails(string contactPerson, string companyName, string phone, IList<string> emailList)
        {
            ContactPerson = contactPerson;
            CompanyName = companyName;
            Phone = phone;
            EmailList = emailList;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the contact person name.
        /// </summary>
        [JsonProperty(PropertyName = "contactPerson")]
        public string ContactPerson { get; set; }

        /// <summary>
        /// Gets or sets the name of the company.
        /// </summary>
        [JsonProperty(PropertyName = "companyName")]
        public string CompanyName { get; set; }

        /// <summary>
        /// Gets or sets the phone number.
        /// </summary>
        [JsonProperty(PropertyName = "phone")]
        public string Phone { get; set; }

        /// <summary>
        /// Gets or sets the email list.
        /// </summary>
        [JsonProperty(PropertyName = "emailList")]
        public IList<string> EmailList { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ContactPerson == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ContactPerson");
            }
            if (CompanyName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CompanyName");
            }
            if (Phone == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Phone");
            }
            if (EmailList == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "EmailList");
            }
        }
    }
}
