// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataBoxEdge.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The restrictions because of which SKU cannot be used.
    /// </summary>
    public partial class SkuRestriction
    {
        /// <summary>
        /// Initializes a new instance of the SkuRestriction class.
        /// </summary>
        public SkuRestriction()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SkuRestriction class.
        /// </summary>
        /// <param name="type">The type of the restriction.</param>
        /// <param name="values">The locations where sku is restricted.</param>
        /// <param name="reasonCode">The SKU restriction reason. Possible
        /// values include: 'NotAvailableForSubscription', 'QuotaId'</param>
        /// <param name="restrictionInfo">Restriction of the SKU for the
        /// location/zone</param>
        public SkuRestriction(string type = default(string), IList<string> values = default(IList<string>), string reasonCode = default(string), SkuRestrictionInfo restrictionInfo = default(SkuRestrictionInfo))
        {
            Type = type;
            Values = values;
            ReasonCode = reasonCode;
            RestrictionInfo = restrictionInfo;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the type of the restriction.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

        /// <summary>
        /// Gets the locations where sku is restricted.
        /// </summary>
        [JsonProperty(PropertyName = "values")]
        public IList<string> Values { get; private set; }

        /// <summary>
        /// Gets the SKU restriction reason. Possible values include:
        /// 'NotAvailableForSubscription', 'QuotaId'
        /// </summary>
        [JsonProperty(PropertyName = "reasonCode")]
        public string ReasonCode { get; private set; }

        /// <summary>
        /// Gets restriction of the SKU for the location/zone
        /// </summary>
        [JsonProperty(PropertyName = "restrictionInfo")]
        public SkuRestrictionInfo RestrictionInfo { get; private set; }

    }
}
