// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ActivityRunsOperations.
    /// </summary>
    public static partial class ActivityRunsOperationsExtensions
    {
            /// <summary>
            /// Query activity runs based on input filter conditions.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='factoryName'>
            /// The factory name.
            /// </param>
            /// <param name='runId'>
            /// The pipeline run identifier.
            /// </param>
            /// <param name='filterParameters'>
            /// Parameters to filter the activity runs.
            /// </param>
            public static ActivityRunsQueryResponse QueryByPipelineRun(this IActivityRunsOperations operations, string resourceGroupName, string factoryName, string runId, RunFilterParameters filterParameters)
            {
                return operations.QueryByPipelineRunAsync(resourceGroupName, factoryName, runId, filterParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Query activity runs based on input filter conditions.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='factoryName'>
            /// The factory name.
            /// </param>
            /// <param name='runId'>
            /// The pipeline run identifier.
            /// </param>
            /// <param name='filterParameters'>
            /// Parameters to filter the activity runs.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ActivityRunsQueryResponse> QueryByPipelineRunAsync(this IActivityRunsOperations operations, string resourceGroupName, string factoryName, string runId, RunFilterParameters filterParameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.QueryByPipelineRunWithHttpMessagesAsync(resourceGroupName, factoryName, runId, filterParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
