// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A copy activity Azure Data Explorer sink.
    /// </summary>
    public partial class AzureDataExplorerSink : CopySink
    {
        /// <summary>
        /// Initializes a new instance of the AzureDataExplorerSink class.
        /// </summary>
        public AzureDataExplorerSink()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureDataExplorerSink class.
        /// </summary>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="writeBatchSize">Write batch size. Type: integer (or
        /// Expression with resultType integer), minimum: 0.</param>
        /// <param name="writeBatchTimeout">Write batch timeout. Type: string
        /// (or Expression with resultType string), pattern:
        /// ((\d+)\.)?(\d\d):(60|([0-5][0-9])):(60|([0-5][0-9])).</param>
        /// <param name="sinkRetryCount">Sink retry count. Type: integer (or
        /// Expression with resultType integer).</param>
        /// <param name="sinkRetryWait">Sink retry wait. Type: string (or
        /// Expression with resultType string), pattern:
        /// ((\d+)\.)?(\d\d):(60|([0-5][0-9])):(60|([0-5][0-9])).</param>
        /// <param name="maxConcurrentConnections">The maximum concurrent
        /// connection count for the sink data store. Type: integer (or
        /// Expression with resultType integer).</param>
        /// <param name="ingestionMappingName">A name of a pre-created csv
        /// mapping that was defined on the target Kusto table. Type:
        /// string.</param>
        /// <param name="ingestionMappingAsJson">An explicit column mapping
        /// description provided in a json format. Type: string.</param>
        /// <param name="flushImmediately">If set to true, any aggregation will
        /// be skipped. Default is false. Type: boolean.</param>
        public AzureDataExplorerSink(IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), object writeBatchSize = default(object), object writeBatchTimeout = default(object), object sinkRetryCount = default(object), object sinkRetryWait = default(object), object maxConcurrentConnections = default(object), object ingestionMappingName = default(object), object ingestionMappingAsJson = default(object), object flushImmediately = default(object))
            : base(additionalProperties, writeBatchSize, writeBatchTimeout, sinkRetryCount, sinkRetryWait, maxConcurrentConnections)
        {
            IngestionMappingName = ingestionMappingName;
            IngestionMappingAsJson = ingestionMappingAsJson;
            FlushImmediately = flushImmediately;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a name of a pre-created csv mapping that was defined
        /// on the target Kusto table. Type: string.
        /// </summary>
        [JsonProperty(PropertyName = "ingestionMappingName")]
        public object IngestionMappingName { get; set; }

        /// <summary>
        /// Gets or sets an explicit column mapping description provided in a
        /// json format. Type: string.
        /// </summary>
        [JsonProperty(PropertyName = "ingestionMappingAsJson")]
        public object IngestionMappingAsJson { get; set; }

        /// <summary>
        /// Gets or sets if set to true, any aggregation will be skipped.
        /// Default is false. Type: boolean.
        /// </summary>
        [JsonProperty(PropertyName = "flushImmediately")]
        public object FlushImmediately { get; set; }

    }
}
