// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Trigger that runs every time the selected Blob container changes.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class BlobTrigger : MultiplePipelineTrigger
    {
        /// <summary>
        /// Initializes a new instance of the BlobTrigger class.
        /// </summary>
        public BlobTrigger()
        {
            LinkedService = new LinkedServiceReference();
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BlobTrigger class.
        /// </summary>
        /// <param name="folderPath">The path of the container/folder that will
        /// trigger the pipeline.</param>
        /// <param name="maxConcurrency">The max number of parallel files to
        /// handle when it is triggered.</param>
        /// <param name="linkedService">The Azure Storage linked service
        /// reference.</param>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="description">Trigger description.</param>
        /// <param name="runtimeState">Indicates if trigger is running or not.
        /// Updated when Start/Stop APIs are called on the Trigger. Possible
        /// values include: 'Started', 'Stopped', 'Disabled'</param>
        /// <param name="annotations">List of tags that can be used for
        /// describing the trigger.</param>
        /// <param name="pipelines">Pipelines that need to be started.</param>
        public BlobTrigger(string folderPath, int maxConcurrency, LinkedServiceReference linkedService, IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), string description = default(string), string runtimeState = default(string), IList<object> annotations = default(IList<object>), IList<TriggerPipelineReference> pipelines = default(IList<TriggerPipelineReference>))
            : base(additionalProperties, description, runtimeState, annotations, pipelines)
        {
            FolderPath = folderPath;
            MaxConcurrency = maxConcurrency;
            LinkedService = linkedService;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the path of the container/folder that will trigger the
        /// pipeline.
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.folderPath")]
        public string FolderPath { get; set; }

        /// <summary>
        /// Gets or sets the max number of parallel files to handle when it is
        /// triggered.
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.maxConcurrency")]
        public int MaxConcurrency { get; set; }

        /// <summary>
        /// Gets or sets the Azure Storage linked service reference.
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.linkedService")]
        public LinkedServiceReference LinkedService { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (FolderPath == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "FolderPath");
            }
            if (LinkedService == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LinkedService");
            }
            if (LinkedService != null)
            {
                LinkedService.Validate();
            }
        }
    }
}
