// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Linked service for CosmosDB (MongoDB API) data source.
    /// </summary>
    [Newtonsoft.Json.JsonObject("CosmosDbMongoDbApi")]
    [Rest.Serialization.JsonTransformation]
    public partial class CosmosDbMongoDbApiLinkedService : LinkedService
    {
        /// <summary>
        /// Initializes a new instance of the CosmosDbMongoDbApiLinkedService
        /// class.
        /// </summary>
        public CosmosDbMongoDbApiLinkedService()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CosmosDbMongoDbApiLinkedService
        /// class.
        /// </summary>
        /// <param name="connectionString">The CosmosDB (MongoDB API)
        /// connection string. Type: string, SecureString or
        /// AzureKeyVaultSecretReference. Type: string, SecureString or
        /// AzureKeyVaultSecretReference.</param>
        /// <param name="database">The name of the CosmosDB (MongoDB API)
        /// database that you want to access. Type: string (or Expression with
        /// resultType string).</param>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="connectVia">The integration runtime reference.</param>
        /// <param name="description">Linked service description.</param>
        /// <param name="parameters">Parameters for linked service.</param>
        /// <param name="annotations">List of tags that can be used for
        /// describing the linked service.</param>
        public CosmosDbMongoDbApiLinkedService(object connectionString, object database, IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), IntegrationRuntimeReference connectVia = default(IntegrationRuntimeReference), string description = default(string), IDictionary<string, ParameterSpecification> parameters = default(IDictionary<string, ParameterSpecification>), IList<object> annotations = default(IList<object>))
            : base(additionalProperties, connectVia, description, parameters, annotations)
        {
            ConnectionString = connectionString;
            Database = database;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the CosmosDB (MongoDB API) connection string. Type:
        /// string, SecureString or AzureKeyVaultSecretReference. Type: string,
        /// SecureString or AzureKeyVaultSecretReference.
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.connectionString")]
        public object ConnectionString { get; set; }

        /// <summary>
        /// Gets or sets the name of the CosmosDB (MongoDB API) database that
        /// you want to access. Type: string (or Expression with resultType
        /// string).
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.database")]
        public object Database { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (ConnectionString == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ConnectionString");
            }
            if (Database == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Database");
            }
        }
    }
}
