// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// DW Copy Command settings.
    /// </summary>
    public partial class DWCopyCommandSettings
    {
        /// <summary>
        /// Initializes a new instance of the DWCopyCommandSettings class.
        /// </summary>
        public DWCopyCommandSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DWCopyCommandSettings class.
        /// </summary>
        /// <param name="defaultValues">Specifies the default values for each
        /// target column in SQL DW. The default values in the property
        /// overwrite the DEFAULT constraint set in the DB, and identity column
        /// cannot have a default value. Type: array of objects (or Expression
        /// with resultType array of objects).</param>
        /// <param name="additionalOptions">Additional options directly passed
        /// to SQL DW in Copy Command. Type: key value pairs (value should be
        /// string type) (or Expression with resultType object). Example:
        /// "additionalOptions": { "MAXERRORS": "1000", "DATEFORMAT": "'ymd'"
        /// }</param>
        public DWCopyCommandSettings(IList<DWCopyCommandDefaultValue> defaultValues = default(IList<DWCopyCommandDefaultValue>), IDictionary<string, string> additionalOptions = default(IDictionary<string, string>))
        {
            DefaultValues = defaultValues;
            AdditionalOptions = additionalOptions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies the default values for each target column in
        /// SQL DW. The default values in the property overwrite the DEFAULT
        /// constraint set in the DB, and identity column cannot have a default
        /// value. Type: array of objects (or Expression with resultType array
        /// of objects).
        /// </summary>
        [JsonProperty(PropertyName = "defaultValues")]
        public IList<DWCopyCommandDefaultValue> DefaultValues { get; set; }

        /// <summary>
        /// Gets or sets additional options directly passed to SQL DW in Copy
        /// Command. Type: key value pairs (value should be string type) (or
        /// Expression with resultType object). Example: "additionalOptions": {
        /// "MAXERRORS": "1000", "DATEFORMAT": "'ymd'" }
        /// </summary>
        [JsonProperty(PropertyName = "additionalOptions")]
        public IDictionary<string, string> AdditionalOptions { get; set; }

    }
}
