// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Data flow debug session info.
    /// </summary>
    public partial class DataFlowDebugSessionInfo
    {
        /// <summary>
        /// Initializes a new instance of the DataFlowDebugSessionInfo class.
        /// </summary>
        public DataFlowDebugSessionInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DataFlowDebugSessionInfo class.
        /// </summary>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="dataFlowName">The name of the data flow.</param>
        /// <param name="computeType">Compute type of the cluster.</param>
        /// <param name="coreCount">Core count of the cluster.</param>
        /// <param name="nodeCount">Node count of the cluster. (deprecated
        /// property)</param>
        /// <param name="integrationRuntimeName">Attached integration runtime
        /// name of data flow debug session.</param>
        /// <param name="sessionId">The ID of data flow debug session.</param>
        /// <param name="startTime">Start time of data flow debug
        /// session.</param>
        /// <param name="timeToLiveInMinutes">Compute type of the
        /// cluster.</param>
        /// <param name="lastActivityTime">Last activity time of data flow
        /// debug session.</param>
        public DataFlowDebugSessionInfo(IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), string dataFlowName = default(string), string computeType = default(string), int? coreCount = default(int?), int? nodeCount = default(int?), string integrationRuntimeName = default(string), string sessionId = default(string), string startTime = default(string), int? timeToLiveInMinutes = default(int?), string lastActivityTime = default(string))
        {
            AdditionalProperties = additionalProperties;
            DataFlowName = dataFlowName;
            ComputeType = computeType;
            CoreCount = coreCount;
            NodeCount = nodeCount;
            IntegrationRuntimeName = integrationRuntimeName;
            SessionId = sessionId;
            StartTime = startTime;
            TimeToLiveInMinutes = timeToLiveInMinutes;
            LastActivityTime = lastActivityTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets unmatched properties from the message are deserialized
        /// this collection
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalProperties { get; set; }

        /// <summary>
        /// Gets or sets the name of the data flow.
        /// </summary>
        [JsonProperty(PropertyName = "dataFlowName")]
        public string DataFlowName { get; set; }

        /// <summary>
        /// Gets or sets compute type of the cluster.
        /// </summary>
        [JsonProperty(PropertyName = "computeType")]
        public string ComputeType { get; set; }

        /// <summary>
        /// Gets or sets core count of the cluster.
        /// </summary>
        [JsonProperty(PropertyName = "coreCount")]
        public int? CoreCount { get; set; }

        /// <summary>
        /// Gets or sets node count of the cluster. (deprecated property)
        /// </summary>
        [JsonProperty(PropertyName = "nodeCount")]
        public int? NodeCount { get; set; }

        /// <summary>
        /// Gets or sets attached integration runtime name of data flow debug
        /// session.
        /// </summary>
        [JsonProperty(PropertyName = "integrationRuntimeName")]
        public string IntegrationRuntimeName { get; set; }

        /// <summary>
        /// Gets or sets the ID of data flow debug session.
        /// </summary>
        [JsonProperty(PropertyName = "sessionId")]
        public string SessionId { get; set; }

        /// <summary>
        /// Gets or sets start time of data flow debug session.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public string StartTime { get; set; }

        /// <summary>
        /// Gets or sets compute type of the cluster.
        /// </summary>
        [JsonProperty(PropertyName = "timeToLiveInMinutes")]
        public int? TimeToLiveInMinutes { get; set; }

        /// <summary>
        /// Gets or sets last activity time of data flow debug session.
        /// </summary>
        [JsonProperty(PropertyName = "lastActivityTime")]
        public string LastActivityTime { get; set; }

    }
}
