// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Distcp settings.
    /// </summary>
    public partial class DistcpSettings
    {
        /// <summary>
        /// Initializes a new instance of the DistcpSettings class.
        /// </summary>
        public DistcpSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DistcpSettings class.
        /// </summary>
        /// <param name="resourceManagerEndpoint">Specifies the Yarn
        /// ResourceManager endpoint. Type: string (or Expression with
        /// resultType string).</param>
        /// <param name="tempScriptPath">Specifies an existing folder path
        /// which will be used to store temp Distcp command script. The script
        /// file is generated by ADF and will be removed after Copy job
        /// finished. Type: string (or Expression with resultType
        /// string).</param>
        /// <param name="distcpOptions">Specifies the Distcp options. Type:
        /// string (or Expression with resultType string).</param>
        public DistcpSettings(object resourceManagerEndpoint, object tempScriptPath, object distcpOptions = default(object))
        {
            ResourceManagerEndpoint = resourceManagerEndpoint;
            TempScriptPath = tempScriptPath;
            DistcpOptions = distcpOptions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies the Yarn ResourceManager endpoint. Type:
        /// string (or Expression with resultType string).
        /// </summary>
        [JsonProperty(PropertyName = "resourceManagerEndpoint")]
        public object ResourceManagerEndpoint { get; set; }

        /// <summary>
        /// Gets or sets specifies an existing folder path which will be used
        /// to store temp Distcp command script. The script file is generated
        /// by ADF and will be removed after Copy job finished. Type: string
        /// (or Expression with resultType string).
        /// </summary>
        [JsonProperty(PropertyName = "tempScriptPath")]
        public object TempScriptPath { get; set; }

        /// <summary>
        /// Gets or sets specifies the Distcp options. Type: string (or
        /// Expression with resultType string).
        /// </summary>
        [JsonProperty(PropertyName = "distcpOptions")]
        public object DistcpOptions { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ResourceManagerEndpoint == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ResourceManagerEndpoint");
            }
            if (TempScriptPath == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TempScriptPath");
            }
        }
    }
}
