// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Execute data flow activity.
    /// </summary>
    [Newtonsoft.Json.JsonObject("ExecuteDataFlow")]
    [Rest.Serialization.JsonTransformation]
    public partial class ExecuteDataFlowActivity : ExecutionActivity
    {
        /// <summary>
        /// Initializes a new instance of the ExecuteDataFlowActivity class.
        /// </summary>
        public ExecuteDataFlowActivity()
        {
            DataFlow = new DataFlowReference();
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ExecuteDataFlowActivity class.
        /// </summary>
        /// <param name="name">Activity name.</param>
        /// <param name="dataFlow">Data flow reference.</param>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="description">Activity description.</param>
        /// <param name="dependsOn">Activity depends on condition.</param>
        /// <param name="userProperties">Activity user properties.</param>
        /// <param name="linkedServiceName">Linked service reference.</param>
        /// <param name="policy">Activity policy.</param>
        /// <param name="staging">Staging info for execute data flow
        /// activity.</param>
        /// <param name="integrationRuntime">The integration runtime
        /// reference.</param>
        /// <param name="compute">Compute properties for data flow
        /// activity.</param>
        public ExecuteDataFlowActivity(string name, DataFlowReference dataFlow, IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), string description = default(string), IList<ActivityDependency> dependsOn = default(IList<ActivityDependency>), IList<UserProperty> userProperties = default(IList<UserProperty>), LinkedServiceReference linkedServiceName = default(LinkedServiceReference), ActivityPolicy policy = default(ActivityPolicy), DataFlowStagingInfo staging = default(DataFlowStagingInfo), IntegrationRuntimeReference integrationRuntime = default(IntegrationRuntimeReference), ExecuteDataFlowActivityTypePropertiesCompute compute = default(ExecuteDataFlowActivityTypePropertiesCompute))
            : base(name, additionalProperties, description, dependsOn, userProperties, linkedServiceName, policy)
        {
            DataFlow = dataFlow;
            Staging = staging;
            IntegrationRuntime = integrationRuntime;
            Compute = compute;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets data flow reference.
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.dataFlow")]
        public DataFlowReference DataFlow { get; set; }

        /// <summary>
        /// Gets or sets staging info for execute data flow activity.
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.staging")]
        public DataFlowStagingInfo Staging { get; set; }

        /// <summary>
        /// Gets or sets the integration runtime reference.
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.integrationRuntime")]
        public IntegrationRuntimeReference IntegrationRuntime { get; set; }

        /// <summary>
        /// Gets or sets compute properties for data flow activity.
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.compute")]
        public ExecuteDataFlowActivityTypePropertiesCompute Compute { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (DataFlow == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DataFlow");
            }
            if (DataFlow != null)
            {
                DataFlow.Validate();
            }
            if (Staging != null)
            {
                Staging.Validate();
            }
            if (IntegrationRuntime != null)
            {
                IntegrationRuntime.Validate();
            }
        }
    }
}
