// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Compute properties for data flow activity.
    /// </summary>
    public partial class ExecuteDataFlowActivityTypePropertiesCompute
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ExecuteDataFlowActivityTypePropertiesCompute class.
        /// </summary>
        public ExecuteDataFlowActivityTypePropertiesCompute()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ExecuteDataFlowActivityTypePropertiesCompute class.
        /// </summary>
        /// <param name="computeType">Compute type of the cluster which will
        /// execute data flow job. Possible values include: 'General',
        /// 'MemoryOptimized', 'ComputeOptimized'</param>
        /// <param name="coreCount">Core count of the cluster which will
        /// execute data flow job. Supported values are: 8, 16, 32, 48, 80, 144
        /// and 272.</param>
        public ExecuteDataFlowActivityTypePropertiesCompute(string computeType = default(string), int? coreCount = default(int?))
        {
            ComputeType = computeType;
            CoreCount = coreCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets compute type of the cluster which will execute data
        /// flow job. Possible values include: 'General', 'MemoryOptimized',
        /// 'ComputeOptimized'
        /// </summary>
        [JsonProperty(PropertyName = "computeType")]
        public string ComputeType { get; set; }

        /// <summary>
        /// Gets or sets core count of the cluster which will execute data flow
        /// job. Supported values are: 8, 16, 32, 48, 80, 144 and 272.
        /// </summary>
        [JsonProperty(PropertyName = "coreCount")]
        public int? CoreCount { get; set; }

    }
}
