// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Custom setup script properties for a managed dedicated integration
    /// runtime.
    /// </summary>
    public partial class IntegrationRuntimeCustomSetupScriptProperties
    {
        /// <summary>
        /// Initializes a new instance of the
        /// IntegrationRuntimeCustomSetupScriptProperties class.
        /// </summary>
        public IntegrationRuntimeCustomSetupScriptProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// IntegrationRuntimeCustomSetupScriptProperties class.
        /// </summary>
        /// <param name="blobContainerUri">The URI of the Azure blob container
        /// that contains the custom setup script.</param>
        /// <param name="sasToken">The SAS token of the Azure blob
        /// container.</param>
        public IntegrationRuntimeCustomSetupScriptProperties(string blobContainerUri = default(string), SecureString sasToken = default(SecureString))
        {
            BlobContainerUri = blobContainerUri;
            SasToken = sasToken;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the URI of the Azure blob container that contains the
        /// custom setup script.
        /// </summary>
        [JsonProperty(PropertyName = "blobContainerUri")]
        public string BlobContainerUri { get; set; }

        /// <summary>
        /// Gets or sets the SAS token of the Azure blob container.
        /// </summary>
        [JsonProperty(PropertyName = "sasToken")]
        public SecureString SasToken { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SasToken != null)
            {
                SasToken.Validate();
            }
        }
    }
}
