// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The linked integration runtime information.
    /// </summary>
    public partial class LinkedIntegrationRuntime
    {
        /// <summary>
        /// Initializes a new instance of the LinkedIntegrationRuntime class.
        /// </summary>
        public LinkedIntegrationRuntime()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the LinkedIntegrationRuntime class.
        /// </summary>
        /// <param name="name">The name of the linked integration
        /// runtime.</param>
        /// <param name="subscriptionId">The subscription ID for which the
        /// linked integration runtime belong to.</param>
        /// <param name="dataFactoryName">The name of the data factory for
        /// which the linked integration runtime belong to.</param>
        /// <param name="dataFactoryLocation">The location of the data factory
        /// for which the linked integration runtime belong to.</param>
        /// <param name="createTime">The creating time of the linked
        /// integration runtime.</param>
        public LinkedIntegrationRuntime(string name = default(string), string subscriptionId = default(string), string dataFactoryName = default(string), string dataFactoryLocation = default(string), System.DateTime? createTime = default(System.DateTime?))
        {
            Name = name;
            SubscriptionId = subscriptionId;
            DataFactoryName = dataFactoryName;
            DataFactoryLocation = dataFactoryLocation;
            CreateTime = createTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the name of the linked integration runtime.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets the subscription ID for which the linked integration runtime
        /// belong to.
        /// </summary>
        [JsonProperty(PropertyName = "subscriptionId")]
        public string SubscriptionId { get; private set; }

        /// <summary>
        /// Gets the name of the data factory for which the linked integration
        /// runtime belong to.
        /// </summary>
        [JsonProperty(PropertyName = "dataFactoryName")]
        public string DataFactoryName { get; private set; }

        /// <summary>
        /// Gets the location of the data factory for which the linked
        /// integration runtime belong to.
        /// </summary>
        [JsonProperty(PropertyName = "dataFactoryLocation")]
        public string DataFactoryLocation { get; private set; }

        /// <summary>
        /// Gets the creating time of the linked integration runtime.
        /// </summary>
        [JsonProperty(PropertyName = "createTime")]
        public System.DateTime? CreateTime { get; private set; }

    }
}
