// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Office365 linked service.
    /// </summary>
    [Newtonsoft.Json.JsonObject("Office365")]
    [Rest.Serialization.JsonTransformation]
    public partial class Office365LinkedService : LinkedService
    {
        /// <summary>
        /// Initializes a new instance of the Office365LinkedService class.
        /// </summary>
        public Office365LinkedService()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Office365LinkedService class.
        /// </summary>
        /// <param name="office365TenantId">Azure tenant ID to which the Office
        /// 365 account belongs. Type: string (or Expression with resultType
        /// string).</param>
        /// <param name="servicePrincipalTenantId">Specify the tenant
        /// information under which your Azure AD web application resides.
        /// Type: string (or Expression with resultType string).</param>
        /// <param name="servicePrincipalId">Specify the application's client
        /// ID. Type: string (or Expression with resultType string).</param>
        /// <param name="servicePrincipalKey">Specify the application's
        /// key.</param>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="connectVia">The integration runtime reference.</param>
        /// <param name="description">Linked service description.</param>
        /// <param name="parameters">Parameters for linked service.</param>
        /// <param name="annotations">List of tags that can be used for
        /// describing the linked service.</param>
        /// <param name="encryptedCredential">The encrypted credential used for
        /// authentication. Credentials are encrypted using the integration
        /// runtime credential manager. Type: string (or Expression with
        /// resultType string).</param>
        public Office365LinkedService(object office365TenantId, object servicePrincipalTenantId, object servicePrincipalId, SecretBase servicePrincipalKey, IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), IntegrationRuntimeReference connectVia = default(IntegrationRuntimeReference), string description = default(string), IDictionary<string, ParameterSpecification> parameters = default(IDictionary<string, ParameterSpecification>), IList<object> annotations = default(IList<object>), object encryptedCredential = default(object))
            : base(additionalProperties, connectVia, description, parameters, annotations)
        {
            Office365TenantId = office365TenantId;
            ServicePrincipalTenantId = servicePrincipalTenantId;
            ServicePrincipalId = servicePrincipalId;
            ServicePrincipalKey = servicePrincipalKey;
            EncryptedCredential = encryptedCredential;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets azure tenant ID to which the Office 365 account
        /// belongs. Type: string (or Expression with resultType string).
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.office365TenantId")]
        public object Office365TenantId { get; set; }

        /// <summary>
        /// Gets or sets specify the tenant information under which your Azure
        /// AD web application resides. Type: string (or Expression with
        /// resultType string).
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.servicePrincipalTenantId")]
        public object ServicePrincipalTenantId { get; set; }

        /// <summary>
        /// Gets or sets specify the application's client ID. Type: string (or
        /// Expression with resultType string).
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.servicePrincipalId")]
        public object ServicePrincipalId { get; set; }

        /// <summary>
        /// Gets or sets specify the application's key.
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.servicePrincipalKey")]
        public SecretBase ServicePrincipalKey { get; set; }

        /// <summary>
        /// Gets or sets the encrypted credential used for authentication.
        /// Credentials are encrypted using the integration runtime credential
        /// manager. Type: string (or Expression with resultType string).
        /// </summary>
        [JsonProperty(PropertyName = "typeProperties.encryptedCredential")]
        public object EncryptedCredential { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (Office365TenantId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Office365TenantId");
            }
            if (ServicePrincipalTenantId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ServicePrincipalTenantId");
            }
            if (ServicePrincipalId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ServicePrincipalId");
            }
            if (ServicePrincipalKey == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ServicePrincipalKey");
            }
        }
    }
}
