// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Details about an operation related to metrics.
    /// </summary>
    public partial class OperationMetricSpecification
    {
        /// <summary>
        /// Initializes a new instance of the OperationMetricSpecification
        /// class.
        /// </summary>
        public OperationMetricSpecification()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OperationMetricSpecification
        /// class.
        /// </summary>
        /// <param name="name">The name of the metric.</param>
        /// <param name="displayName">Localized display name of the
        /// metric.</param>
        /// <param name="displayDescription">The description of the
        /// metric.</param>
        /// <param name="unit">The unit that the metric is measured in.</param>
        /// <param name="aggregationType">The type of metric
        /// aggregation.</param>
        /// <param name="enableRegionalMdmAccount">Whether or not the service
        /// is using regional MDM accounts.</param>
        /// <param name="sourceMdmAccount">The name of the MDM account.</param>
        /// <param name="sourceMdmNamespace">The name of the MDM
        /// namespace.</param>
        /// <param name="availabilities">Defines how often data for metrics
        /// becomes available.</param>
        /// <param name="dimensions">Defines the metric dimension.</param>
        public OperationMetricSpecification(string name = default(string), string displayName = default(string), string displayDescription = default(string), string unit = default(string), string aggregationType = default(string), string enableRegionalMdmAccount = default(string), string sourceMdmAccount = default(string), string sourceMdmNamespace = default(string), IList<OperationMetricAvailability> availabilities = default(IList<OperationMetricAvailability>), IList<OperationMetricDimension> dimensions = default(IList<OperationMetricDimension>))
        {
            Name = name;
            DisplayName = displayName;
            DisplayDescription = displayDescription;
            Unit = unit;
            AggregationType = aggregationType;
            EnableRegionalMdmAccount = enableRegionalMdmAccount;
            SourceMdmAccount = sourceMdmAccount;
            SourceMdmNamespace = sourceMdmNamespace;
            Availabilities = availabilities;
            Dimensions = dimensions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the metric.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets localized display name of the metric.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the description of the metric.
        /// </summary>
        [JsonProperty(PropertyName = "displayDescription")]
        public string DisplayDescription { get; set; }

        /// <summary>
        /// Gets or sets the unit that the metric is measured in.
        /// </summary>
        [JsonProperty(PropertyName = "unit")]
        public string Unit { get; set; }

        /// <summary>
        /// Gets or sets the type of metric aggregation.
        /// </summary>
        [JsonProperty(PropertyName = "aggregationType")]
        public string AggregationType { get; set; }

        /// <summary>
        /// Gets or sets whether or not the service is using regional MDM
        /// accounts.
        /// </summary>
        [JsonProperty(PropertyName = "enableRegionalMdmAccount")]
        public string EnableRegionalMdmAccount { get; set; }

        /// <summary>
        /// Gets or sets the name of the MDM account.
        /// </summary>
        [JsonProperty(PropertyName = "sourceMdmAccount")]
        public string SourceMdmAccount { get; set; }

        /// <summary>
        /// Gets or sets the name of the MDM namespace.
        /// </summary>
        [JsonProperty(PropertyName = "sourceMdmNamespace")]
        public string SourceMdmNamespace { get; set; }

        /// <summary>
        /// Gets or sets defines how often data for metrics becomes available.
        /// </summary>
        [JsonProperty(PropertyName = "availabilities")]
        public IList<OperationMetricAvailability> Availabilities { get; set; }

        /// <summary>
        /// Gets or sets defines the metric dimension.
        /// </summary>
        [JsonProperty(PropertyName = "dimensions")]
        public IList<OperationMetricDimension> Dimensions { get; set; }

    }
}
