// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Redirect incompatible row settings
    /// </summary>
    public partial class RedirectIncompatibleRowSettings
    {
        /// <summary>
        /// Initializes a new instance of the RedirectIncompatibleRowSettings
        /// class.
        /// </summary>
        public RedirectIncompatibleRowSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RedirectIncompatibleRowSettings
        /// class.
        /// </summary>
        /// <param name="linkedServiceName">Name of the Azure Storage, Storage
        /// SAS, or Azure Data Lake Store linked service used for redirecting
        /// incompatible row. Must be specified if
        /// redirectIncompatibleRowSettings is specified. Type: string (or
        /// Expression with resultType string).</param>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="path">The path for storing the redirect incompatible
        /// row data. Type: string (or Expression with resultType
        /// string).</param>
        public RedirectIncompatibleRowSettings(object linkedServiceName, IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), object path = default(object))
        {
            AdditionalProperties = additionalProperties;
            LinkedServiceName = linkedServiceName;
            Path = path;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets unmatched properties from the message are deserialized
        /// this collection
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalProperties { get; set; }

        /// <summary>
        /// Gets or sets name of the Azure Storage, Storage SAS, or Azure Data
        /// Lake Store linked service used for redirecting incompatible row.
        /// Must be specified if redirectIncompatibleRowSettings is specified.
        /// Type: string (or Expression with resultType string).
        /// </summary>
        [JsonProperty(PropertyName = "linkedServiceName")]
        public object LinkedServiceName { get; set; }

        /// <summary>
        /// Gets or sets the path for storing the redirect incompatible row
        /// data. Type: string (or Expression with resultType string).
        /// </summary>
        [JsonProperty(PropertyName = "path")]
        public object Path { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (LinkedServiceName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LinkedServiceName");
            }
        }
    }
}
