// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A copy activity source for SAP Business Warehouse Open Hub Destination
    /// source.
    /// </summary>
    public partial class SapOpenHubSource : TabularSource
    {
        /// <summary>
        /// Initializes a new instance of the SapOpenHubSource class.
        /// </summary>
        public SapOpenHubSource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SapOpenHubSource class.
        /// </summary>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="sourceRetryCount">Source retry count. Type: integer
        /// (or Expression with resultType integer).</param>
        /// <param name="sourceRetryWait">Source retry wait. Type: string (or
        /// Expression with resultType string), pattern:
        /// ((\d+)\.)?(\d\d):(60|([0-5][0-9])):(60|([0-5][0-9])).</param>
        /// <param name="maxConcurrentConnections">The maximum concurrent
        /// connection count for the source data store. Type: integer (or
        /// Expression with resultType integer).</param>
        /// <param name="queryTimeout">Query timeout. Type: string (or
        /// Expression with resultType string), pattern:
        /// ((\d+)\.)?(\d\d):(60|([0-5][0-9])):(60|([0-5][0-9])).</param>
        /// <param name="excludeLastRequest">Whether to exclude the records of
        /// the last request. The default value is true. Type: boolean (or
        /// Expression with resultType boolean).</param>
        /// <param name="baseRequestId">The ID of request for delta loading.
        /// Once it is set, only data with requestId larger than the value of
        /// this property will be retrieved. The default value is 0. Type:
        /// integer (or Expression with resultType integer ).</param>
        public SapOpenHubSource(IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), object sourceRetryCount = default(object), object sourceRetryWait = default(object), object maxConcurrentConnections = default(object), object queryTimeout = default(object), object excludeLastRequest = default(object), object baseRequestId = default(object))
            : base(additionalProperties, sourceRetryCount, sourceRetryWait, maxConcurrentConnections, queryTimeout)
        {
            ExcludeLastRequest = excludeLastRequest;
            BaseRequestId = baseRequestId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets whether to exclude the records of the last request.
        /// The default value is true. Type: boolean (or Expression with
        /// resultType boolean).
        /// </summary>
        [JsonProperty(PropertyName = "excludeLastRequest")]
        public object ExcludeLastRequest { get; set; }

        /// <summary>
        /// Gets or sets the ID of request for delta loading. Once it is set,
        /// only data with requestId larger than the value of this property
        /// will be retrieved. The default value is 0. Type: integer (or
        /// Expression with resultType integer ).
        /// </summary>
        [JsonProperty(PropertyName = "baseRequestId")]
        public object BaseRequestId { get; set; }

    }
}
