// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Update integration runtime request.
    /// </summary>
    public partial class UpdateIntegrationRuntimeRequest
    {
        /// <summary>
        /// Initializes a new instance of the UpdateIntegrationRuntimeRequest
        /// class.
        /// </summary>
        public UpdateIntegrationRuntimeRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the UpdateIntegrationRuntimeRequest
        /// class.
        /// </summary>
        /// <param name="autoUpdate">Enables or disables the auto-update
        /// feature of the self-hosted integration runtime. See
        /// https://go.microsoft.com/fwlink/?linkid=854189. Possible values
        /// include: 'On', 'Off'</param>
        /// <param name="updateDelayOffset">The time offset (in hours) in the
        /// day, e.g., PT03H is 3 hours. The integration runtime auto update
        /// will happen on that time.</param>
        public UpdateIntegrationRuntimeRequest(string autoUpdate = default(string), string updateDelayOffset = default(string))
        {
            AutoUpdate = autoUpdate;
            UpdateDelayOffset = updateDelayOffset;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets enables or disables the auto-update feature of the
        /// self-hosted integration runtime. See
        /// https://go.microsoft.com/fwlink/?linkid=854189. Possible values
        /// include: 'On', 'Off'
        /// </summary>
        [JsonProperty(PropertyName = "autoUpdate")]
        public string AutoUpdate { get; set; }

        /// <summary>
        /// Gets or sets the time offset (in hours) in the day, e.g., PT03H is
        /// 3 hours. The integration runtime auto update will happen on that
        /// time.
        /// </summary>
        [JsonProperty(PropertyName = "updateDelayOffset")]
        public string UpdateDelayOffset { get; set; }

    }
}
