// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Get Data Plane read only token request definition.
    /// </summary>
    public partial class UserAccessPolicy
    {
        /// <summary>
        /// Initializes a new instance of the UserAccessPolicy class.
        /// </summary>
        public UserAccessPolicy()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the UserAccessPolicy class.
        /// </summary>
        /// <param name="permissions">The string with permissions for Data
        /// Plane access. Currently only 'r' is supported which grants read
        /// only access.</param>
        /// <param name="accessResourcePath">The resource path to get access
        /// relative to factory. Currently only empty string is supported which
        /// corresponds to the factory resource.</param>
        /// <param name="profileName">The name of the profile. Currently only
        /// the default is supported. The default value is
        /// DefaultProfile.</param>
        /// <param name="startTime">Start time for the token. If not specified
        /// the current time will be used.</param>
        /// <param name="expireTime">Expiration time for the token. Maximum
        /// duration for the token is eight hours and by default the token will
        /// expire in eight hours.</param>
        public UserAccessPolicy(string permissions = default(string), string accessResourcePath = default(string), string profileName = default(string), string startTime = default(string), string expireTime = default(string))
        {
            Permissions = permissions;
            AccessResourcePath = accessResourcePath;
            ProfileName = profileName;
            StartTime = startTime;
            ExpireTime = expireTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the string with permissions for Data Plane access.
        /// Currently only 'r' is supported which grants read only access.
        /// </summary>
        [JsonProperty(PropertyName = "permissions")]
        public string Permissions { get; set; }

        /// <summary>
        /// Gets or sets the resource path to get access relative to factory.
        /// Currently only empty string is supported which corresponds to the
        /// factory resource.
        /// </summary>
        [JsonProperty(PropertyName = "accessResourcePath")]
        public string AccessResourcePath { get; set; }

        /// <summary>
        /// Gets or sets the name of the profile. Currently only the default is
        /// supported. The default value is DefaultProfile.
        /// </summary>
        [JsonProperty(PropertyName = "profileName")]
        public string ProfileName { get; set; }

        /// <summary>
        /// Gets or sets start time for the token. If not specified the current
        /// time will be used.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public string StartTime { get; set; }

        /// <summary>
        /// Gets or sets expiration time for the token. Maximum duration for
        /// the token is eight hours and by default the token will expire in
        /// eight hours.
        /// </summary>
        [JsonProperty(PropertyName = "expireTime")]
        public string ExpireTime { get; set; }

    }
}
