// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataFactory.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Web activity authentication properties.
    /// </summary>
    public partial class WebActivityAuthentication
    {
        /// <summary>
        /// Initializes a new instance of the WebActivityAuthentication class.
        /// </summary>
        public WebActivityAuthentication()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the WebActivityAuthentication class.
        /// </summary>
        /// <param name="type">Web activity authentication
        /// (Basic/ClientCertificate/MSI)</param>
        /// <param name="pfx">Base64-encoded contents of a PFX file.</param>
        /// <param name="username">Web activity authentication user name for
        /// basic authentication.</param>
        /// <param name="password">Password for the PFX file or basic
        /// authentication.</param>
        /// <param name="resource">Resource for which Azure Auth token will be
        /// requested when using MSI Authentication.</param>
        public WebActivityAuthentication(string type, SecretBase pfx = default(SecretBase), string username = default(string), SecretBase password = default(SecretBase), string resource = default(string))
        {
            Type = type;
            Pfx = pfx;
            Username = username;
            Password = password;
            Resource = resource;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets web activity authentication
        /// (Basic/ClientCertificate/MSI)
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets base64-encoded contents of a PFX file.
        /// </summary>
        [JsonProperty(PropertyName = "pfx")]
        public SecretBase Pfx { get; set; }

        /// <summary>
        /// Gets or sets web activity authentication user name for basic
        /// authentication.
        /// </summary>
        [JsonProperty(PropertyName = "username")]
        public string Username { get; set; }

        /// <summary>
        /// Gets or sets password for the PFX file or basic authentication.
        /// </summary>
        [JsonProperty(PropertyName = "password")]
        public SecretBase Password { get; set; }

        /// <summary>
        /// Gets or sets resource for which Azure Auth token will be requested
        /// when using MSI Authentication.
        /// </summary>
        [JsonProperty(PropertyName = "resource")]
        public string Resource { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Type == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Type");
            }
        }
    }
}
