// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Azure.OData;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for CatalogOperations.
    /// </summary>
    public static partial class CatalogOperationsExtensions
    {
            /// <summary>
            /// Creates the specified secret for use with external data sources in the
            /// specified database. This is deprecated and will be removed in the next
            /// release. Please use CreateCredential instead.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in which to create the secret.
            /// </param>
            /// <param name='secretName'>
            /// The name of the secret.
            /// </param>
            /// <param name='parameters'>
            /// The parameters required to create the secret (name and password)
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static void CreateSecret(this ICatalogOperations operations, string accountName, string databaseName, string secretName, DataLakeAnalyticsCatalogSecretCreateOrUpdateParameters parameters)
            {
                operations.CreateSecretAsync(accountName, databaseName, secretName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates the specified secret for use with external data sources in the
            /// specified database. This is deprecated and will be removed in the next
            /// release. Please use CreateCredential instead.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in which to create the secret.
            /// </param>
            /// <param name='secretName'>
            /// The name of the secret.
            /// </param>
            /// <param name='parameters'>
            /// The parameters required to create the secret (name and password)
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static async Task CreateSecretAsync(this ICatalogOperations operations, string accountName, string databaseName, string secretName, DataLakeAnalyticsCatalogSecretCreateOrUpdateParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.CreateSecretWithHttpMessagesAsync(accountName, databaseName, secretName, parameters, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Gets the specified secret in the specified database. This is deprecated and
            /// will be removed in the next release. Please use GetCredential instead.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the secret.
            /// </param>
            /// <param name='secretName'>
            /// The name of the secret to get
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static USqlSecret GetSecret(this ICatalogOperations operations, string accountName, string databaseName, string secretName)
            {
                return operations.GetSecretAsync(accountName, databaseName, secretName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the specified secret in the specified database. This is deprecated and
            /// will be removed in the next release. Please use GetCredential instead.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the secret.
            /// </param>
            /// <param name='secretName'>
            /// The name of the secret to get
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static async Task<USqlSecret> GetSecretAsync(this ICatalogOperations operations, string accountName, string databaseName, string secretName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetSecretWithHttpMessagesAsync(accountName, databaseName, secretName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Modifies the specified secret for use with external data sources in the
            /// specified database. This is deprecated and will be removed in the next
            /// release. Please use UpdateCredential instead.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the secret.
            /// </param>
            /// <param name='secretName'>
            /// The name of the secret.
            /// </param>
            /// <param name='parameters'>
            /// The parameters required to modify the secret (name and password)
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static void UpdateSecret(this ICatalogOperations operations, string accountName, string databaseName, string secretName, DataLakeAnalyticsCatalogSecretCreateOrUpdateParameters parameters)
            {
                operations.UpdateSecretAsync(accountName, databaseName, secretName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Modifies the specified secret for use with external data sources in the
            /// specified database. This is deprecated and will be removed in the next
            /// release. Please use UpdateCredential instead.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the secret.
            /// </param>
            /// <param name='secretName'>
            /// The name of the secret.
            /// </param>
            /// <param name='parameters'>
            /// The parameters required to modify the secret (name and password)
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static async Task UpdateSecretAsync(this ICatalogOperations operations, string accountName, string databaseName, string secretName, DataLakeAnalyticsCatalogSecretCreateOrUpdateParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.UpdateSecretWithHttpMessagesAsync(accountName, databaseName, secretName, parameters, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Deletes the specified secret in the specified database. This is deprecated
            /// and will be removed in the next release. Please use DeleteCredential
            /// instead.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the secret.
            /// </param>
            /// <param name='secretName'>
            /// The name of the secret to delete
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static void DeleteSecret(this ICatalogOperations operations, string accountName, string databaseName, string secretName)
            {
                operations.DeleteSecretAsync(accountName, databaseName, secretName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the specified secret in the specified database. This is deprecated
            /// and will be removed in the next release. Please use DeleteCredential
            /// instead.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the secret.
            /// </param>
            /// <param name='secretName'>
            /// The name of the secret to delete
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static async Task DeleteSecretAsync(this ICatalogOperations operations, string accountName, string databaseName, string secretName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteSecretWithHttpMessagesAsync(accountName, databaseName, secretName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Deletes all secrets in the specified database. This is deprecated and will
            /// be removed in the next release. In the future, please only drop individual
            /// credentials using DeleteCredential
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the secret.
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static void DeleteAllSecrets(this ICatalogOperations operations, string accountName, string databaseName)
            {
                operations.DeleteAllSecretsAsync(accountName, databaseName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes all secrets in the specified database. This is deprecated and will
            /// be removed in the next release. In the future, please only drop individual
            /// credentials using DeleteCredential
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the secret.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static async Task DeleteAllSecretsAsync(this ICatalogOperations operations, string accountName, string databaseName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteAllSecretsWithHttpMessagesAsync(accountName, databaseName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Creates the specified credential for use with external data sources in the
            /// specified database.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in which to create the credential. Note: This is
            /// NOT an external database name, but the name of an existing U-SQL database
            /// that should contain the new credential object.
            /// </param>
            /// <param name='credentialName'>
            /// The name of the credential.
            /// </param>
            /// <param name='parameters'>
            /// The parameters required to create the credential (name and password)
            /// </param>
            public static void CreateCredential(this ICatalogOperations operations, string accountName, string databaseName, string credentialName, DataLakeAnalyticsCatalogCredentialCreateParameters parameters)
            {
                operations.CreateCredentialAsync(accountName, databaseName, credentialName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates the specified credential for use with external data sources in the
            /// specified database.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in which to create the credential. Note: This is
            /// NOT an external database name, but the name of an existing U-SQL database
            /// that should contain the new credential object.
            /// </param>
            /// <param name='credentialName'>
            /// The name of the credential.
            /// </param>
            /// <param name='parameters'>
            /// The parameters required to create the credential (name and password)
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task CreateCredentialAsync(this ICatalogOperations operations, string accountName, string databaseName, string credentialName, DataLakeAnalyticsCatalogCredentialCreateParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.CreateCredentialWithHttpMessagesAsync(accountName, databaseName, credentialName, parameters, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Retrieves the specified credential from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the schema.
            /// </param>
            /// <param name='credentialName'>
            /// The name of the credential.
            /// </param>
            public static USqlCredential GetCredential(this ICatalogOperations operations, string accountName, string databaseName, string credentialName)
            {
                return operations.GetCredentialAsync(accountName, databaseName, credentialName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified credential from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the schema.
            /// </param>
            /// <param name='credentialName'>
            /// The name of the credential.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlCredential> GetCredentialAsync(this ICatalogOperations operations, string accountName, string databaseName, string credentialName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetCredentialWithHttpMessagesAsync(accountName, databaseName, credentialName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Modifies the specified credential for use with external data sources in the
            /// specified database
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the credential.
            /// </param>
            /// <param name='credentialName'>
            /// The name of the credential.
            /// </param>
            /// <param name='parameters'>
            /// The parameters required to modify the credential (name and password)
            /// </param>
            public static void UpdateCredential(this ICatalogOperations operations, string accountName, string databaseName, string credentialName, DataLakeAnalyticsCatalogCredentialUpdateParameters parameters)
            {
                operations.UpdateCredentialAsync(accountName, databaseName, credentialName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Modifies the specified credential for use with external data sources in the
            /// specified database
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the credential.
            /// </param>
            /// <param name='credentialName'>
            /// The name of the credential.
            /// </param>
            /// <param name='parameters'>
            /// The parameters required to modify the credential (name and password)
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task UpdateCredentialAsync(this ICatalogOperations operations, string accountName, string databaseName, string credentialName, DataLakeAnalyticsCatalogCredentialUpdateParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.UpdateCredentialWithHttpMessagesAsync(accountName, databaseName, credentialName, parameters, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Deletes the specified credential in the specified database
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the credential.
            /// </param>
            /// <param name='credentialName'>
            /// The name of the credential to delete
            /// </param>
            /// <param name='parameters'>
            /// The parameters to delete a credential if the current user is not the
            /// account owner.
            /// </param>
            /// <param name='cascade'>
            /// Indicates if the delete should be a cascading delete (which deletes all
            /// resources dependent on the credential as well as the credential) or not. If
            /// false will fail if there are any resources relying on the credential.
            /// </param>
            public static void DeleteCredential(this ICatalogOperations operations, string accountName, string databaseName, string credentialName, DataLakeAnalyticsCatalogCredentialDeleteParameters parameters = default(DataLakeAnalyticsCatalogCredentialDeleteParameters), bool? cascade = false)
            {
                operations.DeleteCredentialAsync(accountName, databaseName, credentialName, parameters, cascade).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the specified credential in the specified database
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the credential.
            /// </param>
            /// <param name='credentialName'>
            /// The name of the credential to delete
            /// </param>
            /// <param name='parameters'>
            /// The parameters to delete a credential if the current user is not the
            /// account owner.
            /// </param>
            /// <param name='cascade'>
            /// Indicates if the delete should be a cascading delete (which deletes all
            /// resources dependent on the credential as well as the credential) or not. If
            /// false will fail if there are any resources relying on the credential.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteCredentialAsync(this ICatalogOperations operations, string accountName, string databaseName, string credentialName, DataLakeAnalyticsCatalogCredentialDeleteParameters parameters = default(DataLakeAnalyticsCatalogCredentialDeleteParameters), bool? cascade = false, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteCredentialWithHttpMessagesAsync(accountName, databaseName, credentialName, parameters, cascade, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Retrieves the list of credentials from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the schema.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlCredential> ListCredentials(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlCredential> odataQuery = default(ODataQuery<USqlCredential>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListCredentialsAsync(accountName, databaseName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of credentials from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the schema.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlCredential>> ListCredentialsAsync(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlCredential> odataQuery = default(ODataQuery<USqlCredential>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListCredentialsWithHttpMessagesAsync(accountName, databaseName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified external data source from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the external data source.
            /// </param>
            /// <param name='externalDataSourceName'>
            /// The name of the external data source.
            /// </param>
            public static USqlExternalDataSource GetExternalDataSource(this ICatalogOperations operations, string accountName, string databaseName, string externalDataSourceName)
            {
                return operations.GetExternalDataSourceAsync(accountName, databaseName, externalDataSourceName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified external data source from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the external data source.
            /// </param>
            /// <param name='externalDataSourceName'>
            /// The name of the external data source.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlExternalDataSource> GetExternalDataSourceAsync(this ICatalogOperations operations, string accountName, string databaseName, string externalDataSourceName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetExternalDataSourceWithHttpMessagesAsync(accountName, databaseName, externalDataSourceName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of external data sources from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the external data sources.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlExternalDataSource> ListExternalDataSources(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlExternalDataSource> odataQuery = default(ODataQuery<USqlExternalDataSource>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListExternalDataSourcesAsync(accountName, databaseName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of external data sources from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the external data sources.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlExternalDataSource>> ListExternalDataSourcesAsync(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlExternalDataSource> odataQuery = default(ODataQuery<USqlExternalDataSource>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListExternalDataSourcesWithHttpMessagesAsync(accountName, databaseName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified procedure from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the procedure.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the procedure.
            /// </param>
            /// <param name='procedureName'>
            /// The name of the procedure.
            /// </param>
            public static USqlProcedure GetProcedure(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string procedureName)
            {
                return operations.GetProcedureAsync(accountName, databaseName, schemaName, procedureName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified procedure from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the procedure.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the procedure.
            /// </param>
            /// <param name='procedureName'>
            /// The name of the procedure.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlProcedure> GetProcedureAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string procedureName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetProcedureWithHttpMessagesAsync(accountName, databaseName, schemaName, procedureName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of procedures from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the procedures.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the procedures.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlProcedure> ListProcedures(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlProcedure> odataQuery = default(ODataQuery<USqlProcedure>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListProceduresAsync(accountName, databaseName, schemaName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of procedures from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the procedures.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the procedures.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlProcedure>> ListProceduresAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlProcedure> odataQuery = default(ODataQuery<USqlProcedure>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListProceduresWithHttpMessagesAsync(accountName, databaseName, schemaName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified table from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table.
            /// </param>
            public static USqlTable GetTable(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName)
            {
                return operations.GetTableAsync(accountName, databaseName, schemaName, tableName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified table from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlTable> GetTableAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetTableWithHttpMessagesAsync(accountName, databaseName, schemaName, tableName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of table fragments from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table fragments.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table fragments.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the table fragments.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlTableFragment> ListTableFragments(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, ODataQuery<USqlTableFragment> odataQuery = default(ODataQuery<USqlTableFragment>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListTableFragmentsAsync(accountName, databaseName, schemaName, tableName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of table fragments from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table fragments.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table fragments.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the table fragments.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableFragment>> ListTableFragmentsAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, ODataQuery<USqlTableFragment> odataQuery = default(ODataQuery<USqlTableFragment>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableFragmentsWithHttpMessagesAsync(accountName, databaseName, schemaName, tableName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of tables from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the tables.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the tables.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='basic'>
            /// The basic switch indicates what level of information to return when listing
            /// tables. When basic is true, only database_name, schema_name, table_name and
            /// version are returned for each table, otherwise all table metadata is
            /// returned. By default, it is false. Optional.
            /// </param>
            public static IPage<USqlTable> ListTables(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlTable> odataQuery = default(ODataQuery<USqlTable>), string select = default(string), bool? count = default(bool?), bool? basic = false)
            {
                return operations.ListTablesAsync(accountName, databaseName, schemaName, odataQuery, select, count, basic).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of tables from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the tables.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the tables.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='basic'>
            /// The basic switch indicates what level of information to return when listing
            /// tables. When basic is true, only database_name, schema_name, table_name and
            /// version are returned for each table, otherwise all table metadata is
            /// returned. By default, it is false. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTable>> ListTablesAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlTable> odataQuery = default(ODataQuery<USqlTable>), string select = default(string), bool? count = default(bool?), bool? basic = false, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTablesWithHttpMessagesAsync(accountName, databaseName, schemaName, odataQuery, select, count, basic, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of all table statistics within the specified schema from
            /// the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the statistics.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the statistics.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlTableStatistics> ListTableStatisticsByDatabaseAndSchema(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlTableStatistics> odataQuery = default(ODataQuery<USqlTableStatistics>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListTableStatisticsByDatabaseAndSchemaAsync(accountName, databaseName, schemaName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of all table statistics within the specified schema from
            /// the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the statistics.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the statistics.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableStatistics>> ListTableStatisticsByDatabaseAndSchemaAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlTableStatistics> odataQuery = default(ODataQuery<USqlTableStatistics>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableStatisticsByDatabaseAndSchemaWithHttpMessagesAsync(accountName, databaseName, schemaName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified table type from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table type.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table type.
            /// </param>
            /// <param name='tableTypeName'>
            /// The name of the table type to retrieve.
            /// </param>
            public static USqlTableType GetTableType(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableTypeName)
            {
                return operations.GetTableTypeAsync(accountName, databaseName, schemaName, tableTypeName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified table type from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table type.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table type.
            /// </param>
            /// <param name='tableTypeName'>
            /// The name of the table type to retrieve.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlTableType> GetTableTypeAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableTypeName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetTableTypeWithHttpMessagesAsync(accountName, databaseName, schemaName, tableTypeName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of table types from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table types.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table types.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlTableType> ListTableTypes(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlTableType> odataQuery = default(ODataQuery<USqlTableType>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListTableTypesAsync(accountName, databaseName, schemaName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of table types from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table types.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table types.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableType>> ListTableTypesAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlTableType> odataQuery = default(ODataQuery<USqlTableType>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableTypesWithHttpMessagesAsync(accountName, databaseName, schemaName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified package from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the package.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the package.
            /// </param>
            /// <param name='packageName'>
            /// The name of the package.
            /// </param>
            public static USqlPackage GetPackage(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string packageName)
            {
                return operations.GetPackageAsync(accountName, databaseName, schemaName, packageName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified package from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the package.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the package.
            /// </param>
            /// <param name='packageName'>
            /// The name of the package.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlPackage> GetPackageAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string packageName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetPackageWithHttpMessagesAsync(accountName, databaseName, schemaName, packageName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of packages from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the packages.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the packages.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlPackage> ListPackages(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlPackage> odataQuery = default(ODataQuery<USqlPackage>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListPackagesAsync(accountName, databaseName, schemaName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of packages from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the packages.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the packages.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlPackage>> ListPackagesAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlPackage> odataQuery = default(ODataQuery<USqlPackage>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListPackagesWithHttpMessagesAsync(accountName, databaseName, schemaName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified view from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the view.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the view.
            /// </param>
            /// <param name='viewName'>
            /// The name of the view.
            /// </param>
            public static USqlView GetView(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string viewName)
            {
                return operations.GetViewAsync(accountName, databaseName, schemaName, viewName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified view from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the view.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the view.
            /// </param>
            /// <param name='viewName'>
            /// The name of the view.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlView> GetViewAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string viewName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetViewWithHttpMessagesAsync(accountName, databaseName, schemaName, viewName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of views from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the views.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the views.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlView> ListViews(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlView> odataQuery = default(ODataQuery<USqlView>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListViewsAsync(accountName, databaseName, schemaName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of views from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the views.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the views.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlView>> ListViewsAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlView> odataQuery = default(ODataQuery<USqlView>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListViewsWithHttpMessagesAsync(accountName, databaseName, schemaName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified table statistics from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the statistics.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the statistics.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the statistics.
            /// </param>
            /// <param name='statisticsName'>
            /// The name of the table statistics.
            /// </param>
            public static USqlTableStatistics GetTableStatistic(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, string statisticsName)
            {
                return operations.GetTableStatisticAsync(accountName, databaseName, schemaName, tableName, statisticsName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified table statistics from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the statistics.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the statistics.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the statistics.
            /// </param>
            /// <param name='statisticsName'>
            /// The name of the table statistics.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlTableStatistics> GetTableStatisticAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, string statisticsName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetTableStatisticWithHttpMessagesAsync(accountName, databaseName, schemaName, tableName, statisticsName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of table statistics from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the statistics.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the statistics.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the statistics.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlTableStatistics> ListTableStatistics(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, ODataQuery<USqlTableStatistics> odataQuery = default(ODataQuery<USqlTableStatistics>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListTableStatisticsAsync(accountName, databaseName, schemaName, tableName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of table statistics from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the statistics.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the statistics.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the statistics.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableStatistics>> ListTableStatisticsAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, ODataQuery<USqlTableStatistics> odataQuery = default(ODataQuery<USqlTableStatistics>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableStatisticsWithHttpMessagesAsync(accountName, databaseName, schemaName, tableName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves a preview set of rows in given partition.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the partition.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the partition.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the partition.
            /// </param>
            /// <param name='partitionName'>
            /// The name of the table partition.
            /// </param>
            /// <param name='maxRows'>
            /// The maximum number of preview rows to be retrieved.Rows returned may be
            /// less than or equal to this number depending on row sizes and number of rows
            /// in the partition.
            /// </param>
            /// <param name='maxColumns'>
            /// The maximum number of columns to be retrieved.
            /// </param>
            public static USqlTablePreview PreviewTablePartition(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, string partitionName, long? maxRows = default(long?), long? maxColumns = default(long?))
            {
                return operations.PreviewTablePartitionAsync(accountName, databaseName, schemaName, tableName, partitionName, maxRows, maxColumns).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves a preview set of rows in given partition.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the partition.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the partition.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the partition.
            /// </param>
            /// <param name='partitionName'>
            /// The name of the table partition.
            /// </param>
            /// <param name='maxRows'>
            /// The maximum number of preview rows to be retrieved.Rows returned may be
            /// less than or equal to this number depending on row sizes and number of rows
            /// in the partition.
            /// </param>
            /// <param name='maxColumns'>
            /// The maximum number of columns to be retrieved.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlTablePreview> PreviewTablePartitionAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, string partitionName, long? maxRows = default(long?), long? maxColumns = default(long?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.PreviewTablePartitionWithHttpMessagesAsync(accountName, databaseName, schemaName, tableName, partitionName, maxRows, maxColumns, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified table partition from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the partition.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the partition.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the partition.
            /// </param>
            /// <param name='partitionName'>
            /// The name of the table partition.
            /// </param>
            public static USqlTablePartition GetTablePartition(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, string partitionName)
            {
                return operations.GetTablePartitionAsync(accountName, databaseName, schemaName, tableName, partitionName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified table partition from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the partition.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the partition.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the partition.
            /// </param>
            /// <param name='partitionName'>
            /// The name of the table partition.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlTablePartition> GetTablePartitionAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, string partitionName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetTablePartitionWithHttpMessagesAsync(accountName, databaseName, schemaName, tableName, partitionName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves a preview set of rows in given table.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table.
            /// </param>
            /// <param name='maxRows'>
            /// The maximum number of preview rows to be retrieved. Rows returned may be
            /// less than or equal to this number depending on row sizes and number of rows
            /// in the table.
            /// </param>
            /// <param name='maxColumns'>
            /// The maximum number of columns to be retrieved.
            /// </param>
            public static USqlTablePreview PreviewTable(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, long? maxRows = default(long?), long? maxColumns = default(long?))
            {
                return operations.PreviewTableAsync(accountName, databaseName, schemaName, tableName, maxRows, maxColumns).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves a preview set of rows in given table.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table.
            /// </param>
            /// <param name='maxRows'>
            /// The maximum number of preview rows to be retrieved. Rows returned may be
            /// less than or equal to this number depending on row sizes and number of rows
            /// in the table.
            /// </param>
            /// <param name='maxColumns'>
            /// The maximum number of columns to be retrieved.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlTablePreview> PreviewTableAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, long? maxRows = default(long?), long? maxColumns = default(long?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.PreviewTableWithHttpMessagesAsync(accountName, databaseName, schemaName, tableName, maxRows, maxColumns, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of table partitions from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the partitions.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the partitions.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the partitions.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlTablePartition> ListTablePartitions(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, ODataQuery<USqlTablePartition> odataQuery = default(ODataQuery<USqlTablePartition>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListTablePartitionsAsync(accountName, databaseName, schemaName, tableName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of table partitions from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the partitions.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the partitions.
            /// </param>
            /// <param name='tableName'>
            /// The name of the table containing the partitions.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTablePartition>> ListTablePartitionsAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableName, ODataQuery<USqlTablePartition> odataQuery = default(ODataQuery<USqlTablePartition>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTablePartitionsWithHttpMessagesAsync(accountName, databaseName, schemaName, tableName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of types within the specified database and schema from
            /// the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the types.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the types.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlType> ListTypes(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlType> odataQuery = default(ODataQuery<USqlType>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListTypesAsync(accountName, databaseName, schemaName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of types within the specified database and schema from
            /// the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the types.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the types.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlType>> ListTypesAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlType> odataQuery = default(ODataQuery<USqlType>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTypesWithHttpMessagesAsync(accountName, databaseName, schemaName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified table valued function from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table valued function.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table valued function.
            /// </param>
            /// <param name='tableValuedFunctionName'>
            /// The name of the tableValuedFunction.
            /// </param>
            public static USqlTableValuedFunction GetTableValuedFunction(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableValuedFunctionName)
            {
                return operations.GetTableValuedFunctionAsync(accountName, databaseName, schemaName, tableValuedFunctionName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified table valued function from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table valued function.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table valued function.
            /// </param>
            /// <param name='tableValuedFunctionName'>
            /// The name of the tableValuedFunction.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlTableValuedFunction> GetTableValuedFunctionAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, string tableValuedFunctionName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetTableValuedFunctionWithHttpMessagesAsync(accountName, databaseName, schemaName, tableValuedFunctionName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of table valued functions from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table valued functions.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table valued functions.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlTableValuedFunction> ListTableValuedFunctions(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlTableValuedFunction> odataQuery = default(ODataQuery<USqlTableValuedFunction>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListTableValuedFunctionsAsync(accountName, databaseName, schemaName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of table valued functions from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table valued functions.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema containing the table valued functions.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableValuedFunction>> ListTableValuedFunctionsAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, ODataQuery<USqlTableValuedFunction> odataQuery = default(ODataQuery<USqlTableValuedFunction>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableValuedFunctionsWithHttpMessagesAsync(accountName, databaseName, schemaName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified assembly from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the assembly.
            /// </param>
            /// <param name='assemblyName'>
            /// The name of the assembly.
            /// </param>
            public static USqlAssembly GetAssembly(this ICatalogOperations operations, string accountName, string databaseName, string assemblyName)
            {
                return operations.GetAssemblyAsync(accountName, databaseName, assemblyName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified assembly from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the assembly.
            /// </param>
            /// <param name='assemblyName'>
            /// The name of the assembly.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlAssembly> GetAssemblyAsync(this ICatalogOperations operations, string accountName, string databaseName, string assemblyName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetAssemblyWithHttpMessagesAsync(accountName, databaseName, assemblyName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of assemblies from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the assembly.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlAssemblyClr> ListAssemblies(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlAssembly> odataQuery = default(ODataQuery<USqlAssembly>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListAssembliesAsync(accountName, databaseName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of assemblies from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the assembly.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlAssemblyClr>> ListAssembliesAsync(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlAssembly> odataQuery = default(ODataQuery<USqlAssembly>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListAssembliesWithHttpMessagesAsync(accountName, databaseName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified schema from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the schema.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema.
            /// </param>
            public static USqlSchema GetSchema(this ICatalogOperations operations, string accountName, string databaseName, string schemaName)
            {
                return operations.GetSchemaAsync(accountName, databaseName, schemaName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified schema from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the schema.
            /// </param>
            /// <param name='schemaName'>
            /// The name of the schema.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlSchema> GetSchemaAsync(this ICatalogOperations operations, string accountName, string databaseName, string schemaName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetSchemaWithHttpMessagesAsync(accountName, databaseName, schemaName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of schemas from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the schema.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlSchema> ListSchemas(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlSchema> odataQuery = default(ODataQuery<USqlSchema>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListSchemasAsync(accountName, databaseName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of schemas from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the schema.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlSchema>> ListSchemasAsync(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlSchema> odataQuery = default(ODataQuery<USqlSchema>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListSchemasWithHttpMessagesAsync(accountName, databaseName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of all statistics in a database from the Data Lake
            /// Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table statistics.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlTableStatistics> ListTableStatisticsByDatabase(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlTableStatistics> odataQuery = default(ODataQuery<USqlTableStatistics>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListTableStatisticsByDatabaseAsync(accountName, databaseName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of all statistics in a database from the Data Lake
            /// Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table statistics.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableStatistics>> ListTableStatisticsByDatabaseAsync(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlTableStatistics> odataQuery = default(ODataQuery<USqlTableStatistics>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableStatisticsByDatabaseWithHttpMessagesAsync(accountName, databaseName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of all tables in a database from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the tables.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='basic'>
            /// The basic switch indicates what level of information to return when listing
            /// tables. When basic is true, only database_name, schema_name, table_name and
            /// version are returned for each table, otherwise all table metadata is
            /// returned. By default, it is false
            /// </param>
            public static IPage<USqlTable> ListTablesByDatabase(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlTable> odataQuery = default(ODataQuery<USqlTable>), string select = default(string), bool? count = default(bool?), bool? basic = false)
            {
                return operations.ListTablesByDatabaseAsync(accountName, databaseName, odataQuery, select, count, basic).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of all tables in a database from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the tables.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='basic'>
            /// The basic switch indicates what level of information to return when listing
            /// tables. When basic is true, only database_name, schema_name, table_name and
            /// version are returned for each table, otherwise all table metadata is
            /// returned. By default, it is false
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTable>> ListTablesByDatabaseAsync(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlTable> odataQuery = default(ODataQuery<USqlTable>), string select = default(string), bool? count = default(bool?), bool? basic = false, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTablesByDatabaseWithHttpMessagesAsync(accountName, databaseName, odataQuery, select, count, basic, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of all table valued functions in a database from the
            /// Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table valued functions.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlTableValuedFunction> ListTableValuedFunctionsByDatabase(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlTableValuedFunction> odataQuery = default(ODataQuery<USqlTableValuedFunction>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListTableValuedFunctionsByDatabaseAsync(accountName, databaseName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of all table valued functions in a database from the
            /// Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the table valued functions.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableValuedFunction>> ListTableValuedFunctionsByDatabaseAsync(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlTableValuedFunction> odataQuery = default(ODataQuery<USqlTableValuedFunction>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableValuedFunctionsByDatabaseWithHttpMessagesAsync(accountName, databaseName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of all views in a database from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the views.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlView> ListViewsByDatabase(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlView> odataQuery = default(ODataQuery<USqlView>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListViewsByDatabaseAsync(accountName, databaseName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of all views in a database from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database containing the views.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlView>> ListViewsByDatabaseAsync(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<USqlView> odataQuery = default(ODataQuery<USqlView>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListViewsByDatabaseWithHttpMessagesAsync(accountName, databaseName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of access control list (ACL) entries for the database
            /// from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<Acl> ListAclsByDatabase(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<Acl> odataQuery = default(ODataQuery<Acl>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListAclsByDatabaseAsync(accountName, databaseName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of access control list (ACL) entries for the database
            /// from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Acl>> ListAclsByDatabaseAsync(this ICatalogOperations operations, string accountName, string databaseName, ODataQuery<Acl> odataQuery = default(ODataQuery<Acl>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListAclsByDatabaseWithHttpMessagesAsync(accountName, databaseName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of access control list (ACL) entries for the Data Lake
            /// Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<Acl> ListAcls(this ICatalogOperations operations, string accountName, ODataQuery<Acl> odataQuery = default(ODataQuery<Acl>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListAclsAsync(accountName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of access control list (ACL) entries for the Data Lake
            /// Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Acl>> ListAclsAsync(this ICatalogOperations operations, string accountName, ODataQuery<Acl> odataQuery = default(ODataQuery<Acl>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListAclsWithHttpMessagesAsync(accountName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the specified database from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database.
            /// </param>
            public static USqlDatabase GetDatabase(this ICatalogOperations operations, string accountName, string databaseName)
            {
                return operations.GetDatabaseAsync(accountName, databaseName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the specified database from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<USqlDatabase> GetDatabaseAsync(this ICatalogOperations operations, string accountName, string databaseName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetDatabaseWithHttpMessagesAsync(accountName, databaseName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of databases from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            public static IPage<USqlDatabase> ListDatabases(this ICatalogOperations operations, string accountName, ODataQuery<USqlDatabase> odataQuery = default(ODataQuery<USqlDatabase>), string select = default(string), bool? count = default(bool?))
            {
                return operations.ListDatabasesAsync(accountName, odataQuery, select, count).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of databases from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// OData Select statement. Limits the properties on each entry to just those
            /// requested, e.g. Categories?$select=CategoryName,Description. Optional.
            /// </param>
            /// <param name='count'>
            /// The Boolean value of true or false to request a count of the matching
            /// resources included with the resources in the response, e.g.
            /// Categories?$count=true. Optional.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlDatabase>> ListDatabasesAsync(this ICatalogOperations operations, string accountName, ODataQuery<USqlDatabase> odataQuery = default(ODataQuery<USqlDatabase>), string select = default(string), bool? count = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListDatabasesWithHttpMessagesAsync(accountName, odataQuery, select, count, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Grants an access control list (ACL) entry to the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='parameters'>
            /// Parameters supplied to create or update an access control list (ACL) entry
            /// for a Data Lake Analytics catalog.
            /// </param>
            public static void GrantAcl(this ICatalogOperations operations, string accountName, AclCreateOrUpdateParameters parameters)
            {
                operations.GrantAclAsync(accountName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Grants an access control list (ACL) entry to the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='parameters'>
            /// Parameters supplied to create or update an access control list (ACL) entry
            /// for a Data Lake Analytics catalog.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task GrantAclAsync(this ICatalogOperations operations, string accountName, AclCreateOrUpdateParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.GrantAclWithHttpMessagesAsync(accountName, parameters, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Grants an access control list (ACL) entry to the database from the Data
            /// Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database.
            /// </param>
            /// <param name='parameters'>
            /// Parameters supplied to create or update an access control list (ACL) entry
            /// for a database.
            /// </param>
            public static void GrantAclToDatabase(this ICatalogOperations operations, string accountName, string databaseName, AclCreateOrUpdateParameters parameters)
            {
                operations.GrantAclToDatabaseAsync(accountName, databaseName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Grants an access control list (ACL) entry to the database from the Data
            /// Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database.
            /// </param>
            /// <param name='parameters'>
            /// Parameters supplied to create or update an access control list (ACL) entry
            /// for a database.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task GrantAclToDatabaseAsync(this ICatalogOperations operations, string accountName, string databaseName, AclCreateOrUpdateParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.GrantAclToDatabaseWithHttpMessagesAsync(accountName, databaseName, parameters, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Revokes an access control list (ACL) entry from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='parameters'>
            /// Parameters supplied to delete an access control list (ACL) entry from a
            /// Data Lake Analytics catalog.
            /// </param>
            public static void RevokeAcl(this ICatalogOperations operations, string accountName, AclDeleteParameters parameters)
            {
                operations.RevokeAclAsync(accountName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Revokes an access control list (ACL) entry from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='parameters'>
            /// Parameters supplied to delete an access control list (ACL) entry from a
            /// Data Lake Analytics catalog.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task RevokeAclAsync(this ICatalogOperations operations, string accountName, AclDeleteParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.RevokeAclWithHttpMessagesAsync(accountName, parameters, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Revokes an access control list (ACL) entry for the database from the Data
            /// Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database.
            /// </param>
            /// <param name='parameters'>
            /// Parameters supplied to delete an access control list (ACL) entry for a
            /// database.
            /// </param>
            public static void RevokeAclFromDatabase(this ICatalogOperations operations, string accountName, string databaseName, AclDeleteParameters parameters)
            {
                operations.RevokeAclFromDatabaseAsync(accountName, databaseName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Revokes an access control list (ACL) entry for the database from the Data
            /// Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account upon which to execute catalog
            /// operations.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database.
            /// </param>
            /// <param name='parameters'>
            /// Parameters supplied to delete an access control list (ACL) entry for a
            /// database.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task RevokeAclFromDatabaseAsync(this ICatalogOperations operations, string accountName, string databaseName, AclDeleteParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.RevokeAclFromDatabaseWithHttpMessagesAsync(accountName, databaseName, parameters, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Retrieves the list of credentials from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlCredential> ListCredentialsNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListCredentialsNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of credentials from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlCredential>> ListCredentialsNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListCredentialsNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of external data sources from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlExternalDataSource> ListExternalDataSourcesNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListExternalDataSourcesNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of external data sources from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlExternalDataSource>> ListExternalDataSourcesNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListExternalDataSourcesNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of procedures from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlProcedure> ListProceduresNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListProceduresNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of procedures from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlProcedure>> ListProceduresNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListProceduresNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of table fragments from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlTableFragment> ListTableFragmentsNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTableFragmentsNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of table fragments from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableFragment>> ListTableFragmentsNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableFragmentsNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of tables from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlTable> ListTablesNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTablesNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of tables from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTable>> ListTablesNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTablesNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of all table statistics within the specified schema from
            /// the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlTableStatistics> ListTableStatisticsByDatabaseAndSchemaNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTableStatisticsByDatabaseAndSchemaNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of all table statistics within the specified schema from
            /// the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableStatistics>> ListTableStatisticsByDatabaseAndSchemaNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableStatisticsByDatabaseAndSchemaNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of table types from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlTableType> ListTableTypesNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTableTypesNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of table types from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableType>> ListTableTypesNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableTypesNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of packages from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlPackage> ListPackagesNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListPackagesNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of packages from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlPackage>> ListPackagesNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListPackagesNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of views from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlView> ListViewsNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListViewsNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of views from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlView>> ListViewsNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListViewsNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of table statistics from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlTableStatistics> ListTableStatisticsNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTableStatisticsNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of table statistics from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableStatistics>> ListTableStatisticsNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableStatisticsNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of table partitions from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlTablePartition> ListTablePartitionsNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTablePartitionsNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of table partitions from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTablePartition>> ListTablePartitionsNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTablePartitionsNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of types within the specified database and schema from
            /// the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlType> ListTypesNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTypesNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of types within the specified database and schema from
            /// the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlType>> ListTypesNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTypesNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of table valued functions from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlTableValuedFunction> ListTableValuedFunctionsNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTableValuedFunctionsNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of table valued functions from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableValuedFunction>> ListTableValuedFunctionsNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableValuedFunctionsNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of assemblies from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlAssemblyClr> ListAssembliesNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListAssembliesNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of assemblies from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlAssemblyClr>> ListAssembliesNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListAssembliesNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of schemas from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlSchema> ListSchemasNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListSchemasNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of schemas from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlSchema>> ListSchemasNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListSchemasNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of all statistics in a database from the Data Lake
            /// Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlTableStatistics> ListTableStatisticsByDatabaseNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTableStatisticsByDatabaseNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of all statistics in a database from the Data Lake
            /// Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableStatistics>> ListTableStatisticsByDatabaseNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableStatisticsByDatabaseNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of all tables in a database from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlTable> ListTablesByDatabaseNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTablesByDatabaseNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of all tables in a database from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTable>> ListTablesByDatabaseNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTablesByDatabaseNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of all table valued functions in a database from the
            /// Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlTableValuedFunction> ListTableValuedFunctionsByDatabaseNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListTableValuedFunctionsByDatabaseNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of all table valued functions in a database from the
            /// Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlTableValuedFunction>> ListTableValuedFunctionsByDatabaseNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListTableValuedFunctionsByDatabaseNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of all views in a database from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlView> ListViewsByDatabaseNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListViewsByDatabaseNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of all views in a database from the Data Lake Analytics
            /// catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlView>> ListViewsByDatabaseNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListViewsByDatabaseNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of access control list (ACL) entries for the database
            /// from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<Acl> ListAclsByDatabaseNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListAclsByDatabaseNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of access control list (ACL) entries for the database
            /// from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Acl>> ListAclsByDatabaseNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListAclsByDatabaseNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of access control list (ACL) entries for the Data Lake
            /// Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<Acl> ListAclsNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListAclsNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of access control list (ACL) entries for the Data Lake
            /// Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Acl>> ListAclsNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListAclsNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Retrieves the list of databases from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<USqlDatabase> ListDatabasesNext(this ICatalogOperations operations, string nextPageLink)
            {
                return operations.ListDatabasesNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the list of databases from the Data Lake Analytics catalog.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<USqlDatabase>> ListDatabasesNextAsync(this ICatalogOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListDatabasesNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
