// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A Data Lake Analytics catalog access control list (ACL) entry.
    /// </summary>
    public partial class Acl
    {
        /// <summary>
        /// Initializes a new instance of the Acl class.
        /// </summary>
        public Acl()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Acl class.
        /// </summary>
        /// <param name="aceType">the access control list (ACL) entry type.
        /// UserObj and GroupObj denote the owning user and group,
        /// respectively. Possible values include: 'UserObj', 'GroupObj',
        /// 'Other', 'User', 'Group'</param>
        /// <param name="principalId">the Azure AD object ID of the user or
        /// group being specified in the access control list (ACL)
        /// entry.</param>
        /// <param name="permission">the permission type of the access control
        /// list (ACL) entry. Possible values include: 'None', 'Use', 'Create',
        /// 'Drop', 'Alter', 'Write', 'All'</param>
        public Acl(string aceType = default(string), System.Guid? principalId = default(System.Guid?), string permission = default(string))
        {
            AceType = aceType;
            PrincipalId = principalId;
            Permission = permission;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the access control list (ACL) entry type. UserObj and GroupObj
        /// denote the owning user and group, respectively. Possible values
        /// include: 'UserObj', 'GroupObj', 'Other', 'User', 'Group'
        /// </summary>
        [JsonProperty(PropertyName = "aceType")]
        public string AceType { get; private set; }

        /// <summary>
        /// Gets the Azure AD object ID of the user or group being specified in
        /// the access control list (ACL) entry.
        /// </summary>
        [JsonProperty(PropertyName = "principalId")]
        public System.Guid? PrincipalId { get; private set; }

        /// <summary>
        /// Gets the permission type of the access control list (ACL) entry.
        /// Possible values include: 'None', 'Use', 'Create', 'Drop', 'Alter',
        /// 'Write', 'All'
        /// </summary>
        [JsonProperty(PropertyName = "permission")]
        public string Permission { get; private set; }

    }
}
