// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters used to delete an access control list (ACL) entry.
    /// </summary>
    public partial class AclDeleteParameters
    {
        /// <summary>
        /// Initializes a new instance of the AclDeleteParameters class.
        /// </summary>
        public AclDeleteParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AclDeleteParameters class.
        /// </summary>
        /// <param name="aceType">the access control list (ACL) entry type.
        /// UserObj and GroupObj denote the owning user and group,
        /// respectively. Possible values include: 'UserObj', 'GroupObj',
        /// 'Other', 'User', 'Group'</param>
        /// <param name="principalId">the Azure AD object ID of the user or
        /// group being specified in the access control list (ACL)
        /// entry.</param>
        public AclDeleteParameters(string aceType, System.Guid principalId)
        {
            AceType = aceType;
            PrincipalId = principalId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the access control list (ACL) entry type. UserObj and
        /// GroupObj denote the owning user and group, respectively. Possible
        /// values include: 'UserObj', 'GroupObj', 'Other', 'User', 'Group'
        /// </summary>
        [JsonProperty(PropertyName = "aceType")]
        public string AceType { get; set; }

        /// <summary>
        /// Gets or sets the Azure AD object ID of the user or group being
        /// specified in the access control list (ACL) entry.
        /// </summary>
        [JsonProperty(PropertyName = "principalId")]
        public System.Guid PrincipalId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (AceType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AceType");
            }
        }
    }
}
