// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Error diagnostic information for failed jobs.
    /// </summary>
    public partial class Diagnostics
    {
        /// <summary>
        /// Initializes a new instance of the Diagnostics class.
        /// </summary>
        public Diagnostics()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Diagnostics class.
        /// </summary>
        /// <param name="message">The error message.</param>
        /// <param name="severity">The severity of the error. Possible values
        /// include: 'Warning', 'Error', 'Info', 'SevereWarning', 'Deprecated',
        /// 'UserWarning'</param>
        /// <param name="lineNumber">The line number the error occurred
        /// on.</param>
        /// <param name="columnNumber">The column where the error
        /// occurred.</param>
        /// <param name="start">The starting index of the error.</param>
        /// <param name="end">The ending index of the error.</param>
        public Diagnostics(string message = default(string), SeverityTypes? severity = default(SeverityTypes?), int? lineNumber = default(int?), int? columnNumber = default(int?), int? start = default(int?), int? end = default(int?))
        {
            Message = message;
            Severity = severity;
            LineNumber = lineNumber;
            ColumnNumber = columnNumber;
            Start = start;
            End = end;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the error message.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; private set; }

        /// <summary>
        /// Gets the severity of the error. Possible values include: 'Warning',
        /// 'Error', 'Info', 'SevereWarning', 'Deprecated', 'UserWarning'
        /// </summary>
        [JsonProperty(PropertyName = "severity")]
        public SeverityTypes? Severity { get; private set; }

        /// <summary>
        /// Gets the line number the error occurred on.
        /// </summary>
        [JsonProperty(PropertyName = "lineNumber")]
        public int? LineNumber { get; private set; }

        /// <summary>
        /// Gets the column where the error occurred.
        /// </summary>
        [JsonProperty(PropertyName = "columnNumber")]
        public int? ColumnNumber { get; private set; }

        /// <summary>
        /// Gets the starting index of the error.
        /// </summary>
        [JsonProperty(PropertyName = "start")]
        public int? Start { get; private set; }

        /// <summary>
        /// Gets the ending index of the error.
        /// </summary>
        [JsonProperty(PropertyName = "end")]
        public int? End { get; private set; }

    }
}
