// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Data Lake Analytics firewall rule information.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class FirewallRule : SubResource
    {
        /// <summary>
        /// Initializes a new instance of the FirewallRule class.
        /// </summary>
        public FirewallRule()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the FirewallRule class.
        /// </summary>
        /// <param name="id">The resource identifier.</param>
        /// <param name="name">The resource name.</param>
        /// <param name="type">The resource type.</param>
        /// <param name="startIpAddress">The start IP address for the firewall
        /// rule. This can be either ipv4 or ipv6. Start and End should be in
        /// the same protocol.</param>
        /// <param name="endIpAddress">The end IP address for the firewall
        /// rule. This can be either ipv4 or ipv6. Start and End should be in
        /// the same protocol.</param>
        public FirewallRule(string id = default(string), string name = default(string), string type = default(string), string startIpAddress = default(string), string endIpAddress = default(string))
            : base(id, name, type)
        {
            StartIpAddress = startIpAddress;
            EndIpAddress = endIpAddress;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the start IP address for the firewall rule. This can be either
        /// ipv4 or ipv6. Start and End should be in the same protocol.
        /// </summary>
        [JsonProperty(PropertyName = "properties.startIpAddress")]
        public string StartIpAddress { get; private set; }

        /// <summary>
        /// Gets the end IP address for the firewall rule. This can be either
        /// ipv4 or ipv6. Start and End should be in the same protocol.
        /// </summary>
        [JsonProperty(PropertyName = "properties.endIpAddress")]
        public string EndIpAddress { get; private set; }

    }
}
