// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Hive job properties used when retrieving Hive jobs.
    /// </summary>
    [Newtonsoft.Json.JsonObject("Hive")]
    public partial class HiveJobProperties : JobProperties
    {
        /// <summary>
        /// Initializes a new instance of the HiveJobProperties class.
        /// </summary>
        public HiveJobProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the HiveJobProperties class.
        /// </summary>
        /// <param name="script">The script to run. Please note that the
        /// maximum script size is 3 MB.</param>
        /// <param name="runtimeVersion">The runtime version of the Data Lake
        /// Analytics engine to use for the specific type of job being
        /// run.</param>
        /// <param name="logsLocation">The Hive logs location.</param>
        /// <param name="outputLocation">The location of Hive job output files
        /// (both execution output and results).</param>
        /// <param name="statementCount">The number of statements that will be
        /// run based on the script.</param>
        /// <param name="executedStatementCount">The number of statements that
        /// have been run based on the script.</param>
        public HiveJobProperties(string script, string runtimeVersion = default(string), string logsLocation = default(string), string outputLocation = default(string), int? statementCount = default(int?), int? executedStatementCount = default(int?))
            : base(script, runtimeVersion)
        {
            LogsLocation = logsLocation;
            OutputLocation = outputLocation;
            StatementCount = statementCount;
            ExecutedStatementCount = executedStatementCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the Hive logs location.
        /// </summary>
        [JsonProperty(PropertyName = "logsLocation")]
        public string LogsLocation { get; private set; }

        /// <summary>
        /// Gets the location of Hive job output files (both execution output
        /// and results).
        /// </summary>
        [JsonProperty(PropertyName = "outputLocation")]
        public string OutputLocation { get; private set; }

        /// <summary>
        /// Gets the number of statements that will be run based on the script.
        /// </summary>
        [JsonProperty(PropertyName = "statementCount")]
        public int? StatementCount { get; private set; }

        /// <summary>
        /// Gets the number of statements that have been run based on the
        /// script.
        /// </summary>
        [JsonProperty(PropertyName = "executedStatementCount")]
        public int? ExecutedStatementCount { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
