// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Job relationship information properties including pipeline information,
    /// correlation information, etc.
    /// </summary>
    public partial class JobRelationshipProperties
    {
        /// <summary>
        /// Initializes a new instance of the JobRelationshipProperties class.
        /// </summary>
        public JobRelationshipProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JobRelationshipProperties class.
        /// </summary>
        /// <param name="recurrenceId">The recurrence identifier (a GUID),
        /// unique per activity/script, regardless of iterations. This is
        /// something to link different occurrences of the same job
        /// together.</param>
        /// <param name="pipelineId">The job relationship pipeline identifier
        /// (a GUID).</param>
        /// <param name="pipelineName">The friendly name of the job
        /// relationship pipeline, which does not need to be unique.</param>
        /// <param name="pipelineUri">The pipeline uri, unique, links to the
        /// originating service for this pipeline.</param>
        /// <param name="runId">The run identifier (a GUID), unique identifier
        /// of the iteration of this pipeline.</param>
        /// <param name="recurrenceName">The recurrence name, user friendly
        /// name for the correlation between jobs.</param>
        public JobRelationshipProperties(System.Guid recurrenceId, System.Guid? pipelineId = default(System.Guid?), string pipelineName = default(string), string pipelineUri = default(string), System.Guid? runId = default(System.Guid?), string recurrenceName = default(string))
        {
            PipelineId = pipelineId;
            PipelineName = pipelineName;
            PipelineUri = pipelineUri;
            RunId = runId;
            RecurrenceId = recurrenceId;
            RecurrenceName = recurrenceName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the job relationship pipeline identifier (a GUID).
        /// </summary>
        [JsonProperty(PropertyName = "pipelineId")]
        public System.Guid? PipelineId { get; set; }

        /// <summary>
        /// Gets or sets the friendly name of the job relationship pipeline,
        /// which does not need to be unique.
        /// </summary>
        [JsonProperty(PropertyName = "pipelineName")]
        public string PipelineName { get; set; }

        /// <summary>
        /// Gets or sets the pipeline uri, unique, links to the originating
        /// service for this pipeline.
        /// </summary>
        [JsonProperty(PropertyName = "pipelineUri")]
        public string PipelineUri { get; set; }

        /// <summary>
        /// Gets or sets the run identifier (a GUID), unique identifier of the
        /// iteration of this pipeline.
        /// </summary>
        [JsonProperty(PropertyName = "runId")]
        public System.Guid? RunId { get; set; }

        /// <summary>
        /// Gets or sets the recurrence identifier (a GUID), unique per
        /// activity/script, regardless of iterations. This is something to
        /// link different occurrences of the same job together.
        /// </summary>
        [JsonProperty(PropertyName = "recurrenceId")]
        public System.Guid RecurrenceId { get; set; }

        /// <summary>
        /// Gets or sets the recurrence name, user friendly name for the
        /// correlation between jobs.
        /// </summary>
        [JsonProperty(PropertyName = "recurrenceName")]
        public string RecurrenceName { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (PipelineName != null)
            {
                if (PipelineName.Length > 260)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "PipelineName", 260);
                }
            }
            if (RecurrenceName != null)
            {
                if (RecurrenceName.Length > 260)
                {
                    throw new ValidationException(ValidationRules.MaxLength, "RecurrenceName", 260);
                }
            }
        }
    }
}
