// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A Data Lake Analytics catalog U-SQL distribution information object.
    /// </summary>
    public partial class USqlDistributionInfo
    {
        /// <summary>
        /// Initializes a new instance of the USqlDistributionInfo class.
        /// </summary>
        public USqlDistributionInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the USqlDistributionInfo class.
        /// </summary>
        /// <param name="type">the type of this distribution.</param>
        /// <param name="keys">the list of directed columns in the
        /// distribution</param>
        /// <param name="count">the count of indices using this
        /// distribution.</param>
        /// <param name="dynamicCount">the dynamic count of indices using this
        /// distribution.</param>
        public USqlDistributionInfo(int? type = default(int?), IList<USqlDirectedColumn> keys = default(IList<USqlDirectedColumn>), int? count = default(int?), int? dynamicCount = default(int?))
        {
            Type = type;
            Keys = keys;
            Count = count;
            DynamicCount = dynamicCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the type of this distribution.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public int? Type { get; set; }

        /// <summary>
        /// Gets or sets the list of directed columns in the distribution
        /// </summary>
        [JsonProperty(PropertyName = "keys")]
        public IList<USqlDirectedColumn> Keys { get; set; }

        /// <summary>
        /// Gets or sets the count of indices using this distribution.
        /// </summary>
        [JsonProperty(PropertyName = "count")]
        public int? Count { get; set; }

        /// <summary>
        /// Gets or sets the dynamic count of indices using this distribution.
        /// </summary>
        [JsonProperty(PropertyName = "dynamicCount")]
        public int? DynamicCount { get; set; }

    }
}
