// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A Data Lake Analytics catalog U-SQL table index item.
    /// </summary>
    public partial class USqlIndex
    {
        /// <summary>
        /// Initializes a new instance of the USqlIndex class.
        /// </summary>
        public USqlIndex()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the USqlIndex class.
        /// </summary>
        /// <param name="name">the name of the index in the table.</param>
        /// <param name="indexKeys">the list of directed columns in the
        /// index</param>
        /// <param name="columns">the list of columns in the index</param>
        /// <param name="distributionInfo">the distributions info of the
        /// index</param>
        /// <param name="partitionFunction">partition function ID for the
        /// index.</param>
        /// <param name="partitionKeyList">the list of partition keys in the
        /// index</param>
        /// <param name="streamNames">the list of full paths to the streams
        /// that contain this index in the DataLake account.</param>
        /// <param name="isColumnstore">the switch indicating if this index is
        /// a columnstore index.</param>
        /// <param name="indexId">the ID of this index within the
        /// table.</param>
        /// <param name="isUnique">the switch indicating if this index is a
        /// unique index.</param>
        public USqlIndex(string name = default(string), IList<USqlDirectedColumn> indexKeys = default(IList<USqlDirectedColumn>), IList<string> columns = default(IList<string>), USqlDistributionInfo distributionInfo = default(USqlDistributionInfo), System.Guid? partitionFunction = default(System.Guid?), IList<string> partitionKeyList = default(IList<string>), IList<string> streamNames = default(IList<string>), bool? isColumnstore = default(bool?), int? indexId = default(int?), bool? isUnique = default(bool?))
        {
            Name = name;
            IndexKeys = indexKeys;
            Columns = columns;
            DistributionInfo = distributionInfo;
            PartitionFunction = partitionFunction;
            PartitionKeyList = partitionKeyList;
            StreamNames = streamNames;
            IsColumnstore = isColumnstore;
            IndexId = indexId;
            IsUnique = isUnique;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the index in the table.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the list of directed columns in the index
        /// </summary>
        [JsonProperty(PropertyName = "indexKeys")]
        public IList<USqlDirectedColumn> IndexKeys { get; set; }

        /// <summary>
        /// Gets or sets the list of columns in the index
        /// </summary>
        [JsonProperty(PropertyName = "columns")]
        public IList<string> Columns { get; set; }

        /// <summary>
        /// Gets or sets the distributions info of the index
        /// </summary>
        [JsonProperty(PropertyName = "distributionInfo")]
        public USqlDistributionInfo DistributionInfo { get; set; }

        /// <summary>
        /// Gets or sets partition function ID for the index.
        /// </summary>
        [JsonProperty(PropertyName = "partitionFunction")]
        public System.Guid? PartitionFunction { get; set; }

        /// <summary>
        /// Gets or sets the list of partition keys in the index
        /// </summary>
        [JsonProperty(PropertyName = "partitionKeyList")]
        public IList<string> PartitionKeyList { get; set; }

        /// <summary>
        /// Gets or sets the list of full paths to the streams that contain
        /// this index in the DataLake account.
        /// </summary>
        [JsonProperty(PropertyName = "streamNames")]
        public IList<string> StreamNames { get; set; }

        /// <summary>
        /// Gets or sets the switch indicating if this index is a columnstore
        /// index.
        /// </summary>
        [JsonProperty(PropertyName = "isColumnstore")]
        public bool? IsColumnstore { get; set; }

        /// <summary>
        /// Gets or sets the ID of this index within the table.
        /// </summary>
        [JsonProperty(PropertyName = "indexId")]
        public int? IndexId { get; set; }

        /// <summary>
        /// Gets or sets the switch indicating if this index is a unique index.
        /// </summary>
        [JsonProperty(PropertyName = "isUnique")]
        public bool? IsUnique { get; set; }

    }
}
