// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters used to update a firewall rule while updating a Data
    /// Lake Analytics account.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class UpdateFirewallRuleWithAccountParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// UpdateFirewallRuleWithAccountParameters class.
        /// </summary>
        public UpdateFirewallRuleWithAccountParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// UpdateFirewallRuleWithAccountParameters class.
        /// </summary>
        /// <param name="name">The unique name of the firewall rule to
        /// update.</param>
        /// <param name="startIpAddress">The start IP address for the firewall
        /// rule. This can be either ipv4 or ipv6. Start and End should be in
        /// the same protocol.</param>
        /// <param name="endIpAddress">The end IP address for the firewall
        /// rule. This can be either ipv4 or ipv6. Start and End should be in
        /// the same protocol.</param>
        public UpdateFirewallRuleWithAccountParameters(string name, string startIpAddress = default(string), string endIpAddress = default(string))
        {
            Name = name;
            StartIpAddress = startIpAddress;
            EndIpAddress = endIpAddress;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the unique name of the firewall rule to update.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the start IP address for the firewall rule. This can
        /// be either ipv4 or ipv6. Start and End should be in the same
        /// protocol.
        /// </summary>
        [JsonProperty(PropertyName = "properties.startIpAddress")]
        public string StartIpAddress { get; set; }

        /// <summary>
        /// Gets or sets the end IP address for the firewall rule. This can be
        /// either ipv4 or ipv6. Start and End should be in the same protocol.
        /// </summary>
        [JsonProperty(PropertyName = "properties.endIpAddress")]
        public string EndIpAddress { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
        }
    }
}
