// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Analytics
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for RecurrenceOperations.
    /// </summary>
    public static partial class RecurrenceOperationsExtensions
    {
            /// <summary>
            /// Lists all recurrences.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account to execute job operations on.
            /// </param>
            /// <param name='startDateTime'>
            /// The start date for when to get the list of recurrences. The startDateTime
            /// and endDateTime can be no more than 30 days apart.
            /// </param>
            /// <param name='endDateTime'>
            /// The end date for when to get the list of recurrences. The startDateTime and
            /// endDateTime can be no more than 30 days apart.
            /// </param>
            public static IPage<JobRecurrenceInformation> List(this IRecurrenceOperations operations, string accountName, System.DateTimeOffset? startDateTime = default(System.DateTimeOffset?), System.DateTimeOffset? endDateTime = default(System.DateTimeOffset?))
            {
                return operations.ListAsync(accountName, startDateTime, endDateTime).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists all recurrences.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account to execute job operations on.
            /// </param>
            /// <param name='startDateTime'>
            /// The start date for when to get the list of recurrences. The startDateTime
            /// and endDateTime can be no more than 30 days apart.
            /// </param>
            /// <param name='endDateTime'>
            /// The end date for when to get the list of recurrences. The startDateTime and
            /// endDateTime can be no more than 30 days apart.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<JobRecurrenceInformation>> ListAsync(this IRecurrenceOperations operations, string accountName, System.DateTimeOffset? startDateTime = default(System.DateTimeOffset?), System.DateTimeOffset? endDateTime = default(System.DateTimeOffset?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(accountName, startDateTime, endDateTime, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the recurrence information for the specified recurrence ID.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account to execute job operations on.
            /// </param>
            /// <param name='recurrenceIdentity'>
            /// Recurrence ID.
            /// </param>
            /// <param name='startDateTime'>
            /// The start date for when to get the recurrence and aggregate its data. The
            /// startDateTime and endDateTime can be no more than 30 days apart.
            /// </param>
            /// <param name='endDateTime'>
            /// The end date for when to get recurrence and aggregate its data. The
            /// startDateTime and endDateTime can be no more than 30 days apart.
            /// </param>
            public static JobRecurrenceInformation Get(this IRecurrenceOperations operations, string accountName, System.Guid recurrenceIdentity, System.DateTimeOffset? startDateTime = default(System.DateTimeOffset?), System.DateTimeOffset? endDateTime = default(System.DateTimeOffset?))
            {
                return operations.GetAsync(accountName, recurrenceIdentity, startDateTime, endDateTime).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the recurrence information for the specified recurrence ID.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='accountName'>
            /// The Azure Data Lake Analytics account to execute job operations on.
            /// </param>
            /// <param name='recurrenceIdentity'>
            /// Recurrence ID.
            /// </param>
            /// <param name='startDateTime'>
            /// The start date for when to get the recurrence and aggregate its data. The
            /// startDateTime and endDateTime can be no more than 30 days apart.
            /// </param>
            /// <param name='endDateTime'>
            /// The end date for when to get recurrence and aggregate its data. The
            /// startDateTime and endDateTime can be no more than 30 days apart.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<JobRecurrenceInformation> GetAsync(this IRecurrenceOperations operations, string accountName, System.Guid recurrenceIdentity, System.DateTimeOffset? startDateTime = default(System.DateTimeOffset?), System.DateTimeOffset? endDateTime = default(System.DateTimeOffset?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(accountName, recurrenceIdentity, startDateTime, endDateTime, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists all recurrences.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<JobRecurrenceInformation> ListNext(this IRecurrenceOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists all recurrences.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<JobRecurrenceInformation>> ListNextAsync(this IRecurrenceOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
