// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Store.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Data Lake Store account information to update.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class UpdateDataLakeStoreAccountParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// UpdateDataLakeStoreAccountParameters class.
        /// </summary>
        public UpdateDataLakeStoreAccountParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// UpdateDataLakeStoreAccountParameters class.
        /// </summary>
        /// <param name="tags">Resource tags</param>
        /// <param name="defaultGroup">The default owner group for all new
        /// folders and files created in the Data Lake Store account.</param>
        /// <param name="encryptionConfig">Used for rotation of user managed
        /// Key Vault keys. Can only be used to rotate a user managed
        /// encryption Key Vault key.</param>
        /// <param name="firewallRules">The list of firewall rules associated
        /// with this Data Lake Store account.</param>
        /// <param name="virtualNetworkRules">The list of virtual network rules
        /// associated with this Data Lake Store account.</param>
        /// <param name="firewallState">The current state of the IP address
        /// firewall for this Data Lake Store account. Disabling the firewall
        /// does not remove existing rules, they will just be ignored until the
        /// firewall is re-enabled. Possible values include: 'Enabled',
        /// 'Disabled'</param>
        /// <param name="firewallAllowAzureIps">The current state of allowing
        /// or disallowing IPs originating within Azure through the firewall.
        /// If the firewall is disabled, this is not enforced. Possible values
        /// include: 'Enabled', 'Disabled'</param>
        /// <param name="trustedIdProviders">The list of trusted identity
        /// providers associated with this Data Lake Store account.</param>
        /// <param name="trustedIdProviderState">The current state of the
        /// trusted identity provider feature for this Data Lake Store account.
        /// Disabling trusted identity provider functionality does not remove
        /// the providers, they will just be ignored until this feature is
        /// re-enabled. Possible values include: 'Enabled', 'Disabled'</param>
        /// <param name="newTier">The commitment tier to use for next month.
        /// Possible values include: 'Consumption', 'Commitment_1TB',
        /// 'Commitment_10TB', 'Commitment_100TB', 'Commitment_500TB',
        /// 'Commitment_1PB', 'Commitment_5PB'</param>
        public UpdateDataLakeStoreAccountParameters(IDictionary<string, string> tags = default(IDictionary<string, string>), string defaultGroup = default(string), UpdateEncryptionConfig encryptionConfig = default(UpdateEncryptionConfig), IList<UpdateFirewallRuleWithAccountParameters> firewallRules = default(IList<UpdateFirewallRuleWithAccountParameters>), IList<UpdateVirtualNetworkRuleWithAccountParameters> virtualNetworkRules = default(IList<UpdateVirtualNetworkRuleWithAccountParameters>), FirewallState? firewallState = default(FirewallState?), FirewallAllowAzureIpsState? firewallAllowAzureIps = default(FirewallAllowAzureIpsState?), IList<UpdateTrustedIdProviderWithAccountParameters> trustedIdProviders = default(IList<UpdateTrustedIdProviderWithAccountParameters>), TrustedIdProviderState? trustedIdProviderState = default(TrustedIdProviderState?), TierType? newTier = default(TierType?))
        {
            Tags = tags;
            DefaultGroup = defaultGroup;
            EncryptionConfig = encryptionConfig;
            FirewallRules = firewallRules;
            VirtualNetworkRules = virtualNetworkRules;
            FirewallState = firewallState;
            FirewallAllowAzureIps = firewallAllowAzureIps;
            TrustedIdProviders = trustedIdProviders;
            TrustedIdProviderState = trustedIdProviderState;
            NewTier = newTier;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets resource tags
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets or sets the default owner group for all new folders and files
        /// created in the Data Lake Store account.
        /// </summary>
        [JsonProperty(PropertyName = "properties.defaultGroup")]
        public string DefaultGroup { get; set; }

        /// <summary>
        /// Gets or sets used for rotation of user managed Key Vault keys. Can
        /// only be used to rotate a user managed encryption Key Vault key.
        /// </summary>
        [JsonProperty(PropertyName = "properties.encryptionConfig")]
        public UpdateEncryptionConfig EncryptionConfig { get; set; }

        /// <summary>
        /// Gets or sets the list of firewall rules associated with this Data
        /// Lake Store account.
        /// </summary>
        [JsonProperty(PropertyName = "properties.firewallRules")]
        public IList<UpdateFirewallRuleWithAccountParameters> FirewallRules { get; set; }

        /// <summary>
        /// Gets or sets the list of virtual network rules associated with this
        /// Data Lake Store account.
        /// </summary>
        [JsonProperty(PropertyName = "properties.virtualNetworkRules")]
        public IList<UpdateVirtualNetworkRuleWithAccountParameters> VirtualNetworkRules { get; set; }

        /// <summary>
        /// Gets or sets the current state of the IP address firewall for this
        /// Data Lake Store account. Disabling the firewall does not remove
        /// existing rules, they will just be ignored until the firewall is
        /// re-enabled. Possible values include: 'Enabled', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.firewallState")]
        public FirewallState? FirewallState { get; set; }

        /// <summary>
        /// Gets or sets the current state of allowing or disallowing IPs
        /// originating within Azure through the firewall. If the firewall is
        /// disabled, this is not enforced. Possible values include: 'Enabled',
        /// 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.firewallAllowAzureIps")]
        public FirewallAllowAzureIpsState? FirewallAllowAzureIps { get; set; }

        /// <summary>
        /// Gets or sets the list of trusted identity providers associated with
        /// this Data Lake Store account.
        /// </summary>
        [JsonProperty(PropertyName = "properties.trustedIdProviders")]
        public IList<UpdateTrustedIdProviderWithAccountParameters> TrustedIdProviders { get; set; }

        /// <summary>
        /// Gets or sets the current state of the trusted identity provider
        /// feature for this Data Lake Store account. Disabling trusted
        /// identity provider functionality does not remove the providers, they
        /// will just be ignored until this feature is re-enabled. Possible
        /// values include: 'Enabled', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.trustedIdProviderState")]
        public TrustedIdProviderState? TrustedIdProviderState { get; set; }

        /// <summary>
        /// Gets or sets the commitment tier to use for next month. Possible
        /// values include: 'Consumption', 'Commitment_1TB', 'Commitment_10TB',
        /// 'Commitment_100TB', 'Commitment_500TB', 'Commitment_1PB',
        /// 'Commitment_5PB'
        /// </summary>
        [JsonProperty(PropertyName = "properties.newTier")]
        public TierType? NewTier { get; set; }

    }
}
