// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataLake.Store.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters used to update a trusted identity provider while
    /// updating a Data Lake Store account.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class UpdateTrustedIdProviderWithAccountParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// UpdateTrustedIdProviderWithAccountParameters class.
        /// </summary>
        public UpdateTrustedIdProviderWithAccountParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// UpdateTrustedIdProviderWithAccountParameters class.
        /// </summary>
        /// <param name="name">The unique name of the trusted identity provider
        /// to update.</param>
        /// <param name="idProvider">The URL of this trusted identity
        /// provider.</param>
        public UpdateTrustedIdProviderWithAccountParameters(string name, string idProvider = default(string))
        {
            Name = name;
            IdProvider = idProvider;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the unique name of the trusted identity provider to
        /// update.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the URL of this trusted identity provider.
        /// </summary>
        [JsonProperty(PropertyName = "properties.idProvider")]
        public string IdProvider { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
        }
    }
}
