// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Information of the backup file
    /// </summary>
    public partial class BackupFileInfo
    {
        /// <summary>
        /// Initializes a new instance of the BackupFileInfo class.
        /// </summary>
        public BackupFileInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BackupFileInfo class.
        /// </summary>
        /// <param name="fileLocation">Location of the backup file in shared
        /// folder</param>
        /// <param name="familySequenceNumber">Sequence number of the backup
        /// file in the backup set</param>
        /// <param name="status">Status of the backup file during migration.
        /// Possible values include: 'Arrived', 'Queued', 'Uploading',
        /// 'Uploaded', 'Restoring', 'Restored', 'Cancelled'</param>
        public BackupFileInfo(string fileLocation = default(string), int? familySequenceNumber = default(int?), string status = default(string))
        {
            FileLocation = fileLocation;
            FamilySequenceNumber = familySequenceNumber;
            Status = status;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets location of the backup file in shared folder
        /// </summary>
        [JsonProperty(PropertyName = "fileLocation")]
        public string FileLocation { get; set; }

        /// <summary>
        /// Gets or sets sequence number of the backup file in the backup set
        /// </summary>
        [JsonProperty(PropertyName = "familySequenceNumber")]
        public int? FamilySequenceNumber { get; set; }

        /// <summary>
        /// Gets or sets status of the backup file during migration. Possible
        /// values include: 'Arrived', 'Queued', 'Uploading', 'Uploaded',
        /// 'Restoring', 'Restored', 'Cancelled'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

    }
}
