// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Input for the task that validates MySQL database connection
    /// </summary>
    public partial class ConnectToSourceMySqlTaskInput
    {
        /// <summary>
        /// Initializes a new instance of the ConnectToSourceMySqlTaskInput
        /// class.
        /// </summary>
        public ConnectToSourceMySqlTaskInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ConnectToSourceMySqlTaskInput
        /// class.
        /// </summary>
        /// <param name="sourceConnectionInfo">Information for connecting to
        /// MySQL source</param>
        /// <param name="targetPlatform">Target Platform for the migration.
        /// Possible values include: 'SqlServer', 'AzureDbForMySQL'</param>
        /// <param name="checkPermissionsGroup">Permission group for
        /// validations. Possible values include: 'Default',
        /// 'MigrationFromSqlServerToAzureDB',
        /// 'MigrationFromSqlServerToAzureMI',
        /// 'MigrationFromMySQLToAzureDBForMySQL'</param>
        public ConnectToSourceMySqlTaskInput(MySqlConnectionInfo sourceConnectionInfo, string targetPlatform = default(string), ServerLevelPermissionsGroup? checkPermissionsGroup = default(ServerLevelPermissionsGroup?))
        {
            SourceConnectionInfo = sourceConnectionInfo;
            TargetPlatform = targetPlatform;
            CheckPermissionsGroup = checkPermissionsGroup;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets information for connecting to MySQL source
        /// </summary>
        [JsonProperty(PropertyName = "sourceConnectionInfo")]
        public MySqlConnectionInfo SourceConnectionInfo { get; set; }

        /// <summary>
        /// Gets or sets target Platform for the migration. Possible values
        /// include: 'SqlServer', 'AzureDbForMySQL'
        /// </summary>
        [JsonProperty(PropertyName = "targetPlatform")]
        public string TargetPlatform { get; set; }

        /// <summary>
        /// Gets or sets permission group for validations. Possible values
        /// include: 'Default', 'MigrationFromSqlServerToAzureDB',
        /// 'MigrationFromSqlServerToAzureMI',
        /// 'MigrationFromMySQLToAzureDBForMySQL'
        /// </summary>
        [JsonProperty(PropertyName = "checkPermissionsGroup")]
        public ServerLevelPermissionsGroup? CheckPermissionsGroup { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SourceConnectionInfo == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SourceConnectionInfo");
            }
            if (SourceConnectionInfo != null)
            {
                SourceConnectionInfo.Validate();
            }
        }
    }
}
