// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Input for the task that validates connection to PostgreSQL and source
    /// server requirements
    /// </summary>
    public partial class ConnectToSourcePostgreSqlSyncTaskInput
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ConnectToSourcePostgreSqlSyncTaskInput class.
        /// </summary>
        public ConnectToSourcePostgreSqlSyncTaskInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ConnectToSourcePostgreSqlSyncTaskInput class.
        /// </summary>
        /// <param name="sourceConnectionInfo">Connection information for
        /// source PostgreSQL server</param>
        public ConnectToSourcePostgreSqlSyncTaskInput(PostgreSqlConnectionInfo sourceConnectionInfo)
        {
            SourceConnectionInfo = sourceConnectionInfo;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets connection information for source PostgreSQL server
        /// </summary>
        [JsonProperty(PropertyName = "sourceConnectionInfo")]
        public PostgreSqlConnectionInfo SourceConnectionInfo { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SourceConnectionInfo == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SourceConnectionInfo");
            }
            if (SourceConnectionInfo != null)
            {
                SourceConnectionInfo.Validate();
            }
        }
    }
}
