// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Agent Job level output for the task that validates connection to SQL
    /// Server and also validates source server requirements
    /// </summary>
    [Newtonsoft.Json.JsonObject("AgentJobLevelOutput")]
    public partial class ConnectToSourceSqlServerTaskOutputAgentJobLevel : ConnectToSourceSqlServerTaskOutput
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ConnectToSourceSqlServerTaskOutputAgentJobLevel class.
        /// </summary>
        public ConnectToSourceSqlServerTaskOutputAgentJobLevel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ConnectToSourceSqlServerTaskOutputAgentJobLevel class.
        /// </summary>
        /// <param name="id">Result identifier</param>
        /// <param name="name">Agent Job name</param>
        /// <param name="jobCategory">The type of Agent Job.</param>
        /// <param name="isEnabled">The state of the original Agent
        /// Job.</param>
        /// <param name="jobOwner">The owner of the Agent Job</param>
        /// <param name="lastExecutedOn">UTC Date and time when the Agent Job
        /// was last executed.</param>
        /// <param name="validationErrors">Validation errors</param>
        /// <param name="migrationEligibility">Information about eligibility of
        /// agent job for migration.</param>
        public ConnectToSourceSqlServerTaskOutputAgentJobLevel(string id = default(string), string name = default(string), string jobCategory = default(string), bool? isEnabled = default(bool?), string jobOwner = default(string), System.DateTimeOffset? lastExecutedOn = default(System.DateTimeOffset?), IList<ReportableException> validationErrors = default(IList<ReportableException>), MigrationEligibilityInfo migrationEligibility = default(MigrationEligibilityInfo))
            : base(id)
        {
            Name = name;
            JobCategory = jobCategory;
            IsEnabled = isEnabled;
            JobOwner = jobOwner;
            LastExecutedOn = lastExecutedOn;
            ValidationErrors = validationErrors;
            MigrationEligibility = migrationEligibility;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets agent Job name
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets the type of Agent Job.
        /// </summary>
        [JsonProperty(PropertyName = "jobCategory")]
        public string JobCategory { get; private set; }

        /// <summary>
        /// Gets the state of the original Agent Job.
        /// </summary>
        [JsonProperty(PropertyName = "isEnabled")]
        public bool? IsEnabled { get; private set; }

        /// <summary>
        /// Gets the owner of the Agent Job
        /// </summary>
        [JsonProperty(PropertyName = "jobOwner")]
        public string JobOwner { get; private set; }

        /// <summary>
        /// Gets UTC Date and time when the Agent Job was last executed.
        /// </summary>
        [JsonProperty(PropertyName = "lastExecutedOn")]
        public System.DateTimeOffset? LastExecutedOn { get; private set; }

        /// <summary>
        /// Gets validation errors
        /// </summary>
        [JsonProperty(PropertyName = "validationErrors")]
        public IList<ReportableException> ValidationErrors { get; private set; }

        /// <summary>
        /// Gets information about eligibility of agent job for migration.
        /// </summary>
        [JsonProperty(PropertyName = "migrationEligibility")]
        public MigrationEligibilityInfo MigrationEligibility { get; private set; }

    }
}
