// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Output for the task that validates connection to Azure SQL Database
    /// Managed Instance.
    /// </summary>
    public partial class ConnectToTargetSqlMITaskOutput
    {
        /// <summary>
        /// Initializes a new instance of the ConnectToTargetSqlMITaskOutput
        /// class.
        /// </summary>
        public ConnectToTargetSqlMITaskOutput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ConnectToTargetSqlMITaskOutput
        /// class.
        /// </summary>
        /// <param name="id">Result identifier</param>
        /// <param name="targetServerVersion">Target server version</param>
        /// <param name="targetServerBrandVersion">Target server brand
        /// version</param>
        /// <param name="logins">List of logins on the target server.</param>
        /// <param name="agentJobs">List of agent jobs on the target
        /// server.</param>
        /// <param name="validationErrors">Validation errors</param>
        public ConnectToTargetSqlMITaskOutput(string id = default(string), string targetServerVersion = default(string), string targetServerBrandVersion = default(string), IList<string> logins = default(IList<string>), IList<string> agentJobs = default(IList<string>), IList<ReportableException> validationErrors = default(IList<ReportableException>))
        {
            Id = id;
            TargetServerVersion = targetServerVersion;
            TargetServerBrandVersion = targetServerBrandVersion;
            Logins = logins;
            AgentJobs = agentJobs;
            ValidationErrors = validationErrors;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets result identifier
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets target server version
        /// </summary>
        [JsonProperty(PropertyName = "targetServerVersion")]
        public string TargetServerVersion { get; private set; }

        /// <summary>
        /// Gets target server brand version
        /// </summary>
        [JsonProperty(PropertyName = "targetServerBrandVersion")]
        public string TargetServerBrandVersion { get; private set; }

        /// <summary>
        /// Gets list of logins on the target server.
        /// </summary>
        [JsonProperty(PropertyName = "logins")]
        public IList<string> Logins { get; private set; }

        /// <summary>
        /// Gets list of agent jobs on the target server.
        /// </summary>
        [JsonProperty(PropertyName = "agentJobs")]
        public IList<string> AgentJobs { get; private set; }

        /// <summary>
        /// Gets validation errors
        /// </summary>
        [JsonProperty(PropertyName = "validationErrors")]
        public IList<ReportableException> ValidationErrors { get; private set; }

    }
}
