// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Service health status
    /// </summary>
    public partial class DataMigrationServiceStatusResponse
    {
        /// <summary>
        /// Initializes a new instance of the
        /// DataMigrationServiceStatusResponse class.
        /// </summary>
        public DataMigrationServiceStatusResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// DataMigrationServiceStatusResponse class.
        /// </summary>
        /// <param name="agentVersion">The DMS instance agent version</param>
        /// <param name="status">The machine-readable status, such as
        /// 'Initializing', 'Offline', 'Online', 'Deploying', 'Deleting',
        /// 'Stopped', 'Stopping', 'Starting', 'FailedToStart', 'FailedToStop'
        /// or 'Failed'</param>
        /// <param name="vmSize">The services virtual machine size, such as
        /// 'Standard_D2_v2'</param>
        /// <param name="supportedTaskTypes">The list of supported task
        /// types</param>
        public DataMigrationServiceStatusResponse(string agentVersion = default(string), string status = default(string), string vmSize = default(string), IList<string> supportedTaskTypes = default(IList<string>))
        {
            AgentVersion = agentVersion;
            Status = status;
            VmSize = vmSize;
            SupportedTaskTypes = supportedTaskTypes;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the DMS instance agent version
        /// </summary>
        [JsonProperty(PropertyName = "agentVersion")]
        public string AgentVersion { get; set; }

        /// <summary>
        /// Gets or sets the machine-readable status, such as 'Initializing',
        /// 'Offline', 'Online', 'Deploying', 'Deleting', 'Stopped',
        /// 'Stopping', 'Starting', 'FailedToStart', 'FailedToStop' or 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets the services virtual machine size, such as
        /// 'Standard_D2_v2'
        /// </summary>
        [JsonProperty(PropertyName = "vmSize")]
        public string VmSize { get; set; }

        /// <summary>
        /// Gets or sets the list of supported task types
        /// </summary>
        [JsonProperty(PropertyName = "supportedTaskTypes")]
        public IList<string> SupportedTaskTypes { get; set; }

    }
}
