// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Input for the task that collects user tables for the given list of
    /// databases
    /// </summary>
    public partial class GetUserTablesSqlSyncTaskInput
    {
        /// <summary>
        /// Initializes a new instance of the GetUserTablesSqlSyncTaskInput
        /// class.
        /// </summary>
        public GetUserTablesSqlSyncTaskInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GetUserTablesSqlSyncTaskInput
        /// class.
        /// </summary>
        /// <param name="sourceConnectionInfo">Connection information for SQL
        /// Server</param>
        /// <param name="targetConnectionInfo">Connection information for SQL
        /// DB</param>
        /// <param name="selectedSourceDatabases">List of source database names
        /// to collect tables for</param>
        /// <param name="selectedTargetDatabases">List of target database names
        /// to collect tables for</param>
        public GetUserTablesSqlSyncTaskInput(SqlConnectionInfo sourceConnectionInfo, SqlConnectionInfo targetConnectionInfo, IList<string> selectedSourceDatabases, IList<string> selectedTargetDatabases)
        {
            SourceConnectionInfo = sourceConnectionInfo;
            TargetConnectionInfo = targetConnectionInfo;
            SelectedSourceDatabases = selectedSourceDatabases;
            SelectedTargetDatabases = selectedTargetDatabases;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets connection information for SQL Server
        /// </summary>
        [JsonProperty(PropertyName = "sourceConnectionInfo")]
        public SqlConnectionInfo SourceConnectionInfo { get; set; }

        /// <summary>
        /// Gets or sets connection information for SQL DB
        /// </summary>
        [JsonProperty(PropertyName = "targetConnectionInfo")]
        public SqlConnectionInfo TargetConnectionInfo { get; set; }

        /// <summary>
        /// Gets or sets list of source database names to collect tables for
        /// </summary>
        [JsonProperty(PropertyName = "selectedSourceDatabases")]
        public IList<string> SelectedSourceDatabases { get; set; }

        /// <summary>
        /// Gets or sets list of target database names to collect tables for
        /// </summary>
        [JsonProperty(PropertyName = "selectedTargetDatabases")]
        public IList<string> SelectedTargetDatabases { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SourceConnectionInfo == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SourceConnectionInfo");
            }
            if (TargetConnectionInfo == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetConnectionInfo");
            }
            if (SelectedSourceDatabases == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SelectedSourceDatabases");
            }
            if (SelectedTargetDatabases == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SelectedTargetDatabases");
            }
            if (SourceConnectionInfo != null)
            {
                SourceConnectionInfo.Validate();
            }
            if (TargetConnectionInfo != null)
            {
                TargetConnectionInfo.Validate();
            }
        }
    }
}
