// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Database specific information for MySQL to Azure Database for MySQL
    /// migration task inputs
    /// </summary>
    public partial class MigrateMySqlAzureDbForMySqlSyncDatabaseInput
    {
        /// <summary>
        /// Initializes a new instance of the
        /// MigrateMySqlAzureDbForMySqlSyncDatabaseInput class.
        /// </summary>
        public MigrateMySqlAzureDbForMySqlSyncDatabaseInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// MigrateMySqlAzureDbForMySqlSyncDatabaseInput class.
        /// </summary>
        /// <param name="name">Name of the database</param>
        /// <param name="targetDatabaseName">Name of target database. Note:
        /// Target database will be truncated before starting
        /// migration.</param>
        /// <param name="migrationSetting">Migration settings which tune the
        /// migration behavior</param>
        /// <param name="sourceSetting">Source settings to tune source endpoint
        /// migration behavior</param>
        /// <param name="targetSetting">Target settings to tune target endpoint
        /// migration behavior</param>
        public MigrateMySqlAzureDbForMySqlSyncDatabaseInput(string name = default(string), string targetDatabaseName = default(string), IDictionary<string, string> migrationSetting = default(IDictionary<string, string>), IDictionary<string, string> sourceSetting = default(IDictionary<string, string>), IDictionary<string, string> targetSetting = default(IDictionary<string, string>))
        {
            Name = name;
            TargetDatabaseName = targetDatabaseName;
            MigrationSetting = migrationSetting;
            SourceSetting = sourceSetting;
            TargetSetting = targetSetting;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the database
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets name of target database. Note: Target database will be
        /// truncated before starting migration.
        /// </summary>
        [JsonProperty(PropertyName = "targetDatabaseName")]
        public string TargetDatabaseName { get; set; }

        /// <summary>
        /// Gets or sets migration settings which tune the migration behavior
        /// </summary>
        [JsonProperty(PropertyName = "migrationSetting")]
        public IDictionary<string, string> MigrationSetting { get; set; }

        /// <summary>
        /// Gets or sets source settings to tune source endpoint migration
        /// behavior
        /// </summary>
        [JsonProperty(PropertyName = "sourceSetting")]
        public IDictionary<string, string> SourceSetting { get; set; }

        /// <summary>
        /// Gets or sets target settings to tune target endpoint migration
        /// behavior
        /// </summary>
        [JsonProperty(PropertyName = "targetSetting")]
        public IDictionary<string, string> TargetSetting { get; set; }

    }
}
