// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Input for the task that migrates on-prem SQL Server databases to Azure
    /// SQL Database for online migrations
    /// </summary>
    public partial class MigrateSqlServerSqlDbSyncTaskInput : SqlMigrationTaskInput
    {
        /// <summary>
        /// Initializes a new instance of the
        /// MigrateSqlServerSqlDbSyncTaskInput class.
        /// </summary>
        public MigrateSqlServerSqlDbSyncTaskInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// MigrateSqlServerSqlDbSyncTaskInput class.
        /// </summary>
        /// <param name="sourceConnectionInfo">Information for connecting to
        /// source</param>
        /// <param name="targetConnectionInfo">Information for connecting to
        /// target</param>
        /// <param name="selectedDatabases">Databases to migrate</param>
        /// <param name="validationOptions">Validation options</param>
        public MigrateSqlServerSqlDbSyncTaskInput(SqlConnectionInfo sourceConnectionInfo, SqlConnectionInfo targetConnectionInfo, IList<MigrateSqlServerSqlDbSyncDatabaseInput> selectedDatabases, MigrationValidationOptions validationOptions = default(MigrationValidationOptions))
            : base(sourceConnectionInfo, targetConnectionInfo)
        {
            SelectedDatabases = selectedDatabases;
            ValidationOptions = validationOptions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets databases to migrate
        /// </summary>
        [JsonProperty(PropertyName = "selectedDatabases")]
        public IList<MigrateSqlServerSqlDbSyncDatabaseInput> SelectedDatabases { get; set; }

        /// <summary>
        /// Gets or sets validation options
        /// </summary>
        [JsonProperty(PropertyName = "validationOptions")]
        public MigrationValidationOptions ValidationOptions { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (SelectedDatabases == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SelectedDatabases");
            }
        }
    }
}
