// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    [Newtonsoft.Json.JsonObject("SsisProjectLevelOutput")]
    public partial class MigrateSsisTaskOutputProjectLevel : MigrateSsisTaskOutput
    {
        /// <summary>
        /// Initializes a new instance of the MigrateSsisTaskOutputProjectLevel
        /// class.
        /// </summary>
        public MigrateSsisTaskOutputProjectLevel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MigrateSsisTaskOutputProjectLevel
        /// class.
        /// </summary>
        /// <param name="id">Result identifier</param>
        /// <param name="folderName">Name of the folder</param>
        /// <param name="projectName">Name of the project</param>
        /// <param name="state">Current state of migration. Possible values
        /// include: 'None', 'InProgress', 'Failed', 'Warning', 'Completed',
        /// 'Skipped', 'Stopped'</param>
        /// <param name="stage">Stage of SSIS migration. Possible values
        /// include: 'None', 'Initialize', 'InProgress', 'Completed'</param>
        /// <param name="startedOn">Migration start time</param>
        /// <param name="endedOn">Migration end time</param>
        /// <param name="message">Migration progress message</param>
        /// <param name="exceptionsAndWarnings">Migration exceptions and
        /// warnings</param>
        public MigrateSsisTaskOutputProjectLevel(string id = default(string), string folderName = default(string), string projectName = default(string), string state = default(string), string stage = default(string), System.DateTimeOffset? startedOn = default(System.DateTimeOffset?), System.DateTimeOffset? endedOn = default(System.DateTimeOffset?), string message = default(string), IList<ReportableException> exceptionsAndWarnings = default(IList<ReportableException>))
            : base(id)
        {
            FolderName = folderName;
            ProjectName = projectName;
            State = state;
            Stage = stage;
            StartedOn = startedOn;
            EndedOn = endedOn;
            Message = message;
            ExceptionsAndWarnings = exceptionsAndWarnings;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets name of the folder
        /// </summary>
        [JsonProperty(PropertyName = "folderName")]
        public string FolderName { get; private set; }

        /// <summary>
        /// Gets name of the project
        /// </summary>
        [JsonProperty(PropertyName = "projectName")]
        public string ProjectName { get; private set; }

        /// <summary>
        /// Gets current state of migration. Possible values include: 'None',
        /// 'InProgress', 'Failed', 'Warning', 'Completed', 'Skipped',
        /// 'Stopped'
        /// </summary>
        [JsonProperty(PropertyName = "state")]
        public string State { get; private set; }

        /// <summary>
        /// Gets stage of SSIS migration. Possible values include: 'None',
        /// 'Initialize', 'InProgress', 'Completed'
        /// </summary>
        [JsonProperty(PropertyName = "stage")]
        public string Stage { get; private set; }

        /// <summary>
        /// Gets migration start time
        /// </summary>
        [JsonProperty(PropertyName = "startedOn")]
        public System.DateTimeOffset? StartedOn { get; private set; }

        /// <summary>
        /// Gets migration end time
        /// </summary>
        [JsonProperty(PropertyName = "endedOn")]
        public System.DateTimeOffset? EndedOn { get; private set; }

        /// <summary>
        /// Gets migration progress message
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; private set; }

        /// <summary>
        /// Gets migration exceptions and warnings
        /// </summary>
        [JsonProperty(PropertyName = "exceptionsAndWarnings")]
        public IList<ReportableException> ExceptionsAndWarnings { get; private set; }

    }
}
