// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes a connection to a MongoDB data source
    /// </summary>
    public partial class MongoDbConnectionInfo : ConnectionInfo
    {
        /// <summary>
        /// Initializes a new instance of the MongoDbConnectionInfo class.
        /// </summary>
        public MongoDbConnectionInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MongoDbConnectionInfo class.
        /// </summary>
        /// <param name="connectionString">A MongoDB connection string or blob
        /// container URL. The user name and password can be specified here or
        /// in the userName and password properties</param>
        /// <param name="userName">User name</param>
        /// <param name="password">Password credential.</param>
        public MongoDbConnectionInfo(string connectionString, string userName = default(string), string password = default(string))
            : base(userName, password)
        {
            ConnectionString = connectionString;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a MongoDB connection string or blob container URL. The
        /// user name and password can be specified here or in the userName and
        /// password properties
        /// </summary>
        [JsonProperty(PropertyName = "connectionString")]
        public string ConnectionString { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ConnectionString == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ConnectionString");
            }
        }
    }
}
