// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes an error or warning that occurred during a MongoDB migration
    /// </summary>
    public partial class MongoDbError
    {
        /// <summary>
        /// Initializes a new instance of the MongoDbError class.
        /// </summary>
        public MongoDbError()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MongoDbError class.
        /// </summary>
        /// <param name="code">The non-localized, machine-readable code that
        /// describes the error or warning</param>
        /// <param name="count">The number of times the error or warning has
        /// occurred</param>
        /// <param name="message">The localized, human-readable message that
        /// describes the error or warning</param>
        /// <param name="type">The type of error or warning. Possible values
        /// include: 'Error', 'ValidationError', 'Warning'</param>
        public MongoDbError(string code = default(string), int? count = default(int?), string message = default(string), string type = default(string))
        {
            Code = code;
            Count = count;
            Message = message;
            Type = type;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the non-localized, machine-readable code that
        /// describes the error or warning
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; set; }

        /// <summary>
        /// Gets or sets the number of times the error or warning has occurred
        /// </summary>
        [JsonProperty(PropertyName = "count")]
        public int? Count { get; set; }

        /// <summary>
        /// Gets or sets the localized, human-readable message that describes
        /// the error or warning
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

        /// <summary>
        /// Gets or sets the type of error or warning. Possible values include:
        /// 'Error', 'ValidationError', 'Warning'
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

    }
}
