// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Specifies resource limits for the migration
    /// </summary>
    public partial class MongoDbThrottlingSettings
    {
        /// <summary>
        /// Initializes a new instance of the MongoDbThrottlingSettings class.
        /// </summary>
        public MongoDbThrottlingSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MongoDbThrottlingSettings class.
        /// </summary>
        /// <param name="minFreeCpu">The percentage of CPU time that the
        /// migrator will try to avoid using, from 0 to 100</param>
        /// <param name="minFreeMemoryMb">The number of megabytes of RAM that
        /// the migrator will try to avoid using</param>
        /// <param name="maxParallelism">The maximum number of work items (e.g.
        /// collection copies) that will be processed in parallel</param>
        public MongoDbThrottlingSettings(int? minFreeCpu = default(int?), int? minFreeMemoryMb = default(int?), int? maxParallelism = default(int?))
        {
            MinFreeCpu = minFreeCpu;
            MinFreeMemoryMb = minFreeMemoryMb;
            MaxParallelism = maxParallelism;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the percentage of CPU time that the migrator will try
        /// to avoid using, from 0 to 100
        /// </summary>
        [JsonProperty(PropertyName = "minFreeCpu")]
        public int? MinFreeCpu { get; set; }

        /// <summary>
        /// Gets or sets the number of megabytes of RAM that the migrator will
        /// try to avoid using
        /// </summary>
        [JsonProperty(PropertyName = "minFreeMemoryMb")]
        public int? MinFreeMemoryMb { get; set; }

        /// <summary>
        /// Gets or sets the maximum number of work items (e.g. collection
        /// copies) that will be processed in parallel
        /// </summary>
        [JsonProperty(PropertyName = "maxParallelism")]
        public int? MaxParallelism { get; set; }

    }
}
