// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Indicates whether a proposed resource name is available
    /// </summary>
    public partial class NameAvailabilityResponse
    {
        /// <summary>
        /// Initializes a new instance of the NameAvailabilityResponse class.
        /// </summary>
        public NameAvailabilityResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the NameAvailabilityResponse class.
        /// </summary>
        /// <param name="nameAvailable">If true, the name is valid and
        /// available. If false, 'reason' describes why not.</param>
        /// <param name="reason">The reason why the name is not available, if
        /// nameAvailable is false. Possible values include: 'AlreadyExists',
        /// 'Invalid'</param>
        /// <param name="message">The localized reason why the name is not
        /// available, if nameAvailable is false</param>
        public NameAvailabilityResponse(bool? nameAvailable = default(bool?), string reason = default(string), string message = default(string))
        {
            NameAvailable = nameAvailable;
            Reason = reason;
            Message = message;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets if true, the name is valid and available. If false,
        /// 'reason' describes why not.
        /// </summary>
        [JsonProperty(PropertyName = "nameAvailable")]
        public bool? NameAvailable { get; set; }

        /// <summary>
        /// Gets or sets the reason why the name is not available, if
        /// nameAvailable is false. Possible values include: 'AlreadyExists',
        /// 'Invalid'
        /// </summary>
        [JsonProperty(PropertyName = "reason")]
        public string Reason { get; set; }

        /// <summary>
        /// Gets or sets the localized reason why the name is not available, if
        /// nameAvailable is false
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

    }
}
