// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Object used to report the data migration results of a table
    /// </summary>
    public partial class NonSqlDataMigrationTableResult
    {
        /// <summary>
        /// Initializes a new instance of the NonSqlDataMigrationTableResult
        /// class.
        /// </summary>
        public NonSqlDataMigrationTableResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the NonSqlDataMigrationTableResult
        /// class.
        /// </summary>
        /// <param name="resultCode">Result code of the data migration.
        /// Possible values include: 'Initial', 'Completed',
        /// 'ObjectNotExistsInSource', 'ObjectNotExistsInTarget',
        /// 'TargetObjectIsInaccessible', 'FatalError'</param>
        /// <param name="sourceName">Name of the source table</param>
        /// <param name="targetName">Name of the target table</param>
        /// <param name="sourceRowCount">Number of rows in the source
        /// table</param>
        /// <param name="targetRowCount">Number of rows in the target
        /// table</param>
        /// <param name="elapsedTimeInMiliseconds">Time taken to migrate the
        /// data</param>
        /// <param name="errors">List of errors, if any, during
        /// migration</param>
        public NonSqlDataMigrationTableResult(string resultCode = default(string), string sourceName = default(string), string targetName = default(string), long? sourceRowCount = default(long?), long? targetRowCount = default(long?), double? elapsedTimeInMiliseconds = default(double?), IList<DataMigrationError> errors = default(IList<DataMigrationError>))
        {
            ResultCode = resultCode;
            SourceName = sourceName;
            TargetName = targetName;
            SourceRowCount = sourceRowCount;
            TargetRowCount = targetRowCount;
            ElapsedTimeInMiliseconds = elapsedTimeInMiliseconds;
            Errors = errors;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets result code of the data migration. Possible values include:
        /// 'Initial', 'Completed', 'ObjectNotExistsInSource',
        /// 'ObjectNotExistsInTarget', 'TargetObjectIsInaccessible',
        /// 'FatalError'
        /// </summary>
        [JsonProperty(PropertyName = "resultCode")]
        public string ResultCode { get; private set; }

        /// <summary>
        /// Gets name of the source table
        /// </summary>
        [JsonProperty(PropertyName = "sourceName")]
        public string SourceName { get; private set; }

        /// <summary>
        /// Gets name of the target table
        /// </summary>
        [JsonProperty(PropertyName = "targetName")]
        public string TargetName { get; private set; }

        /// <summary>
        /// Gets number of rows in the source table
        /// </summary>
        [JsonProperty(PropertyName = "sourceRowCount")]
        public long? SourceRowCount { get; private set; }

        /// <summary>
        /// Gets number of rows in the target table
        /// </summary>
        [JsonProperty(PropertyName = "targetRowCount")]
        public long? TargetRowCount { get; private set; }

        /// <summary>
        /// Gets time taken to migrate the data
        /// </summary>
        [JsonProperty(PropertyName = "elapsedTimeInMiliseconds")]
        public double? ElapsedTimeInMiliseconds { get; private set; }

        /// <summary>
        /// Gets list of errors, if any, during migration
        /// </summary>
        [JsonProperty(PropertyName = "errors")]
        public IList<DataMigrationError> Errors { get; private set; }

    }
}
