// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Base class for non sql migration task output
    /// </summary>
    public partial class NonSqlMigrationTaskOutput
    {
        /// <summary>
        /// Initializes a new instance of the NonSqlMigrationTaskOutput class.
        /// </summary>
        public NonSqlMigrationTaskOutput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the NonSqlMigrationTaskOutput class.
        /// </summary>
        /// <param name="id">Result identifier</param>
        /// <param name="startedOn">Migration start time</param>
        /// <param name="endedOn">Migration end time</param>
        /// <param name="status">Current state of migration. Possible values
        /// include: 'Default', 'Connecting', 'SourceAndTargetSelected',
        /// 'SelectLogins', 'Configured', 'Running', 'Error', 'Stopped',
        /// 'Completed', 'CompletedWithWarnings'</param>
        /// <param name="dataMigrationTableResults">Results of the migration.
        /// The key contains the table name and the value the table result
        /// object</param>
        /// <param name="progressMessage">Message about the progress of the
        /// migration</param>
        /// <param name="sourceServerName">Name of source server</param>
        /// <param name="targetServerName">Name of target server</param>
        public NonSqlMigrationTaskOutput(string id = default(string), System.DateTimeOffset? startedOn = default(System.DateTimeOffset?), System.DateTimeOffset? endedOn = default(System.DateTimeOffset?), string status = default(string), IDictionary<string, NonSqlDataMigrationTableResult> dataMigrationTableResults = default(IDictionary<string, NonSqlDataMigrationTableResult>), string progressMessage = default(string), string sourceServerName = default(string), string targetServerName = default(string))
        {
            Id = id;
            StartedOn = startedOn;
            EndedOn = endedOn;
            Status = status;
            DataMigrationTableResults = dataMigrationTableResults;
            ProgressMessage = progressMessage;
            SourceServerName = sourceServerName;
            TargetServerName = targetServerName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets result identifier
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets migration start time
        /// </summary>
        [JsonProperty(PropertyName = "startedOn")]
        public System.DateTimeOffset? StartedOn { get; private set; }

        /// <summary>
        /// Gets migration end time
        /// </summary>
        [JsonProperty(PropertyName = "endedOn")]
        public System.DateTimeOffset? EndedOn { get; private set; }

        /// <summary>
        /// Gets current state of migration. Possible values include:
        /// 'Default', 'Connecting', 'SourceAndTargetSelected', 'SelectLogins',
        /// 'Configured', 'Running', 'Error', 'Stopped', 'Completed',
        /// 'CompletedWithWarnings'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; private set; }

        /// <summary>
        /// Gets results of the migration. The key contains the table name and
        /// the value the table result object
        /// </summary>
        [JsonProperty(PropertyName = "dataMigrationTableResults")]
        public IDictionary<string, NonSqlDataMigrationTableResult> DataMigrationTableResults { get; private set; }

        /// <summary>
        /// Gets message about the progress of the migration
        /// </summary>
        [JsonProperty(PropertyName = "progressMessage")]
        public string ProgressMessage { get; private set; }

        /// <summary>
        /// Gets name of source server
        /// </summary>
        [JsonProperty(PropertyName = "sourceServerName")]
        public string SourceServerName { get; private set; }

        /// <summary>
        /// Gets name of target server
        /// </summary>
        [JsonProperty(PropertyName = "targetServerName")]
        public string TargetServerName { get; private set; }

    }
}
