// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Information about an Oracle OCI driver.
    /// </summary>
    public partial class OracleOCIDriverInfo
    {
        /// <summary>
        /// Initializes a new instance of the OracleOCIDriverInfo class.
        /// </summary>
        public OracleOCIDriverInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OracleOCIDriverInfo class.
        /// </summary>
        /// <param name="driverName">The name of the driver package</param>
        /// <param name="driverSize">The size in bytes of the driver
        /// package</param>
        /// <param name="archiveChecksum">The MD5 Base64 encoded checksum for
        /// the driver package.</param>
        /// <param name="oracleChecksum">The checksum for the driver package
        /// provided by Oracle.</param>
        /// <param name="assemblyVersion">Version listed in the OCI assembly
        /// 'oci.dll'</param>
        /// <param name="supportedOracleVersions">List of Oracle database
        /// versions supported by this driver. Only major minor of the version
        /// is listed.</param>
        public OracleOCIDriverInfo(string driverName = default(string), string driverSize = default(string), string archiveChecksum = default(string), string oracleChecksum = default(string), string assemblyVersion = default(string), IList<string> supportedOracleVersions = default(IList<string>))
        {
            DriverName = driverName;
            DriverSize = driverSize;
            ArchiveChecksum = archiveChecksum;
            OracleChecksum = oracleChecksum;
            AssemblyVersion = assemblyVersion;
            SupportedOracleVersions = supportedOracleVersions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the name of the driver package
        /// </summary>
        [JsonProperty(PropertyName = "driverName")]
        public string DriverName { get; private set; }

        /// <summary>
        /// Gets the size in bytes of the driver package
        /// </summary>
        [JsonProperty(PropertyName = "driverSize")]
        public string DriverSize { get; private set; }

        /// <summary>
        /// Gets the MD5 Base64 encoded checksum for the driver package.
        /// </summary>
        [JsonProperty(PropertyName = "archiveChecksum")]
        public string ArchiveChecksum { get; private set; }

        /// <summary>
        /// Gets the checksum for the driver package provided by Oracle.
        /// </summary>
        [JsonProperty(PropertyName = "oracleChecksum")]
        public string OracleChecksum { get; private set; }

        /// <summary>
        /// Gets version listed in the OCI assembly 'oci.dll'
        /// </summary>
        [JsonProperty(PropertyName = "assemblyVersion")]
        public string AssemblyVersion { get; private set; }

        /// <summary>
        /// Gets list of Oracle database versions supported by this driver.
        /// Only major minor of the version is listed.
        /// </summary>
        [JsonProperty(PropertyName = "supportedOracleVersions")]
        public IList<string> SupportedOracleVersions { get; private set; }

    }
}
