// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes an available DMS SKU.
    /// </summary>
    public partial class ResourceSku
    {
        /// <summary>
        /// Initializes a new instance of the ResourceSku class.
        /// </summary>
        public ResourceSku()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceSku class.
        /// </summary>
        /// <param name="resourceType">The type of resource the SKU applies
        /// to.</param>
        /// <param name="name">The name of SKU.</param>
        /// <param name="tier">Specifies the tier of DMS in a scale
        /// set.</param>
        /// <param name="size">The Size of the SKU.</param>
        /// <param name="family">The Family of this particular SKU.</param>
        /// <param name="kind">The Kind of resources that are supported in this
        /// SKU.</param>
        /// <param name="capacity">Not used.</param>
        /// <param name="locations">The set of locations that the SKU is
        /// available.</param>
        /// <param name="apiVersions">The api versions that support this
        /// SKU.</param>
        /// <param name="costs">Metadata for retrieving price info.</param>
        /// <param name="capabilities">A name value pair to describe the
        /// capability.</param>
        /// <param name="restrictions">The restrictions because of which SKU
        /// cannot be used. This is empty if there are no restrictions.</param>
        public ResourceSku(string resourceType = default(string), string name = default(string), string tier = default(string), string size = default(string), string family = default(string), string kind = default(string), ResourceSkuCapacity capacity = default(ResourceSkuCapacity), IList<string> locations = default(IList<string>), IList<string> apiVersions = default(IList<string>), IList<ResourceSkuCosts> costs = default(IList<ResourceSkuCosts>), IList<ResourceSkuCapabilities> capabilities = default(IList<ResourceSkuCapabilities>), IList<ResourceSkuRestrictions> restrictions = default(IList<ResourceSkuRestrictions>))
        {
            ResourceType = resourceType;
            Name = name;
            Tier = tier;
            Size = size;
            Family = family;
            Kind = kind;
            Capacity = capacity;
            Locations = locations;
            ApiVersions = apiVersions;
            Costs = costs;
            Capabilities = capabilities;
            Restrictions = restrictions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the type of resource the SKU applies to.
        /// </summary>
        [JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; private set; }

        /// <summary>
        /// Gets the name of SKU.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets specifies the tier of DMS in a scale set.
        /// </summary>
        [JsonProperty(PropertyName = "tier")]
        public string Tier { get; private set; }

        /// <summary>
        /// Gets the Size of the SKU.
        /// </summary>
        [JsonProperty(PropertyName = "size")]
        public string Size { get; private set; }

        /// <summary>
        /// Gets the Family of this particular SKU.
        /// </summary>
        [JsonProperty(PropertyName = "family")]
        public string Family { get; private set; }

        /// <summary>
        /// Gets the Kind of resources that are supported in this SKU.
        /// </summary>
        [JsonProperty(PropertyName = "kind")]
        public string Kind { get; private set; }

        /// <summary>
        /// Gets not used.
        /// </summary>
        [JsonProperty(PropertyName = "capacity")]
        public ResourceSkuCapacity Capacity { get; private set; }

        /// <summary>
        /// Gets the set of locations that the SKU is available.
        /// </summary>
        [JsonProperty(PropertyName = "locations")]
        public IList<string> Locations { get; private set; }

        /// <summary>
        /// Gets the api versions that support this SKU.
        /// </summary>
        [JsonProperty(PropertyName = "apiVersions")]
        public IList<string> ApiVersions { get; private set; }

        /// <summary>
        /// Gets metadata for retrieving price info.
        /// </summary>
        [JsonProperty(PropertyName = "costs")]
        public IList<ResourceSkuCosts> Costs { get; private set; }

        /// <summary>
        /// Gets a name value pair to describe the capability.
        /// </summary>
        [JsonProperty(PropertyName = "capabilities")]
        public IList<ResourceSkuCapabilities> Capabilities { get; private set; }

        /// <summary>
        /// Gets the restrictions because of which SKU cannot be used. This is
        /// empty if there are no restrictions.
        /// </summary>
        [JsonProperty(PropertyName = "restrictions")]
        public IList<ResourceSkuRestrictions> Restrictions { get; private set; }

    }
}
