// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes scaling information of a SKU.
    /// </summary>
    public partial class ResourceSkuRestrictions
    {
        /// <summary>
        /// Initializes a new instance of the ResourceSkuRestrictions class.
        /// </summary>
        public ResourceSkuRestrictions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceSkuRestrictions class.
        /// </summary>
        /// <param name="type">The type of restrictions. Possible values
        /// include: 'location'</param>
        /// <param name="values">The value of restrictions. If the restriction
        /// type is set to location. This would be different locations where
        /// the SKU is restricted.</param>
        /// <param name="reasonCode">The reason code for restriction. Possible
        /// values include: 'QuotaId', 'NotAvailableForSubscription'</param>
        public ResourceSkuRestrictions(string type = default(string), IList<string> values = default(IList<string>), string reasonCode = default(string))
        {
            Type = type;
            Values = values;
            ReasonCode = reasonCode;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the type of restrictions. Possible values include: 'location'
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

        /// <summary>
        /// Gets the value of restrictions. If the restriction type is set to
        /// location. This would be different locations where the SKU is
        /// restricted.
        /// </summary>
        [JsonProperty(PropertyName = "values")]
        public IList<string> Values { get; private set; }

        /// <summary>
        /// Gets the reason code for restriction. Possible values include:
        /// 'QuotaId', 'NotAvailableForSubscription'
        /// </summary>
        [JsonProperty(PropertyName = "reasonCode")]
        public string ReasonCode { get; private set; }

    }
}
