// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Settings for migrating schema from source to target
    /// </summary>
    public partial class SchemaMigrationSetting
    {
        /// <summary>
        /// Initializes a new instance of the SchemaMigrationSetting class.
        /// </summary>
        public SchemaMigrationSetting()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SchemaMigrationSetting class.
        /// </summary>
        /// <param name="schemaOption">Option on how to migrate the schema.
        /// Possible values include: 'None', 'ExtractFromSource',
        /// 'UseStorageFile'</param>
        /// <param name="fileId">Resource Identifier of a file resource
        /// containing the uploaded schema file</param>
        public SchemaMigrationSetting(string schemaOption = default(string), string fileId = default(string))
        {
            SchemaOption = schemaOption;
            FileId = fileId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets option on how to migrate the schema. Possible values
        /// include: 'None', 'ExtractFromSource', 'UseStorageFile'
        /// </summary>
        [JsonProperty(PropertyName = "schemaOption")]
        public string SchemaOption { get; set; }

        /// <summary>
        /// Gets or sets resource Identifier of a file resource containing the
        /// uploaded schema file
        /// </summary>
        [JsonProperty(PropertyName = "fileId")]
        public string FileId { get; set; }

    }
}
