// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Info for certificate to be exported for TDE enabled databases.
    /// </summary>
    public partial class SelectedCertificateInput
    {
        /// <summary>
        /// Initializes a new instance of the SelectedCertificateInput class.
        /// </summary>
        public SelectedCertificateInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SelectedCertificateInput class.
        /// </summary>
        /// <param name="certificateName">Name of certificate to be
        /// exported.</param>
        /// <param name="password">Password to use for encrypting the exported
        /// certificate.</param>
        public SelectedCertificateInput(string certificateName, string password)
        {
            CertificateName = certificateName;
            Password = password;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of certificate to be exported.
        /// </summary>
        [JsonProperty(PropertyName = "certificateName")]
        public string CertificateName { get; set; }

        /// <summary>
        /// Gets or sets password to use for encrypting the exported
        /// certificate.
        /// </summary>
        [JsonProperty(PropertyName = "password")]
        public string Password { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (CertificateName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CertificateName");
            }
            if (Password == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Password");
            }
        }
    }
}
