// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataMigration.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Input for task that validates migration input for SQL to Azure SQL
    /// Managed Instance
    /// </summary>
    public partial class ValidateMigrationInputSqlServerSqlMITaskInput
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ValidateMigrationInputSqlServerSqlMITaskInput class.
        /// </summary>
        public ValidateMigrationInputSqlServerSqlMITaskInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ValidateMigrationInputSqlServerSqlMITaskInput class.
        /// </summary>
        /// <param name="sourceConnectionInfo">Information for connecting to
        /// source</param>
        /// <param name="targetConnectionInfo">Information for connecting to
        /// target</param>
        /// <param name="selectedDatabases">Databases to migrate</param>
        /// <param name="backupBlobShare">SAS URI of Azure Storage Account
        /// Container to be used for storing backup files.</param>
        /// <param name="selectedLogins">Logins to migrate</param>
        /// <param name="backupFileShare">Backup file share information for all
        /// selected databases.</param>
        /// <param name="backupMode">Backup Mode to specify whether to use
        /// existing backup or create new backup. Possible values include:
        /// 'CreateBackup', 'ExistingBackup'</param>
        public ValidateMigrationInputSqlServerSqlMITaskInput(SqlConnectionInfo sourceConnectionInfo, SqlConnectionInfo targetConnectionInfo, IList<MigrateSqlServerSqlMIDatabaseInput> selectedDatabases, BlobShare backupBlobShare, IList<string> selectedLogins = default(IList<string>), FileShare backupFileShare = default(FileShare), string backupMode = default(string))
        {
            SourceConnectionInfo = sourceConnectionInfo;
            TargetConnectionInfo = targetConnectionInfo;
            SelectedDatabases = selectedDatabases;
            SelectedLogins = selectedLogins;
            BackupFileShare = backupFileShare;
            BackupBlobShare = backupBlobShare;
            BackupMode = backupMode;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets information for connecting to source
        /// </summary>
        [JsonProperty(PropertyName = "sourceConnectionInfo")]
        public SqlConnectionInfo SourceConnectionInfo { get; set; }

        /// <summary>
        /// Gets or sets information for connecting to target
        /// </summary>
        [JsonProperty(PropertyName = "targetConnectionInfo")]
        public SqlConnectionInfo TargetConnectionInfo { get; set; }

        /// <summary>
        /// Gets or sets databases to migrate
        /// </summary>
        [JsonProperty(PropertyName = "selectedDatabases")]
        public IList<MigrateSqlServerSqlMIDatabaseInput> SelectedDatabases { get; set; }

        /// <summary>
        /// Gets or sets logins to migrate
        /// </summary>
        [JsonProperty(PropertyName = "selectedLogins")]
        public IList<string> SelectedLogins { get; set; }

        /// <summary>
        /// Gets or sets backup file share information for all selected
        /// databases.
        /// </summary>
        [JsonProperty(PropertyName = "backupFileShare")]
        public FileShare BackupFileShare { get; set; }

        /// <summary>
        /// Gets or sets SAS URI of Azure Storage Account Container to be used
        /// for storing backup files.
        /// </summary>
        [JsonProperty(PropertyName = "backupBlobShare")]
        public BlobShare BackupBlobShare { get; set; }

        /// <summary>
        /// Gets or sets backup Mode to specify whether to use existing backup
        /// or create new backup. Possible values include: 'CreateBackup',
        /// 'ExistingBackup'
        /// </summary>
        [JsonProperty(PropertyName = "backupMode")]
        public string BackupMode { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SourceConnectionInfo == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SourceConnectionInfo");
            }
            if (TargetConnectionInfo == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetConnectionInfo");
            }
            if (SelectedDatabases == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SelectedDatabases");
            }
            if (BackupBlobShare == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "BackupBlobShare");
            }
            if (SourceConnectionInfo != null)
            {
                SourceConnectionInfo.Validate();
            }
            if (TargetConnectionInfo != null)
            {
                TargetConnectionInfo.Validate();
            }
            if (SelectedDatabases != null)
            {
                foreach (var element in SelectedDatabases)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (BackupFileShare != null)
            {
                BackupFileShare.Validate();
            }
            if (BackupBlobShare != null)
            {
                BackupBlobShare.Validate();
            }
        }
    }
}
