// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataShare
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// Creates a Microsoft.DataShare management client.
    /// </summary>
    public partial interface IDataShareManagementClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// The api version to use.
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// The subscription identifier
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IAccountsOperations.
        /// </summary>
        IAccountsOperations Accounts { get; }

        /// <summary>
        /// Gets the IConsumerInvitationsOperations.
        /// </summary>
        IConsumerInvitationsOperations ConsumerInvitations { get; }

        /// <summary>
        /// Gets the IDataSetsOperations.
        /// </summary>
        IDataSetsOperations DataSets { get; }

        /// <summary>
        /// Gets the IDataSetMappingsOperations.
        /// </summary>
        IDataSetMappingsOperations DataSetMappings { get; }

        /// <summary>
        /// Gets the IInvitationsOperations.
        /// </summary>
        IInvitationsOperations Invitations { get; }

        /// <summary>
        /// Gets the IOperations.
        /// </summary>
        IOperations Operations { get; }

        /// <summary>
        /// Gets the ISharesOperations.
        /// </summary>
        ISharesOperations Shares { get; }

        /// <summary>
        /// Gets the IProviderShareSubscriptionsOperations.
        /// </summary>
        IProviderShareSubscriptionsOperations ProviderShareSubscriptions { get; }

        /// <summary>
        /// Gets the IShareSubscriptionsOperations.
        /// </summary>
        IShareSubscriptionsOperations ShareSubscriptions { get; }

        /// <summary>
        /// Gets the IConsumerSourceDataSetsOperations.
        /// </summary>
        IConsumerSourceDataSetsOperations ConsumerSourceDataSets { get; }

        /// <summary>
        /// Gets the ISynchronizationSettingsOperations.
        /// </summary>
        ISynchronizationSettingsOperations SynchronizationSettings { get; }

        /// <summary>
        /// Gets the ITriggersOperations.
        /// </summary>
        ITriggersOperations Triggers { get; }

    }
}
