// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataShare.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The data share error body model.
    /// </summary>
    public partial class DataShareErrorInfo
    {
        /// <summary>
        /// Initializes a new instance of the DataShareErrorInfo class.
        /// </summary>
        public DataShareErrorInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DataShareErrorInfo class.
        /// </summary>
        /// <param name="code">Code of the error</param>
        /// <param name="message">Message of the error</param>
        /// <param name="details">Nested details of the error model</param>
        /// <param name="target">Target of the error</param>
        public DataShareErrorInfo(string code, string message, IList<DataShareErrorInfo> details = default(IList<DataShareErrorInfo>), string target = default(string))
        {
            Code = code;
            Details = details;
            Message = message;
            Target = target;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets code of the error
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; set; }

        /// <summary>
        /// Gets or sets nested details of the error model
        /// </summary>
        [JsonProperty(PropertyName = "details")]
        public IList<DataShareErrorInfo> Details { get; set; }

        /// <summary>
        /// Gets or sets message of the error
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

        /// <summary>
        /// Gets or sets target of the error
        /// </summary>
        [JsonProperty(PropertyName = "target")]
        public string Target { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Code == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Code");
            }
            if (Message == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Message");
            }
            if (Details != null)
            {
                foreach (var element in Details)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
