// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DataShare
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for TriggersOperations.
    /// </summary>
    public static partial class TriggersOperationsExtensions
    {
            /// <summary>
            /// Get Trigger in a shareSubscription.
            /// </summary>
            /// <remarks>
            /// Get a Trigger in a shareSubscription
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the shareSubscription.
            /// </param>
            /// <param name='triggerName'>
            /// The name of the trigger.
            /// </param>
            public static Trigger Get(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string triggerName)
            {
                return operations.GetAsync(resourceGroupName, accountName, shareSubscriptionName, triggerName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get Trigger in a shareSubscription.
            /// </summary>
            /// <remarks>
            /// Get a Trigger in a shareSubscription
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the shareSubscription.
            /// </param>
            /// <param name='triggerName'>
            /// The name of the trigger.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Trigger> GetAsync(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string triggerName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, accountName, shareSubscriptionName, triggerName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This method creates a trigger for a share subscription
            /// </summary>
            /// <remarks>
            /// Create a Trigger
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the share subscription which will hold the data set sink.
            /// </param>
            /// <param name='triggerName'>
            /// The name of the trigger.
            /// </param>
            /// <param name='trigger'>
            /// Trigger details.
            /// </param>
            public static Trigger Create(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string triggerName, Trigger trigger)
            {
                return operations.CreateAsync(resourceGroupName, accountName, shareSubscriptionName, triggerName, trigger).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This method creates a trigger for a share subscription
            /// </summary>
            /// <remarks>
            /// Create a Trigger
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the share subscription which will hold the data set sink.
            /// </param>
            /// <param name='triggerName'>
            /// The name of the trigger.
            /// </param>
            /// <param name='trigger'>
            /// Trigger details.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Trigger> CreateAsync(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string triggerName, Trigger trigger, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateWithHttpMessagesAsync(resourceGroupName, accountName, shareSubscriptionName, triggerName, trigger, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete Trigger in a shareSubscription.
            /// </summary>
            /// <remarks>
            /// Delete a Trigger in a shareSubscription
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the shareSubscription.
            /// </param>
            /// <param name='triggerName'>
            /// The name of the trigger.
            /// </param>
            public static OperationResponse Delete(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string triggerName)
            {
                return operations.DeleteAsync(resourceGroupName, accountName, shareSubscriptionName, triggerName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete Trigger in a shareSubscription.
            /// </summary>
            /// <remarks>
            /// Delete a Trigger in a shareSubscription
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the shareSubscription.
            /// </param>
            /// <param name='triggerName'>
            /// The name of the trigger.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<OperationResponse> DeleteAsync(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string triggerName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteWithHttpMessagesAsync(resourceGroupName, accountName, shareSubscriptionName, triggerName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// List Triggers in a share subscription.
            /// </summary>
            /// <remarks>
            /// List Triggers in a share subscription
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the share subscription.
            /// </param>
            /// <param name='skipToken'>
            /// Continuation token
            /// </param>
            public static IPage<Trigger> ListByShareSubscription(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string skipToken = default(string))
            {
                return operations.ListByShareSubscriptionAsync(resourceGroupName, accountName, shareSubscriptionName, skipToken).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List Triggers in a share subscription.
            /// </summary>
            /// <remarks>
            /// List Triggers in a share subscription
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the share subscription.
            /// </param>
            /// <param name='skipToken'>
            /// Continuation token
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Trigger>> ListByShareSubscriptionAsync(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string skipToken = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByShareSubscriptionWithHttpMessagesAsync(resourceGroupName, accountName, shareSubscriptionName, skipToken, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This method creates a trigger for a share subscription
            /// </summary>
            /// <remarks>
            /// Create a Trigger
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the share subscription which will hold the data set sink.
            /// </param>
            /// <param name='triggerName'>
            /// The name of the trigger.
            /// </param>
            /// <param name='trigger'>
            /// Trigger details.
            /// </param>
            public static Trigger BeginCreate(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string triggerName, Trigger trigger)
            {
                return operations.BeginCreateAsync(resourceGroupName, accountName, shareSubscriptionName, triggerName, trigger).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This method creates a trigger for a share subscription
            /// </summary>
            /// <remarks>
            /// Create a Trigger
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the share subscription which will hold the data set sink.
            /// </param>
            /// <param name='triggerName'>
            /// The name of the trigger.
            /// </param>
            /// <param name='trigger'>
            /// Trigger details.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Trigger> BeginCreateAsync(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string triggerName, Trigger trigger, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateWithHttpMessagesAsync(resourceGroupName, accountName, shareSubscriptionName, triggerName, trigger, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete Trigger in a shareSubscription.
            /// </summary>
            /// <remarks>
            /// Delete a Trigger in a shareSubscription
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the shareSubscription.
            /// </param>
            /// <param name='triggerName'>
            /// The name of the trigger.
            /// </param>
            public static OperationResponse BeginDelete(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string triggerName)
            {
                return operations.BeginDeleteAsync(resourceGroupName, accountName, shareSubscriptionName, triggerName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete Trigger in a shareSubscription.
            /// </summary>
            /// <remarks>
            /// Delete a Trigger in a shareSubscription
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='accountName'>
            /// The name of the share account.
            /// </param>
            /// <param name='shareSubscriptionName'>
            /// The name of the shareSubscription.
            /// </param>
            /// <param name='triggerName'>
            /// The name of the trigger.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<OperationResponse> BeginDeleteAsync(this ITriggersOperations operations, string resourceGroupName, string accountName, string shareSubscriptionName, string triggerName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginDeleteWithHttpMessagesAsync(resourceGroupName, accountName, shareSubscriptionName, triggerName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// List Triggers in a share subscription.
            /// </summary>
            /// <remarks>
            /// List Triggers in a share subscription
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<Trigger> ListByShareSubscriptionNext(this ITriggersOperations operations, string nextPageLink)
            {
                return operations.ListByShareSubscriptionNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List Triggers in a share subscription.
            /// </summary>
            /// <remarks>
            /// List Triggers in a share subscription
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Trigger>> ListByShareSubscriptionNextAsync(this ITriggersOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByShareSubscriptionNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
