// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Detailed error information of any failure.
    /// </summary>
    public partial class CloudErrorBody
    {
        /// <summary>
        /// Initializes a new instance of the CloudErrorBody class.
        /// </summary>
        public CloudErrorBody()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CloudErrorBody class.
        /// </summary>
        /// <param name="code">Error code string.</param>
        /// <param name="message">Descriptive error information.</param>
        /// <param name="target">Error target</param>
        /// <param name="details">More detailed error information.</param>
        public CloudErrorBody(string code = default(string), string message = default(string), string target = default(string), IList<CloudErrorBody> details = default(IList<CloudErrorBody>))
        {
            Code = code;
            Message = message;
            Target = target;
            Details = details;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets error code string.
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; private set; }

        /// <summary>
        /// Gets descriptive error information.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; private set; }

        /// <summary>
        /// Gets or sets error target
        /// </summary>
        [JsonProperty(PropertyName = "target")]
        public string Target { get; set; }

        /// <summary>
        /// Gets or sets more detailed error information.
        /// </summary>
        [JsonProperty(PropertyName = "details")]
        public IList<CloudErrorBody> Details { get; set; }

    }
}
