// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Individual resource operation information.
    /// </summary>
    public partial class ResourceOperation
    {
        /// <summary>
        /// Initializes a new instance of the ResourceOperation class.
        /// </summary>
        public ResourceOperation()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceOperation class.
        /// </summary>
        /// <param name="resourceName">Name of the resource as specified in the
        /// artifacts. For ARM resources, this is the name of the resource
        /// specified in the template.</param>
        /// <param name="operationId">Unique identifier of the operation. For
        /// ARM resources, this is the operationId obtained from ARM
        /// service.</param>
        /// <param name="resourceType">Type of the resource as specified in the
        /// artifacts. For ARM resources, this is the type of the resource
        /// specified in the template.</param>
        /// <param name="provisioningState">State of the resource deployment.
        /// For ARM resources, this is the current provisioning state of the
        /// resource.</param>
        /// <param name="statusMessage">Descriptive information of the resource
        /// operation.</param>
        /// <param name="statusCode">Http status code of the operation.</param>
        public ResourceOperation(string resourceName = default(string), string operationId = default(string), string resourceType = default(string), string provisioningState = default(string), string statusMessage = default(string), string statusCode = default(string))
        {
            ResourceName = resourceName;
            OperationId = operationId;
            ResourceType = resourceType;
            ProvisioningState = provisioningState;
            StatusMessage = statusMessage;
            StatusCode = statusCode;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the resource as specified in the artifacts.
        /// For ARM resources, this is the name of the resource specified in
        /// the template.
        /// </summary>
        [JsonProperty(PropertyName = "resourceName")]
        public string ResourceName { get; set; }

        /// <summary>
        /// Gets unique identifier of the operation. For ARM resources, this is
        /// the operationId obtained from ARM service.
        /// </summary>
        [JsonProperty(PropertyName = "operationId")]
        public string OperationId { get; private set; }

        /// <summary>
        /// Gets or sets type of the resource as specified in the artifacts.
        /// For ARM resources, this is the type of the resource specified in
        /// the template.
        /// </summary>
        [JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; set; }

        /// <summary>
        /// Gets state of the resource deployment. For ARM resources, this is
        /// the current provisioning state of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets descriptive information of the resource operation.
        /// </summary>
        [JsonProperty(PropertyName = "statusMessage")]
        public string StatusMessage { get; private set; }

        /// <summary>
        /// Gets http status code of the operation.
        /// </summary>
        [JsonProperty(PropertyName = "statusCode")]
        public string StatusCode { get; private set; }

    }
}
