// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Defines the REST health check step properties.
    /// </summary>
    [Newtonsoft.Json.JsonObject("REST")]
    [Rest.Serialization.JsonTransformation]
    public partial class RestHealthCheckStepAttributes : HealthCheckStepAttributes
    {
        /// <summary>
        /// Initializes a new instance of the RestHealthCheckStepAttributes
        /// class.
        /// </summary>
        public RestHealthCheckStepAttributes()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RestHealthCheckStepAttributes
        /// class.
        /// </summary>
        /// <param name="healthyStateDuration">The duration in ISO 8601 format
        /// for which the resource is expected to be continuously healthy. If
        /// maxElasticDuration is specified, healthy state duration is enforced
        /// after the detection of first healthy signal.</param>
        /// <param name="healthChecks">The list of checks that form the health
        /// check step.</param>
        /// <param name="waitDuration">The duration in ISO 8601 format for
        /// which health check waits idly without any checks.</param>
        /// <param name="maxElasticDuration">The duration in ISO 8601 format
        /// for which the health check waits for the resource to become
        /// healthy. Health check fails if it doesn't. Health check starts to
        /// enforce healthyStateDuration once resource becomes healthy.</param>
        public RestHealthCheckStepAttributes(string healthyStateDuration, IList<RestHealthCheck> healthChecks, string waitDuration = default(string), string maxElasticDuration = default(string))
            : base(healthyStateDuration, waitDuration, maxElasticDuration)
        {
            HealthChecks = healthChecks;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the list of checks that form the health check step.
        /// </summary>
        [JsonProperty(PropertyName = "properties.healthChecks")]
        public IList<RestHealthCheck> HealthChecks { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (HealthChecks == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "HealthChecks");
            }
            if (HealthChecks != null)
            {
                foreach (var element in HealthChecks)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
