// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties that make up the expected REST response
    /// </summary>
    public partial class RestResponse
    {
        /// <summary>
        /// Initializes a new instance of the RestResponse class.
        /// </summary>
        public RestResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RestResponse class.
        /// </summary>
        /// <param name="successStatusCodes">The HTTP status codes expected in
        /// a successful health check response. The response is expected to
        /// match one of the given status codes. If no expected status codes
        /// are provided, default expected status code is 200 OK.</param>
        /// <param name="regex">The regular expressions to match the response
        /// content with.</param>
        public RestResponse(IList<string> successStatusCodes = default(IList<string>), RestResponseRegex regex = default(RestResponseRegex))
        {
            SuccessStatusCodes = successStatusCodes;
            Regex = regex;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the HTTP status codes expected in a successful health
        /// check response. The response is expected to match one of the given
        /// status codes. If no expected status codes are provided, default
        /// expected status code is 200 OK.
        /// </summary>
        [JsonProperty(PropertyName = "successStatusCodes")]
        public IList<string> SuccessStatusCodes { get; set; }

        /// <summary>
        /// Gets or sets the regular expressions to match the response content
        /// with.
        /// </summary>
        [JsonProperty(PropertyName = "regex")]
        public RestResponseRegex Regex { get; set; }

    }
}
