// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Detailed runtime information of the rollout.
    /// </summary>
    public partial class RolloutOperationInfo
    {
        /// <summary>
        /// Initializes a new instance of the RolloutOperationInfo class.
        /// </summary>
        public RolloutOperationInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RolloutOperationInfo class.
        /// </summary>
        /// <param name="retryAttempt">The ordinal count of the number of retry
        /// attempts on a rollout. 0 if no retries of the rollout have been
        /// performed. If the rollout is updated with a PUT, this count is
        /// reset to 0.</param>
        /// <param name="skipSucceededOnRetry">True, if all steps that
        /// succeeded on the previous run/attempt were chosen to be skipped in
        /// this retry attempt. False, otherwise.</param>
        /// <param name="startTime">The start time of the rollout in
        /// UTC.</param>
        /// <param name="endTime">The start time of the rollout in UTC. This
        /// property will not be set if the rollout has not completed
        /// yet.</param>
        /// <param name="error">The detailed error information for any
        /// failure.</param>
        public RolloutOperationInfo(int? retryAttempt = default(int?), bool? skipSucceededOnRetry = default(bool?), System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), CloudErrorBody error = default(CloudErrorBody))
        {
            RetryAttempt = retryAttempt;
            SkipSucceededOnRetry = skipSucceededOnRetry;
            StartTime = startTime;
            EndTime = endTime;
            Error = error;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the ordinal count of the number of retry attempts on a
        /// rollout. 0 if no retries of the rollout have been performed. If the
        /// rollout is updated with a PUT, this count is reset to 0.
        /// </summary>
        [JsonProperty(PropertyName = "retryAttempt")]
        public int? RetryAttempt { get; private set; }

        /// <summary>
        /// Gets true, if all steps that succeeded on the previous run/attempt
        /// were chosen to be skipped in this retry attempt. False, otherwise.
        /// </summary>
        [JsonProperty(PropertyName = "skipSucceededOnRetry")]
        public bool? SkipSucceededOnRetry { get; private set; }

        /// <summary>
        /// Gets the start time of the rollout in UTC.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; private set; }

        /// <summary>
        /// Gets the start time of the rollout in UTC. This property will not
        /// be set if the rollout has not completed yet.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; private set; }

        /// <summary>
        /// Gets the detailed error information for any failure.
        /// </summary>
        [JsonProperty(PropertyName = "error")]
        public CloudErrorBody Error { get; private set; }

    }
}
