// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Defines the properties of a rollout.
    /// </summary>
    public partial class RolloutPropertiesModel
    {
        /// <summary>
        /// Initializes a new instance of the RolloutPropertiesModel class.
        /// </summary>
        public RolloutPropertiesModel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RolloutPropertiesModel class.
        /// </summary>
        /// <param name="status">The current status of the rollout.</param>
        /// <param name="totalRetryAttempts">The cardinal count of total number
        /// of retries performed on the rollout at a given time.</param>
        /// <param name="operationInfo">Operational information of the
        /// rollout.</param>
        /// <param name="services">The detailed information on the services
        /// being deployed.</param>
        public RolloutPropertiesModel(string status = default(string), int? totalRetryAttempts = default(int?), RolloutOperationInfo operationInfo = default(RolloutOperationInfo), IList<Service> services = default(IList<Service>))
        {
            Status = status;
            TotalRetryAttempts = totalRetryAttempts;
            OperationInfo = operationInfo;
            Services = services;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the current status of the rollout.
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; private set; }

        /// <summary>
        /// Gets the cardinal count of total number of retries performed on the
        /// rollout at a given time.
        /// </summary>
        [JsonProperty(PropertyName = "totalRetryAttempts")]
        public int? TotalRetryAttempts { get; private set; }

        /// <summary>
        /// Gets operational information of the rollout.
        /// </summary>
        [JsonProperty(PropertyName = "operationInfo")]
        public RolloutOperationInfo OperationInfo { get; private set; }

        /// <summary>
        /// Gets the detailed information on the services being deployed.
        /// </summary>
        [JsonProperty(PropertyName = "services")]
        public IList<Service> Services { get; private set; }

    }
}
