// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties of a service.
    /// </summary>
    public partial class ServiceProperties
    {
        /// <summary>
        /// Initializes a new instance of the ServiceProperties class.
        /// </summary>
        public ServiceProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServiceProperties class.
        /// </summary>
        /// <param name="targetLocation">The Azure location to which the
        /// resources in the service belong to or should be deployed
        /// to.</param>
        /// <param name="targetSubscriptionId">The subscription to which the
        /// resources in the service belong to or should be deployed
        /// to.</param>
        public ServiceProperties(string targetLocation, string targetSubscriptionId)
        {
            TargetLocation = targetLocation;
            TargetSubscriptionId = targetSubscriptionId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Azure location to which the resources in the
        /// service belong to or should be deployed to.
        /// </summary>
        [JsonProperty(PropertyName = "targetLocation")]
        public string TargetLocation { get; set; }

        /// <summary>
        /// Gets or sets the subscription to which the resources in the service
        /// belong to or should be deployed to.
        /// </summary>
        [JsonProperty(PropertyName = "targetSubscriptionId")]
        public string TargetSubscriptionId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (TargetLocation == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetLocation");
            }
            if (TargetSubscriptionId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetSubscriptionId");
            }
        }
    }
}
