// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The resource representation of a service in a service topology.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ServiceResource : TrackedResource
    {
        /// <summary>
        /// Initializes a new instance of the ServiceResource class.
        /// </summary>
        public ServiceResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServiceResource class.
        /// </summary>
        /// <param name="location">The geo-location where the resource
        /// lives</param>
        /// <param name="targetLocation">The Azure location to which the
        /// resources in the service belong to or should be deployed
        /// to.</param>
        /// <param name="targetSubscriptionId">The subscription to which the
        /// resources in the service belong to or should be deployed
        /// to.</param>
        /// <param name="id">Fully qualified resource Id for the resource. Ex -
        /// /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="type">The type of the resource. Ex-
        /// Microsoft.Compute/virtualMachines or
        /// Microsoft.Storage/storageAccounts.</param>
        /// <param name="tags">Resource tags.</param>
        public ServiceResource(string location, string targetLocation, string targetSubscriptionId, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>))
            : base(location, id, name, type, tags)
        {
            TargetLocation = targetLocation;
            TargetSubscriptionId = targetSubscriptionId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Azure location to which the resources in the
        /// service belong to or should be deployed to.
        /// </summary>
        [JsonProperty(PropertyName = "properties.targetLocation")]
        public string TargetLocation { get; set; }

        /// <summary>
        /// Gets or sets the subscription to which the resources in the service
        /// belong to or should be deployed to.
        /// </summary>
        [JsonProperty(PropertyName = "properties.targetSubscriptionId")]
        public string TargetSubscriptionId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (TargetLocation == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetLocation");
            }
            if (TargetSubscriptionId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetSubscriptionId");
            }
        }
    }
}
