// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The resource representation of a service topology.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ServiceTopologyResource : TrackedResource
    {
        /// <summary>
        /// Initializes a new instance of the ServiceTopologyResource class.
        /// </summary>
        public ServiceTopologyResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServiceTopologyResource class.
        /// </summary>
        /// <param name="location">The geo-location where the resource
        /// lives</param>
        /// <param name="id">Fully qualified resource Id for the resource. Ex -
        /// /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="type">The type of the resource. Ex-
        /// Microsoft.Compute/virtualMachines or
        /// Microsoft.Storage/storageAccounts.</param>
        /// <param name="tags">Resource tags.</param>
        /// <param name="artifactSourceId">The resource Id of the artifact
        /// source that contains the artifacts that can be referenced in the
        /// service units.</param>
        public ServiceTopologyResource(string location, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string artifactSourceId = default(string))
            : base(location, id, name, type, tags)
        {
            ArtifactSourceId = artifactSourceId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the resource Id of the artifact source that contains
        /// the artifacts that can be referenced in the service units.
        /// </summary>
        [JsonProperty(PropertyName = "properties.artifactSourceId")]
        public string ArtifactSourceId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
