// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the artifacts of a service unit.
    /// </summary>
    public partial class ServiceUnitArtifacts
    {
        /// <summary>
        /// Initializes a new instance of the ServiceUnitArtifacts class.
        /// </summary>
        public ServiceUnitArtifacts()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServiceUnitArtifacts class.
        /// </summary>
        /// <param name="templateUri">The full URI of the ARM template file
        /// with the SAS token.</param>
        /// <param name="parametersUri">The full URI of the ARM parameters file
        /// with the SAS token.</param>
        /// <param name="templateArtifactSourceRelativePath">The path to the
        /// ARM template file relative to the artifact source.</param>
        /// <param name="parametersArtifactSourceRelativePath">The path to the
        /// ARM parameters file relative to the artifact source.</param>
        public ServiceUnitArtifacts(string templateUri = default(string), string parametersUri = default(string), string templateArtifactSourceRelativePath = default(string), string parametersArtifactSourceRelativePath = default(string))
        {
            TemplateUri = templateUri;
            ParametersUri = parametersUri;
            TemplateArtifactSourceRelativePath = templateArtifactSourceRelativePath;
            ParametersArtifactSourceRelativePath = parametersArtifactSourceRelativePath;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the full URI of the ARM template file with the SAS
        /// token.
        /// </summary>
        [JsonProperty(PropertyName = "templateUri")]
        public string TemplateUri { get; set; }

        /// <summary>
        /// Gets or sets the full URI of the ARM parameters file with the SAS
        /// token.
        /// </summary>
        [JsonProperty(PropertyName = "parametersUri")]
        public string ParametersUri { get; set; }

        /// <summary>
        /// Gets or sets the path to the ARM template file relative to the
        /// artifact source.
        /// </summary>
        [JsonProperty(PropertyName = "templateArtifactSourceRelativePath")]
        public string TemplateArtifactSourceRelativePath { get; set; }

        /// <summary>
        /// Gets or sets the path to the ARM parameters file relative to the
        /// artifact source.
        /// </summary>
        [JsonProperty(PropertyName = "parametersArtifactSourceRelativePath")]
        public string ParametersArtifactSourceRelativePath { get; set; }

    }
}
