// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the properties of a service unit.
    /// </summary>
    public partial class ServiceUnitProperties
    {
        /// <summary>
        /// Initializes a new instance of the ServiceUnitProperties class.
        /// </summary>
        public ServiceUnitProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServiceUnitProperties class.
        /// </summary>
        /// <param name="targetResourceGroup">The Azure Resource Group to which
        /// the resources in the service unit belong to or should be deployed
        /// to.</param>
        /// <param name="deploymentMode">Describes the type of ARM deployment
        /// to be performed on the resource. Possible values include:
        /// 'Incremental', 'Complete'</param>
        /// <param name="artifacts">The artifacts for the service unit.</param>
        public ServiceUnitProperties(string targetResourceGroup, DeploymentMode deploymentMode, ServiceUnitArtifacts artifacts = default(ServiceUnitArtifacts))
        {
            TargetResourceGroup = targetResourceGroup;
            DeploymentMode = deploymentMode;
            Artifacts = artifacts;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Azure Resource Group to which the resources in the
        /// service unit belong to or should be deployed to.
        /// </summary>
        [JsonProperty(PropertyName = "targetResourceGroup")]
        public string TargetResourceGroup { get; set; }

        /// <summary>
        /// Gets or sets describes the type of ARM deployment to be performed
        /// on the resource. Possible values include: 'Incremental', 'Complete'
        /// </summary>
        [JsonProperty(PropertyName = "deploymentMode")]
        public DeploymentMode DeploymentMode { get; set; }

        /// <summary>
        /// Gets or sets the artifacts for the service unit.
        /// </summary>
        [JsonProperty(PropertyName = "artifacts")]
        public ServiceUnitArtifacts Artifacts { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (TargetResourceGroup == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetResourceGroup");
            }
        }
    }
}
