// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Detailed information of a specific step run.
    /// </summary>
    public partial class StepOperationInfo
    {
        /// <summary>
        /// Initializes a new instance of the StepOperationInfo class.
        /// </summary>
        public StepOperationInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the StepOperationInfo class.
        /// </summary>
        /// <param name="deploymentName">The name of the ARM deployment
        /// initiated as part of the step.</param>
        /// <param name="correlationId">Unique identifier to track the request
        /// for ARM-based resources.</param>
        /// <param name="startTime">Start time of the action in UTC.</param>
        /// <param name="endTime">End time of the action in UTC.</param>
        /// <param name="lastUpdatedTime">Last time in UTC this operation was
        /// updated.</param>
        /// <param name="error">The errors, if any, for the action.</param>
        public StepOperationInfo(string deploymentName = default(string), string correlationId = default(string), System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), System.DateTime? lastUpdatedTime = default(System.DateTime?), CloudErrorBody error = default(CloudErrorBody))
        {
            DeploymentName = deploymentName;
            CorrelationId = correlationId;
            StartTime = startTime;
            EndTime = endTime;
            LastUpdatedTime = lastUpdatedTime;
            Error = error;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the name of the ARM deployment initiated as part of the step.
        /// </summary>
        [JsonProperty(PropertyName = "deploymentName")]
        public string DeploymentName { get; private set; }

        /// <summary>
        /// Gets unique identifier to track the request for ARM-based
        /// resources.
        /// </summary>
        [JsonProperty(PropertyName = "correlationId")]
        public string CorrelationId { get; private set; }

        /// <summary>
        /// Gets start time of the action in UTC.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; private set; }

        /// <summary>
        /// Gets end time of the action in UTC.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; private set; }

        /// <summary>
        /// Gets last time in UTC this operation was updated.
        /// </summary>
        [JsonProperty(PropertyName = "lastUpdatedTime")]
        public System.DateTime? LastUpdatedTime { get; private set; }

        /// <summary>
        /// Gets or sets the errors, if any, for the action.
        /// </summary>
        [JsonProperty(PropertyName = "error")]
        public CloudErrorBody Error { get; set; }

    }
}
