// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeploymentManager
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ServicesOperations.
    /// </summary>
    public static partial class ServicesOperationsExtensions
    {
            /// <summary>
            /// Creates or updates a service in the service topology.
            /// </summary>
            /// <remarks>
            /// Synchronously creates a new service or updates an existing service.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group. The name is case insensitive.
            /// </param>
            /// <param name='serviceTopologyName'>
            /// The name of the service topology .
            /// </param>
            /// <param name='serviceName'>
            /// The name of the service resource.
            /// </param>
            /// <param name='serviceInfo'>
            /// The service object
            /// </param>
            public static ServiceResource CreateOrUpdate(this IServicesOperations operations, string resourceGroupName, string serviceTopologyName, string serviceName, ServiceResource serviceInfo)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, serviceTopologyName, serviceName, serviceInfo).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates or updates a service in the service topology.
            /// </summary>
            /// <remarks>
            /// Synchronously creates a new service or updates an existing service.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group. The name is case insensitive.
            /// </param>
            /// <param name='serviceTopologyName'>
            /// The name of the service topology .
            /// </param>
            /// <param name='serviceName'>
            /// The name of the service resource.
            /// </param>
            /// <param name='serviceInfo'>
            /// The service object
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ServiceResource> CreateOrUpdateAsync(this IServicesOperations operations, string resourceGroupName, string serviceTopologyName, string serviceName, ServiceResource serviceInfo, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, serviceTopologyName, serviceName, serviceInfo, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group. The name is case insensitive.
            /// </param>
            /// <param name='serviceTopologyName'>
            /// The name of the service topology .
            /// </param>
            /// <param name='serviceName'>
            /// The name of the service resource.
            /// </param>
            public static ServiceResource Get(this IServicesOperations operations, string resourceGroupName, string serviceTopologyName, string serviceName)
            {
                return operations.GetAsync(resourceGroupName, serviceTopologyName, serviceName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group. The name is case insensitive.
            /// </param>
            /// <param name='serviceTopologyName'>
            /// The name of the service topology .
            /// </param>
            /// <param name='serviceName'>
            /// The name of the service resource.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ServiceResource> GetAsync(this IServicesOperations operations, string resourceGroupName, string serviceTopologyName, string serviceName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, serviceTopologyName, serviceName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group. The name is case insensitive.
            /// </param>
            /// <param name='serviceTopologyName'>
            /// The name of the service topology .
            /// </param>
            /// <param name='serviceName'>
            /// The name of the service resource.
            /// </param>
            public static void Delete(this IServicesOperations operations, string resourceGroupName, string serviceTopologyName, string serviceName)
            {
                operations.DeleteAsync(resourceGroupName, serviceTopologyName, serviceName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group. The name is case insensitive.
            /// </param>
            /// <param name='serviceTopologyName'>
            /// The name of the service topology .
            /// </param>
            /// <param name='serviceName'>
            /// The name of the service resource.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IServicesOperations operations, string resourceGroupName, string serviceTopologyName, string serviceName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, serviceTopologyName, serviceName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Lists the services in the service topology.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group. The name is case insensitive.
            /// </param>
            /// <param name='serviceTopologyName'>
            /// The name of the service topology .
            /// </param>
            public static IList<ServiceResource> List(this IServicesOperations operations, string resourceGroupName, string serviceTopologyName)
            {
                return operations.ListAsync(resourceGroupName, serviceTopologyName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists the services in the service topology.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group. The name is case insensitive.
            /// </param>
            /// <param name='serviceTopologyName'>
            /// The name of the service topology .
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IList<ServiceResource>> ListAsync(this IServicesOperations operations, string resourceGroupName, string serviceTopologyName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroupName, serviceTopologyName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
