// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DeviceProvisioningServices.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Description of the IoT hub.
    /// </summary>
    public partial class IotHubDefinitionDescription
    {
        /// <summary>
        /// Initializes a new instance of the IotHubDefinitionDescription
        /// class.
        /// </summary>
        public IotHubDefinitionDescription()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IotHubDefinitionDescription
        /// class.
        /// </summary>
        /// <param name="connectionString">Connection string og the IoT
        /// hub.</param>
        /// <param name="location">ARM region of the IoT hub.</param>
        /// <param name="applyAllocationPolicy">flag for applying
        /// allocationPolicy or not for a given iot hub.</param>
        /// <param name="allocationWeight">weight to apply for a given iot
        /// h.</param>
        /// <param name="name">Host name of the IoT hub.</param>
        public IotHubDefinitionDescription(string connectionString, string location, bool? applyAllocationPolicy = default(bool?), int? allocationWeight = default(int?), string name = default(string))
        {
            ApplyAllocationPolicy = applyAllocationPolicy;
            AllocationWeight = allocationWeight;
            Name = name;
            ConnectionString = connectionString;
            Location = location;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets flag for applying allocationPolicy or not for a given
        /// iot hub.
        /// </summary>
        [JsonProperty(PropertyName = "applyAllocationPolicy")]
        public bool? ApplyAllocationPolicy { get; set; }

        /// <summary>
        /// Gets or sets weight to apply for a given iot h.
        /// </summary>
        [JsonProperty(PropertyName = "allocationWeight")]
        public int? AllocationWeight { get; set; }

        /// <summary>
        /// Gets host name of the IoT hub.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets or sets connection string og the IoT hub.
        /// </summary>
        [JsonProperty(PropertyName = "connectionString")]
        public string ConnectionString { get; set; }

        /// <summary>
        /// Gets or sets ARM region of the IoT hub.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ConnectionString == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ConnectionString");
            }
            if (Location == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Location");
            }
        }
    }
}
