// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A data disks attached to a virtual machine.
    /// </summary>
    public partial class ComputeDataDiskFragment
    {
        /// <summary>
        /// Initializes a new instance of the ComputeDataDiskFragment class.
        /// </summary>
        public ComputeDataDiskFragment()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ComputeDataDiskFragment class.
        /// </summary>
        /// <param name="name">Gets data disk name.</param>
        /// <param name="diskUri">When backed by a blob, the URI of underlying
        /// blob.</param>
        /// <param name="managedDiskId">When backed by managed disk, this is
        /// the ID of the compute disk resource.</param>
        /// <param name="diskSizeGiB">Gets data disk size in GiB.</param>
        public ComputeDataDiskFragment(string name = default(string), string diskUri = default(string), string managedDiskId = default(string), int? diskSizeGiB = default(int?))
        {
            Name = name;
            DiskUri = diskUri;
            ManagedDiskId = managedDiskId;
            DiskSizeGiB = diskSizeGiB;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets data disk name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets when backed by a blob, the URI of underlying blob.
        /// </summary>
        [JsonProperty(PropertyName = "diskUri")]
        public string DiskUri { get; set; }

        /// <summary>
        /// Gets or sets when backed by managed disk, this is the ID of the
        /// compute disk resource.
        /// </summary>
        [JsonProperty(PropertyName = "managedDiskId")]
        public string ManagedDiskId { get; set; }

        /// <summary>
        /// Gets data disk size in GiB.
        /// </summary>
        [JsonProperty(PropertyName = "diskSizeGiB")]
        public int? DiskSizeGiB { get; set; }

    }
}
