// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Properties for creating a custom image from a VHD.
    /// </summary>
    public partial class CustomImagePropertiesCustom
    {
        /// <summary>
        /// Initializes a new instance of the CustomImagePropertiesCustom
        /// class.
        /// </summary>
        public CustomImagePropertiesCustom()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CustomImagePropertiesCustom
        /// class.
        /// </summary>
        /// <param name="osType">The OS type of the custom image (i.e. Windows,
        /// Linux). Possible values include: 'Windows', 'Linux', 'None'</param>
        /// <param name="imageName">The image name.</param>
        /// <param name="sysPrep">Indicates whether sysprep has been run on the
        /// VHD.</param>
        public CustomImagePropertiesCustom(string osType, string imageName = default(string), bool? sysPrep = default(bool?))
        {
            ImageName = imageName;
            SysPrep = sysPrep;
            OsType = osType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the image name.
        /// </summary>
        [JsonProperty(PropertyName = "imageName")]
        public string ImageName { get; set; }

        /// <summary>
        /// Gets or sets indicates whether sysprep has been run on the VHD.
        /// </summary>
        [JsonProperty(PropertyName = "sysPrep")]
        public bool? SysPrep { get; set; }

        /// <summary>
        /// Gets or sets the OS type of the custom image (i.e. Windows, Linux).
        /// Possible values include: 'Windows', 'Linux', 'None'
        /// </summary>
        [JsonProperty(PropertyName = "osType")]
        public string OsType { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (OsType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "OsType");
            }
        }
    }
}
