// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Request body for adding a new or existing data disk to a virtual
    /// machine.
    /// </summary>
    public partial class DataDiskPropertiesFragment
    {
        /// <summary>
        /// Initializes a new instance of the DataDiskPropertiesFragment class.
        /// </summary>
        public DataDiskPropertiesFragment()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DataDiskPropertiesFragment class.
        /// </summary>
        /// <param name="attachNewDataDiskOptions">Specifies options to attach
        /// a new disk to the virtual machine.</param>
        /// <param name="existingLabDiskId">Specifies the existing lab disk id
        /// to attach to virtual machine.</param>
        /// <param name="hostCaching">Caching option for a data disk (i.e.
        /// None, ReadOnly, ReadWrite). Possible values include: 'None',
        /// 'ReadOnly', 'ReadWrite'</param>
        public DataDiskPropertiesFragment(AttachNewDataDiskOptionsFragment attachNewDataDiskOptions = default(AttachNewDataDiskOptionsFragment), string existingLabDiskId = default(string), string hostCaching = default(string))
        {
            AttachNewDataDiskOptions = attachNewDataDiskOptions;
            ExistingLabDiskId = existingLabDiskId;
            HostCaching = hostCaching;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies options to attach a new disk to the virtual
        /// machine.
        /// </summary>
        [JsonProperty(PropertyName = "attachNewDataDiskOptions")]
        public AttachNewDataDiskOptionsFragment AttachNewDataDiskOptions { get; set; }

        /// <summary>
        /// Gets or sets specifies the existing lab disk id to attach to
        /// virtual machine.
        /// </summary>
        [JsonProperty(PropertyName = "existingLabDiskId")]
        public string ExistingLabDiskId { get; set; }

        /// <summary>
        /// Gets or sets caching option for a data disk (i.e. None, ReadOnly,
        /// ReadWrite). Possible values include: 'None', 'ReadOnly',
        /// 'ReadWrite'
        /// </summary>
        [JsonProperty(PropertyName = "hostCaching")]
        public string HostCaching { get; set; }

    }
}
