// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// An environment, which is essentially an ARM template deployment.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class DtlEnvironment : Resource
    {
        /// <summary>
        /// Initializes a new instance of the DtlEnvironment class.
        /// </summary>
        public DtlEnvironment()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DtlEnvironment class.
        /// </summary>
        /// <param name="id">The identifier of the resource.</param>
        /// <param name="name">The name of the resource.</param>
        /// <param name="type">The type of the resource.</param>
        /// <param name="location">The location of the resource.</param>
        /// <param name="tags">The tags of the resource.</param>
        /// <param name="deploymentProperties">The deployment properties of the
        /// environment.</param>
        /// <param name="armTemplateDisplayName">The display name of the Azure
        /// Resource Manager template that produced the environment.</param>
        /// <param name="resourceGroupId">The identifier of the resource group
        /// containing the environment's resources.</param>
        /// <param name="createdByUser">The creator of the environment.</param>
        /// <param name="provisioningState">The provisioning status of the
        /// resource.</param>
        /// <param name="uniqueIdentifier">The unique immutable identifier of a
        /// resource (Guid).</param>
        public DtlEnvironment(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), EnvironmentDeploymentProperties deploymentProperties = default(EnvironmentDeploymentProperties), string armTemplateDisplayName = default(string), string resourceGroupId = default(string), string createdByUser = default(string), string provisioningState = default(string), string uniqueIdentifier = default(string))
            : base(id, name, type, location, tags)
        {
            DeploymentProperties = deploymentProperties;
            ArmTemplateDisplayName = armTemplateDisplayName;
            ResourceGroupId = resourceGroupId;
            CreatedByUser = createdByUser;
            ProvisioningState = provisioningState;
            UniqueIdentifier = uniqueIdentifier;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the deployment properties of the environment.
        /// </summary>
        [JsonProperty(PropertyName = "properties.deploymentProperties")]
        public EnvironmentDeploymentProperties DeploymentProperties { get; set; }

        /// <summary>
        /// Gets or sets the display name of the Azure Resource Manager
        /// template that produced the environment.
        /// </summary>
        [JsonProperty(PropertyName = "properties.armTemplateDisplayName")]
        public string ArmTemplateDisplayName { get; set; }

        /// <summary>
        /// Gets the identifier of the resource group containing the
        /// environment's resources.
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceGroupId")]
        public string ResourceGroupId { get; private set; }

        /// <summary>
        /// Gets the creator of the environment.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdByUser")]
        public string CreatedByUser { get; private set; }

        /// <summary>
        /// Gets the provisioning status of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets the unique immutable identifier of a resource (Guid).
        /// </summary>
        [JsonProperty(PropertyName = "properties.uniqueIdentifier")]
        public string UniqueIdentifier { get; private set; }

    }
}
