// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// An environment, which is essentially an ARM template deployment.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class DtlEnvironmentFragment : UpdateResource
    {
        /// <summary>
        /// Initializes a new instance of the DtlEnvironmentFragment class.
        /// </summary>
        public DtlEnvironmentFragment()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DtlEnvironmentFragment class.
        /// </summary>
        /// <param name="tags">The tags of the resource.</param>
        /// <param name="deploymentProperties">The deployment properties of the
        /// environment.</param>
        /// <param name="armTemplateDisplayName">The display name of the Azure
        /// Resource Manager template that produced the environment.</param>
        public DtlEnvironmentFragment(IDictionary<string, string> tags = default(IDictionary<string, string>), EnvironmentDeploymentPropertiesFragment deploymentProperties = default(EnvironmentDeploymentPropertiesFragment), string armTemplateDisplayName = default(string))
            : base(tags)
        {
            DeploymentProperties = deploymentProperties;
            ArmTemplateDisplayName = armTemplateDisplayName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the deployment properties of the environment.
        /// </summary>
        [JsonProperty(PropertyName = "properties.deploymentProperties")]
        public EnvironmentDeploymentPropertiesFragment DeploymentProperties { get; set; }

        /// <summary>
        /// Gets or sets the display name of the Azure Resource Manager
        /// template that produced the environment.
        /// </summary>
        [JsonProperty(PropertyName = "properties.armTemplateDisplayName")]
        public string ArmTemplateDisplayName { get; set; }

    }
}
