// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters of the export operation.
    /// </summary>
    public partial class ExportResourceUsageParameters
    {
        /// <summary>
        /// Initializes a new instance of the ExportResourceUsageParameters
        /// class.
        /// </summary>
        public ExportResourceUsageParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ExportResourceUsageParameters
        /// class.
        /// </summary>
        /// <param name="blobStorageAbsoluteSasUri">The blob storage absolute
        /// sas uri with write permission to the container which the usage data
        /// needs to be uploaded to.</param>
        /// <param name="usageStartDate">The start time of the usage. If not
        /// provided, usage will be reported since the beginning of data
        /// collection.</param>
        public ExportResourceUsageParameters(string blobStorageAbsoluteSasUri = default(string), System.DateTime? usageStartDate = default(System.DateTime?))
        {
            BlobStorageAbsoluteSasUri = blobStorageAbsoluteSasUri;
            UsageStartDate = usageStartDate;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the blob storage absolute sas uri with write
        /// permission to the container which the usage data needs to be
        /// uploaded to.
        /// </summary>
        [JsonProperty(PropertyName = "blobStorageAbsoluteSasUri")]
        public string BlobStorageAbsoluteSasUri { get; set; }

        /// <summary>
        /// Gets or sets the start time of the usage. If not provided, usage
        /// will be reported since the beginning of data collection.
        /// </summary>
        [JsonProperty(PropertyName = "usageStartDate")]
        public System.DateTime? UsageStartDate { get; set; }

    }
}
