// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A cost item.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class LabCost : Resource
    {
        /// <summary>
        /// Initializes a new instance of the LabCost class.
        /// </summary>
        public LabCost()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the LabCost class.
        /// </summary>
        /// <param name="id">The identifier of the resource.</param>
        /// <param name="name">The name of the resource.</param>
        /// <param name="type">The type of the resource.</param>
        /// <param name="location">The location of the resource.</param>
        /// <param name="tags">The tags of the resource.</param>
        /// <param name="targetCost">The target cost properties</param>
        /// <param name="labCostSummary">The lab cost summary component of the
        /// cost data.</param>
        /// <param name="labCostDetails">The lab cost details component of the
        /// cost data.</param>
        /// <param name="resourceCosts">The resource cost component of the cost
        /// data.</param>
        /// <param name="currencyCode">The currency code of the cost.</param>
        /// <param name="startDateTime">The start time of the cost
        /// data.</param>
        /// <param name="endDateTime">The end time of the cost data.</param>
        /// <param name="createdDate">The creation date of the cost.</param>
        /// <param name="provisioningState">The provisioning status of the
        /// resource.</param>
        /// <param name="uniqueIdentifier">The unique immutable identifier of a
        /// resource (Guid).</param>
        public LabCost(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), TargetCostProperties targetCost = default(TargetCostProperties), LabCostSummaryProperties labCostSummary = default(LabCostSummaryProperties), IList<LabCostDetailsProperties> labCostDetails = default(IList<LabCostDetailsProperties>), IList<LabResourceCostProperties> resourceCosts = default(IList<LabResourceCostProperties>), string currencyCode = default(string), System.DateTime? startDateTime = default(System.DateTime?), System.DateTime? endDateTime = default(System.DateTime?), System.DateTime? createdDate = default(System.DateTime?), string provisioningState = default(string), string uniqueIdentifier = default(string))
            : base(id, name, type, location, tags)
        {
            TargetCost = targetCost;
            LabCostSummary = labCostSummary;
            LabCostDetails = labCostDetails;
            ResourceCosts = resourceCosts;
            CurrencyCode = currencyCode;
            StartDateTime = startDateTime;
            EndDateTime = endDateTime;
            CreatedDate = createdDate;
            ProvisioningState = provisioningState;
            UniqueIdentifier = uniqueIdentifier;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the target cost properties
        /// </summary>
        [JsonProperty(PropertyName = "properties.targetCost")]
        public TargetCostProperties TargetCost { get; set; }

        /// <summary>
        /// Gets the lab cost summary component of the cost data.
        /// </summary>
        [JsonProperty(PropertyName = "properties.labCostSummary")]
        public LabCostSummaryProperties LabCostSummary { get; private set; }

        /// <summary>
        /// Gets the lab cost details component of the cost data.
        /// </summary>
        [JsonProperty(PropertyName = "properties.labCostDetails")]
        public IList<LabCostDetailsProperties> LabCostDetails { get; private set; }

        /// <summary>
        /// Gets the resource cost component of the cost data.
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceCosts")]
        public IList<LabResourceCostProperties> ResourceCosts { get; private set; }

        /// <summary>
        /// Gets or sets the currency code of the cost.
        /// </summary>
        [JsonProperty(PropertyName = "properties.currencyCode")]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Gets or sets the start time of the cost data.
        /// </summary>
        [JsonProperty(PropertyName = "properties.startDateTime")]
        public System.DateTime? StartDateTime { get; set; }

        /// <summary>
        /// Gets or sets the end time of the cost data.
        /// </summary>
        [JsonProperty(PropertyName = "properties.endDateTime")]
        public System.DateTime? EndDateTime { get; set; }

        /// <summary>
        /// Gets or sets the creation date of the cost.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdDate")]
        public System.DateTime? CreatedDate { get; set; }

        /// <summary>
        /// Gets the provisioning status of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets the unique immutable identifier of a resource (Guid).
        /// </summary>
        [JsonProperty(PropertyName = "properties.uniqueIdentifier")]
        public string UniqueIdentifier { get; private set; }

    }
}
