// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Properties for creating a schedule.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ScheduleCreationParameter
    {
        /// <summary>
        /// Initializes a new instance of the ScheduleCreationParameter class.
        /// </summary>
        public ScheduleCreationParameter()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ScheduleCreationParameter class.
        /// </summary>
        /// <param name="status">The status of the schedule (i.e. Enabled,
        /// Disabled). Possible values include: 'Enabled', 'Disabled'</param>
        /// <param name="taskType">The task type of the schedule (e.g.
        /// LabVmsShutdownTask, LabVmAutoStart).</param>
        /// <param name="weeklyRecurrence">If the schedule will occur only some
        /// days of the week, specify the weekly recurrence.</param>
        /// <param name="dailyRecurrence">If the schedule will occur once each
        /// day of the week, specify the daily recurrence.</param>
        /// <param name="hourlyRecurrence">If the schedule will occur multiple
        /// times a day, specify the hourly recurrence.</param>
        /// <param name="timeZoneId">The time zone ID (e.g. Pacific Standard
        /// time).</param>
        /// <param name="notificationSettings">Notification settings.</param>
        /// <param name="targetResourceId">The resource ID to which the
        /// schedule belongs</param>
        /// <param name="name">The name of the virtual machine or
        /// environment</param>
        /// <param name="location">The location of the new virtual machine or
        /// environment</param>
        /// <param name="tags">The tags of the resource.</param>
        public ScheduleCreationParameter(string status = default(string), string taskType = default(string), WeekDetails weeklyRecurrence = default(WeekDetails), DayDetails dailyRecurrence = default(DayDetails), HourDetails hourlyRecurrence = default(HourDetails), string timeZoneId = default(string), NotificationSettings notificationSettings = default(NotificationSettings), string targetResourceId = default(string), string name = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>))
        {
            Status = status;
            TaskType = taskType;
            WeeklyRecurrence = weeklyRecurrence;
            DailyRecurrence = dailyRecurrence;
            HourlyRecurrence = hourlyRecurrence;
            TimeZoneId = timeZoneId;
            NotificationSettings = notificationSettings;
            TargetResourceId = targetResourceId;
            Name = name;
            Location = location;
            Tags = tags;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the status of the schedule (i.e. Enabled, Disabled).
        /// Possible values include: 'Enabled', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets the task type of the schedule (e.g.
        /// LabVmsShutdownTask, LabVmAutoStart).
        /// </summary>
        [JsonProperty(PropertyName = "properties.taskType")]
        public string TaskType { get; set; }

        /// <summary>
        /// Gets or sets if the schedule will occur only some days of the week,
        /// specify the weekly recurrence.
        /// </summary>
        [JsonProperty(PropertyName = "properties.weeklyRecurrence")]
        public WeekDetails WeeklyRecurrence { get; set; }

        /// <summary>
        /// Gets or sets if the schedule will occur once each day of the week,
        /// specify the daily recurrence.
        /// </summary>
        [JsonProperty(PropertyName = "properties.dailyRecurrence")]
        public DayDetails DailyRecurrence { get; set; }

        /// <summary>
        /// Gets or sets if the schedule will occur multiple times a day,
        /// specify the hourly recurrence.
        /// </summary>
        [JsonProperty(PropertyName = "properties.hourlyRecurrence")]
        public HourDetails HourlyRecurrence { get; set; }

        /// <summary>
        /// Gets or sets the time zone ID (e.g. Pacific Standard time).
        /// </summary>
        [JsonProperty(PropertyName = "properties.timeZoneId")]
        public string TimeZoneId { get; set; }

        /// <summary>
        /// Gets or sets notification settings.
        /// </summary>
        [JsonProperty(PropertyName = "properties.notificationSettings")]
        public NotificationSettings NotificationSettings { get; set; }

        /// <summary>
        /// Gets or sets the resource ID to which the schedule belongs
        /// </summary>
        [JsonProperty(PropertyName = "properties.targetResourceId")]
        public string TargetResourceId { get; set; }

        /// <summary>
        /// Gets or sets the name of the virtual machine or environment
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the location of the new virtual machine or environment
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets the tags of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

    }
}
