// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.DevTestLabs
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Azure.OData;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ServiceFabricSchedulesOperations.
    /// </summary>
    public static partial class ServiceFabricSchedulesOperationsExtensions
    {
            /// <summary>
            /// List schedules in a given service fabric.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            public static IPage<Schedule> List(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, ODataQuery<Schedule> odataQuery = default(ODataQuery<Schedule>))
            {
                return operations.ListAsync(resourceGroupName, labName, userName, serviceFabricName, odataQuery).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List schedules in a given service fabric.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Schedule>> ListAsync(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, ODataQuery<Schedule> odataQuery = default(ODataQuery<Schedule>), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroupName, labName, userName, serviceFabricName, odataQuery, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get schedule.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            /// <param name='expand'>
            /// Specify the $expand query. Example: 'properties($select=status)'
            /// </param>
            public static Schedule Get(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name, string expand = default(string))
            {
                return operations.GetAsync(resourceGroupName, labName, userName, serviceFabricName, name, expand).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get schedule.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            /// <param name='expand'>
            /// Specify the $expand query. Example: 'properties($select=status)'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Schedule> GetAsync(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name, string expand = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, labName, userName, serviceFabricName, name, expand, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Create or replace an existing schedule.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            /// <param name='schedule'>
            /// A schedule.
            /// </param>
            public static Schedule CreateOrUpdate(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name, Schedule schedule)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, labName, userName, serviceFabricName, name, schedule).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or replace an existing schedule.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            /// <param name='schedule'>
            /// A schedule.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Schedule> CreateOrUpdateAsync(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name, Schedule schedule, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, labName, userName, serviceFabricName, name, schedule, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete schedule.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            public static void Delete(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name)
            {
                operations.DeleteAsync(resourceGroupName, labName, userName, serviceFabricName, name).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete schedule.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, labName, userName, serviceFabricName, name, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Modify properties of schedules.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            /// <param name='schedule'>
            /// A schedule.
            /// </param>
            public static Schedule Update(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name, ScheduleFragment schedule)
            {
                return operations.UpdateAsync(resourceGroupName, labName, userName, serviceFabricName, name, schedule).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Modify properties of schedules.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            /// <param name='schedule'>
            /// A schedule.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Schedule> UpdateAsync(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name, ScheduleFragment schedule, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(resourceGroupName, labName, userName, serviceFabricName, name, schedule, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute a schedule. This operation can take a while to complete.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            public static void Execute(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name)
            {
                operations.ExecuteAsync(resourceGroupName, labName, userName, serviceFabricName, name).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute a schedule. This operation can take a while to complete.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task ExecuteAsync(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.ExecuteWithHttpMessagesAsync(resourceGroupName, labName, userName, serviceFabricName, name, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Execute a schedule. This operation can take a while to complete.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            public static void BeginExecute(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name)
            {
                operations.BeginExecuteAsync(resourceGroupName, labName, userName, serviceFabricName, name).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute a schedule. This operation can take a while to complete.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='labName'>
            /// The name of the lab.
            /// </param>
            /// <param name='userName'>
            /// The name of the user profile.
            /// </param>
            /// <param name='serviceFabricName'>
            /// The name of the service Fabric.
            /// </param>
            /// <param name='name'>
            /// The name of the schedule.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginExecuteAsync(this IServiceFabricSchedulesOperations operations, string resourceGroupName, string labName, string userName, string serviceFabricName, string name, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginExecuteWithHttpMessagesAsync(resourceGroupName, labName, userName, serviceFabricName, name, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// List schedules in a given service fabric.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<Schedule> ListNext(this IServiceFabricSchedulesOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List schedules in a given service fabric.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Schedule>> ListNextAsync(this IServiceFabricSchedulesOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
