// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.EdgeGateway.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Details related to the IPv6 address configuration.
    /// </summary>
    public partial class Ipv6Config
    {
        /// <summary>
        /// Initializes a new instance of the Ipv6Config class.
        /// </summary>
        public Ipv6Config()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Ipv6Config class.
        /// </summary>
        /// <param name="ipAddress">The IPv6 address of the network
        /// adapter.</param>
        /// <param name="prefixLength">The IPv6 prefix of the network
        /// adapter.</param>
        /// <param name="gateway">The IPv6 gateway of the network
        /// adapter.</param>
        public Ipv6Config(string ipAddress = default(string), int? prefixLength = default(int?), string gateway = default(string))
        {
            IpAddress = ipAddress;
            PrefixLength = prefixLength;
            Gateway = gateway;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the IPv6 address of the network adapter.
        /// </summary>
        [JsonProperty(PropertyName = "ipAddress")]
        public string IpAddress { get; private set; }

        /// <summary>
        /// Gets the IPv6 prefix of the network adapter.
        /// </summary>
        [JsonProperty(PropertyName = "prefixLength")]
        public int? PrefixLength { get; private set; }

        /// <summary>
        /// Gets the IPv6 gateway of the network adapter.
        /// </summary>
        [JsonProperty(PropertyName = "gateway")]
        public string Gateway { get; private set; }

    }
}
