// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.EdgeGateway.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Fields for tracking refresh job on the share.
    /// </summary>
    public partial class RefreshDetails
    {
        /// <summary>
        /// Initializes a new instance of the RefreshDetails class.
        /// </summary>
        public RefreshDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RefreshDetails class.
        /// </summary>
        /// <param name="inProgressRefreshJobId">If a refresh share job is
        /// currently in progress on this share, this field indicates the ARM
        /// resource ID of that job. The field is empty if no job is in
        /// progress.</param>
        /// <param name="lastCompletedRefreshJobTimeInUTC">Indicates the
        /// completed time for the last refresh job on this particular share,
        /// if any.This could be a failed job or a successful job.</param>
        /// <param name="errorManifestFile">Indicates the relative path of the
        /// error xml for the last refresh job on this particular share, if
        /// any. This could be a failed job or a successful job.</param>
        /// <param name="lastJob">Indicates the id of the last refresh job on
        /// this particular share,if any. This could be a failed job or a
        /// successful job.</param>
        public RefreshDetails(string inProgressRefreshJobId = default(string), System.DateTime? lastCompletedRefreshJobTimeInUTC = default(System.DateTime?), string errorManifestFile = default(string), string lastJob = default(string))
        {
            InProgressRefreshJobId = inProgressRefreshJobId;
            LastCompletedRefreshJobTimeInUTC = lastCompletedRefreshJobTimeInUTC;
            ErrorManifestFile = errorManifestFile;
            LastJob = lastJob;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets if a refresh share job is currently in progress on
        /// this share, this field indicates the ARM resource ID of that job.
        /// The field is empty if no job is in progress.
        /// </summary>
        [JsonProperty(PropertyName = "inProgressRefreshJobId")]
        public string InProgressRefreshJobId { get; set; }

        /// <summary>
        /// Gets or sets indicates the completed time for the last refresh job
        /// on this particular share, if any.This could be a failed job or a
        /// successful job.
        /// </summary>
        [JsonProperty(PropertyName = "lastCompletedRefreshJobTimeInUTC")]
        public System.DateTime? LastCompletedRefreshJobTimeInUTC { get; set; }

        /// <summary>
        /// Gets or sets indicates the relative path of the error xml for the
        /// last refresh job on this particular share, if any. This could be a
        /// failed job or a successful job.
        /// </summary>
        [JsonProperty(PropertyName = "errorManifestFile")]
        public string ErrorManifestFile { get; set; }

        /// <summary>
        /// Gets or sets indicates the id of the last refresh job on this
        /// particular share,if any. This could be a failed job or a successful
        /// job.
        /// </summary>
        [JsonProperty(PropertyName = "lastJob")]
        public string LastJob { get; set; }

    }
}
