// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.EventGrid.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The target of the event.
    /// </summary>
    public partial class ContainerRegistryArtifactEventTarget
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ContainerRegistryArtifactEventTarget class.
        /// </summary>
        public ContainerRegistryArtifactEventTarget()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ContainerRegistryArtifactEventTarget class.
        /// </summary>
        /// <param name="mediaType">The MIME type of the artifact.</param>
        /// <param name="size">The size in bytes of the artifact.</param>
        /// <param name="digest">The digest of the artifact.</param>
        /// <param name="repository">The repository name of the
        /// artifact.</param>
        /// <param name="tag">The tag of the artifact.</param>
        /// <param name="name">The name of the artifact.</param>
        /// <param name="version">The version of the artifact.</param>
        public ContainerRegistryArtifactEventTarget(string mediaType = default(string), long? size = default(long?), string digest = default(string), string repository = default(string), string tag = default(string), string name = default(string), string version = default(string))
        {
            MediaType = mediaType;
            Size = size;
            Digest = digest;
            Repository = repository;
            Tag = tag;
            Name = name;
            Version = version;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the MIME type of the artifact.
        /// </summary>
        [JsonProperty(PropertyName = "mediaType")]
        public string MediaType { get; set; }

        /// <summary>
        /// Gets or sets the size in bytes of the artifact.
        /// </summary>
        [JsonProperty(PropertyName = "size")]
        public long? Size { get; set; }

        /// <summary>
        /// Gets or sets the digest of the artifact.
        /// </summary>
        [JsonProperty(PropertyName = "digest")]
        public string Digest { get; set; }

        /// <summary>
        /// Gets or sets the repository name of the artifact.
        /// </summary>
        [JsonProperty(PropertyName = "repository")]
        public string Repository { get; set; }

        /// <summary>
        /// Gets or sets the tag of the artifact.
        /// </summary>
        [JsonProperty(PropertyName = "tag")]
        public string Tag { get; set; }

        /// <summary>
        /// Gets or sets the name of the artifact.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the version of the artifact.
        /// </summary>
        [JsonProperty(PropertyName = "version")]
        public string Version { get; set; }

    }
}
