// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.EventGrid.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The content of the event request message.
    /// </summary>
    public partial class ContainerRegistryEventData
    {
        /// <summary>
        /// Initializes a new instance of the ContainerRegistryEventData class.
        /// </summary>
        public ContainerRegistryEventData()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ContainerRegistryEventData class.
        /// </summary>
        /// <param name="id">The event ID.</param>
        /// <param name="timestamp">The time at which the event
        /// occurred.</param>
        /// <param name="action">The action that encompasses the provided
        /// event.</param>
        /// <param name="target">The target of the event.</param>
        /// <param name="request">The request that generated the event.</param>
        /// <param name="actor">The agent that initiated the event. For most
        /// situations, this could be from the authorization context of the
        /// request.</param>
        /// <param name="source">The registry node that generated the event.
        /// Put differently, while the actor initiates the event, the source
        /// generates it.</param>
        public ContainerRegistryEventData(string id = default(string), System.DateTime? timestamp = default(System.DateTime?), string action = default(string), ContainerRegistryEventTarget target = default(ContainerRegistryEventTarget), ContainerRegistryEventRequest request = default(ContainerRegistryEventRequest), ContainerRegistryEventActor actor = default(ContainerRegistryEventActor), ContainerRegistryEventSource source = default(ContainerRegistryEventSource))
        {
            Id = id;
            Timestamp = timestamp;
            Action = action;
            Target = target;
            Request = request;
            Actor = actor;
            Source = source;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the event ID.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the time at which the event occurred.
        /// </summary>
        [JsonProperty(PropertyName = "timestamp")]
        public System.DateTime? Timestamp { get; set; }

        /// <summary>
        /// Gets or sets the action that encompasses the provided event.
        /// </summary>
        [JsonProperty(PropertyName = "action")]
        public string Action { get; set; }

        /// <summary>
        /// Gets or sets the target of the event.
        /// </summary>
        [JsonProperty(PropertyName = "target")]
        public ContainerRegistryEventTarget Target { get; set; }

        /// <summary>
        /// Gets or sets the request that generated the event.
        /// </summary>
        [JsonProperty(PropertyName = "request")]
        public ContainerRegistryEventRequest Request { get; set; }

        /// <summary>
        /// Gets or sets the agent that initiated the event. For most
        /// situations, this could be from the authorization context of the
        /// request.
        /// </summary>
        [JsonProperty(PropertyName = "actor")]
        public ContainerRegistryEventActor Actor { get; set; }

        /// <summary>
        /// Gets or sets the registry node that generated the event. Put
        /// differently, while the actor initiates the event, the source
        /// generates it.
        /// </summary>
        [JsonProperty(PropertyName = "source")]
        public ContainerRegistryEventSource Source { get; set; }

    }
}
