// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.EventGrid.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Schema of the Data property of an EventGridEvent for a device
    /// connection state event (DeviceConnected, DeviceDisconnected).
    /// </summary>
    public partial class DeviceConnectionStateEventProperties
    {
        /// <summary>
        /// Initializes a new instance of the
        /// DeviceConnectionStateEventProperties class.
        /// </summary>
        public DeviceConnectionStateEventProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// DeviceConnectionStateEventProperties class.
        /// </summary>
        /// <param name="deviceId">The unique identifier of the device. This
        /// case-sensitive string can be up to 128 characters long, and
        /// supports ASCII 7-bit alphanumeric characters plus the following
        /// special characters: - : . + % _ &amp;#35; * ? ! ( ) , = @ ; $
        /// '.</param>
        /// <param name="moduleId">The unique identifier of the module. This
        /// case-sensitive string can be up to 128 characters long, and
        /// supports ASCII 7-bit alphanumeric characters plus the following
        /// special characters: - : . + % _ &amp;#35; * ? ! ( ) , = @ ; $
        /// '.</param>
        /// <param name="hubName">Name of the IoT Hub where the device was
        /// created or deleted.</param>
        /// <param name="deviceConnectionStateEventInfo">Information about the
        /// device connection state event.</param>
        public DeviceConnectionStateEventProperties(string deviceId = default(string), string moduleId = default(string), string hubName = default(string), DeviceConnectionStateEventInfo deviceConnectionStateEventInfo = default(DeviceConnectionStateEventInfo))
        {
            DeviceId = deviceId;
            ModuleId = moduleId;
            HubName = hubName;
            DeviceConnectionStateEventInfo = deviceConnectionStateEventInfo;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the unique identifier of the device. This
        /// case-sensitive string can be up to 128 characters long, and
        /// supports ASCII 7-bit alphanumeric characters plus the following
        /// special characters: - : . + % _ &amp;amp;#35; * ? ! ( ) , = @ ; $
        /// '.
        /// </summary>
        [JsonProperty(PropertyName = "deviceId")]
        public string DeviceId { get; set; }

        /// <summary>
        /// Gets or sets the unique identifier of the module. This
        /// case-sensitive string can be up to 128 characters long, and
        /// supports ASCII 7-bit alphanumeric characters plus the following
        /// special characters: - : . + % _ &amp;amp;#35; * ? ! ( ) , = @ ; $
        /// '.
        /// </summary>
        [JsonProperty(PropertyName = "moduleId")]
        public string ModuleId { get; set; }

        /// <summary>
        /// Gets or sets name of the IoT Hub where the device was created or
        /// deleted.
        /// </summary>
        [JsonProperty(PropertyName = "hubName")]
        public string HubName { get; set; }

        /// <summary>
        /// Gets or sets information about the device connection state event.
        /// </summary>
        [JsonProperty(PropertyName = "deviceConnectionStateEventInfo")]
        public DeviceConnectionStateEventInfo DeviceConnectionStateEventInfo { get; set; }

    }
}
