// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.EventGrid.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The thumbprint is a unique value for the x509 certificate, commonly
    /// used to find a particular certificate in a certificate store. The
    /// thumbprint is dynamically generated using the SHA1 algorithm, and does
    /// not physically exist in the certificate.
    /// </summary>
    public partial class DeviceTwinInfoX509Thumbprint
    {
        /// <summary>
        /// Initializes a new instance of the DeviceTwinInfoX509Thumbprint
        /// class.
        /// </summary>
        public DeviceTwinInfoX509Thumbprint()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DeviceTwinInfoX509Thumbprint
        /// class.
        /// </summary>
        /// <param name="primaryThumbprint">Primary thumbprint for the x509
        /// certificate.</param>
        /// <param name="secondaryThumbprint">Secondary thumbprint for the x509
        /// certificate.</param>
        public DeviceTwinInfoX509Thumbprint(string primaryThumbprint = default(string), string secondaryThumbprint = default(string))
        {
            PrimaryThumbprint = primaryThumbprint;
            SecondaryThumbprint = secondaryThumbprint;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets primary thumbprint for the x509 certificate.
        /// </summary>
        [JsonProperty(PropertyName = "primaryThumbprint")]
        public string PrimaryThumbprint { get; set; }

        /// <summary>
        /// Gets or sets secondary thumbprint for the x509 certificate.
        /// </summary>
        [JsonProperty(PropertyName = "secondaryThumbprint")]
        public string SecondaryThumbprint { get; set; }

    }
}
