// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.EventGrid.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The geofence geometry.
    /// </summary>
    public partial class MapsGeofenceGeometry
    {
        /// <summary>
        /// Initializes a new instance of the MapsGeofenceGeometry class.
        /// </summary>
        public MapsGeofenceGeometry()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MapsGeofenceGeometry class.
        /// </summary>
        /// <param name="deviceId">ID of the device.</param>
        /// <param name="distance">Distance from the coordinate to the closest
        /// border of the geofence. Positive means the coordinate is outside of
        /// the geofence. If the coordinate is outside of the geofence, but
        /// more than the value of searchBuffer away from the closest geofence
        /// border, then the value is 999. Negative means the coordinate is
        /// inside of the geofence. If the coordinate is inside the polygon,
        /// but more than the value of searchBuffer away from the closest
        /// geofencing border,then the value is -999. A value of 999 means that
        /// there is great confidence the coordinate is well outside the
        /// geofence. A value of -999 means that there is great confidence the
        /// coordinate is well within the geofence.</param>
        /// <param name="geometryId">The unique ID for the geofence
        /// geometry.</param>
        /// <param name="nearestLat">Latitude of the nearest point of the
        /// geometry.</param>
        /// <param name="nearestLon">Longitude of the nearest point of the
        /// geometry.</param>
        /// <param name="udId">The unique id returned from user upload service
        /// when uploading a geofence. Will not be included in geofencing post
        /// API.</param>
        public MapsGeofenceGeometry(string deviceId = default(string), double? distance = default(double?), string geometryId = default(string), double? nearestLat = default(double?), double? nearestLon = default(double?), string udId = default(string))
        {
            DeviceId = deviceId;
            Distance = distance;
            GeometryId = geometryId;
            NearestLat = nearestLat;
            NearestLon = nearestLon;
            UdId = udId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID of the device.
        /// </summary>
        [JsonProperty(PropertyName = "deviceId")]
        public string DeviceId { get; set; }

        /// <summary>
        /// Gets or sets distance from the coordinate to the closest border of
        /// the geofence. Positive means the coordinate is outside of the
        /// geofence. If the coordinate is outside of the geofence, but more
        /// than the value of searchBuffer away from the closest geofence
        /// border, then the value is 999. Negative means the coordinate is
        /// inside of the geofence. If the coordinate is inside the polygon,
        /// but more than the value of searchBuffer away from the closest
        /// geofencing border,then the value is -999. A value of 999 means that
        /// there is great confidence the coordinate is well outside the
        /// geofence. A value of -999 means that there is great confidence the
        /// coordinate is well within the geofence.
        /// </summary>
        [JsonProperty(PropertyName = "distance")]
        public double? Distance { get; set; }

        /// <summary>
        /// Gets or sets the unique ID for the geofence geometry.
        /// </summary>
        [JsonProperty(PropertyName = "geometryId")]
        public string GeometryId { get; set; }

        /// <summary>
        /// Gets or sets latitude of the nearest point of the geometry.
        /// </summary>
        [JsonProperty(PropertyName = "nearestLat")]
        public double? NearestLat { get; set; }

        /// <summary>
        /// Gets or sets longitude of the nearest point of the geometry.
        /// </summary>
        [JsonProperty(PropertyName = "nearestLon")]
        public double? NearestLon { get; set; }

        /// <summary>
        /// Gets or sets the unique id returned from user upload service when
        /// uploading a geofence. Will not be included in geofencing post API.
        /// </summary>
        [JsonProperty(PropertyName = "udId")]
        public string UdId { get; set; }

    }
}
