// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.EventGrid.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Schema of the Data property of an EventGridEvent for a
    /// Microsoft.Media.JobOutputStateChange event.
    /// </summary>
    public partial class MediaJobOutputStateChangeEventData
    {
        /// <summary>
        /// Initializes a new instance of the
        /// MediaJobOutputStateChangeEventData class.
        /// </summary>
        public MediaJobOutputStateChangeEventData()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// MediaJobOutputStateChangeEventData class.
        /// </summary>
        /// <param name="previousState">The previous state of the Job. Possible
        /// values include: 'Canceled', 'Canceling', 'Error', 'Finished',
        /// 'Processing', 'Queued', 'Scheduled'</param>
        /// <param name="output">Gets the output.</param>
        /// <param name="jobCorrelationData">Gets the Job correlation
        /// data.</param>
        public MediaJobOutputStateChangeEventData(MediaJobState previousState = default(MediaJobState), MediaJobOutput output = default(MediaJobOutput), IDictionary<string, string> jobCorrelationData = default(IDictionary<string, string>))
        {
            PreviousState = previousState;
            Output = output;
            JobCorrelationData = jobCorrelationData;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the previous state of the Job. Possible values include:
        /// 'Canceled', 'Canceling', 'Error', 'Finished', 'Processing',
        /// 'Queued', 'Scheduled'
        /// </summary>
        [JsonProperty(PropertyName = "previousState")]
        public MediaJobState PreviousState { get; private set; }

        /// <summary>
        /// Gets the output.
        /// </summary>
        [JsonProperty(PropertyName = "output")]
        public MediaJobOutput Output { get; set; }

        /// <summary>
        /// Gets the Job correlation data.
        /// </summary>
        [JsonProperty(PropertyName = "jobCorrelationData")]
        public IDictionary<string, string> JobCorrelationData { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Output != null)
            {
                Output.Validate();
            }
        }
    }
}
