// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.EventGrid.Models
{
    using Newtonsoft.Json;
    using Newtonsoft.Json.Converters;
    using System.Runtime;
    using System.Runtime.Serialization;

    /// <summary>
    /// Defines values for MediaJobState.
    /// </summary>
    [JsonConverter(typeof(StringEnumConverter))]
    public enum MediaJobState
    {
        /// <summary>
        /// The job was canceled. This is a final state for the job.
        /// </summary>
        [EnumMember(Value = "Canceled")]
        Canceled,
        /// <summary>
        /// The job is in the process of being canceled. This is a transient
        /// state for the job.
        /// </summary>
        [EnumMember(Value = "Canceling")]
        Canceling,
        /// <summary>
        /// The job has encountered an error. This is a final state for the
        /// job.
        /// </summary>
        [EnumMember(Value = "Error")]
        Error,
        /// <summary>
        /// The job is finished. This is a final state for the job.
        /// </summary>
        [EnumMember(Value = "Finished")]
        Finished,
        /// <summary>
        /// The job is processing. This is a transient state for the job.
        /// </summary>
        [EnumMember(Value = "Processing")]
        Processing,
        /// <summary>
        /// The job is in a queued state, waiting for resources to become
        /// available. This is a transient state.
        /// </summary>
        [EnumMember(Value = "Queued")]
        Queued,
        /// <summary>
        /// The job is being scheduled to run on an available resource. This is
        /// a transient state, between queued and processing states.
        /// </summary>
        [EnumMember(Value = "Scheduled")]
        Scheduled
    }
    internal static class MediaJobStateEnumExtension
    {
        internal static string ToSerializedValue(this MediaJobState? value)
        {
            return value == null ? null : ((MediaJobState)value).ToSerializedValue();
        }

        internal static string ToSerializedValue(this MediaJobState value)
        {
            switch( value )
            {
                case MediaJobState.Canceled:
                    return "Canceled";
                case MediaJobState.Canceling:
                    return "Canceling";
                case MediaJobState.Error:
                    return "Error";
                case MediaJobState.Finished:
                    return "Finished";
                case MediaJobState.Processing:
                    return "Processing";
                case MediaJobState.Queued:
                    return "Queued";
                case MediaJobState.Scheduled:
                    return "Scheduled";
            }
            return null;
        }

        internal static MediaJobState? ParseMediaJobState(this string value)
        {
            switch( value )
            {
                case "Canceled":
                    return MediaJobState.Canceled;
                case "Canceling":
                    return MediaJobState.Canceling;
                case "Error":
                    return MediaJobState.Error;
                case "Finished":
                    return MediaJobState.Finished;
                case "Processing":
                    return MediaJobState.Processing;
                case "Queued":
                    return MediaJobState.Queued;
                case "Scheduled":
                    return MediaJobState.Scheduled;
            }
            return null;
        }
    }
}
