// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.EventGrid.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Schema of the Data property of an EventGridEvent for a
    /// Microsoft.Resources.ResourceActionFailure event. This is raised when a
    /// resource action operation fails.
    /// </summary>
    public partial class ResourceActionFailureData
    {
        /// <summary>
        /// Initializes a new instance of the ResourceActionFailureData class.
        /// </summary>
        public ResourceActionFailureData()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceActionFailureData class.
        /// </summary>
        /// <param name="tenantId">The tenant ID of the resource.</param>
        /// <param name="subscriptionId">The subscription ID of the
        /// resource.</param>
        /// <param name="resourceGroup">The resource group of the
        /// resource.</param>
        /// <param name="resourceProvider">The resource provider performing the
        /// operation.</param>
        /// <param name="resourceUri">The URI of the resource in the
        /// operation.</param>
        /// <param name="operationName">The operation that was
        /// performed.</param>
        /// <param name="status">The status of the operation.</param>
        /// <param name="authorization">The requested authorization for the
        /// operation.</param>
        /// <param name="claims">The properties of the claims.</param>
        /// <param name="correlationId">An operation ID used for
        /// troubleshooting.</param>
        /// <param name="httpRequest">The details of the operation.</param>
        public ResourceActionFailureData(string tenantId = default(string), string subscriptionId = default(string), string resourceGroup = default(string), string resourceProvider = default(string), string resourceUri = default(string), string operationName = default(string), string status = default(string), string authorization = default(string), string claims = default(string), string correlationId = default(string), string httpRequest = default(string))
        {
            TenantId = tenantId;
            SubscriptionId = subscriptionId;
            ResourceGroup = resourceGroup;
            ResourceProvider = resourceProvider;
            ResourceUri = resourceUri;
            OperationName = operationName;
            Status = status;
            Authorization = authorization;
            Claims = claims;
            CorrelationId = correlationId;
            HttpRequest = httpRequest;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the tenant ID of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "tenantId")]
        public string TenantId { get; set; }

        /// <summary>
        /// Gets or sets the subscription ID of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "subscriptionId")]
        public string SubscriptionId { get; set; }

        /// <summary>
        /// Gets or sets the resource group of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "resourceGroup")]
        public string ResourceGroup { get; set; }

        /// <summary>
        /// Gets or sets the resource provider performing the operation.
        /// </summary>
        [JsonProperty(PropertyName = "resourceProvider")]
        public string ResourceProvider { get; set; }

        /// <summary>
        /// Gets or sets the URI of the resource in the operation.
        /// </summary>
        [JsonProperty(PropertyName = "resourceUri")]
        public string ResourceUri { get; set; }

        /// <summary>
        /// Gets or sets the operation that was performed.
        /// </summary>
        [JsonProperty(PropertyName = "operationName")]
        public string OperationName { get; set; }

        /// <summary>
        /// Gets or sets the status of the operation.
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets the requested authorization for the operation.
        /// </summary>
        [JsonProperty(PropertyName = "authorization")]
        public string Authorization { get; set; }

        /// <summary>
        /// Gets or sets the properties of the claims.
        /// </summary>
        [JsonProperty(PropertyName = "claims")]
        public string Claims { get; set; }

        /// <summary>
        /// Gets or sets an operation ID used for troubleshooting.
        /// </summary>
        [JsonProperty(PropertyName = "correlationId")]
        public string CorrelationId { get; set; }

        /// <summary>
        /// Gets or sets the details of the operation.
        /// </summary>
        [JsonProperty(PropertyName = "httpRequest")]
        public string HttpRequest { get; set; }

    }
}
