// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.EventGrid.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Schema of the Data property of an EventGridEvent for a
    /// Microsoft.EventGrid.SubscriptionValidationEvent.
    /// </summary>
    public partial class SubscriptionValidationEventData
    {
        /// <summary>
        /// Initializes a new instance of the SubscriptionValidationEventData
        /// class.
        /// </summary>
        public SubscriptionValidationEventData()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SubscriptionValidationEventData
        /// class.
        /// </summary>
        /// <param name="validationCode">The validation code sent by Azure
        /// Event Grid to validate an event subscription. To complete the
        /// validation handshake, the subscriber must either respond with this
        /// validation code as part of the validation response, or perform a
        /// GET request on the validationUrl (available starting version
        /// 2018-05-01-preview).</param>
        /// <param name="validationUrl">The validation URL sent by Azure Event
        /// Grid (available starting version 2018-05-01-preview). To complete
        /// the validation handshake, the subscriber must either respond with
        /// the validationCode as part of the validation response, or perform a
        /// GET request on the validationUrl (available starting version
        /// 2018-05-01-preview).</param>
        public SubscriptionValidationEventData(string validationCode = default(string), string validationUrl = default(string))
        {
            ValidationCode = validationCode;
            ValidationUrl = validationUrl;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the validation code sent by Azure Event Grid to validate an
        /// event subscription. To complete the validation handshake, the
        /// subscriber must either respond with this validation code as part of
        /// the validation response, or perform a GET request on the
        /// validationUrl (available starting version 2018-05-01-preview).
        /// </summary>
        [JsonProperty(PropertyName = "validationCode")]
        public string ValidationCode { get; private set; }

        /// <summary>
        /// Gets the validation URL sent by Azure Event Grid (available
        /// starting version 2018-05-01-preview). To complete the validation
        /// handshake, the subscriber must either respond with the
        /// validationCode as part of the validation response, or perform a GET
        /// request on the validationUrl (available starting version
        /// 2018-05-01-preview).
        /// </summary>
        [JsonProperty(PropertyName = "validationUrl")]
        public string ValidationUrl { get; private set; }

    }
}
