// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.EventGrid.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Information about the azure function destination for an event
    /// subscription.
    /// </summary>
    [Newtonsoft.Json.JsonObject("AzureFunction")]
    [Rest.Serialization.JsonTransformation]
    public partial class AzureFunctionEventSubscriptionDestination : EventSubscriptionDestination
    {
        /// <summary>
        /// Initializes a new instance of the
        /// AzureFunctionEventSubscriptionDestination class.
        /// </summary>
        public AzureFunctionEventSubscriptionDestination()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// AzureFunctionEventSubscriptionDestination class.
        /// </summary>
        /// <param name="resourceId">The Azure Resource Id that represents the
        /// endpoint of the Azure Function destination of an event
        /// subscription.</param>
        /// <param name="maxEventsPerBatch">Maximum number of events per
        /// batch.</param>
        /// <param name="preferredBatchSizeInKilobytes">Preferred batch size in
        /// Kilobytes.</param>
        public AzureFunctionEventSubscriptionDestination(string resourceId = default(string), int? maxEventsPerBatch = default(int?), int? preferredBatchSizeInKilobytes = default(int?))
        {
            ResourceId = resourceId;
            MaxEventsPerBatch = maxEventsPerBatch;
            PreferredBatchSizeInKilobytes = preferredBatchSizeInKilobytes;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Azure Resource Id that represents the endpoint of
        /// the Azure Function destination of an event subscription.
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceId")]
        public string ResourceId { get; set; }

        /// <summary>
        /// Gets or sets maximum number of events per batch.
        /// </summary>
        [JsonProperty(PropertyName = "properties.maxEventsPerBatch")]
        public int? MaxEventsPerBatch { get; set; }

        /// <summary>
        /// Gets or sets preferred batch size in Kilobytes.
        /// </summary>
        [JsonProperty(PropertyName = "properties.preferredBatchSizeInKilobytes")]
        public int? PreferredBatchSizeInKilobytes { get; set; }

    }
}
