// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.EventGrid.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This is used to express the source of an input schema mapping for a
    /// single target field
    /// in the Event Grid Event schema. This is currently used in the mappings
    /// for the 'subject',
    /// 'eventtype' and 'dataversion' properties. This represents a field in
    /// the input event schema
    /// along with a default value to be used, and at least one of these two
    /// properties should be provided.
    /// </summary>
    public partial class JsonFieldWithDefault
    {
        /// <summary>
        /// Initializes a new instance of the JsonFieldWithDefault class.
        /// </summary>
        public JsonFieldWithDefault()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JsonFieldWithDefault class.
        /// </summary>
        /// <param name="sourceField">Name of a field in the input event schema
        /// that's to be used as the source of a mapping.</param>
        /// <param name="defaultValue">The default value to be used for mapping
        /// when a SourceField is not provided or if there's no property with
        /// the specified name in the published JSON event payload.</param>
        public JsonFieldWithDefault(string sourceField = default(string), string defaultValue = default(string))
        {
            SourceField = sourceField;
            DefaultValue = defaultValue;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of a field in the input event schema that's to be
        /// used as the source of a mapping.
        /// </summary>
        [JsonProperty(PropertyName = "sourceField")]
        public string SourceField { get; set; }

        /// <summary>
        /// Gets or sets the default value to be used for mapping when a
        /// SourceField is not provided or if there's no property with the
        /// specified name in the published JSON event payload.
        /// </summary>
        [JsonProperty(PropertyName = "defaultValue")]
        public string DefaultValue { get; set; }

    }
}
