// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.EventGrid.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Information about the storage blob based dead letter destination.
    /// </summary>
    [Newtonsoft.Json.JsonObject("StorageBlob")]
    [Rest.Serialization.JsonTransformation]
    public partial class StorageBlobDeadLetterDestination : DeadLetterDestination
    {
        /// <summary>
        /// Initializes a new instance of the StorageBlobDeadLetterDestination
        /// class.
        /// </summary>
        public StorageBlobDeadLetterDestination()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the StorageBlobDeadLetterDestination
        /// class.
        /// </summary>
        /// <param name="resourceId">The Azure Resource ID of the storage
        /// account that is the destination of the deadletter events</param>
        /// <param name="blobContainerName">The name of the Storage blob
        /// container that is the destination of the deadletter events</param>
        public StorageBlobDeadLetterDestination(string resourceId = default(string), string blobContainerName = default(string))
        {
            ResourceId = resourceId;
            BlobContainerName = blobContainerName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Azure Resource ID of the storage account that is
        /// the destination of the deadletter events
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceId")]
        public string ResourceId { get; set; }

        /// <summary>
        /// Gets or sets the name of the Storage blob container that is the
        /// destination of the deadletter events
        /// </summary>
        [JsonProperty(PropertyName = "properties.blobContainerName")]
        public string BlobContainerName { get; set; }

    }
}
