// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.EventGrid.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Information about the storage queue destination for an event
    /// subscription.
    /// </summary>
    [Newtonsoft.Json.JsonObject("StorageQueue")]
    [Rest.Serialization.JsonTransformation]
    public partial class StorageQueueEventSubscriptionDestination : EventSubscriptionDestination
    {
        /// <summary>
        /// Initializes a new instance of the
        /// StorageQueueEventSubscriptionDestination class.
        /// </summary>
        public StorageQueueEventSubscriptionDestination()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// StorageQueueEventSubscriptionDestination class.
        /// </summary>
        /// <param name="resourceId">The Azure Resource ID of the storage
        /// account that contains the queue that is the destination of an event
        /// subscription.</param>
        /// <param name="queueName">The name of the Storage queue under a
        /// storage account that is the destination of an event
        /// subscription.</param>
        public StorageQueueEventSubscriptionDestination(string resourceId = default(string), string queueName = default(string))
        {
            ResourceId = resourceId;
            QueueName = queueName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Azure Resource ID of the storage account that
        /// contains the queue that is the destination of an event
        /// subscription.
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceId")]
        public string ResourceId { get; set; }

        /// <summary>
        /// Gets or sets the name of the Storage queue under a storage account
        /// that is the destination of an event subscription.
        /// </summary>
        [JsonProperty(PropertyName = "properties.queueName")]
        public string QueueName { get; set; }

    }
}
