// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.EventGrid.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Properties of the Topic update
    /// </summary>
    public partial class TopicUpdateParameters
    {
        /// <summary>
        /// Initializes a new instance of the TopicUpdateParameters class.
        /// </summary>
        public TopicUpdateParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TopicUpdateParameters class.
        /// </summary>
        /// <param name="tags">Tags of the resource.</param>
        /// <param name="allowTrafficFromAllIPs">This determines if IP
        /// filtering rules ought to be evaluated or not. By default it will
        /// not evaluate and will allow traffic from all IPs.</param>
        /// <param name="inboundIpRules">This determines the IP filtering rules
        /// that ought be applied when events are received on this
        /// domain.</param>
        public TopicUpdateParameters(IDictionary<string, string> tags = default(IDictionary<string, string>), bool? allowTrafficFromAllIPs = default(bool?), IList<InboundIpRule> inboundIpRules = default(IList<InboundIpRule>))
        {
            Tags = tags;
            AllowTrafficFromAllIPs = allowTrafficFromAllIPs;
            InboundIpRules = inboundIpRules;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets tags of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets or sets this determines if IP filtering rules ought to be
        /// evaluated or not. By default it will not evaluate and will allow
        /// traffic from all IPs.
        /// </summary>
        [JsonProperty(PropertyName = "allowTrafficFromAllIPs")]
        public bool? AllowTrafficFromAllIPs { get; set; }

        /// <summary>
        /// Gets or sets this determines the IP filtering rules that ought be
        /// applied when events are received on this domain.
        /// </summary>
        [JsonProperty(PropertyName = "inboundIpRules")]
        public IList<InboundIpRule> InboundIpRules { get; set; }

    }
}
