// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.EventGrid
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for TopicTypesOperations.
    /// </summary>
    public static partial class TopicTypesOperationsExtensions
    {
            /// <summary>
            /// List topic types.
            /// </summary>
            /// <remarks>
            /// List all registered topic types.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static IEnumerable<TopicTypeInfo> List(this ITopicTypesOperations operations)
            {
                return operations.ListAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// List topic types.
            /// </summary>
            /// <remarks>
            /// List all registered topic types.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IEnumerable<TopicTypeInfo>> ListAsync(this ITopicTypesOperations operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a topic type.
            /// </summary>
            /// <remarks>
            /// Get information about a topic type.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='topicTypeName'>
            /// Name of the topic type.
            /// </param>
            public static TopicTypeInfo Get(this ITopicTypesOperations operations, string topicTypeName)
            {
                return operations.GetAsync(topicTypeName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a topic type.
            /// </summary>
            /// <remarks>
            /// Get information about a topic type.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='topicTypeName'>
            /// Name of the topic type.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<TopicTypeInfo> GetAsync(this ITopicTypesOperations operations, string topicTypeName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(topicTypeName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// List event types.
            /// </summary>
            /// <remarks>
            /// List event types for a topic type.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='topicTypeName'>
            /// Name of the topic type.
            /// </param>
            public static IEnumerable<EventType> ListEventTypes(this ITopicTypesOperations operations, string topicTypeName)
            {
                return operations.ListEventTypesAsync(topicTypeName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List event types.
            /// </summary>
            /// <remarks>
            /// List event types for a topic type.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='topicTypeName'>
            /// Name of the topic type.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IEnumerable<EventType>> ListEventTypesAsync(this ITopicTypesOperations operations, string topicTypeName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListEventTypesWithHttpMessagesAsync(topicTypeName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
