// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.FrontDoor.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Settings that apply to all backend pools.
    /// </summary>
    public partial class BackendPoolsSettings
    {
        /// <summary>
        /// Initializes a new instance of the BackendPoolsSettings class.
        /// </summary>
        public BackendPoolsSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BackendPoolsSettings class.
        /// </summary>
        /// <param name="enforceCertificateNameCheck">Whether to enforce
        /// certificate name check on HTTPS requests to all backend pools. No
        /// effect on non-HTTPS requests. Possible values include: 'Enabled',
        /// 'Disabled'</param>
        /// <param name="sendRecvTimeoutSeconds">Send and receive timeout on
        /// forwarding request to the backend. When timeout is reached, the
        /// request fails and returns.</param>
        public BackendPoolsSettings(string enforceCertificateNameCheck = default(string), int? sendRecvTimeoutSeconds = default(int?))
        {
            EnforceCertificateNameCheck = enforceCertificateNameCheck;
            SendRecvTimeoutSeconds = sendRecvTimeoutSeconds;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets whether to enforce certificate name check on HTTPS
        /// requests to all backend pools. No effect on non-HTTPS requests.
        /// Possible values include: 'Enabled', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "enforceCertificateNameCheck")]
        public string EnforceCertificateNameCheck { get; set; }

        /// <summary>
        /// Gets or sets send and receive timeout on forwarding request to the
        /// backend. When timeout is reached, the request fails and returns.
        /// </summary>
        [JsonProperty(PropertyName = "sendRecvTimeoutSeconds")]
        public int? SendRecvTimeoutSeconds { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SendRecvTimeoutSeconds < 16)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "SendRecvTimeoutSeconds", 16);
            }
        }
    }
}
