// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.FrontDoor.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Caching settings for a caching-type route. To disable caching, do not
    /// provide a cacheConfiguration object.
    /// </summary>
    public partial class CacheConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the CacheConfiguration class.
        /// </summary>
        public CacheConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CacheConfiguration class.
        /// </summary>
        /// <param name="queryParameterStripDirective">Treatment of URL query
        /// terms when forming the cache key. Possible values include:
        /// 'StripNone', 'StripAll'</param>
        /// <param name="dynamicCompression">Whether to use dynamic compression
        /// for cached content. Possible values include: 'Enabled',
        /// 'Disabled'</param>
        public CacheConfiguration(string queryParameterStripDirective = default(string), string dynamicCompression = default(string))
        {
            QueryParameterStripDirective = queryParameterStripDirective;
            DynamicCompression = dynamicCompression;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets treatment of URL query terms when forming the cache
        /// key. Possible values include: 'StripNone', 'StripAll'
        /// </summary>
        [JsonProperty(PropertyName = "queryParameterStripDirective")]
        public string QueryParameterStripDirective { get; set; }

        /// <summary>
        /// Gets or sets whether to use dynamic compression for cached content.
        /// Possible values include: 'Enabled', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "dynamicCompression")]
        public string DynamicCompression { get; set; }

    }
}
