// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.FrontDoor.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Load balancing settings for a backend pool
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class LoadBalancingSettingsModel : SubResource
    {
        /// <summary>
        /// Initializes a new instance of the LoadBalancingSettingsModel class.
        /// </summary>
        public LoadBalancingSettingsModel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the LoadBalancingSettingsModel class.
        /// </summary>
        /// <param name="id">Resource ID.</param>
        /// <param name="sampleSize">The number of samples to consider for load
        /// balancing decisions</param>
        /// <param name="successfulSamplesRequired">The number of samples
        /// within the sample period that must succeed</param>
        /// <param name="additionalLatencyMilliseconds">The additional latency
        /// in milliseconds for probes to fall into the lowest latency
        /// bucket</param>
        /// <param name="resourceState">Resource status. Possible values
        /// include: 'Creating', 'Enabling', 'Enabled', 'Disabling',
        /// 'Disabled', 'Deleting'</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        public LoadBalancingSettingsModel(string id = default(string), int? sampleSize = default(int?), int? successfulSamplesRequired = default(int?), int? additionalLatencyMilliseconds = default(int?), string resourceState = default(string), string name = default(string), string type = default(string))
            : base(id)
        {
            SampleSize = sampleSize;
            SuccessfulSamplesRequired = successfulSamplesRequired;
            AdditionalLatencyMilliseconds = additionalLatencyMilliseconds;
            ResourceState = resourceState;
            Name = name;
            Type = type;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the number of samples to consider for load balancing
        /// decisions
        /// </summary>
        [JsonProperty(PropertyName = "properties.sampleSize")]
        public int? SampleSize { get; set; }

        /// <summary>
        /// Gets or sets the number of samples within the sample period that
        /// must succeed
        /// </summary>
        [JsonProperty(PropertyName = "properties.successfulSamplesRequired")]
        public int? SuccessfulSamplesRequired { get; set; }

        /// <summary>
        /// Gets or sets the additional latency in milliseconds for probes to
        /// fall into the lowest latency bucket
        /// </summary>
        [JsonProperty(PropertyName = "properties.additionalLatencyMilliseconds")]
        public int? AdditionalLatencyMilliseconds { get; set; }

        /// <summary>
        /// Gets or sets resource status. Possible values include: 'Creating',
        /// 'Enabling', 'Enabled', 'Disabling', 'Disabled', 'Deleting'
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceState")]
        public string ResourceState { get; set; }

        /// <summary>
        /// Gets or sets resource name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets resource type.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

    }
}
