// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.FrontDoor.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes a managed rule definition.
    /// </summary>
    public partial class ManagedRuleDefinition
    {
        /// <summary>
        /// Initializes a new instance of the ManagedRuleDefinition class.
        /// </summary>
        public ManagedRuleDefinition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ManagedRuleDefinition class.
        /// </summary>
        /// <param name="ruleId">Identifier for the managed rule.</param>
        /// <param name="defaultState">Describes the default state for the
        /// managed rule. Possible values include: 'Disabled',
        /// 'Enabled'</param>
        /// <param name="defaultAction">Describes the default action to be
        /// applied when the managed rule matches. Possible values include:
        /// 'Allow', 'Block', 'Log', 'Redirect'</param>
        /// <param name="description">Describes the functionality of the
        /// managed rule.</param>
        public ManagedRuleDefinition(string ruleId = default(string), string defaultState = default(string), string defaultAction = default(string), string description = default(string))
        {
            RuleId = ruleId;
            DefaultState = defaultState;
            DefaultAction = defaultAction;
            Description = description;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets identifier for the managed rule.
        /// </summary>
        [JsonProperty(PropertyName = "ruleId")]
        public string RuleId { get; private set; }

        /// <summary>
        /// Gets describes the default state for the managed rule. Possible
        /// values include: 'Disabled', 'Enabled'
        /// </summary>
        [JsonProperty(PropertyName = "defaultState")]
        public string DefaultState { get; private set; }

        /// <summary>
        /// Gets describes the default action to be applied when the managed
        /// rule matches. Possible values include: 'Allow', 'Block', 'Log',
        /// 'Redirect'
        /// </summary>
        [JsonProperty(PropertyName = "defaultAction")]
        public string DefaultAction { get; private set; }

        /// <summary>
        /// Gets describes the functionality of the managed rule.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; private set; }

    }
}
