// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.FrontDoor.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Exclude variables from managed rule evaluation.
    /// </summary>
    public partial class ManagedRuleExclusion
    {
        /// <summary>
        /// Initializes a new instance of the ManagedRuleExclusion class.
        /// </summary>
        public ManagedRuleExclusion()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ManagedRuleExclusion class.
        /// </summary>
        /// <param name="matchVariable">The variable type to be excluded.
        /// Possible values include: 'RequestHeaderNames',
        /// 'RequestCookieNames', 'QueryStringArgNames',
        /// 'RequestBodyPostArgNames'</param>
        /// <param name="selectorMatchOperator">Comparison operator to apply to
        /// the selector when specifying which elements in the collection this
        /// exclusion applies to. Possible values include: 'Equals',
        /// 'Contains', 'StartsWith', 'EndsWith', 'EqualsAny'</param>
        /// <param name="selector">Selector value for which elements in the
        /// collection this exclusion applies to.</param>
        public ManagedRuleExclusion(string matchVariable, string selectorMatchOperator, string selector)
        {
            MatchVariable = matchVariable;
            SelectorMatchOperator = selectorMatchOperator;
            Selector = selector;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the variable type to be excluded. Possible values
        /// include: 'RequestHeaderNames', 'RequestCookieNames',
        /// 'QueryStringArgNames', 'RequestBodyPostArgNames'
        /// </summary>
        [JsonProperty(PropertyName = "matchVariable")]
        public string MatchVariable { get; set; }

        /// <summary>
        /// Gets or sets comparison operator to apply to the selector when
        /// specifying which elements in the collection this exclusion applies
        /// to. Possible values include: 'Equals', 'Contains', 'StartsWith',
        /// 'EndsWith', 'EqualsAny'
        /// </summary>
        [JsonProperty(PropertyName = "selectorMatchOperator")]
        public string SelectorMatchOperator { get; set; }

        /// <summary>
        /// Gets or sets selector value for which elements in the collection
        /// this exclusion applies to.
        /// </summary>
        [JsonProperty(PropertyName = "selector")]
        public string Selector { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (MatchVariable == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "MatchVariable");
            }
            if (SelectorMatchOperator == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SelectorMatchOperator");
            }
            if (Selector == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Selector");
            }
        }
    }
}
