// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.FrontDoor
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ReportsOperations.
    /// </summary>
    public static partial class ReportsOperationsExtensions
    {
            /// <summary>
            /// Gets a Latency Scorecard for a given Experiment
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the Resource group within the Azure subscription.
            /// </param>
            /// <param name='profileName'>
            /// The Profile identifier associated with the Tenant and Partner
            /// </param>
            /// <param name='experimentName'>
            /// The Experiment identifier associated with the Experiment
            /// </param>
            /// <param name='aggregationInterval'>
            /// The aggregation interval of the Latency Scorecard. Possible values include:
            /// 'Daily', 'Weekly', 'Monthly'
            /// </param>
            /// <param name='endDateTimeUTC'>
            /// The end DateTime of the Latency Scorecard in UTC
            /// </param>
            /// <param name='country'>
            /// The country associated with the Latency Scorecard. Values are country ISO
            /// codes as specified here- https://www.iso.org/iso-3166-country-codes.html
            /// </param>
            public static LatencyScorecard GetLatencyScorecards(this IReportsOperations operations, string resourceGroupName, string profileName, string experimentName, string aggregationInterval, string endDateTimeUTC = default(string), string country = default(string))
            {
                return operations.GetLatencyScorecardsAsync(resourceGroupName, profileName, experimentName, aggregationInterval, endDateTimeUTC, country).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets a Latency Scorecard for a given Experiment
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the Resource group within the Azure subscription.
            /// </param>
            /// <param name='profileName'>
            /// The Profile identifier associated with the Tenant and Partner
            /// </param>
            /// <param name='experimentName'>
            /// The Experiment identifier associated with the Experiment
            /// </param>
            /// <param name='aggregationInterval'>
            /// The aggregation interval of the Latency Scorecard. Possible values include:
            /// 'Daily', 'Weekly', 'Monthly'
            /// </param>
            /// <param name='endDateTimeUTC'>
            /// The end DateTime of the Latency Scorecard in UTC
            /// </param>
            /// <param name='country'>
            /// The country associated with the Latency Scorecard. Values are country ISO
            /// codes as specified here- https://www.iso.org/iso-3166-country-codes.html
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<LatencyScorecard> GetLatencyScorecardsAsync(this IReportsOperations operations, string resourceGroupName, string profileName, string experimentName, string aggregationInterval, string endDateTimeUTC = default(string), string country = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetLatencyScorecardsWithHttpMessagesAsync(resourceGroupName, profileName, experimentName, aggregationInterval, endDateTimeUTC, country, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets a Timeseries for a given Experiment
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the Resource group within the Azure subscription.
            /// </param>
            /// <param name='profileName'>
            /// The Profile identifier associated with the Tenant and Partner
            /// </param>
            /// <param name='experimentName'>
            /// The Experiment identifier associated with the Experiment
            /// </param>
            /// <param name='startDateTimeUTC'>
            /// The start DateTime of the Timeseries in UTC
            /// </param>
            /// <param name='endDateTimeUTC'>
            /// The end DateTime of the Timeseries in UTC
            /// </param>
            /// <param name='aggregationInterval'>
            /// The aggregation interval of the Timeseries. Possible values include:
            /// 'Hourly', 'Daily'
            /// </param>
            /// <param name='timeseriesType'>
            /// The type of Timeseries. Possible values include: 'MeasurementCounts',
            /// 'LatencyP50', 'LatencyP75', 'LatencyP95'
            /// </param>
            /// <param name='endpoint'>
            /// The specific endpoint
            /// </param>
            /// <param name='country'>
            /// The country associated with the Timeseries. Values are country ISO codes as
            /// specified here- https://www.iso.org/iso-3166-country-codes.html
            /// </param>
            public static Timeseries GetTimeseries(this IReportsOperations operations, string resourceGroupName, string profileName, string experimentName, System.DateTime startDateTimeUTC, System.DateTime endDateTimeUTC, string aggregationInterval, string timeseriesType, string endpoint = default(string), string country = default(string))
            {
                return operations.GetTimeseriesAsync(resourceGroupName, profileName, experimentName, startDateTimeUTC, endDateTimeUTC, aggregationInterval, timeseriesType, endpoint, country).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets a Timeseries for a given Experiment
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the Resource group within the Azure subscription.
            /// </param>
            /// <param name='profileName'>
            /// The Profile identifier associated with the Tenant and Partner
            /// </param>
            /// <param name='experimentName'>
            /// The Experiment identifier associated with the Experiment
            /// </param>
            /// <param name='startDateTimeUTC'>
            /// The start DateTime of the Timeseries in UTC
            /// </param>
            /// <param name='endDateTimeUTC'>
            /// The end DateTime of the Timeseries in UTC
            /// </param>
            /// <param name='aggregationInterval'>
            /// The aggregation interval of the Timeseries. Possible values include:
            /// 'Hourly', 'Daily'
            /// </param>
            /// <param name='timeseriesType'>
            /// The type of Timeseries. Possible values include: 'MeasurementCounts',
            /// 'LatencyP50', 'LatencyP75', 'LatencyP95'
            /// </param>
            /// <param name='endpoint'>
            /// The specific endpoint
            /// </param>
            /// <param name='country'>
            /// The country associated with the Timeseries. Values are country ISO codes as
            /// specified here- https://www.iso.org/iso-3166-country-codes.html
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Timeseries> GetTimeseriesAsync(this IReportsOperations operations, string resourceGroupName, string profileName, string experimentName, System.DateTime startDateTimeUTC, System.DateTime endDateTimeUTC, string aggregationInterval, string timeseriesType, string endpoint = default(string), string country = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetTimeseriesWithHttpMessagesAsync(resourceGroupName, profileName, experimentName, startDateTimeUTC, endDateTimeUTC, aggregationInterval, timeseriesType, endpoint, country, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
