// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Graph.RBAC
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for OAuth2PermissionGrantOperations.
    /// </summary>
    public static partial class OAuth2PermissionGrantOperationsExtensions
    {
            /// <summary>
            /// Queries OAuth2 permissions grants for the relevant SP ObjectId of an app.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='filter'>
            /// This is the Service Principal ObjectId associated with the app
            /// </param>
            public static IPage<OAuth2PermissionGrant> List(this IOAuth2PermissionGrantOperations operations, string filter = default(string))
            {
                return operations.ListAsync(filter).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Queries OAuth2 permissions grants for the relevant SP ObjectId of an app.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='filter'>
            /// This is the Service Principal ObjectId associated with the app
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<OAuth2PermissionGrant>> ListAsync(this IOAuth2PermissionGrantOperations operations, string filter = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(filter, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Grants OAuth2 permissions for the relevant resource Ids of an app.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// The relevant app Service Principal Object Id and the Service Principal
            /// Object Id you want to grant.
            /// </param>
            public static OAuth2PermissionGrant Create(this IOAuth2PermissionGrantOperations operations, OAuth2PermissionGrant body = default(OAuth2PermissionGrant))
            {
                return operations.CreateAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Grants OAuth2 permissions for the relevant resource Ids of an app.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// The relevant app Service Principal Object Id and the Service Principal
            /// Object Id you want to grant.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<OAuth2PermissionGrant> CreateAsync(this IOAuth2PermissionGrantOperations operations, OAuth2PermissionGrant body = default(OAuth2PermissionGrant), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete a OAuth2 permission grant for the relevant resource Ids of an app.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='objectId'>
            /// The object ID of a permission grant.
            /// </param>
            public static void Delete(this IOAuth2PermissionGrantOperations operations, string objectId)
            {
                operations.DeleteAsync(objectId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete a OAuth2 permission grant for the relevant resource Ids of an app.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='objectId'>
            /// The object ID of a permission grant.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IOAuth2PermissionGrantOperations operations, string objectId, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(objectId, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Gets the next page of OAuth2 permission grants
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextLink'>
            /// Next link for the list operation.
            /// </param>
            public static IPage<OAuth2PermissionGrant> ListNext(this IOAuth2PermissionGrantOperations operations, string nextLink)
            {
                return operations.ListNextAsync(nextLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the next page of OAuth2 permission grants
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextLink'>
            /// Next link for the list operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<OAuth2PermissionGrant>> ListNextAsync(this IOAuth2PermissionGrantOperations operations, string nextLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
