// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.GuestConfiguration
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for GuestConfigurationAssignmentReportsOperations.
    /// </summary>
    public static partial class GuestConfigurationAssignmentReportsOperationsExtensions
    {
            /// <summary>
            /// List all reports for the guest configuration assignment, latest report
            /// first.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='guestConfigurationAssignmentName'>
            /// The guest configuration assignment name.
            /// </param>
            /// <param name='vmName'>
            /// The name of the virtual machine.
            /// </param>
            public static GuestConfigurationAssignmentReportList List(this IGuestConfigurationAssignmentReportsOperations operations, string resourceGroupName, string guestConfigurationAssignmentName, string vmName)
            {
                return operations.ListAsync(resourceGroupName, guestConfigurationAssignmentName, vmName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List all reports for the guest configuration assignment, latest report
            /// first.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='guestConfigurationAssignmentName'>
            /// The guest configuration assignment name.
            /// </param>
            /// <param name='vmName'>
            /// The name of the virtual machine.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<GuestConfigurationAssignmentReportList> ListAsync(this IGuestConfigurationAssignmentReportsOperations operations, string resourceGroupName, string guestConfigurationAssignmentName, string vmName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroupName, guestConfigurationAssignmentName, vmName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a report for the guest configuration assignment, by reportId.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='guestConfigurationAssignmentName'>
            /// The guest configuration assignment name.
            /// </param>
            /// <param name='reportId'>
            /// The GUID for the guest configuration assignment report.
            /// </param>
            /// <param name='vmName'>
            /// The name of the virtual machine.
            /// </param>
            public static GuestConfigurationAssignmentReport Get(this IGuestConfigurationAssignmentReportsOperations operations, string resourceGroupName, string guestConfigurationAssignmentName, string reportId, string vmName)
            {
                return operations.GetAsync(resourceGroupName, guestConfigurationAssignmentName, reportId, vmName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a report for the guest configuration assignment, by reportId.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='guestConfigurationAssignmentName'>
            /// The guest configuration assignment name.
            /// </param>
            /// <param name='reportId'>
            /// The GUID for the guest configuration assignment report.
            /// </param>
            /// <param name='vmName'>
            /// The name of the virtual machine.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<GuestConfigurationAssignmentReport> GetAsync(this IGuestConfigurationAssignmentReportsOperations operations, string resourceGroupName, string guestConfigurationAssignmentName, string reportId, string vmName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, guestConfigurationAssignmentName, reportId, vmName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
