// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.GuestConfiguration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Details of the guest configuration assignment report.
    /// </summary>
    public partial class AssignmentReportDetails
    {
        /// <summary>
        /// Initializes a new instance of the AssignmentReportDetails class.
        /// </summary>
        public AssignmentReportDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AssignmentReportDetails class.
        /// </summary>
        /// <param name="complianceStatus">A value indicating compliance status
        /// of the virtual machine for the assigned guest configuration.
        /// Possible values include: 'Compliant', 'NonCompliant',
        /// 'Pending'</param>
        /// <param name="startTime">Start date and time of the guest
        /// configuration assignment compliance status check.</param>
        /// <param name="endTime">End date and time of the guest configuration
        /// assignment compliance status check.</param>
        /// <param name="jobId">GUID of the report.</param>
        /// <param name="operationType">Type of report, Consistency or Initial.
        /// Possible values include: 'Consistency', 'Initial'</param>
        /// <param name="resources">The list of resources for which guest
        /// configuration assignment compliance is checked.</param>
        public AssignmentReportDetails(string complianceStatus = default(string), System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), string jobId = default(string), string operationType = default(string), IList<AssignmentReportResource> resources = default(IList<AssignmentReportResource>))
        {
            ComplianceStatus = complianceStatus;
            StartTime = startTime;
            EndTime = endTime;
            JobId = jobId;
            OperationType = operationType;
            Resources = resources;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets a value indicating compliance status of the virtual machine
        /// for the assigned guest configuration. Possible values include:
        /// 'Compliant', 'NonCompliant', 'Pending'
        /// </summary>
        [JsonProperty(PropertyName = "complianceStatus")]
        public string ComplianceStatus { get; private set; }

        /// <summary>
        /// Gets start date and time of the guest configuration assignment
        /// compliance status check.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; private set; }

        /// <summary>
        /// Gets end date and time of the guest configuration assignment
        /// compliance status check.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; private set; }

        /// <summary>
        /// Gets GUID of the report.
        /// </summary>
        [JsonProperty(PropertyName = "jobId")]
        public string JobId { get; private set; }

        /// <summary>
        /// Gets type of report, Consistency or Initial. Possible values
        /// include: 'Consistency', 'Initial'
        /// </summary>
        [JsonProperty(PropertyName = "operationType")]
        public string OperationType { get; private set; }

        /// <summary>
        /// Gets or sets the list of resources for which guest configuration
        /// assignment compliance is checked.
        /// </summary>
        [JsonProperty(PropertyName = "resources")]
        public IList<AssignmentReportResource> Resources { get; set; }

    }
}
