// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.GuestConfiguration.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The guest configuration assignment resource.
    /// </summary>
    public partial class AssignmentReportResource
    {
        /// <summary>
        /// Initializes a new instance of the AssignmentReportResource class.
        /// </summary>
        public AssignmentReportResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AssignmentReportResource class.
        /// </summary>
        /// <param name="complianceStatus">A value indicating compliance status
        /// of the virtual machine for the assigned guest configuration.
        /// Possible values include: 'Compliant', 'NonCompliant',
        /// 'Pending'</param>
        /// <param name="reasons">Compliance reason and reason code for a
        /// resource.</param>
        /// <param name="properties">Properties of a guest configuration
        /// assignment resource.</param>
        public AssignmentReportResource(string complianceStatus = default(string), IList<AssignmentReportResourceComplianceReason> reasons = default(IList<AssignmentReportResourceComplianceReason>), object properties = default(object))
        {
            ComplianceStatus = complianceStatus;
            Reasons = reasons;
            Properties = properties;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets a value indicating compliance status of the virtual machine
        /// for the assigned guest configuration. Possible values include:
        /// 'Compliant', 'NonCompliant', 'Pending'
        /// </summary>
        [JsonProperty(PropertyName = "complianceStatus")]
        public string ComplianceStatus { get; private set; }

        /// <summary>
        /// Gets or sets compliance reason and reason code for a resource.
        /// </summary>
        [JsonProperty(PropertyName = "reasons")]
        public IList<AssignmentReportResourceComplianceReason> Reasons { get; set; }

        /// <summary>
        /// Gets properties of a guest configuration assignment resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public object Properties { get; private set; }

    }
}
