// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.GuestConfiguration.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Report for the guest configuration assignment. Report contains
    /// information such as compliance status, reason, and more.
    /// </summary>
    public partial class GuestConfigurationAssignmentReport
    {
        /// <summary>
        /// Initializes a new instance of the
        /// GuestConfigurationAssignmentReport class.
        /// </summary>
        public GuestConfigurationAssignmentReport()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// GuestConfigurationAssignmentReport class.
        /// </summary>
        /// <param name="id">ARM resource id of the report for the guest
        /// configuration assignment.</param>
        /// <param name="name">GUID that identifies the guest configuration
        /// assignment report under a subscription, resource group.</param>
        /// <param name="properties">Properties of the guest configuration
        /// report.</param>
        public GuestConfigurationAssignmentReport(string id = default(string), string name = default(string), GuestConfigurationAssignmentReportProperties properties = default(GuestConfigurationAssignmentReportProperties))
        {
            Id = id;
            Name = name;
            Properties = properties;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets ARM resource id of the report for the guest configuration
        /// assignment.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets GUID that identifies the guest configuration assignment report
        /// under a subscription, resource group.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets or sets properties of the guest configuration report.
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public GuestConfigurationAssignmentReportProperties Properties { get; set; }

    }
}
