﻿// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.1.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.HDInsight.Models
{
    using System;

    /// <summary>
    /// Contains cluster storage information.
    /// </summary>
    public abstract class StorageInfo
    {
        /// <summary>
        /// Fully-qualified storage account name
        /// </summary>
        public string StorageAccountName { get; protected set; }

        public StorageInfo(string storageAccountName)
        {
            if (string.IsNullOrWhiteSpace(storageAccountName))
            {
                throw new ArgumentException(Constants.Errors.ERROR_INPUT_CANNOT_BE_EMPTY, "storageAccountName");
            }

            if (storageAccountName.Contains("://"))
            {
                throw new ArgumentException(Constants.Errors.ERROR_SCHEME_SPECIFIED_IN_STORAGE_FQDN, "storageAccountName");
            }

            this.StorageAccountName = storageAccountName;
        }
    }
}