// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.HDInsight.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The Disk Encryption Cluster request parameters.
    /// </summary>
    public partial class ClusterDiskEncryptionParameters
    {
        /// <summary>
        /// Initializes a new instance of the ClusterDiskEncryptionParameters
        /// class.
        /// </summary>
        public ClusterDiskEncryptionParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ClusterDiskEncryptionParameters
        /// class.
        /// </summary>
        /// <param name="vaultUri">Base key vault URI where the customers key
        /// is located eg. https://myvault.vault.azure.net</param>
        /// <param name="keyName">Key name that is used for enabling disk
        /// encryption.</param>
        /// <param name="keyVersion">Specific key version that is used for
        /// enabling disk encryption.</param>
        public ClusterDiskEncryptionParameters(string vaultUri = default(string), string keyName = default(string), string keyVersion = default(string))
        {
            VaultUri = vaultUri;
            KeyName = keyName;
            KeyVersion = keyVersion;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets base key vault URI where the customers key is located
        /// eg. https://myvault.vault.azure.net
        /// </summary>
        [JsonProperty(PropertyName = "vaultUri")]
        public string VaultUri { get; set; }

        /// <summary>
        /// Gets or sets key name that is used for enabling disk encryption.
        /// </summary>
        [JsonProperty(PropertyName = "keyName")]
        public string KeyName { get; set; }

        /// <summary>
        /// Gets or sets specific key version that is used for enabling disk
        /// encryption.
        /// </summary>
        [JsonProperty(PropertyName = "keyVersion")]
        public string KeyVersion { get; set; }

    }
}
