// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.HDInsight.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Gateway settings.
    /// </summary>
    public partial class GatewaySettings
    {
        /// <summary>
        /// Initializes a new instance of the GatewaySettings class.
        /// </summary>
        public GatewaySettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GatewaySettings class.
        /// </summary>
        /// <param name="isCredentialEnabled">Indicates whether or not the
        /// gateway settings based authorization is enabled.</param>
        /// <param name="userName">The gateway settings user name.</param>
        /// <param name="password">The gateway settings user password.</param>
        public GatewaySettings(string isCredentialEnabled = default(string), string userName = default(string), string password = default(string))
        {
            IsCredentialEnabled = isCredentialEnabled;
            UserName = userName;
            Password = password;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets indicates whether or not the gateway settings based
        /// authorization is enabled.
        /// </summary>
        [JsonProperty(PropertyName = "restAuthCredential.isEnabled")]
        public string IsCredentialEnabled { get; private set; }

        /// <summary>
        /// Gets the gateway settings user name.
        /// </summary>
        [JsonProperty(PropertyName = "restAuthCredential.username")]
        public string UserName { get; private set; }

        /// <summary>
        /// Gets the gateway settings user password.
        /// </summary>
        [JsonProperty(PropertyName = "restAuthCredential.password")]
        public string Password { get; private set; }

    }
}
