// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.HDInsight.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The regional quota capability.
    /// </summary>
    public partial class QuotaCapability
    {
        /// <summary>
        /// Initializes a new instance of the QuotaCapability class.
        /// </summary>
        public QuotaCapability()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the QuotaCapability class.
        /// </summary>
        /// <param name="coresUsed">The number of cores used in the
        /// subscription.</param>
        /// <param name="maxCoresAllowed">The number of cores that the
        /// subscription allowed.</param>
        /// <param name="regionalQuotas">The list of region quota
        /// capabilities.</param>
        public QuotaCapability(long? coresUsed = default(long?), long? maxCoresAllowed = default(long?), IList<RegionalQuotaCapability> regionalQuotas = default(IList<RegionalQuotaCapability>))
        {
            CoresUsed = coresUsed;
            MaxCoresAllowed = maxCoresAllowed;
            RegionalQuotas = regionalQuotas;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the number of cores used in the subscription.
        /// </summary>
        [JsonProperty(PropertyName = "cores_used")]
        public long? CoresUsed { get; set; }

        /// <summary>
        /// Gets or sets the number of cores that the subscription allowed.
        /// </summary>
        [JsonProperty(PropertyName = "max_cores_allowed")]
        public long? MaxCoresAllowed { get; set; }

        /// <summary>
        /// Gets or sets the list of region quota capabilities.
        /// </summary>
        [JsonProperty(PropertyName = "regionalQuotas")]
        public IList<RegionalQuotaCapability> RegionalQuotas { get; set; }

    }
}
