// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.HDInsight.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The storage Account.
    /// </summary>
    public partial class StorageAccount
    {
        /// <summary>
        /// Initializes a new instance of the StorageAccount class.
        /// </summary>
        public StorageAccount()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the StorageAccount class.
        /// </summary>
        /// <param name="name">The name of the storage account.</param>
        /// <param name="isDefault">Whether or not the storage account is the
        /// default storage account.</param>
        /// <param name="container">The container in the storage account, only
        /// to be specified for WASB storage accounts.</param>
        /// <param name="fileSystem">The filesystem, only to be specified for
        /// Azure Data Lake Storage Gen 2.</param>
        /// <param name="key">The storage account access key.</param>
        /// <param name="resourceId">The resource ID of storage account, only
        /// to be specified for Azure Data Lake Storage Gen 2.</param>
        /// <param name="msiResourceId">The managed identity (MSI) that is
        /// allowed to access the storage account, only to be specified for
        /// Azure Data Lake Storage Gen 2.</param>
        public StorageAccount(string name = default(string), bool? isDefault = default(bool?), string container = default(string), string fileSystem = default(string), string key = default(string), string resourceId = default(string), string msiResourceId = default(string))
        {
            Name = name;
            IsDefault = isDefault;
            Container = container;
            FileSystem = fileSystem;
            Key = key;
            ResourceId = resourceId;
            MsiResourceId = msiResourceId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the storage account.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets whether or not the storage account is the default
        /// storage account.
        /// </summary>
        [JsonProperty(PropertyName = "isDefault")]
        public bool? IsDefault { get; set; }

        /// <summary>
        /// Gets or sets the container in the storage account, only to be
        /// specified for WASB storage accounts.
        /// </summary>
        [JsonProperty(PropertyName = "container")]
        public string Container { get; set; }

        /// <summary>
        /// Gets or sets the filesystem, only to be specified for Azure Data
        /// Lake Storage Gen 2.
        /// </summary>
        [JsonProperty(PropertyName = "fileSystem")]
        public string FileSystem { get; set; }

        /// <summary>
        /// Gets or sets the storage account access key.
        /// </summary>
        [JsonProperty(PropertyName = "key")]
        public string Key { get; set; }

        /// <summary>
        /// Gets or sets the resource ID of storage account, only to be
        /// specified for Azure Data Lake Storage Gen 2.
        /// </summary>
        [JsonProperty(PropertyName = "resourceId")]
        public string ResourceId { get; set; }

        /// <summary>
        /// Gets or sets the managed identity (MSI) that is allowed to access
        /// the storage account, only to be specified for Azure Data Lake
        /// Storage Gen 2.
        /// </summary>
        [JsonProperty(PropertyName = "msiResourceId")]
        public string MsiResourceId { get; set; }

    }
}
