// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.HealthcareApis
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for OperationResultsOperations.
    /// </summary>
    public static partial class OperationResultsOperationsExtensions
    {
            /// <summary>
            /// Get the operation result for a long running operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='locationName'>
            /// The location of the operation.
            /// </param>
            /// <param name='operationResultId'>
            /// The ID of the operation result to get.
            /// </param>
            public static object Get(this IOperationResultsOperations operations, string locationName, string operationResultId)
            {
                return operations.GetAsync(locationName, operationResultId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get the operation result for a long running operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='locationName'>
            /// The location of the operation.
            /// </param>
            /// <param name='operationResultId'>
            /// The ID of the operation result to get.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetAsync(this IOperationResultsOperations operations, string locationName, string operationResultId, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(locationName, operationResultId, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
