// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Insights
{
    using Microsoft.Rest.Azure;
    using Models;

    /// <summary>
    /// MetricsOperations operations.
    /// </summary>
    public partial interface IMetricsOperations
    {
        /// <summary>
        /// Lists the metric values for a resource. The $filter is used to
        /// reduce the set of metric data returned. Some common properties for
        /// this expression will be: name.value, aggregationType, startTime,
        /// endTime, timeGrain. The filter expression uses these properties
        /// with comparison operators (eg. eq, gt, lt) and multiple expressions
        /// can be combined with parentheses and 'and/or' operators. Some
        /// example filter expressions are: - $filter=(name.value eq
        /// 'RunsSucceeded') and aggregationType eq 'Total' and startTime eq
        /// 2016-02-20 and endTime eq 2016-02-21 and timeGrain eq
        /// duration'PT1M', - $filter=(name.value eq 'RunsSucceeded') and
        /// (aggregationType eq 'Total' or aggregationType eq 'Average') and
        /// startTime eq 2016-02-20 and endTime eq 2016-02-21 and timeGrain eq
        /// duration'PT1H', - $filter=(name.value eq 'ActionsCompleted' or
        /// name.value eq 'RunsSucceeded') and (aggregationType eq 'Total' or
        /// aggregationType eq 'Average') and startTime eq 2016-02-20 and
        /// endTime eq 2016-02-21 and timeGrain eq duration'PT1M'.
        /// </summary>
        /// <param name='resourceUri'>
        /// The identifier of the resource.
        /// </param>
        /// <param name='odataQuery'>
        /// OData parameters to apply to the operation.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        System.Threading.Tasks.Task<Microsoft.Rest.Azure.AzureOperationResponse<System.Collections.Generic.IEnumerable<Metric>>> ListWithHttpMessagesAsync(string resourceUri, Microsoft.Rest.Azure.OData.ODataQuery<Metric> odataQuery = default(Microsoft.Rest.Azure.OData.ODataQuery<Metric>), System.Collections.Generic.Dictionary<string, System.Collections.Generic.List<string>> customHeaders = null, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
    }
}
