// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotCentral.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Input values.
    /// </summary>
    public partial class OperationInputs
    {
        /// <summary>
        /// Initializes a new instance of the OperationInputs class.
        /// </summary>
        public OperationInputs()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OperationInputs class.
        /// </summary>
        /// <param name="name">The name of the IoT Central application instance
        /// to check.</param>
        /// <param name="type">The type of the IoT Central resource to
        /// query.</param>
        public OperationInputs(string name, string type = default(string))
        {
            Name = name;
            Type = type;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the IoT Central application instance to
        /// check.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the type of the IoT Central resource to query.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (Name != null)
            {
                if (!System.Text.RegularExpressions.Regex.IsMatch(Name, "^[a-z0-9-]{1,63}$"))
                {
                    throw new ValidationException(ValidationRules.Pattern, "Name", "^[a-z0-9-]{1,63}$");
                }
            }
        }
    }
}
