// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotHub
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// IotHubOperations operations.
    /// </summary>
    public partial interface IIotHubOperations
    {
        /// <summary>
        /// Manual Failover Fail over
        /// </summary>
        /// <remarks>
        /// Perform manual fail over of given hub
        /// </remarks>
        /// <param name='iotHubName'>
        /// IotHub to fail over
        /// </param>
        /// <param name='failoverInput'>
        /// Region to failover to. Must be a azure DR pair
        /// </param>
        /// <param name='resourceGroupName'>
        /// resource group which Iot Hub belongs to
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="ErrorDetailsException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse> ManualFailoverWithHttpMessagesAsync(string iotHubName, FailoverInput failoverInput, string resourceGroupName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Manual Failover Fail over
        /// </summary>
        /// <remarks>
        /// Perform manual fail over of given hub
        /// </remarks>
        /// <param name='iotHubName'>
        /// IotHub to fail over
        /// </param>
        /// <param name='failoverInput'>
        /// Region to failover to. Must be a azure DR pair
        /// </param>
        /// <param name='resourceGroupName'>
        /// resource group which Iot Hub belongs to
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="ErrorDetailsException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse> BeginManualFailoverWithHttpMessagesAsync(string iotHubName, FailoverInput failoverInput, string resourceGroupName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
    }
}
