// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotHub
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for IotHubOperations.
    /// </summary>
    public static partial class IotHubOperationsExtensions
    {
            /// <summary>
            /// Manual Failover Fail over
            /// </summary>
            /// <remarks>
            /// Perform manual fail over of given hub
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='iotHubName'>
            /// IotHub to fail over
            /// </param>
            /// <param name='failoverInput'>
            /// Region to failover to. Must be a azure DR pair
            /// </param>
            /// <param name='resourceGroupName'>
            /// resource group which Iot Hub belongs to
            /// </param>
            public static void ManualFailover(this IIotHubOperations operations, string iotHubName, FailoverInput failoverInput, string resourceGroupName)
            {
                operations.ManualFailoverAsync(iotHubName, failoverInput, resourceGroupName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Manual Failover Fail over
            /// </summary>
            /// <remarks>
            /// Perform manual fail over of given hub
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='iotHubName'>
            /// IotHub to fail over
            /// </param>
            /// <param name='failoverInput'>
            /// Region to failover to. Must be a azure DR pair
            /// </param>
            /// <param name='resourceGroupName'>
            /// resource group which Iot Hub belongs to
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task ManualFailoverAsync(this IIotHubOperations operations, string iotHubName, FailoverInput failoverInput, string resourceGroupName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.ManualFailoverWithHttpMessagesAsync(iotHubName, failoverInput, resourceGroupName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Manual Failover Fail over
            /// </summary>
            /// <remarks>
            /// Perform manual fail over of given hub
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='iotHubName'>
            /// IotHub to fail over
            /// </param>
            /// <param name='failoverInput'>
            /// Region to failover to. Must be a azure DR pair
            /// </param>
            /// <param name='resourceGroupName'>
            /// resource group which Iot Hub belongs to
            /// </param>
            public static void BeginManualFailover(this IIotHubOperations operations, string iotHubName, FailoverInput failoverInput, string resourceGroupName)
            {
                operations.BeginManualFailoverAsync(iotHubName, failoverInput, resourceGroupName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Manual Failover Fail over
            /// </summary>
            /// <remarks>
            /// Perform manual fail over of given hub
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='iotHubName'>
            /// IotHub to fail over
            /// </param>
            /// <param name='failoverInput'>
            /// Region to failover to. Must be a azure DR pair
            /// </param>
            /// <param name='resourceGroupName'>
            /// resource group which Iot Hub belongs to
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginManualFailoverAsync(this IIotHubOperations operations, string iotHubName, FailoverInput failoverInput, string resourceGroupName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginManualFailoverWithHttpMessagesAsync(iotHubName, failoverInput, resourceGroupName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

    }
}
