// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotHub.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The health data for an endpoint
    /// </summary>
    public partial class EndpointHealthData
    {
        /// <summary>
        /// Initializes a new instance of the EndpointHealthData class.
        /// </summary>
        public EndpointHealthData()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EndpointHealthData class.
        /// </summary>
        /// <param name="endpointId">Id of the endpoint</param>
        /// <param name="healthStatus">Health statuses have following meanings.
        /// The 'healthy' status shows that the endpoint is accepting messages
        /// as expected. The 'unhealthy' status shows that the endpoint is not
        /// accepting messages as expected and IoT Hub is retrying to send data
        /// to this endpoint. The status of an unhealthy endpoint will be
        /// updated to healthy when IoT Hub has established an eventually
        /// consistent state of health. The 'dead' status shows that the
        /// endpoint is not accepting messages, after IoT Hub retried sending
        /// messages for the retrial period. See IoT Hub metrics to identify
        /// errors and monitor issues with endpoints. The 'unknown' status
        /// shows that the IoT Hub has not established a connection with the
        /// endpoint. No messages have been delivered to or rejected from this
        /// endpoint. Possible values include: 'unknown', 'healthy',
        /// 'unhealthy', 'dead'</param>
        public EndpointHealthData(string endpointId = default(string), string healthStatus = default(string))
        {
            EndpointId = endpointId;
            HealthStatus = healthStatus;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets id of the endpoint
        /// </summary>
        [JsonProperty(PropertyName = "endpointId")]
        public string EndpointId { get; set; }

        /// <summary>
        /// Gets or sets health statuses have following meanings. The 'healthy'
        /// status shows that the endpoint is accepting messages as expected.
        /// The 'unhealthy' status shows that the endpoint is not accepting
        /// messages as expected and IoT Hub is retrying to send data to this
        /// endpoint. The status of an unhealthy endpoint will be updated to
        /// healthy when IoT Hub has established an eventually consistent state
        /// of health. The 'dead' status shows that the endpoint is not
        /// accepting messages, after IoT Hub retried sending messages for the
        /// retrial period. See IoT Hub metrics to identify errors and monitor
        /// issues with endpoints. The 'unknown' status shows that the IoT Hub
        /// has not established a connection with the endpoint. No messages
        /// have been delivered to or rejected from this endpoint. Possible
        /// values include: 'unknown', 'healthy', 'unhealthy', 'dead'
        /// </summary>
        [JsonProperty(PropertyName = "healthStatus")]
        public string HealthStatus { get; set; }

    }
}
