// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotHub.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties of the provisioned Event Hub-compatible endpoint used by
    /// the IoT hub.
    /// </summary>
    public partial class EventHubProperties
    {
        /// <summary>
        /// Initializes a new instance of the EventHubProperties class.
        /// </summary>
        public EventHubProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EventHubProperties class.
        /// </summary>
        /// <param name="retentionTimeInDays">The retention time for
        /// device-to-cloud messages in days. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#device-to-cloud-messages</param>
        /// <param name="partitionCount">The number of partitions for receiving
        /// device-to-cloud messages in the Event Hub-compatible endpoint. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#device-to-cloud-messages.</param>
        /// <param name="partitionIds">The partition ids in the Event
        /// Hub-compatible endpoint.</param>
        /// <param name="path">The Event Hub-compatible name.</param>
        /// <param name="endpoint">The Event Hub-compatible endpoint.</param>
        public EventHubProperties(long? retentionTimeInDays = default(long?), int? partitionCount = default(int?), IList<string> partitionIds = default(IList<string>), string path = default(string), string endpoint = default(string))
        {
            RetentionTimeInDays = retentionTimeInDays;
            PartitionCount = partitionCount;
            PartitionIds = partitionIds;
            Path = path;
            Endpoint = endpoint;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the retention time for device-to-cloud messages in
        /// days. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#device-to-cloud-messages
        /// </summary>
        [JsonProperty(PropertyName = "retentionTimeInDays")]
        public long? RetentionTimeInDays { get; set; }

        /// <summary>
        /// Gets or sets the number of partitions for receiving device-to-cloud
        /// messages in the Event Hub-compatible endpoint. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#device-to-cloud-messages.
        /// </summary>
        [JsonProperty(PropertyName = "partitionCount")]
        public int? PartitionCount { get; set; }

        /// <summary>
        /// Gets the partition ids in the Event Hub-compatible endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "partitionIds")]
        public IList<string> PartitionIds { get; private set; }

        /// <summary>
        /// Gets the Event Hub-compatible name.
        /// </summary>
        [JsonProperty(PropertyName = "path")]
        public string Path { get; private set; }

        /// <summary>
        /// Gets the Event Hub-compatible endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "endpoint")]
        public string Endpoint { get; private set; }

    }
}
