// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotHub.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Use to provide parameters when requesting an export of all devices in
    /// the IoT hub.
    /// </summary>
    public partial class ExportDevicesRequest
    {
        /// <summary>
        /// Initializes a new instance of the ExportDevicesRequest class.
        /// </summary>
        public ExportDevicesRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ExportDevicesRequest class.
        /// </summary>
        /// <param name="exportBlobContainerUri">The export blob container
        /// URI.</param>
        /// <param name="excludeKeys">The value indicating whether keys should
        /// be excluded during export.</param>
        public ExportDevicesRequest(string exportBlobContainerUri, bool excludeKeys)
        {
            ExportBlobContainerUri = exportBlobContainerUri;
            ExcludeKeys = excludeKeys;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the export blob container URI.
        /// </summary>
        [JsonProperty(PropertyName = "exportBlobContainerUri")]
        public string ExportBlobContainerUri { get; set; }

        /// <summary>
        /// Gets or sets the value indicating whether keys should be excluded
        /// during export.
        /// </summary>
        [JsonProperty(PropertyName = "excludeKeys")]
        public bool ExcludeKeys { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ExportBlobContainerUri == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ExportBlobContainerUri");
            }
        }
    }
}
