// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotHub.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties of the feedback queue for cloud-to-device messages.
    /// </summary>
    public partial class FeedbackProperties
    {
        /// <summary>
        /// Initializes a new instance of the FeedbackProperties class.
        /// </summary>
        public FeedbackProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the FeedbackProperties class.
        /// </summary>
        /// <param name="lockDurationAsIso8601">The lock duration for the
        /// feedback queue. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.</param>
        /// <param name="ttlAsIso8601">The period of time for which a message
        /// is available to consume before it is expired by the IoT hub. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.</param>
        /// <param name="maxDeliveryCount">The number of times the IoT hub
        /// attempts to deliver a message on the feedback queue. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.</param>
        public FeedbackProperties(System.TimeSpan? lockDurationAsIso8601 = default(System.TimeSpan?), System.TimeSpan? ttlAsIso8601 = default(System.TimeSpan?), int? maxDeliveryCount = default(int?))
        {
            LockDurationAsIso8601 = lockDurationAsIso8601;
            TtlAsIso8601 = ttlAsIso8601;
            MaxDeliveryCount = maxDeliveryCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the lock duration for the feedback queue. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.
        /// </summary>
        [JsonProperty(PropertyName = "lockDurationAsIso8601")]
        public System.TimeSpan? LockDurationAsIso8601 { get; set; }

        /// <summary>
        /// Gets or sets the period of time for which a message is available to
        /// consume before it is expired by the IoT hub. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.
        /// </summary>
        [JsonProperty(PropertyName = "ttlAsIso8601")]
        public System.TimeSpan? TtlAsIso8601 { get; set; }

        /// <summary>
        /// Gets or sets the number of times the IoT hub attempts to deliver a
        /// message on the feedback queue. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.
        /// </summary>
        [JsonProperty(PropertyName = "maxDeliveryCount")]
        public int? MaxDeliveryCount { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (MaxDeliveryCount > 100)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "MaxDeliveryCount", 100);
            }
            if (MaxDeliveryCount < 1)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "MaxDeliveryCount", 1);
            }
        }
    }
}
