// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotHub.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// SKU properties.
    /// </summary>
    public partial class IotHubSkuDescription
    {
        /// <summary>
        /// Initializes a new instance of the IotHubSkuDescription class.
        /// </summary>
        public IotHubSkuDescription()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IotHubSkuDescription class.
        /// </summary>
        /// <param name="sku">The type of the resource.</param>
        /// <param name="capacity">IotHub capacity</param>
        /// <param name="resourceType">The type of the resource.</param>
        public IotHubSkuDescription(IotHubSkuInfo sku, IotHubCapacity capacity, string resourceType = default(string))
        {
            ResourceType = resourceType;
            Sku = sku;
            Capacity = capacity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the type of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; private set; }

        /// <summary>
        /// Gets or sets the type of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public IotHubSkuInfo Sku { get; set; }

        /// <summary>
        /// Gets or sets iotHub capacity
        /// </summary>
        [JsonProperty(PropertyName = "capacity")]
        public IotHubCapacity Capacity { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Sku == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Sku");
            }
            if (Capacity == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Capacity");
            }
            if (Sku != null)
            {
                Sku.Validate();
            }
            if (Capacity != null)
            {
                Capacity.Validate();
            }
        }
    }
}
