// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotHub.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties related to the custom endpoints to which your IoT hub
    /// routes messages based on the routing rules. A maximum of 10 custom
    /// endpoints are allowed across all endpoint types for paid hubs and only
    /// 1 custom endpoint is allowed across all endpoint types for free hubs.
    /// </summary>
    public partial class RoutingEndpoints
    {
        /// <summary>
        /// Initializes a new instance of the RoutingEndpoints class.
        /// </summary>
        public RoutingEndpoints()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RoutingEndpoints class.
        /// </summary>
        /// <param name="serviceBusQueues">The list of Service Bus queue
        /// endpoints that IoT hub routes the messages to, based on the routing
        /// rules.</param>
        /// <param name="serviceBusTopics">The list of Service Bus topic
        /// endpoints that the IoT hub routes the messages to, based on the
        /// routing rules.</param>
        /// <param name="eventHubs">The list of Event Hubs endpoints that IoT
        /// hub routes messages to, based on the routing rules. This list does
        /// not include the built-in Event Hubs endpoint.</param>
        /// <param name="storageContainers">The list of storage container
        /// endpoints that IoT hub routes messages to, based on the routing
        /// rules.</param>
        public RoutingEndpoints(IList<RoutingServiceBusQueueEndpointProperties> serviceBusQueues = default(IList<RoutingServiceBusQueueEndpointProperties>), IList<RoutingServiceBusTopicEndpointProperties> serviceBusTopics = default(IList<RoutingServiceBusTopicEndpointProperties>), IList<RoutingEventHubProperties> eventHubs = default(IList<RoutingEventHubProperties>), IList<RoutingStorageContainerProperties> storageContainers = default(IList<RoutingStorageContainerProperties>))
        {
            ServiceBusQueues = serviceBusQueues;
            ServiceBusTopics = serviceBusTopics;
            EventHubs = eventHubs;
            StorageContainers = storageContainers;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the list of Service Bus queue endpoints that IoT hub
        /// routes the messages to, based on the routing rules.
        /// </summary>
        [JsonProperty(PropertyName = "serviceBusQueues")]
        public IList<RoutingServiceBusQueueEndpointProperties> ServiceBusQueues { get; set; }

        /// <summary>
        /// Gets or sets the list of Service Bus topic endpoints that the IoT
        /// hub routes the messages to, based on the routing rules.
        /// </summary>
        [JsonProperty(PropertyName = "serviceBusTopics")]
        public IList<RoutingServiceBusTopicEndpointProperties> ServiceBusTopics { get; set; }

        /// <summary>
        /// Gets or sets the list of Event Hubs endpoints that IoT hub routes
        /// messages to, based on the routing rules. This list does not include
        /// the built-in Event Hubs endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "eventHubs")]
        public IList<RoutingEventHubProperties> EventHubs { get; set; }

        /// <summary>
        /// Gets or sets the list of storage container endpoints that IoT hub
        /// routes messages to, based on the routing rules.
        /// </summary>
        [JsonProperty(PropertyName = "storageContainers")]
        public IList<RoutingStorageContainerProperties> StorageContainers { get; set; }

    }
}
