// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotHub.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties of an IoT hub shared access policy.
    /// </summary>
    public partial class SharedAccessSignatureAuthorizationRule
    {
        /// <summary>
        /// Initializes a new instance of the
        /// SharedAccessSignatureAuthorizationRule class.
        /// </summary>
        public SharedAccessSignatureAuthorizationRule()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// SharedAccessSignatureAuthorizationRule class.
        /// </summary>
        /// <param name="keyName">The name of the shared access policy.</param>
        /// <param name="rights">The permissions assigned to the shared access
        /// policy. Possible values include: 'RegistryRead', 'RegistryWrite',
        /// 'ServiceConnect', 'DeviceConnect', 'RegistryRead, RegistryWrite',
        /// 'RegistryRead, ServiceConnect', 'RegistryRead, DeviceConnect',
        /// 'RegistryWrite, ServiceConnect', 'RegistryWrite, DeviceConnect',
        /// 'ServiceConnect, DeviceConnect', 'RegistryRead, RegistryWrite,
        /// ServiceConnect', 'RegistryRead, RegistryWrite, DeviceConnect',
        /// 'RegistryRead, ServiceConnect, DeviceConnect', 'RegistryWrite,
        /// ServiceConnect, DeviceConnect', 'RegistryRead, RegistryWrite,
        /// ServiceConnect, DeviceConnect'</param>
        /// <param name="primaryKey">The primary key.</param>
        /// <param name="secondaryKey">The secondary key.</param>
        public SharedAccessSignatureAuthorizationRule(string keyName, AccessRights rights, string primaryKey = default(string), string secondaryKey = default(string))
        {
            KeyName = keyName;
            PrimaryKey = primaryKey;
            SecondaryKey = secondaryKey;
            Rights = rights;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the shared access policy.
        /// </summary>
        [JsonProperty(PropertyName = "keyName")]
        public string KeyName { get; set; }

        /// <summary>
        /// Gets or sets the primary key.
        /// </summary>
        [JsonProperty(PropertyName = "primaryKey")]
        public string PrimaryKey { get; set; }

        /// <summary>
        /// Gets or sets the secondary key.
        /// </summary>
        [JsonProperty(PropertyName = "secondaryKey")]
        public string SecondaryKey { get; set; }

        /// <summary>
        /// Gets or sets the permissions assigned to the shared access policy.
        /// Possible values include: 'RegistryRead', 'RegistryWrite',
        /// 'ServiceConnect', 'DeviceConnect', 'RegistryRead, RegistryWrite',
        /// 'RegistryRead, ServiceConnect', 'RegistryRead, DeviceConnect',
        /// 'RegistryWrite, ServiceConnect', 'RegistryWrite, DeviceConnect',
        /// 'ServiceConnect, DeviceConnect', 'RegistryRead, RegistryWrite,
        /// ServiceConnect', 'RegistryRead, RegistryWrite, DeviceConnect',
        /// 'RegistryRead, ServiceConnect, DeviceConnect', 'RegistryWrite,
        /// ServiceConnect, DeviceConnect', 'RegistryRead, RegistryWrite,
        /// ServiceConnect, DeviceConnect'
        /// </summary>
        [JsonProperty(PropertyName = "rights")]
        public AccessRights Rights { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (KeyName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "KeyName");
            }
        }
    }
}
