// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.IotHub.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties of the Azure Storage endpoint for file upload.
    /// </summary>
    public partial class StorageEndpointProperties
    {
        /// <summary>
        /// Initializes a new instance of the StorageEndpointProperties class.
        /// </summary>
        public StorageEndpointProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the StorageEndpointProperties class.
        /// </summary>
        /// <param name="connectionString">The connection string for the Azure
        /// Storage account to which files are uploaded.</param>
        /// <param name="containerName">The name of the root container where
        /// you upload files. The container need not exist but should be
        /// creatable using the connectionString specified.</param>
        /// <param name="sasTtlAsIso8601">The period of time for which the SAS
        /// URI generated by IoT Hub for file upload is valid. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-file-upload#file-upload-notification-configuration-options.</param>
        public StorageEndpointProperties(string connectionString, string containerName, System.TimeSpan? sasTtlAsIso8601 = default(System.TimeSpan?))
        {
            SasTtlAsIso8601 = sasTtlAsIso8601;
            ConnectionString = connectionString;
            ContainerName = containerName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the period of time for which the SAS URI generated by
        /// IoT Hub for file upload is valid. See:
        /// https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-file-upload#file-upload-notification-configuration-options.
        /// </summary>
        [JsonProperty(PropertyName = "sasTtlAsIso8601")]
        public System.TimeSpan? SasTtlAsIso8601 { get; set; }

        /// <summary>
        /// Gets or sets the connection string for the Azure Storage account to
        /// which files are uploaded.
        /// </summary>
        [JsonProperty(PropertyName = "connectionString")]
        public string ConnectionString { get; set; }

        /// <summary>
        /// Gets or sets the name of the root container where you upload files.
        /// The container need not exist but should be creatable using the
        /// connectionString specified.
        /// </summary>
        [JsonProperty(PropertyName = "containerName")]
        public string ContainerName { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ConnectionString == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ConnectionString");
            }
            if (ContainerName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ContainerName");
            }
        }
    }
}
