// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.KeyVault.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The SAS definition item containing storage SAS definition metadata.
    /// </summary>
    public partial class SasDefinitionItem
    {
        /// <summary>
        /// Initializes a new instance of the SasDefinitionItem class.
        /// </summary>
        public SasDefinitionItem()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SasDefinitionItem class.
        /// </summary>
        /// <param name="id">The storage SAS identifier.</param>
        /// <param name="secretId">The storage account SAS definition secret
        /// id.</param>
        /// <param name="attributes">The SAS definition management
        /// attributes.</param>
        /// <param name="tags">Application specific metadata in the form of
        /// key-value pairs.</param>
        public SasDefinitionItem(string id = default(string), string secretId = default(string), SasDefinitionAttributes attributes = default(SasDefinitionAttributes), IDictionary<string, string> tags = default(IDictionary<string, string>))
        {
            Id = id;
            SecretId = secretId;
            Attributes = attributes;
            Tags = tags;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the storage SAS identifier.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets the storage account SAS definition secret id.
        /// </summary>
        [JsonProperty(PropertyName = "sid")]
        public string SecretId { get; private set; }

        /// <summary>
        /// Gets the SAS definition management attributes.
        /// </summary>
        [JsonProperty(PropertyName = "attributes")]
        public SasDefinitionAttributes Attributes { get; private set; }

        /// <summary>
        /// Gets application specific metadata in the form of key-value pairs.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; private set; }

    }
}
