// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Kusto
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for AttachedDatabaseConfigurationsOperations.
    /// </summary>
    public static partial class AttachedDatabaseConfigurationsOperationsExtensions
    {
            /// <summary>
            /// Returns the list of attached database configurations of the given Kusto
            /// cluster.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            public static IEnumerable<AttachedDatabaseConfiguration> ListByCluster(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName)
            {
                return operations.ListByClusterAsync(resourceGroupName, clusterName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns the list of attached database configurations of the given Kusto
            /// cluster.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IEnumerable<AttachedDatabaseConfiguration>> ListByClusterAsync(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByClusterWithHttpMessagesAsync(resourceGroupName, clusterName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns an attached database configuration.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='attachedDatabaseConfigurationName'>
            /// The name of the attached database configuration.
            /// </param>
            public static AttachedDatabaseConfiguration Get(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, string attachedDatabaseConfigurationName)
            {
                return operations.GetAsync(resourceGroupName, clusterName, attachedDatabaseConfigurationName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns an attached database configuration.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='attachedDatabaseConfigurationName'>
            /// The name of the attached database configuration.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AttachedDatabaseConfiguration> GetAsync(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, string attachedDatabaseConfigurationName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, clusterName, attachedDatabaseConfigurationName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Creates or updates an attached database configuration.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='attachedDatabaseConfigurationName'>
            /// The name of the attached database configuration.
            /// </param>
            /// <param name='parameters'>
            /// The database parameters supplied to the CreateOrUpdate operation.
            /// </param>
            public static AttachedDatabaseConfiguration CreateOrUpdate(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, string attachedDatabaseConfigurationName, AttachedDatabaseConfiguration parameters)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, clusterName, attachedDatabaseConfigurationName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates or updates an attached database configuration.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='attachedDatabaseConfigurationName'>
            /// The name of the attached database configuration.
            /// </param>
            /// <param name='parameters'>
            /// The database parameters supplied to the CreateOrUpdate operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AttachedDatabaseConfiguration> CreateOrUpdateAsync(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, string attachedDatabaseConfigurationName, AttachedDatabaseConfiguration parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, clusterName, attachedDatabaseConfigurationName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the attached database configuration with the given name.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='attachedDatabaseConfigurationName'>
            /// The name of the attached database configuration.
            /// </param>
            public static void Delete(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, string attachedDatabaseConfigurationName)
            {
                operations.DeleteAsync(resourceGroupName, clusterName, attachedDatabaseConfigurationName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the attached database configuration with the given name.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='attachedDatabaseConfigurationName'>
            /// The name of the attached database configuration.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, string attachedDatabaseConfigurationName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, clusterName, attachedDatabaseConfigurationName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Creates or updates an attached database configuration.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='attachedDatabaseConfigurationName'>
            /// The name of the attached database configuration.
            /// </param>
            /// <param name='parameters'>
            /// The database parameters supplied to the CreateOrUpdate operation.
            /// </param>
            public static AttachedDatabaseConfiguration BeginCreateOrUpdate(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, string attachedDatabaseConfigurationName, AttachedDatabaseConfiguration parameters)
            {
                return operations.BeginCreateOrUpdateAsync(resourceGroupName, clusterName, attachedDatabaseConfigurationName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates or updates an attached database configuration.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='attachedDatabaseConfigurationName'>
            /// The name of the attached database configuration.
            /// </param>
            /// <param name='parameters'>
            /// The database parameters supplied to the CreateOrUpdate operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AttachedDatabaseConfiguration> BeginCreateOrUpdateAsync(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, string attachedDatabaseConfigurationName, AttachedDatabaseConfiguration parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateOrUpdateWithHttpMessagesAsync(resourceGroupName, clusterName, attachedDatabaseConfigurationName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the attached database configuration with the given name.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='attachedDatabaseConfigurationName'>
            /// The name of the attached database configuration.
            /// </param>
            public static void BeginDelete(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, string attachedDatabaseConfigurationName)
            {
                operations.BeginDeleteAsync(resourceGroupName, clusterName, attachedDatabaseConfigurationName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the attached database configuration with the given name.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='attachedDatabaseConfigurationName'>
            /// The name of the attached database configuration.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginDeleteAsync(this IAttachedDatabaseConfigurationsOperations operations, string resourceGroupName, string clusterName, string attachedDatabaseConfigurationName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginDeleteWithHttpMessagesAsync(resourceGroupName, clusterName, attachedDatabaseConfigurationName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

    }
}
