// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Kusto
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ClusterPrincipalAssignmentsOperations.
    /// </summary>
    public static partial class ClusterPrincipalAssignmentsOperationsExtensions
    {
            /// <summary>
            /// Checks that the principal assignment name is valid and is not already in
            /// use.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the principal assignment.
            /// </param>
            public static CheckNameResult CheckNameAvailability(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, ClusterPrincipalAssignmentCheckNameRequest principalAssignmentName)
            {
                return operations.CheckNameAvailabilityAsync(resourceGroupName, clusterName, principalAssignmentName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Checks that the principal assignment name is valid and is not already in
            /// use.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the principal assignment.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<CheckNameResult> CheckNameAvailabilityAsync(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, ClusterPrincipalAssignmentCheckNameRequest principalAssignmentName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CheckNameAvailabilityWithHttpMessagesAsync(resourceGroupName, clusterName, principalAssignmentName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets a Kusto cluster principalAssignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the Kusto principalAssignment.
            /// </param>
            public static ClusterPrincipalAssignment Get(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, string principalAssignmentName)
            {
                return operations.GetAsync(resourceGroupName, clusterName, principalAssignmentName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets a Kusto cluster principalAssignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the Kusto principalAssignment.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ClusterPrincipalAssignment> GetAsync(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, string principalAssignmentName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, clusterName, principalAssignmentName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Create a Kusto cluster principalAssignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the Kusto principalAssignment.
            /// </param>
            /// <param name='parameters'>
            /// The Kusto cluster principalAssignment's parameters supplied for the
            /// operation.
            /// </param>
            public static ClusterPrincipalAssignment CreateOrUpdate(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, string principalAssignmentName, ClusterPrincipalAssignment parameters)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, clusterName, principalAssignmentName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create a Kusto cluster principalAssignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the Kusto principalAssignment.
            /// </param>
            /// <param name='parameters'>
            /// The Kusto cluster principalAssignment's parameters supplied for the
            /// operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ClusterPrincipalAssignment> CreateOrUpdateAsync(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, string principalAssignmentName, ClusterPrincipalAssignment parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, clusterName, principalAssignmentName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes a Kusto cluster principalAssignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the Kusto principalAssignment.
            /// </param>
            public static void Delete(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, string principalAssignmentName)
            {
                operations.DeleteAsync(resourceGroupName, clusterName, principalAssignmentName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes a Kusto cluster principalAssignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the Kusto principalAssignment.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, string principalAssignmentName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, clusterName, principalAssignmentName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Lists all Kusto cluster principalAssignments.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            public static IEnumerable<ClusterPrincipalAssignment> List(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName)
            {
                return operations.ListAsync(resourceGroupName, clusterName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists all Kusto cluster principalAssignments.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IEnumerable<ClusterPrincipalAssignment>> ListAsync(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroupName, clusterName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Create a Kusto cluster principalAssignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the Kusto principalAssignment.
            /// </param>
            /// <param name='parameters'>
            /// The Kusto cluster principalAssignment's parameters supplied for the
            /// operation.
            /// </param>
            public static ClusterPrincipalAssignment BeginCreateOrUpdate(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, string principalAssignmentName, ClusterPrincipalAssignment parameters)
            {
                return operations.BeginCreateOrUpdateAsync(resourceGroupName, clusterName, principalAssignmentName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create a Kusto cluster principalAssignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the Kusto principalAssignment.
            /// </param>
            /// <param name='parameters'>
            /// The Kusto cluster principalAssignment's parameters supplied for the
            /// operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ClusterPrincipalAssignment> BeginCreateOrUpdateAsync(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, string principalAssignmentName, ClusterPrincipalAssignment parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateOrUpdateWithHttpMessagesAsync(resourceGroupName, clusterName, principalAssignmentName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes a Kusto cluster principalAssignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the Kusto principalAssignment.
            /// </param>
            public static void BeginDelete(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, string principalAssignmentName)
            {
                operations.BeginDeleteAsync(resourceGroupName, clusterName, principalAssignmentName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes a Kusto cluster principalAssignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='principalAssignmentName'>
            /// The name of the Kusto principalAssignment.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginDeleteAsync(this IClusterPrincipalAssignmentsOperations operations, string resourceGroupName, string clusterName, string principalAssignmentName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginDeleteWithHttpMessagesAsync(resourceGroupName, clusterName, principalAssignmentName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

    }
}
