// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Kusto
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for DataConnectionsOperations.
    /// </summary>
    public static partial class DataConnectionsOperationsExtensions
    {
            /// <summary>
            /// Returns the list of data connections of the given Kusto database.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            public static IEnumerable<DataConnection> ListByDatabase(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName)
            {
                return operations.ListByDatabaseAsync(resourceGroupName, clusterName, databaseName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns the list of data connections of the given Kusto database.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IEnumerable<DataConnection>> ListByDatabaseAsync(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByDatabaseWithHttpMessagesAsync(resourceGroupName, clusterName, databaseName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Checks that the data connection parameters are valid.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='parameters'>
            /// The data connection parameters supplied to the CreateOrUpdate operation.
            /// </param>
            public static DataConnectionValidationListResult DataConnectionValidationMethod(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, DataConnectionValidation parameters)
            {
                return operations.DataConnectionValidationMethodAsync(resourceGroupName, clusterName, databaseName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Checks that the data connection parameters are valid.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='parameters'>
            /// The data connection parameters supplied to the CreateOrUpdate operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DataConnectionValidationListResult> DataConnectionValidationMethodAsync(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, DataConnectionValidation parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DataConnectionValidationMethodWithHttpMessagesAsync(resourceGroupName, clusterName, databaseName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Checks that the data connection name is valid and is not already in use.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            public static CheckNameResult CheckNameAvailability(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, DataConnectionCheckNameRequest dataConnectionName)
            {
                return operations.CheckNameAvailabilityAsync(resourceGroupName, clusterName, databaseName, dataConnectionName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Checks that the data connection name is valid and is not already in use.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<CheckNameResult> CheckNameAvailabilityAsync(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, DataConnectionCheckNameRequest dataConnectionName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CheckNameAvailabilityWithHttpMessagesAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns a data connection.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            public static DataConnection Get(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName)
            {
                return operations.GetAsync(resourceGroupName, clusterName, databaseName, dataConnectionName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns a data connection.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DataConnection> GetAsync(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Creates or updates a data connection.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='parameters'>
            /// The data connection parameters supplied to the CreateOrUpdate operation.
            /// </param>
            public static DataConnection CreateOrUpdate(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, DataConnection parameters)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates or updates a data connection.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='parameters'>
            /// The data connection parameters supplied to the CreateOrUpdate operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DataConnection> CreateOrUpdateAsync(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, DataConnection parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Updates a data connection.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='parameters'>
            /// The data connection parameters supplied to the Update operation.
            /// </param>
            public static DataConnection Update(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, DataConnection parameters)
            {
                return operations.UpdateAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates a data connection.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='parameters'>
            /// The data connection parameters supplied to the Update operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DataConnection> UpdateAsync(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, DataConnection parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the data connection with the given name.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            public static void Delete(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName)
            {
                operations.DeleteAsync(resourceGroupName, clusterName, databaseName, dataConnectionName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the data connection with the given name.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Creates or updates a data connection.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='parameters'>
            /// The data connection parameters supplied to the CreateOrUpdate operation.
            /// </param>
            public static DataConnection BeginCreateOrUpdate(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, DataConnection parameters)
            {
                return operations.BeginCreateOrUpdateAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates or updates a data connection.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='parameters'>
            /// The data connection parameters supplied to the CreateOrUpdate operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DataConnection> BeginCreateOrUpdateAsync(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, DataConnection parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateOrUpdateWithHttpMessagesAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Updates a data connection.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='parameters'>
            /// The data connection parameters supplied to the Update operation.
            /// </param>
            public static DataConnection BeginUpdate(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, DataConnection parameters)
            {
                return operations.BeginUpdateAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates a data connection.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='parameters'>
            /// The data connection parameters supplied to the Update operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DataConnection> BeginUpdateAsync(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, DataConnection parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginUpdateWithHttpMessagesAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the data connection with the given name.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            public static void BeginDelete(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName)
            {
                operations.BeginDeleteAsync(resourceGroupName, clusterName, databaseName, dataConnectionName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the data connection with the given name.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group containing the Kusto cluster.
            /// </param>
            /// <param name='clusterName'>
            /// The name of the Kusto cluster.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database in the Kusto cluster.
            /// </param>
            /// <param name='dataConnectionName'>
            /// The name of the data connection.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginDeleteAsync(this IDataConnectionsOperations operations, string resourceGroupName, string clusterName, string databaseName, string dataConnectionName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginDeleteWithHttpMessagesAsync(resourceGroupName, clusterName, databaseName, dataConnectionName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

    }
}
