// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Kusto.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Class representing an attached database configuration.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class AttachedDatabaseConfiguration : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the AttachedDatabaseConfiguration
        /// class.
        /// </summary>
        public AttachedDatabaseConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AttachedDatabaseConfiguration
        /// class.
        /// </summary>
        /// <param name="databaseName">The name of the database which you would
        /// like to attach, use * if you want to follow all current and future
        /// databases.</param>
        /// <param name="clusterResourceId">The resource id of the cluster
        /// where the databases you would like to attach reside.</param>
        /// <param name="defaultPrincipalsModificationKind">The default
        /// principals modification kind. Possible values include: 'Union',
        /// 'Replace', 'None'</param>
        /// <param name="id">Fully qualified resource Id for the resource. Ex -
        /// /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="type">The type of the resource. Ex-
        /// Microsoft.Compute/virtualMachines or
        /// Microsoft.Storage/storageAccounts.</param>
        /// <param name="location">Resource location.</param>
        /// <param name="provisioningState">The provisioned state of the
        /// resource. Possible values include: 'Running', 'Creating',
        /// 'Deleting', 'Succeeded', 'Failed', 'Moving'</param>
        /// <param name="attachedDatabaseNames">The list of databases from the
        /// clusterResourceId which are currently attached to the
        /// cluster.</param>
        public AttachedDatabaseConfiguration(string databaseName, string clusterResourceId, string defaultPrincipalsModificationKind, string id = default(string), string name = default(string), string type = default(string), string location = default(string), string provisioningState = default(string), IList<string> attachedDatabaseNames = default(IList<string>))
            : base(id, name, type)
        {
            Location = location;
            ProvisioningState = provisioningState;
            DatabaseName = databaseName;
            ClusterResourceId = clusterResourceId;
            AttachedDatabaseNames = attachedDatabaseNames;
            DefaultPrincipalsModificationKind = defaultPrincipalsModificationKind;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets resource location.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets the provisioned state of the resource. Possible values
        /// include: 'Running', 'Creating', 'Deleting', 'Succeeded', 'Failed',
        /// 'Moving'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets the name of the database which you would like to
        /// attach, use * if you want to follow all current and future
        /// databases.
        /// </summary>
        [JsonProperty(PropertyName = "properties.databaseName")]
        public string DatabaseName { get; set; }

        /// <summary>
        /// Gets or sets the resource id of the cluster where the databases you
        /// would like to attach reside.
        /// </summary>
        [JsonProperty(PropertyName = "properties.clusterResourceId")]
        public string ClusterResourceId { get; set; }

        /// <summary>
        /// Gets the list of databases from the clusterResourceId which are
        /// currently attached to the cluster.
        /// </summary>
        [JsonProperty(PropertyName = "properties.attachedDatabaseNames")]
        public IList<string> AttachedDatabaseNames { get; private set; }

        /// <summary>
        /// Gets or sets the default principals modification kind. Possible
        /// values include: 'Union', 'Replace', 'None'
        /// </summary>
        [JsonProperty(PropertyName = "properties.defaultPrincipalsModificationKind")]
        public string DefaultPrincipalsModificationKind { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (DatabaseName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DatabaseName");
            }
            if (ClusterResourceId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ClusterResourceId");
            }
            if (DefaultPrincipalsModificationKind == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DefaultPrincipalsModificationKind");
            }
        }
    }
}
