// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Kusto.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Azure resource SKU definition.
    /// </summary>
    public partial class AzureResourceSku
    {
        /// <summary>
        /// Initializes a new instance of the AzureResourceSku class.
        /// </summary>
        public AzureResourceSku()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureResourceSku class.
        /// </summary>
        /// <param name="resourceType">Resource Namespace and Type.</param>
        /// <param name="sku">The SKU details.</param>
        /// <param name="capacity">The number of instances of the
        /// cluster.</param>
        public AzureResourceSku(string resourceType = default(string), AzureSku sku = default(AzureSku), AzureCapacity capacity = default(AzureCapacity))
        {
            ResourceType = resourceType;
            Sku = sku;
            Capacity = capacity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets resource Namespace and Type.
        /// </summary>
        [JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; set; }

        /// <summary>
        /// Gets or sets the SKU details.
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public AzureSku Sku { get; set; }

        /// <summary>
        /// Gets or sets the number of instances of the cluster.
        /// </summary>
        [JsonProperty(PropertyName = "capacity")]
        public AzureCapacity Capacity { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Sku != null)
            {
                Sku.Validate();
            }
            if (Capacity != null)
            {
                Capacity.Validate();
            }
        }
    }
}
