// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Kusto.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Class representing an Event Grid data connection.
    /// </summary>
    [Newtonsoft.Json.JsonObject("EventGrid")]
    [Rest.Serialization.JsonTransformation]
    public partial class EventGridDataConnection : DataConnection
    {
        /// <summary>
        /// Initializes a new instance of the EventGridDataConnection class.
        /// </summary>
        public EventGridDataConnection()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EventGridDataConnection class.
        /// </summary>
        /// <param name="storageAccountResourceId">The resource ID of the
        /// storage account where the data resides.</param>
        /// <param name="eventHubResourceId">The resource ID where the event
        /// grid is configured to send events.</param>
        /// <param name="consumerGroup">The event hub consumer group.</param>
        /// <param name="tableName">The table where the data should be
        /// ingested. Optionally the table information can be added to each
        /// message.</param>
        /// <param name="dataFormat">The data format of the message. Optionally
        /// the data format can be added to each message. Possible values
        /// include: 'MULTIJSON', 'JSON', 'CSV', 'TSV', 'SCSV', 'SOHSV', 'PSV',
        /// 'TXT', 'RAW', 'SINGLEJSON', 'AVRO', 'TSVE', 'PARQUET',
        /// 'ORC'</param>
        /// <param name="id">Fully qualified resource Id for the resource. Ex -
        /// /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="type">The type of the resource. Ex-
        /// Microsoft.Compute/virtualMachines or
        /// Microsoft.Storage/storageAccounts.</param>
        /// <param name="location">Resource location.</param>
        /// <param name="mappingRuleName">The mapping rule to be used to ingest
        /// the data. Optionally the mapping information can be added to each
        /// message.</param>
        public EventGridDataConnection(string storageAccountResourceId, string eventHubResourceId, string consumerGroup, string tableName, string dataFormat, string id = default(string), string name = default(string), string type = default(string), string location = default(string), string mappingRuleName = default(string))
            : base(id, name, type, location)
        {
            StorageAccountResourceId = storageAccountResourceId;
            EventHubResourceId = eventHubResourceId;
            ConsumerGroup = consumerGroup;
            TableName = tableName;
            MappingRuleName = mappingRuleName;
            DataFormat = dataFormat;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the resource ID of the storage account where the data
        /// resides.
        /// </summary>
        [JsonProperty(PropertyName = "properties.storageAccountResourceId")]
        public string StorageAccountResourceId { get; set; }

        /// <summary>
        /// Gets or sets the resource ID where the event grid is configured to
        /// send events.
        /// </summary>
        [JsonProperty(PropertyName = "properties.eventHubResourceId")]
        public string EventHubResourceId { get; set; }

        /// <summary>
        /// Gets or sets the event hub consumer group.
        /// </summary>
        [JsonProperty(PropertyName = "properties.consumerGroup")]
        public string ConsumerGroup { get; set; }

        /// <summary>
        /// Gets or sets the table where the data should be ingested.
        /// Optionally the table information can be added to each message.
        /// </summary>
        [JsonProperty(PropertyName = "properties.tableName")]
        public string TableName { get; set; }

        /// <summary>
        /// Gets or sets the mapping rule to be used to ingest the data.
        /// Optionally the mapping information can be added to each message.
        /// </summary>
        [JsonProperty(PropertyName = "properties.mappingRuleName")]
        public string MappingRuleName { get; set; }

        /// <summary>
        /// Gets or sets the data format of the message. Optionally the data
        /// format can be added to each message. Possible values include:
        /// 'MULTIJSON', 'JSON', 'CSV', 'TSV', 'SCSV', 'SOHSV', 'PSV', 'TXT',
        /// 'RAW', 'SINGLEJSON', 'AVRO', 'TSVE', 'PARQUET', 'ORC'
        /// </summary>
        [JsonProperty(PropertyName = "properties.dataFormat")]
        public string DataFormat { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (StorageAccountResourceId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "StorageAccountResourceId");
            }
            if (EventHubResourceId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "EventHubResourceId");
            }
            if (ConsumerGroup == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ConsumerGroup");
            }
            if (TableName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TableName");
            }
            if (DataFormat == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DataFormat");
            }
        }
    }
}
