// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Kusto.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A class that contains the optimized auto scale definition.
    /// </summary>
    public partial class OptimizedAutoscale
    {
        /// <summary>
        /// Initializes a new instance of the OptimizedAutoscale class.
        /// </summary>
        public OptimizedAutoscale()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OptimizedAutoscale class.
        /// </summary>
        /// <param name="version">The version of the template defined, for
        /// instance 1.</param>
        /// <param name="isEnabled">A boolean value that indicate if the
        /// optimized autoscale feature is enabled or not.</param>
        /// <param name="minimum">Minimum allowed instances count.</param>
        /// <param name="maximum">Maximum allowed instances count.</param>
        public OptimizedAutoscale(int version, bool isEnabled, int minimum, int maximum)
        {
            Version = version;
            IsEnabled = isEnabled;
            Minimum = minimum;
            Maximum = maximum;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the version of the template defined, for instance 1.
        /// </summary>
        [JsonProperty(PropertyName = "version")]
        public int Version { get; set; }

        /// <summary>
        /// Gets or sets a boolean value that indicate if the optimized
        /// autoscale feature is enabled or not.
        /// </summary>
        [JsonProperty(PropertyName = "isEnabled")]
        public bool IsEnabled { get; set; }

        /// <summary>
        /// Gets or sets minimum allowed instances count.
        /// </summary>
        [JsonProperty(PropertyName = "minimum")]
        public int Minimum { get; set; }

        /// <summary>
        /// Gets or sets maximum allowed instances count.
        /// </summary>
        [JsonProperty(PropertyName = "maximum")]
        public int Maximum { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
