// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Kusto.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A class that contains virtual network definition.
    /// </summary>
    public partial class VirtualNetworkConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the VirtualNetworkConfiguration
        /// class.
        /// </summary>
        public VirtualNetworkConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualNetworkConfiguration
        /// class.
        /// </summary>
        /// <param name="subnetId">The subnet resource id.</param>
        /// <param name="enginePublicIpId">Engine service's public IP address
        /// resource id.</param>
        /// <param name="dataManagementPublicIpId">Data management's service
        /// public IP address resource id.</param>
        public VirtualNetworkConfiguration(string subnetId, string enginePublicIpId, string dataManagementPublicIpId)
        {
            SubnetId = subnetId;
            EnginePublicIpId = enginePublicIpId;
            DataManagementPublicIpId = dataManagementPublicIpId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the subnet resource id.
        /// </summary>
        [JsonProperty(PropertyName = "subnetId")]
        public string SubnetId { get; set; }

        /// <summary>
        /// Gets or sets engine service's public IP address resource id.
        /// </summary>
        [JsonProperty(PropertyName = "enginePublicIpId")]
        public string EnginePublicIpId { get; set; }

        /// <summary>
        /// Gets or sets data management's service public IP address resource
        /// id.
        /// </summary>
        [JsonProperty(PropertyName = "dataManagementPublicIpId")]
        public string DataManagementPublicIpId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SubnetId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SubnetId");
            }
            if (EnginePublicIpId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "EnginePublicIpId");
            }
            if (DataManagementPublicIpId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DataManagementPublicIpId");
            }
        }
    }
}
