// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.LabServices
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// The Managed Labs Client.
    /// </summary>
    public partial interface IManagedLabsClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// Client API version.
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// The subscription ID.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IProviderOperations.
        /// </summary>
        IProviderOperations ProviderOperations { get; }

        /// <summary>
        /// Gets the IGlobalUsersOperations.
        /// </summary>
        IGlobalUsersOperations GlobalUsers { get; }

        /// <summary>
        /// Gets the ILabAccountsOperations.
        /// </summary>
        ILabAccountsOperations LabAccounts { get; }

        /// <summary>
        /// Gets the IOperations.
        /// </summary>
        IOperations Operations { get; }

        /// <summary>
        /// Gets the IGalleryImagesOperations.
        /// </summary>
        IGalleryImagesOperations GalleryImages { get; }

        /// <summary>
        /// Gets the ILabsOperations.
        /// </summary>
        ILabsOperations Labs { get; }

        /// <summary>
        /// Gets the IEnvironmentSettingsOperations.
        /// </summary>
        IEnvironmentSettingsOperations EnvironmentSettings { get; }

        /// <summary>
        /// Gets the IEnvironmentsOperations.
        /// </summary>
        IEnvironmentsOperations Environments { get; }

        /// <summary>
        /// Gets the IUsersOperations.
        /// </summary>
        IUsersOperations Users { get; }

    }
}
