// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.LabServices.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Properties for creating a managed lab and a default environment setting
    /// </summary>
    public partial class CreateLabProperties
    {
        /// <summary>
        /// Initializes a new instance of the CreateLabProperties class.
        /// </summary>
        public CreateLabProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CreateLabProperties class.
        /// </summary>
        /// <param name="labCreationParameters">Settings related to creating a
        /// lab</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="environmentSettingCreationParameters">Settings related
        /// to creating an environment setting</param>
        /// <param name="location">The location of the resource</param>
        /// <param name="tags">The tags of the resource.</param>
        public CreateLabProperties(LabCreationParameters labCreationParameters, string name, EnvironmentSettingCreationParameters environmentSettingCreationParameters = default(EnvironmentSettingCreationParameters), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>))
        {
            EnvironmentSettingCreationParameters = environmentSettingCreationParameters;
            LabCreationParameters = labCreationParameters;
            Name = name;
            Location = location;
            Tags = tags;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets settings related to creating an environment setting
        /// </summary>
        [JsonProperty(PropertyName = "environmentSettingCreationParameters")]
        public EnvironmentSettingCreationParameters EnvironmentSettingCreationParameters { get; set; }

        /// <summary>
        /// Gets or sets settings related to creating a lab
        /// </summary>
        [JsonProperty(PropertyName = "labCreationParameters")]
        public LabCreationParameters LabCreationParameters { get; set; }

        /// <summary>
        /// Gets or sets the name of the resource
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the location of the resource
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets the tags of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (LabCreationParameters == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LabCreationParameters");
            }
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (EnvironmentSettingCreationParameters != null)
            {
                EnvironmentSettingCreationParameters.Validate();
            }
        }
    }
}
