// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.LabServices.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents settings of an environment, from which environment instances
    /// would be created
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class EnvironmentSetting : Resource
    {
        /// <summary>
        /// Initializes a new instance of the EnvironmentSetting class.
        /// </summary>
        public EnvironmentSetting()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EnvironmentSetting class.
        /// </summary>
        /// <param name="resourceSettings">The resource specific
        /// settings</param>
        /// <param name="id">The identifier of the resource.</param>
        /// <param name="name">The name of the resource.</param>
        /// <param name="type">The type of the resource.</param>
        /// <param name="location">The location of the resource.</param>
        /// <param name="tags">The tags of the resource.</param>
        /// <param name="publishingState">Describes the readiness of this
        /// environment setting. Possible values include: 'Draft',
        /// 'Publishing', 'Published', 'PublishFailed', 'Scaling'</param>
        /// <param name="configurationState">Describes the user's progress in
        /// configuring their environment setting. Possible values include:
        /// 'NotApplicable', 'Completed'</param>
        /// <param name="description">Describes the environment and its
        /// resource settings</param>
        /// <param name="title">Brief title describing the environment and its
        /// resource settings</param>
        /// <param name="lastChanged">Time when the template VM was last
        /// changed.</param>
        /// <param name="lastPublished">Time when the template VM was last sent
        /// for publishing.</param>
        /// <param name="provisioningState">The provisioning status of the
        /// resource.</param>
        /// <param name="uniqueIdentifier">The unique immutable identifier of a
        /// resource (Guid).</param>
        /// <param name="latestOperationResult">The details of the latest
        /// operation. ex: status, error</param>
        public EnvironmentSetting(ResourceSettings resourceSettings, string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string publishingState = default(string), string configurationState = default(string), string description = default(string), string title = default(string), System.DateTime? lastChanged = default(System.DateTime?), System.DateTime? lastPublished = default(System.DateTime?), string provisioningState = default(string), string uniqueIdentifier = default(string), LatestOperationResult latestOperationResult = default(LatestOperationResult))
            : base(id, name, type, location, tags)
        {
            PublishingState = publishingState;
            ConfigurationState = configurationState;
            Description = description;
            Title = title;
            ResourceSettings = resourceSettings;
            LastChanged = lastChanged;
            LastPublished = lastPublished;
            ProvisioningState = provisioningState;
            UniqueIdentifier = uniqueIdentifier;
            LatestOperationResult = latestOperationResult;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets describes the readiness of this environment setting. Possible
        /// values include: 'Draft', 'Publishing', 'Published',
        /// 'PublishFailed', 'Scaling'
        /// </summary>
        [JsonProperty(PropertyName = "properties.publishingState")]
        public string PublishingState { get; private set; }

        /// <summary>
        /// Gets or sets describes the user's progress in configuring their
        /// environment setting. Possible values include: 'NotApplicable',
        /// 'Completed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.configurationState")]
        public string ConfigurationState { get; set; }

        /// <summary>
        /// Gets or sets describes the environment and its resource settings
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets brief title describing the environment and its
        /// resource settings
        /// </summary>
        [JsonProperty(PropertyName = "properties.title")]
        public string Title { get; set; }

        /// <summary>
        /// Gets or sets the resource specific settings
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceSettings")]
        public ResourceSettings ResourceSettings { get; set; }

        /// <summary>
        /// Gets time when the template VM was last changed.
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastChanged")]
        public System.DateTime? LastChanged { get; private set; }

        /// <summary>
        /// Gets time when the template VM was last sent for publishing.
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastPublished")]
        public System.DateTime? LastPublished { get; private set; }

        /// <summary>
        /// Gets or sets the provisioning status of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets or sets the unique immutable identifier of a resource (Guid).
        /// </summary>
        [JsonProperty(PropertyName = "properties.uniqueIdentifier")]
        public string UniqueIdentifier { get; set; }

        /// <summary>
        /// Gets the details of the latest operation. ex: status, error
        /// </summary>
        [JsonProperty(PropertyName = "properties.latestOperationResult")]
        public LatestOperationResult LatestOperationResult { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ResourceSettings == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ResourceSettings");
            }
            if (ResourceSettings != null)
            {
                ResourceSettings.Validate();
            }
        }
    }
}
