// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.LabServices.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents settings of an environment, from which environment instances
    /// would be created
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class EnvironmentSettingFragment : Resource
    {
        /// <summary>
        /// Initializes a new instance of the EnvironmentSettingFragment class.
        /// </summary>
        public EnvironmentSettingFragment()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EnvironmentSettingFragment class.
        /// </summary>
        /// <param name="id">The identifier of the resource.</param>
        /// <param name="name">The name of the resource.</param>
        /// <param name="type">The type of the resource.</param>
        /// <param name="location">The location of the resource.</param>
        /// <param name="tags">The tags of the resource.</param>
        /// <param name="configurationState">Describes the user's progress in
        /// configuring their environment setting. Possible values include:
        /// 'NotApplicable', 'Completed'</param>
        /// <param name="description">Describes the environment and its
        /// resource settings</param>
        /// <param name="title">Brief title describing the environment and its
        /// resource settings</param>
        /// <param name="resourceSettings">The resource specific
        /// settings</param>
        /// <param name="provisioningState">The provisioning status of the
        /// resource.</param>
        /// <param name="uniqueIdentifier">The unique immutable identifier of a
        /// resource (Guid).</param>
        public EnvironmentSettingFragment(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string configurationState = default(string), string description = default(string), string title = default(string), ResourceSettingsFragment resourceSettings = default(ResourceSettingsFragment), string provisioningState = default(string), string uniqueIdentifier = default(string))
            : base(id, name, type, location, tags)
        {
            ConfigurationState = configurationState;
            Description = description;
            Title = title;
            ResourceSettings = resourceSettings;
            ProvisioningState = provisioningState;
            UniqueIdentifier = uniqueIdentifier;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets describes the user's progress in configuring their
        /// environment setting. Possible values include: 'NotApplicable',
        /// 'Completed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.configurationState")]
        public string ConfigurationState { get; set; }

        /// <summary>
        /// Gets or sets describes the environment and its resource settings
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets brief title describing the environment and its
        /// resource settings
        /// </summary>
        [JsonProperty(PropertyName = "properties.title")]
        public string Title { get; set; }

        /// <summary>
        /// Gets or sets the resource specific settings
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceSettings")]
        public ResourceSettingsFragment ResourceSettings { get; set; }

        /// <summary>
        /// Gets or sets the provisioning status of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets or sets the unique immutable identifier of a resource (Guid).
        /// </summary>
        [JsonProperty(PropertyName = "properties.uniqueIdentifier")]
        public string UniqueIdentifier { get; set; }

    }
}
