// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.LabServices.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Details of the status of an operation.
    /// </summary>
    public partial class LatestOperationResult
    {
        /// <summary>
        /// Initializes a new instance of the LatestOperationResult class.
        /// </summary>
        public LatestOperationResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the LatestOperationResult class.
        /// </summary>
        /// <param name="status">The current status of the operation.</param>
        /// <param name="errorCode">Error code on failure.</param>
        /// <param name="errorMessage">The error message.</param>
        /// <param name="requestUri">Request URI of the operation.</param>
        /// <param name="httpMethod">The HttpMethod - PUT/POST/DELETE for the
        /// operation.</param>
        /// <param name="operationUrl">The URL to use to check long-running
        /// operation status</param>
        public LatestOperationResult(string status = default(string), string errorCode = default(string), string errorMessage = default(string), string requestUri = default(string), string httpMethod = default(string), string operationUrl = default(string))
        {
            Status = status;
            ErrorCode = errorCode;
            ErrorMessage = errorMessage;
            RequestUri = requestUri;
            HttpMethod = httpMethod;
            OperationUrl = operationUrl;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the current status of the operation.
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; private set; }

        /// <summary>
        /// Gets error code on failure.
        /// </summary>
        [JsonProperty(PropertyName = "errorCode")]
        public string ErrorCode { get; private set; }

        /// <summary>
        /// Gets the error message.
        /// </summary>
        [JsonProperty(PropertyName = "errorMessage")]
        public string ErrorMessage { get; private set; }

        /// <summary>
        /// Gets request URI of the operation.
        /// </summary>
        [JsonProperty(PropertyName = "requestUri")]
        public string RequestUri { get; private set; }

        /// <summary>
        /// Gets the HttpMethod - PUT/POST/DELETE for the operation.
        /// </summary>
        [JsonProperty(PropertyName = "httpMethod")]
        public string HttpMethod { get; private set; }

        /// <summary>
        /// Gets the URL to use to check long-running operation status
        /// </summary>
        [JsonProperty(PropertyName = "operationUrl")]
        public string OperationUrl { get; private set; }

    }
}
