// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.LabServices.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents payload for any Environment operations like get, start,
    /// stop, connect
    /// </summary>
    public partial class PersonalPerferencesOperationsPayload
    {
        /// <summary>
        /// Initializes a new instance of the
        /// PersonalPerferencesOperationsPayload class.
        /// </summary>
        public PersonalPerferencesOperationsPayload()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// PersonalPerferencesOperationsPayload class.
        /// </summary>
        /// <param name="labAccountResourceId">Resource Id of the lab
        /// account</param>
        /// <param name="addRemove">Enum indicating if user is adding or
        /// removing a favorite lab. Possible values include: 'Add',
        /// 'Remove'</param>
        /// <param name="labResourceId">Resource Id of the lab to add/remove
        /// from the favorites list</param>
        public PersonalPerferencesOperationsPayload(string labAccountResourceId = default(string), string addRemove = default(string), string labResourceId = default(string))
        {
            LabAccountResourceId = labAccountResourceId;
            AddRemove = addRemove;
            LabResourceId = labResourceId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets resource Id of the lab account
        /// </summary>
        [JsonProperty(PropertyName = "labAccountResourceId")]
        public string LabAccountResourceId { get; set; }

        /// <summary>
        /// Gets or sets enum indicating if user is adding or removing a
        /// favorite lab. Possible values include: 'Add', 'Remove'
        /// </summary>
        [JsonProperty(PropertyName = "addRemove")]
        public string AddRemove { get; set; }

        /// <summary>
        /// Gets or sets resource Id of the lab to add/remove from the
        /// favorites list
        /// </summary>
        [JsonProperty(PropertyName = "labResourceId")]
        public string LabResourceId { get; set; }

    }
}
