// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.LabServices.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents resource specific settings
    /// </summary>
    public partial class ResourceSettingsFragment
    {
        /// <summary>
        /// Initializes a new instance of the ResourceSettingsFragment class.
        /// </summary>
        public ResourceSettingsFragment()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceSettingsFragment class.
        /// </summary>
        /// <param name="galleryImageResourceId">The resource id of the gallery
        /// image used for creating the virtual machine</param>
        /// <param name="size">The size of the virtual machine. Possible values
        /// include: 'Basic', 'Standard', 'Performance'</param>
        /// <param name="referenceVm">Details specific to Reference Vm</param>
        public ResourceSettingsFragment(string galleryImageResourceId = default(string), string size = default(string), ReferenceVmFragment referenceVm = default(ReferenceVmFragment))
        {
            GalleryImageResourceId = galleryImageResourceId;
            Size = size;
            ReferenceVm = referenceVm;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the resource id of the gallery image used for creating
        /// the virtual machine
        /// </summary>
        [JsonProperty(PropertyName = "galleryImageResourceId")]
        public string GalleryImageResourceId { get; set; }

        /// <summary>
        /// Gets or sets the size of the virtual machine. Possible values
        /// include: 'Basic', 'Standard', 'Performance'
        /// </summary>
        [JsonProperty(PropertyName = "size")]
        public string Size { get; set; }

        /// <summary>
        /// Gets or sets details specific to Reference Vm
        /// </summary>
        [JsonProperty(PropertyName = "referenceVm")]
        public ReferenceVmFragment ReferenceVm { get; set; }

    }
}
