// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.LabServices.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Contains detailed information about a size
    /// </summary>
    public partial class SizeInfo
    {
        /// <summary>
        /// Initializes a new instance of the SizeInfo class.
        /// </summary>
        public SizeInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SizeInfo class.
        /// </summary>
        /// <param name="computeSize">Represents the actual compute size, e.g.
        /// Standard_A2_v2.</param>
        /// <param name="price">The pay-as-you-go price per hour this size will
        /// cost. It does not include discounts and may not reflect the actual
        /// price the size will cost.</param>
        /// <param name="numberOfCores">The number of cores a VM of this size
        /// has.</param>
        /// <param name="memory">The amount of memory available (in
        /// GB).</param>
        public SizeInfo(string computeSize = default(string), decimal? price = default(decimal?), int? numberOfCores = default(int?), double? memory = default(double?))
        {
            ComputeSize = computeSize;
            Price = price;
            NumberOfCores = numberOfCores;
            Memory = memory;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets represents the actual compute size, e.g.
        /// Standard_A2_v2.
        /// </summary>
        [JsonProperty(PropertyName = "computeSize")]
        public string ComputeSize { get; set; }

        /// <summary>
        /// Gets or sets the pay-as-you-go price per hour this size will cost.
        /// It does not include discounts and may not reflect the actual price
        /// the size will cost.
        /// </summary>
        [JsonProperty(PropertyName = "price")]
        public decimal? Price { get; set; }

        /// <summary>
        /// Gets or sets the number of cores a VM of this size has.
        /// </summary>
        [JsonProperty(PropertyName = "numberOfCores")]
        public int? NumberOfCores { get; set; }

        /// <summary>
        /// Gets or sets the amount of memory available (in GB).
        /// </summary>
        [JsonProperty(PropertyName = "memory")]
        public double? Memory { get; set; }

    }
}
