// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.LabServices.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The User registered to a lab
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class User : Resource
    {
        /// <summary>
        /// Initializes a new instance of the User class.
        /// </summary>
        public User()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the User class.
        /// </summary>
        /// <param name="id">The identifier of the resource.</param>
        /// <param name="name">The name of the resource.</param>
        /// <param name="type">The type of the resource.</param>
        /// <param name="location">The location of the resource.</param>
        /// <param name="tags">The tags of the resource.</param>
        /// <param name="email">The user email address, as it was specified
        /// during registration.</param>
        /// <param name="familyName">The user family name, as it was specified
        /// during registration.</param>
        /// <param name="givenName">The user given name, as it was specified
        /// during registration.</param>
        /// <param name="tenantId">The user tenant ID, as it was specified
        /// during registration.</param>
        /// <param name="totalUsage">How long the user has used his VMs in this
        /// lab</param>
        /// <param name="provisioningState">The provisioning status of the
        /// resource.</param>
        /// <param name="uniqueIdentifier">The unique immutable identifier of a
        /// resource (Guid).</param>
        /// <param name="latestOperationResult">The details of the latest
        /// operation. ex: status, error</param>
        public User(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string email = default(string), string familyName = default(string), string givenName = default(string), string tenantId = default(string), System.TimeSpan? totalUsage = default(System.TimeSpan?), string provisioningState = default(string), string uniqueIdentifier = default(string), LatestOperationResult latestOperationResult = default(LatestOperationResult))
            : base(id, name, type, location, tags)
        {
            Email = email;
            FamilyName = familyName;
            GivenName = givenName;
            TenantId = tenantId;
            TotalUsage = totalUsage;
            ProvisioningState = provisioningState;
            UniqueIdentifier = uniqueIdentifier;
            LatestOperationResult = latestOperationResult;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the user email address, as it was specified during
        /// registration.
        /// </summary>
        [JsonProperty(PropertyName = "properties.email")]
        public string Email { get; private set; }

        /// <summary>
        /// Gets the user family name, as it was specified during registration.
        /// </summary>
        [JsonProperty(PropertyName = "properties.familyName")]
        public string FamilyName { get; private set; }

        /// <summary>
        /// Gets the user given name, as it was specified during registration.
        /// </summary>
        [JsonProperty(PropertyName = "properties.givenName")]
        public string GivenName { get; private set; }

        /// <summary>
        /// Gets the user tenant ID, as it was specified during registration.
        /// </summary>
        [JsonProperty(PropertyName = "properties.tenantId")]
        public string TenantId { get; private set; }

        /// <summary>
        /// Gets how long the user has used his VMs in this lab
        /// </summary>
        [JsonProperty(PropertyName = "properties.totalUsage")]
        public System.TimeSpan? TotalUsage { get; private set; }

        /// <summary>
        /// Gets or sets the provisioning status of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets or sets the unique immutable identifier of a resource (Guid).
        /// </summary>
        [JsonProperty(PropertyName = "properties.uniqueIdentifier")]
        public string UniqueIdentifier { get; set; }

        /// <summary>
        /// Gets the details of the latest operation. ex: status, error
        /// </summary>
        [JsonProperty(PropertyName = "properties.latestOperationResult")]
        public LatestOperationResult LatestOperationResult { get; private set; }

    }
}
