// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.LabServices.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Details about the state of the reference virtual machine.
    /// </summary>
    public partial class VmStateDetails
    {
        /// <summary>
        /// Initializes a new instance of the VmStateDetails class.
        /// </summary>
        public VmStateDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VmStateDetails class.
        /// </summary>
        /// <param name="rdpAuthority">The RdpAuthority property is a server
        /// DNS host name or IP address followed by the service port number for
        /// RDP (Remote Desktop Protocol).</param>
        /// <param name="sshAuthority">The SshAuthority property is a server
        /// DNS host name or IP address followed by the service port number for
        /// SSH.</param>
        /// <param name="powerState">The power state of the reference virtual
        /// machine.</param>
        /// <param name="lastKnownPowerState">Last known compute power state
        /// captured in DTL</param>
        public VmStateDetails(string rdpAuthority = default(string), string sshAuthority = default(string), string powerState = default(string), string lastKnownPowerState = default(string))
        {
            RdpAuthority = rdpAuthority;
            SshAuthority = sshAuthority;
            PowerState = powerState;
            LastKnownPowerState = lastKnownPowerState;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the RdpAuthority property is a server DNS host name or IP
        /// address followed by the service port number for RDP (Remote Desktop
        /// Protocol).
        /// </summary>
        [JsonProperty(PropertyName = "rdpAuthority")]
        public string RdpAuthority { get; private set; }

        /// <summary>
        /// Gets the SshAuthority property is a server DNS host name or IP
        /// address followed by the service port number for SSH.
        /// </summary>
        [JsonProperty(PropertyName = "sshAuthority")]
        public string SshAuthority { get; private set; }

        /// <summary>
        /// Gets the power state of the reference virtual machine.
        /// </summary>
        [JsonProperty(PropertyName = "powerState")]
        public string PowerState { get; private set; }

        /// <summary>
        /// Gets last known compute power state captured in DTL
        /// </summary>
        [JsonProperty(PropertyName = "lastKnownPowerState")]
        public string LastKnownPowerState { get; private set; }

    }
}
