// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Logic
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// REST API for Azure Logic Apps.
    /// </summary>
    public partial interface ILogicManagementClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// The subscription id.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// The API version.
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IWorkflowsOperations.
        /// </summary>
        IWorkflowsOperations Workflows { get; }

        /// <summary>
        /// Gets the IWorkflowVersionsOperations.
        /// </summary>
        IWorkflowVersionsOperations WorkflowVersions { get; }

        /// <summary>
        /// Gets the IWorkflowTriggersOperations.
        /// </summary>
        IWorkflowTriggersOperations WorkflowTriggers { get; }

        /// <summary>
        /// Gets the IWorkflowVersionTriggersOperations.
        /// </summary>
        IWorkflowVersionTriggersOperations WorkflowVersionTriggers { get; }

        /// <summary>
        /// Gets the IWorkflowTriggerHistoriesOperations.
        /// </summary>
        IWorkflowTriggerHistoriesOperations WorkflowTriggerHistories { get; }

        /// <summary>
        /// Gets the IWorkflowRunsOperations.
        /// </summary>
        IWorkflowRunsOperations WorkflowRuns { get; }

        /// <summary>
        /// Gets the IWorkflowRunActionsOperations.
        /// </summary>
        IWorkflowRunActionsOperations WorkflowRunActions { get; }

        /// <summary>
        /// Gets the IWorkflowRunActionRepetitionsOperations.
        /// </summary>
        IWorkflowRunActionRepetitionsOperations WorkflowRunActionRepetitions { get; }

        /// <summary>
        /// Gets the IWorkflowRunActionRepetitionsRequestHistoriesOperations.
        /// </summary>
        IWorkflowRunActionRepetitionsRequestHistoriesOperations WorkflowRunActionRepetitionsRequestHistories { get; }

        /// <summary>
        /// Gets the IWorkflowRunActionRequestHistoriesOperations.
        /// </summary>
        IWorkflowRunActionRequestHistoriesOperations WorkflowRunActionRequestHistories { get; }

        /// <summary>
        /// Gets the IWorkflowRunActionScopeRepetitionsOperations.
        /// </summary>
        IWorkflowRunActionScopeRepetitionsOperations WorkflowRunActionScopeRepetitions { get; }

        /// <summary>
        /// Gets the IWorkflowRunOperations.
        /// </summary>
        IWorkflowRunOperations WorkflowRunOperations { get; }

        /// <summary>
        /// Gets the IIntegrationAccountsOperations.
        /// </summary>
        IIntegrationAccountsOperations IntegrationAccounts { get; }

        /// <summary>
        /// Gets the IIntegrationAccountAssembliesOperations.
        /// </summary>
        IIntegrationAccountAssembliesOperations IntegrationAccountAssemblies { get; }

        /// <summary>
        /// Gets the IIntegrationAccountBatchConfigurationsOperations.
        /// </summary>
        IIntegrationAccountBatchConfigurationsOperations IntegrationAccountBatchConfigurations { get; }

        /// <summary>
        /// Gets the IIntegrationAccountSchemasOperations.
        /// </summary>
        IIntegrationAccountSchemasOperations IntegrationAccountSchemas { get; }

        /// <summary>
        /// Gets the IIntegrationAccountMapsOperations.
        /// </summary>
        IIntegrationAccountMapsOperations IntegrationAccountMaps { get; }

        /// <summary>
        /// Gets the IIntegrationAccountPartnersOperations.
        /// </summary>
        IIntegrationAccountPartnersOperations IntegrationAccountPartners { get; }

        /// <summary>
        /// Gets the IIntegrationAccountAgreementsOperations.
        /// </summary>
        IIntegrationAccountAgreementsOperations IntegrationAccountAgreements { get; }

        /// <summary>
        /// Gets the IIntegrationAccountCertificatesOperations.
        /// </summary>
        IIntegrationAccountCertificatesOperations IntegrationAccountCertificates { get; }

        /// <summary>
        /// Gets the IIntegrationAccountSessionsOperations.
        /// </summary>
        IIntegrationAccountSessionsOperations IntegrationAccountSessions { get; }

        /// <summary>
        /// Gets the IIntegrationServiceEnvironmentsOperations.
        /// </summary>
        IIntegrationServiceEnvironmentsOperations IntegrationServiceEnvironments { get; }

        /// <summary>
        /// Gets the IIntegrationServiceEnvironmentSkusOperations.
        /// </summary>
        IIntegrationServiceEnvironmentSkusOperations IntegrationServiceEnvironmentSkus { get; }

        /// <summary>
        /// Gets the IIntegrationServiceEnvironmentNetworkHealthOperations.
        /// </summary>
        IIntegrationServiceEnvironmentNetworkHealthOperations IntegrationServiceEnvironmentNetworkHealth { get; }

        /// <summary>
        /// Gets the IIntegrationServiceEnvironmentManagedApisOperations.
        /// </summary>
        IIntegrationServiceEnvironmentManagedApisOperations IntegrationServiceEnvironmentManagedApis { get; }

        /// <summary>
        /// Gets the IIntegrationServiceEnvironmentManagedApiOperations.
        /// </summary>
        IIntegrationServiceEnvironmentManagedApiOperations IntegrationServiceEnvironmentManagedApiOperations { get; }

        /// <summary>
        /// Gets the IOperations.
        /// </summary>
        IOperations Operations { get; }

    }
}
