// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Logic
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Azure.OData;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for IntegrationAccountSchemasOperations.
    /// </summary>
    public static partial class IntegrationAccountSchemasOperationsExtensions
    {
            /// <summary>
            /// Gets a list of integration account schemas.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationAccountName'>
            /// The integration account name.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            public static IPage<IntegrationAccountSchema> List(this IIntegrationAccountSchemasOperations operations, string resourceGroupName, string integrationAccountName, ODataQuery<IntegrationAccountSchemaFilter> odataQuery = default(ODataQuery<IntegrationAccountSchemaFilter>))
            {
                return operations.ListAsync(resourceGroupName, integrationAccountName, odataQuery).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets a list of integration account schemas.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationAccountName'>
            /// The integration account name.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<IntegrationAccountSchema>> ListAsync(this IIntegrationAccountSchemasOperations operations, string resourceGroupName, string integrationAccountName, ODataQuery<IntegrationAccountSchemaFilter> odataQuery = default(ODataQuery<IntegrationAccountSchemaFilter>), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroupName, integrationAccountName, odataQuery, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets an integration account schema.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationAccountName'>
            /// The integration account name.
            /// </param>
            /// <param name='schemaName'>
            /// The integration account schema name.
            /// </param>
            public static IntegrationAccountSchema Get(this IIntegrationAccountSchemasOperations operations, string resourceGroupName, string integrationAccountName, string schemaName)
            {
                return operations.GetAsync(resourceGroupName, integrationAccountName, schemaName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets an integration account schema.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationAccountName'>
            /// The integration account name.
            /// </param>
            /// <param name='schemaName'>
            /// The integration account schema name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IntegrationAccountSchema> GetAsync(this IIntegrationAccountSchemasOperations operations, string resourceGroupName, string integrationAccountName, string schemaName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, integrationAccountName, schemaName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Creates or updates an integration account schema.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationAccountName'>
            /// The integration account name.
            /// </param>
            /// <param name='schemaName'>
            /// The integration account schema name.
            /// </param>
            /// <param name='schema'>
            /// The integration account schema.
            /// </param>
            public static IntegrationAccountSchema CreateOrUpdate(this IIntegrationAccountSchemasOperations operations, string resourceGroupName, string integrationAccountName, string schemaName, IntegrationAccountSchema schema)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, integrationAccountName, schemaName, schema).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates or updates an integration account schema.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationAccountName'>
            /// The integration account name.
            /// </param>
            /// <param name='schemaName'>
            /// The integration account schema name.
            /// </param>
            /// <param name='schema'>
            /// The integration account schema.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IntegrationAccountSchema> CreateOrUpdateAsync(this IIntegrationAccountSchemasOperations operations, string resourceGroupName, string integrationAccountName, string schemaName, IntegrationAccountSchema schema, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, integrationAccountName, schemaName, schema, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes an integration account schema.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationAccountName'>
            /// The integration account name.
            /// </param>
            /// <param name='schemaName'>
            /// The integration account schema name.
            /// </param>
            public static void Delete(this IIntegrationAccountSchemasOperations operations, string resourceGroupName, string integrationAccountName, string schemaName)
            {
                operations.DeleteAsync(resourceGroupName, integrationAccountName, schemaName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes an integration account schema.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationAccountName'>
            /// The integration account name.
            /// </param>
            /// <param name='schemaName'>
            /// The integration account schema name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IIntegrationAccountSchemasOperations operations, string resourceGroupName, string integrationAccountName, string schemaName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, integrationAccountName, schemaName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Get the content callback url.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationAccountName'>
            /// The integration account name.
            /// </param>
            /// <param name='schemaName'>
            /// The integration account schema name.
            /// </param>
            /// <param name='listContentCallbackUrl'>
            /// </param>
            public static WorkflowTriggerCallbackUrl ListContentCallbackUrl(this IIntegrationAccountSchemasOperations operations, string resourceGroupName, string integrationAccountName, string schemaName, GetCallbackUrlParameters listContentCallbackUrl)
            {
                return operations.ListContentCallbackUrlAsync(resourceGroupName, integrationAccountName, schemaName, listContentCallbackUrl).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get the content callback url.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationAccountName'>
            /// The integration account name.
            /// </param>
            /// <param name='schemaName'>
            /// The integration account schema name.
            /// </param>
            /// <param name='listContentCallbackUrl'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<WorkflowTriggerCallbackUrl> ListContentCallbackUrlAsync(this IIntegrationAccountSchemasOperations operations, string resourceGroupName, string integrationAccountName, string schemaName, GetCallbackUrlParameters listContentCallbackUrl, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListContentCallbackUrlWithHttpMessagesAsync(resourceGroupName, integrationAccountName, schemaName, listContentCallbackUrl, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets a list of integration account schemas.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<IntegrationAccountSchema> ListNext(this IIntegrationAccountSchemasOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets a list of integration account schemas.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<IntegrationAccountSchema>> ListNextAsync(this IIntegrationAccountSchemasOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
