// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Logic
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for IntegrationServiceEnvironmentManagedApisOperations.
    /// </summary>
    public static partial class IntegrationServiceEnvironmentManagedApisOperationsExtensions
    {
            /// <summary>
            /// Gets the integration service environment managed Apis.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            public static IPage<ManagedApi> List(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName)
            {
                return operations.ListAsync(resourceGroup, integrationServiceEnvironmentName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the integration service environment managed Apis.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ManagedApi>> ListAsync(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroup, integrationServiceEnvironmentName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the integration service environment managed Api.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='apiName'>
            /// The api name.
            /// </param>
            public static ManagedApi Get(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, string apiName)
            {
                return operations.GetAsync(resourceGroup, integrationServiceEnvironmentName, apiName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the integration service environment managed Api.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='apiName'>
            /// The api name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ManagedApi> GetAsync(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, string apiName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroup, integrationServiceEnvironmentName, apiName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Puts the integration service environment managed Api.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='apiName'>
            /// The api name.
            /// </param>
            public static ManagedApi Put(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, string apiName)
            {
                return operations.PutAsync(resourceGroup, integrationServiceEnvironmentName, apiName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Puts the integration service environment managed Api.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='apiName'>
            /// The api name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ManagedApi> PutAsync(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, string apiName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.PutWithHttpMessagesAsync(resourceGroup, integrationServiceEnvironmentName, apiName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the integration service environment managed Api.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='apiName'>
            /// The api name.
            /// </param>
            public static void Delete(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, string apiName)
            {
                operations.DeleteAsync(resourceGroup, integrationServiceEnvironmentName, apiName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the integration service environment managed Api.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='apiName'>
            /// The api name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, string apiName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroup, integrationServiceEnvironmentName, apiName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Puts the integration service environment managed Api.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='apiName'>
            /// The api name.
            /// </param>
            public static ManagedApi BeginPut(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, string apiName)
            {
                return operations.BeginPutAsync(resourceGroup, integrationServiceEnvironmentName, apiName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Puts the integration service environment managed Api.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group name.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='apiName'>
            /// The api name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ManagedApi> BeginPutAsync(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, string apiName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginPutWithHttpMessagesAsync(resourceGroup, integrationServiceEnvironmentName, apiName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the integration service environment managed Api.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='apiName'>
            /// The api name.
            /// </param>
            public static void BeginDelete(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, string apiName)
            {
                operations.BeginDeleteAsync(resourceGroup, integrationServiceEnvironmentName, apiName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the integration service environment managed Api.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroup'>
            /// The resource group.
            /// </param>
            /// <param name='integrationServiceEnvironmentName'>
            /// The integration service environment name.
            /// </param>
            /// <param name='apiName'>
            /// The api name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginDeleteAsync(this IIntegrationServiceEnvironmentManagedApisOperations operations, string resourceGroup, string integrationServiceEnvironmentName, string apiName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginDeleteWithHttpMessagesAsync(resourceGroup, integrationServiceEnvironmentName, apiName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Gets the integration service environment managed Apis.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<ManagedApi> ListNext(this IIntegrationServiceEnvironmentManagedApisOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the integration service environment managed Apis.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ManagedApi>> ListNextAsync(this IIntegrationServiceEnvironmentManagedApisOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
