// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Logic.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The extended error info.
    /// </summary>
    public partial class ExtendedErrorInfo
    {
        /// <summary>
        /// Initializes a new instance of the ExtendedErrorInfo class.
        /// </summary>
        public ExtendedErrorInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ExtendedErrorInfo class.
        /// </summary>
        /// <param name="code">The error code. Possible values include:
        /// 'NotSpecified', 'IntegrationServiceEnvironmentNotFound',
        /// 'InternalServerError', 'InvalidOperationId'</param>
        /// <param name="message">The error message.</param>
        /// <param name="details">The error message details.</param>
        /// <param name="innerError">The inner error.</param>
        public ExtendedErrorInfo(string code, string message, IList<ExtendedErrorInfo> details = default(IList<ExtendedErrorInfo>), object innerError = default(object))
        {
            Code = code;
            Message = message;
            Details = details;
            InnerError = innerError;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the error code. Possible values include:
        /// 'NotSpecified', 'IntegrationServiceEnvironmentNotFound',
        /// 'InternalServerError', 'InvalidOperationId'
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; set; }

        /// <summary>
        /// Gets or sets the error message.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

        /// <summary>
        /// Gets or sets the error message details.
        /// </summary>
        [JsonProperty(PropertyName = "details")]
        public IList<ExtendedErrorInfo> Details { get; set; }

        /// <summary>
        /// Gets or sets the inner error.
        /// </summary>
        [JsonProperty(PropertyName = "innerError")]
        public object InnerError { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Code == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Code");
            }
            if (Message == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Message");
            }
            if (Details != null)
            {
                foreach (var element in Details)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
