// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Logic.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The operation result definition.
    /// </summary>
    public partial class OperationResult : OperationResultProperties
    {
        /// <summary>
        /// Initializes a new instance of the OperationResult class.
        /// </summary>
        public OperationResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OperationResult class.
        /// </summary>
        /// <param name="startTime">The start time of the workflow scope
        /// repetition.</param>
        /// <param name="endTime">The end time of the workflow scope
        /// repetition.</param>
        /// <param name="correlation">The correlation properties.</param>
        /// <param name="status">The status of the workflow scope repetition.
        /// Possible values include: 'NotSpecified', 'Paused', 'Running',
        /// 'Waiting', 'Succeeded', 'Skipped', 'Suspended', 'Cancelled',
        /// 'Failed', 'Faulted', 'TimedOut', 'Aborted', 'Ignored'</param>
        /// <param name="code">The workflow scope repetition code.</param>
        /// <param name="trackingId">Gets the tracking id.</param>
        /// <param name="inputs">Gets the inputs.</param>
        /// <param name="inputsLink">Gets the link to inputs.</param>
        /// <param name="outputs">Gets the outputs.</param>
        /// <param name="outputsLink">Gets the link to outputs.</param>
        /// <param name="trackedProperties">Gets the tracked
        /// properties.</param>
        /// <param name="retryHistory">Gets the retry histories.</param>
        public OperationResult(System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), RunActionCorrelation correlation = default(RunActionCorrelation), string status = default(string), string code = default(string), object error = default(object), string trackingId = default(string), object inputs = default(object), ContentLink inputsLink = default(ContentLink), object outputs = default(object), ContentLink outputsLink = default(ContentLink), object trackedProperties = default(object), IList<RetryHistory> retryHistory = default(IList<RetryHistory>), int? iterationCount = default(int?))
            : base(startTime, endTime, correlation, status, code, error)
        {
            TrackingId = trackingId;
            Inputs = inputs;
            InputsLink = inputsLink;
            Outputs = outputs;
            OutputsLink = outputsLink;
            TrackedProperties = trackedProperties;
            RetryHistory = retryHistory;
            IterationCount = iterationCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the tracking id.
        /// </summary>
        [JsonProperty(PropertyName = "trackingId")]
        public string TrackingId { get; private set; }

        /// <summary>
        /// Gets the inputs.
        /// </summary>
        [JsonProperty(PropertyName = "inputs")]
        public object Inputs { get; private set; }

        /// <summary>
        /// Gets the link to inputs.
        /// </summary>
        [JsonProperty(PropertyName = "inputsLink")]
        public ContentLink InputsLink { get; private set; }

        /// <summary>
        /// Gets the outputs.
        /// </summary>
        [JsonProperty(PropertyName = "outputs")]
        public object Outputs { get; private set; }

        /// <summary>
        /// Gets the link to outputs.
        /// </summary>
        [JsonProperty(PropertyName = "outputsLink")]
        public ContentLink OutputsLink { get; private set; }

        /// <summary>
        /// Gets the tracked properties.
        /// </summary>
        [JsonProperty(PropertyName = "trackedProperties")]
        public object TrackedProperties { get; private set; }

        /// <summary>
        /// Gets the retry histories.
        /// </summary>
        [JsonProperty(PropertyName = "retryHistory")]
        public IList<RetryHistory> RetryHistory { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "iterationCount")]
        public int? IterationCount { get; set; }

    }
}
