// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Logic.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The run operation result properties.
    /// </summary>
    public partial class OperationResultProperties
    {
        /// <summary>
        /// Initializes a new instance of the OperationResultProperties class.
        /// </summary>
        public OperationResultProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OperationResultProperties class.
        /// </summary>
        /// <param name="startTime">The start time of the workflow scope
        /// repetition.</param>
        /// <param name="endTime">The end time of the workflow scope
        /// repetition.</param>
        /// <param name="correlation">The correlation properties.</param>
        /// <param name="status">The status of the workflow scope repetition.
        /// Possible values include: 'NotSpecified', 'Paused', 'Running',
        /// 'Waiting', 'Succeeded', 'Skipped', 'Suspended', 'Cancelled',
        /// 'Failed', 'Faulted', 'TimedOut', 'Aborted', 'Ignored'</param>
        /// <param name="code">The workflow scope repetition code.</param>
        public OperationResultProperties(System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), RunActionCorrelation correlation = default(RunActionCorrelation), string status = default(string), string code = default(string), object error = default(object))
        {
            StartTime = startTime;
            EndTime = endTime;
            Correlation = correlation;
            Status = status;
            Code = code;
            Error = error;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the start time of the workflow scope repetition.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; set; }

        /// <summary>
        /// Gets or sets the end time of the workflow scope repetition.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; set; }

        /// <summary>
        /// Gets or sets the correlation properties.
        /// </summary>
        [JsonProperty(PropertyName = "correlation")]
        public RunActionCorrelation Correlation { get; set; }

        /// <summary>
        /// Gets or sets the status of the workflow scope repetition. Possible
        /// values include: 'NotSpecified', 'Paused', 'Running', 'Waiting',
        /// 'Succeeded', 'Skipped', 'Suspended', 'Cancelled', 'Failed',
        /// 'Faulted', 'TimedOut', 'Aborted', 'Ignored'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets the workflow scope repetition code.
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "error")]
        public object Error { get; set; }

    }
}
