// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Logic.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The X12 agreement envelope settings.
    /// </summary>
    public partial class X12EnvelopeSettings
    {
        /// <summary>
        /// Initializes a new instance of the X12EnvelopeSettings class.
        /// </summary>
        public X12EnvelopeSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the X12EnvelopeSettings class.
        /// </summary>
        /// <param name="controlStandardsId">The controls standards id.</param>
        /// <param name="useControlStandardsIdAsRepetitionCharacter">The value
        /// indicating whether to use control standards id as repetition
        /// character.</param>
        /// <param name="senderApplicationId">The sender application
        /// id.</param>
        /// <param name="receiverApplicationId">The receiver application
        /// id.</param>
        /// <param name="controlVersionNumber">The control version
        /// number.</param>
        /// <param name="interchangeControlNumberLowerBound">The interchange
        /// control number lower bound.</param>
        /// <param name="interchangeControlNumberUpperBound">The interchange
        /// control number upper bound.</param>
        /// <param name="rolloverInterchangeControlNumber">The value indicating
        /// whether to rollover interchange control number.</param>
        /// <param name="enableDefaultGroupHeaders">The value indicating
        /// whether to enable default group headers.</param>
        /// <param name="groupControlNumberLowerBound">The group control number
        /// lower bound.</param>
        /// <param name="groupControlNumberUpperBound">The group control number
        /// upper bound.</param>
        /// <param name="rolloverGroupControlNumber">The value indicating
        /// whether to rollover group control number.</param>
        /// <param name="groupHeaderAgencyCode">The group header agency
        /// code.</param>
        /// <param name="groupHeaderVersion">The group header version.</param>
        /// <param name="transactionSetControlNumberLowerBound">The transaction
        /// set control number lower bound.</param>
        /// <param name="transactionSetControlNumberUpperBound">The transaction
        /// set control number upper bound.</param>
        /// <param name="rolloverTransactionSetControlNumber">The value
        /// indicating whether to rollover transaction set control
        /// number.</param>
        /// <param name="overwriteExistingTransactionSetControlNumber">The
        /// value indicating whether to overwrite existing transaction set
        /// control number.</param>
        /// <param name="groupHeaderDateFormat">The group header date format.
        /// Possible values include: 'NotSpecified', 'CCYYMMDD',
        /// 'YYMMDD'</param>
        /// <param name="groupHeaderTimeFormat">The group header time format.
        /// Possible values include: 'NotSpecified', 'HHMM', 'HHMMSS',
        /// 'HHMMSSdd', 'HHMMSSd'</param>
        /// <param name="usageIndicator">The usage indicator. Possible values
        /// include: 'NotSpecified', 'Test', 'Information',
        /// 'Production'</param>
        /// <param name="functionalGroupId">The functional group id.</param>
        /// <param name="transactionSetControlNumberPrefix">The transaction set
        /// control number prefix.</param>
        /// <param name="transactionSetControlNumberSuffix">The transaction set
        /// control number suffix.</param>
        public X12EnvelopeSettings(int controlStandardsId, bool useControlStandardsIdAsRepetitionCharacter, string senderApplicationId, string receiverApplicationId, string controlVersionNumber, int interchangeControlNumberLowerBound, int interchangeControlNumberUpperBound, bool rolloverInterchangeControlNumber, bool enableDefaultGroupHeaders, int groupControlNumberLowerBound, int groupControlNumberUpperBound, bool rolloverGroupControlNumber, string groupHeaderAgencyCode, string groupHeaderVersion, int transactionSetControlNumberLowerBound, int transactionSetControlNumberUpperBound, bool rolloverTransactionSetControlNumber, bool overwriteExistingTransactionSetControlNumber, string groupHeaderDateFormat, string groupHeaderTimeFormat, string usageIndicator, string functionalGroupId = default(string), string transactionSetControlNumberPrefix = default(string), string transactionSetControlNumberSuffix = default(string))
        {
            ControlStandardsId = controlStandardsId;
            UseControlStandardsIdAsRepetitionCharacter = useControlStandardsIdAsRepetitionCharacter;
            SenderApplicationId = senderApplicationId;
            ReceiverApplicationId = receiverApplicationId;
            ControlVersionNumber = controlVersionNumber;
            InterchangeControlNumberLowerBound = interchangeControlNumberLowerBound;
            InterchangeControlNumberUpperBound = interchangeControlNumberUpperBound;
            RolloverInterchangeControlNumber = rolloverInterchangeControlNumber;
            EnableDefaultGroupHeaders = enableDefaultGroupHeaders;
            FunctionalGroupId = functionalGroupId;
            GroupControlNumberLowerBound = groupControlNumberLowerBound;
            GroupControlNumberUpperBound = groupControlNumberUpperBound;
            RolloverGroupControlNumber = rolloverGroupControlNumber;
            GroupHeaderAgencyCode = groupHeaderAgencyCode;
            GroupHeaderVersion = groupHeaderVersion;
            TransactionSetControlNumberLowerBound = transactionSetControlNumberLowerBound;
            TransactionSetControlNumberUpperBound = transactionSetControlNumberUpperBound;
            RolloverTransactionSetControlNumber = rolloverTransactionSetControlNumber;
            TransactionSetControlNumberPrefix = transactionSetControlNumberPrefix;
            TransactionSetControlNumberSuffix = transactionSetControlNumberSuffix;
            OverwriteExistingTransactionSetControlNumber = overwriteExistingTransactionSetControlNumber;
            GroupHeaderDateFormat = groupHeaderDateFormat;
            GroupHeaderTimeFormat = groupHeaderTimeFormat;
            UsageIndicator = usageIndicator;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the controls standards id.
        /// </summary>
        [JsonProperty(PropertyName = "controlStandardsId")]
        public int ControlStandardsId { get; set; }

        /// <summary>
        /// Gets or sets the value indicating whether to use control standards
        /// id as repetition character.
        /// </summary>
        [JsonProperty(PropertyName = "useControlStandardsIdAsRepetitionCharacter")]
        public bool UseControlStandardsIdAsRepetitionCharacter { get; set; }

        /// <summary>
        /// Gets or sets the sender application id.
        /// </summary>
        [JsonProperty(PropertyName = "senderApplicationId")]
        public string SenderApplicationId { get; set; }

        /// <summary>
        /// Gets or sets the receiver application id.
        /// </summary>
        [JsonProperty(PropertyName = "receiverApplicationId")]
        public string ReceiverApplicationId { get; set; }

        /// <summary>
        /// Gets or sets the control version number.
        /// </summary>
        [JsonProperty(PropertyName = "controlVersionNumber")]
        public string ControlVersionNumber { get; set; }

        /// <summary>
        /// Gets or sets the interchange  control number lower bound.
        /// </summary>
        [JsonProperty(PropertyName = "interchangeControlNumberLowerBound")]
        public int InterchangeControlNumberLowerBound { get; set; }

        /// <summary>
        /// Gets or sets the interchange  control number upper bound.
        /// </summary>
        [JsonProperty(PropertyName = "interchangeControlNumberUpperBound")]
        public int InterchangeControlNumberUpperBound { get; set; }

        /// <summary>
        /// Gets or sets the value indicating whether to rollover interchange
        /// control number.
        /// </summary>
        [JsonProperty(PropertyName = "rolloverInterchangeControlNumber")]
        public bool RolloverInterchangeControlNumber { get; set; }

        /// <summary>
        /// Gets or sets the value indicating whether to enable default group
        /// headers.
        /// </summary>
        [JsonProperty(PropertyName = "enableDefaultGroupHeaders")]
        public bool EnableDefaultGroupHeaders { get; set; }

        /// <summary>
        /// Gets or sets the functional group id.
        /// </summary>
        [JsonProperty(PropertyName = "functionalGroupId")]
        public string FunctionalGroupId { get; set; }

        /// <summary>
        /// Gets or sets the group control number lower bound.
        /// </summary>
        [JsonProperty(PropertyName = "groupControlNumberLowerBound")]
        public int GroupControlNumberLowerBound { get; set; }

        /// <summary>
        /// Gets or sets the group control number upper bound.
        /// </summary>
        [JsonProperty(PropertyName = "groupControlNumberUpperBound")]
        public int GroupControlNumberUpperBound { get; set; }

        /// <summary>
        /// Gets or sets the value indicating whether to rollover group control
        /// number.
        /// </summary>
        [JsonProperty(PropertyName = "rolloverGroupControlNumber")]
        public bool RolloverGroupControlNumber { get; set; }

        /// <summary>
        /// Gets or sets the group header agency code.
        /// </summary>
        [JsonProperty(PropertyName = "groupHeaderAgencyCode")]
        public string GroupHeaderAgencyCode { get; set; }

        /// <summary>
        /// Gets or sets the group header version.
        /// </summary>
        [JsonProperty(PropertyName = "groupHeaderVersion")]
        public string GroupHeaderVersion { get; set; }

        /// <summary>
        /// Gets or sets the transaction set control number lower bound.
        /// </summary>
        [JsonProperty(PropertyName = "transactionSetControlNumberLowerBound")]
        public int TransactionSetControlNumberLowerBound { get; set; }

        /// <summary>
        /// Gets or sets the transaction set control number upper bound.
        /// </summary>
        [JsonProperty(PropertyName = "transactionSetControlNumberUpperBound")]
        public int TransactionSetControlNumberUpperBound { get; set; }

        /// <summary>
        /// Gets or sets the value indicating whether to rollover transaction
        /// set control number.
        /// </summary>
        [JsonProperty(PropertyName = "rolloverTransactionSetControlNumber")]
        public bool RolloverTransactionSetControlNumber { get; set; }

        /// <summary>
        /// Gets or sets the transaction set control number prefix.
        /// </summary>
        [JsonProperty(PropertyName = "transactionSetControlNumberPrefix")]
        public string TransactionSetControlNumberPrefix { get; set; }

        /// <summary>
        /// Gets or sets the transaction set control number suffix.
        /// </summary>
        [JsonProperty(PropertyName = "transactionSetControlNumberSuffix")]
        public string TransactionSetControlNumberSuffix { get; set; }

        /// <summary>
        /// Gets or sets the value indicating whether to overwrite existing
        /// transaction set control number.
        /// </summary>
        [JsonProperty(PropertyName = "overwriteExistingTransactionSetControlNumber")]
        public bool OverwriteExistingTransactionSetControlNumber { get; set; }

        /// <summary>
        /// Gets or sets the group header date format. Possible values include:
        /// 'NotSpecified', 'CCYYMMDD', 'YYMMDD'
        /// </summary>
        [JsonProperty(PropertyName = "groupHeaderDateFormat")]
        public string GroupHeaderDateFormat { get; set; }

        /// <summary>
        /// Gets or sets the group header time format. Possible values include:
        /// 'NotSpecified', 'HHMM', 'HHMMSS', 'HHMMSSdd', 'HHMMSSd'
        /// </summary>
        [JsonProperty(PropertyName = "groupHeaderTimeFormat")]
        public string GroupHeaderTimeFormat { get; set; }

        /// <summary>
        /// Gets or sets the usage indicator. Possible values include:
        /// 'NotSpecified', 'Test', 'Information', 'Production'
        /// </summary>
        [JsonProperty(PropertyName = "usageIndicator")]
        public string UsageIndicator { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SenderApplicationId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SenderApplicationId");
            }
            if (ReceiverApplicationId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ReceiverApplicationId");
            }
            if (ControlVersionNumber == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ControlVersionNumber");
            }
            if (GroupHeaderAgencyCode == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "GroupHeaderAgencyCode");
            }
            if (GroupHeaderVersion == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "GroupHeaderVersion");
            }
            if (GroupHeaderDateFormat == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "GroupHeaderDateFormat");
            }
            if (GroupHeaderTimeFormat == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "GroupHeaderTimeFormat");
            }
            if (UsageIndicator == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "UsageIndicator");
            }
        }
    }
}
