// Code generated by Microsoft (R) AutoRest Code Generator 1.0.1.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.MachineLearning;
    using Microsoft.Azure.Management.MachineLearning.WebServices;
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Information about an asset associated with the web service.
    /// </summary>
    public partial class AssetItem
    {
        /// <summary>
        /// Initializes a new instance of the AssetItem class.
        /// </summary>
        public AssetItem()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AssetItem class.
        /// </summary>
        /// <param name="name">Asset's friendly name.</param>
        /// <param name="type">Asset's type. Possible values include: 'Module',
        /// 'Resource'</param>
        /// <param name="locationInfo">Access information for the
        /// asset.</param>
        /// <param name="id">Asset's Id.</param>
        /// <param name="inputPorts">Information about the asset's input
        /// ports.</param>
        /// <param name="outputPorts">Information about the asset's output
        /// ports.</param>
        /// <param name="metadata">If the asset is a custom module, this holds
        /// the module's metadata.</param>
        /// <param name="parameters">If the asset is a custom module, this
        /// holds the module's parameters.</param>
        public AssetItem(string name, string type, BlobLocation locationInfo, string id = default(string), IDictionary<string, InputPort> inputPorts = default(IDictionary<string, InputPort>), IDictionary<string, OutputPort> outputPorts = default(IDictionary<string, OutputPort>), IDictionary<string, string> metadata = default(IDictionary<string, string>), IList<ModuleAssetParameter> parameters = default(IList<ModuleAssetParameter>))
        {
            Name = name;
            Id = id;
            Type = type;
            LocationInfo = locationInfo;
            InputPorts = inputPorts;
            OutputPorts = outputPorts;
            Metadata = metadata;
            Parameters = parameters;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets asset's friendly name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets asset's Id.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets asset's type. Possible values include: 'Module',
        /// 'Resource'
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets access information for the asset.
        /// </summary>
        [JsonProperty(PropertyName = "locationInfo")]
        public BlobLocation LocationInfo { get; set; }

        /// <summary>
        /// Gets or sets information about the asset's input ports.
        /// </summary>
        [JsonProperty(PropertyName = "inputPorts")]
        public IDictionary<string, InputPort> InputPorts { get; set; }

        /// <summary>
        /// Gets or sets information about the asset's output ports.
        /// </summary>
        [JsonProperty(PropertyName = "outputPorts")]
        public IDictionary<string, OutputPort> OutputPorts { get; set; }

        /// <summary>
        /// Gets or sets if the asset is a custom module, this holds the
        /// module's metadata.
        /// </summary>
        [JsonProperty(PropertyName = "metadata")]
        public IDictionary<string, string> Metadata { get; set; }

        /// <summary>
        /// Gets or sets if the asset is a custom module, this holds the
        /// module's parameters.
        /// </summary>
        [JsonProperty(PropertyName = "parameters")]
        public IList<ModuleAssetParameter> Parameters { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (Type == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Type");
            }
            if (LocationInfo == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LocationInfo");
            }
            if (LocationInfo != null)
            {
                LocationInfo.Validate();
            }
        }
    }
}
