// Code generated by Microsoft (R) AutoRest Code Generator 1.0.1.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.MachineLearning;
    using Microsoft.Azure.Management.MachineLearning.WebServices;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Azure async operation status.
    /// </summary>
    public partial class AsyncOperationStatus
    {
        /// <summary>
        /// Initializes a new instance of the AsyncOperationStatus class.
        /// </summary>
        public AsyncOperationStatus()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AsyncOperationStatus class.
        /// </summary>
        /// <param name="id">Async operation id.</param>
        /// <param name="name">Async operation name.</param>
        /// <param name="provisioningState">Read Only: The provisioning state
        /// of the web service. Valid values are Unknown, Provisioning,
        /// Succeeded, and Failed. Possible values include: 'Unknown',
        /// 'Provisioning', 'Succeeded', 'Failed'</param>
        /// <param name="startTime">The date time that the async operation
        /// started.</param>
        /// <param name="endTime">The date time that the async operation
        /// finished.</param>
        /// <param name="percentComplete">Async operation progress.</param>
        /// <param name="errorInfo">If the async operation fails, this
        /// structure contains the error details.</param>
        public AsyncOperationStatus(string id = default(string), string name = default(string), string provisioningState = default(string), System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), double? percentComplete = default(double?), AsyncOperationErrorInfo errorInfo = default(AsyncOperationErrorInfo))
        {
            Id = id;
            Name = name;
            ProvisioningState = provisioningState;
            StartTime = startTime;
            EndTime = endTime;
            PercentComplete = percentComplete;
            ErrorInfo = errorInfo;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets async operation id.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets async operation name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets read Only: The provisioning state of the web service. Valid
        /// values are Unknown, Provisioning, Succeeded, and Failed. Possible
        /// values include: 'Unknown', 'Provisioning', 'Succeeded', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets the date time that the async operation started.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; private set; }

        /// <summary>
        /// Gets the date time that the async operation finished.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; private set; }

        /// <summary>
        /// Gets or sets async operation progress.
        /// </summary>
        [JsonProperty(PropertyName = "percentComplete")]
        public double? PercentComplete { get; set; }

        /// <summary>
        /// Gets or sets if the async operation fails, this structure contains
        /// the error details.
        /// </summary>
        [JsonProperty(PropertyName = "errorInfo")]
        public AsyncOperationErrorInfo ErrorInfo { get; set; }

    }
}
