// Code generated by Microsoft (R) AutoRest Code Generator 1.0.1.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.MachineLearning;
    using Microsoft.Azure.Management.MachineLearning.WebServices;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Specifies a node in the web service graph. The node can either be an
    /// input, output or asset node, so only one of the corresponding id
    /// properties is populated at any given time.
    /// </summary>
    public partial class GraphNode
    {
        /// <summary>
        /// Initializes a new instance of the GraphNode class.
        /// </summary>
        public GraphNode()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GraphNode class.
        /// </summary>
        /// <param name="assetId">The id of the asset represented by this
        /// node.</param>
        /// <param name="inputId">The id of the input element represented by
        /// this node.</param>
        /// <param name="outputId">The id of the output element represented by
        /// this node.</param>
        /// <param name="parameters">If applicable, parameters of the node.
        /// Global graph parameters map into these, with values set at
        /// runtime.</param>
        public GraphNode(string assetId = default(string), string inputId = default(string), string outputId = default(string), IDictionary<string, WebServiceParameter> parameters = default(IDictionary<string, WebServiceParameter>))
        {
            AssetId = assetId;
            InputId = inputId;
            OutputId = outputId;
            Parameters = parameters;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the id of the asset represented by this node.
        /// </summary>
        [JsonProperty(PropertyName = "assetId")]
        public string AssetId { get; set; }

        /// <summary>
        /// Gets or sets the id of the input element represented by this node.
        /// </summary>
        [JsonProperty(PropertyName = "inputId")]
        public string InputId { get; set; }

        /// <summary>
        /// Gets or sets the id of the output element represented by this node.
        /// </summary>
        [JsonProperty(PropertyName = "outputId")]
        public string OutputId { get; set; }

        /// <summary>
        /// Gets or sets if applicable, parameters of the node. Global graph
        /// parameters map into these, with values set at runtime.
        /// </summary>
        [JsonProperty(PropertyName = "parameters")]
        public IDictionary<string, WebServiceParameter> Parameters { get; set; }

    }
}
