// Code generated by Microsoft (R) AutoRest Code Generator 1.0.1.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.MachineLearning;
    using Microsoft.Azure.Management.MachineLearning.WebServices;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Defines the graph of modules making up the machine learning solution.
    /// </summary>
    public partial class GraphPackage
    {
        /// <summary>
        /// Initializes a new instance of the GraphPackage class.
        /// </summary>
        public GraphPackage()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GraphPackage class.
        /// </summary>
        /// <param name="nodes">The set of nodes making up the graph, provided
        /// as a nodeId to GraphNode map</param>
        /// <param name="edges">The list of edges making up the graph.</param>
        /// <param name="graphParameters">The collection of global parameters
        /// for the graph, given as a global parameter name to GraphParameter
        /// map. Each parameter here has a 1:1 match with the global parameters
        /// values map declared at the WebServiceProperties level.</param>
        public GraphPackage(IDictionary<string, GraphNode> nodes = default(IDictionary<string, GraphNode>), IList<GraphEdge> edges = default(IList<GraphEdge>), IDictionary<string, GraphParameter> graphParameters = default(IDictionary<string, GraphParameter>))
        {
            Nodes = nodes;
            Edges = edges;
            GraphParameters = graphParameters;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the set of nodes making up the graph, provided as a
        /// nodeId to GraphNode map
        /// </summary>
        [JsonProperty(PropertyName = "nodes")]
        public IDictionary<string, GraphNode> Nodes { get; set; }

        /// <summary>
        /// Gets or sets the list of edges making up the graph.
        /// </summary>
        [JsonProperty(PropertyName = "edges")]
        public IList<GraphEdge> Edges { get; set; }

        /// <summary>
        /// Gets or sets the collection of global parameters for the graph,
        /// given as a global parameter name to GraphParameter map. Each
        /// parameter here has a 1:1 match with the global parameters values
        /// map declared at the WebServiceProperties level.
        /// </summary>
        [JsonProperty(PropertyName = "graphParameters")]
        public IDictionary<string, GraphParameter> GraphParameters { get; set; }

    }
}
