// Code generated by Microsoft (R) AutoRest Code Generator 1.0.1.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.MachineLearning;
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for WebServicesOperations.
    /// </summary>
    public static partial class WebServicesOperationsExtensions
    {
            /// <summary>
            /// Create or update a web service. This call will overwrite an existing web
            /// service. Note that there is no warning or confirmation. This is a
            /// nonrecoverable operation. If your intent is to create a new web service,
            /// call the Get operation first to verify that it does not exist.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='createOrUpdatePayload'>
            /// The payload that is used to create or update the web service.
            /// </param>
            public static WebService CreateOrUpdate(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, WebService createOrUpdatePayload)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, webServiceName, createOrUpdatePayload).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or update a web service. This call will overwrite an existing web
            /// service. Note that there is no warning or confirmation. This is a
            /// nonrecoverable operation. If your intent is to create a new web service,
            /// call the Get operation first to verify that it does not exist.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='createOrUpdatePayload'>
            /// The payload that is used to create or update the web service.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<WebService> CreateOrUpdateAsync(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, WebService createOrUpdatePayload, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, webServiceName, createOrUpdatePayload, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the Web Service Definition as specified by a subscription, resource
            /// group, and name. Note that the storage credentials and web service keys are
            /// not returned by this call. To get the web service access keys, call List
            /// Keys.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='region'>
            /// The region for which encrypted credential parameters are valid.
            /// </param>
            public static WebService Get(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, string region = default(string))
            {
                return operations.GetAsync(resourceGroupName, webServiceName, region).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the Web Service Definition as specified by a subscription, resource
            /// group, and name. Note that the storage credentials and web service keys are
            /// not returned by this call. To get the web service access keys, call List
            /// Keys.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='region'>
            /// The region for which encrypted credential parameters are valid.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<WebService> GetAsync(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, string region = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, webServiceName, region, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Modifies an existing web service resource. The PATCH API call is an
            /// asynchronous operation. To determine whether it has completed successfully,
            /// you must perform a Get operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='patchPayload'>
            /// The payload to use to patch the web service.
            /// </param>
            public static WebService Patch(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, WebService patchPayload)
            {
                return operations.PatchAsync(resourceGroupName, webServiceName, patchPayload).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Modifies an existing web service resource. The PATCH API call is an
            /// asynchronous operation. To determine whether it has completed successfully,
            /// you must perform a Get operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='patchPayload'>
            /// The payload to use to patch the web service.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<WebService> PatchAsync(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, WebService patchPayload, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.PatchWithHttpMessagesAsync(resourceGroupName, webServiceName, patchPayload, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the specified web service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            public static void Remove(this IWebServicesOperations operations, string resourceGroupName, string webServiceName)
            {
                operations.RemoveAsync(resourceGroupName, webServiceName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the specified web service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task RemoveAsync(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.RemoveWithHttpMessagesAsync(resourceGroupName, webServiceName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Creates an encrypted credentials parameter blob for the specified region.
            /// To get the web service from a region other than the region in which it has
            /// been created, you must first call Create Regional Web Services Properties
            /// to create a copy of the encrypted credential parameter blob in that region.
            /// You only need to do this before the first time that you get the web service
            /// in the new region.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='region'>
            /// The region for which encrypted credential parameters are created.
            /// </param>
            public static AsyncOperationStatus CreateRegionalProperties(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, string region)
            {
                return operations.CreateRegionalPropertiesAsync(resourceGroupName, webServiceName, region).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates an encrypted credentials parameter blob for the specified region.
            /// To get the web service from a region other than the region in which it has
            /// been created, you must first call Create Regional Web Services Properties
            /// to create a copy of the encrypted credential parameter blob in that region.
            /// You only need to do this before the first time that you get the web service
            /// in the new region.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='region'>
            /// The region for which encrypted credential parameters are created.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AsyncOperationStatus> CreateRegionalPropertiesAsync(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, string region, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateRegionalPropertiesWithHttpMessagesAsync(resourceGroupName, webServiceName, region, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the access keys for the specified web service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            public static WebServiceKeys ListKeys(this IWebServicesOperations operations, string resourceGroupName, string webServiceName)
            {
                return operations.ListKeysAsync(resourceGroupName, webServiceName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the access keys for the specified web service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<WebServiceKeys> ListKeysAsync(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListKeysWithHttpMessagesAsync(resourceGroupName, webServiceName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the web services in the specified resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='skiptoken'>
            /// Continuation token for pagination.
            /// </param>
            public static IPage<WebService> ListByResourceGroup(this IWebServicesOperations operations, string resourceGroupName, string skiptoken = default(string))
            {
                return operations.ListByResourceGroupAsync(resourceGroupName, skiptoken).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the web services in the specified resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='skiptoken'>
            /// Continuation token for pagination.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<WebService>> ListByResourceGroupAsync(this IWebServicesOperations operations, string resourceGroupName, string skiptoken = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByResourceGroupWithHttpMessagesAsync(resourceGroupName, skiptoken, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the web services in the specified subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='skiptoken'>
            /// Continuation token for pagination.
            /// </param>
            public static IPage<WebService> ListBySubscriptionId(this IWebServicesOperations operations, string skiptoken = default(string))
            {
                return operations.ListBySubscriptionIdAsync(skiptoken).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the web services in the specified subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='skiptoken'>
            /// Continuation token for pagination.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<WebService>> ListBySubscriptionIdAsync(this IWebServicesOperations operations, string skiptoken = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListBySubscriptionIdWithHttpMessagesAsync(skiptoken, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Create or update a web service. This call will overwrite an existing web
            /// service. Note that there is no warning or confirmation. This is a
            /// nonrecoverable operation. If your intent is to create a new web service,
            /// call the Get operation first to verify that it does not exist.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='createOrUpdatePayload'>
            /// The payload that is used to create or update the web service.
            /// </param>
            public static WebService BeginCreateOrUpdate(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, WebService createOrUpdatePayload)
            {
                return operations.BeginCreateOrUpdateAsync(resourceGroupName, webServiceName, createOrUpdatePayload).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or update a web service. This call will overwrite an existing web
            /// service. Note that there is no warning or confirmation. This is a
            /// nonrecoverable operation. If your intent is to create a new web service,
            /// call the Get operation first to verify that it does not exist.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='createOrUpdatePayload'>
            /// The payload that is used to create or update the web service.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<WebService> BeginCreateOrUpdateAsync(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, WebService createOrUpdatePayload, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateOrUpdateWithHttpMessagesAsync(resourceGroupName, webServiceName, createOrUpdatePayload, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Modifies an existing web service resource. The PATCH API call is an
            /// asynchronous operation. To determine whether it has completed successfully,
            /// you must perform a Get operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='patchPayload'>
            /// The payload to use to patch the web service.
            /// </param>
            public static WebService BeginPatch(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, WebService patchPayload)
            {
                return operations.BeginPatchAsync(resourceGroupName, webServiceName, patchPayload).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Modifies an existing web service resource. The PATCH API call is an
            /// asynchronous operation. To determine whether it has completed successfully,
            /// you must perform a Get operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='patchPayload'>
            /// The payload to use to patch the web service.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<WebService> BeginPatchAsync(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, WebService patchPayload, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginPatchWithHttpMessagesAsync(resourceGroupName, webServiceName, patchPayload, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the specified web service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            public static void BeginRemove(this IWebServicesOperations operations, string resourceGroupName, string webServiceName)
            {
                operations.BeginRemoveAsync(resourceGroupName, webServiceName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the specified web service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginRemoveAsync(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginRemoveWithHttpMessagesAsync(resourceGroupName, webServiceName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Creates an encrypted credentials parameter blob for the specified region.
            /// To get the web service from a region other than the region in which it has
            /// been created, you must first call Create Regional Web Services Properties
            /// to create a copy of the encrypted credential parameter blob in that region.
            /// You only need to do this before the first time that you get the web service
            /// in the new region.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='region'>
            /// The region for which encrypted credential parameters are created.
            /// </param>
            public static AsyncOperationStatus BeginCreateRegionalProperties(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, string region)
            {
                return operations.BeginCreateRegionalPropertiesAsync(resourceGroupName, webServiceName, region).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates an encrypted credentials parameter blob for the specified region.
            /// To get the web service from a region other than the region in which it has
            /// been created, you must first call Create Regional Web Services Properties
            /// to create a copy of the encrypted credential parameter blob in that region.
            /// You only need to do this before the first time that you get the web service
            /// in the new region.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of the resource group in which the web service is located.
            /// </param>
            /// <param name='webServiceName'>
            /// The name of the web service.
            /// </param>
            /// <param name='region'>
            /// The region for which encrypted credential parameters are created.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AsyncOperationStatus> BeginCreateRegionalPropertiesAsync(this IWebServicesOperations operations, string resourceGroupName, string webServiceName, string region, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateRegionalPropertiesWithHttpMessagesAsync(resourceGroupName, webServiceName, region, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the web services in the specified resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<WebService> ListByResourceGroupNext(this IWebServicesOperations operations, string nextPageLink)
            {
                return operations.ListByResourceGroupNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the web services in the specified resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<WebService>> ListByResourceGroupNextAsync(this IWebServicesOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByResourceGroupNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the web services in the specified subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<WebService> ListBySubscriptionIdNext(this IWebServicesOperations operations, string nextPageLink)
            {
                return operations.ListBySubscriptionIdNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the web services in the specified subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<WebService>> ListBySubscriptionIdNextAsync(this IWebServicesOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListBySubscriptionIdNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
