// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.MachineLearningCompute.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Information about the Azure Container Registry which contains the
    /// images deployed to the cluster.
    /// </summary>
    public partial class ContainerRegistryCredentials
    {
        /// <summary>
        /// Initializes a new instance of the ContainerRegistryCredentials
        /// class.
        /// </summary>
        public ContainerRegistryCredentials()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ContainerRegistryCredentials
        /// class.
        /// </summary>
        /// <param name="loginServer">The ACR login server name. User name is
        /// the first part of the FQDN.</param>
        /// <param name="password">The ACR primary password.</param>
        /// <param name="password2">The ACR secondary password.</param>
        /// <param name="username">The ACR login username.</param>
        public ContainerRegistryCredentials(string loginServer = default(string), string password = default(string), string password2 = default(string), string username = default(string))
        {
            LoginServer = loginServer;
            Password = password;
            Password2 = password2;
            Username = username;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the ACR login server name. User name is the first part of the
        /// FQDN.
        /// </summary>
        [JsonProperty(PropertyName = "loginServer")]
        public string LoginServer { get; private set; }

        /// <summary>
        /// Gets the ACR primary password.
        /// </summary>
        [JsonProperty(PropertyName = "password")]
        public string Password { get; private set; }

        /// <summary>
        /// Gets the ACR secondary password.
        /// </summary>
        [JsonProperty(PropertyName = "password2")]
        public string Password2 { get; private set; }

        /// <summary>
        /// Gets the ACR login username.
        /// </summary>
        [JsonProperty(PropertyName = "username")]
        public string Username { get; private set; }

    }
}
