// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.MachineLearningCompute.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Information about the Azure Container Registry which contains the
    /// images deployed to the cluster.
    /// </summary>
    public partial class ContainerServiceCredentials
    {
        /// <summary>
        /// Initializes a new instance of the ContainerServiceCredentials
        /// class.
        /// </summary>
        public ContainerServiceCredentials()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ContainerServiceCredentials
        /// class.
        /// </summary>
        /// <param name="acsKubeConfig">The ACS kube config file.</param>
        /// <param name="servicePrincipalConfiguration">Service principal
        /// configuration used by Kubernetes.</param>
        /// <param name="imagePullSecretName">The ACR image pull secret name
        /// which was created in Kubernetes.</param>
        public ContainerServiceCredentials(string acsKubeConfig = default(string), ServicePrincipalProperties servicePrincipalConfiguration = default(ServicePrincipalProperties), string imagePullSecretName = default(string))
        {
            AcsKubeConfig = acsKubeConfig;
            ServicePrincipalConfiguration = servicePrincipalConfiguration;
            ImagePullSecretName = imagePullSecretName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the ACS kube config file.
        /// </summary>
        [JsonProperty(PropertyName = "acsKubeConfig")]
        public string AcsKubeConfig { get; private set; }

        /// <summary>
        /// Gets service principal configuration used by Kubernetes.
        /// </summary>
        [JsonProperty(PropertyName = "servicePrincipalConfiguration")]
        public ServicePrincipalProperties ServicePrincipalConfiguration { get; private set; }

        /// <summary>
        /// Gets the ACR image pull secret name which was created in
        /// Kubernetes.
        /// </summary>
        [JsonProperty(PropertyName = "imagePullSecretName")]
        public string ImagePullSecretName { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ServicePrincipalConfiguration != null)
            {
                ServicePrincipalConfiguration.Validate();
            }
        }
    }
}
