// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.MachineLearningCompute.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Global configuration for services in the cluster.
    /// </summary>
    public partial class GlobalServiceConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the GlobalServiceConfiguration class.
        /// </summary>
        public GlobalServiceConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GlobalServiceConfiguration class.
        /// </summary>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="etag">The configuration ETag for updates.</param>
        /// <param name="ssl">The SSL configuration properties</param>
        /// <param name="serviceAuth">Optional global authorization keys for
        /// all user services deployed in cluster. These are used if the
        /// service does not have auth keys.</param>
        /// <param name="autoScale">The auto-scale configuration</param>
        public GlobalServiceConfiguration(IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), string etag = default(string), SslConfiguration ssl = default(SslConfiguration), ServiceAuthConfiguration serviceAuth = default(ServiceAuthConfiguration), AutoScaleConfiguration autoScale = default(AutoScaleConfiguration))
        {
            AdditionalProperties = additionalProperties;
            Etag = etag;
            Ssl = ssl;
            ServiceAuth = serviceAuth;
            AutoScale = autoScale;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets unmatched properties from the message are deserialized
        /// this collection
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalProperties { get; set; }

        /// <summary>
        /// Gets or sets the configuration ETag for updates.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

        /// <summary>
        /// Gets or sets the SSL configuration properties
        /// </summary>
        [JsonProperty(PropertyName = "ssl")]
        public SslConfiguration Ssl { get; set; }

        /// <summary>
        /// Gets or sets optional global authorization keys for all user
        /// services deployed in cluster. These are used if the service does
        /// not have auth keys.
        /// </summary>
        [JsonProperty(PropertyName = "serviceAuth")]
        public ServiceAuthConfiguration ServiceAuth { get; set; }

        /// <summary>
        /// Gets or sets the auto-scale configuration
        /// </summary>
        [JsonProperty(PropertyName = "autoScale")]
        public AutoScaleConfiguration AutoScale { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ServiceAuth != null)
            {
                ServiceAuth.Validate();
            }
            if (AutoScale != null)
            {
                AutoScale.Validate();
            }
        }
    }
}
