// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.MachineLearningCompute.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Global service auth configuration properties. These are the data-plane
    /// authorization keys and are used if a service doesn't define it's own.
    /// </summary>
    public partial class ServiceAuthConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the ServiceAuthConfiguration class.
        /// </summary>
        public ServiceAuthConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServiceAuthConfiguration class.
        /// </summary>
        /// <param name="primaryAuthKeyHash">The primary auth key hash. This is
        /// not returned in response of GET/PUT on the resource.. To see this
        /// please call listKeys API.</param>
        /// <param name="secondaryAuthKeyHash">The secondary auth key hash.
        /// This is not returned in response of GET/PUT on the resource.. To
        /// see this please call listKeys API.</param>
        public ServiceAuthConfiguration(string primaryAuthKeyHash, string secondaryAuthKeyHash)
        {
            PrimaryAuthKeyHash = primaryAuthKeyHash;
            SecondaryAuthKeyHash = secondaryAuthKeyHash;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the primary auth key hash. This is not returned in
        /// response of GET/PUT on the resource.. To see this please call
        /// listKeys API.
        /// </summary>
        [JsonProperty(PropertyName = "primaryAuthKeyHash")]
        public string PrimaryAuthKeyHash { get; set; }

        /// <summary>
        /// Gets or sets the secondary auth key hash. This is not returned in
        /// response of GET/PUT on the resource.. To see this please call
        /// listKeys API.
        /// </summary>
        [JsonProperty(PropertyName = "secondaryAuthKeyHash")]
        public string SecondaryAuthKeyHash { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (PrimaryAuthKeyHash == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PrimaryAuthKeyHash");
            }
            if (SecondaryAuthKeyHash == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SecondaryAuthKeyHash");
            }
        }
    }
}
