// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Maintenance
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ApplyUpdatesOperations.
    /// </summary>
    public static partial class ApplyUpdatesOperationsExtensions
    {
            /// <summary>
            /// Track Updates to resource with parent
            /// </summary>
            /// <remarks>
            /// Track maintenance updates to resource with parent
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name
            /// </param>
            /// <param name='resourceParentType'>
            /// Resource parent type
            /// </param>
            /// <param name='resourceParentName'>
            /// Resource parent identifier
            /// </param>
            /// <param name='providerName'>
            /// Resource provider name
            /// </param>
            /// <param name='resourceType'>
            /// Resource type
            /// </param>
            /// <param name='resourceName'>
            /// Resource identifier
            /// </param>
            /// <param name='applyUpdateName'>
            /// applyUpdate Id
            /// </param>
            public static ApplyUpdate GetParent(this IApplyUpdatesOperations operations, string resourceGroupName, string resourceParentType, string resourceParentName, string providerName, string resourceType, string resourceName, string applyUpdateName)
            {
                return operations.GetParentAsync(resourceGroupName, resourceParentType, resourceParentName, providerName, resourceType, resourceName, applyUpdateName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Track Updates to resource with parent
            /// </summary>
            /// <remarks>
            /// Track maintenance updates to resource with parent
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name
            /// </param>
            /// <param name='resourceParentType'>
            /// Resource parent type
            /// </param>
            /// <param name='resourceParentName'>
            /// Resource parent identifier
            /// </param>
            /// <param name='providerName'>
            /// Resource provider name
            /// </param>
            /// <param name='resourceType'>
            /// Resource type
            /// </param>
            /// <param name='resourceName'>
            /// Resource identifier
            /// </param>
            /// <param name='applyUpdateName'>
            /// applyUpdate Id
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ApplyUpdate> GetParentAsync(this IApplyUpdatesOperations operations, string resourceGroupName, string resourceParentType, string resourceParentName, string providerName, string resourceType, string resourceName, string applyUpdateName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetParentWithHttpMessagesAsync(resourceGroupName, resourceParentType, resourceParentName, providerName, resourceType, resourceName, applyUpdateName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Track Updates to resource
            /// </summary>
            /// <remarks>
            /// Track maintenance updates to resource
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name
            /// </param>
            /// <param name='providerName'>
            /// Resource provider name
            /// </param>
            /// <param name='resourceType'>
            /// Resource type
            /// </param>
            /// <param name='resourceName'>
            /// Resource identifier
            /// </param>
            /// <param name='applyUpdateName'>
            /// applyUpdate Id
            /// </param>
            public static ApplyUpdate Get(this IApplyUpdatesOperations operations, string resourceGroupName, string providerName, string resourceType, string resourceName, string applyUpdateName)
            {
                return operations.GetAsync(resourceGroupName, providerName, resourceType, resourceName, applyUpdateName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Track Updates to resource
            /// </summary>
            /// <remarks>
            /// Track maintenance updates to resource
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name
            /// </param>
            /// <param name='providerName'>
            /// Resource provider name
            /// </param>
            /// <param name='resourceType'>
            /// Resource type
            /// </param>
            /// <param name='resourceName'>
            /// Resource identifier
            /// </param>
            /// <param name='applyUpdateName'>
            /// applyUpdate Id
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ApplyUpdate> GetAsync(this IApplyUpdatesOperations operations, string resourceGroupName, string providerName, string resourceType, string resourceName, string applyUpdateName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, providerName, resourceType, resourceName, applyUpdateName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Apply Updates to resource with parent
            /// </summary>
            /// <remarks>
            /// Apply maintenance updates to resource with parent
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name
            /// </param>
            /// <param name='providerName'>
            /// Resource provider name
            /// </param>
            /// <param name='resourceParentType'>
            /// Resource parent type
            /// </param>
            /// <param name='resourceParentName'>
            /// Resource parent identifier
            /// </param>
            /// <param name='resourceType'>
            /// Resource type
            /// </param>
            /// <param name='resourceName'>
            /// Resource identifier
            /// </param>
            public static ApplyUpdate CreateOrUpdateParent(this IApplyUpdatesOperations operations, string resourceGroupName, string providerName, string resourceParentType, string resourceParentName, string resourceType, string resourceName)
            {
                return operations.CreateOrUpdateParentAsync(resourceGroupName, providerName, resourceParentType, resourceParentName, resourceType, resourceName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Apply Updates to resource with parent
            /// </summary>
            /// <remarks>
            /// Apply maintenance updates to resource with parent
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name
            /// </param>
            /// <param name='providerName'>
            /// Resource provider name
            /// </param>
            /// <param name='resourceParentType'>
            /// Resource parent type
            /// </param>
            /// <param name='resourceParentName'>
            /// Resource parent identifier
            /// </param>
            /// <param name='resourceType'>
            /// Resource type
            /// </param>
            /// <param name='resourceName'>
            /// Resource identifier
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ApplyUpdate> CreateOrUpdateParentAsync(this IApplyUpdatesOperations operations, string resourceGroupName, string providerName, string resourceParentType, string resourceParentName, string resourceType, string resourceName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateParentWithHttpMessagesAsync(resourceGroupName, providerName, resourceParentType, resourceParentName, resourceType, resourceName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Apply Updates to resource
            /// </summary>
            /// <remarks>
            /// Apply maintenance updates to resource
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name
            /// </param>
            /// <param name='providerName'>
            /// Resource provider name
            /// </param>
            /// <param name='resourceType'>
            /// Resource type
            /// </param>
            /// <param name='resourceName'>
            /// Resource identifier
            /// </param>
            public static ApplyUpdate CreateOrUpdate(this IApplyUpdatesOperations operations, string resourceGroupName, string providerName, string resourceType, string resourceName)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, providerName, resourceType, resourceName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Apply Updates to resource
            /// </summary>
            /// <remarks>
            /// Apply maintenance updates to resource
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Resource group name
            /// </param>
            /// <param name='providerName'>
            /// Resource provider name
            /// </param>
            /// <param name='resourceType'>
            /// Resource type
            /// </param>
            /// <param name='resourceName'>
            /// Resource identifier
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ApplyUpdate> CreateOrUpdateAsync(this IApplyUpdatesOperations operations, string resourceGroupName, string providerName, string resourceType, string resourceName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, providerName, resourceType, resourceName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
