// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ManagedNetwork
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// ManagedNetworkPeeringPoliciesOperations operations.
    /// </summary>
    public partial interface IManagedNetworkPeeringPoliciesOperations
    {
        /// <summary>
        /// The Get ManagedNetworkPeeringPolicies operation gets a Managed
        /// Network Peering Policy resource, specified by the  resource group,
        /// Managed Network name, and peering policy name
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The name of the resource group.
        /// </param>
        /// <param name='managedNetworkName'>
        /// The name of the Managed Network.
        /// </param>
        /// <param name='managedNetworkPeeringPolicyName'>
        /// The name of the Managed Network Peering Policy.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="ErrorResponseException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<ManagedNetworkPeeringPolicy>> GetWithHttpMessagesAsync(string resourceGroupName, string managedNetworkName, string managedNetworkPeeringPolicyName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// The Put ManagedNetworkPeeringPolicies operation creates/updates a
        /// new Managed Network Peering Policy
        /// </summary>
        /// <param name='managedNetworkPolicy'>
        /// Parameters supplied to create/update a Managed Network Peering
        /// Policy
        /// </param>
        /// <param name='resourceGroupName'>
        /// The name of the resource group.
        /// </param>
        /// <param name='managedNetworkName'>
        /// The name of the Managed Network.
        /// </param>
        /// <param name='managedNetworkPeeringPolicyName'>
        /// The name of the Managed Network Peering Policy.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="ErrorResponseException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<ManagedNetworkPeeringPolicy>> CreateOrUpdateWithHttpMessagesAsync(ManagedNetworkPeeringPolicy managedNetworkPolicy, string resourceGroupName, string managedNetworkName, string managedNetworkPeeringPolicyName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// The Delete ManagedNetworkPeeringPolicies operation deletes a
        /// Managed Network Peering Policy, specified by the  resource group,
        /// Managed Network name, and peering policy name
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The name of the resource group.
        /// </param>
        /// <param name='managedNetworkName'>
        /// The name of the Managed Network.
        /// </param>
        /// <param name='managedNetworkPeeringPolicyName'>
        /// The name of the Managed Network Peering Policy.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="ErrorResponseException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse> DeleteWithHttpMessagesAsync(string resourceGroupName, string managedNetworkName, string managedNetworkPeeringPolicyName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// The ListByManagedNetwork PeeringPolicies operation retrieves all
        /// the Managed Network Peering Policies in a specified Managed
        /// Network, in a paginated format.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The name of the resource group.
        /// </param>
        /// <param name='managedNetworkName'>
        /// The name of the Managed Network.
        /// </param>
        /// <param name='top'>
        /// May be used to limit the number of results in a page for list
        /// queries.
        /// </param>
        /// <param name='skiptoken'>
        /// Skiptoken is only used if a previous operation returned a partial
        /// result. If a previous response contains a nextLink element, the
        /// value of the nextLink element will include a skiptoken parameter
        /// that specifies a starting point to use for subsequent calls.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="ErrorResponseException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<IPage<ManagedNetworkPeeringPolicy>>> ListByManagedNetworkWithHttpMessagesAsync(string resourceGroupName, string managedNetworkName, int? top = default(int?), string skiptoken = default(string), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// The Put ManagedNetworkPeeringPolicies operation creates/updates a
        /// new Managed Network Peering Policy
        /// </summary>
        /// <param name='managedNetworkPolicy'>
        /// Parameters supplied to create/update a Managed Network Peering
        /// Policy
        /// </param>
        /// <param name='resourceGroupName'>
        /// The name of the resource group.
        /// </param>
        /// <param name='managedNetworkName'>
        /// The name of the Managed Network.
        /// </param>
        /// <param name='managedNetworkPeeringPolicyName'>
        /// The name of the Managed Network Peering Policy.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="ErrorResponseException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<ManagedNetworkPeeringPolicy>> BeginCreateOrUpdateWithHttpMessagesAsync(ManagedNetworkPeeringPolicy managedNetworkPolicy, string resourceGroupName, string managedNetworkName, string managedNetworkPeeringPolicyName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// The Delete ManagedNetworkPeeringPolicies operation deletes a
        /// Managed Network Peering Policy, specified by the  resource group,
        /// Managed Network name, and peering policy name
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The name of the resource group.
        /// </param>
        /// <param name='managedNetworkName'>
        /// The name of the Managed Network.
        /// </param>
        /// <param name='managedNetworkPeeringPolicyName'>
        /// The name of the Managed Network Peering Policy.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="ErrorResponseException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse> BeginDeleteWithHttpMessagesAsync(string resourceGroupName, string managedNetworkName, string managedNetworkPeeringPolicyName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// The ListByManagedNetwork PeeringPolicies operation retrieves all
        /// the Managed Network Peering Policies in a specified Managed
        /// Network, in a paginated format.
        /// </summary>
        /// <param name='nextPageLink'>
        /// The NextLink from the previous successful call to List operation.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="ErrorResponseException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<IPage<ManagedNetworkPeeringPolicy>>> ListByManagedNetworkNextWithHttpMessagesAsync(string nextPageLink, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
    }
}
