// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ManagedNetwork.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Scope of a Managed Network
    /// </summary>
    public partial class Scope
    {
        /// <summary>
        /// Initializes a new instance of the Scope class.
        /// </summary>
        public Scope()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Scope class.
        /// </summary>
        /// <param name="managementGroups">The collection of management groups
        /// covered by the Managed Network</param>
        /// <param name="subscriptions">The collection of subscriptions covered
        /// by the Managed Network</param>
        /// <param name="virtualNetworks">The collection of virtual nets
        /// covered by the Managed Network</param>
        /// <param name="subnets">The collection of  subnets covered by the
        /// Managed Network</param>
        public Scope(IList<ResourceId> managementGroups = default(IList<ResourceId>), IList<ResourceId> subscriptions = default(IList<ResourceId>), IList<ResourceId> virtualNetworks = default(IList<ResourceId>), IList<ResourceId> subnets = default(IList<ResourceId>))
        {
            ManagementGroups = managementGroups;
            Subscriptions = subscriptions;
            VirtualNetworks = virtualNetworks;
            Subnets = subnets;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the collection of management groups covered by the
        /// Managed Network
        /// </summary>
        [JsonProperty(PropertyName = "managementGroups")]
        public IList<ResourceId> ManagementGroups { get; set; }

        /// <summary>
        /// Gets or sets the collection of subscriptions covered by the Managed
        /// Network
        /// </summary>
        [JsonProperty(PropertyName = "subscriptions")]
        public IList<ResourceId> Subscriptions { get; set; }

        /// <summary>
        /// Gets or sets the collection of virtual nets covered by the Managed
        /// Network
        /// </summary>
        [JsonProperty(PropertyName = "virtualNetworks")]
        public IList<ResourceId> VirtualNetworks { get; set; }

        /// <summary>
        /// Gets or sets the collection of  subnets covered by the Managed
        /// Network
        /// </summary>
        [JsonProperty(PropertyName = "subnets")]
        public IList<ResourceId> Subnets { get; set; }

    }
}
