// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ManagedServices.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Registration definition.
    /// </summary>
    public partial class RegistrationDefinition : IResource
    {
        /// <summary>
        /// Initializes a new instance of the RegistrationDefinition class.
        /// </summary>
        public RegistrationDefinition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RegistrationDefinition class.
        /// </summary>
        /// <param name="properties">Properties of a registration
        /// definition.</param>
        /// <param name="plan">Plan details for the managed services.</param>
        /// <param name="id">Fully qualified path of the registration
        /// definition.</param>
        /// <param name="type">Type of the resource.</param>
        /// <param name="name">Name of the registration definition.</param>
        public RegistrationDefinition(RegistrationDefinitionProperties properties = default(RegistrationDefinitionProperties), Plan plan = default(Plan), string id = default(string), string type = default(string), string name = default(string))
        {
            Properties = properties;
            Plan = plan;
            Id = id;
            Type = type;
            Name = name;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets properties of a registration definition.
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public RegistrationDefinitionProperties Properties { get; set; }

        /// <summary>
        /// Gets or sets plan details for the managed services.
        /// </summary>
        [JsonProperty(PropertyName = "plan")]
        public Plan Plan { get; set; }

        /// <summary>
        /// Gets fully qualified path of the registration definition.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets type of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

        /// <summary>
        /// Gets name of the registration definition.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Properties != null)
            {
                Properties.Validate();
            }
            if (Plan != null)
            {
                Plan.Validate();
            }
        }
    }
}
