// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ManagedServices
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for RegistrationAssignmentsOperations.
    /// </summary>
    public static partial class RegistrationAssignmentsOperationsExtensions
    {
            /// <summary>
            /// Gets the details of specified registration assignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='registrationAssignmentId'>
            /// Guid of the registration assignment.
            /// </param>
            /// <param name='expandRegistrationDefinition'>
            /// Tells whether to return registration definition details also along with
            /// registration assignment details.
            /// </param>
            public static RegistrationAssignment Get(this IRegistrationAssignmentsOperations operations, string scope, string registrationAssignmentId, bool? expandRegistrationDefinition = default(bool?))
            {
                return operations.GetAsync(scope, registrationAssignmentId, expandRegistrationDefinition).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the details of specified registration assignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='registrationAssignmentId'>
            /// Guid of the registration assignment.
            /// </param>
            /// <param name='expandRegistrationDefinition'>
            /// Tells whether to return registration definition details also along with
            /// registration assignment details.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<RegistrationAssignment> GetAsync(this IRegistrationAssignmentsOperations operations, string scope, string registrationAssignmentId, bool? expandRegistrationDefinition = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(scope, registrationAssignmentId, expandRegistrationDefinition, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the specified registration assignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='registrationAssignmentId'>
            /// Guid of the registration assignment.
            /// </param>
            public static void Delete(this IRegistrationAssignmentsOperations operations, string scope, string registrationAssignmentId)
            {
                operations.DeleteAsync(scope, registrationAssignmentId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the specified registration assignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='registrationAssignmentId'>
            /// Guid of the registration assignment.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IRegistrationAssignmentsOperations operations, string scope, string registrationAssignmentId, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(scope, registrationAssignmentId, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Creates or updates a registration assignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='registrationAssignmentId'>
            /// Guid of the registration assignment.
            /// </param>
            /// <param name='requestBody'>
            /// The parameters required to create new registration assignment.
            /// </param>
            public static RegistrationAssignment CreateOrUpdate(this IRegistrationAssignmentsOperations operations, string scope, string registrationAssignmentId, RegistrationAssignment requestBody)
            {
                return operations.CreateOrUpdateAsync(scope, registrationAssignmentId, requestBody).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates or updates a registration assignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='registrationAssignmentId'>
            /// Guid of the registration assignment.
            /// </param>
            /// <param name='requestBody'>
            /// The parameters required to create new registration assignment.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<RegistrationAssignment> CreateOrUpdateAsync(this IRegistrationAssignmentsOperations operations, string scope, string registrationAssignmentId, RegistrationAssignment requestBody, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(scope, registrationAssignmentId, requestBody, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets a list of the registration assignments.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='expandRegistrationDefinition'>
            /// Tells whether to return registration definition details also along with
            /// registration assignment details.
            /// </param>
            public static IPage<RegistrationAssignment> List(this IRegistrationAssignmentsOperations operations, string scope, bool? expandRegistrationDefinition = default(bool?))
            {
                return operations.ListAsync(scope, expandRegistrationDefinition).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets a list of the registration assignments.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='expandRegistrationDefinition'>
            /// Tells whether to return registration definition details also along with
            /// registration assignment details.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<RegistrationAssignment>> ListAsync(this IRegistrationAssignmentsOperations operations, string scope, bool? expandRegistrationDefinition = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(scope, expandRegistrationDefinition, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes the specified registration assignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='registrationAssignmentId'>
            /// Guid of the registration assignment.
            /// </param>
            public static void BeginDelete(this IRegistrationAssignmentsOperations operations, string scope, string registrationAssignmentId)
            {
                operations.BeginDeleteAsync(scope, registrationAssignmentId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes the specified registration assignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='registrationAssignmentId'>
            /// Guid of the registration assignment.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginDeleteAsync(this IRegistrationAssignmentsOperations operations, string scope, string registrationAssignmentId, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginDeleteWithHttpMessagesAsync(scope, registrationAssignmentId, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Creates or updates a registration assignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='registrationAssignmentId'>
            /// Guid of the registration assignment.
            /// </param>
            /// <param name='requestBody'>
            /// The parameters required to create new registration assignment.
            /// </param>
            public static RegistrationAssignment BeginCreateOrUpdate(this IRegistrationAssignmentsOperations operations, string scope, string registrationAssignmentId, RegistrationAssignment requestBody)
            {
                return operations.BeginCreateOrUpdateAsync(scope, registrationAssignmentId, requestBody).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates or updates a registration assignment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='scope'>
            /// Scope of the resource.
            /// </param>
            /// <param name='registrationAssignmentId'>
            /// Guid of the registration assignment.
            /// </param>
            /// <param name='requestBody'>
            /// The parameters required to create new registration assignment.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<RegistrationAssignment> BeginCreateOrUpdateAsync(this IRegistrationAssignmentsOperations operations, string scope, string registrationAssignmentId, RegistrationAssignment requestBody, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateOrUpdateWithHttpMessagesAsync(scope, registrationAssignmentId, requestBody, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets a list of the registration assignments.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<RegistrationAssignment> ListNext(this IRegistrationAssignmentsOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets a list of the registration assignments.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<RegistrationAssignment>> ListNextAsync(this IRegistrationAssignmentsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
