// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ManagementGroups
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ManagementGroupsAPIClient.
    /// </summary>
    public static partial class ManagementGroupsAPIClientExtensions
    {
            /// <summary>
            /// Checks if the specified management group name is valid and unique
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='checkNameAvailabilityRequest'>
            /// Management group name availability check parameters.
            /// </param>
            public static CheckNameAvailabilityResult CheckNameAvailability(this IManagementGroupsAPIClient operations, CheckNameAvailabilityRequest checkNameAvailabilityRequest)
            {
                return operations.CheckNameAvailabilityAsync(checkNameAvailabilityRequest).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Checks if the specified management group name is valid and unique
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='checkNameAvailabilityRequest'>
            /// Management group name availability check parameters.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<CheckNameAvailabilityResult> CheckNameAvailabilityAsync(this IManagementGroupsAPIClient operations, CheckNameAvailabilityRequest checkNameAvailabilityRequest, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CheckNameAvailabilityWithHttpMessagesAsync(checkNameAvailabilityRequest, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Starts backfilling subscriptions for the Tenant.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static TenantBackfillStatusResult StartTenantBackfill(this IManagementGroupsAPIClient operations)
            {
                return operations.StartTenantBackfillAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Starts backfilling subscriptions for the Tenant.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<TenantBackfillStatusResult> StartTenantBackfillAsync(this IManagementGroupsAPIClient operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartTenantBackfillWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets tenant backfill status
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static TenantBackfillStatusResult TenantBackfillStatus(this IManagementGroupsAPIClient operations)
            {
                return operations.TenantBackfillStatusAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets tenant backfill status
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<TenantBackfillStatusResult> TenantBackfillStatusAsync(this IManagementGroupsAPIClient operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.TenantBackfillStatusWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
