// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Maps
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for AccountsOperations.
    /// </summary>
    public static partial class AccountsOperationsExtensions
    {
            /// <summary>
            /// Create or update a Maps Account. A Maps Account holds the keys which allow
            /// access to the Maps REST APIs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            /// <param name='mapsAccountCreateParameters'>
            /// The new or updated parameters for the Maps Account.
            /// </param>
            public static MapsAccount CreateOrUpdate(this IAccountsOperations operations, string resourceGroupName, string accountName, MapsAccountCreateParameters mapsAccountCreateParameters)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, accountName, mapsAccountCreateParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or update a Maps Account. A Maps Account holds the keys which allow
            /// access to the Maps REST APIs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            /// <param name='mapsAccountCreateParameters'>
            /// The new or updated parameters for the Maps Account.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<MapsAccount> CreateOrUpdateAsync(this IAccountsOperations operations, string resourceGroupName, string accountName, MapsAccountCreateParameters mapsAccountCreateParameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, accountName, mapsAccountCreateParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Updates a Maps Account. Only a subset of the parameters may be updated
            /// after creation, such as Sku and Tags.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            /// <param name='mapsAccountUpdateParameters'>
            /// The updated parameters for the Maps Account.
            /// </param>
            public static MapsAccount Update(this IAccountsOperations operations, string resourceGroupName, string accountName, MapsAccountUpdateParameters mapsAccountUpdateParameters)
            {
                return operations.UpdateAsync(resourceGroupName, accountName, mapsAccountUpdateParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates a Maps Account. Only a subset of the parameters may be updated
            /// after creation, such as Sku and Tags.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            /// <param name='mapsAccountUpdateParameters'>
            /// The updated parameters for the Maps Account.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<MapsAccount> UpdateAsync(this IAccountsOperations operations, string resourceGroupName, string accountName, MapsAccountUpdateParameters mapsAccountUpdateParameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(resourceGroupName, accountName, mapsAccountUpdateParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete a Maps Account.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            public static void Delete(this IAccountsOperations operations, string resourceGroupName, string accountName)
            {
                operations.DeleteAsync(resourceGroupName, accountName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete a Maps Account.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IAccountsOperations operations, string resourceGroupName, string accountName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, accountName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Get a Maps Account.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            public static MapsAccount Get(this IAccountsOperations operations, string resourceGroupName, string accountName)
            {
                return operations.GetAsync(resourceGroupName, accountName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a Maps Account.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<MapsAccount> GetAsync(this IAccountsOperations operations, string resourceGroupName, string accountName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, accountName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get all Maps Accounts in a Resource Group
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            public static IEnumerable<MapsAccount> ListByResourceGroup(this IAccountsOperations operations, string resourceGroupName)
            {
                return operations.ListByResourceGroupAsync(resourceGroupName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get all Maps Accounts in a Resource Group
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IEnumerable<MapsAccount>> ListByResourceGroupAsync(this IAccountsOperations operations, string resourceGroupName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByResourceGroupWithHttpMessagesAsync(resourceGroupName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get all Maps Accounts in a Subscription
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static IEnumerable<MapsAccount> ListBySubscription(this IAccountsOperations operations)
            {
                return operations.ListBySubscriptionAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get all Maps Accounts in a Subscription
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IEnumerable<MapsAccount>> ListBySubscriptionAsync(this IAccountsOperations operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListBySubscriptionWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Moves Maps Accounts from one ResourceGroup (or Subscription) to another
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group that contains Maps Account to move.
            /// </param>
            /// <param name='moveRequest'>
            /// The details of the Maps Account move.
            /// </param>
            public static void Move(this IAccountsOperations operations, string resourceGroupName, MapsAccountsMoveRequest moveRequest)
            {
                operations.MoveAsync(resourceGroupName, moveRequest).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Moves Maps Accounts from one ResourceGroup (or Subscription) to another
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group that contains Maps Account to move.
            /// </param>
            /// <param name='moveRequest'>
            /// The details of the Maps Account move.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task MoveAsync(this IAccountsOperations operations, string resourceGroupName, MapsAccountsMoveRequest moveRequest, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.MoveWithHttpMessagesAsync(resourceGroupName, moveRequest, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Get the keys to use with the Maps APIs. A key is used to authenticate and
            /// authorize access to the Maps REST APIs. Only one key is needed at a time;
            /// two are given to provide seamless key regeneration.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            public static MapsAccountKeys ListKeys(this IAccountsOperations operations, string resourceGroupName, string accountName)
            {
                return operations.ListKeysAsync(resourceGroupName, accountName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get the keys to use with the Maps APIs. A key is used to authenticate and
            /// authorize access to the Maps REST APIs. Only one key is needed at a time;
            /// two are given to provide seamless key regeneration.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<MapsAccountKeys> ListKeysAsync(this IAccountsOperations operations, string resourceGroupName, string accountName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListKeysWithHttpMessagesAsync(resourceGroupName, accountName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Regenerate either the primary or secondary key for use with the Maps APIs.
            /// The old key will stop working immediately.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            /// <param name='keySpecification'>
            /// Which key to regenerate:  primary or secondary.
            /// </param>
            public static MapsAccountKeys RegenerateKeys(this IAccountsOperations operations, string resourceGroupName, string accountName, MapsKeySpecification keySpecification)
            {
                return operations.RegenerateKeysAsync(resourceGroupName, accountName, keySpecification).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Regenerate either the primary or secondary key for use with the Maps APIs.
            /// The old key will stop working immediately.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the Azure Resource Group.
            /// </param>
            /// <param name='accountName'>
            /// The name of the Maps Account.
            /// </param>
            /// <param name='keySpecification'>
            /// Which key to regenerate:  primary or secondary.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<MapsAccountKeys> RegenerateKeysAsync(this IAccountsOperations operations, string resourceGroupName, string accountName, MapsKeySpecification keySpecification, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.RegenerateKeysWithHttpMessagesAsync(resourceGroupName, accountName, keySpecification, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// List operations available for the Maps Resource Provider
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static IEnumerable<MapsOperationsValueItem> ListOperations(this IAccountsOperations operations)
            {
                return operations.ListOperationsAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// List operations available for the Maps Resource Provider
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IEnumerable<MapsOperationsValueItem>> ListOperationsAsync(this IAccountsOperations operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListOperationsWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
