// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for AccountFiltersOperations.
    /// </summary>
    public static partial class AccountFiltersOperationsExtensions
    {
            /// <summary>
            /// List Account Filters
            /// </summary>
            /// <remarks>
            /// List Account Filters in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            public static IPage<AccountFilter> List(this IAccountFiltersOperations operations, string resourceGroupName, string accountName)
            {
                return operations.ListAsync(resourceGroupName, accountName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List Account Filters
            /// </summary>
            /// <remarks>
            /// List Account Filters in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<AccountFilter>> ListAsync(this IAccountFiltersOperations operations, string resourceGroupName, string accountName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroupName, accountName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get an Account Filter.
            /// </summary>
            /// <remarks>
            /// Get the details of an Account Filter in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='filterName'>
            /// The Account Filter name
            /// </param>
            public static AccountFilter Get(this IAccountFiltersOperations operations, string resourceGroupName, string accountName, string filterName)
            {
                return operations.GetAsync(resourceGroupName, accountName, filterName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get an Account Filter.
            /// </summary>
            /// <remarks>
            /// Get the details of an Account Filter in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='filterName'>
            /// The Account Filter name
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AccountFilter> GetAsync(this IAccountFiltersOperations operations, string resourceGroupName, string accountName, string filterName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, accountName, filterName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Create or update an Account Filter
            /// </summary>
            /// <remarks>
            /// Creates or updates an Account Filter in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='filterName'>
            /// The Account Filter name
            /// </param>
            /// <param name='parameters'>
            /// The request parameters
            /// </param>
            public static AccountFilter CreateOrUpdate(this IAccountFiltersOperations operations, string resourceGroupName, string accountName, string filterName, AccountFilter parameters)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, accountName, filterName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or update an Account Filter
            /// </summary>
            /// <remarks>
            /// Creates or updates an Account Filter in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='filterName'>
            /// The Account Filter name
            /// </param>
            /// <param name='parameters'>
            /// The request parameters
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AccountFilter> CreateOrUpdateAsync(this IAccountFiltersOperations operations, string resourceGroupName, string accountName, string filterName, AccountFilter parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, accountName, filterName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete an Account Filter.
            /// </summary>
            /// <remarks>
            /// Deletes an Account Filter in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='filterName'>
            /// The Account Filter name
            /// </param>
            public static void Delete(this IAccountFiltersOperations operations, string resourceGroupName, string accountName, string filterName)
            {
                operations.DeleteAsync(resourceGroupName, accountName, filterName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete an Account Filter.
            /// </summary>
            /// <remarks>
            /// Deletes an Account Filter in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='filterName'>
            /// The Account Filter name
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IAccountFiltersOperations operations, string resourceGroupName, string accountName, string filterName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, accountName, filterName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Update an Account Filter
            /// </summary>
            /// <remarks>
            /// Updates an existing Account Filter in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='filterName'>
            /// The Account Filter name
            /// </param>
            /// <param name='parameters'>
            /// The request parameters
            /// </param>
            public static AccountFilter Update(this IAccountFiltersOperations operations, string resourceGroupName, string accountName, string filterName, AccountFilter parameters)
            {
                return operations.UpdateAsync(resourceGroupName, accountName, filterName, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Update an Account Filter
            /// </summary>
            /// <remarks>
            /// Updates an existing Account Filter in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='filterName'>
            /// The Account Filter name
            /// </param>
            /// <param name='parameters'>
            /// The request parameters
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AccountFilter> UpdateAsync(this IAccountFiltersOperations operations, string resourceGroupName, string accountName, string filterName, AccountFilter parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(resourceGroupName, accountName, filterName, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// List Account Filters
            /// </summary>
            /// <remarks>
            /// List Account Filters in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<AccountFilter> ListNext(this IAccountFiltersOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List Account Filters
            /// </summary>
            /// <remarks>
            /// List Account Filters in the Media Services account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<AccountFilter>> ListNextAsync(this IAccountFiltersOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
