// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// </summary>
    public partial interface IAzureMediaServicesClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// The unique identifier for a Microsoft Azure subscription.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// The Version of the API to be used with the client request.
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IAccountFiltersOperations.
        /// </summary>
        IAccountFiltersOperations AccountFilters { get; }

        /// <summary>
        /// Gets the IOperations.
        /// </summary>
        IOperations Operations { get; }

        /// <summary>
        /// Gets the IMediaservicesOperations.
        /// </summary>
        IMediaservicesOperations Mediaservices { get; }

        /// <summary>
        /// Gets the ILocationsOperations.
        /// </summary>
        ILocationsOperations Locations { get; }

        /// <summary>
        /// Gets the IAssetsOperations.
        /// </summary>
        IAssetsOperations Assets { get; }

        /// <summary>
        /// Gets the IAssetFiltersOperations.
        /// </summary>
        IAssetFiltersOperations AssetFilters { get; }

        /// <summary>
        /// Gets the IContentKeyPoliciesOperations.
        /// </summary>
        IContentKeyPoliciesOperations ContentKeyPolicies { get; }

        /// <summary>
        /// Gets the ITransformsOperations.
        /// </summary>
        ITransformsOperations Transforms { get; }

        /// <summary>
        /// Gets the IJobsOperations.
        /// </summary>
        IJobsOperations Jobs { get; }

        /// <summary>
        /// Gets the IStreamingPoliciesOperations.
        /// </summary>
        IStreamingPoliciesOperations StreamingPolicies { get; }

        /// <summary>
        /// Gets the IStreamingLocatorsOperations.
        /// </summary>
        IStreamingLocatorsOperations StreamingLocators { get; }

        /// <summary>
        /// Gets the ILiveEventsOperations.
        /// </summary>
        ILiveEventsOperations LiveEvents { get; }

        /// <summary>
        /// Gets the ILiveOutputsOperations.
        /// </summary>
        ILiveOutputsOperations LiveOutputs { get; }

        /// <summary>
        /// Gets the IStreamingEndpointsOperations.
        /// </summary>
        IStreamingEndpointsOperations StreamingEndpoints { get; }

    }
}
