// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;

    /// <summary>
    /// Defines values for AssetContainerPermission.
    /// </summary>
    /// <summary>
    /// Determine base value for a given allowed value if exists, else return
    /// the value itself
    /// </summary>
    [JsonConverter(typeof(AssetContainerPermissionConverter))]
    public struct AssetContainerPermission : System.IEquatable<AssetContainerPermission>
    {
        private AssetContainerPermission(string underlyingValue)
        {
            UnderlyingValue=underlyingValue;
        }

        /// <summary>
        /// The SAS URL will allow read access to the container.
        /// </summary>
        public static readonly AssetContainerPermission Read = "Read";

        /// <summary>
        /// The SAS URL will allow read and write access to the container.
        /// </summary>
        public static readonly AssetContainerPermission ReadWrite = "ReadWrite";

        /// <summary>
        /// The SAS URL will allow read, write and delete access to the
        /// container.
        /// </summary>
        public static readonly AssetContainerPermission ReadWriteDelete = "ReadWriteDelete";


        /// <summary>
        /// Underlying value of enum AssetContainerPermission
        /// </summary>
        private readonly string UnderlyingValue;

        /// <summary>
        /// Returns string representation for AssetContainerPermission
        /// </summary>
        public override string ToString()
        {
            return UnderlyingValue == null ? null : UnderlyingValue.ToString();
        }

        /// <summary>
        /// Compares enums of type AssetContainerPermission
        /// </summary>
        public bool Equals(AssetContainerPermission e)
        {
            return UnderlyingValue.Equals(e.UnderlyingValue);
        }

        /// <summary>
        /// Implicit operator to convert string to AssetContainerPermission
        /// </summary>
        public static implicit operator AssetContainerPermission(string value)
        {
            return new AssetContainerPermission(value);
        }

        /// <summary>
        /// Implicit operator to convert AssetContainerPermission to string
        /// </summary>
        public static implicit operator string(AssetContainerPermission e)
        {
            return e.UnderlyingValue;
        }

        /// <summary>
        /// Overriding == operator for enum AssetContainerPermission
        /// </summary>
        public static bool operator == (AssetContainerPermission e1, AssetContainerPermission e2)
        {
            return e2.Equals(e1);
        }

        /// <summary>
        /// Overriding != operator for enum AssetContainerPermission
        /// </summary>
        public static bool operator != (AssetContainerPermission e1, AssetContainerPermission e2)
        {
            return !e2.Equals(e1);
        }

        /// <summary>
        /// Overrides Equals operator for AssetContainerPermission
        /// </summary>
        public override bool Equals(object obj)
        {
            return obj is AssetContainerPermission && Equals((AssetContainerPermission)obj);
        }

        /// <summary>
        /// Returns for hashCode AssetContainerPermission
        /// </summary>
        public override int GetHashCode()
        {
            return UnderlyingValue.GetHashCode();
        }

    }
}
