// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;

    /// <summary>
    /// Defines values for AssetStorageEncryptionFormat.
    /// </summary>
    /// <summary>
    /// Determine base value for a given allowed value if exists, else return
    /// the value itself
    /// </summary>
    [JsonConverter(typeof(AssetStorageEncryptionFormatConverter))]
    public struct AssetStorageEncryptionFormat : System.IEquatable<AssetStorageEncryptionFormat>
    {
        private AssetStorageEncryptionFormat(string underlyingValue)
        {
            UnderlyingValue=underlyingValue;
        }

        /// <summary>
        /// The Asset does not use client-side storage encryption (this is the
        /// only allowed value for new Assets).
        /// </summary>
        public static readonly AssetStorageEncryptionFormat None = "None";

        /// <summary>
        /// The Asset is encrypted with Media Services client-side encryption.
        /// </summary>
        public static readonly AssetStorageEncryptionFormat MediaStorageClientEncryption = "MediaStorageClientEncryption";


        /// <summary>
        /// Underlying value of enum AssetStorageEncryptionFormat
        /// </summary>
        private readonly string UnderlyingValue;

        /// <summary>
        /// Returns string representation for AssetStorageEncryptionFormat
        /// </summary>
        public override string ToString()
        {
            return UnderlyingValue == null ? null : UnderlyingValue.ToString();
        }

        /// <summary>
        /// Compares enums of type AssetStorageEncryptionFormat
        /// </summary>
        public bool Equals(AssetStorageEncryptionFormat e)
        {
            return UnderlyingValue.Equals(e.UnderlyingValue);
        }

        /// <summary>
        /// Implicit operator to convert string to AssetStorageEncryptionFormat
        /// </summary>
        public static implicit operator AssetStorageEncryptionFormat(string value)
        {
            return new AssetStorageEncryptionFormat(value);
        }

        /// <summary>
        /// Implicit operator to convert AssetStorageEncryptionFormat to string
        /// </summary>
        public static implicit operator string(AssetStorageEncryptionFormat e)
        {
            return e.UnderlyingValue;
        }

        /// <summary>
        /// Overriding == operator for enum AssetStorageEncryptionFormat
        /// </summary>
        public static bool operator == (AssetStorageEncryptionFormat e1, AssetStorageEncryptionFormat e2)
        {
            return e2.Equals(e1);
        }

        /// <summary>
        /// Overriding != operator for enum AssetStorageEncryptionFormat
        /// </summary>
        public static bool operator != (AssetStorageEncryptionFormat e1, AssetStorageEncryptionFormat e2)
        {
            return !e2.Equals(e1);
        }

        /// <summary>
        /// Overrides Equals operator for AssetStorageEncryptionFormat
        /// </summary>
        public override bool Equals(object obj)
        {
            return obj is AssetStorageEncryptionFormat && Equals((AssetStorageEncryptionFormat)obj);
        }

        /// <summary>
        /// Returns for hashCode AssetStorageEncryptionFormat
        /// </summary>
        public override int GetHashCode()
        {
            return UnderlyingValue.GetHashCode();
        }

    }
}
