// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Class to specify DRM configurations of CommonEncryptionCbcs scheme in
    /// Streaming Policy
    /// </summary>
    public partial class CbcsDrmConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the CbcsDrmConfiguration class.
        /// </summary>
        public CbcsDrmConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CbcsDrmConfiguration class.
        /// </summary>
        /// <param name="fairPlay">FairPlay configurations</param>
        /// <param name="playReady">PlayReady configurations</param>
        /// <param name="widevine">Widevine configurations</param>
        public CbcsDrmConfiguration(StreamingPolicyFairPlayConfiguration fairPlay = default(StreamingPolicyFairPlayConfiguration), StreamingPolicyPlayReadyConfiguration playReady = default(StreamingPolicyPlayReadyConfiguration), StreamingPolicyWidevineConfiguration widevine = default(StreamingPolicyWidevineConfiguration))
        {
            FairPlay = fairPlay;
            PlayReady = playReady;
            Widevine = widevine;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets fairPlay configurations
        /// </summary>
        [JsonProperty(PropertyName = "fairPlay")]
        public StreamingPolicyFairPlayConfiguration FairPlay { get; set; }

        /// <summary>
        /// Gets or sets playReady configurations
        /// </summary>
        [JsonProperty(PropertyName = "playReady")]
        public StreamingPolicyPlayReadyConfiguration PlayReady { get; set; }

        /// <summary>
        /// Gets or sets widevine configurations
        /// </summary>
        [JsonProperty(PropertyName = "widevine")]
        public StreamingPolicyWidevineConfiguration Widevine { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (FairPlay != null)
            {
                FairPlay.Validate();
            }
        }
    }
}
