// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;

    /// <summary>
    /// Defines values for DeinterlaceMode.
    /// </summary>
    /// <summary>
    /// Determine base value for a given allowed value if exists, else return
    /// the value itself
    /// </summary>
    [JsonConverter(typeof(DeinterlaceModeConverter))]
    public struct DeinterlaceMode : System.IEquatable<DeinterlaceMode>
    {
        private DeinterlaceMode(string underlyingValue)
        {
            UnderlyingValue=underlyingValue;
        }

        /// <summary>
        /// Disables de-interlacing of the source video.
        /// </summary>
        public static readonly DeinterlaceMode Off = "Off";

        /// <summary>
        /// Apply automatic pixel adaptive de-interlacing on each frame in the
        /// input video.
        /// </summary>
        public static readonly DeinterlaceMode AutoPixelAdaptive = "AutoPixelAdaptive";


        /// <summary>
        /// Underlying value of enum DeinterlaceMode
        /// </summary>
        private readonly string UnderlyingValue;

        /// <summary>
        /// Returns string representation for DeinterlaceMode
        /// </summary>
        public override string ToString()
        {
            return UnderlyingValue == null ? null : UnderlyingValue.ToString();
        }

        /// <summary>
        /// Compares enums of type DeinterlaceMode
        /// </summary>
        public bool Equals(DeinterlaceMode e)
        {
            return UnderlyingValue.Equals(e.UnderlyingValue);
        }

        /// <summary>
        /// Implicit operator to convert string to DeinterlaceMode
        /// </summary>
        public static implicit operator DeinterlaceMode(string value)
        {
            return new DeinterlaceMode(value);
        }

        /// <summary>
        /// Implicit operator to convert DeinterlaceMode to string
        /// </summary>
        public static implicit operator string(DeinterlaceMode e)
        {
            return e.UnderlyingValue;
        }

        /// <summary>
        /// Overriding == operator for enum DeinterlaceMode
        /// </summary>
        public static bool operator == (DeinterlaceMode e1, DeinterlaceMode e2)
        {
            return e2.Equals(e1);
        }

        /// <summary>
        /// Overriding != operator for enum DeinterlaceMode
        /// </summary>
        public static bool operator != (DeinterlaceMode e1, DeinterlaceMode e2)
        {
            return !e2.Equals(e1);
        }

        /// <summary>
        /// Overrides Equals operator for DeinterlaceMode
        /// </summary>
        public override bool Equals(object obj)
        {
            return obj is DeinterlaceMode && Equals((DeinterlaceMode)obj);
        }

        /// <summary>
        /// Returns for hashCode DeinterlaceMode
        /// </summary>
        public override int GetHashCode()
        {
            return UnderlyingValue.GetHashCode();
        }

    }
}
