// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Class to specify which protocols are enabled
    /// </summary>
    public partial class EnabledProtocols
    {
        /// <summary>
        /// Initializes a new instance of the EnabledProtocols class.
        /// </summary>
        public EnabledProtocols()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EnabledProtocols class.
        /// </summary>
        /// <param name="download">Enable Download protocol or not</param>
        /// <param name="dash">Enable DASH protocol or not</param>
        /// <param name="hls">Enable HLS protocol or not</param>
        /// <param name="smoothStreaming">Enable SmoothStreaming protocol or
        /// not</param>
        public EnabledProtocols(bool download, bool dash, bool hls, bool smoothStreaming)
        {
            Download = download;
            Dash = dash;
            Hls = hls;
            SmoothStreaming = smoothStreaming;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets enable Download protocol or not
        /// </summary>
        [JsonProperty(PropertyName = "download")]
        public bool Download { get; set; }

        /// <summary>
        /// Gets or sets enable DASH protocol or not
        /// </summary>
        [JsonProperty(PropertyName = "dash")]
        public bool Dash { get; set; }

        /// <summary>
        /// Gets or sets enable HLS protocol or not
        /// </summary>
        [JsonProperty(PropertyName = "hls")]
        public bool Hls { get; set; }

        /// <summary>
        /// Gets or sets enable SmoothStreaming protocol or not
        /// </summary>
        [JsonProperty(PropertyName = "smoothStreaming")]
        public bool SmoothStreaming { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
