// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A metric emitted by service.
    /// </summary>
    public partial class Metric
    {
        /// <summary>
        /// Initializes a new instance of the Metric class.
        /// </summary>
        public Metric()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Metric class.
        /// </summary>
        /// <param name="name">The metric name.</param>
        /// <param name="displayName">The metric display name.</param>
        /// <param name="displayDescription">The metric display
        /// description.</param>
        /// <param name="unit">The metric unit. Possible values include:
        /// 'Bytes', 'Count', 'Milliseconds'</param>
        /// <param name="aggregationType">The metric aggregation type. Possible
        /// values include: 'Average', 'Count', 'Total'</param>
        /// <param name="dimensions">The metric dimensions.</param>
        public Metric(string name = default(string), string displayName = default(string), string displayDescription = default(string), MetricUnit unit = default(MetricUnit), MetricAggregationType aggregationType = default(MetricAggregationType), IList<MetricDimension> dimensions = default(IList<MetricDimension>))
        {
            Name = name;
            DisplayName = displayName;
            DisplayDescription = displayDescription;
            Unit = unit;
            AggregationType = aggregationType;
            Dimensions = dimensions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the metric name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets the metric display name.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; private set; }

        /// <summary>
        /// Gets the metric display description.
        /// </summary>
        [JsonProperty(PropertyName = "displayDescription")]
        public string DisplayDescription { get; private set; }

        /// <summary>
        /// Gets the metric unit. Possible values include: 'Bytes', 'Count',
        /// 'Milliseconds'
        /// </summary>
        [JsonProperty(PropertyName = "unit")]
        public MetricUnit Unit { get; private set; }

        /// <summary>
        /// Gets the metric aggregation type. Possible values include:
        /// 'Average', 'Count', 'Total'
        /// </summary>
        [JsonProperty(PropertyName = "aggregationType")]
        public MetricAggregationType AggregationType { get; private set; }

        /// <summary>
        /// Gets the metric dimensions.
        /// </summary>
        [JsonProperty(PropertyName = "dimensions")]
        public IList<MetricDimension> Dimensions { get; private set; }

    }
}
