// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;

    /// <summary>
    /// Defines values for OnErrorType.
    /// </summary>
    /// <summary>
    /// Determine base value for a given allowed value if exists, else return
    /// the value itself
    /// </summary>
    [JsonConverter(typeof(OnErrorTypeConverter))]
    public struct OnErrorType : System.IEquatable<OnErrorType>
    {
        private OnErrorType(string underlyingValue)
        {
            UnderlyingValue=underlyingValue;
        }

        /// <summary>
        /// Tells the service that if this TransformOutput fails, then any
        /// other incomplete TransformOutputs can be stopped.
        /// </summary>
        public static readonly OnErrorType StopProcessingJob = "StopProcessingJob";

        /// <summary>
        /// Tells the service that if this TransformOutput fails, then allow
        /// any other TransformOutput to continue.
        /// </summary>
        public static readonly OnErrorType ContinueJob = "ContinueJob";


        /// <summary>
        /// Underlying value of enum OnErrorType
        /// </summary>
        private readonly string UnderlyingValue;

        /// <summary>
        /// Returns string representation for OnErrorType
        /// </summary>
        public override string ToString()
        {
            return UnderlyingValue == null ? null : UnderlyingValue.ToString();
        }

        /// <summary>
        /// Compares enums of type OnErrorType
        /// </summary>
        public bool Equals(OnErrorType e)
        {
            return UnderlyingValue.Equals(e.UnderlyingValue);
        }

        /// <summary>
        /// Implicit operator to convert string to OnErrorType
        /// </summary>
        public static implicit operator OnErrorType(string value)
        {
            return new OnErrorType(value);
        }

        /// <summary>
        /// Implicit operator to convert OnErrorType to string
        /// </summary>
        public static implicit operator string(OnErrorType e)
        {
            return e.UnderlyingValue;
        }

        /// <summary>
        /// Overriding == operator for enum OnErrorType
        /// </summary>
        public static bool operator == (OnErrorType e1, OnErrorType e2)
        {
            return e2.Equals(e1);
        }

        /// <summary>
        /// Overriding != operator for enum OnErrorType
        /// </summary>
        public static bool operator != (OnErrorType e1, OnErrorType e2)
        {
            return !e2.Equals(e1);
        }

        /// <summary>
        /// Overrides Equals operator for OnErrorType
        /// </summary>
        public override bool Equals(object obj)
        {
            return obj is OnErrorType && Equals((OnErrorType)obj);
        }

        /// <summary>
        /// Returns for hashCode OnErrorType
        /// </summary>
        public override int GetHashCode()
        {
            return UnderlyingValue.GetHashCode();
        }

    }
}
