// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the properties of a rectangular window applied to the input
    /// media before processing it.
    /// </summary>
    public partial class Rectangle
    {
        /// <summary>
        /// Initializes a new instance of the Rectangle class.
        /// </summary>
        public Rectangle()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Rectangle class.
        /// </summary>
        /// <param name="left">The number of pixels from the left-margin. This
        /// can be absolute pixel value (e.g 100), or relative to the size of
        /// the video (For example, 50%).</param>
        /// <param name="top">The number of pixels from the top-margin. This
        /// can be absolute pixel value (e.g 100), or relative to the size of
        /// the video (For example, 50%).</param>
        /// <param name="width">The width of the rectangular region in pixels.
        /// This can be absolute pixel value (e.g 100), or relative to the size
        /// of the video (For example, 50%).</param>
        /// <param name="height">The height of the rectangular region in
        /// pixels. This can be absolute pixel value (e.g 100), or relative to
        /// the size of the video (For example, 50%).</param>
        public Rectangle(string left = default(string), string top = default(string), string width = default(string), string height = default(string))
        {
            Left = left;
            Top = top;
            Width = width;
            Height = height;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the number of pixels from the left-margin. This can be
        /// absolute pixel value (e.g 100), or relative to the size of the
        /// video (For example, 50%).
        /// </summary>
        [JsonProperty(PropertyName = "left")]
        public string Left { get; set; }

        /// <summary>
        /// Gets or sets the number of pixels from the top-margin. This can be
        /// absolute pixel value (e.g 100), or relative to the size of the
        /// video (For example, 50%).
        /// </summary>
        [JsonProperty(PropertyName = "top")]
        public string Top { get; set; }

        /// <summary>
        /// Gets or sets the width of the rectangular region in pixels. This
        /// can be absolute pixel value (e.g 100), or relative to the size of
        /// the video (For example, 50%).
        /// </summary>
        [JsonProperty(PropertyName = "width")]
        public string Width { get; set; }

        /// <summary>
        /// Gets or sets the height of the rectangular region in pixels. This
        /// can be absolute pixel value (e.g 100), or relative to the size of
        /// the video (For example, 50%).
        /// </summary>
        [JsonProperty(PropertyName = "height")]
        public string Height { get; set; }

    }
}
