// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;

    /// <summary>
    /// Defines values for StreamingPolicyStreamingProtocol.
    /// </summary>
    /// <summary>
    /// Determine base value for a given allowed value if exists, else return
    /// the value itself
    /// </summary>
    [JsonConverter(typeof(StreamingPolicyStreamingProtocolConverter))]
    public struct StreamingPolicyStreamingProtocol : System.IEquatable<StreamingPolicyStreamingProtocol>
    {
        private StreamingPolicyStreamingProtocol(string underlyingValue)
        {
            UnderlyingValue=underlyingValue;
        }

        /// <summary>
        /// HLS protocol
        /// </summary>
        public static readonly StreamingPolicyStreamingProtocol Hls = "Hls";

        /// <summary>
        /// DASH protocol
        /// </summary>
        public static readonly StreamingPolicyStreamingProtocol Dash = "Dash";

        /// <summary>
        /// SmoothStreaming protocol
        /// </summary>
        public static readonly StreamingPolicyStreamingProtocol SmoothStreaming = "SmoothStreaming";

        /// <summary>
        /// Download protocol
        /// </summary>
        public static readonly StreamingPolicyStreamingProtocol Download = "Download";


        /// <summary>
        /// Underlying value of enum StreamingPolicyStreamingProtocol
        /// </summary>
        private readonly string UnderlyingValue;

        /// <summary>
        /// Returns string representation for StreamingPolicyStreamingProtocol
        /// </summary>
        public override string ToString()
        {
            return UnderlyingValue == null ? null : UnderlyingValue.ToString();
        }

        /// <summary>
        /// Compares enums of type StreamingPolicyStreamingProtocol
        /// </summary>
        public bool Equals(StreamingPolicyStreamingProtocol e)
        {
            return UnderlyingValue.Equals(e.UnderlyingValue);
        }

        /// <summary>
        /// Implicit operator to convert string to
        /// StreamingPolicyStreamingProtocol
        /// </summary>
        public static implicit operator StreamingPolicyStreamingProtocol(string value)
        {
            return new StreamingPolicyStreamingProtocol(value);
        }

        /// <summary>
        /// Implicit operator to convert StreamingPolicyStreamingProtocol to
        /// string
        /// </summary>
        public static implicit operator string(StreamingPolicyStreamingProtocol e)
        {
            return e.UnderlyingValue;
        }

        /// <summary>
        /// Overriding == operator for enum StreamingPolicyStreamingProtocol
        /// </summary>
        public static bool operator == (StreamingPolicyStreamingProtocol e1, StreamingPolicyStreamingProtocol e2)
        {
            return e2.Equals(e1);
        }

        /// <summary>
        /// Overriding != operator for enum StreamingPolicyStreamingProtocol
        /// </summary>
        public static bool operator != (StreamingPolicyStreamingProtocol e1, StreamingPolicyStreamingProtocol e2)
        {
            return !e2.Equals(e1);
        }

        /// <summary>
        /// Overrides Equals operator for StreamingPolicyStreamingProtocol
        /// </summary>
        public override bool Equals(object obj)
        {
            return obj is StreamingPolicyStreamingProtocol && Equals((StreamingPolicyStreamingProtocol)obj);
        }

        /// <summary>
        /// Returns for hashCode StreamingPolicyStreamingProtocol
        /// </summary>
        public override int GetHashCode()
        {
            return UnderlyingValue.GetHashCode();
        }

    }
}
