// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;

    /// <summary>
    /// Defines values for TrackPropertyCompareOperation.
    /// </summary>
    /// <summary>
    /// Determine base value for a given allowed value if exists, else return
    /// the value itself
    /// </summary>
    [JsonConverter(typeof(TrackPropertyCompareOperationConverter))]
    public struct TrackPropertyCompareOperation : System.IEquatable<TrackPropertyCompareOperation>
    {
        private TrackPropertyCompareOperation(string underlyingValue)
        {
            UnderlyingValue=underlyingValue;
        }

        /// <summary>
        /// Unknown track property compare operation
        /// </summary>
        public static readonly TrackPropertyCompareOperation Unknown = "Unknown";

        /// <summary>
        /// Equal operation
        /// </summary>
        public static readonly TrackPropertyCompareOperation Equal = "Equal";


        /// <summary>
        /// Underlying value of enum TrackPropertyCompareOperation
        /// </summary>
        private readonly string UnderlyingValue;

        /// <summary>
        /// Returns string representation for TrackPropertyCompareOperation
        /// </summary>
        public override string ToString()
        {
            return UnderlyingValue == null ? null : UnderlyingValue.ToString();
        }

        /// <summary>
        /// Compares enums of type TrackPropertyCompareOperation
        /// </summary>
        public bool Equals(TrackPropertyCompareOperation e)
        {
            return UnderlyingValue.Equals(e.UnderlyingValue);
        }

        /// <summary>
        /// Implicit operator to convert string to
        /// TrackPropertyCompareOperation
        /// </summary>
        public static implicit operator TrackPropertyCompareOperation(string value)
        {
            return new TrackPropertyCompareOperation(value);
        }

        /// <summary>
        /// Implicit operator to convert TrackPropertyCompareOperation to
        /// string
        /// </summary>
        public static implicit operator string(TrackPropertyCompareOperation e)
        {
            return e.UnderlyingValue;
        }

        /// <summary>
        /// Overriding == operator for enum TrackPropertyCompareOperation
        /// </summary>
        public static bool operator == (TrackPropertyCompareOperation e1, TrackPropertyCompareOperation e2)
        {
            return e2.Equals(e1);
        }

        /// <summary>
        /// Overriding != operator for enum TrackPropertyCompareOperation
        /// </summary>
        public static bool operator != (TrackPropertyCompareOperation e1, TrackPropertyCompareOperation e2)
        {
            return !e2.Equals(e1);
        }

        /// <summary>
        /// Overrides Equals operator for TrackPropertyCompareOperation
        /// </summary>
        public override bool Equals(object obj)
        {
            return obj is TrackPropertyCompareOperation && Equals((TrackPropertyCompareOperation)obj);
        }

        /// <summary>
        /// Returns for hashCode TrackPropertyCompareOperation
        /// </summary>
        public override int GetHashCode()
        {
            return UnderlyingValue.GetHashCode();
        }

    }
}
