// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Class to specify one track property condition
    /// </summary>
    public partial class TrackPropertyCondition
    {
        /// <summary>
        /// Initializes a new instance of the TrackPropertyCondition class.
        /// </summary>
        public TrackPropertyCondition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TrackPropertyCondition class.
        /// </summary>
        /// <param name="property">Track property type. Possible values
        /// include: 'Unknown', 'FourCC'</param>
        /// <param name="operation">Track property condition operation.
        /// Possible values include: 'Unknown', 'Equal'</param>
        /// <param name="value">Track property value</param>
        public TrackPropertyCondition(TrackPropertyType property, TrackPropertyCompareOperation operation, string value = default(string))
        {
            Property = property;
            Operation = operation;
            Value = value;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets track property type. Possible values include:
        /// 'Unknown', 'FourCC'
        /// </summary>
        [JsonProperty(PropertyName = "property")]
        public TrackPropertyType Property { get; set; }

        /// <summary>
        /// Gets or sets track property condition operation. Possible values
        /// include: 'Unknown', 'Equal'
        /// </summary>
        [JsonProperty(PropertyName = "operation")]
        public TrackPropertyCompareOperation Operation { get; set; }

        /// <summary>
        /// Gets or sets track property value
        /// </summary>
        [JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
