// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Media
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Azure.OData;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for TransformsOperations.
    /// </summary>
    public static partial class TransformsOperationsExtensions
    {
            /// <summary>
            /// List Transforms
            /// </summary>
            /// <remarks>
            /// Lists the Transforms in the account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            public static IPage<Transform> List(this ITransformsOperations operations, string resourceGroupName, string accountName, ODataQuery<Transform> odataQuery = default(ODataQuery<Transform>))
            {
                return operations.ListAsync(resourceGroupName, accountName, odataQuery).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List Transforms
            /// </summary>
            /// <remarks>
            /// Lists the Transforms in the account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Transform>> ListAsync(this ITransformsOperations operations, string resourceGroupName, string accountName, ODataQuery<Transform> odataQuery = default(ODataQuery<Transform>), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroupName, accountName, odataQuery, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get Transform
            /// </summary>
            /// <remarks>
            /// Gets a Transform.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='transformName'>
            /// The Transform name.
            /// </param>
            public static Transform Get(this ITransformsOperations operations, string resourceGroupName, string accountName, string transformName)
            {
                return operations.GetAsync(resourceGroupName, accountName, transformName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get Transform
            /// </summary>
            /// <remarks>
            /// Gets a Transform.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='transformName'>
            /// The Transform name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Transform> GetAsync(this ITransformsOperations operations, string resourceGroupName, string accountName, string transformName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, accountName, transformName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Create or Update Transform
            /// </summary>
            /// <remarks>
            /// Creates or updates a new Transform.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='transformName'>
            /// The Transform name.
            /// </param>
            /// <param name='outputs'>
            /// An array of one or more TransformOutputs that the Transform should
            /// generate.
            /// </param>
            /// <param name='description'>
            /// An optional verbose description of the Transform.
            /// </param>
            public static Transform CreateOrUpdate(this ITransformsOperations operations, string resourceGroupName, string accountName, string transformName, IList<TransformOutput> outputs, string description = default(string))
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, accountName, transformName, outputs, description).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or Update Transform
            /// </summary>
            /// <remarks>
            /// Creates or updates a new Transform.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='transformName'>
            /// The Transform name.
            /// </param>
            /// <param name='outputs'>
            /// An array of one or more TransformOutputs that the Transform should
            /// generate.
            /// </param>
            /// <param name='description'>
            /// An optional verbose description of the Transform.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Transform> CreateOrUpdateAsync(this ITransformsOperations operations, string resourceGroupName, string accountName, string transformName, IList<TransformOutput> outputs, string description = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, accountName, transformName, outputs, description, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete Transform
            /// </summary>
            /// <remarks>
            /// Deletes a Transform.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='transformName'>
            /// The Transform name.
            /// </param>
            public static void Delete(this ITransformsOperations operations, string resourceGroupName, string accountName, string transformName)
            {
                operations.DeleteAsync(resourceGroupName, accountName, transformName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete Transform
            /// </summary>
            /// <remarks>
            /// Deletes a Transform.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='transformName'>
            /// The Transform name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this ITransformsOperations operations, string resourceGroupName, string accountName, string transformName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, accountName, transformName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Update Transform
            /// </summary>
            /// <remarks>
            /// Updates a Transform.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='transformName'>
            /// The Transform name.
            /// </param>
            /// <param name='outputs'>
            /// An array of one or more TransformOutputs that the Transform should
            /// generate.
            /// </param>
            /// <param name='description'>
            /// An optional verbose description of the Transform.
            /// </param>
            public static Transform Update(this ITransformsOperations operations, string resourceGroupName, string accountName, string transformName, IList<TransformOutput> outputs, string description = default(string))
            {
                return operations.UpdateAsync(resourceGroupName, accountName, transformName, outputs, description).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Update Transform
            /// </summary>
            /// <remarks>
            /// Updates a Transform.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group within the Azure subscription.
            /// </param>
            /// <param name='accountName'>
            /// The Media Services account name.
            /// </param>
            /// <param name='transformName'>
            /// The Transform name.
            /// </param>
            /// <param name='outputs'>
            /// An array of one or more TransformOutputs that the Transform should
            /// generate.
            /// </param>
            /// <param name='description'>
            /// An optional verbose description of the Transform.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Transform> UpdateAsync(this ITransformsOperations operations, string resourceGroupName, string accountName, string transformName, IList<TransformOutput> outputs, string description = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(resourceGroupName, accountName, transformName, outputs, description, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// List Transforms
            /// </summary>
            /// <remarks>
            /// Lists the Transforms in the account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<Transform> ListNext(this ITransformsOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// List Transforms
            /// </summary>
            /// <remarks>
            /// Lists the Transforms in the account.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Transform>> ListNextAsync(this ITransformsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
