// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.MixedReality
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for MixedRealityClient.
    /// </summary>
    public static partial class MixedRealityClientExtensions
    {
            /// <summary>
            /// Check Name Availability for global uniqueness
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The location in which uniqueness will be verified.
            /// </param>
            /// <param name='checkNameAvailability'>
            /// Check Name Availability Request.
            /// </param>
            public static CheckNameAvailabilityResponse CheckNameAvailabilityLocal(this IMixedRealityClient operations, string location, CheckNameAvailabilityRequest checkNameAvailability)
            {
                return operations.CheckNameAvailabilityLocalAsync(location, checkNameAvailability).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Check Name Availability for global uniqueness
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The location in which uniqueness will be verified.
            /// </param>
            /// <param name='checkNameAvailability'>
            /// Check Name Availability Request.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<CheckNameAvailabilityResponse> CheckNameAvailabilityLocalAsync(this IMixedRealityClient operations, string location, CheckNameAvailabilityRequest checkNameAvailability, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CheckNameAvailabilityLocalWithHttpMessagesAsync(location, checkNameAvailability, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
