// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Monitor
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Azure.OData;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ActivityLogsOperations.
    /// </summary>
    public static partial class ActivityLogsOperationsExtensions
    {
            /// <summary>
            /// Provides the list of records from the activity logs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// Used to fetch events with only the given properties.&lt;br&gt;The
            /// **$select** argument is a comma separated list of property names to be
            /// returned. Possible values are: *authorization*, *claims*, *correlationId*,
            /// *description*, *eventDataId*, *eventName*, *eventTimestamp*, *httpRequest*,
            /// *level*, *operationId*, *operationName*, *properties*, *resourceGroupName*,
            /// *resourceProviderName*, *resourceId*, *status*, *submissionTimestamp*,
            /// *subStatus*, *subscriptionId*
            /// </param>
            public static IPage<EventData> List(this IActivityLogsOperations operations, ODataQuery<EventData> odataQuery, string select = default(string))
            {
                return operations.ListAsync(odataQuery, select).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Provides the list of records from the activity logs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='select'>
            /// Used to fetch events with only the given properties.&lt;br&gt;The
            /// **$select** argument is a comma separated list of property names to be
            /// returned. Possible values are: *authorization*, *claims*, *correlationId*,
            /// *description*, *eventDataId*, *eventName*, *eventTimestamp*, *httpRequest*,
            /// *level*, *operationId*, *operationName*, *properties*, *resourceGroupName*,
            /// *resourceProviderName*, *resourceId*, *status*, *submissionTimestamp*,
            /// *subStatus*, *subscriptionId*
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<EventData>> ListAsync(this IActivityLogsOperations operations, ODataQuery<EventData> odataQuery, string select = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(odataQuery, select, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Provides the list of records from the activity logs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<EventData> ListNext(this IActivityLogsOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Provides the list of records from the activity logs.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<EventData>> ListNextAsync(this IActivityLogsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
