// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Monitor
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for VMInsightsOperations.
    /// </summary>
    public static partial class VMInsightsOperationsExtensions
    {
            /// <summary>
            /// Retrieves the VM Insights onboarding status for the specified resource or
            /// resource scope.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceUri'>
            /// The fully qualified Azure Resource manager identifier of the resource, or
            /// scope, whose status to retrieve.
            /// </param>
            public static VMInsightsOnboardingStatus GetOnboardingStatus(this IVMInsightsOperations operations, string resourceUri)
            {
                return operations.GetOnboardingStatusAsync(resourceUri).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the VM Insights onboarding status for the specified resource or
            /// resource scope.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceUri'>
            /// The fully qualified Azure Resource manager identifier of the resource, or
            /// scope, whose status to retrieve.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VMInsightsOnboardingStatus> GetOnboardingStatusAsync(this IVMInsightsOperations operations, string resourceUri, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetOnboardingStatusWithHttpMessagesAsync(resourceUri, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
