// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// UrlPathMaps give a url path to the backend mapping information for
    /// PathBasedRouting.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ApplicationGatewayUrlPathMap : SubResource
    {
        /// <summary>
        /// Initializes a new instance of the ApplicationGatewayUrlPathMap
        /// class.
        /// </summary>
        public ApplicationGatewayUrlPathMap()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ApplicationGatewayUrlPathMap
        /// class.
        /// </summary>
        /// <param name="id">Resource ID.</param>
        /// <param name="defaultBackendAddressPool">Default backend address
        /// pool resource of URL path map.</param>
        /// <param name="defaultBackendHttpSettings">Default backend http
        /// settings resource of URL path map.</param>
        /// <param name="defaultRewriteRuleSet">Default Rewrite rule set
        /// resource of URL path map.</param>
        /// <param name="defaultRedirectConfiguration">Default redirect
        /// configuration resource of URL path map.</param>
        /// <param name="pathRules">Path rule of URL path map resource.</param>
        /// <param name="provisioningState">The provisioning state of the URL
        /// path map resource. Possible values include: 'Succeeded',
        /// 'Updating', 'Deleting', 'Failed'</param>
        /// <param name="name">Name of the URL path map that is unique within
        /// an Application Gateway.</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated.</param>
        /// <param name="type">Type of the resource.</param>
        public ApplicationGatewayUrlPathMap(string id = default(string), SubResource defaultBackendAddressPool = default(SubResource), SubResource defaultBackendHttpSettings = default(SubResource), SubResource defaultRewriteRuleSet = default(SubResource), SubResource defaultRedirectConfiguration = default(SubResource), IList<ApplicationGatewayPathRule> pathRules = default(IList<ApplicationGatewayPathRule>), string provisioningState = default(string), string name = default(string), string etag = default(string), string type = default(string))
            : base(id)
        {
            DefaultBackendAddressPool = defaultBackendAddressPool;
            DefaultBackendHttpSettings = defaultBackendHttpSettings;
            DefaultRewriteRuleSet = defaultRewriteRuleSet;
            DefaultRedirectConfiguration = defaultRedirectConfiguration;
            PathRules = pathRules;
            ProvisioningState = provisioningState;
            Name = name;
            Etag = etag;
            Type = type;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets default backend address pool resource of URL path map.
        /// </summary>
        [JsonProperty(PropertyName = "properties.defaultBackendAddressPool")]
        public SubResource DefaultBackendAddressPool { get; set; }

        /// <summary>
        /// Gets or sets default backend http settings resource of URL path
        /// map.
        /// </summary>
        [JsonProperty(PropertyName = "properties.defaultBackendHttpSettings")]
        public SubResource DefaultBackendHttpSettings { get; set; }

        /// <summary>
        /// Gets or sets default Rewrite rule set resource of URL path map.
        /// </summary>
        [JsonProperty(PropertyName = "properties.defaultRewriteRuleSet")]
        public SubResource DefaultRewriteRuleSet { get; set; }

        /// <summary>
        /// Gets or sets default redirect configuration resource of URL path
        /// map.
        /// </summary>
        [JsonProperty(PropertyName = "properties.defaultRedirectConfiguration")]
        public SubResource DefaultRedirectConfiguration { get; set; }

        /// <summary>
        /// Gets or sets path rule of URL path map resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.pathRules")]
        public IList<ApplicationGatewayPathRule> PathRules { get; set; }

        /// <summary>
        /// Gets the provisioning state of the URL path map resource. Possible
        /// values include: 'Succeeded', 'Updating', 'Deleting', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets name of the URL path map that is unique within an
        /// Application Gateway.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

        /// <summary>
        /// Gets type of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

    }
}
