// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Bastion Host resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class BastionHost : Resource
    {
        /// <summary>
        /// Initializes a new instance of the BastionHost class.
        /// </summary>
        public BastionHost()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BastionHost class.
        /// </summary>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="location">Resource location.</param>
        /// <param name="tags">Resource tags.</param>
        /// <param name="ipConfigurations">IP configuration of the Bastion Host
        /// resource.</param>
        /// <param name="dnsName">FQDN for the endpoint on which bastion host
        /// is accessible.</param>
        /// <param name="provisioningState">The provisioning state of the
        /// bastion host resource. Possible values include: 'Succeeded',
        /// 'Updating', 'Deleting', 'Failed'</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated.</param>
        public BastionHost(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), IList<BastionHostIPConfiguration> ipConfigurations = default(IList<BastionHostIPConfiguration>), string dnsName = default(string), string provisioningState = default(string), string etag = default(string))
            : base(id, name, type, location, tags)
        {
            IpConfigurations = ipConfigurations;
            DnsName = dnsName;
            ProvisioningState = provisioningState;
            Etag = etag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets IP configuration of the Bastion Host resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.ipConfigurations")]
        public IList<BastionHostIPConfiguration> IpConfigurations { get; set; }

        /// <summary>
        /// Gets or sets FQDN for the endpoint on which bastion host is
        /// accessible.
        /// </summary>
        [JsonProperty(PropertyName = "properties.dnsName")]
        public string DnsName { get; set; }

        /// <summary>
        /// Gets the provisioning state of the bastion host resource. Possible
        /// values include: 'Succeeded', 'Updating', 'Deleting', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

    }
}
