// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Bastion Shareable Link.
    /// </summary>
    public partial class BastionShareableLink
    {
        /// <summary>
        /// Initializes a new instance of the BastionShareableLink class.
        /// </summary>
        public BastionShareableLink()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BastionShareableLink class.
        /// </summary>
        /// <param name="vm">Reference of the virtual machine resource.</param>
        /// <param name="bsl">The unique Bastion Shareable Link to the virtual
        /// machine.</param>
        /// <param name="createdAt">The time when the link was created.</param>
        /// <param name="message">Optional field indicating the warning or
        /// error message related to the vm in case of partial failure.</param>
        public BastionShareableLink(VM vm, string bsl = default(string), string createdAt = default(string), string message = default(string))
        {
            Vm = vm;
            Bsl = bsl;
            CreatedAt = createdAt;
            Message = message;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets reference of the virtual machine resource.
        /// </summary>
        [JsonProperty(PropertyName = "vm")]
        public VM Vm { get; set; }

        /// <summary>
        /// Gets the unique Bastion Shareable Link to the virtual machine.
        /// </summary>
        [JsonProperty(PropertyName = "bsl")]
        public string Bsl { get; private set; }

        /// <summary>
        /// Gets the time when the link was created.
        /// </summary>
        [JsonProperty(PropertyName = "createdAt")]
        public string CreatedAt { get; private set; }

        /// <summary>
        /// Gets optional field indicating the warning or error message related
        /// to the vm in case of partial failure.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Vm == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Vm");
            }
        }
    }
}
