// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the connection monitor endpoint.
    /// </summary>
    public partial class ConnectionMonitorEndpoint
    {
        /// <summary>
        /// Initializes a new instance of the ConnectionMonitorEndpoint class.
        /// </summary>
        public ConnectionMonitorEndpoint()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ConnectionMonitorEndpoint class.
        /// </summary>
        /// <param name="name">The name of the connection monitor
        /// endpoint.</param>
        /// <param name="resourceId">Resource ID of the connection monitor
        /// endpoint.</param>
        /// <param name="address">Address of the connection monitor endpoint
        /// (IP or domain name).</param>
        /// <param name="filter">Filter for sub-items within the
        /// endpoint.</param>
        public ConnectionMonitorEndpoint(string name, string resourceId = default(string), string address = default(string), ConnectionMonitorEndpointFilter filter = default(ConnectionMonitorEndpointFilter))
        {
            Name = name;
            ResourceId = resourceId;
            Address = address;
            Filter = filter;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the connection monitor endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets resource ID of the connection monitor endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "resourceId")]
        public string ResourceId { get; set; }

        /// <summary>
        /// Gets or sets address of the connection monitor endpoint (IP or
        /// domain name).
        /// </summary>
        [JsonProperty(PropertyName = "address")]
        public string Address { get; set; }

        /// <summary>
        /// Gets or sets filter for sub-items within the endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "filter")]
        public ConnectionMonitorEndpointFilter Filter { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
        }
    }
}
