// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes the connection monitor test group.
    /// </summary>
    public partial class ConnectionMonitorTestGroup
    {
        /// <summary>
        /// Initializes a new instance of the ConnectionMonitorTestGroup class.
        /// </summary>
        public ConnectionMonitorTestGroup()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ConnectionMonitorTestGroup class.
        /// </summary>
        /// <param name="name">The name of the connection monitor test
        /// group.</param>
        /// <param name="testConfigurations">List of test configuration
        /// names.</param>
        /// <param name="sources">List of source endpoint names.</param>
        /// <param name="destinations">List of destination endpoint
        /// names.</param>
        /// <param name="disable">Value indicating whether test group is
        /// disabled.</param>
        public ConnectionMonitorTestGroup(string name, IList<string> testConfigurations, IList<string> sources, IList<string> destinations, bool? disable = default(bool?))
        {
            Name = name;
            Disable = disable;
            TestConfigurations = testConfigurations;
            Sources = sources;
            Destinations = destinations;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the connection monitor test group.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets value indicating whether test group is disabled.
        /// </summary>
        [JsonProperty(PropertyName = "disable")]
        public bool? Disable { get; set; }

        /// <summary>
        /// Gets or sets list of test configuration names.
        /// </summary>
        [JsonProperty(PropertyName = "testConfigurations")]
        public IList<string> TestConfigurations { get; set; }

        /// <summary>
        /// Gets or sets list of source endpoint names.
        /// </summary>
        [JsonProperty(PropertyName = "sources")]
        public IList<string> Sources { get; set; }

        /// <summary>
        /// Gets or sets list of destination endpoint names.
        /// </summary>
        [JsonProperty(PropertyName = "destinations")]
        public IList<string> Destinations { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (TestConfigurations == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TestConfigurations");
            }
            if (Sources == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Sources");
            }
            if (Destinations == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Destinations");
            }
        }
    }
}
