// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Container network interface configuration child resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ContainerNetworkInterfaceConfiguration : SubResource
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ContainerNetworkInterfaceConfiguration class.
        /// </summary>
        public ContainerNetworkInterfaceConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ContainerNetworkInterfaceConfiguration class.
        /// </summary>
        /// <param name="id">Resource ID.</param>
        /// <param name="ipConfigurations">A list of ip configurations of the
        /// container network interface configuration.</param>
        /// <param name="containerNetworkInterfaces">A list of container
        /// network interfaces created from this container network interface
        /// configuration.</param>
        /// <param name="provisioningState">The provisioning state of the
        /// container network interface configuration resource. Possible values
        /// include: 'Succeeded', 'Updating', 'Deleting', 'Failed'</param>
        /// <param name="name">The name of the resource. This name can be used
        /// to access the resource.</param>
        /// <param name="type">Sub Resource type.</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated.</param>
        public ContainerNetworkInterfaceConfiguration(string id = default(string), IList<IPConfigurationProfile> ipConfigurations = default(IList<IPConfigurationProfile>), IList<SubResource> containerNetworkInterfaces = default(IList<SubResource>), string provisioningState = default(string), string name = default(string), string type = default(string), string etag = default(string))
            : base(id)
        {
            IpConfigurations = ipConfigurations;
            ContainerNetworkInterfaces = containerNetworkInterfaces;
            ProvisioningState = provisioningState;
            Name = name;
            Type = type;
            Etag = etag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a list of ip configurations of the container network
        /// interface configuration.
        /// </summary>
        [JsonProperty(PropertyName = "properties.ipConfigurations")]
        public IList<IPConfigurationProfile> IpConfigurations { get; set; }

        /// <summary>
        /// Gets or sets a list of container network interfaces created from
        /// this container network interface configuration.
        /// </summary>
        [JsonProperty(PropertyName = "properties.containerNetworkInterfaces")]
        public IList<SubResource> ContainerNetworkInterfaces { get; set; }

        /// <summary>
        /// Gets the provisioning state of the container network interface
        /// configuration resource. Possible values include: 'Succeeded',
        /// 'Updating', 'Deleting', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets the name of the resource. This name can be used to
        /// access the resource.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets sub Resource type.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

    }
}
