// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A DDoS protection plan in a resource group.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class DdosProtectionPlan : IResource
    {
        /// <summary>
        /// Initializes a new instance of the DdosProtectionPlan class.
        /// </summary>
        public DdosProtectionPlan()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DdosProtectionPlan class.
        /// </summary>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="location">Resource location.</param>
        /// <param name="tags">Resource tags.</param>
        /// <param name="resourceGuid">The resource GUID property of the DDoS
        /// protection plan resource. It uniquely identifies the resource, even
        /// if the user changes its name or migrate the resource across
        /// subscriptions or resource groups.</param>
        /// <param name="provisioningState">The provisioning state of the DDoS
        /// protection plan resource. Possible values include: 'Succeeded',
        /// 'Updating', 'Deleting', 'Failed'</param>
        /// <param name="virtualNetworks">The list of virtual networks
        /// associated with the DDoS protection plan resource. This list is
        /// read-only.</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated.</param>
        public DdosProtectionPlan(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string resourceGuid = default(string), string provisioningState = default(string), IList<SubResource> virtualNetworks = default(IList<SubResource>), string etag = default(string))
        {
            Id = id;
            Name = name;
            Type = type;
            Location = location;
            Tags = tags;
            ResourceGuid = resourceGuid;
            ProvisioningState = provisioningState;
            VirtualNetworks = virtualNetworks;
            Etag = etag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets resource ID.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets resource name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets resource type.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

        /// <summary>
        /// Gets or sets resource location.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets resource tags.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets the resource GUID property of the DDoS protection plan
        /// resource. It uniquely identifies the resource, even if the user
        /// changes its name or migrate the resource across subscriptions or
        /// resource groups.
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceGuid")]
        public string ResourceGuid { get; private set; }

        /// <summary>
        /// Gets the provisioning state of the DDoS protection plan resource.
        /// Possible values include: 'Succeeded', 'Updating', 'Deleting',
        /// 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets the list of virtual networks associated with the DDoS
        /// protection plan resource. This list is read-only.
        /// </summary>
        [JsonProperty(PropertyName = "properties.virtualNetworks")]
        public IList<SubResource> VirtualNetworks { get; private set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

    }
}
