// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// ExpressRoutePorts Peering Location
    /// </summary>
    /// <remarks>
    /// Definition of the ExpressRoutePorts peering location resource.
    /// </remarks>
    [Rest.Serialization.JsonTransformation]
    public partial class ExpressRoutePortsLocation : Resource
    {
        /// <summary>
        /// Initializes a new instance of the ExpressRoutePortsLocation class.
        /// </summary>
        public ExpressRoutePortsLocation()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ExpressRoutePortsLocation class.
        /// </summary>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="location">Resource location.</param>
        /// <param name="tags">Resource tags.</param>
        /// <param name="address">Address of peering location.</param>
        /// <param name="contact">Contact details of peering locations.</param>
        /// <param name="availableBandwidths">The inventory of available
        /// ExpressRoutePort bandwidths.</param>
        /// <param name="provisioningState">The provisioning state of the
        /// express route port location resource. Possible values include:
        /// 'Succeeded', 'Updating', 'Deleting', 'Failed'</param>
        public ExpressRoutePortsLocation(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string address = default(string), string contact = default(string), IList<ExpressRoutePortsLocationBandwidths> availableBandwidths = default(IList<ExpressRoutePortsLocationBandwidths>), string provisioningState = default(string))
            : base(id, name, type, location, tags)
        {
            Address = address;
            Contact = contact;
            AvailableBandwidths = availableBandwidths;
            ProvisioningState = provisioningState;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets address of peering location.
        /// </summary>
        [JsonProperty(PropertyName = "properties.address")]
        public string Address { get; private set; }

        /// <summary>
        /// Gets contact details of peering locations.
        /// </summary>
        [JsonProperty(PropertyName = "properties.contact")]
        public string Contact { get; private set; }

        /// <summary>
        /// Gets or sets the inventory of available ExpressRoutePort
        /// bandwidths.
        /// </summary>
        [JsonProperty(PropertyName = "properties.availableBandwidths")]
        public IList<ExpressRoutePortsLocationBandwidths> AvailableBandwidths { get; set; }

        /// <summary>
        /// Gets the provisioning state of the express route port location
        /// resource. Possible values include: 'Succeeded', 'Updating',
        /// 'Deleting', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

    }
}
