// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Network
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for VirtualHubRouteTableV2sOperations.
    /// </summary>
    public static partial class VirtualHubRouteTableV2sOperationsExtensions
    {
            /// <summary>
            /// Retrieves the details of a VirtualHubRouteTableV2.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='routeTableName'>
            /// The name of the VirtualHubRouteTableV2.
            /// </param>
            public static VirtualHubRouteTableV2 Get(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, string routeTableName)
            {
                return operations.GetAsync(resourceGroupName, virtualHubName, routeTableName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the details of a VirtualHubRouteTableV2.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='routeTableName'>
            /// The name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VirtualHubRouteTableV2> GetAsync(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, string routeTableName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, virtualHubName, routeTableName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Creates a VirtualHubRouteTableV2 resource if it doesn't exist else updates
            /// the existing VirtualHubRouteTableV2.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHub.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='routeTableName'>
            /// The name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='virtualHubRouteTableV2Parameters'>
            /// Parameters supplied to create or update VirtualHubRouteTableV2.
            /// </param>
            public static VirtualHubRouteTableV2 CreateOrUpdate(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, string routeTableName, VirtualHubRouteTableV2 virtualHubRouteTableV2Parameters)
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, virtualHubName, routeTableName, virtualHubRouteTableV2Parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates a VirtualHubRouteTableV2 resource if it doesn't exist else updates
            /// the existing VirtualHubRouteTableV2.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHub.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='routeTableName'>
            /// The name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='virtualHubRouteTableV2Parameters'>
            /// Parameters supplied to create or update VirtualHubRouteTableV2.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VirtualHubRouteTableV2> CreateOrUpdateAsync(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, string routeTableName, VirtualHubRouteTableV2 virtualHubRouteTableV2Parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, virtualHubName, routeTableName, virtualHubRouteTableV2Parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes a VirtualHubRouteTableV2.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='routeTableName'>
            /// The name of the VirtualHubRouteTableV2.
            /// </param>
            public static void Delete(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, string routeTableName)
            {
                operations.DeleteAsync(resourceGroupName, virtualHubName, routeTableName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes a VirtualHubRouteTableV2.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='routeTableName'>
            /// The name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, string routeTableName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, virtualHubName, routeTableName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Retrieves the details of all VirtualHubRouteTableV2s.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHub.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            public static IPage<VirtualHubRouteTableV2> List(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName)
            {
                return operations.ListAsync(resourceGroupName, virtualHubName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the details of all VirtualHubRouteTableV2s.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHub.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<VirtualHubRouteTableV2>> ListAsync(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(resourceGroupName, virtualHubName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Creates a VirtualHubRouteTableV2 resource if it doesn't exist else updates
            /// the existing VirtualHubRouteTableV2.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHub.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='routeTableName'>
            /// The name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='virtualHubRouteTableV2Parameters'>
            /// Parameters supplied to create or update VirtualHubRouteTableV2.
            /// </param>
            public static VirtualHubRouteTableV2 BeginCreateOrUpdate(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, string routeTableName, VirtualHubRouteTableV2 virtualHubRouteTableV2Parameters)
            {
                return operations.BeginCreateOrUpdateAsync(resourceGroupName, virtualHubName, routeTableName, virtualHubRouteTableV2Parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates a VirtualHubRouteTableV2 resource if it doesn't exist else updates
            /// the existing VirtualHubRouteTableV2.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHub.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='routeTableName'>
            /// The name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='virtualHubRouteTableV2Parameters'>
            /// Parameters supplied to create or update VirtualHubRouteTableV2.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VirtualHubRouteTableV2> BeginCreateOrUpdateAsync(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, string routeTableName, VirtualHubRouteTableV2 virtualHubRouteTableV2Parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateOrUpdateWithHttpMessagesAsync(resourceGroupName, virtualHubName, routeTableName, virtualHubRouteTableV2Parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes a VirtualHubRouteTableV2.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='routeTableName'>
            /// The name of the VirtualHubRouteTableV2.
            /// </param>
            public static void BeginDelete(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, string routeTableName)
            {
                operations.BeginDeleteAsync(resourceGroupName, virtualHubName, routeTableName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes a VirtualHubRouteTableV2.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The resource group name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='virtualHubName'>
            /// The name of the VirtualHub.
            /// </param>
            /// <param name='routeTableName'>
            /// The name of the VirtualHubRouteTableV2.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginDeleteAsync(this IVirtualHubRouteTableV2sOperations operations, string resourceGroupName, string virtualHubName, string routeTableName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginDeleteWithHttpMessagesAsync(resourceGroupName, virtualHubName, routeTableName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Retrieves the details of all VirtualHubRouteTableV2s.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<VirtualHubRouteTableV2> ListNext(this IVirtualHubRouteTableV2sOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the details of all VirtualHubRouteTableV2s.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<VirtualHubRouteTableV2>> ListNextAsync(this IVirtualHubRouteTableV2sOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
