// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.OperationalInsights.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Datasources under OMS Workspace.
    /// </summary>
    public partial class DataSource : IResource
    {
        /// <summary>
        /// Initializes a new instance of the DataSource class.
        /// </summary>
        public DataSource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DataSource class.
        /// </summary>
        /// <param name="properties">The data source properties in raw json
        /// format, each kind of data source have it's own schema.</param>
        /// <param name="kind">Possible values include: 'AzureActivityLog',
        /// 'ChangeTrackingPath', 'ChangeTrackingDefaultPath',
        /// 'ChangeTrackingDefaultRegistry', 'ChangeTrackingCustomRegistry',
        /// 'CustomLog', 'CustomLogCollection', 'GenericDataSource', 'IISLogs',
        /// 'LinuxPerformanceObject', 'LinuxPerformanceCollection',
        /// 'LinuxSyslog', 'LinuxSyslogCollection', 'WindowsEvent',
        /// 'WindowsPerformanceCounter'</param>
        /// <param name="eTag">The ETag of the data source.</param>
        public DataSource(object properties, string kind, string eTag = default(string))
        {
            Properties = properties;
            ETag = eTag;
            Kind = kind;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the data source properties in raw json format, each
        /// kind of data source have it's own schema.
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public object Properties { get; set; }

        /// <summary>
        /// Gets or sets the ETag of the data source.
        /// </summary>
        [JsonProperty(PropertyName = "eTag")]
        public string ETag { get; set; }

        /// <summary>
        /// Gets or sets possible values include: 'AzureActivityLog',
        /// 'ChangeTrackingPath', 'ChangeTrackingDefaultPath',
        /// 'ChangeTrackingDefaultRegistry', 'ChangeTrackingCustomRegistry',
        /// 'CustomLog', 'CustomLogCollection', 'GenericDataSource', 'IISLogs',
        /// 'LinuxPerformanceObject', 'LinuxPerformanceCollection',
        /// 'LinuxSyslog', 'LinuxSyslogCollection', 'WindowsEvent',
        /// 'WindowsPerformanceCounter'
        /// </summary>
        [JsonProperty(PropertyName = "kind")]
        public string Kind { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Properties == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Properties");
            }
            if (Kind == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Kind");
            }
        }
    }
}
