// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Peering.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties that define a direct peering facility.
    /// </summary>
    public partial class DirectPeeringFacility
    {
        /// <summary>
        /// Initializes a new instance of the DirectPeeringFacility class.
        /// </summary>
        public DirectPeeringFacility()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DirectPeeringFacility class.
        /// </summary>
        /// <param name="address">The address of the direct peering
        /// facility.</param>
        /// <param name="directPeeringType">The type of the direct peering.
        /// Possible values include: 'Edge', 'Transit', 'Cdn',
        /// 'Internal'</param>
        /// <param name="peeringDBFacilityId">The PeeringDB.com ID of the
        /// facility.</param>
        /// <param name="peeringDBFacilityLink">The PeeringDB.com URL of the
        /// facility.</param>
        public DirectPeeringFacility(string address = default(string), string directPeeringType = default(string), int? peeringDBFacilityId = default(int?), string peeringDBFacilityLink = default(string))
        {
            Address = address;
            DirectPeeringType = directPeeringType;
            PeeringDBFacilityId = peeringDBFacilityId;
            PeeringDBFacilityLink = peeringDBFacilityLink;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the address of the direct peering facility.
        /// </summary>
        [JsonProperty(PropertyName = "address")]
        public string Address { get; set; }

        /// <summary>
        /// Gets or sets the type of the direct peering. Possible values
        /// include: 'Edge', 'Transit', 'Cdn', 'Internal'
        /// </summary>
        [JsonProperty(PropertyName = "directPeeringType")]
        public string DirectPeeringType { get; set; }

        /// <summary>
        /// Gets or sets the PeeringDB.com ID of the facility.
        /// </summary>
        [JsonProperty(PropertyName = "peeringDBFacilityId")]
        public int? PeeringDBFacilityId { get; set; }

        /// <summary>
        /// Gets or sets the PeeringDB.com URL of the facility.
        /// </summary>
        [JsonProperty(PropertyName = "peeringDBFacilityLink")]
        public string PeeringDBFacilityLink { get; set; }

    }
}
