// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Peering.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties that define an exchange connection.
    /// </summary>
    public partial class ExchangeConnection
    {
        /// <summary>
        /// Initializes a new instance of the ExchangeConnection class.
        /// </summary>
        public ExchangeConnection()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ExchangeConnection class.
        /// </summary>
        /// <param name="peeringDBFacilityId">The PeeringDB.com ID of the
        /// facility at which the connection has to be set up.</param>
        /// <param name="connectionState">The state of the connection. Possible
        /// values include: 'None', 'PendingApproval', 'Approved',
        /// 'ProvisioningStarted', 'ProvisioningFailed',
        /// 'ProvisioningCompleted', 'Validating', 'Active'</param>
        /// <param name="bgpSession">The BGP session associated with the
        /// connection.</param>
        /// <param name="connectionIdentifier">The unique identifier (GUID) for
        /// the connection.</param>
        /// <param name="errorMessage">The error message related to the
        /// connection state, if any.</param>
        public ExchangeConnection(int? peeringDBFacilityId = default(int?), string connectionState = default(string), BgpSession bgpSession = default(BgpSession), string connectionIdentifier = default(string), string errorMessage = default(string))
        {
            PeeringDBFacilityId = peeringDBFacilityId;
            ConnectionState = connectionState;
            BgpSession = bgpSession;
            ConnectionIdentifier = connectionIdentifier;
            ErrorMessage = errorMessage;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the PeeringDB.com ID of the facility at which the
        /// connection has to be set up.
        /// </summary>
        [JsonProperty(PropertyName = "peeringDBFacilityId")]
        public int? PeeringDBFacilityId { get; set; }

        /// <summary>
        /// Gets the state of the connection. Possible values include: 'None',
        /// 'PendingApproval', 'Approved', 'ProvisioningStarted',
        /// 'ProvisioningFailed', 'ProvisioningCompleted', 'Validating',
        /// 'Active'
        /// </summary>
        [JsonProperty(PropertyName = "connectionState")]
        public string ConnectionState { get; private set; }

        /// <summary>
        /// Gets or sets the BGP session associated with the connection.
        /// </summary>
        [JsonProperty(PropertyName = "bgpSession")]
        public BgpSession BgpSession { get; set; }

        /// <summary>
        /// Gets or sets the unique identifier (GUID) for the connection.
        /// </summary>
        [JsonProperty(PropertyName = "connectionIdentifier")]
        public string ConnectionIdentifier { get; set; }

        /// <summary>
        /// Gets the error message related to the connection state, if any.
        /// </summary>
        [JsonProperty(PropertyName = "errorMessage")]
        public string ErrorMessage { get; private set; }

    }
}
