// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Peering
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for PeeringLocationsOperations.
    /// </summary>
    public static partial class PeeringLocationsOperationsExtensions
    {
            /// <summary>
            /// Lists all of the available peering locations for the specified kind of
            /// peering.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='kind'>
            /// The kind of the peering. Possible values include: 'Direct', 'Exchange'
            /// </param>
            /// <param name='directPeeringType'>
            /// The type of direct peering. Possible values include: 'Edge', 'Transit',
            /// 'Cdn', 'Internal'
            /// </param>
            public static IPage<PeeringLocation> List(this IPeeringLocationsOperations operations, string kind, string directPeeringType = default(string))
            {
                return operations.ListAsync(kind, directPeeringType).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists all of the available peering locations for the specified kind of
            /// peering.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='kind'>
            /// The kind of the peering. Possible values include: 'Direct', 'Exchange'
            /// </param>
            /// <param name='directPeeringType'>
            /// The type of direct peering. Possible values include: 'Edge', 'Transit',
            /// 'Cdn', 'Internal'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<PeeringLocation>> ListAsync(this IPeeringLocationsOperations operations, string kind, string directPeeringType = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(kind, directPeeringType, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists all of the available peering locations for the specified kind of
            /// peering.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<PeeringLocation> ListNext(this IPeeringLocationsOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists all of the available peering locations for the specified kind of
            /// peering.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<PeeringLocation>> ListNextAsync(this IPeeringLocationsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
