// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.PolicyInsights.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Policy tracked resource record.
    /// </summary>
    public partial class PolicyTrackedResource
    {
        /// <summary>
        /// Initializes a new instance of the PolicyTrackedResource class.
        /// </summary>
        public PolicyTrackedResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PolicyTrackedResource class.
        /// </summary>
        /// <param name="trackedResourceId">The ID of the policy tracked
        /// resource.</param>
        /// <param name="policyDetails">The details of the policy that require
        /// the tracked resource.</param>
        /// <param name="createdBy">The details of the policy triggered
        /// deployment that created the tracked resource.</param>
        /// <param name="lastModifiedBy">The details of the policy triggered
        /// deployment that modified the tracked resource.</param>
        /// <param name="lastUpdateUtc">Timestamp of the last update to the
        /// tracked resource.</param>
        public PolicyTrackedResource(string trackedResourceId = default(string), PolicyDetails policyDetails = default(PolicyDetails), TrackedResourceModificationDetails createdBy = default(TrackedResourceModificationDetails), TrackedResourceModificationDetails lastModifiedBy = default(TrackedResourceModificationDetails), System.DateTime? lastUpdateUtc = default(System.DateTime?))
        {
            TrackedResourceId = trackedResourceId;
            PolicyDetails = policyDetails;
            CreatedBy = createdBy;
            LastModifiedBy = lastModifiedBy;
            LastUpdateUtc = lastUpdateUtc;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the ID of the policy tracked resource.
        /// </summary>
        [JsonProperty(PropertyName = "trackedResourceId")]
        public string TrackedResourceId { get; private set; }

        /// <summary>
        /// Gets the details of the policy that require the tracked resource.
        /// </summary>
        [JsonProperty(PropertyName = "policyDetails")]
        public PolicyDetails PolicyDetails { get; private set; }

        /// <summary>
        /// Gets the details of the policy triggered deployment that created
        /// the tracked resource.
        /// </summary>
        [JsonProperty(PropertyName = "createdBy")]
        public TrackedResourceModificationDetails CreatedBy { get; private set; }

        /// <summary>
        /// Gets the details of the policy triggered deployment that modified
        /// the tracked resource.
        /// </summary>
        [JsonProperty(PropertyName = "lastModifiedBy")]
        public TrackedResourceModificationDetails LastModifiedBy { get; private set; }

        /// <summary>
        /// Gets timestamp of the last update to the tracked resource.
        /// </summary>
        [JsonProperty(PropertyName = "lastUpdateUtc")]
        public System.DateTime? LastUpdateUtc { get; private set; }

    }
}
