// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.PolicyInsights.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The deployment status summary for all deployments created by the
    /// remediation.
    /// </summary>
    public partial class RemediationDeploymentSummary
    {
        /// <summary>
        /// Initializes a new instance of the RemediationDeploymentSummary
        /// class.
        /// </summary>
        public RemediationDeploymentSummary()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RemediationDeploymentSummary
        /// class.
        /// </summary>
        /// <param name="totalDeployments">The number of deployments required
        /// by the remediation.</param>
        /// <param name="successfulDeployments">The number of deployments
        /// required by the remediation that have succeeded.</param>
        /// <param name="failedDeployments">The number of deployments required
        /// by the remediation that have failed.</param>
        public RemediationDeploymentSummary(int? totalDeployments = default(int?), int? successfulDeployments = default(int?), int? failedDeployments = default(int?))
        {
            TotalDeployments = totalDeployments;
            SuccessfulDeployments = successfulDeployments;
            FailedDeployments = failedDeployments;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the number of deployments required by the remediation.
        /// </summary>
        [JsonProperty(PropertyName = "totalDeployments")]
        public int? TotalDeployments { get; private set; }

        /// <summary>
        /// Gets the number of deployments required by the remediation that
        /// have succeeded.
        /// </summary>
        [JsonProperty(PropertyName = "successfulDeployments")]
        public int? SuccessfulDeployments { get; private set; }

        /// <summary>
        /// Gets the number of deployments required by the remediation that
        /// have failed.
        /// </summary>
        [JsonProperty(PropertyName = "failedDeployments")]
        public int? FailedDeployments { get; private set; }

    }
}
