// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.PolicyInsights.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The details of the policy triggered deployment that created or modified
    /// the tracked resource.
    /// </summary>
    public partial class TrackedResourceModificationDetails
    {
        /// <summary>
        /// Initializes a new instance of the
        /// TrackedResourceModificationDetails class.
        /// </summary>
        public TrackedResourceModificationDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// TrackedResourceModificationDetails class.
        /// </summary>
        /// <param name="policyDetails">The details of the policy that created
        /// or modified the tracked resource.</param>
        /// <param name="deploymentId">The ID of the deployment that created or
        /// modified the tracked resource.</param>
        /// <param name="deploymentTime">Timestamp of the deployment that
        /// created or modified the tracked resource.</param>
        public TrackedResourceModificationDetails(PolicyDetails policyDetails = default(PolicyDetails), string deploymentId = default(string), System.DateTime? deploymentTime = default(System.DateTime?))
        {
            PolicyDetails = policyDetails;
            DeploymentId = deploymentId;
            DeploymentTime = deploymentTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the details of the policy that created or modified the tracked
        /// resource.
        /// </summary>
        [JsonProperty(PropertyName = "policyDetails")]
        public PolicyDetails PolicyDetails { get; private set; }

        /// <summary>
        /// Gets the ID of the deployment that created or modified the tracked
        /// resource.
        /// </summary>
        [JsonProperty(PropertyName = "deploymentId")]
        public string DeploymentId { get; private set; }

        /// <summary>
        /// Gets timestamp of the deployment that created or modified the
        /// tracked resource.
        /// </summary>
        [JsonProperty(PropertyName = "deploymentTime")]
        public System.DateTime? DeploymentTime { get; private set; }

    }
}
