// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.PostgreSQL.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents a log file.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class LogFile : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the LogFile class.
        /// </summary>
        public LogFile()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the LogFile class.
        /// </summary>
        /// <param name="id">Resource ID</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="sizeInKB">Size of the log file.</param>
        /// <param name="createdTime">Creation timestamp of the log
        /// file.</param>
        /// <param name="lastModifiedTime">Last modified timestamp of the log
        /// file.</param>
        /// <param name="logFileType">Type of the log file.</param>
        /// <param name="url">The url to download the log file from.</param>
        public LogFile(string id = default(string), string name = default(string), string type = default(string), long? sizeInKB = default(long?), System.DateTime? createdTime = default(System.DateTime?), System.DateTime? lastModifiedTime = default(System.DateTime?), string logFileType = default(string), string url = default(string))
            : base(id, name, type)
        {
            SizeInKB = sizeInKB;
            CreatedTime = createdTime;
            LastModifiedTime = lastModifiedTime;
            LogFileType = logFileType;
            Url = url;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets size of the log file.
        /// </summary>
        [JsonProperty(PropertyName = "properties.sizeInKB")]
        public long? SizeInKB { get; set; }

        /// <summary>
        /// Gets creation timestamp of the log file.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdTime")]
        public System.DateTime? CreatedTime { get; private set; }

        /// <summary>
        /// Gets last modified timestamp of the log file.
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastModifiedTime")]
        public System.DateTime? LastModifiedTime { get; private set; }

        /// <summary>
        /// Gets or sets type of the log file.
        /// </summary>
        [JsonProperty(PropertyName = "properties.type")]
        public string LogFileType { get; set; }

        /// <summary>
        /// Gets or sets the url to download the log file from.
        /// </summary>
        [JsonProperty(PropertyName = "properties.url")]
        public string Url { get; set; }

    }
}
