// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.PostgreSQL.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties used to create a new server by restoring from a backup.
    /// </summary>
    [Newtonsoft.Json.JsonObject("PointInTimeRestore")]
    public partial class ServerPropertiesForRestore : ServerPropertiesForCreate
    {
        /// <summary>
        /// Initializes a new instance of the ServerPropertiesForRestore class.
        /// </summary>
        public ServerPropertiesForRestore()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServerPropertiesForRestore class.
        /// </summary>
        /// <param name="sourceServerId">The source server id to restore
        /// from.</param>
        /// <param name="restorePointInTime">Restore point creation time
        /// (ISO8601 format), specifying the time to restore from.</param>
        /// <param name="version">Server version. Possible values include:
        /// '9.5', '9.6', '10', '10.0', '10.2'</param>
        /// <param name="sslEnforcement">Enable ssl enforcement or not when
        /// connect to server. Possible values include: 'Enabled',
        /// 'Disabled'</param>
        /// <param name="storageProfile">Storage profile of a server.</param>
        public ServerPropertiesForRestore(string sourceServerId, System.DateTime restorePointInTime, string version = default(string), SslEnforcementEnum? sslEnforcement = default(SslEnforcementEnum?), StorageProfile storageProfile = default(StorageProfile))
            : base(version, sslEnforcement, storageProfile)
        {
            SourceServerId = sourceServerId;
            RestorePointInTime = restorePointInTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the source server id to restore from.
        /// </summary>
        [JsonProperty(PropertyName = "sourceServerId")]
        public string SourceServerId { get; set; }

        /// <summary>
        /// Gets or sets restore point creation time (ISO8601 format),
        /// specifying the time to restore from.
        /// </summary>
        [JsonProperty(PropertyName = "restorePointInTime")]
        public System.DateTime RestorePointInTime { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SourceServerId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SourceServerId");
            }
        }
    }
}
