// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for FeatureSupportOperations.
    /// </summary>
    public static partial class FeatureSupportOperationsExtensions
    {
            /// <summary>
            /// It will validate if given feature with resource properties is supported in
            /// service
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='azureRegion'>
            /// Azure region to hit Api
            /// </param>
            /// <param name='parameters'>
            /// Feature support request object
            /// </param>
            public static AzureVMResourceFeatureSupportResponse Validate(this IFeatureSupportOperations operations, string azureRegion, FeatureSupportRequest parameters)
            {
                return operations.ValidateAsync(azureRegion, parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// It will validate if given feature with resource properties is supported in
            /// service
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='azureRegion'>
            /// Azure region to hit Api
            /// </param>
            /// <param name='parameters'>
            /// Feature support request object
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AzureVMResourceFeatureSupportResponse> ValidateAsync(this IFeatureSupportOperations operations, string azureRegion, FeatureSupportRequest parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ValidateWithHttpMessagesAsync(azureRegion, parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
