// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Protectable item for Azure Fileshare workloads.
    /// </summary>
    [Newtonsoft.Json.JsonObject("AzureFileShare")]
    public partial class AzureFileShareProtectableItem : WorkloadProtectableItem
    {
        /// <summary>
        /// Initializes a new instance of the AzureFileShareProtectableItem
        /// class.
        /// </summary>
        public AzureFileShareProtectableItem()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureFileShareProtectableItem
        /// class.
        /// </summary>
        /// <param name="backupManagementType">Type of backup management to
        /// backup an item.</param>
        /// <param name="workloadType">Type of workload for the backup
        /// management</param>
        /// <param name="friendlyName">Friendly name of the backup
        /// item.</param>
        /// <param name="protectionState">State of the back up item. Possible
        /// values include: 'Invalid', 'NotProtected', 'Protecting',
        /// 'Protected', 'ProtectionFailed'</param>
        /// <param name="parentContainerFabricId">Full Fabric ID of container
        /// to which this protectable item belongs. For example, ARM
        /// ID.</param>
        /// <param name="parentContainerFriendlyName">Friendly name of
        /// container to which this protectable item belongs.</param>
        /// <param name="azureFileShareType">File Share type XSync or XSMB.
        /// Possible values include: 'Invalid', 'XSMB', 'XSync'</param>
        public AzureFileShareProtectableItem(string backupManagementType = default(string), string workloadType = default(string), string friendlyName = default(string), string protectionState = default(string), string parentContainerFabricId = default(string), string parentContainerFriendlyName = default(string), string azureFileShareType = default(string))
            : base(backupManagementType, workloadType, friendlyName, protectionState)
        {
            ParentContainerFabricId = parentContainerFabricId;
            ParentContainerFriendlyName = parentContainerFriendlyName;
            AzureFileShareType = azureFileShareType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets full Fabric ID of container to which this protectable
        /// item belongs. For example, ARM ID.
        /// </summary>
        [JsonProperty(PropertyName = "parentContainerFabricId")]
        public string ParentContainerFabricId { get; set; }

        /// <summary>
        /// Gets or sets friendly name of container to which this protectable
        /// item belongs.
        /// </summary>
        [JsonProperty(PropertyName = "parentContainerFriendlyName")]
        public string ParentContainerFriendlyName { get; set; }

        /// <summary>
        /// Gets or sets file Share type XSync or XSMB. Possible values
        /// include: 'Invalid', 'XSMB', 'XSync'
        /// </summary>
        [JsonProperty(PropertyName = "azureFileShareType")]
        public string AzureFileShareType { get; set; }

    }
}
