// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Azure File Share workload specific backup copy.
    /// </summary>
    public partial class AzureFileShareRecoveryPoint : RecoveryPoint
    {
        /// <summary>
        /// Initializes a new instance of the AzureFileShareRecoveryPoint
        /// class.
        /// </summary>
        public AzureFileShareRecoveryPoint()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureFileShareRecoveryPoint
        /// class.
        /// </summary>
        /// <param name="recoveryPointType">Type of the backup copy. Specifies
        /// whether it is a crash consistent backup or app consistent.</param>
        /// <param name="recoveryPointTime">Time at which this backup copy was
        /// created.</param>
        /// <param name="fileShareSnapshotUri">Contains Url to the snapshot of
        /// fileshare, if applicable</param>
        /// <param name="recoveryPointSizeInGB">Contains recovery point
        /// size</param>
        public AzureFileShareRecoveryPoint(string recoveryPointType = default(string), System.DateTime? recoveryPointTime = default(System.DateTime?), string fileShareSnapshotUri = default(string), int? recoveryPointSizeInGB = default(int?))
        {
            RecoveryPointType = recoveryPointType;
            RecoveryPointTime = recoveryPointTime;
            FileShareSnapshotUri = fileShareSnapshotUri;
            RecoveryPointSizeInGB = recoveryPointSizeInGB;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets type of the backup copy. Specifies whether it is a crash
        /// consistent backup or app consistent.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPointType")]
        public string RecoveryPointType { get; private set; }

        /// <summary>
        /// Gets time at which this backup copy was created.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPointTime")]
        public System.DateTime? RecoveryPointTime { get; private set; }

        /// <summary>
        /// Gets contains Url to the snapshot of fileshare, if applicable
        /// </summary>
        [JsonProperty(PropertyName = "fileShareSnapshotUri")]
        public string FileShareSnapshotUri { get; private set; }

        /// <summary>
        /// Gets contains recovery point size
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPointSizeInGB")]
        public int? RecoveryPointSizeInGB { get; private set; }

    }
}
