// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Azure VM workload-specific protectable item.
    /// </summary>
    public partial class AzureVmWorkloadProtectableItem : WorkloadProtectableItem
    {
        /// <summary>
        /// Initializes a new instance of the AzureVmWorkloadProtectableItem
        /// class.
        /// </summary>
        public AzureVmWorkloadProtectableItem()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureVmWorkloadProtectableItem
        /// class.
        /// </summary>
        /// <param name="backupManagementType">Type of backup management to
        /// backup an item.</param>
        /// <param name="workloadType">Type of workload for the backup
        /// management</param>
        /// <param name="friendlyName">Friendly name of the backup
        /// item.</param>
        /// <param name="protectionState">State of the back up item. Possible
        /// values include: 'Invalid', 'NotProtected', 'Protecting',
        /// 'Protected', 'ProtectionFailed'</param>
        /// <param name="parentName">Name for instance or AG</param>
        /// <param name="parentUniqueName">Parent Unique Name is added to
        /// provide the service formatted URI Name of the Parent
        /// Only Applicable for data bases where the parent would be either
        /// Instance or a SQL AG.</param>
        /// <param name="serverName">Host/Cluster Name for instance or
        /// AG</param>
        /// <param name="isAutoProtectable">Indicates if protectable item is
        /// auto-protectable</param>
        /// <param name="isAutoProtected">Indicates if protectable item is
        /// auto-protected</param>
        /// <param name="subinquireditemcount">For instance or AG, indicates
        /// number of DB's present</param>
        /// <param name="subprotectableitemcount">For instance or AG, indicates
        /// number of DB's to be protected</param>
        /// <param name="prebackupvalidation">Pre-backup validation for
        /// protectable objects</param>
        public AzureVmWorkloadProtectableItem(string backupManagementType = default(string), string workloadType = default(string), string friendlyName = default(string), string protectionState = default(string), string parentName = default(string), string parentUniqueName = default(string), string serverName = default(string), bool? isAutoProtectable = default(bool?), bool? isAutoProtected = default(bool?), int? subinquireditemcount = default(int?), int? subprotectableitemcount = default(int?), PreBackupValidation prebackupvalidation = default(PreBackupValidation))
            : base(backupManagementType, workloadType, friendlyName, protectionState)
        {
            ParentName = parentName;
            ParentUniqueName = parentUniqueName;
            ServerName = serverName;
            IsAutoProtectable = isAutoProtectable;
            IsAutoProtected = isAutoProtected;
            Subinquireditemcount = subinquireditemcount;
            Subprotectableitemcount = subprotectableitemcount;
            Prebackupvalidation = prebackupvalidation;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name for instance or AG
        /// </summary>
        [JsonProperty(PropertyName = "parentName")]
        public string ParentName { get; set; }

        /// <summary>
        /// Gets or sets parent Unique Name is added to provide the service
        /// formatted URI Name of the Parent
        /// Only Applicable for data bases where the parent would be either
        /// Instance or a SQL AG.
        /// </summary>
        [JsonProperty(PropertyName = "parentUniqueName")]
        public string ParentUniqueName { get; set; }

        /// <summary>
        /// Gets or sets host/Cluster Name for instance or AG
        /// </summary>
        [JsonProperty(PropertyName = "serverName")]
        public string ServerName { get; set; }

        /// <summary>
        /// Gets or sets indicates if protectable item is auto-protectable
        /// </summary>
        [JsonProperty(PropertyName = "isAutoProtectable")]
        public bool? IsAutoProtectable { get; set; }

        /// <summary>
        /// Gets or sets indicates if protectable item is auto-protected
        /// </summary>
        [JsonProperty(PropertyName = "isAutoProtected")]
        public bool? IsAutoProtected { get; set; }

        /// <summary>
        /// Gets or sets for instance or AG, indicates number of DB's present
        /// </summary>
        [JsonProperty(PropertyName = "subinquireditemcount")]
        public int? Subinquireditemcount { get; set; }

        /// <summary>
        /// Gets or sets for instance or AG, indicates number of DB's to be
        /// protected
        /// </summary>
        [JsonProperty(PropertyName = "subprotectableitemcount")]
        public int? Subprotectableitemcount { get; set; }

        /// <summary>
        /// Gets or sets pre-backup validation for protectable objects
        /// </summary>
        [JsonProperty(PropertyName = "prebackupvalidation")]
        public PreBackupValidation Prebackupvalidation { get; set; }

    }
}
