// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Azure VM (Mercury) workload-specific backup policy.
    /// </summary>
    [Newtonsoft.Json.JsonObject("AzureWorkload")]
    public partial class AzureVmWorkloadProtectionPolicy : ProtectionPolicy
    {
        /// <summary>
        /// Initializes a new instance of the AzureVmWorkloadProtectionPolicy
        /// class.
        /// </summary>
        public AzureVmWorkloadProtectionPolicy()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureVmWorkloadProtectionPolicy
        /// class.
        /// </summary>
        /// <param name="protectedItemsCount">Number of items associated with
        /// this policy.</param>
        /// <param name="workLoadType">Type of workload for the backup
        /// management. Possible values include: 'Invalid', 'VM', 'FileFolder',
        /// 'AzureSqlDb', 'SQLDB', 'Exchange', 'Sharepoint', 'VMwareVM',
        /// 'SystemState', 'Client', 'GenericDataSource', 'SQLDataBase',
        /// 'AzureFileShare', 'SAPHanaDatabase', 'SAPAseDatabase'</param>
        /// <param name="settings">Common settings for the backup
        /// management</param>
        /// <param name="subProtectionPolicy">List of sub-protection policies
        /// which includes schedule and retention</param>
        /// <param name="makePolicyConsistent">Fix the policy
        /// inconsistency</param>
        public AzureVmWorkloadProtectionPolicy(int? protectedItemsCount = default(int?), string workLoadType = default(string), Settings settings = default(Settings), IList<SubProtectionPolicy> subProtectionPolicy = default(IList<SubProtectionPolicy>), bool? makePolicyConsistent = default(bool?))
            : base(protectedItemsCount)
        {
            WorkLoadType = workLoadType;
            Settings = settings;
            SubProtectionPolicy = subProtectionPolicy;
            MakePolicyConsistent = makePolicyConsistent;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets type of workload for the backup management. Possible
        /// values include: 'Invalid', 'VM', 'FileFolder', 'AzureSqlDb',
        /// 'SQLDB', 'Exchange', 'Sharepoint', 'VMwareVM', 'SystemState',
        /// 'Client', 'GenericDataSource', 'SQLDataBase', 'AzureFileShare',
        /// 'SAPHanaDatabase', 'SAPAseDatabase'
        /// </summary>
        [JsonProperty(PropertyName = "workLoadType")]
        public string WorkLoadType { get; set; }

        /// <summary>
        /// Gets or sets common settings for the backup management
        /// </summary>
        [JsonProperty(PropertyName = "settings")]
        public Settings Settings { get; set; }

        /// <summary>
        /// Gets or sets list of sub-protection policies which includes
        /// schedule and retention
        /// </summary>
        [JsonProperty(PropertyName = "subProtectionPolicy")]
        public IList<SubProtectionPolicy> SubProtectionPolicy { get; set; }

        /// <summary>
        /// Gets or sets fix the policy inconsistency
        /// </summary>
        [JsonProperty(PropertyName = "makePolicyConsistent")]
        public bool? MakePolicyConsistent { get; set; }

    }
}
