// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Azure storage specific error information
    /// </summary>
    public partial class AzureWorkloadErrorInfo
    {
        /// <summary>
        /// Initializes a new instance of the AzureWorkloadErrorInfo class.
        /// </summary>
        public AzureWorkloadErrorInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureWorkloadErrorInfo class.
        /// </summary>
        /// <param name="errorCode">Error code.</param>
        /// <param name="errorString">Localized error string.</param>
        /// <param name="errorTitle">Title: Typically, the entity that the
        /// error pertains to.</param>
        /// <param name="recommendations">List of localized recommendations for
        /// above error code.</param>
        /// <param name="additionalDetails">Additional details for above error
        /// code.</param>
        public AzureWorkloadErrorInfo(int? errorCode = default(int?), string errorString = default(string), string errorTitle = default(string), IList<string> recommendations = default(IList<string>), string additionalDetails = default(string))
        {
            ErrorCode = errorCode;
            ErrorString = errorString;
            ErrorTitle = errorTitle;
            Recommendations = recommendations;
            AdditionalDetails = additionalDetails;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets error code.
        /// </summary>
        [JsonProperty(PropertyName = "errorCode")]
        public int? ErrorCode { get; set; }

        /// <summary>
        /// Gets or sets localized error string.
        /// </summary>
        [JsonProperty(PropertyName = "errorString")]
        public string ErrorString { get; set; }

        /// <summary>
        /// Gets or sets title: Typically, the entity that the error pertains
        /// to.
        /// </summary>
        [JsonProperty(PropertyName = "errorTitle")]
        public string ErrorTitle { get; set; }

        /// <summary>
        /// Gets or sets list of localized recommendations for above error
        /// code.
        /// </summary>
        [JsonProperty(PropertyName = "recommendations")]
        public IList<string> Recommendations { get; set; }

        /// <summary>
        /// Gets or sets additional details for above error code.
        /// </summary>
        [JsonProperty(PropertyName = "additionalDetails")]
        public string AdditionalDetails { get; set; }

    }
}
