// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Query parameters to fetch list of backup engines.
    /// </summary>
    public partial class BMSBackupEnginesQueryObject
    {
        /// <summary>
        /// Initializes a new instance of the BMSBackupEnginesQueryObject
        /// class.
        /// </summary>
        public BMSBackupEnginesQueryObject()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BMSBackupEnginesQueryObject
        /// class.
        /// </summary>
        /// <param name="backupManagementType">Backup management type for the
        /// backup engine. Possible values include: 'Invalid', 'AzureIaasVM',
        /// 'MAB', 'DPM', 'AzureBackupServer', 'AzureSql', 'AzureStorage',
        /// 'AzureWorkload', 'DefaultBackup'</param>
        /// <param name="friendlyName">Friendly name of the backup
        /// engine.</param>
        /// <param name="expand">Attribute to add extended info.</param>
        public BMSBackupEnginesQueryObject(string backupManagementType = default(string), string friendlyName = default(string), string expand = default(string))
        {
            BackupManagementType = backupManagementType;
            FriendlyName = friendlyName;
            Expand = expand;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets backup management type for the backup engine. Possible
        /// values include: 'Invalid', 'AzureIaasVM', 'MAB', 'DPM',
        /// 'AzureBackupServer', 'AzureSql', 'AzureStorage', 'AzureWorkload',
        /// 'DefaultBackup'
        /// </summary>
        [JsonProperty(PropertyName = "backupManagementType")]
        public string BackupManagementType { get; set; }

        /// <summary>
        /// Gets or sets friendly name of the backup engine.
        /// </summary>
        [JsonProperty(PropertyName = "friendlyName")]
        public string FriendlyName { get; set; }

        /// <summary>
        /// Gets or sets attribute to add extended info.
        /// </summary>
        [JsonProperty(PropertyName = "expand")]
        public string Expand { get; set; }

    }
}
