// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Backup management usages of a vault.
    /// </summary>
    public partial class BackupManagementUsage
    {
        /// <summary>
        /// Initializes a new instance of the BackupManagementUsage class.
        /// </summary>
        public BackupManagementUsage()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BackupManagementUsage class.
        /// </summary>
        /// <param name="unit">Unit of the usage. Possible values include:
        /// 'Count', 'Bytes', 'Seconds', 'Percent', 'CountPerSecond',
        /// 'BytesPerSecond'</param>
        /// <param name="quotaPeriod">Quota period of usage.</param>
        /// <param name="nextResetTime">Next reset time of usage.</param>
        /// <param name="currentValue">Current value of usage.</param>
        /// <param name="limit">Limit of usage.</param>
        /// <param name="name">Name of usage.</param>
        public BackupManagementUsage(string unit = default(string), string quotaPeriod = default(string), System.DateTime? nextResetTime = default(System.DateTime?), long? currentValue = default(long?), long? limit = default(long?), NameInfo name = default(NameInfo))
        {
            Unit = unit;
            QuotaPeriod = quotaPeriod;
            NextResetTime = nextResetTime;
            CurrentValue = currentValue;
            Limit = limit;
            Name = name;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets unit of the usage. Possible values include: 'Count',
        /// 'Bytes', 'Seconds', 'Percent', 'CountPerSecond', 'BytesPerSecond'
        /// </summary>
        [JsonProperty(PropertyName = "unit")]
        public string Unit { get; set; }

        /// <summary>
        /// Gets or sets quota period of usage.
        /// </summary>
        [JsonProperty(PropertyName = "quotaPeriod")]
        public string QuotaPeriod { get; set; }

        /// <summary>
        /// Gets or sets next reset time of usage.
        /// </summary>
        [JsonProperty(PropertyName = "nextResetTime")]
        public System.DateTime? NextResetTime { get; set; }

        /// <summary>
        /// Gets or sets current value of usage.
        /// </summary>
        [JsonProperty(PropertyName = "currentValue")]
        public long? CurrentValue { get; set; }

        /// <summary>
        /// Gets or sets limit of usage.
        /// </summary>
        [JsonProperty(PropertyName = "limit")]
        public long? Limit { get; set; }

        /// <summary>
        /// Gets or sets name of usage.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public NameInfo Name { get; set; }

    }
}
