// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Backup resource vault config details.
    /// </summary>
    public partial class BackupResourceVaultConfig
    {
        /// <summary>
        /// Initializes a new instance of the BackupResourceVaultConfig class.
        /// </summary>
        public BackupResourceVaultConfig()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BackupResourceVaultConfig class.
        /// </summary>
        /// <param name="storageModelType">Storage type. Possible values
        /// include: 'Invalid', 'GeoRedundant', 'LocallyRedundant'</param>
        /// <param name="storageType">Storage type. Possible values include:
        /// 'Invalid', 'GeoRedundant', 'LocallyRedundant'</param>
        /// <param name="storageTypeState">Locked or Unlocked. Once a machine
        /// is registered against a resource, the storageTypeState is always
        /// Locked. Possible values include: 'Invalid', 'Locked',
        /// 'Unlocked'</param>
        /// <param name="enhancedSecurityState">Enabled or Disabled. Possible
        /// values include: 'Invalid', 'Enabled', 'Disabled'</param>
        /// <param name="softDeleteFeatureState">Soft Delete feature state.
        /// Possible values include: 'Invalid', 'Enabled', 'Disabled'</param>
        public BackupResourceVaultConfig(string storageModelType = default(string), string storageType = default(string), string storageTypeState = default(string), string enhancedSecurityState = default(string), string softDeleteFeatureState = default(string))
        {
            StorageModelType = storageModelType;
            StorageType = storageType;
            StorageTypeState = storageTypeState;
            EnhancedSecurityState = enhancedSecurityState;
            SoftDeleteFeatureState = softDeleteFeatureState;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets storage type. Possible values include: 'Invalid',
        /// 'GeoRedundant', 'LocallyRedundant'
        /// </summary>
        [JsonProperty(PropertyName = "storageModelType")]
        public string StorageModelType { get; set; }

        /// <summary>
        /// Gets or sets storage type. Possible values include: 'Invalid',
        /// 'GeoRedundant', 'LocallyRedundant'
        /// </summary>
        [JsonProperty(PropertyName = "storageType")]
        public string StorageType { get; set; }

        /// <summary>
        /// Gets or sets locked or Unlocked. Once a machine is registered
        /// against a resource, the storageTypeState is always Locked. Possible
        /// values include: 'Invalid', 'Locked', 'Unlocked'
        /// </summary>
        [JsonProperty(PropertyName = "storageTypeState")]
        public string StorageTypeState { get; set; }

        /// <summary>
        /// Gets or sets enabled or Disabled. Possible values include:
        /// 'Invalid', 'Enabled', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "enhancedSecurityState")]
        public string EnhancedSecurityState { get; set; }

        /// <summary>
        /// Gets or sets soft Delete feature state. Possible values include:
        /// 'Invalid', 'Enabled', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "softDeleteFeatureState")]
        public string SoftDeleteFeatureState { get; set; }

    }
}
