// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// BackupStatus request.
    /// </summary>
    public partial class BackupStatusRequest
    {
        /// <summary>
        /// Initializes a new instance of the BackupStatusRequest class.
        /// </summary>
        public BackupStatusRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BackupStatusRequest class.
        /// </summary>
        /// <param name="resourceType">Container Type - VM, SQLPaaS, DPM,
        /// AzureFileShare. Possible values include: 'Invalid', 'VM',
        /// 'FileFolder', 'AzureSqlDb', 'SQLDB', 'Exchange', 'Sharepoint',
        /// 'VMwareVM', 'SystemState', 'Client', 'GenericDataSource',
        /// 'SQLDataBase', 'AzureFileShare', 'SAPHanaDatabase',
        /// 'SAPAseDatabase'</param>
        /// <param name="resourceId">Entire ARM resource id of the
        /// resource</param>
        /// <param name="poLogicalName">Protectable Item Logical Name</param>
        public BackupStatusRequest(string resourceType = default(string), string resourceId = default(string), string poLogicalName = default(string))
        {
            ResourceType = resourceType;
            ResourceId = resourceId;
            PoLogicalName = poLogicalName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets container Type - VM, SQLPaaS, DPM, AzureFileShare.
        /// Possible values include: 'Invalid', 'VM', 'FileFolder',
        /// 'AzureSqlDb', 'SQLDB', 'Exchange', 'Sharepoint', 'VMwareVM',
        /// 'SystemState', 'Client', 'GenericDataSource', 'SQLDataBase',
        /// 'AzureFileShare', 'SAPHanaDatabase', 'SAPAseDatabase'
        /// </summary>
        [JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; set; }

        /// <summary>
        /// Gets or sets entire ARM resource id of the resource
        /// </summary>
        [JsonProperty(PropertyName = "resourceId")]
        public string ResourceId { get; set; }

        /// <summary>
        /// Gets or sets protectable Item Logical Name
        /// </summary>
        [JsonProperty(PropertyName = "poLogicalName")]
        public string PoLogicalName { get; set; }

    }
}
