// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// BackupStatus response.
    /// </summary>
    public partial class BackupStatusResponse
    {
        /// <summary>
        /// Initializes a new instance of the BackupStatusResponse class.
        /// </summary>
        public BackupStatusResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BackupStatusResponse class.
        /// </summary>
        /// <param name="protectionStatus">Specifies whether the container is
        /// registered or not. Possible values include: 'Invalid',
        /// 'NotProtected', 'Protecting', 'Protected',
        /// 'ProtectionFailed'</param>
        /// <param name="vaultId">Specifies the arm resource id of the
        /// vault</param>
        /// <param name="fabricName">Specifies the fabric name - Azure or AD.
        /// Possible values include: 'Invalid', 'Azure'</param>
        /// <param name="containerName">Specifies the product specific
        /// container name. E.g.
        /// iaasvmcontainer;iaasvmcontainer;csname;vmname.</param>
        /// <param name="protectedItemName">Specifies the product specific ds
        /// name. E.g. vm;iaasvmcontainer;csname;vmname.</param>
        /// <param name="errorCode">ErrorCode in case of intent failed</param>
        /// <param name="errorMessage">ErrorMessage in case of intent
        /// failed.</param>
        /// <param name="policyName">Specifies the policy name which is used
        /// for protection</param>
        /// <param name="registrationStatus">Container registration
        /// status</param>
        public BackupStatusResponse(string protectionStatus = default(string), string vaultId = default(string), string fabricName = default(string), string containerName = default(string), string protectedItemName = default(string), string errorCode = default(string), string errorMessage = default(string), string policyName = default(string), string registrationStatus = default(string))
        {
            ProtectionStatus = protectionStatus;
            VaultId = vaultId;
            FabricName = fabricName;
            ContainerName = containerName;
            ProtectedItemName = protectedItemName;
            ErrorCode = errorCode;
            ErrorMessage = errorMessage;
            PolicyName = policyName;
            RegistrationStatus = registrationStatus;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies whether the container is registered or not.
        /// Possible values include: 'Invalid', 'NotProtected', 'Protecting',
        /// 'Protected', 'ProtectionFailed'
        /// </summary>
        [JsonProperty(PropertyName = "protectionStatus")]
        public string ProtectionStatus { get; set; }

        /// <summary>
        /// Gets or sets specifies the arm resource id of the vault
        /// </summary>
        [JsonProperty(PropertyName = "vaultId")]
        public string VaultId { get; set; }

        /// <summary>
        /// Gets or sets specifies the fabric name - Azure or AD. Possible
        /// values include: 'Invalid', 'Azure'
        /// </summary>
        [JsonProperty(PropertyName = "fabricName")]
        public string FabricName { get; set; }

        /// <summary>
        /// Gets or sets specifies the product specific container name. E.g.
        /// iaasvmcontainer;iaasvmcontainer;csname;vmname.
        /// </summary>
        [JsonProperty(PropertyName = "containerName")]
        public string ContainerName { get; set; }

        /// <summary>
        /// Gets or sets specifies the product specific ds name. E.g.
        /// vm;iaasvmcontainer;csname;vmname.
        /// </summary>
        [JsonProperty(PropertyName = "protectedItemName")]
        public string ProtectedItemName { get; set; }

        /// <summary>
        /// Gets or sets errorCode in case of intent failed
        /// </summary>
        [JsonProperty(PropertyName = "errorCode")]
        public string ErrorCode { get; set; }

        /// <summary>
        /// Gets or sets errorMessage in case of intent failed.
        /// </summary>
        [JsonProperty(PropertyName = "errorMessage")]
        public string ErrorMessage { get; set; }

        /// <summary>
        /// Gets or sets specifies the policy name which is used for protection
        /// </summary>
        [JsonProperty(PropertyName = "policyName")]
        public string PolicyName { get; set; }

        /// <summary>
        /// Gets or sets container registration status
        /// </summary>
        [JsonProperty(PropertyName = "registrationStatus")]
        public string RegistrationStatus { get; set; }

    }
}
