// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Generic backup copy.
    /// </summary>
    public partial class GenericRecoveryPoint : RecoveryPoint
    {
        /// <summary>
        /// Initializes a new instance of the GenericRecoveryPoint class.
        /// </summary>
        public GenericRecoveryPoint()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GenericRecoveryPoint class.
        /// </summary>
        /// <param name="friendlyName">Friendly name of the backup
        /// copy.</param>
        /// <param name="recoveryPointType">Type of the backup copy.</param>
        /// <param name="recoveryPointTime">Time at which this backup copy was
        /// created.</param>
        /// <param name="recoveryPointAdditionalInfo">Additional information
        /// associated with this backup copy.</param>
        public GenericRecoveryPoint(string friendlyName = default(string), string recoveryPointType = default(string), System.DateTime? recoveryPointTime = default(System.DateTime?), string recoveryPointAdditionalInfo = default(string))
        {
            FriendlyName = friendlyName;
            RecoveryPointType = recoveryPointType;
            RecoveryPointTime = recoveryPointTime;
            RecoveryPointAdditionalInfo = recoveryPointAdditionalInfo;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets friendly name of the backup copy.
        /// </summary>
        [JsonProperty(PropertyName = "friendlyName")]
        public string FriendlyName { get; set; }

        /// <summary>
        /// Gets or sets type of the backup copy.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPointType")]
        public string RecoveryPointType { get; set; }

        /// <summary>
        /// Gets or sets time at which this backup copy was created.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPointTime")]
        public System.DateTime? RecoveryPointTime { get; set; }

        /// <summary>
        /// Gets or sets additional information associated with this backup
        /// copy.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPointAdditionalInfo")]
        public string RecoveryPointAdditionalInfo { get; set; }

    }
}
