// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Details about inquired protectable items under a given container.
    /// </summary>
    public partial class InquiryInfo
    {
        /// <summary>
        /// Initializes a new instance of the InquiryInfo class.
        /// </summary>
        public InquiryInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the InquiryInfo class.
        /// </summary>
        /// <param name="status">Inquiry Status for this container such as
        /// InProgress | Failed | Succeeded</param>
        /// <param name="errorDetail">Error Details if the Status is
        /// non-success.</param>
        /// <param name="inquiryDetails">Inquiry Details which will have
        /// workload specific details.
        /// For e.g. - For SQL and oracle this will contain different
        /// details.</param>
        public InquiryInfo(string status = default(string), ErrorDetail errorDetail = default(ErrorDetail), IList<WorkloadInquiryDetails> inquiryDetails = default(IList<WorkloadInquiryDetails>))
        {
            Status = status;
            ErrorDetail = errorDetail;
            InquiryDetails = inquiryDetails;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets inquiry Status for this container such as
        /// InProgress | Failed | Succeeded
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets error Details if the Status is non-success.
        /// </summary>
        [JsonProperty(PropertyName = "errorDetail")]
        public ErrorDetail ErrorDetail { get; set; }

        /// <summary>
        /// Gets or sets inquiry Details which will have workload specific
        /// details.
        /// For e.g. - For SQL and oracle this will contain different details.
        /// </summary>
        [JsonProperty(PropertyName = "inquiryDetails")]
        public IList<WorkloadInquiryDetails> InquiryDetails { get; set; }

    }
}
