// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// BEK is bitlocker key.
    /// KEK is encryption key for BEK
    /// If the VM was encrypted then we will store following details :
    /// 1. Secret(BEK) - Url + Backup Data + vaultId.
    /// 2. Key(KEK) - Url + Backup Data + vaultId.
    /// 3. EncryptionMechanism
    /// BEK and KEK can potentially have different vault ids.
    /// </summary>
    public partial class KeyAndSecretDetails
    {
        /// <summary>
        /// Initializes a new instance of the KeyAndSecretDetails class.
        /// </summary>
        public KeyAndSecretDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the KeyAndSecretDetails class.
        /// </summary>
        /// <param name="kekDetails">KEK is encryption key for BEK.</param>
        /// <param name="bekDetails">BEK is bitlocker encryption key.</param>
        /// <param name="encryptionMechanism">Encryption mechanism: None/
        /// SinglePass/ DoublePass</param>
        public KeyAndSecretDetails(KEKDetails kekDetails = default(KEKDetails), BEKDetails bekDetails = default(BEKDetails), string encryptionMechanism = default(string))
        {
            KekDetails = kekDetails;
            BekDetails = bekDetails;
            EncryptionMechanism = encryptionMechanism;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets KEK is encryption key for BEK.
        /// </summary>
        [JsonProperty(PropertyName = "kekDetails")]
        public KEKDetails KekDetails { get; set; }

        /// <summary>
        /// Gets or sets BEK is bitlocker encryption key.
        /// </summary>
        [JsonProperty(PropertyName = "bekDetails")]
        public BEKDetails BekDetails { get; set; }

        /// <summary>
        /// Gets or sets encryption mechanism: None/ SinglePass/ DoublePass
        /// </summary>
        [JsonProperty(PropertyName = "encryptionMechanism")]
        public string EncryptionMechanism { get; set; }

    }
}
