// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Container with items backed up using MAB backup engine.
    /// </summary>
    [Newtonsoft.Json.JsonObject("Windows")]
    public partial class MabContainer : ProtectionContainer
    {
        /// <summary>
        /// Initializes a new instance of the MabContainer class.
        /// </summary>
        public MabContainer()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MabContainer class.
        /// </summary>
        /// <param name="friendlyName">Friendly name of the container.</param>
        /// <param name="backupManagementType">Type of backup management for
        /// the container. Possible values include: 'Invalid', 'AzureIaasVM',
        /// 'MAB', 'DPM', 'AzureBackupServer', 'AzureSql', 'AzureStorage',
        /// 'AzureWorkload', 'DefaultBackup'</param>
        /// <param name="registrationStatus">Status of registration of the
        /// container with the Recovery Services Vault.</param>
        /// <param name="healthStatus">Status of health of the
        /// container.</param>
        /// <param name="canReRegister">Can the container be registered one
        /// more time.</param>
        /// <param name="containerId">ContainerID represents the
        /// container.</param>
        /// <param name="protectedItemCount">Number of items backed up in this
        /// container.</param>
        /// <param name="agentVersion">Agent version of this container.</param>
        /// <param name="extendedInfo">Additional information for this
        /// container</param>
        /// <param name="mabContainerHealthDetails">Health details on this mab
        /// container.</param>
        /// <param name="containerHealthState">Health state of mab
        /// container.</param>
        public MabContainer(string friendlyName = default(string), string backupManagementType = default(string), string registrationStatus = default(string), string healthStatus = default(string), bool? canReRegister = default(bool?), long? containerId = default(long?), long? protectedItemCount = default(long?), string agentVersion = default(string), MabContainerExtendedInfo extendedInfo = default(MabContainerExtendedInfo), IList<MABContainerHealthDetails> mabContainerHealthDetails = default(IList<MABContainerHealthDetails>), string containerHealthState = default(string))
            : base(friendlyName, backupManagementType, registrationStatus, healthStatus)
        {
            CanReRegister = canReRegister;
            ContainerId = containerId;
            ProtectedItemCount = protectedItemCount;
            AgentVersion = agentVersion;
            ExtendedInfo = extendedInfo;
            MabContainerHealthDetails = mabContainerHealthDetails;
            ContainerHealthState = containerHealthState;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets can the container be registered one more time.
        /// </summary>
        [JsonProperty(PropertyName = "canReRegister")]
        public bool? CanReRegister { get; set; }

        /// <summary>
        /// Gets or sets containerID represents the container.
        /// </summary>
        [JsonProperty(PropertyName = "containerId")]
        public long? ContainerId { get; set; }

        /// <summary>
        /// Gets or sets number of items backed up in this container.
        /// </summary>
        [JsonProperty(PropertyName = "protectedItemCount")]
        public long? ProtectedItemCount { get; set; }

        /// <summary>
        /// Gets or sets agent version of this container.
        /// </summary>
        [JsonProperty(PropertyName = "agentVersion")]
        public string AgentVersion { get; set; }

        /// <summary>
        /// Gets or sets additional information for this container
        /// </summary>
        [JsonProperty(PropertyName = "extendedInfo")]
        public MabContainerExtendedInfo ExtendedInfo { get; set; }

        /// <summary>
        /// Gets or sets health details on this mab container.
        /// </summary>
        [JsonProperty(PropertyName = "mabContainerHealthDetails")]
        public IList<MABContainerHealthDetails> MabContainerHealthDetails { get; set; }

        /// <summary>
        /// Gets or sets health state of mab container.
        /// </summary>
        [JsonProperty(PropertyName = "containerHealthState")]
        public string ContainerHealthState { get; set; }

    }
}
