// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Base class for operation result info.
    /// </summary>
    public partial class OperationResultInfoBaseResource : OperationWorkerResponse
    {
        /// <summary>
        /// Initializes a new instance of the OperationResultInfoBaseResource
        /// class.
        /// </summary>
        public OperationResultInfoBaseResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OperationResultInfoBaseResource
        /// class.
        /// </summary>
        /// <param name="statusCode">HTTP Status Code of the operation.
        /// Possible values include: 'Continue', 'SwitchingProtocols', 'OK',
        /// 'Created', 'Accepted', 'NonAuthoritativeInformation', 'NoContent',
        /// 'ResetContent', 'PartialContent', 'MultipleChoices', 'Ambiguous',
        /// 'MovedPermanently', 'Moved', 'Found', 'Redirect', 'SeeOther',
        /// 'RedirectMethod', 'NotModified', 'UseProxy', 'Unused',
        /// 'TemporaryRedirect', 'RedirectKeepVerb', 'BadRequest',
        /// 'Unauthorized', 'PaymentRequired', 'Forbidden', 'NotFound',
        /// 'MethodNotAllowed', 'NotAcceptable', 'ProxyAuthenticationRequired',
        /// 'RequestTimeout', 'Conflict', 'Gone', 'LengthRequired',
        /// 'PreconditionFailed', 'RequestEntityTooLarge', 'RequestUriTooLong',
        /// 'UnsupportedMediaType', 'RequestedRangeNotSatisfiable',
        /// 'ExpectationFailed', 'UpgradeRequired', 'InternalServerError',
        /// 'NotImplemented', 'BadGateway', 'ServiceUnavailable',
        /// 'GatewayTimeout', 'HttpVersionNotSupported'</param>
        /// <param name="headers">HTTP headers associated with this
        /// operation.</param>
        /// <param name="operation">OperationResultInfoBaseResource
        /// operation</param>
        public OperationResultInfoBaseResource(HttpStatusCode? statusCode = default(HttpStatusCode?), IDictionary<string, IList<string>> headers = default(IDictionary<string, IList<string>>), OperationResultInfoBase operation = default(OperationResultInfoBase))
            : base(statusCode, headers)
        {
            Operation = operation;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets operationResultInfoBaseResource operation
        /// </summary>
        [JsonProperty(PropertyName = "operation")]
        public OperationResultInfoBase Operation { get; set; }

    }
}
