// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Pre-backup validation for Azure VM Workload provider.
    /// </summary>
    public partial class PreBackupValidation
    {
        /// <summary>
        /// Initializes a new instance of the PreBackupValidation class.
        /// </summary>
        public PreBackupValidation()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PreBackupValidation class.
        /// </summary>
        /// <param name="status">Status of protectable item, i.e.
        /// InProgress,Succeeded,Failed. Possible values include: 'Invalid',
        /// 'Success', 'Failed'</param>
        /// <param name="code">Error code of protectable item</param>
        /// <param name="message">Message corresponding to the error code for
        /// the protectable item</param>
        public PreBackupValidation(string status = default(string), string code = default(string), string message = default(string))
        {
            Status = status;
            Code = code;
            Message = message;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets status of protectable item, i.e.
        /// InProgress,Succeeded,Failed. Possible values include: 'Invalid',
        /// 'Success', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets error code of protectable item
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; set; }

        /// <summary>
        /// Gets or sets message corresponding to the error code for the
        /// protectable item
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

    }
}
