// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Response contract for enable backup validation request
    /// </summary>
    public partial class PreValidateEnableBackupResponse
    {
        /// <summary>
        /// Initializes a new instance of the PreValidateEnableBackupResponse
        /// class.
        /// </summary>
        public PreValidateEnableBackupResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PreValidateEnableBackupResponse
        /// class.
        /// </summary>
        /// <param name="status">Validation Status. Possible values include:
        /// 'Invalid', 'Succeeded', 'Failed'</param>
        /// <param name="errorCode">Response error code</param>
        /// <param name="errorMessage">Response error message</param>
        /// <param name="recommendation">Recommended action for user</param>
        /// <param name="containerName">Specifies the product specific
        /// container name. E.g. iaasvmcontainer;iaasvmcontainer;rgname;vmname.
        /// This is required
        /// for portal</param>
        /// <param name="protectedItemName">Specifies the product specific ds
        /// name. E.g. vm;iaasvmcontainer;rgname;vmname. This is required for
        /// portal</param>
        public PreValidateEnableBackupResponse(string status = default(string), string errorCode = default(string), string errorMessage = default(string), string recommendation = default(string), string containerName = default(string), string protectedItemName = default(string))
        {
            Status = status;
            ErrorCode = errorCode;
            ErrorMessage = errorMessage;
            Recommendation = recommendation;
            ContainerName = containerName;
            ProtectedItemName = protectedItemName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets validation Status. Possible values include: 'Invalid',
        /// 'Succeeded', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets response error code
        /// </summary>
        [JsonProperty(PropertyName = "errorCode")]
        public string ErrorCode { get; set; }

        /// <summary>
        /// Gets or sets response error message
        /// </summary>
        [JsonProperty(PropertyName = "errorMessage")]
        public string ErrorMessage { get; set; }

        /// <summary>
        /// Gets or sets recommended action for user
        /// </summary>
        [JsonProperty(PropertyName = "recommendation")]
        public string Recommendation { get; set; }

        /// <summary>
        /// Gets or sets specifies the product specific container name. E.g.
        /// iaasvmcontainer;iaasvmcontainer;rgname;vmname. This is required
        /// for portal
        /// </summary>
        [JsonProperty(PropertyName = "containerName")]
        public string ContainerName { get; set; }

        /// <summary>
        /// Gets or sets specifies the product specific ds name. E.g.
        /// vm;iaasvmcontainer;rgname;vmname. This is required for portal
        /// </summary>
        [JsonProperty(PropertyName = "protectedItemName")]
        public string ProtectedItemName { get; set; }

    }
}
