// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Base class for backup items.
    /// </summary>
    public partial class ProtectedItem
    {
        /// <summary>
        /// Initializes a new instance of the ProtectedItem class.
        /// </summary>
        public ProtectedItem()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ProtectedItem class.
        /// </summary>
        /// <param name="backupManagementType">Type of backup management for
        /// the backed up item. Possible values include: 'Invalid',
        /// 'AzureIaasVM', 'MAB', 'DPM', 'AzureBackupServer', 'AzureSql',
        /// 'AzureStorage', 'AzureWorkload', 'DefaultBackup'</param>
        /// <param name="workloadType">Type of workload this item represents.
        /// Possible values include: 'Invalid', 'VM', 'FileFolder',
        /// 'AzureSqlDb', 'SQLDB', 'Exchange', 'Sharepoint', 'VMwareVM',
        /// 'SystemState', 'Client', 'GenericDataSource', 'SQLDataBase',
        /// 'AzureFileShare', 'SAPHanaDatabase', 'SAPAseDatabase'</param>
        /// <param name="containerName">Unique name of container</param>
        /// <param name="sourceResourceId">ARM ID of the resource to be backed
        /// up.</param>
        /// <param name="policyId">ID of the backup policy with which this item
        /// is backed up.</param>
        /// <param name="lastRecoveryPoint">Timestamp when the last (latest)
        /// backup copy was created for this backup item.</param>
        /// <param name="backupSetName">Name of the backup set the backup item
        /// belongs to</param>
        /// <param name="createMode">Create mode to indicate recovery of
        /// existing soft deleted data source or creation of new data source.
        /// Possible values include: 'Invalid', 'Default', 'Recover'</param>
        /// <param name="deferredDeleteTimeInUTC">Time for deferred deletion in
        /// UTC</param>
        /// <param name="isScheduledForDeferredDelete">Flag to identify whether
        /// the DS is scheduled for deferred delete</param>
        /// <param name="deferredDeleteTimeRemaining">Time remaining before the
        /// DS marked for deferred delete is permanently deleted</param>
        /// <param name="isDeferredDeleteScheduleUpcoming">Flag to identify
        /// whether the deferred deleted DS is to be purged soon</param>
        /// <param name="isRehydrate">Flag to identify that deferred deleted DS
        /// is to be moved into Pause state</param>
        public ProtectedItem(string backupManagementType = default(string), string workloadType = default(string), string containerName = default(string), string sourceResourceId = default(string), string policyId = default(string), System.DateTime? lastRecoveryPoint = default(System.DateTime?), string backupSetName = default(string), string createMode = default(string), System.DateTime? deferredDeleteTimeInUTC = default(System.DateTime?), bool? isScheduledForDeferredDelete = default(bool?), string deferredDeleteTimeRemaining = default(string), bool? isDeferredDeleteScheduleUpcoming = default(bool?), bool? isRehydrate = default(bool?))
        {
            BackupManagementType = backupManagementType;
            WorkloadType = workloadType;
            ContainerName = containerName;
            SourceResourceId = sourceResourceId;
            PolicyId = policyId;
            LastRecoveryPoint = lastRecoveryPoint;
            BackupSetName = backupSetName;
            CreateMode = createMode;
            DeferredDeleteTimeInUTC = deferredDeleteTimeInUTC;
            IsScheduledForDeferredDelete = isScheduledForDeferredDelete;
            DeferredDeleteTimeRemaining = deferredDeleteTimeRemaining;
            IsDeferredDeleteScheduleUpcoming = isDeferredDeleteScheduleUpcoming;
            IsRehydrate = isRehydrate;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets type of backup management for the backed up item.
        /// Possible values include: 'Invalid', 'AzureIaasVM', 'MAB', 'DPM',
        /// 'AzureBackupServer', 'AzureSql', 'AzureStorage', 'AzureWorkload',
        /// 'DefaultBackup'
        /// </summary>
        [JsonProperty(PropertyName = "backupManagementType")]
        public string BackupManagementType { get; set; }

        /// <summary>
        /// Gets or sets type of workload this item represents. Possible values
        /// include: 'Invalid', 'VM', 'FileFolder', 'AzureSqlDb', 'SQLDB',
        /// 'Exchange', 'Sharepoint', 'VMwareVM', 'SystemState', 'Client',
        /// 'GenericDataSource', 'SQLDataBase', 'AzureFileShare',
        /// 'SAPHanaDatabase', 'SAPAseDatabase'
        /// </summary>
        [JsonProperty(PropertyName = "workloadType")]
        public string WorkloadType { get; set; }

        /// <summary>
        /// Gets or sets unique name of container
        /// </summary>
        [JsonProperty(PropertyName = "containerName")]
        public string ContainerName { get; set; }

        /// <summary>
        /// Gets or sets ARM ID of the resource to be backed up.
        /// </summary>
        [JsonProperty(PropertyName = "sourceResourceId")]
        public string SourceResourceId { get; set; }

        /// <summary>
        /// Gets or sets ID of the backup policy with which this item is backed
        /// up.
        /// </summary>
        [JsonProperty(PropertyName = "policyId")]
        public string PolicyId { get; set; }

        /// <summary>
        /// Gets or sets timestamp when the last (latest) backup copy was
        /// created for this backup item.
        /// </summary>
        [JsonProperty(PropertyName = "lastRecoveryPoint")]
        public System.DateTime? LastRecoveryPoint { get; set; }

        /// <summary>
        /// Gets or sets name of the backup set the backup item belongs to
        /// </summary>
        [JsonProperty(PropertyName = "backupSetName")]
        public string BackupSetName { get; set; }

        /// <summary>
        /// Gets or sets create mode to indicate recovery of existing soft
        /// deleted data source or creation of new data source. Possible values
        /// include: 'Invalid', 'Default', 'Recover'
        /// </summary>
        [JsonProperty(PropertyName = "createMode")]
        public string CreateMode { get; set; }

        /// <summary>
        /// Gets or sets time for deferred deletion in UTC
        /// </summary>
        [JsonProperty(PropertyName = "deferredDeleteTimeInUTC")]
        public System.DateTime? DeferredDeleteTimeInUTC { get; set; }

        /// <summary>
        /// Gets or sets flag to identify whether the DS is scheduled for
        /// deferred delete
        /// </summary>
        [JsonProperty(PropertyName = "isScheduledForDeferredDelete")]
        public bool? IsScheduledForDeferredDelete { get; set; }

        /// <summary>
        /// Gets or sets time remaining before the DS marked for deferred
        /// delete is permanently deleted
        /// </summary>
        [JsonProperty(PropertyName = "deferredDeleteTimeRemaining")]
        public string DeferredDeleteTimeRemaining { get; set; }

        /// <summary>
        /// Gets or sets flag to identify whether the deferred deleted DS is to
        /// be purged soon
        /// </summary>
        [JsonProperty(PropertyName = "isDeferredDeleteScheduleUpcoming")]
        public bool? IsDeferredDeleteScheduleUpcoming { get; set; }

        /// <summary>
        /// Gets or sets flag to identify that deferred deleted DS is to be
        /// moved into Pause state
        /// </summary>
        [JsonProperty(PropertyName = "isRehydrate")]
        public bool? IsRehydrate { get; set; }

    }
}
