// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Filters to list backup items.
    /// </summary>
    public partial class ProtectedItemQueryObject
    {
        /// <summary>
        /// Initializes a new instance of the ProtectedItemQueryObject class.
        /// </summary>
        public ProtectedItemQueryObject()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ProtectedItemQueryObject class.
        /// </summary>
        /// <param name="healthState">Health State for the backed up item.
        /// Possible values include: 'Passed', 'ActionRequired',
        /// 'ActionSuggested', 'Invalid'</param>
        /// <param name="backupManagementType">Backup management type for the
        /// backed up item. Possible values include: 'Invalid', 'AzureIaasVM',
        /// 'MAB', 'DPM', 'AzureBackupServer', 'AzureSql', 'AzureStorage',
        /// 'AzureWorkload', 'DefaultBackup'</param>
        /// <param name="itemType">Type of workload this item represents.
        /// Possible values include: 'Invalid', 'VM', 'FileFolder',
        /// 'AzureSqlDb', 'SQLDB', 'Exchange', 'Sharepoint', 'VMwareVM',
        /// 'SystemState', 'Client', 'GenericDataSource', 'SQLDataBase',
        /// 'AzureFileShare', 'SAPHanaDatabase', 'SAPAseDatabase'</param>
        /// <param name="policyName">Backup policy name associated with the
        /// backup item.</param>
        /// <param name="containerName">Name of the container.</param>
        /// <param name="backupEngineName">Backup Engine name</param>
        /// <param name="friendlyName">Friendly name of protected item</param>
        /// <param name="fabricName">Name of the fabric.</param>
        /// <param name="backupSetName">Name of the backup set.</param>
        public ProtectedItemQueryObject(string healthState = default(string), string backupManagementType = default(string), string itemType = default(string), string policyName = default(string), string containerName = default(string), string backupEngineName = default(string), string friendlyName = default(string), string fabricName = default(string), string backupSetName = default(string))
        {
            HealthState = healthState;
            BackupManagementType = backupManagementType;
            ItemType = itemType;
            PolicyName = policyName;
            ContainerName = containerName;
            BackupEngineName = backupEngineName;
            FriendlyName = friendlyName;
            FabricName = fabricName;
            BackupSetName = backupSetName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets health State for the backed up item. Possible values
        /// include: 'Passed', 'ActionRequired', 'ActionSuggested', 'Invalid'
        /// </summary>
        [JsonProperty(PropertyName = "healthState")]
        public string HealthState { get; set; }

        /// <summary>
        /// Gets or sets backup management type for the backed up item.
        /// Possible values include: 'Invalid', 'AzureIaasVM', 'MAB', 'DPM',
        /// 'AzureBackupServer', 'AzureSql', 'AzureStorage', 'AzureWorkload',
        /// 'DefaultBackup'
        /// </summary>
        [JsonProperty(PropertyName = "backupManagementType")]
        public string BackupManagementType { get; set; }

        /// <summary>
        /// Gets or sets type of workload this item represents. Possible values
        /// include: 'Invalid', 'VM', 'FileFolder', 'AzureSqlDb', 'SQLDB',
        /// 'Exchange', 'Sharepoint', 'VMwareVM', 'SystemState', 'Client',
        /// 'GenericDataSource', 'SQLDataBase', 'AzureFileShare',
        /// 'SAPHanaDatabase', 'SAPAseDatabase'
        /// </summary>
        [JsonProperty(PropertyName = "itemType")]
        public string ItemType { get; set; }

        /// <summary>
        /// Gets or sets backup policy name associated with the backup item.
        /// </summary>
        [JsonProperty(PropertyName = "policyName")]
        public string PolicyName { get; set; }

        /// <summary>
        /// Gets or sets name of the container.
        /// </summary>
        [JsonProperty(PropertyName = "containerName")]
        public string ContainerName { get; set; }

        /// <summary>
        /// Gets or sets backup Engine name
        /// </summary>
        [JsonProperty(PropertyName = "backupEngineName")]
        public string BackupEngineName { get; set; }

        /// <summary>
        /// Gets or sets friendly name of protected item
        /// </summary>
        [JsonProperty(PropertyName = "friendlyName")]
        public string FriendlyName { get; set; }

        /// <summary>
        /// Gets or sets name of the fabric.
        /// </summary>
        [JsonProperty(PropertyName = "fabricName")]
        public string FabricName { get; set; }

        /// <summary>
        /// Gets or sets name of the backup set.
        /// </summary>
        [JsonProperty(PropertyName = "backupSetName")]
        public string BackupSetName { get; set; }

    }
}
