// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Disk configuration
    /// </summary>
    public partial class RecoveryPointDiskConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the RecoveryPointDiskConfiguration
        /// class.
        /// </summary>
        public RecoveryPointDiskConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RecoveryPointDiskConfiguration
        /// class.
        /// </summary>
        /// <param name="numberOfDisksIncludedInBackup">Number of disks
        /// included in backup</param>
        /// <param name="numberOfDisksAttachedToVm">Number of disks attached to
        /// the VM</param>
        /// <param name="includedDiskList">Information of disks included in
        /// backup</param>
        /// <param name="excludedDiskList">Information of disks excluded from
        /// backup</param>
        public RecoveryPointDiskConfiguration(int? numberOfDisksIncludedInBackup = default(int?), int? numberOfDisksAttachedToVm = default(int?), IList<DiskInformation> includedDiskList = default(IList<DiskInformation>), IList<DiskInformation> excludedDiskList = default(IList<DiskInformation>))
        {
            NumberOfDisksIncludedInBackup = numberOfDisksIncludedInBackup;
            NumberOfDisksAttachedToVm = numberOfDisksAttachedToVm;
            IncludedDiskList = includedDiskList;
            ExcludedDiskList = excludedDiskList;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets number of disks included in backup
        /// </summary>
        [JsonProperty(PropertyName = "numberOfDisksIncludedInBackup")]
        public int? NumberOfDisksIncludedInBackup { get; set; }

        /// <summary>
        /// Gets or sets number of disks attached to the VM
        /// </summary>
        [JsonProperty(PropertyName = "numberOfDisksAttachedToVm")]
        public int? NumberOfDisksAttachedToVm { get; set; }

        /// <summary>
        /// Gets or sets information of disks included in backup
        /// </summary>
        [JsonProperty(PropertyName = "includedDiskList")]
        public IList<DiskInformation> IncludedDiskList { get; set; }

        /// <summary>
        /// Gets or sets information of disks excluded from backup
        /// </summary>
        [JsonProperty(PropertyName = "excludedDiskList")]
        public IList<DiskInformation> ExcludedDiskList { get; set; }

    }
}
