// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Restore file specs like file path, type and target folder path info.
    /// </summary>
    public partial class RestoreFileSpecs
    {
        /// <summary>
        /// Initializes a new instance of the RestoreFileSpecs class.
        /// </summary>
        public RestoreFileSpecs()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RestoreFileSpecs class.
        /// </summary>
        /// <param name="path">Source File/Folder path</param>
        /// <param name="fileSpecType">Indicates what the Path variable stands
        /// for</param>
        /// <param name="targetFolderPath">Destination folder path in target
        /// FileShare</param>
        public RestoreFileSpecs(string path = default(string), string fileSpecType = default(string), string targetFolderPath = default(string))
        {
            Path = path;
            FileSpecType = fileSpecType;
            TargetFolderPath = targetFolderPath;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets source File/Folder path
        /// </summary>
        [JsonProperty(PropertyName = "path")]
        public string Path { get; set; }

        /// <summary>
        /// Gets or sets indicates what the Path variable stands for
        /// </summary>
        [JsonProperty(PropertyName = "fileSpecType")]
        public string FileSpecType { get; set; }

        /// <summary>
        /// Gets or sets destination folder path in target FileShare
        /// </summary>
        [JsonProperty(PropertyName = "targetFolderPath")]
        public string TargetFolderPath { get; set; }

    }
}
