// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Retention duration.
    /// </summary>
    public partial class RetentionDuration
    {
        /// <summary>
        /// Initializes a new instance of the RetentionDuration class.
        /// </summary>
        public RetentionDuration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RetentionDuration class.
        /// </summary>
        /// <param name="count">Count of duration types. Retention duration is
        /// obtained by the counting the duration type Count times.
        /// For example, when Count = 3 and DurationType = Weeks, retention
        /// duration will be three weeks.</param>
        /// <param name="durationType">Retention duration type of retention
        /// policy. Possible values include: 'Invalid', 'Days', 'Weeks',
        /// 'Months', 'Years'</param>
        public RetentionDuration(int? count = default(int?), string durationType = default(string))
        {
            Count = count;
            DurationType = durationType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets count of duration types. Retention duration is
        /// obtained by the counting the duration type Count times.
        /// For example, when Count = 3 and DurationType = Weeks, retention
        /// duration will be three weeks.
        /// </summary>
        [JsonProperty(PropertyName = "count")]
        public int? Count { get; set; }

        /// <summary>
        /// Gets or sets retention duration type of retention policy. Possible
        /// values include: 'Invalid', 'Days', 'Weeks', 'Months', 'Years'
        /// </summary>
        [JsonProperty(PropertyName = "durationType")]
        public string DurationType { get; set; }

    }
}
