// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Details about target workload during restore operation.
    /// </summary>
    public partial class TargetRestoreInfo
    {
        /// <summary>
        /// Initializes a new instance of the TargetRestoreInfo class.
        /// </summary>
        public TargetRestoreInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TargetRestoreInfo class.
        /// </summary>
        /// <param name="overwriteOption">Can Overwrite if Target DataBase
        /// already exists. Possible values include: 'Invalid',
        /// 'FailOnConflict', 'Overwrite'</param>
        /// <param name="containerId">Resource Id name of the container in
        /// which Target DataBase resides</param>
        /// <param name="databaseName">Database name InstanceName/DataBaseName
        /// for SQL or System/DbName for SAP Hana</param>
        /// <param name="targetDirectoryForFileRestore">Target directory
        /// location for restore as files.</param>
        public TargetRestoreInfo(string overwriteOption = default(string), string containerId = default(string), string databaseName = default(string), string targetDirectoryForFileRestore = default(string))
        {
            OverwriteOption = overwriteOption;
            ContainerId = containerId;
            DatabaseName = databaseName;
            TargetDirectoryForFileRestore = targetDirectoryForFileRestore;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets can Overwrite if Target DataBase already exists.
        /// Possible values include: 'Invalid', 'FailOnConflict', 'Overwrite'
        /// </summary>
        [JsonProperty(PropertyName = "overwriteOption")]
        public string OverwriteOption { get; set; }

        /// <summary>
        /// Gets or sets resource Id name of the container in which Target
        /// DataBase resides
        /// </summary>
        [JsonProperty(PropertyName = "containerId")]
        public string ContainerId { get; set; }

        /// <summary>
        /// Gets or sets database name InstanceName/DataBaseName for SQL or
        /// System/DbName for SAP Hana
        /// </summary>
        [JsonProperty(PropertyName = "databaseName")]
        public string DatabaseName { get; set; }

        /// <summary>
        /// Gets or sets target directory location for restore as files.
        /// </summary>
        [JsonProperty(PropertyName = "targetDirectoryForFileRestore")]
        public string TargetDirectoryForFileRestore { get; set; }

    }
}
