// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Details of an inquired protectable item.
    /// </summary>
    public partial class WorkloadInquiryDetails
    {
        /// <summary>
        /// Initializes a new instance of the WorkloadInquiryDetails class.
        /// </summary>
        public WorkloadInquiryDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the WorkloadInquiryDetails class.
        /// </summary>
        /// <param name="type">Type of the Workload such as SQL, Oracle
        /// etc.</param>
        /// <param name="itemCount">Contains the protectable item Count inside
        /// this Container.</param>
        /// <param name="inquiryValidation">Inquiry validation such as
        /// permissions and other backup validations.</param>
        public WorkloadInquiryDetails(string type = default(string), long? itemCount = default(long?), InquiryValidation inquiryValidation = default(InquiryValidation))
        {
            Type = type;
            ItemCount = itemCount;
            InquiryValidation = inquiryValidation;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets type of the Workload such as SQL, Oracle etc.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets contains the protectable item Count inside this
        /// Container.
        /// </summary>
        [JsonProperty(PropertyName = "itemCount")]
        public long? ItemCount { get; set; }

        /// <summary>
        /// Gets or sets inquiry validation such as permissions and other
        /// backup validations.
        /// </summary>
        [JsonProperty(PropertyName = "inquiryValidation")]
        public InquiryValidation InquiryValidation { get; set; }

    }
}
