// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ProtectionContainerRefreshOperationResultsOperations.
    /// </summary>
    public static partial class ProtectionContainerRefreshOperationResultsOperationsExtensions
    {
            /// <summary>
            /// Provides the result of the refresh operation triggered by the BeginRefresh
            /// operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='vaultName'>
            /// The name of the recovery services vault.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group where the recovery services vault is
            /// present.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name associated with the container.
            /// </param>
            /// <param name='operationId'>
            /// Operation ID associated with the operation whose result needs to be
            /// fetched.
            /// </param>
            public static void Get(this IProtectionContainerRefreshOperationResultsOperations operations, string vaultName, string resourceGroupName, string fabricName, string operationId)
            {
                operations.GetAsync(vaultName, resourceGroupName, fabricName, operationId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Provides the result of the refresh operation triggered by the BeginRefresh
            /// operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='vaultName'>
            /// The name of the recovery services vault.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group where the recovery services vault is
            /// present.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name associated with the container.
            /// </param>
            /// <param name='operationId'>
            /// Operation ID associated with the operation whose result needs to be
            /// fetched.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task GetAsync(this IProtectionContainerRefreshOperationResultsOperations operations, string vaultName, string resourceGroupName, string fabricName, string operationId, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.GetWithHttpMessagesAsync(vaultName, resourceGroupName, fabricName, operationId, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

    }
}
