// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.Backup
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ProtectionPolicyOperationStatusesOperations.
    /// </summary>
    public static partial class ProtectionPolicyOperationStatusesOperationsExtensions
    {
            /// <summary>
            /// Provides the status of the asynchronous operations like backup, restore.
            /// The status can be in progress, completed
            /// or failed. You can refer to the Operation Status enum for all the possible
            /// states of an operation. Some operations
            /// create jobs. This method returns the list of jobs associated with
            /// operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='vaultName'>
            /// The name of the recovery services vault.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group where the recovery services vault is
            /// present.
            /// </param>
            /// <param name='policyName'>
            /// Backup policy name whose operation's status needs to be fetched.
            /// </param>
            /// <param name='operationId'>
            /// Operation ID which represents an operation whose status needs to be
            /// fetched.
            /// </param>
            public static OperationStatus Get(this IProtectionPolicyOperationStatusesOperations operations, string vaultName, string resourceGroupName, string policyName, string operationId)
            {
                return operations.GetAsync(vaultName, resourceGroupName, policyName, operationId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Provides the status of the asynchronous operations like backup, restore.
            /// The status can be in progress, completed
            /// or failed. You can refer to the Operation Status enum for all the possible
            /// states of an operation. Some operations
            /// create jobs. This method returns the list of jobs associated with
            /// operation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='vaultName'>
            /// The name of the recovery services vault.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group where the recovery services vault is
            /// present.
            /// </param>
            /// <param name='policyName'>
            /// Backup policy name whose operation's status needs to be fetched.
            /// </param>
            /// <param name='operationId'>
            /// Operation ID which represents an operation whose status needs to be
            /// fetched.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<OperationStatus> GetAsync(this IProtectionPolicyOperationStatusesOperations operations, string vaultName, string resourceGroupName, string policyName, string operationId, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(vaultName, resourceGroupName, policyName, operationId, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
