// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// </summary>
    public partial interface ISiteRecoveryManagementClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// The subscription Id.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// The name of the resource group where the recovery services vault is
        /// present.
        /// </summary>
        string ResourceGroupName { get; set; }

        /// <summary>
        /// The name of the recovery services vault.
        /// </summary>
        string ResourceName { get; set; }

        /// <summary>
        /// Client Api Version.
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IOperations.
        /// </summary>
        IOperations Operations { get; }

        /// <summary>
        /// Gets the IReplicationAlertSettingsOperations.
        /// </summary>
        IReplicationAlertSettingsOperations ReplicationAlertSettings { get; }

        /// <summary>
        /// Gets the IReplicationEligibilityResultsOperations.
        /// </summary>
        IReplicationEligibilityResultsOperations ReplicationEligibilityResults { get; }

        /// <summary>
        /// Gets the IReplicationEventsOperations.
        /// </summary>
        IReplicationEventsOperations ReplicationEvents { get; }

        /// <summary>
        /// Gets the IReplicationFabricsOperations.
        /// </summary>
        IReplicationFabricsOperations ReplicationFabrics { get; }

        /// <summary>
        /// Gets the IReplicationLogicalNetworksOperations.
        /// </summary>
        IReplicationLogicalNetworksOperations ReplicationLogicalNetworks { get; }

        /// <summary>
        /// Gets the IReplicationNetworksOperations.
        /// </summary>
        IReplicationNetworksOperations ReplicationNetworks { get; }

        /// <summary>
        /// Gets the IReplicationNetworkMappingsOperations.
        /// </summary>
        IReplicationNetworkMappingsOperations ReplicationNetworkMappings { get; }

        /// <summary>
        /// Gets the IReplicationProtectionContainersOperations.
        /// </summary>
        IReplicationProtectionContainersOperations ReplicationProtectionContainers { get; }

        /// <summary>
        /// Gets the IReplicationMigrationItemsOperations.
        /// </summary>
        IReplicationMigrationItemsOperations ReplicationMigrationItems { get; }

        /// <summary>
        /// Gets the IMigrationRecoveryPointsOperations.
        /// </summary>
        IMigrationRecoveryPointsOperations MigrationRecoveryPoints { get; }

        /// <summary>
        /// Gets the IReplicationProtectableItemsOperations.
        /// </summary>
        IReplicationProtectableItemsOperations ReplicationProtectableItems { get; }

        /// <summary>
        /// Gets the IReplicationProtectedItemsOperations.
        /// </summary>
        IReplicationProtectedItemsOperations ReplicationProtectedItems { get; }

        /// <summary>
        /// Gets the IRecoveryPointsOperations.
        /// </summary>
        IRecoveryPointsOperations RecoveryPoints { get; }

        /// <summary>
        /// Gets the ITargetComputeSizesOperations.
        /// </summary>
        ITargetComputeSizesOperations TargetComputeSizes { get; }

        /// <summary>
        /// Gets the IReplicationProtectionContainerMappingsOperations.
        /// </summary>
        IReplicationProtectionContainerMappingsOperations ReplicationProtectionContainerMappings { get; }

        /// <summary>
        /// Gets the IReplicationRecoveryServicesProvidersOperations.
        /// </summary>
        IReplicationRecoveryServicesProvidersOperations ReplicationRecoveryServicesProviders { get; }

        /// <summary>
        /// Gets the IReplicationStorageClassificationsOperations.
        /// </summary>
        IReplicationStorageClassificationsOperations ReplicationStorageClassifications { get; }

        /// <summary>
        /// Gets the IReplicationStorageClassificationMappingsOperations.
        /// </summary>
        IReplicationStorageClassificationMappingsOperations ReplicationStorageClassificationMappings { get; }

        /// <summary>
        /// Gets the IReplicationvCentersOperations.
        /// </summary>
        IReplicationvCentersOperations ReplicationvCenters { get; }

        /// <summary>
        /// Gets the IReplicationJobsOperations.
        /// </summary>
        IReplicationJobsOperations ReplicationJobs { get; }

        /// <summary>
        /// Gets the IReplicationPoliciesOperations.
        /// </summary>
        IReplicationPoliciesOperations ReplicationPolicies { get; }

        /// <summary>
        /// Gets the IReplicationRecoveryPlansOperations.
        /// </summary>
        IReplicationRecoveryPlansOperations ReplicationRecoveryPlans { get; }

        /// <summary>
        /// Gets the ISupportedOperatingSystemsOperations.
        /// </summary>
        ISupportedOperatingSystemsOperations SupportedOperatingSystems { get; }

        /// <summary>
        /// Gets the IReplicationVaultHealthOperations.
        /// </summary>
        IReplicationVaultHealthOperations ReplicationVaultHealth { get; }

        /// <summary>
        /// Gets the IReplicationVaultSettingOperations.
        /// </summary>
        IReplicationVaultSettingOperations ReplicationVaultSetting { get; }

    }
}
