// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for MigrationRecoveryPointsOperations.
    /// </summary>
    public static partial class MigrationRecoveryPointsOperationsExtensions
    {
            /// <summary>
            /// Gets the recovery points for a migration item.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric unique name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='migrationItemName'>
            /// Migration item name.
            /// </param>
            public static IPage<MigrationRecoveryPoint> ListByReplicationMigrationItems(this IMigrationRecoveryPointsOperations operations, string fabricName, string protectionContainerName, string migrationItemName)
            {
                return operations.ListByReplicationMigrationItemsAsync(fabricName, protectionContainerName, migrationItemName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the recovery points for a migration item.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric unique name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='migrationItemName'>
            /// Migration item name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<MigrationRecoveryPoint>> ListByReplicationMigrationItemsAsync(this IMigrationRecoveryPointsOperations operations, string fabricName, string protectionContainerName, string migrationItemName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByReplicationMigrationItemsWithHttpMessagesAsync(fabricName, protectionContainerName, migrationItemName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets a recovery point for a migration item.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric unique name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='migrationItemName'>
            /// Migration item name.
            /// </param>
            /// <param name='migrationRecoveryPointName'>
            /// The migration recovery point name.
            /// </param>
            public static MigrationRecoveryPoint Get(this IMigrationRecoveryPointsOperations operations, string fabricName, string protectionContainerName, string migrationItemName, string migrationRecoveryPointName)
            {
                return operations.GetAsync(fabricName, protectionContainerName, migrationItemName, migrationRecoveryPointName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets a recovery point for a migration item.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric unique name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='migrationItemName'>
            /// Migration item name.
            /// </param>
            /// <param name='migrationRecoveryPointName'>
            /// The migration recovery point name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<MigrationRecoveryPoint> GetAsync(this IMigrationRecoveryPointsOperations operations, string fabricName, string protectionContainerName, string migrationItemName, string migrationRecoveryPointName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(fabricName, protectionContainerName, migrationItemName, migrationRecoveryPointName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the recovery points for a migration item.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<MigrationRecoveryPoint> ListByReplicationMigrationItemsNext(this IMigrationRecoveryPointsOperations operations, string nextPageLink)
            {
                return operations.ListByReplicationMigrationItemsNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the recovery points for a migration item.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<MigrationRecoveryPoint>> ListByReplicationMigrationItemsNextAsync(this IMigrationRecoveryPointsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByReplicationMigrationItemsNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
