// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A2A provider specific input for failover.
    /// </summary>
    [Newtonsoft.Json.JsonObject("A2A")]
    public partial class A2AFailoverProviderInput : ProviderSpecificFailoverInput
    {
        /// <summary>
        /// Initializes a new instance of the A2AFailoverProviderInput class.
        /// </summary>
        public A2AFailoverProviderInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the A2AFailoverProviderInput class.
        /// </summary>
        /// <param name="recoveryPointId">The recovery point id to be passed to
        /// failover to a particular recovery point. In case of latest recovery
        /// point, null should be passed.</param>
        /// <param name="cloudServiceCreationOption">A value indicating whether
        /// to use recovery cloud service for TFO or not.</param>
        public A2AFailoverProviderInput(string recoveryPointId = default(string), string cloudServiceCreationOption = default(string))
        {
            RecoveryPointId = recoveryPointId;
            CloudServiceCreationOption = cloudServiceCreationOption;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the recovery point id to be passed to failover to a
        /// particular recovery point. In case of latest recovery point, null
        /// should be passed.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPointId")]
        public string RecoveryPointId { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether to use recovery cloud
        /// service for TFO or not.
        /// </summary>
        [JsonProperty(PropertyName = "cloudServiceCreationOption")]
        public string CloudServiceCreationOption { get; set; }

    }
}
