// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Azure VM managed disk update input details.
    /// </summary>
    public partial class A2AVmManagedDiskUpdateDetails
    {
        /// <summary>
        /// Initializes a new instance of the A2AVmManagedDiskUpdateDetails
        /// class.
        /// </summary>
        public A2AVmManagedDiskUpdateDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the A2AVmManagedDiskUpdateDetails
        /// class.
        /// </summary>
        /// <param name="diskId">The disk Id.</param>
        /// <param name="recoveryTargetDiskAccountType">The target disk type
        /// before failover.</param>
        /// <param name="recoveryReplicaDiskAccountType">The replica disk type
        /// before failover.</param>
        /// <param name="diskEncryptionInfo">The recovery disk encryption
        /// information (for one / single pass flows).</param>
        /// <param name="failoverDiskName">The target disk name for unplanned
        /// failover operation.</param>
        /// <param name="tfoDiskName">The target disk name for test failover
        /// operation.</param>
        public A2AVmManagedDiskUpdateDetails(string diskId = default(string), string recoveryTargetDiskAccountType = default(string), string recoveryReplicaDiskAccountType = default(string), DiskEncryptionInfo diskEncryptionInfo = default(DiskEncryptionInfo), string failoverDiskName = default(string), string tfoDiskName = default(string))
        {
            DiskId = diskId;
            RecoveryTargetDiskAccountType = recoveryTargetDiskAccountType;
            RecoveryReplicaDiskAccountType = recoveryReplicaDiskAccountType;
            DiskEncryptionInfo = diskEncryptionInfo;
            FailoverDiskName = failoverDiskName;
            TfoDiskName = tfoDiskName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the disk Id.
        /// </summary>
        [JsonProperty(PropertyName = "diskId")]
        public string DiskId { get; set; }

        /// <summary>
        /// Gets or sets the target disk type before failover.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryTargetDiskAccountType")]
        public string RecoveryTargetDiskAccountType { get; set; }

        /// <summary>
        /// Gets or sets the replica disk type before failover.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryReplicaDiskAccountType")]
        public string RecoveryReplicaDiskAccountType { get; set; }

        /// <summary>
        /// Gets or sets the recovery disk encryption information (for one /
        /// single pass flows).
        /// </summary>
        [JsonProperty(PropertyName = "diskEncryptionInfo")]
        public DiskEncryptionInfo DiskEncryptionInfo { get; set; }

        /// <summary>
        /// Gets or sets the target disk name for unplanned failover operation.
        /// </summary>
        [JsonProperty(PropertyName = "failoverDiskName")]
        public string FailoverDiskName { get; set; }

        /// <summary>
        /// Gets or sets the target disk name for test failover operation.
        /// </summary>
        [JsonProperty(PropertyName = "tfoDiskName")]
        public string TfoDiskName { get; set; }

    }
}
