// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Task of the Job.
    /// </summary>
    public partial class ASRTask
    {
        /// <summary>
        /// Initializes a new instance of the ASRTask class.
        /// </summary>
        public ASRTask()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ASRTask class.
        /// </summary>
        /// <param name="taskId">The Id.</param>
        /// <param name="name">The unique Task name.</param>
        /// <param name="startTime">The start time.</param>
        /// <param name="endTime">The end time.</param>
        /// <param name="allowedActions">The state/actions applicable on this
        /// task.</param>
        /// <param name="friendlyName">The name.</param>
        /// <param name="state">The State. It is one of these values -
        /// NotStarted, InProgress, Succeeded, Failed, Cancelled, Suspended or
        /// Other.</param>
        /// <param name="stateDescription">The description of the task state.
        /// For example - For Succeeded state, description can be Completed,
        /// PartiallySucceeded, CompletedWithInformation or Skipped.</param>
        /// <param name="taskType">The type of task. Details in CustomDetails
        /// property depend on this type.</param>
        /// <param name="customDetails">The custom task details based on the
        /// task type.</param>
        /// <param name="groupTaskCustomDetails">The custom task details based
        /// on the task type, if the task type is GroupTaskDetails or one of
        /// the types derived from it.</param>
        /// <param name="errors">The task error details.</param>
        public ASRTask(string taskId = default(string), string name = default(string), System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), IList<string> allowedActions = default(IList<string>), string friendlyName = default(string), string state = default(string), string stateDescription = default(string), string taskType = default(string), TaskTypeDetails customDetails = default(TaskTypeDetails), GroupTaskDetails groupTaskCustomDetails = default(GroupTaskDetails), IList<JobErrorDetails> errors = default(IList<JobErrorDetails>))
        {
            TaskId = taskId;
            Name = name;
            StartTime = startTime;
            EndTime = endTime;
            AllowedActions = allowedActions;
            FriendlyName = friendlyName;
            State = state;
            StateDescription = stateDescription;
            TaskType = taskType;
            CustomDetails = customDetails;
            GroupTaskCustomDetails = groupTaskCustomDetails;
            Errors = errors;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Id.
        /// </summary>
        [JsonProperty(PropertyName = "taskId")]
        public string TaskId { get; set; }

        /// <summary>
        /// Gets or sets the unique Task name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the start time.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; set; }

        /// <summary>
        /// Gets or sets the end time.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; set; }

        /// <summary>
        /// Gets or sets the state/actions applicable on this task.
        /// </summary>
        [JsonProperty(PropertyName = "allowedActions")]
        public IList<string> AllowedActions { get; set; }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        [JsonProperty(PropertyName = "friendlyName")]
        public string FriendlyName { get; set; }

        /// <summary>
        /// Gets or sets the State. It is one of these values - NotStarted,
        /// InProgress, Succeeded, Failed, Cancelled, Suspended or Other.
        /// </summary>
        [JsonProperty(PropertyName = "state")]
        public string State { get; set; }

        /// <summary>
        /// Gets or sets the description of the task state. For example - For
        /// Succeeded state, description can be Completed, PartiallySucceeded,
        /// CompletedWithInformation or Skipped.
        /// </summary>
        [JsonProperty(PropertyName = "stateDescription")]
        public string StateDescription { get; set; }

        /// <summary>
        /// Gets or sets the type of task. Details in CustomDetails property
        /// depend on this type.
        /// </summary>
        [JsonProperty(PropertyName = "taskType")]
        public string TaskType { get; set; }

        /// <summary>
        /// Gets or sets the custom task details based on the task type.
        /// </summary>
        [JsonProperty(PropertyName = "customDetails")]
        public TaskTypeDetails CustomDetails { get; set; }

        /// <summary>
        /// Gets or sets the custom task details based on the task type, if the
        /// task type is GroupTaskDetails or one of the types derived from it.
        /// </summary>
        [JsonProperty(PropertyName = "groupTaskCustomDetails")]
        public GroupTaskDetails GroupTaskCustomDetails { get; set; }

        /// <summary>
        /// Gets or sets the task error details.
        /// </summary>
        [JsonProperty(PropertyName = "errors")]
        public IList<JobErrorDetails> Errors { get; set; }

    }
}
