// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This class represents the task details for an automation runbook.
    /// </summary>
    public partial class AutomationRunbookTaskDetails : TaskTypeDetails
    {
        /// <summary>
        /// Initializes a new instance of the AutomationRunbookTaskDetails
        /// class.
        /// </summary>
        public AutomationRunbookTaskDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AutomationRunbookTaskDetails
        /// class.
        /// </summary>
        /// <param name="name">The recovery plan task name.</param>
        /// <param name="cloudServiceName">The cloud service of the automation
        /// runbook account.</param>
        /// <param name="subscriptionId">The subscription Id of the automation
        /// runbook account.</param>
        /// <param name="accountName">The automation account name of the
        /// runbook.</param>
        /// <param name="runbookId">The runbook Id.</param>
        /// <param name="runbookName">The runbook name.</param>
        /// <param name="jobId">The job Id of the runbook execution.</param>
        /// <param name="jobOutput">The execution output of the
        /// runbook.</param>
        /// <param name="isPrimarySideScript">A value indicating whether it is
        /// a primary side script or not.</param>
        public AutomationRunbookTaskDetails(string name = default(string), string cloudServiceName = default(string), string subscriptionId = default(string), string accountName = default(string), string runbookId = default(string), string runbookName = default(string), string jobId = default(string), string jobOutput = default(string), bool? isPrimarySideScript = default(bool?))
        {
            Name = name;
            CloudServiceName = cloudServiceName;
            SubscriptionId = subscriptionId;
            AccountName = accountName;
            RunbookId = runbookId;
            RunbookName = runbookName;
            JobId = jobId;
            JobOutput = jobOutput;
            IsPrimarySideScript = isPrimarySideScript;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the recovery plan task name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the cloud service of the automation runbook account.
        /// </summary>
        [JsonProperty(PropertyName = "cloudServiceName")]
        public string CloudServiceName { get; set; }

        /// <summary>
        /// Gets or sets the subscription Id of the automation runbook account.
        /// </summary>
        [JsonProperty(PropertyName = "subscriptionId")]
        public string SubscriptionId { get; set; }

        /// <summary>
        /// Gets or sets the automation account name of the runbook.
        /// </summary>
        [JsonProperty(PropertyName = "accountName")]
        public string AccountName { get; set; }

        /// <summary>
        /// Gets or sets the runbook Id.
        /// </summary>
        [JsonProperty(PropertyName = "runbookId")]
        public string RunbookId { get; set; }

        /// <summary>
        /// Gets or sets the runbook name.
        /// </summary>
        [JsonProperty(PropertyName = "runbookName")]
        public string RunbookName { get; set; }

        /// <summary>
        /// Gets or sets the job Id of the runbook execution.
        /// </summary>
        [JsonProperty(PropertyName = "jobId")]
        public string JobId { get; set; }

        /// <summary>
        /// Gets or sets the execution output of the runbook.
        /// </summary>
        [JsonProperty(PropertyName = "jobOutput")]
        public string JobOutput { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether it is a primary side script
        /// or not.
        /// </summary>
        [JsonProperty(PropertyName = "isPrimarySideScript")]
        public bool? IsPrimarySideScript { get; set; }

    }
}
