// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Recovery disk encryption info (BEK and KEK).
    /// </summary>
    public partial class DiskEncryptionInfo
    {
        /// <summary>
        /// Initializes a new instance of the DiskEncryptionInfo class.
        /// </summary>
        public DiskEncryptionInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DiskEncryptionInfo class.
        /// </summary>
        /// <param name="diskEncryptionKeyInfo">The recovery KeyVault reference
        /// for secret.</param>
        /// <param name="keyEncryptionKeyInfo">The recovery KeyVault reference
        /// for key.</param>
        public DiskEncryptionInfo(DiskEncryptionKeyInfo diskEncryptionKeyInfo = default(DiskEncryptionKeyInfo), KeyEncryptionKeyInfo keyEncryptionKeyInfo = default(KeyEncryptionKeyInfo))
        {
            DiskEncryptionKeyInfo = diskEncryptionKeyInfo;
            KeyEncryptionKeyInfo = keyEncryptionKeyInfo;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the recovery KeyVault reference for secret.
        /// </summary>
        [JsonProperty(PropertyName = "diskEncryptionKeyInfo")]
        public DiskEncryptionKeyInfo DiskEncryptionKeyInfo { get; set; }

        /// <summary>
        /// Gets or sets the recovery KeyVault reference for key.
        /// </summary>
        [JsonProperty(PropertyName = "keyEncryptionKeyInfo")]
        public KeyEncryptionKeyInfo KeyEncryptionKeyInfo { get; set; }

    }
}
