// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Disk Encryption Key Information (BitLocker Encryption Key (BEK) on
    /// Windows).
    /// </summary>
    public partial class DiskEncryptionKeyInfo
    {
        /// <summary>
        /// Initializes a new instance of the DiskEncryptionKeyInfo class.
        /// </summary>
        public DiskEncryptionKeyInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DiskEncryptionKeyInfo class.
        /// </summary>
        /// <param name="secretIdentifier">The secret url / identifier.</param>
        /// <param name="keyVaultResourceArmId">The KeyVault resource ARM id
        /// for secret.</param>
        public DiskEncryptionKeyInfo(string secretIdentifier = default(string), string keyVaultResourceArmId = default(string))
        {
            SecretIdentifier = secretIdentifier;
            KeyVaultResourceArmId = keyVaultResourceArmId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the secret url / identifier.
        /// </summary>
        [JsonProperty(PropertyName = "secretIdentifier")]
        public string SecretIdentifier { get; set; }

        /// <summary>
        /// Gets or sets the KeyVault resource ARM id for secret.
        /// </summary>
        [JsonProperty(PropertyName = "keyVaultResourceArmId")]
        public string KeyVaultResourceArmId { get; set; }

    }
}
