// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Implements the event query parameter.
    /// </summary>
    public partial class EventQueryParameter
    {
        /// <summary>
        /// Initializes a new instance of the EventQueryParameter class.
        /// </summary>
        public EventQueryParameter()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EventQueryParameter class.
        /// </summary>
        /// <param name="eventCode">The source id of the events to be
        /// queried.</param>
        /// <param name="severity">The severity of the events to be
        /// queried.</param>
        /// <param name="eventType">The type of the events to be
        /// queried.</param>
        /// <param name="fabricName">The affected object server id of the
        /// events to be queried.</param>
        /// <param name="affectedObjectFriendlyName">The affected object name
        /// of the events to be queried.</param>
        /// <param name="startTime">The start time of the time range within
        /// which the events are to be queried.</param>
        /// <param name="endTime">The end time of the time range within which
        /// the events are to be queried.</param>
        public EventQueryParameter(string eventCode = default(string), string severity = default(string), string eventType = default(string), string fabricName = default(string), string affectedObjectFriendlyName = default(string), System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?))
        {
            EventCode = eventCode;
            Severity = severity;
            EventType = eventType;
            FabricName = fabricName;
            AffectedObjectFriendlyName = affectedObjectFriendlyName;
            StartTime = startTime;
            EndTime = endTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the source id of the events to be queried.
        /// </summary>
        [JsonProperty(PropertyName = "eventCode")]
        public string EventCode { get; set; }

        /// <summary>
        /// Gets or sets the severity of the events to be queried.
        /// </summary>
        [JsonProperty(PropertyName = "severity")]
        public string Severity { get; set; }

        /// <summary>
        /// Gets or sets the type of the events to be queried.
        /// </summary>
        [JsonProperty(PropertyName = "eventType")]
        public string EventType { get; set; }

        /// <summary>
        /// Gets or sets the affected object server id of the events to be
        /// queried.
        /// </summary>
        [JsonProperty(PropertyName = "fabricName")]
        public string FabricName { get; set; }

        /// <summary>
        /// Gets or sets the affected object name of the events to be queried.
        /// </summary>
        [JsonProperty(PropertyName = "affectedObjectFriendlyName")]
        public string AffectedObjectFriendlyName { get; set; }

        /// <summary>
        /// Gets or sets the start time of the time range within which the
        /// events are to be queried.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; set; }

        /// <summary>
        /// Gets or sets the end time of the time range within which the events
        /// are to be queried.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; set; }

    }
}
