// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Hyper-V Replica Azure specific protection profile details.
    /// </summary>
    [Newtonsoft.Json.JsonObject("HyperVReplicaAzure")]
    public partial class HyperVReplicaAzurePolicyDetails : PolicyProviderSpecificDetails
    {
        /// <summary>
        /// Initializes a new instance of the HyperVReplicaAzurePolicyDetails
        /// class.
        /// </summary>
        public HyperVReplicaAzurePolicyDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the HyperVReplicaAzurePolicyDetails
        /// class.
        /// </summary>
        /// <param name="recoveryPointHistoryDurationInHours">The duration (in
        /// hours) to which point the recovery history needs to be
        /// maintained.</param>
        /// <param name="applicationConsistentSnapshotFrequencyInHours">The
        /// interval (in hours) at which Hyper-V Replica should create an
        /// application consistent snapshot within the VM.</param>
        /// <param name="replicationInterval">The replication interval.</param>
        /// <param name="onlineReplicationStartTime">The scheduled start time
        /// for the initial replication. If this parameter is Null, the initial
        /// replication starts immediately.</param>
        /// <param name="encryption">A value indicating whether encryption is
        /// enabled for virtual machines in this cloud.</param>
        /// <param name="activeStorageAccountId">The active storage account
        /// Id.</param>
        public HyperVReplicaAzurePolicyDetails(int? recoveryPointHistoryDurationInHours = default(int?), int? applicationConsistentSnapshotFrequencyInHours = default(int?), int? replicationInterval = default(int?), string onlineReplicationStartTime = default(string), string encryption = default(string), string activeStorageAccountId = default(string))
        {
            RecoveryPointHistoryDurationInHours = recoveryPointHistoryDurationInHours;
            ApplicationConsistentSnapshotFrequencyInHours = applicationConsistentSnapshotFrequencyInHours;
            ReplicationInterval = replicationInterval;
            OnlineReplicationStartTime = onlineReplicationStartTime;
            Encryption = encryption;
            ActiveStorageAccountId = activeStorageAccountId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the duration (in hours) to which point the recovery
        /// history needs to be maintained.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPointHistoryDurationInHours")]
        public int? RecoveryPointHistoryDurationInHours { get; set; }

        /// <summary>
        /// Gets or sets the interval (in hours) at which Hyper-V Replica
        /// should create an application consistent snapshot within the VM.
        /// </summary>
        [JsonProperty(PropertyName = "applicationConsistentSnapshotFrequencyInHours")]
        public int? ApplicationConsistentSnapshotFrequencyInHours { get; set; }

        /// <summary>
        /// Gets or sets the replication interval.
        /// </summary>
        [JsonProperty(PropertyName = "replicationInterval")]
        public int? ReplicationInterval { get; set; }

        /// <summary>
        /// Gets or sets the scheduled start time for the initial replication.
        /// If this parameter is Null, the initial replication starts
        /// immediately.
        /// </summary>
        [JsonProperty(PropertyName = "onlineReplicationStartTime")]
        public string OnlineReplicationStartTime { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether encryption is enabled for
        /// virtual machines in this cloud.
        /// </summary>
        [JsonProperty(PropertyName = "encryption")]
        public string Encryption { get; set; }

        /// <summary>
        /// Gets or sets the active storage account Id.
        /// </summary>
        [JsonProperty(PropertyName = "activeStorageAccountId")]
        public string ActiveStorageAccountId { get; set; }

    }
}
