// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Azure specific reprotect input.
    /// </summary>
    [Newtonsoft.Json.JsonObject("HyperVReplicaAzure")]
    public partial class HyperVReplicaAzureReprotectInput : ReverseReplicationProviderSpecificInput
    {
        /// <summary>
        /// Initializes a new instance of the HyperVReplicaAzureReprotectInput
        /// class.
        /// </summary>
        public HyperVReplicaAzureReprotectInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the HyperVReplicaAzureReprotectInput
        /// class.
        /// </summary>
        /// <param name="hvHostVmId">The Hyper-V host Vm Id.</param>
        /// <param name="vmName">The Vm Name.</param>
        /// <param name="osType">The OS type associated with vm.</param>
        /// <param name="vHDId">The OS disk VHD id associated with vm.</param>
        /// <param name="storageAccountId">The storage account name.</param>
        /// <param name="logStorageAccountId">The storage account to be used
        /// for logging during replication.</param>
        public HyperVReplicaAzureReprotectInput(string hvHostVmId = default(string), string vmName = default(string), string osType = default(string), string vHDId = default(string), string storageAccountId = default(string), string logStorageAccountId = default(string))
        {
            HvHostVmId = hvHostVmId;
            VmName = vmName;
            OsType = osType;
            VHDId = vHDId;
            StorageAccountId = storageAccountId;
            LogStorageAccountId = logStorageAccountId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Hyper-V host Vm Id.
        /// </summary>
        [JsonProperty(PropertyName = "hvHostVmId")]
        public string HvHostVmId { get; set; }

        /// <summary>
        /// Gets or sets the Vm Name.
        /// </summary>
        [JsonProperty(PropertyName = "vmName")]
        public string VmName { get; set; }

        /// <summary>
        /// Gets or sets the OS type associated with vm.
        /// </summary>
        [JsonProperty(PropertyName = "osType")]
        public string OsType { get; set; }

        /// <summary>
        /// Gets or sets the OS disk VHD id associated with vm.
        /// </summary>
        [JsonProperty(PropertyName = "vHDId")]
        public string VHDId { get; set; }

        /// <summary>
        /// Gets or sets the storage account name.
        /// </summary>
        [JsonProperty(PropertyName = "storageAccountId")]
        public string StorageAccountId { get; set; }

        /// <summary>
        /// Gets or sets the storage account to be used for logging during
        /// replication.
        /// </summary>
        [JsonProperty(PropertyName = "logStorageAccountId")]
        public string LogStorageAccountId { get; set; }

    }
}
