// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// HyperV replica Azure input to update replication protected item.
    /// </summary>
    [Newtonsoft.Json.JsonObject("HyperVReplicaAzure")]
    public partial class HyperVReplicaAzureUpdateReplicationProtectedItemInput : UpdateReplicationProtectedItemProviderInput
    {
        /// <summary>
        /// Initializes a new instance of the
        /// HyperVReplicaAzureUpdateReplicationProtectedItemInput class.
        /// </summary>
        public HyperVReplicaAzureUpdateReplicationProtectedItemInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// HyperVReplicaAzureUpdateReplicationProtectedItemInput class.
        /// </summary>
        /// <param name="recoveryAzureV1ResourceGroupId">The recovery Azure
        /// resource group Id for classic deployment.</param>
        /// <param name="recoveryAzureV2ResourceGroupId">The recovery Azure
        /// resource group Id for resource manager deployment.</param>
        /// <param name="useManagedDisks">A value indicating whether managed
        /// disks should be used during failover.</param>
        /// <param name="diskIdToDiskEncryptionMap">The dictionary of disk
        /// resource Id to disk encryption set ARM Id.</param>
        public HyperVReplicaAzureUpdateReplicationProtectedItemInput(string recoveryAzureV1ResourceGroupId = default(string), string recoveryAzureV2ResourceGroupId = default(string), string useManagedDisks = default(string), IDictionary<string, string> diskIdToDiskEncryptionMap = default(IDictionary<string, string>))
        {
            RecoveryAzureV1ResourceGroupId = recoveryAzureV1ResourceGroupId;
            RecoveryAzureV2ResourceGroupId = recoveryAzureV2ResourceGroupId;
            UseManagedDisks = useManagedDisks;
            DiskIdToDiskEncryptionMap = diskIdToDiskEncryptionMap;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the recovery Azure resource group Id for classic
        /// deployment.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryAzureV1ResourceGroupId")]
        public string RecoveryAzureV1ResourceGroupId { get; set; }

        /// <summary>
        /// Gets or sets the recovery Azure resource group Id for resource
        /// manager deployment.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryAzureV2ResourceGroupId")]
        public string RecoveryAzureV2ResourceGroupId { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether managed disks should be
        /// used during failover.
        /// </summary>
        [JsonProperty(PropertyName = "useManagedDisks")]
        public string UseManagedDisks { get; set; }

        /// <summary>
        /// Gets or sets the dictionary of disk resource Id to disk encryption
        /// set ARM Id.
        /// </summary>
        [JsonProperty(PropertyName = "diskIdToDiskEncryptionMap")]
        public IDictionary<string, string> DiskIdToDiskEncryptionMap { get; set; }

    }
}
