// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// HyperV replica 2012 replication details.
    /// </summary>
    [Newtonsoft.Json.JsonObject("HyperVReplica2012")]
    public partial class HyperVReplicaReplicationDetails : ReplicationProviderSpecificSettings
    {
        /// <summary>
        /// Initializes a new instance of the HyperVReplicaReplicationDetails
        /// class.
        /// </summary>
        public HyperVReplicaReplicationDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the HyperVReplicaReplicationDetails
        /// class.
        /// </summary>
        /// <param name="lastReplicatedTime">The Last replication time.</param>
        /// <param name="vmNics">The PE Network details.</param>
        /// <param name="vmId">The virtual machine Id.</param>
        /// <param name="vmProtectionState">The protection state for the
        /// vm.</param>
        /// <param name="vmProtectionStateDescription">The protection state
        /// description for the vm.</param>
        /// <param name="initialReplicationDetails">Initial replication
        /// details.</param>
        /// <param name="vMDiskDetails">VM disk details.</param>
        public HyperVReplicaReplicationDetails(System.DateTime? lastReplicatedTime = default(System.DateTime?), IList<VMNicDetails> vmNics = default(IList<VMNicDetails>), string vmId = default(string), string vmProtectionState = default(string), string vmProtectionStateDescription = default(string), InitialReplicationDetails initialReplicationDetails = default(InitialReplicationDetails), IList<DiskDetails> vMDiskDetails = default(IList<DiskDetails>))
        {
            LastReplicatedTime = lastReplicatedTime;
            VmNics = vmNics;
            VmId = vmId;
            VmProtectionState = vmProtectionState;
            VmProtectionStateDescription = vmProtectionStateDescription;
            InitialReplicationDetails = initialReplicationDetails;
            VMDiskDetails = vMDiskDetails;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Last replication time.
        /// </summary>
        [JsonProperty(PropertyName = "lastReplicatedTime")]
        public System.DateTime? LastReplicatedTime { get; set; }

        /// <summary>
        /// Gets or sets the PE Network details.
        /// </summary>
        [JsonProperty(PropertyName = "vmNics")]
        public IList<VMNicDetails> VmNics { get; set; }

        /// <summary>
        /// Gets or sets the virtual machine Id.
        /// </summary>
        [JsonProperty(PropertyName = "vmId")]
        public string VmId { get; set; }

        /// <summary>
        /// Gets or sets the protection state for the vm.
        /// </summary>
        [JsonProperty(PropertyName = "vmProtectionState")]
        public string VmProtectionState { get; set; }

        /// <summary>
        /// Gets or sets the protection state description for the vm.
        /// </summary>
        [JsonProperty(PropertyName = "vmProtectionStateDescription")]
        public string VmProtectionStateDescription { get; set; }

        /// <summary>
        /// Gets or sets initial replication details.
        /// </summary>
        [JsonProperty(PropertyName = "initialReplicationDetails")]
        public InitialReplicationDetails InitialReplicationDetails { get; set; }

        /// <summary>
        /// Gets or sets VM disk details.
        /// </summary>
        [JsonProperty(PropertyName = "vMDiskDetails")]
        public IList<DiskDetails> VMDiskDetails { get; set; }

    }
}
