// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// IP configuration details.
    /// </summary>
    public partial class IPConfig
    {
        /// <summary>
        /// Initializes a new instance of the IPConfig class.
        /// </summary>
        public IPConfig()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IPConfig class.
        /// </summary>
        /// <param name="staticIPAddress">The static IP address of the IP
        /// configuration.</param>
        /// <param name="publicIpAddressId">The Id of the public IP address
        /// associated with the IP configuration.</param>
        /// <param name="lBBackendAddressPoolIds">The backend address pools
        /// associated with the IP configuration.</param>
        public IPConfig(string staticIPAddress = default(string), string publicIpAddressId = default(string), IList<string> lBBackendAddressPoolIds = default(IList<string>))
        {
            StaticIPAddress = staticIPAddress;
            PublicIpAddressId = publicIpAddressId;
            LBBackendAddressPoolIds = lBBackendAddressPoolIds;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the static IP address of the IP configuration.
        /// </summary>
        [JsonProperty(PropertyName = "staticIPAddress")]
        public string StaticIPAddress { get; set; }

        /// <summary>
        /// Gets or sets the Id of the public IP address associated with the IP
        /// configuration.
        /// </summary>
        [JsonProperty(PropertyName = "publicIpAddressId")]
        public string PublicIpAddressId { get; set; }

        /// <summary>
        /// Gets or sets the backend address pools associated with the IP
        /// configuration.
        /// </summary>
        [JsonProperty(PropertyName = "lBBackendAddressPoolIds")]
        public IList<string> LBBackendAddressPoolIds { get; set; }

    }
}
