// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Identity provider details.
    /// </summary>
    public partial class IdentityProviderDetails
    {
        /// <summary>
        /// Initializes a new instance of the IdentityProviderDetails class.
        /// </summary>
        public IdentityProviderDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IdentityProviderDetails class.
        /// </summary>
        /// <param name="tenantId">The tenant Id for the service principal with
        /// which the on-premise management/data plane components would
        /// communicate with our Azure services.</param>
        /// <param name="applicationId">The application/client Id for the
        /// service principal with which the on-premise management/data plane
        /// components would communicate with our Azure services.</param>
        /// <param name="objectId">The object Id of the service principal with
        /// which the on-premise management/data plane components would
        /// communicate with our Azure services.</param>
        /// <param name="audience">The intended Audience of the service
        /// principal with which the on-premise management/data plane
        /// components would communicate with our Azure services.</param>
        /// <param name="aadAuthority">The base authority for Azure Active
        /// Directory authentication.</param>
        public IdentityProviderDetails(string tenantId = default(string), string applicationId = default(string), string objectId = default(string), string audience = default(string), string aadAuthority = default(string))
        {
            TenantId = tenantId;
            ApplicationId = applicationId;
            ObjectId = objectId;
            Audience = audience;
            AadAuthority = aadAuthority;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the tenant Id for the service principal with which the
        /// on-premise management/data plane components would communicate with
        /// our Azure services.
        /// </summary>
        [JsonProperty(PropertyName = "tenantId")]
        public string TenantId { get; set; }

        /// <summary>
        /// Gets or sets the application/client Id for the service principal
        /// with which the on-premise management/data plane components would
        /// communicate with our Azure services.
        /// </summary>
        [JsonProperty(PropertyName = "applicationId")]
        public string ApplicationId { get; set; }

        /// <summary>
        /// Gets or sets the object Id of the service principal with which the
        /// on-premise management/data plane components would communicate with
        /// our Azure services.
        /// </summary>
        [JsonProperty(PropertyName = "objectId")]
        public string ObjectId { get; set; }

        /// <summary>
        /// Gets or sets the intended Audience of the service principal with
        /// which the on-premise management/data plane components would
        /// communicate with our Azure services.
        /// </summary>
        [JsonProperty(PropertyName = "audience")]
        public string Audience { get; set; }

        /// <summary>
        /// Gets or sets the base authority for Azure Active Directory
        /// authentication.
        /// </summary>
        [JsonProperty(PropertyName = "aadAuthority")]
        public string AadAuthority { get; set; }

    }
}
