// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// DiskExclusionInput when doing enable protection of virtual machine in
    /// InMage provider.
    /// </summary>
    public partial class InMageDiskExclusionInput
    {
        /// <summary>
        /// Initializes a new instance of the InMageDiskExclusionInput class.
        /// </summary>
        public InMageDiskExclusionInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the InMageDiskExclusionInput class.
        /// </summary>
        /// <param name="volumeOptions">The volume label based option for disk
        /// exclusion.</param>
        /// <param name="diskSignatureOptions">The guest disk signature based
        /// option for disk exclusion.</param>
        public InMageDiskExclusionInput(IList<InMageVolumeExclusionOptions> volumeOptions = default(IList<InMageVolumeExclusionOptions>), IList<InMageDiskSignatureExclusionOptions> diskSignatureOptions = default(IList<InMageDiskSignatureExclusionOptions>))
        {
            VolumeOptions = volumeOptions;
            DiskSignatureOptions = diskSignatureOptions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the volume label based option for disk exclusion.
        /// </summary>
        [JsonProperty(PropertyName = "volumeOptions")]
        public IList<InMageVolumeExclusionOptions> VolumeOptions { get; set; }

        /// <summary>
        /// Gets or sets the guest disk signature based option for disk
        /// exclusion.
        /// </summary>
        [JsonProperty(PropertyName = "diskSignatureOptions")]
        public IList<InMageDiskSignatureExclusionOptions> DiskSignatureOptions { get; set; }

    }
}
