// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// This class stores the monitoring details for consistency check of
    /// inconsistent Protected Entity.
    /// </summary>
    public partial class InconsistentVmDetails
    {
        /// <summary>
        /// Initializes a new instance of the InconsistentVmDetails class.
        /// </summary>
        public InconsistentVmDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the InconsistentVmDetails class.
        /// </summary>
        /// <param name="vmName">The Vm name.</param>
        /// <param name="cloudName">The Cloud name.</param>
        /// <param name="details">The list of details regarding state of the
        /// Protected Entity in SRS and On prem.</param>
        /// <param name="errorIds">The list of error ids.</param>
        public InconsistentVmDetails(string vmName = default(string), string cloudName = default(string), IList<string> details = default(IList<string>), IList<string> errorIds = default(IList<string>))
        {
            VmName = vmName;
            CloudName = cloudName;
            Details = details;
            ErrorIds = errorIds;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Vm name.
        /// </summary>
        [JsonProperty(PropertyName = "vmName")]
        public string VmName { get; set; }

        /// <summary>
        /// Gets or sets the Cloud name.
        /// </summary>
        [JsonProperty(PropertyName = "cloudName")]
        public string CloudName { get; set; }

        /// <summary>
        /// Gets or sets the list of details regarding state of the Protected
        /// Entity in SRS and On prem.
        /// </summary>
        [JsonProperty(PropertyName = "details")]
        public IList<string> Details { get; set; }

        /// <summary>
        /// Gets or sets the list of error ids.
        /// </summary>
        [JsonProperty(PropertyName = "errorIds")]
        public IList<string> ErrorIds { get; set; }

    }
}
