// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This class contains the error details per object.
    /// </summary>
    public partial class JobErrorDetails
    {
        /// <summary>
        /// Initializes a new instance of the JobErrorDetails class.
        /// </summary>
        public JobErrorDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JobErrorDetails class.
        /// </summary>
        /// <param name="serviceErrorDetails">The Service error
        /// details.</param>
        /// <param name="providerErrorDetails">The Provider error
        /// details.</param>
        /// <param name="errorLevel">Error level of error.</param>
        /// <param name="creationTime">The creation time of job error.</param>
        /// <param name="taskId">The Id of the task.</param>
        public JobErrorDetails(ServiceError serviceErrorDetails = default(ServiceError), ProviderError providerErrorDetails = default(ProviderError), string errorLevel = default(string), System.DateTime? creationTime = default(System.DateTime?), string taskId = default(string))
        {
            ServiceErrorDetails = serviceErrorDetails;
            ProviderErrorDetails = providerErrorDetails;
            ErrorLevel = errorLevel;
            CreationTime = creationTime;
            TaskId = taskId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Service error details.
        /// </summary>
        [JsonProperty(PropertyName = "serviceErrorDetails")]
        public ServiceError ServiceErrorDetails { get; set; }

        /// <summary>
        /// Gets or sets the Provider error details.
        /// </summary>
        [JsonProperty(PropertyName = "providerErrorDetails")]
        public ProviderError ProviderErrorDetails { get; set; }

        /// <summary>
        /// Gets or sets error level of error.
        /// </summary>
        [JsonProperty(PropertyName = "errorLevel")]
        public string ErrorLevel { get; set; }

        /// <summary>
        /// Gets or sets the creation time of job error.
        /// </summary>
        [JsonProperty(PropertyName = "creationTime")]
        public System.DateTime? CreationTime { get; set; }

        /// <summary>
        /// Gets or sets the Id of the task.
        /// </summary>
        [JsonProperty(PropertyName = "taskId")]
        public string TaskId { get; set; }

    }
}
