// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Query parameter to enumerate jobs.
    /// </summary>
    public partial class JobQueryParameter
    {
        /// <summary>
        /// Initializes a new instance of the JobQueryParameter class.
        /// </summary>
        public JobQueryParameter()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JobQueryParameter class.
        /// </summary>
        /// <param name="startTime">Date time to get jobs from.</param>
        /// <param name="endTime">Date time to get jobs up to.</param>
        /// <param name="fabricId">The Id of the fabric to search jobs
        /// under.</param>
        /// <param name="affectedObjectTypes">The type of objects.</param>
        /// <param name="jobStatus">The states of the job to be filtered can be
        /// in.</param>
        public JobQueryParameter(string startTime = default(string), string endTime = default(string), string fabricId = default(string), string affectedObjectTypes = default(string), string jobStatus = default(string))
        {
            StartTime = startTime;
            EndTime = endTime;
            FabricId = fabricId;
            AffectedObjectTypes = affectedObjectTypes;
            JobStatus = jobStatus;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets date time to get jobs from.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public string StartTime { get; set; }

        /// <summary>
        /// Gets or sets date time to get jobs up to.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public string EndTime { get; set; }

        /// <summary>
        /// Gets or sets the Id of the fabric to search jobs under.
        /// </summary>
        [JsonProperty(PropertyName = "fabricId")]
        public string FabricId { get; set; }

        /// <summary>
        /// Gets or sets the type of objects.
        /// </summary>
        [JsonProperty(PropertyName = "affectedObjectTypes")]
        public string AffectedObjectTypes { get; set; }

        /// <summary>
        /// Gets or sets the states of the job to be filtered can be in.
        /// </summary>
        [JsonProperty(PropertyName = "jobStatus")]
        public string JobStatus { get; set; }

    }
}
