// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Recovery plan action details.
    /// </summary>
    public partial class RecoveryPlanAction
    {
        /// <summary>
        /// Initializes a new instance of the RecoveryPlanAction class.
        /// </summary>
        public RecoveryPlanAction()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RecoveryPlanAction class.
        /// </summary>
        /// <param name="actionName">The action name.</param>
        /// <param name="failoverTypes">The list of failover types.</param>
        /// <param name="failoverDirections">The list of failover
        /// directions.</param>
        /// <param name="customDetails">The custom details.</param>
        public RecoveryPlanAction(string actionName, IList<string> failoverTypes, IList<string> failoverDirections, RecoveryPlanActionDetails customDetails)
        {
            ActionName = actionName;
            FailoverTypes = failoverTypes;
            FailoverDirections = failoverDirections;
            CustomDetails = customDetails;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the action name.
        /// </summary>
        [JsonProperty(PropertyName = "actionName")]
        public string ActionName { get; set; }

        /// <summary>
        /// Gets or sets the list of failover types.
        /// </summary>
        [JsonProperty(PropertyName = "failoverTypes")]
        public IList<string> FailoverTypes { get; set; }

        /// <summary>
        /// Gets or sets the list of failover directions.
        /// </summary>
        [JsonProperty(PropertyName = "failoverDirections")]
        public IList<string> FailoverDirections { get; set; }

        /// <summary>
        /// Gets or sets the custom details.
        /// </summary>
        [JsonProperty(PropertyName = "customDetails")]
        public RecoveryPlanActionDetails CustomDetails { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ActionName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ActionName");
            }
            if (FailoverTypes == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "FailoverTypes");
            }
            if (FailoverDirections == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "FailoverDirections");
            }
            if (CustomDetails == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CustomDetails");
            }
        }
    }
}
