// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Recovery plan Automation runbook action details.
    /// </summary>
    [Newtonsoft.Json.JsonObject("AutomationRunbookActionDetails")]
    public partial class RecoveryPlanAutomationRunbookActionDetails : RecoveryPlanActionDetails
    {
        /// <summary>
        /// Initializes a new instance of the
        /// RecoveryPlanAutomationRunbookActionDetails class.
        /// </summary>
        public RecoveryPlanAutomationRunbookActionDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// RecoveryPlanAutomationRunbookActionDetails class.
        /// </summary>
        /// <param name="fabricLocation">The fabric location. Possible values
        /// include: 'Primary', 'Recovery'</param>
        /// <param name="runbookId">The runbook ARM Id.</param>
        /// <param name="timeout">The runbook timeout.</param>
        public RecoveryPlanAutomationRunbookActionDetails(string fabricLocation, string runbookId = default(string), string timeout = default(string))
        {
            RunbookId = runbookId;
            Timeout = timeout;
            FabricLocation = fabricLocation;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the runbook ARM Id.
        /// </summary>
        [JsonProperty(PropertyName = "runbookId")]
        public string RunbookId { get; set; }

        /// <summary>
        /// Gets or sets the runbook timeout.
        /// </summary>
        [JsonProperty(PropertyName = "timeout")]
        public string Timeout { get; set; }

        /// <summary>
        /// Gets or sets the fabric location. Possible values include:
        /// 'Primary', 'Recovery'
        /// </summary>
        [JsonProperty(PropertyName = "fabricLocation")]
        public string FabricLocation { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (FabricLocation == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "FabricLocation");
            }
        }
    }
}
