// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Recovery plan InMageAzureV2 failover input.
    /// </summary>
    [Newtonsoft.Json.JsonObject("InMageAzureV2")]
    public partial class RecoveryPlanInMageAzureV2FailoverInput : RecoveryPlanProviderSpecificFailoverInput
    {
        /// <summary>
        /// Initializes a new instance of the
        /// RecoveryPlanInMageAzureV2FailoverInput class.
        /// </summary>
        public RecoveryPlanInMageAzureV2FailoverInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// RecoveryPlanInMageAzureV2FailoverInput class.
        /// </summary>
        /// <param name="vaultLocation">The vault location.</param>
        /// <param name="recoveryPointType">The recovery point type. Possible
        /// values include: 'Latest', 'LatestApplicationConsistent',
        /// 'LatestCrashConsistent', 'LatestProcessed'</param>
        /// <param name="useMultiVmSyncPoint">A value indicating whether multi
        /// VM sync enabled VMs should use multi VM sync points for
        /// failover.</param>
        public RecoveryPlanInMageAzureV2FailoverInput(string vaultLocation, string recoveryPointType, string useMultiVmSyncPoint = default(string))
        {
            VaultLocation = vaultLocation;
            RecoveryPointType = recoveryPointType;
            UseMultiVmSyncPoint = useMultiVmSyncPoint;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the vault location.
        /// </summary>
        [JsonProperty(PropertyName = "vaultLocation")]
        public string VaultLocation { get; set; }

        /// <summary>
        /// Gets or sets the recovery point type. Possible values include:
        /// 'Latest', 'LatestApplicationConsistent', 'LatestCrashConsistent',
        /// 'LatestProcessed'
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPointType")]
        public string RecoveryPointType { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether multi VM sync enabled VMs
        /// should use multi VM sync points for failover.
        /// </summary>
        [JsonProperty(PropertyName = "useMultiVmSyncPoint")]
        public string UseMultiVmSyncPoint { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VaultLocation == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "VaultLocation");
            }
            if (RecoveryPointType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "RecoveryPointType");
            }
        }
    }
}
