// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Recovery plan script action details.
    /// </summary>
    [Newtonsoft.Json.JsonObject("ScriptActionDetails")]
    public partial class RecoveryPlanScriptActionDetails : RecoveryPlanActionDetails
    {
        /// <summary>
        /// Initializes a new instance of the RecoveryPlanScriptActionDetails
        /// class.
        /// </summary>
        public RecoveryPlanScriptActionDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RecoveryPlanScriptActionDetails
        /// class.
        /// </summary>
        /// <param name="path">The script path.</param>
        /// <param name="fabricLocation">The fabric location. Possible values
        /// include: 'Primary', 'Recovery'</param>
        /// <param name="timeout">The script timeout.</param>
        public RecoveryPlanScriptActionDetails(string path, string fabricLocation, string timeout = default(string))
        {
            Path = path;
            Timeout = timeout;
            FabricLocation = fabricLocation;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the script path.
        /// </summary>
        [JsonProperty(PropertyName = "path")]
        public string Path { get; set; }

        /// <summary>
        /// Gets or sets the script timeout.
        /// </summary>
        [JsonProperty(PropertyName = "timeout")]
        public string Timeout { get; set; }

        /// <summary>
        /// Gets or sets the fabric location. Possible values include:
        /// 'Primary', 'Recovery'
        /// </summary>
        [JsonProperty(PropertyName = "fabricLocation")]
        public string FabricLocation { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Path == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Path");
            }
            if (FabricLocation == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "FabricLocation");
            }
        }
    }
}
