// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Input definition for planned failover input properties.
    /// </summary>
    public partial class TestFailoverInputProperties
    {
        /// <summary>
        /// Initializes a new instance of the TestFailoverInputProperties
        /// class.
        /// </summary>
        public TestFailoverInputProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TestFailoverInputProperties
        /// class.
        /// </summary>
        /// <param name="failoverDirection">Failover direction.</param>
        /// <param name="networkType">Network type to be used for test
        /// failover.</param>
        /// <param name="networkId">The id of the network to be used for test
        /// failover</param>
        /// <param name="skipTestFailoverCleanup">A value indicating whether
        /// the test failover cleanup is to be skipped.</param>
        /// <param name="providerSpecificDetails">Provider specific
        /// settings</param>
        public TestFailoverInputProperties(string failoverDirection = default(string), string networkType = default(string), string networkId = default(string), string skipTestFailoverCleanup = default(string), ProviderSpecificFailoverInput providerSpecificDetails = default(ProviderSpecificFailoverInput))
        {
            FailoverDirection = failoverDirection;
            NetworkType = networkType;
            NetworkId = networkId;
            SkipTestFailoverCleanup = skipTestFailoverCleanup;
            ProviderSpecificDetails = providerSpecificDetails;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets failover direction.
        /// </summary>
        [JsonProperty(PropertyName = "failoverDirection")]
        public string FailoverDirection { get; set; }

        /// <summary>
        /// Gets or sets network type to be used for test failover.
        /// </summary>
        [JsonProperty(PropertyName = "networkType")]
        public string NetworkType { get; set; }

        /// <summary>
        /// Gets or sets the id of the network to be used for test failover
        /// </summary>
        [JsonProperty(PropertyName = "networkId")]
        public string NetworkId { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether the test failover cleanup
        /// is to be skipped.
        /// </summary>
        [JsonProperty(PropertyName = "skipTestFailoverCleanup")]
        public string SkipTestFailoverCleanup { get; set; }

        /// <summary>
        /// Gets or sets provider specific settings
        /// </summary>
        [JsonProperty(PropertyName = "providerSpecificDetails")]
        public ProviderSpecificFailoverInput ProviderSpecificDetails { get; set; }

    }
}
