// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// This class represents the details for a test failover job.
    /// </summary>
    public partial class TestFailoverJobDetails : JobDetails
    {
        /// <summary>
        /// Initializes a new instance of the TestFailoverJobDetails class.
        /// </summary>
        public TestFailoverJobDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TestFailoverJobDetails class.
        /// </summary>
        /// <param name="affectedObjectDetails">The affected object properties
        /// like source server, source cloud, target server, target cloud etc.
        /// based on the workflow object details.</param>
        /// <param name="testFailoverStatus">The test failover status.</param>
        /// <param name="comments">The test failover comments.</param>
        /// <param name="networkName">The test network name.</param>
        /// <param name="networkFriendlyName">The test network friendly
        /// name.</param>
        /// <param name="networkType">The test network type (see
        /// TestFailoverInput enum for possible values).</param>
        /// <param name="protectedItemDetails">The test VM details.</param>
        public TestFailoverJobDetails(IDictionary<string, string> affectedObjectDetails = default(IDictionary<string, string>), string testFailoverStatus = default(string), string comments = default(string), string networkName = default(string), string networkFriendlyName = default(string), string networkType = default(string), IList<FailoverReplicationProtectedItemDetails> protectedItemDetails = default(IList<FailoverReplicationProtectedItemDetails>))
            : base(affectedObjectDetails)
        {
            TestFailoverStatus = testFailoverStatus;
            Comments = comments;
            NetworkName = networkName;
            NetworkFriendlyName = networkFriendlyName;
            NetworkType = networkType;
            ProtectedItemDetails = protectedItemDetails;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the test failover status.
        /// </summary>
        [JsonProperty(PropertyName = "testFailoverStatus")]
        public string TestFailoverStatus { get; set; }

        /// <summary>
        /// Gets or sets the test failover comments.
        /// </summary>
        [JsonProperty(PropertyName = "comments")]
        public string Comments { get; set; }

        /// <summary>
        /// Gets or sets the test network name.
        /// </summary>
        [JsonProperty(PropertyName = "networkName")]
        public string NetworkName { get; set; }

        /// <summary>
        /// Gets or sets the test network friendly name.
        /// </summary>
        [JsonProperty(PropertyName = "networkFriendlyName")]
        public string NetworkFriendlyName { get; set; }

        /// <summary>
        /// Gets or sets the test network type (see TestFailoverInput enum for
        /// possible values).
        /// </summary>
        [JsonProperty(PropertyName = "networkType")]
        public string NetworkType { get; set; }

        /// <summary>
        /// Gets or sets the test VM details.
        /// </summary>
        [JsonProperty(PropertyName = "protectedItemDetails")]
        public IList<FailoverReplicationProtectedItemDetails> ProtectedItemDetails { get; set; }

    }
}
