// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Update protected item input properties.
    /// </summary>
    public partial class UpdateReplicationProtectedItemInputProperties
    {
        /// <summary>
        /// Initializes a new instance of the
        /// UpdateReplicationProtectedItemInputProperties class.
        /// </summary>
        public UpdateReplicationProtectedItemInputProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// UpdateReplicationProtectedItemInputProperties class.
        /// </summary>
        /// <param name="recoveryAzureVMName">Target azure VM name given by the
        /// user.</param>
        /// <param name="recoveryAzureVMSize">Target Azure Vm size.</param>
        /// <param name="selectedRecoveryAzureNetworkId">Target Azure Network
        /// Id.</param>
        /// <param name="selectedTfoAzureNetworkId">The Azure Network Id for
        /// test failover.</param>
        /// <param name="selectedSourceNicId">The selected source nic Id which
        /// will be used as the primary nic during failover.</param>
        /// <param name="enableRdpOnTargetOption">The selected option to enable
        /// RDP\SSH on target vm after failover. String value of
        /// {SrsDataContract.EnableRDPOnTargetOption} enum.</param>
        /// <param name="vmNics">The list of vm nic details.</param>
        /// <param name="licenseType">License type. Possible values include:
        /// 'NotSpecified', 'NoLicenseType', 'WindowsServer'</param>
        /// <param name="recoveryAvailabilitySetId">The target availability set
        /// id.</param>
        /// <param name="providerSpecificDetails">The provider specific input
        /// to update replication protected item.</param>
        public UpdateReplicationProtectedItemInputProperties(string recoveryAzureVMName = default(string), string recoveryAzureVMSize = default(string), string selectedRecoveryAzureNetworkId = default(string), string selectedTfoAzureNetworkId = default(string), string selectedSourceNicId = default(string), string enableRdpOnTargetOption = default(string), IList<VMNicInputDetails> vmNics = default(IList<VMNicInputDetails>), string licenseType = default(string), string recoveryAvailabilitySetId = default(string), UpdateReplicationProtectedItemProviderInput providerSpecificDetails = default(UpdateReplicationProtectedItemProviderInput))
        {
            RecoveryAzureVMName = recoveryAzureVMName;
            RecoveryAzureVMSize = recoveryAzureVMSize;
            SelectedRecoveryAzureNetworkId = selectedRecoveryAzureNetworkId;
            SelectedTfoAzureNetworkId = selectedTfoAzureNetworkId;
            SelectedSourceNicId = selectedSourceNicId;
            EnableRdpOnTargetOption = enableRdpOnTargetOption;
            VmNics = vmNics;
            LicenseType = licenseType;
            RecoveryAvailabilitySetId = recoveryAvailabilitySetId;
            ProviderSpecificDetails = providerSpecificDetails;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets target azure VM name given by the user.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryAzureVMName")]
        public string RecoveryAzureVMName { get; set; }

        /// <summary>
        /// Gets or sets target Azure Vm size.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryAzureVMSize")]
        public string RecoveryAzureVMSize { get; set; }

        /// <summary>
        /// Gets or sets target Azure Network Id.
        /// </summary>
        [JsonProperty(PropertyName = "selectedRecoveryAzureNetworkId")]
        public string SelectedRecoveryAzureNetworkId { get; set; }

        /// <summary>
        /// Gets or sets the Azure Network Id for test failover.
        /// </summary>
        [JsonProperty(PropertyName = "selectedTfoAzureNetworkId")]
        public string SelectedTfoAzureNetworkId { get; set; }

        /// <summary>
        /// Gets or sets the selected source nic Id which will be used as the
        /// primary nic during failover.
        /// </summary>
        [JsonProperty(PropertyName = "selectedSourceNicId")]
        public string SelectedSourceNicId { get; set; }

        /// <summary>
        /// Gets or sets the selected option to enable RDP\SSH on target vm
        /// after failover. String value of
        /// {SrsDataContract.EnableRDPOnTargetOption} enum.
        /// </summary>
        [JsonProperty(PropertyName = "enableRdpOnTargetOption")]
        public string EnableRdpOnTargetOption { get; set; }

        /// <summary>
        /// Gets or sets the list of vm nic details.
        /// </summary>
        [JsonProperty(PropertyName = "vmNics")]
        public IList<VMNicInputDetails> VmNics { get; set; }

        /// <summary>
        /// Gets or sets license type. Possible values include: 'NotSpecified',
        /// 'NoLicenseType', 'WindowsServer'
        /// </summary>
        [JsonProperty(PropertyName = "licenseType")]
        public string LicenseType { get; set; }

        /// <summary>
        /// Gets or sets the target availability set id.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryAvailabilitySetId")]
        public string RecoveryAvailabilitySetId { get; set; }

        /// <summary>
        /// Gets or sets the provider specific input to update replication
        /// protected item.
        /// </summary>
        [JsonProperty(PropertyName = "providerSpecificDetails")]
        public UpdateReplicationProtectedItemProviderInput ProviderSpecificDetails { get; set; }

    }
}
