// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// VMwareCbt container mapping input.
    /// </summary>
    [Newtonsoft.Json.JsonObject("VMwareCbt")]
    public partial class VMwareCbtContainerMappingInput : ReplicationProviderSpecificContainerMappingInput
    {
        /// <summary>
        /// Initializes a new instance of the VMwareCbtContainerMappingInput
        /// class.
        /// </summary>
        public VMwareCbtContainerMappingInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VMwareCbtContainerMappingInput
        /// class.
        /// </summary>
        /// <param name="keyVaultId">The target key vault ARM Id.</param>
        /// <param name="keyVaultUri">The target key vault URL.</param>
        /// <param name="storageAccountId">The storage account ARM Id.</param>
        /// <param name="storageAccountSasSecretName">The secret name of the
        /// storage account.</param>
        /// <param name="serviceBusConnectionStringSecretName">The secret name
        /// of the service bus connection string.</param>
        /// <param name="targetLocation">The target location.</param>
        public VMwareCbtContainerMappingInput(string keyVaultId, string keyVaultUri, string storageAccountId, string storageAccountSasSecretName, string serviceBusConnectionStringSecretName, string targetLocation)
        {
            KeyVaultId = keyVaultId;
            KeyVaultUri = keyVaultUri;
            StorageAccountId = storageAccountId;
            StorageAccountSasSecretName = storageAccountSasSecretName;
            ServiceBusConnectionStringSecretName = serviceBusConnectionStringSecretName;
            TargetLocation = targetLocation;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the target key vault ARM Id.
        /// </summary>
        [JsonProperty(PropertyName = "keyVaultId")]
        public string KeyVaultId { get; set; }

        /// <summary>
        /// Gets or sets the target key vault URL.
        /// </summary>
        [JsonProperty(PropertyName = "keyVaultUri")]
        public string KeyVaultUri { get; set; }

        /// <summary>
        /// Gets or sets the storage account ARM Id.
        /// </summary>
        [JsonProperty(PropertyName = "storageAccountId")]
        public string StorageAccountId { get; set; }

        /// <summary>
        /// Gets or sets the secret name of the storage account.
        /// </summary>
        [JsonProperty(PropertyName = "storageAccountSasSecretName")]
        public string StorageAccountSasSecretName { get; set; }

        /// <summary>
        /// Gets or sets the secret name of the service bus connection string.
        /// </summary>
        [JsonProperty(PropertyName = "serviceBusConnectionStringSecretName")]
        public string ServiceBusConnectionStringSecretName { get; set; }

        /// <summary>
        /// Gets or sets the target location.
        /// </summary>
        [JsonProperty(PropertyName = "targetLocation")]
        public string TargetLocation { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (KeyVaultId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "KeyVaultId");
            }
            if (KeyVaultUri == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "KeyVaultUri");
            }
            if (StorageAccountId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "StorageAccountId");
            }
            if (StorageAccountSasSecretName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "StorageAccountSasSecretName");
            }
            if (ServiceBusConnectionStringSecretName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ServiceBusConnectionStringSecretName");
            }
            if (TargetLocation == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetLocation");
            }
        }
    }
}
