// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// VMwareCbt NIC details.
    /// </summary>
    public partial class VMwareCbtNicDetails
    {
        /// <summary>
        /// Initializes a new instance of the VMwareCbtNicDetails class.
        /// </summary>
        public VMwareCbtNicDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VMwareCbtNicDetails class.
        /// </summary>
        /// <param name="nicId">The NIC Id.</param>
        /// <param name="isPrimaryNic">A value indicating whether this is the
        /// primary NIC.</param>
        /// <param name="sourceIPAddress">The source IP address.</param>
        /// <param name="sourceIPAddressType">The source IP address type.
        /// Possible values include: 'Dynamic', 'Static'</param>
        /// <param name="sourceNetworkId">Source network Id.</param>
        /// <param name="targetIPAddress">The target IP address.</param>
        /// <param name="targetIPAddressType">The target IP address type.
        /// Possible values include: 'Dynamic', 'Static'</param>
        /// <param name="targetSubnetName">Target subnet name.</param>
        /// <param name="isSelectedForMigration">A value indicating whether
        /// this NIC is selected for migration.</param>
        public VMwareCbtNicDetails(string nicId = default(string), string isPrimaryNic = default(string), string sourceIPAddress = default(string), string sourceIPAddressType = default(string), string sourceNetworkId = default(string), string targetIPAddress = default(string), string targetIPAddressType = default(string), string targetSubnetName = default(string), string isSelectedForMigration = default(string))
        {
            NicId = nicId;
            IsPrimaryNic = isPrimaryNic;
            SourceIPAddress = sourceIPAddress;
            SourceIPAddressType = sourceIPAddressType;
            SourceNetworkId = sourceNetworkId;
            TargetIPAddress = targetIPAddress;
            TargetIPAddressType = targetIPAddressType;
            TargetSubnetName = targetSubnetName;
            IsSelectedForMigration = isSelectedForMigration;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the NIC Id.
        /// </summary>
        [JsonProperty(PropertyName = "nicId")]
        public string NicId { get; private set; }

        /// <summary>
        /// Gets or sets a value indicating whether this is the primary NIC.
        /// </summary>
        [JsonProperty(PropertyName = "isPrimaryNic")]
        public string IsPrimaryNic { get; set; }

        /// <summary>
        /// Gets the source IP address.
        /// </summary>
        [JsonProperty(PropertyName = "sourceIPAddress")]
        public string SourceIPAddress { get; private set; }

        /// <summary>
        /// Gets the source IP address type. Possible values include:
        /// 'Dynamic', 'Static'
        /// </summary>
        [JsonProperty(PropertyName = "sourceIPAddressType")]
        public string SourceIPAddressType { get; private set; }

        /// <summary>
        /// Gets source network Id.
        /// </summary>
        [JsonProperty(PropertyName = "sourceNetworkId")]
        public string SourceNetworkId { get; private set; }

        /// <summary>
        /// Gets or sets the target IP address.
        /// </summary>
        [JsonProperty(PropertyName = "targetIPAddress")]
        public string TargetIPAddress { get; set; }

        /// <summary>
        /// Gets or sets the target IP address type. Possible values include:
        /// 'Dynamic', 'Static'
        /// </summary>
        [JsonProperty(PropertyName = "targetIPAddressType")]
        public string TargetIPAddressType { get; set; }

        /// <summary>
        /// Gets or sets target subnet name.
        /// </summary>
        [JsonProperty(PropertyName = "targetSubnetName")]
        public string TargetSubnetName { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether this NIC is selected for
        /// migration.
        /// </summary>
        [JsonProperty(PropertyName = "isSelectedForMigration")]
        public string IsSelectedForMigration { get; set; }

    }
}
