// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// VMwareV2 fabric provider specific settings.
    /// </summary>
    [Newtonsoft.Json.JsonObject("VMwareV2")]
    public partial class VMwareV2FabricCreationInput : FabricSpecificCreationInput
    {
        /// <summary>
        /// Initializes a new instance of the VMwareV2FabricCreationInput
        /// class.
        /// </summary>
        public VMwareV2FabricCreationInput()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VMwareV2FabricCreationInput
        /// class.
        /// </summary>
        /// <param name="vmwareSiteId">The ARM Id of the VMware site.</param>
        /// <param name="migrationSolutionId">The ARM Id of the migration
        /// solution.</param>
        public VMwareV2FabricCreationInput(string vmwareSiteId, string migrationSolutionId)
        {
            VmwareSiteId = vmwareSiteId;
            MigrationSolutionId = migrationSolutionId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the ARM Id of the VMware site.
        /// </summary>
        [JsonProperty(PropertyName = "vmwareSiteId")]
        public string VmwareSiteId { get; set; }

        /// <summary>
        /// Gets or sets the ARM Id of the migration solution.
        /// </summary>
        [JsonProperty(PropertyName = "migrationSolutionId")]
        public string MigrationSolutionId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VmwareSiteId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "VmwareSiteId");
            }
            if (MigrationSolutionId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "MigrationSolutionId");
            }
        }
    }
}
