// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// VMware Cbt specific policy details.
    /// </summary>
    [Newtonsoft.Json.JsonObject("VMwareCbt")]
    public partial class VmwareCbtPolicyDetails : PolicyProviderSpecificDetails
    {
        /// <summary>
        /// Initializes a new instance of the VmwareCbtPolicyDetails class.
        /// </summary>
        public VmwareCbtPolicyDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VmwareCbtPolicyDetails class.
        /// </summary>
        /// <param name="recoveryPointHistoryInMinutes">The duration in minutes
        /// until which the recovery points need to be stored.</param>
        /// <param name="appConsistentFrequencyInMinutes">The app consistent
        /// snapshot frequency in minutes.</param>
        /// <param name="crashConsistentFrequencyInMinutes">The crash
        /// consistent snapshot frequency in minutes.</param>
        public VmwareCbtPolicyDetails(int? recoveryPointHistoryInMinutes = default(int?), int? appConsistentFrequencyInMinutes = default(int?), int? crashConsistentFrequencyInMinutes = default(int?))
        {
            RecoveryPointHistoryInMinutes = recoveryPointHistoryInMinutes;
            AppConsistentFrequencyInMinutes = appConsistentFrequencyInMinutes;
            CrashConsistentFrequencyInMinutes = crashConsistentFrequencyInMinutes;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the duration in minutes until which the recovery
        /// points need to be stored.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPointHistoryInMinutes")]
        public int? RecoveryPointHistoryInMinutes { get; set; }

        /// <summary>
        /// Gets or sets the app consistent snapshot frequency in minutes.
        /// </summary>
        [JsonProperty(PropertyName = "appConsistentFrequencyInMinutes")]
        public int? AppConsistentFrequencyInMinutes { get; set; }

        /// <summary>
        /// Gets or sets the crash consistent snapshot frequency in minutes.
        /// </summary>
        [JsonProperty(PropertyName = "crashConsistentFrequencyInMinutes")]
        public int? CrashConsistentFrequencyInMinutes { get; set; }

    }
}
