// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ReplicationAlertSettingsOperations.
    /// </summary>
    public static partial class ReplicationAlertSettingsOperationsExtensions
    {
            /// <summary>
            /// Gets the list of configured email notification(alert) configurations.
            /// </summary>
            /// <remarks>
            /// Gets the list of email notification(alert) configurations for the vault.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static IPage<Alert> List(this IReplicationAlertSettingsOperations operations)
            {
                return operations.ListAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the list of configured email notification(alert) configurations.
            /// </summary>
            /// <remarks>
            /// Gets the list of email notification(alert) configurations for the vault.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Alert>> ListAsync(this IReplicationAlertSettingsOperations operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets an email notification(alert) configuration.
            /// </summary>
            /// <remarks>
            /// Gets the details of the specified email notification(alert) configuration.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='alertSettingName'>
            /// The name of the email notification configuration.
            /// </param>
            public static Alert Get(this IReplicationAlertSettingsOperations operations, string alertSettingName)
            {
                return operations.GetAsync(alertSettingName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets an email notification(alert) configuration.
            /// </summary>
            /// <remarks>
            /// Gets the details of the specified email notification(alert) configuration.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='alertSettingName'>
            /// The name of the email notification configuration.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Alert> GetAsync(this IReplicationAlertSettingsOperations operations, string alertSettingName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(alertSettingName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Configures email notifications for this vault.
            /// </summary>
            /// <remarks>
            /// Create or update an email notification(alert) configuration.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='alertSettingName'>
            /// The name of the email notification(alert) configuration.
            /// </param>
            /// <param name='request'>
            /// The input to configure the email notification(alert).
            /// </param>
            public static Alert Create(this IReplicationAlertSettingsOperations operations, string alertSettingName, ConfigureAlertRequest request)
            {
                return operations.CreateAsync(alertSettingName, request).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Configures email notifications for this vault.
            /// </summary>
            /// <remarks>
            /// Create or update an email notification(alert) configuration.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='alertSettingName'>
            /// The name of the email notification(alert) configuration.
            /// </param>
            /// <param name='request'>
            /// The input to configure the email notification(alert).
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Alert> CreateAsync(this IReplicationAlertSettingsOperations operations, string alertSettingName, ConfigureAlertRequest request, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateWithHttpMessagesAsync(alertSettingName, request, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the list of configured email notification(alert) configurations.
            /// </summary>
            /// <remarks>
            /// Gets the list of email notification(alert) configurations for the vault.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<Alert> ListNext(this IReplicationAlertSettingsOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the list of configured email notification(alert) configurations.
            /// </summary>
            /// <remarks>
            /// Gets the list of email notification(alert) configurations for the vault.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Alert>> ListNextAsync(this IReplicationAlertSettingsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
