// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Azure.OData;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ReplicationProtectedItemsOperations.
    /// </summary>
    public static partial class ReplicationProtectedItemsOperationsExtensions
    {
            /// <summary>
            /// Gets the list of Replication protected items.
            /// </summary>
            /// <remarks>
            /// Gets the list of ASR replication protected items in the protection
            /// container.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            public static IPage<ReplicationProtectedItem> ListByReplicationProtectionContainers(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName)
            {
                return operations.ListByReplicationProtectionContainersAsync(fabricName, protectionContainerName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the list of Replication protected items.
            /// </summary>
            /// <remarks>
            /// Gets the list of ASR replication protected items in the protection
            /// container.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ReplicationProtectedItem>> ListByReplicationProtectionContainersAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByReplicationProtectionContainersWithHttpMessagesAsync(fabricName, protectionContainerName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the details of a Replication protected item.
            /// </summary>
            /// <remarks>
            /// Gets the details of an ASR replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric unique name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            public static ReplicationProtectedItem Get(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName)
            {
                return operations.GetAsync(fabricName, protectionContainerName, replicatedProtectedItemName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the details of a Replication protected item.
            /// </summary>
            /// <remarks>
            /// Gets the details of an ASR replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric unique name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> GetAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Enables protection.
            /// </summary>
            /// <remarks>
            /// The operation to create an ASR replication protected item (Enable
            /// replication).
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Name of the fabric.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// A name for the replication protected item.
            /// </param>
            /// <param name='input'>
            /// Enable Protection Input.
            /// </param>
            public static ReplicationProtectedItem Create(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, EnableProtectionInput input)
            {
                return operations.CreateAsync(fabricName, protectionContainerName, replicatedProtectedItemName, input).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Enables protection.
            /// </summary>
            /// <remarks>
            /// The operation to create an ASR replication protected item (Enable
            /// replication).
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Name of the fabric.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// A name for the replication protected item.
            /// </param>
            /// <param name='input'>
            /// Enable Protection Input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> CreateAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, EnableProtectionInput input, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, input, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Purges protection.
            /// </summary>
            /// <remarks>
            /// The operation to delete or purge a replication protected item. This
            /// operation will force delete the replication protected item. Use the remove
            /// operation on replication protected item to perform a clean disable
            /// replication for the item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            public static void Purge(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName)
            {
                operations.PurgeAsync(fabricName, protectionContainerName, replicatedProtectedItemName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Purges protection.
            /// </summary>
            /// <remarks>
            /// The operation to delete or purge a replication protected item. This
            /// operation will force delete the replication protected item. Use the remove
            /// operation on replication protected item to perform a clean disable
            /// replication for the item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task PurgeAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.PurgeWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Updates protection.
            /// </summary>
            /// <remarks>
            /// The operation to update the recovery settings of an ASR replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='updateProtectionInput'>
            /// Update protection input.
            /// </param>
            public static ReplicationProtectedItem Update(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, UpdateReplicationProtectedItemInput updateProtectionInput)
            {
                return operations.UpdateAsync(fabricName, protectionContainerName, replicatedProtectedItemName, updateProtectionInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates protection.
            /// </summary>
            /// <remarks>
            /// The operation to update the recovery settings of an ASR replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='updateProtectionInput'>
            /// Update protection input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> UpdateAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, UpdateReplicationProtectedItemInput updateProtectionInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, updateProtectionInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Add disk(s) for protection.
            /// </summary>
            /// <remarks>
            /// Operation to add disks(s) to the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='addDisksInput'>
            /// Add disks input.
            /// </param>
            public static ReplicationProtectedItem AddDisks(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, AddDisksInput addDisksInput)
            {
                return operations.AddDisksAsync(fabricName, protectionContainerName, replicatedProtectedItemName, addDisksInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Add disk(s) for protection.
            /// </summary>
            /// <remarks>
            /// Operation to add disks(s) to the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='addDisksInput'>
            /// Add disks input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> AddDisksAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, AddDisksInput addDisksInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.AddDisksWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, addDisksInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Change or apply recovery point.
            /// </summary>
            /// <remarks>
            /// The operation to change the recovery point of a failed over replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The ARM fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// The replicated protected item's name.
            /// </param>
            /// <param name='applyRecoveryPointInput'>
            /// The ApplyRecoveryPointInput.
            /// </param>
            public static ReplicationProtectedItem ApplyRecoveryPoint(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ApplyRecoveryPointInput applyRecoveryPointInput)
            {
                return operations.ApplyRecoveryPointAsync(fabricName, protectionContainerName, replicatedProtectedItemName, applyRecoveryPointInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Change or apply recovery point.
            /// </summary>
            /// <remarks>
            /// The operation to change the recovery point of a failed over replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The ARM fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// The replicated protected item's name.
            /// </param>
            /// <param name='applyRecoveryPointInput'>
            /// The ApplyRecoveryPointInput.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> ApplyRecoveryPointAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ApplyRecoveryPointInput applyRecoveryPointInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ApplyRecoveryPointWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, applyRecoveryPointInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute commit failover
            /// </summary>
            /// <remarks>
            /// Operation to commit the failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            public static ReplicationProtectedItem FailoverCommit(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName)
            {
                return operations.FailoverCommitAsync(fabricName, protectionContainerName, replicatedProtectedItemName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute commit failover
            /// </summary>
            /// <remarks>
            /// Operation to commit the failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> FailoverCommitAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FailoverCommitWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute planned failover
            /// </summary>
            /// <remarks>
            /// Operation to initiate a planned failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Disable protection input.
            /// </param>
            public static ReplicationProtectedItem PlannedFailover(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, PlannedFailoverInput failoverInput)
            {
                return operations.PlannedFailoverAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute planned failover
            /// </summary>
            /// <remarks>
            /// Operation to initiate a planned failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Disable protection input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> PlannedFailoverAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, PlannedFailoverInput failoverInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.PlannedFailoverWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Disables protection.
            /// </summary>
            /// <remarks>
            /// The operation to disable replication on a replication protected item. This
            /// will also remove the item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='disableProtectionInput'>
            /// Disable protection input.
            /// </param>
            public static void Delete(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, DisableProtectionInput disableProtectionInput)
            {
                operations.DeleteAsync(fabricName, protectionContainerName, replicatedProtectedItemName, disableProtectionInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Disables protection.
            /// </summary>
            /// <remarks>
            /// The operation to disable replication on a replication protected item. This
            /// will also remove the item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='disableProtectionInput'>
            /// Disable protection input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, DisableProtectionInput disableProtectionInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, disableProtectionInput, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Removes disk(s).
            /// </summary>
            /// <remarks>
            /// Operation to remove disk(s) from the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='removeDisksInput'>
            /// Remove disks input.
            /// </param>
            public static ReplicationProtectedItem RemoveDisks(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, RemoveDisksInput removeDisksInput)
            {
                return operations.RemoveDisksAsync(fabricName, protectionContainerName, replicatedProtectedItemName, removeDisksInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Removes disk(s).
            /// </summary>
            /// <remarks>
            /// Operation to remove disk(s) from the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='removeDisksInput'>
            /// Remove disks input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> RemoveDisksAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, RemoveDisksInput removeDisksInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.RemoveDisksWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, removeDisksInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Resynchronize or repair replication.
            /// </summary>
            /// <remarks>
            /// The operation to start resynchronize/repair replication for a replication
            /// protected item requiring resynchronization.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The name of the fabric.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The name of the container.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// The name of the replication protected item.
            /// </param>
            public static ReplicationProtectedItem RepairReplication(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName)
            {
                return operations.RepairReplicationAsync(fabricName, protectionContainerName, replicatedProtectedItemName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Resynchronize or repair replication.
            /// </summary>
            /// <remarks>
            /// The operation to start resynchronize/repair replication for a replication
            /// protected item requiring resynchronization.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The name of the fabric.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The name of the container.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// The name of the replication protected item.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> RepairReplicationAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.RepairReplicationWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute Reverse Replication\Reprotect
            /// </summary>
            /// <remarks>
            /// Operation to reprotect or reverse replicate a failed over replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='rrInput'>
            /// Disable protection input.
            /// </param>
            public static ReplicationProtectedItem Reprotect(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ReverseReplicationInput rrInput)
            {
                return operations.ReprotectAsync(fabricName, protectionContainerName, replicatedProtectedItemName, rrInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute Reverse Replication\Reprotect
            /// </summary>
            /// <remarks>
            /// Operation to reprotect or reverse replicate a failed over replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='rrInput'>
            /// Disable protection input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> ReprotectAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ReverseReplicationInput rrInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ReprotectWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, rrInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Resolve health errors.
            /// </summary>
            /// <remarks>
            /// Operation to resolve health issues of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='resolveHealthInput'>
            /// Health issue input object.
            /// </param>
            public static ReplicationProtectedItem ResolveHealthErrors(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ResolveHealthInput resolveHealthInput)
            {
                return operations.ResolveHealthErrorsAsync(fabricName, protectionContainerName, replicatedProtectedItemName, resolveHealthInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Resolve health errors.
            /// </summary>
            /// <remarks>
            /// Operation to resolve health issues of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='resolveHealthInput'>
            /// Health issue input object.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> ResolveHealthErrorsAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ResolveHealthInput resolveHealthInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ResolveHealthErrorsWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, resolveHealthInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute test failover
            /// </summary>
            /// <remarks>
            /// Operation to perform a test failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Test failover input.
            /// </param>
            public static ReplicationProtectedItem TestFailover(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, TestFailoverInput failoverInput)
            {
                return operations.TestFailoverAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute test failover
            /// </summary>
            /// <remarks>
            /// Operation to perform a test failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Test failover input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> TestFailoverAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, TestFailoverInput failoverInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.TestFailoverWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute test failover cleanup.
            /// </summary>
            /// <remarks>
            /// Operation to clean up the test failover of a replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='cleanupInput'>
            /// Test failover cleanup input.
            /// </param>
            public static ReplicationProtectedItem TestFailoverCleanup(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, TestFailoverCleanupInput cleanupInput)
            {
                return operations.TestFailoverCleanupAsync(fabricName, protectionContainerName, replicatedProtectedItemName, cleanupInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute test failover cleanup.
            /// </summary>
            /// <remarks>
            /// Operation to clean up the test failover of a replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='cleanupInput'>
            /// Test failover cleanup input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> TestFailoverCleanupAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, TestFailoverCleanupInput cleanupInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.TestFailoverCleanupWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, cleanupInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute unplanned failover
            /// </summary>
            /// <remarks>
            /// Operation to initiate a failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Disable protection input.
            /// </param>
            public static ReplicationProtectedItem UnplannedFailover(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, UnplannedFailoverInput failoverInput)
            {
                return operations.UnplannedFailoverAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute unplanned failover
            /// </summary>
            /// <remarks>
            /// Operation to initiate a failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Disable protection input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> UnplannedFailoverAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, UnplannedFailoverInput failoverInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UnplannedFailoverWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Update the mobility service on a protected item.
            /// </summary>
            /// <remarks>
            /// The operation to update(push update) the installed mobility service
            /// software on a replication protected item to the latest available version.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The name of the fabric containing the protected item.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The name of the container containing the protected item.
            /// </param>
            /// <param name='replicationProtectedItemName'>
            /// The name of the protected item on which the agent is to be updated.
            /// </param>
            /// <param name='updateMobilityServiceRequest'>
            /// Request to update the mobility service on the protected item.
            /// </param>
            public static ReplicationProtectedItem UpdateMobilityService(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicationProtectedItemName, UpdateMobilityServiceRequest updateMobilityServiceRequest)
            {
                return operations.UpdateMobilityServiceAsync(fabricName, protectionContainerName, replicationProtectedItemName, updateMobilityServiceRequest).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Update the mobility service on a protected item.
            /// </summary>
            /// <remarks>
            /// The operation to update(push update) the installed mobility service
            /// software on a replication protected item to the latest available version.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The name of the fabric containing the protected item.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The name of the container containing the protected item.
            /// </param>
            /// <param name='replicationProtectedItemName'>
            /// The name of the protected item on which the agent is to be updated.
            /// </param>
            /// <param name='updateMobilityServiceRequest'>
            /// Request to update the mobility service on the protected item.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> UpdateMobilityServiceAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicationProtectedItemName, UpdateMobilityServiceRequest updateMobilityServiceRequest, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateMobilityServiceWithHttpMessagesAsync(fabricName, protectionContainerName, replicationProtectedItemName, updateMobilityServiceRequest, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the list of replication protected items.
            /// </summary>
            /// <remarks>
            /// Gets the list of ASR replication protected items in the vault.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='skipToken'>
            /// The pagination token. Possible values: "FabricId" or "FabricId_CloudId" or
            /// null
            /// </param>
            public static IPage<ReplicationProtectedItem> List(this IReplicationProtectedItemsOperations operations, ODataQuery<ProtectedItemsQueryParameter> odataQuery = default(ODataQuery<ProtectedItemsQueryParameter>), string skipToken = default(string))
            {
                return operations.ListAsync(odataQuery, skipToken).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the list of replication protected items.
            /// </summary>
            /// <remarks>
            /// Gets the list of ASR replication protected items in the vault.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='odataQuery'>
            /// OData parameters to apply to the operation.
            /// </param>
            /// <param name='skipToken'>
            /// The pagination token. Possible values: "FabricId" or "FabricId_CloudId" or
            /// null
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ReplicationProtectedItem>> ListAsync(this IReplicationProtectedItemsOperations operations, ODataQuery<ProtectedItemsQueryParameter> odataQuery = default(ODataQuery<ProtectedItemsQueryParameter>), string skipToken = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(odataQuery, skipToken, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Enables protection.
            /// </summary>
            /// <remarks>
            /// The operation to create an ASR replication protected item (Enable
            /// replication).
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Name of the fabric.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// A name for the replication protected item.
            /// </param>
            /// <param name='input'>
            /// Enable Protection Input.
            /// </param>
            public static ReplicationProtectedItem BeginCreate(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, EnableProtectionInput input)
            {
                return operations.BeginCreateAsync(fabricName, protectionContainerName, replicatedProtectedItemName, input).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Enables protection.
            /// </summary>
            /// <remarks>
            /// The operation to create an ASR replication protected item (Enable
            /// replication).
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Name of the fabric.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// A name for the replication protected item.
            /// </param>
            /// <param name='input'>
            /// Enable Protection Input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginCreateAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, EnableProtectionInput input, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, input, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Purges protection.
            /// </summary>
            /// <remarks>
            /// The operation to delete or purge a replication protected item. This
            /// operation will force delete the replication protected item. Use the remove
            /// operation on replication protected item to perform a clean disable
            /// replication for the item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            public static void BeginPurge(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName)
            {
                operations.BeginPurgeAsync(fabricName, protectionContainerName, replicatedProtectedItemName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Purges protection.
            /// </summary>
            /// <remarks>
            /// The operation to delete or purge a replication protected item. This
            /// operation will force delete the replication protected item. Use the remove
            /// operation on replication protected item to perform a clean disable
            /// replication for the item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginPurgeAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginPurgeWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Updates protection.
            /// </summary>
            /// <remarks>
            /// The operation to update the recovery settings of an ASR replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='updateProtectionInput'>
            /// Update protection input.
            /// </param>
            public static ReplicationProtectedItem BeginUpdate(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, UpdateReplicationProtectedItemInput updateProtectionInput)
            {
                return operations.BeginUpdateAsync(fabricName, protectionContainerName, replicatedProtectedItemName, updateProtectionInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates protection.
            /// </summary>
            /// <remarks>
            /// The operation to update the recovery settings of an ASR replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='updateProtectionInput'>
            /// Update protection input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginUpdateAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, UpdateReplicationProtectedItemInput updateProtectionInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginUpdateWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, updateProtectionInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Add disk(s) for protection.
            /// </summary>
            /// <remarks>
            /// Operation to add disks(s) to the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='addDisksInput'>
            /// Add disks input.
            /// </param>
            public static ReplicationProtectedItem BeginAddDisks(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, AddDisksInput addDisksInput)
            {
                return operations.BeginAddDisksAsync(fabricName, protectionContainerName, replicatedProtectedItemName, addDisksInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Add disk(s) for protection.
            /// </summary>
            /// <remarks>
            /// Operation to add disks(s) to the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='addDisksInput'>
            /// Add disks input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginAddDisksAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, AddDisksInput addDisksInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginAddDisksWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, addDisksInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Change or apply recovery point.
            /// </summary>
            /// <remarks>
            /// The operation to change the recovery point of a failed over replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The ARM fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// The replicated protected item's name.
            /// </param>
            /// <param name='applyRecoveryPointInput'>
            /// The ApplyRecoveryPointInput.
            /// </param>
            public static ReplicationProtectedItem BeginApplyRecoveryPoint(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ApplyRecoveryPointInput applyRecoveryPointInput)
            {
                return operations.BeginApplyRecoveryPointAsync(fabricName, protectionContainerName, replicatedProtectedItemName, applyRecoveryPointInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Change or apply recovery point.
            /// </summary>
            /// <remarks>
            /// The operation to change the recovery point of a failed over replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The ARM fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// The replicated protected item's name.
            /// </param>
            /// <param name='applyRecoveryPointInput'>
            /// The ApplyRecoveryPointInput.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginApplyRecoveryPointAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ApplyRecoveryPointInput applyRecoveryPointInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginApplyRecoveryPointWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, applyRecoveryPointInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute commit failover
            /// </summary>
            /// <remarks>
            /// Operation to commit the failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            public static ReplicationProtectedItem BeginFailoverCommit(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName)
            {
                return operations.BeginFailoverCommitAsync(fabricName, protectionContainerName, replicatedProtectedItemName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute commit failover
            /// </summary>
            /// <remarks>
            /// Operation to commit the failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginFailoverCommitAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginFailoverCommitWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute planned failover
            /// </summary>
            /// <remarks>
            /// Operation to initiate a planned failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Disable protection input.
            /// </param>
            public static ReplicationProtectedItem BeginPlannedFailover(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, PlannedFailoverInput failoverInput)
            {
                return operations.BeginPlannedFailoverAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute planned failover
            /// </summary>
            /// <remarks>
            /// Operation to initiate a planned failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Disable protection input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginPlannedFailoverAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, PlannedFailoverInput failoverInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginPlannedFailoverWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Disables protection.
            /// </summary>
            /// <remarks>
            /// The operation to disable replication on a replication protected item. This
            /// will also remove the item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='disableProtectionInput'>
            /// Disable protection input.
            /// </param>
            public static void BeginDelete(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, DisableProtectionInput disableProtectionInput)
            {
                operations.BeginDeleteAsync(fabricName, protectionContainerName, replicatedProtectedItemName, disableProtectionInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Disables protection.
            /// </summary>
            /// <remarks>
            /// The operation to disable replication on a replication protected item. This
            /// will also remove the item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='disableProtectionInput'>
            /// Disable protection input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task BeginDeleteAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, DisableProtectionInput disableProtectionInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.BeginDeleteWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, disableProtectionInput, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// Removes disk(s).
            /// </summary>
            /// <remarks>
            /// Operation to remove disk(s) from the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='removeDisksInput'>
            /// Remove disks input.
            /// </param>
            public static ReplicationProtectedItem BeginRemoveDisks(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, RemoveDisksInput removeDisksInput)
            {
                return operations.BeginRemoveDisksAsync(fabricName, protectionContainerName, replicatedProtectedItemName, removeDisksInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Removes disk(s).
            /// </summary>
            /// <remarks>
            /// Operation to remove disk(s) from the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='removeDisksInput'>
            /// Remove disks input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginRemoveDisksAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, RemoveDisksInput removeDisksInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginRemoveDisksWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, removeDisksInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Resynchronize or repair replication.
            /// </summary>
            /// <remarks>
            /// The operation to start resynchronize/repair replication for a replication
            /// protected item requiring resynchronization.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The name of the fabric.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The name of the container.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// The name of the replication protected item.
            /// </param>
            public static ReplicationProtectedItem BeginRepairReplication(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName)
            {
                return operations.BeginRepairReplicationAsync(fabricName, protectionContainerName, replicatedProtectedItemName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Resynchronize or repair replication.
            /// </summary>
            /// <remarks>
            /// The operation to start resynchronize/repair replication for a replication
            /// protected item requiring resynchronization.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The name of the fabric.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The name of the container.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// The name of the replication protected item.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginRepairReplicationAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginRepairReplicationWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute Reverse Replication\Reprotect
            /// </summary>
            /// <remarks>
            /// Operation to reprotect or reverse replicate a failed over replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='rrInput'>
            /// Disable protection input.
            /// </param>
            public static ReplicationProtectedItem BeginReprotect(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ReverseReplicationInput rrInput)
            {
                return operations.BeginReprotectAsync(fabricName, protectionContainerName, replicatedProtectedItemName, rrInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute Reverse Replication\Reprotect
            /// </summary>
            /// <remarks>
            /// Operation to reprotect or reverse replicate a failed over replication
            /// protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='rrInput'>
            /// Disable protection input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginReprotectAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ReverseReplicationInput rrInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginReprotectWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, rrInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Resolve health errors.
            /// </summary>
            /// <remarks>
            /// Operation to resolve health issues of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='resolveHealthInput'>
            /// Health issue input object.
            /// </param>
            public static ReplicationProtectedItem BeginResolveHealthErrors(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ResolveHealthInput resolveHealthInput)
            {
                return operations.BeginResolveHealthErrorsAsync(fabricName, protectionContainerName, replicatedProtectedItemName, resolveHealthInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Resolve health errors.
            /// </summary>
            /// <remarks>
            /// Operation to resolve health issues of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='resolveHealthInput'>
            /// Health issue input object.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginResolveHealthErrorsAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, ResolveHealthInput resolveHealthInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginResolveHealthErrorsWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, resolveHealthInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute test failover
            /// </summary>
            /// <remarks>
            /// Operation to perform a test failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Test failover input.
            /// </param>
            public static ReplicationProtectedItem BeginTestFailover(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, TestFailoverInput failoverInput)
            {
                return operations.BeginTestFailoverAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute test failover
            /// </summary>
            /// <remarks>
            /// Operation to perform a test failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Test failover input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginTestFailoverAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, TestFailoverInput failoverInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginTestFailoverWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute test failover cleanup.
            /// </summary>
            /// <remarks>
            /// Operation to clean up the test failover of a replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='cleanupInput'>
            /// Test failover cleanup input.
            /// </param>
            public static ReplicationProtectedItem BeginTestFailoverCleanup(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, TestFailoverCleanupInput cleanupInput)
            {
                return operations.BeginTestFailoverCleanupAsync(fabricName, protectionContainerName, replicatedProtectedItemName, cleanupInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute test failover cleanup.
            /// </summary>
            /// <remarks>
            /// Operation to clean up the test failover of a replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='cleanupInput'>
            /// Test failover cleanup input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginTestFailoverCleanupAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, TestFailoverCleanupInput cleanupInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginTestFailoverCleanupWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, cleanupInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Execute unplanned failover
            /// </summary>
            /// <remarks>
            /// Operation to initiate a failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Disable protection input.
            /// </param>
            public static ReplicationProtectedItem BeginUnplannedFailover(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, UnplannedFailoverInput failoverInput)
            {
                return operations.BeginUnplannedFailoverAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Execute unplanned failover
            /// </summary>
            /// <remarks>
            /// Operation to initiate a failover of the replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Unique fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// Protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='failoverInput'>
            /// Disable protection input.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginUnplannedFailoverAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, UnplannedFailoverInput failoverInput, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginUnplannedFailoverWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, failoverInput, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Update the mobility service on a protected item.
            /// </summary>
            /// <remarks>
            /// The operation to update(push update) the installed mobility service
            /// software on a replication protected item to the latest available version.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The name of the fabric containing the protected item.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The name of the container containing the protected item.
            /// </param>
            /// <param name='replicationProtectedItemName'>
            /// The name of the protected item on which the agent is to be updated.
            /// </param>
            /// <param name='updateMobilityServiceRequest'>
            /// Request to update the mobility service on the protected item.
            /// </param>
            public static ReplicationProtectedItem BeginUpdateMobilityService(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicationProtectedItemName, UpdateMobilityServiceRequest updateMobilityServiceRequest)
            {
                return operations.BeginUpdateMobilityServiceAsync(fabricName, protectionContainerName, replicationProtectedItemName, updateMobilityServiceRequest).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Update the mobility service on a protected item.
            /// </summary>
            /// <remarks>
            /// The operation to update(push update) the installed mobility service
            /// software on a replication protected item to the latest available version.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// The name of the fabric containing the protected item.
            /// </param>
            /// <param name='protectionContainerName'>
            /// The name of the container containing the protected item.
            /// </param>
            /// <param name='replicationProtectedItemName'>
            /// The name of the protected item on which the agent is to be updated.
            /// </param>
            /// <param name='updateMobilityServiceRequest'>
            /// Request to update the mobility service on the protected item.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReplicationProtectedItem> BeginUpdateMobilityServiceAsync(this IReplicationProtectedItemsOperations operations, string fabricName, string protectionContainerName, string replicationProtectedItemName, UpdateMobilityServiceRequest updateMobilityServiceRequest, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginUpdateMobilityServiceWithHttpMessagesAsync(fabricName, protectionContainerName, replicationProtectedItemName, updateMobilityServiceRequest, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the list of Replication protected items.
            /// </summary>
            /// <remarks>
            /// Gets the list of ASR replication protected items in the protection
            /// container.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<ReplicationProtectedItem> ListByReplicationProtectionContainersNext(this IReplicationProtectedItemsOperations operations, string nextPageLink)
            {
                return operations.ListByReplicationProtectionContainersNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the list of Replication protected items.
            /// </summary>
            /// <remarks>
            /// Gets the list of ASR replication protected items in the protection
            /// container.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ReplicationProtectedItem>> ListByReplicationProtectionContainersNextAsync(this IReplicationProtectedItemsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByReplicationProtectionContainersNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the list of replication protected items.
            /// </summary>
            /// <remarks>
            /// Gets the list of ASR replication protected items in the vault.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<ReplicationProtectedItem> ListNext(this IReplicationProtectedItemsOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the list of replication protected items.
            /// </summary>
            /// <remarks>
            /// Gets the list of ASR replication protected items in the vault.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<ReplicationProtectedItem>> ListNextAsync(this IReplicationProtectedItemsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
