// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.RecoveryServices.SiteRecovery
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for TargetComputeSizesOperations.
    /// </summary>
    public static partial class TargetComputeSizesOperationsExtensions
    {
            /// <summary>
            /// Gets the list of target compute sizes for the replication protected item.
            /// </summary>
            /// <remarks>
            /// Lists the available target compute sizes for a replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            public static IPage<TargetComputeSize> ListByReplicationProtectedItems(this ITargetComputeSizesOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName)
            {
                return operations.ListByReplicationProtectedItemsAsync(fabricName, protectionContainerName, replicatedProtectedItemName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the list of target compute sizes for the replication protected item.
            /// </summary>
            /// <remarks>
            /// Lists the available target compute sizes for a replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fabricName'>
            /// Fabric name.
            /// </param>
            /// <param name='protectionContainerName'>
            /// protection container name.
            /// </param>
            /// <param name='replicatedProtectedItemName'>
            /// Replication protected item name.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<TargetComputeSize>> ListByReplicationProtectedItemsAsync(this ITargetComputeSizesOperations operations, string fabricName, string protectionContainerName, string replicatedProtectedItemName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByReplicationProtectedItemsWithHttpMessagesAsync(fabricName, protectionContainerName, replicatedProtectedItemName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the list of target compute sizes for the replication protected item.
            /// </summary>
            /// <remarks>
            /// Lists the available target compute sizes for a replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<TargetComputeSize> ListByReplicationProtectedItemsNext(this ITargetComputeSizesOperations operations, string nextPageLink)
            {
                return operations.ListByReplicationProtectedItemsNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the list of target compute sizes for the replication protected item.
            /// </summary>
            /// <remarks>
            /// Lists the available target compute sizes for a replication protected item.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<TargetComputeSize>> ListByReplicationProtectedItemsNextAsync(this ITargetComputeSizesOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByReplicationProtectedItemsNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
