// Code generated by Microsoft (R) AutoRest Code Generator 1.0.1.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.RecoveryServices.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.RecoveryServices;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Replication usages of a vault.
    /// </summary>
    public partial class ReplicationUsage
    {
        /// <summary>
        /// Initializes a new instance of the ReplicationUsage class.
        /// </summary>
        public ReplicationUsage() { }

        /// <summary>
        /// Initializes a new instance of the ReplicationUsage class.
        /// </summary>
        /// <param name="monitoringSummary">Summary of the replication
        /// monitoring data for this vault.</param>
        /// <param name="jobsSummary">Summary of the replication jobs data for
        /// this vault.</param>
        /// <param name="protectedItemCount">Number of replication protected
        /// items for this vault.</param>
        /// <param name="recoveryPlanCount">Number of replication recovery
        /// plans for this vault.</param>
        /// <param name="registeredServersCount">Number of servers registered
        /// to this vault.</param>
        /// <param name="recoveryServicesProviderAuthType">The authentication
        /// type of recovery service providers in the vault.</param>
        public ReplicationUsage(MonitoringSummary monitoringSummary = default(MonitoringSummary), JobsSummary jobsSummary = default(JobsSummary), int? protectedItemCount = default(int?), int? recoveryPlanCount = default(int?), int? registeredServersCount = default(int?), int? recoveryServicesProviderAuthType = default(int?))
        {
            MonitoringSummary = monitoringSummary;
            JobsSummary = jobsSummary;
            ProtectedItemCount = protectedItemCount;
            RecoveryPlanCount = recoveryPlanCount;
            RegisteredServersCount = registeredServersCount;
            RecoveryServicesProviderAuthType = recoveryServicesProviderAuthType;
        }

        /// <summary>
        /// Gets or sets summary of the replication monitoring data for this
        /// vault.
        /// </summary>
        [JsonProperty(PropertyName = "monitoringSummary")]
        public MonitoringSummary MonitoringSummary { get; set; }

        /// <summary>
        /// Gets or sets summary of the replication jobs data for this vault.
        /// </summary>
        [JsonProperty(PropertyName = "jobsSummary")]
        public JobsSummary JobsSummary { get; set; }

        /// <summary>
        /// Gets or sets number of replication protected items for this vault.
        /// </summary>
        [JsonProperty(PropertyName = "protectedItemCount")]
        public int? ProtectedItemCount { get; set; }

        /// <summary>
        /// Gets or sets number of replication recovery plans for this vault.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryPlanCount")]
        public int? RecoveryPlanCount { get; set; }

        /// <summary>
        /// Gets or sets number of servers registered to this vault.
        /// </summary>
        [JsonProperty(PropertyName = "registeredServersCount")]
        public int? RegisteredServersCount { get; set; }

        /// <summary>
        /// Gets or sets the authentication type of recovery service providers
        /// in the vault.
        /// </summary>
        [JsonProperty(PropertyName = "recoveryServicesProviderAuthType")]
        public int? RecoveryServicesProviderAuthType { get; set; }

    }
}
