// Code generated by Microsoft (R) AutoRest Code Generator 1.0.1.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.RecoveryServices.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.RecoveryServices;
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Certificate details representing the Vault credentials for ACS.
    /// </summary>
    [Newtonsoft.Json.JsonObject("AccessControlService")]
    public partial class ResourceCertificateAndAcsDetails : ResourceCertificateDetails
    {
        /// <summary>
        /// Initializes a new instance of the ResourceCertificateAndAcsDetails
        /// class.
        /// </summary>
        public ResourceCertificateAndAcsDetails() { }

        /// <summary>
        /// Initializes a new instance of the ResourceCertificateAndAcsDetails
        /// class.
        /// </summary>
        /// <param name="globalAcsNamespace">ACS namespace name - tenant for
        /// our service.</param>
        /// <param name="globalAcsHostName">Acs mgmt host name to connect
        /// to.</param>
        /// <param name="globalAcsRPRealm">Global ACS namespace RP
        /// realm.</param>
        /// <param name="certificate">The base64 encoded certificate raw data
        /// string.</param>
        /// <param name="friendlyName">Certificate friendlyname.</param>
        /// <param name="issuer">Certificate issuer.</param>
        /// <param name="resourceId">Resource ID of the vault.</param>
        /// <param name="subject">Certificate Subject Name.</param>
        /// <param name="thumbprint">Certificate thumbprint.</param>
        /// <param name="validFrom">Certificate Validity start Date
        /// time.</param>
        /// <param name="validTo">Certificate Validity End Date time.</param>
        public ResourceCertificateAndAcsDetails(string globalAcsNamespace, string globalAcsHostName, string globalAcsRPRealm, byte[] certificate = default(byte[]), string friendlyName = default(string), string issuer = default(string), long? resourceId = default(long?), string subject = default(string), string thumbprint = default(string), System.DateTime? validFrom = default(System.DateTime?), System.DateTime? validTo = default(System.DateTime?))
            : base(certificate, friendlyName, issuer, resourceId, subject, thumbprint, validFrom, validTo)
        {
            GlobalAcsNamespace = globalAcsNamespace;
            GlobalAcsHostName = globalAcsHostName;
            GlobalAcsRPRealm = globalAcsRPRealm;
        }

        /// <summary>
        /// Gets or sets ACS namespace name - tenant for our service.
        /// </summary>
        [JsonProperty(PropertyName = "globalAcsNamespace")]
        public string GlobalAcsNamespace { get; set; }

        /// <summary>
        /// Gets or sets acs mgmt host name to connect to.
        /// </summary>
        [JsonProperty(PropertyName = "globalAcsHostName")]
        public string GlobalAcsHostName { get; set; }

        /// <summary>
        /// Gets or sets global ACS namespace RP realm.
        /// </summary>
        [JsonProperty(PropertyName = "globalAcsRPRealm")]
        public string GlobalAcsRPRealm { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (GlobalAcsNamespace == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "GlobalAcsNamespace");
            }
            if (GlobalAcsHostName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "GlobalAcsHostName");
            }
            if (GlobalAcsRPRealm == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "GlobalAcsRPRealm");
            }
        }
    }
}
