// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Reservations.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class CalculatePriceResponseProperties
    {
        /// <summary>
        /// Initializes a new instance of the CalculatePriceResponseProperties
        /// class.
        /// </summary>
        public CalculatePriceResponseProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CalculatePriceResponseProperties
        /// class.
        /// </summary>
        /// <param name="billingCurrencyTotal">Currency and amount that
        /// customer will be charged in customer's local currency. Tax is not
        /// included.</param>
        /// <param name="isBillingPartnerManaged">True if billing is managed by
        /// Microsoft Partner. Used only for CSP accounts.</param>
        /// <param name="reservationOrderId">GUID that represents reservation
        /// order that can be placed after calculating price.</param>
        /// <param name="skuTitle">Title of SKU that is being
        /// purchased.</param>
        /// <param name="skuDescription">Description of SKU that is being
        /// purchased.</param>
        /// <param name="pricingCurrencyTotal">Amount that Microsoft uses for
        /// record. Used during refund for calculating refund limit. Tax is not
        /// included.</param>
        public CalculatePriceResponseProperties(CalculatePriceResponsePropertiesBillingCurrencyTotal billingCurrencyTotal = default(CalculatePriceResponsePropertiesBillingCurrencyTotal), bool? isBillingPartnerManaged = default(bool?), string reservationOrderId = default(string), string skuTitle = default(string), string skuDescription = default(string), CalculatePriceResponsePropertiesPricingCurrencyTotal pricingCurrencyTotal = default(CalculatePriceResponsePropertiesPricingCurrencyTotal), IList<PaymentDetail> paymentSchedule = default(IList<PaymentDetail>))
        {
            BillingCurrencyTotal = billingCurrencyTotal;
            IsBillingPartnerManaged = isBillingPartnerManaged;
            ReservationOrderId = reservationOrderId;
            SkuTitle = skuTitle;
            SkuDescription = skuDescription;
            PricingCurrencyTotal = pricingCurrencyTotal;
            PaymentSchedule = paymentSchedule;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets currency and amount that customer will be charged in
        /// customer's local currency. Tax is not included.
        /// </summary>
        [JsonProperty(PropertyName = "billingCurrencyTotal")]
        public CalculatePriceResponsePropertiesBillingCurrencyTotal BillingCurrencyTotal { get; set; }

        /// <summary>
        /// Gets or sets true if billing is managed by Microsoft Partner. Used
        /// only for CSP accounts.
        /// </summary>
        [JsonProperty(PropertyName = "isBillingPartnerManaged")]
        public bool? IsBillingPartnerManaged { get; set; }

        /// <summary>
        /// Gets or sets GUID that represents reservation order that can be
        /// placed after calculating price.
        /// </summary>
        [JsonProperty(PropertyName = "reservationOrderId")]
        public string ReservationOrderId { get; set; }

        /// <summary>
        /// Gets or sets title of SKU that is being purchased.
        /// </summary>
        [JsonProperty(PropertyName = "skuTitle")]
        public string SkuTitle { get; set; }

        /// <summary>
        /// Gets or sets description of SKU that is being purchased.
        /// </summary>
        [JsonProperty(PropertyName = "skuDescription")]
        public string SkuDescription { get; set; }

        /// <summary>
        /// Gets or sets amount that Microsoft uses for record. Used during
        /// refund for calculating refund limit. Tax is not included.
        /// </summary>
        [JsonProperty(PropertyName = "pricingCurrencyTotal")]
        public CalculatePriceResponsePropertiesPricingCurrencyTotal PricingCurrencyTotal { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "paymentSchedule")]
        public IList<PaymentDetail> PaymentSchedule { get; set; }

    }
}
