// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Reservations.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    public partial class RenewPropertiesResponse
    {
        /// <summary>
        /// Initializes a new instance of the RenewPropertiesResponse class.
        /// </summary>
        public RenewPropertiesResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RenewPropertiesResponse class.
        /// </summary>
        /// <param name="pricingCurrencyTotal">Amount that Microsoft uses for
        /// record. Used during refund for calculating refund limit. Tax is not
        /// included. This is locked price 30 days before expiry.</param>
        /// <param name="billingCurrencyTotal">Currency and amount that
        /// customer will be charged in customer's local currency for renewal
        /// purchase. Tax is not included.</param>
        public RenewPropertiesResponse(PurchaseRequest purchaseProperties = default(PurchaseRequest), RenewPropertiesResponsePricingCurrencyTotal pricingCurrencyTotal = default(RenewPropertiesResponsePricingCurrencyTotal), RenewPropertiesResponseBillingCurrencyTotal billingCurrencyTotal = default(RenewPropertiesResponseBillingCurrencyTotal))
        {
            PurchaseProperties = purchaseProperties;
            PricingCurrencyTotal = pricingCurrencyTotal;
            BillingCurrencyTotal = billingCurrencyTotal;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "purchaseProperties")]
        public PurchaseRequest PurchaseProperties { get; set; }

        /// <summary>
        /// Gets or sets amount that Microsoft uses for record. Used during
        /// refund for calculating refund limit. Tax is not included. This is
        /// locked price 30 days before expiry.
        /// </summary>
        [JsonProperty(PropertyName = "pricingCurrencyTotal")]
        public RenewPropertiesResponsePricingCurrencyTotal PricingCurrencyTotal { get; set; }

        /// <summary>
        /// Gets or sets currency and amount that customer will be charged in
        /// customer's local currency for renewal purchase. Tax is not
        /// included.
        /// </summary>
        [JsonProperty(PropertyName = "billingCurrencyTotal")]
        public RenewPropertiesResponseBillingCurrencyTotal BillingCurrencyTotal { get; set; }

    }
}
