// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Reservations.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    [Rest.Serialization.JsonTransformation]
    public partial class ReservationOrderResponse : IResource
    {
        /// <summary>
        /// Initializes a new instance of the ReservationOrderResponse class.
        /// </summary>
        public ReservationOrderResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ReservationOrderResponse class.
        /// </summary>
        /// <param name="id">Identifier of the reservation</param>
        /// <param name="name">Name of the reservation</param>
        /// <param name="displayName">Friendly name for user to easily
        /// identified the reservation.</param>
        /// <param name="requestDateTime">This is the DateTime when the
        /// reservation was initially requested for purchase.</param>
        /// <param name="createdDateTime">This is the DateTime when the
        /// reservation was created.</param>
        /// <param name="expiryDate">This is the date when the Reservation will
        /// expire.</param>
        /// <param name="term">Possible values include: 'P1Y', 'P3Y'</param>
        /// <param name="provisioningState">Current state of the
        /// reservation.</param>
        /// <param name="billingPlan">Possible values include: 'Upfront',
        /// 'Monthly'</param>
        /// <param name="type">Type of resource.
        /// "Microsoft.Capacity/reservations"</param>
        public ReservationOrderResponse(int? etag = default(int?), string id = default(string), string name = default(string), string displayName = default(string), System.DateTime? requestDateTime = default(System.DateTime?), System.DateTime? createdDateTime = default(System.DateTime?), System.DateTime? expiryDate = default(System.DateTime?), int? originalQuantity = default(int?), string term = default(string), string provisioningState = default(string), string billingPlan = default(string), ReservationOrderBillingPlanInformation planInformation = default(ReservationOrderBillingPlanInformation), IList<ReservationResponse> reservationsProperty = default(IList<ReservationResponse>), string type = default(string))
        {
            Etag = etag;
            Id = id;
            Name = name;
            DisplayName = displayName;
            RequestDateTime = requestDateTime;
            CreatedDateTime = createdDateTime;
            ExpiryDate = expiryDate;
            OriginalQuantity = originalQuantity;
            Term = term;
            ProvisioningState = provisioningState;
            BillingPlan = billingPlan;
            PlanInformation = planInformation;
            ReservationsProperty = reservationsProperty;
            Type = type;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public int? Etag { get; set; }

        /// <summary>
        /// Gets identifier of the reservation
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets name of the reservation
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets or sets friendly name for user to easily identified the
        /// reservation.
        /// </summary>
        [JsonProperty(PropertyName = "properties.displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets this is the DateTime when the reservation was
        /// initially requested for purchase.
        /// </summary>
        [JsonProperty(PropertyName = "properties.requestDateTime")]
        public System.DateTime? RequestDateTime { get; set; }

        /// <summary>
        /// Gets or sets this is the DateTime when the reservation was created.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdDateTime")]
        public System.DateTime? CreatedDateTime { get; set; }

        /// <summary>
        /// Gets or sets this is the date when the Reservation will expire.
        /// </summary>
        [JsonConverter(typeof(DateJsonConverter))]
        [JsonProperty(PropertyName = "properties.expiryDate")]
        public System.DateTime? ExpiryDate { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.originalQuantity")]
        public int? OriginalQuantity { get; set; }

        /// <summary>
        /// Gets or sets possible values include: 'P1Y', 'P3Y'
        /// </summary>
        [JsonProperty(PropertyName = "properties.term")]
        public string Term { get; set; }

        /// <summary>
        /// Gets or sets current state of the reservation.
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets or sets possible values include: 'Upfront', 'Monthly'
        /// </summary>
        [JsonProperty(PropertyName = "properties.billingPlan")]
        public string BillingPlan { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.planInformation")]
        public ReservationOrderBillingPlanInformation PlanInformation { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.reservations")]
        public IList<ReservationResponse> ReservationsProperty { get; set; }

        /// <summary>
        /// Gets type of resource. "Microsoft.Capacity/reservations"
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

    }
}
