// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ResourceGraph
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ResourceGraphClient.
    /// </summary>
    public static partial class ResourceGraphClientExtensions
    {
            /// <summary>
            /// Queries the resources managed by Azure Resource Manager for all
            /// subscriptions specified in the request.
            /// <see href="https://aka.ms/resource-graph/learntoquery" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='query'>
            /// Request specifying query and its options.
            /// </param>
            public static QueryResponse Resources(this IResourceGraphClient operations, QueryRequest query)
            {
                return operations.ResourcesAsync(query).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Queries the resources managed by Azure Resource Manager for all
            /// subscriptions specified in the request.
            /// <see href="https://aka.ms/resource-graph/learntoquery" />
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='query'>
            /// Request specifying query and its options.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<QueryResponse> ResourcesAsync(this IResourceGraphClient operations, QueryRequest query, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ResourcesWithHttpMessagesAsync(query, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
