// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ResourceManager.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The resource link.
    /// </summary>
    public partial class ResourceLink : IResource
    {
        /// <summary>
        /// Initializes a new instance of the ResourceLink class.
        /// </summary>
        public ResourceLink()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceLink class.
        /// </summary>
        /// <param name="id">The fully qualified ID of the resource
        /// link.</param>
        /// <param name="name">The name of the resource link.</param>
        /// <param name="properties">Properties for resource link.</param>
        public ResourceLink(string id = default(string), string name = default(string), ResourceLinkProperties properties = default(ResourceLinkProperties))
        {
            Id = id;
            Name = name;
            Properties = properties;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the fully qualified ID of the resource link.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets the name of the resource link.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets or sets properties for resource link.
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public ResourceLinkProperties Properties { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Properties != null)
            {
                Properties.Validate();
            }
        }
    }
}
