// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Response containing suggestion query results from an index.
    /// </summary>
    public partial class DocumentSuggestResult<T>
    {
        /// <summary>
        /// Initializes a new instance of the DocumentSuggestResult class.
        /// </summary>
        public DocumentSuggestResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DocumentSuggestResult class.
        /// </summary>
        /// <param name="results">The sequence of results returned by the
        /// query.</param>
        /// <param name="coverage">A value indicating the percentage of the
        /// index that was included in the query, or null if minimumCoverage
        /// was not set in the request.</param>
        public DocumentSuggestResult(IList<SuggestResult<T>> results = default(IList<SuggestResult<T>>), double? coverage = default(double?))
        {
            Results = results;
            Coverage = coverage;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the sequence of results returned by the query.
        /// </summary>
        [JsonProperty(PropertyName = "value")]
        public IList<SuggestResult<T>> Results { get; private set; }

        /// <summary>
        /// Gets a value indicating the percentage of the index that was
        /// included in the query, or null if minimumCoverage was not set in
        /// the request.
        /// </summary>
        [JsonProperty(PropertyName = "@search.coverage")]
        public double? Coverage { get; private set; }

    }
}
