// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents an index action that operates on a document.
    /// </summary>
    public partial class IndexAction<T>
    {
        /// <summary>
        /// Initializes a new instance of the IndexAction class.
        /// </summary>
        public IndexAction()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IndexAction class.
        /// </summary>
        /// <param name="document">The document on which the action will be performed.</param>
        /// <param name="actionType">The operation to perform on a document in
        /// an indexing batch. Possible values include: 'upload', 'merge',
        /// 'mergeOrUpload', 'delete'</param>
        public IndexAction(T document = default(T), IndexActionType actionType = default(IndexActionType))
        {
            Document = document;
            ActionType = actionType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the document on which the action will be performed; Fields other than the key are ignored for delete actions. 
        /// </summary>
        public T Document { get; set; }

        /// <summary>
        /// Gets or sets the operation to perform on a document in an indexing
        /// batch. Possible values include: 'upload', 'merge', 'mergeOrUpload',
        /// 'delete'
        /// </summary>
        [JsonProperty(PropertyName = "@search.action")]
        public IndexActionType ActionType { get; set; }

    }
}
