// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Status of an indexing operation for a single document.
    /// </summary>
    public partial class IndexingResult
    {
        /// <summary>
        /// Initializes a new instance of the IndexingResult class.
        /// </summary>
        public IndexingResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IndexingResult class.
        /// </summary>
        /// <param name="key">The key of a document that was in the indexing
        /// request.</param>
        /// <param name="errorMessage">The error message explaining why the
        /// indexing operation failed for the document identified by the key;
        /// null if indexing succeeded.</param>
        /// <param name="succeeded">A value indicating whether the indexing
        /// operation succeeded for the document identified by the key.</param>
        /// <param name="statusCode">The status code of the indexing operation.
        /// Possible values include: 200 for a successful update or delete, 201
        /// for successful document creation, 400 for a malformed input
        /// document, 404 for document not found, 409 for a version conflict,
        /// 422 when the index is temporarily unavailable, or 503 for when the
        /// service is too busy.</param>
        public IndexingResult(string key = default(string), string errorMessage = default(string), bool succeeded = default(bool), int statusCode = default(int))
        {
            Key = key;
            ErrorMessage = errorMessage;
            Succeeded = succeeded;
            StatusCode = statusCode;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the key of a document that was in the indexing request.
        /// </summary>
        [JsonProperty(PropertyName = "key")]
        public string Key { get; private set; }

        /// <summary>
        /// Gets the error message explaining why the indexing operation failed
        /// for the document identified by the key; null if indexing succeeded.
        /// </summary>
        [JsonProperty(PropertyName = "errorMessage")]
        public string ErrorMessage { get; private set; }

        /// <summary>
        /// Gets a value indicating whether the indexing operation succeeded
        /// for the document identified by the key.
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public bool Succeeded { get; private set; }

        /// <summary>
        /// Gets the status code of the indexing operation. Possible values
        /// include: 200 for a successful update or delete, 201 for successful
        /// document creation, 400 for a malformed input document, 404 for
        /// document not found, 409 for a version conflict, 422 when the index
        /// is temporarily unavailable, or 503 for when the service is too
        /// busy.
        /// </summary>
        [JsonProperty(PropertyName = "statusCode")]
        public int StatusCode { get; private set; }

    }
}
