// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Converts alphabetic, numeric, and symbolic Unicode characters which are
    /// not in the first 127 ASCII characters (the "Basic Latin" Unicode block)
    /// into their ASCII equivalents, if such equivalents exist. This token
    /// filter is implemented using Apache Lucene.
    /// <see
    /// href="http://lucene.apache.org/core/4_10_3/analyzers-common/org/apache/lucene/analysis/miscellaneous/ASCIIFoldingFilter.html"
    /// />
    /// </summary>
    [Newtonsoft.Json.JsonObject("#Microsoft.Azure.Search.AsciiFoldingTokenFilter")]
    public partial class AsciiFoldingTokenFilter : TokenFilter
    {
        /// <summary>
        /// Initializes a new instance of the AsciiFoldingTokenFilter class.
        /// </summary>
        public AsciiFoldingTokenFilter()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AsciiFoldingTokenFilter class.
        /// </summary>
        /// <param name="name">The name of the token filter. It must only
        /// contain letters, digits, spaces, dashes or underscores, can only
        /// start and end with alphanumeric characters, and is limited to 128
        /// characters.</param>
        /// <param name="preserveOriginal">A value indicating whether the
        /// original token will be kept. Default is false.</param>
        public AsciiFoldingTokenFilter(string name, bool? preserveOriginal = default(bool?))
            : base(name)
        {
            PreserveOriginal = preserveOriginal;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a value indicating whether the original token will be
        /// kept. Default is false.
        /// </summary>
        [JsonProperty(PropertyName = "preserveOriginal")]
        public bool? PreserveOriginal { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
