// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Provides parameter values to a distance scoring function.
    /// </summary>
    public partial class DistanceScoringParameters
    {
        /// <summary>
        /// Initializes a new instance of the DistanceScoringParameters class.
        /// </summary>
        public DistanceScoringParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DistanceScoringParameters class.
        /// </summary>
        /// <param name="referencePointParameter">The name of the parameter
        /// passed in search queries to specify the reference location.</param>
        /// <param name="boostingDistance">The distance in kilometers from the
        /// reference location where the boosting range ends.</param>
        public DistanceScoringParameters(string referencePointParameter, double boostingDistance)
        {
            ReferencePointParameter = referencePointParameter;
            BoostingDistance = boostingDistance;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the parameter passed in search queries to
        /// specify the reference location.
        /// </summary>
        [JsonProperty(PropertyName = "referencePointParameter")]
        public string ReferencePointParameter { get; set; }

        /// <summary>
        /// Gets or sets the distance in kilometers from the reference location
        /// where the boosting range ends.
        /// </summary>
        [JsonProperty(PropertyName = "boostingDistance")]
        public double BoostingDistance { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ReferencePointParameter == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ReferencePointParameter");
            }
        }
    }
}
