// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents an indexer.
    /// <see
    /// href="https://docs.microsoft.com/rest/api/searchservice/Indexer-operations"
    /// />
    /// </summary>
    public partial class Indexer
    {
        /// <summary>
        /// Initializes a new instance of the Indexer class.
        /// </summary>
        public Indexer()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Indexer class.
        /// </summary>
        /// <param name="name">The name of the indexer.</param>
        /// <param name="dataSourceName">The name of the datasource from which
        /// this indexer reads data.</param>
        /// <param name="targetIndexName">The name of the index to which this
        /// indexer writes data.</param>
        /// <param name="description">The description of the indexer.</param>
        /// <param name="skillsetName">The name of the skillset executing with
        /// this indexer.</param>
        /// <param name="schedule">The schedule for this indexer.</param>
        /// <param name="parameters">Parameters for indexer execution.</param>
        /// <param name="fieldMappings">Defines mappings between fields in the
        /// data source and corresponding target fields in the index.</param>
        /// <param name="outputFieldMappings">Output field mappings are applied
        /// after enrichment and immediately before indexing.</param>
        /// <param name="isDisabled">A value indicating whether the indexer is
        /// disabled. Default is false.</param>
        /// <param name="eTag">The ETag of the Indexer.</param>
        public Indexer(string name, string dataSourceName, string targetIndexName, string description = default(string), string skillsetName = default(string), IndexingSchedule schedule = default(IndexingSchedule), IndexingParameters parameters = default(IndexingParameters), IList<FieldMapping> fieldMappings = default(IList<FieldMapping>), IList<FieldMapping> outputFieldMappings = default(IList<FieldMapping>), bool? isDisabled = default(bool?), string eTag = default(string))
        {
            Name = name;
            Description = description;
            DataSourceName = dataSourceName;
            SkillsetName = skillsetName;
            TargetIndexName = targetIndexName;
            Schedule = schedule;
            Parameters = parameters;
            FieldMappings = fieldMappings;
            OutputFieldMappings = outputFieldMappings;
            IsDisabled = isDisabled;
            ETag = eTag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the indexer.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the description of the indexer.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets the name of the datasource from which this indexer
        /// reads data.
        /// </summary>
        [JsonProperty(PropertyName = "dataSourceName")]
        public string DataSourceName { get; set; }

        /// <summary>
        /// Gets or sets the name of the skillset executing with this indexer.
        /// </summary>
        [JsonProperty(PropertyName = "skillsetName")]
        public string SkillsetName { get; set; }

        /// <summary>
        /// Gets or sets the name of the index to which this indexer writes
        /// data.
        /// </summary>
        [JsonProperty(PropertyName = "targetIndexName")]
        public string TargetIndexName { get; set; }

        /// <summary>
        /// Gets or sets the schedule for this indexer.
        /// </summary>
        [JsonProperty(PropertyName = "schedule")]
        public IndexingSchedule Schedule { get; set; }

        /// <summary>
        /// Gets or sets parameters for indexer execution.
        /// </summary>
        [JsonProperty(PropertyName = "parameters")]
        public IndexingParameters Parameters { get; set; }

        /// <summary>
        /// Gets or sets defines mappings between fields in the data source and
        /// corresponding target fields in the index.
        /// </summary>
        [JsonProperty(PropertyName = "fieldMappings")]
        public IList<FieldMapping> FieldMappings { get; set; }

        /// <summary>
        /// Gets or sets output field mappings are applied after enrichment and
        /// immediately before indexing.
        /// </summary>
        [JsonProperty(PropertyName = "outputFieldMappings")]
        public IList<FieldMapping> OutputFieldMappings { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether the indexer is disabled.
        /// Default is false.
        /// </summary>
        [JsonProperty(PropertyName = "disabled")]
        public bool? IsDisabled { get; set; }

        /// <summary>
        /// Gets or sets the ETag of the Indexer.
        /// </summary>
        [JsonProperty(PropertyName = "@odata.etag")]
        public string ETag { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (DataSourceName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DataSourceName");
            }
            if (TargetIndexName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetIndexName");
            }
            if (Schedule != null)
            {
                Schedule.Validate();
            }
            if (FieldMappings != null)
            {
                foreach (var element in FieldMappings)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (OutputFieldMappings != null)
            {
                foreach (var element1 in OutputFieldMappings)
                {
                    if (element1 != null)
                    {
                        element1.Validate();
                    }
                }
            }
        }
    }
}
