// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents the current status and execution history of an indexer.
    /// </summary>
    public partial class IndexerExecutionInfo
    {
        /// <summary>
        /// Initializes a new instance of the IndexerExecutionInfo class.
        /// </summary>
        public IndexerExecutionInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IndexerExecutionInfo class.
        /// </summary>
        /// <param name="status">Overall indexer status. Possible values
        /// include: 'unknown', 'error', 'running'</param>
        /// <param name="lastResult">The result of the most recent or an
        /// in-progress indexer execution.</param>
        /// <param name="executionHistory">History of the recent indexer
        /// executions, sorted in reverse chronological order.</param>
        /// <param name="limits">The execution limits for the indexer.</param>
        public IndexerExecutionInfo(IndexerStatus status = default(IndexerStatus), IndexerExecutionResult lastResult = default(IndexerExecutionResult), IList<IndexerExecutionResult> executionHistory = default(IList<IndexerExecutionResult>), IndexerLimits limits = default(IndexerLimits))
        {
            Status = status;
            LastResult = lastResult;
            ExecutionHistory = executionHistory;
            Limits = limits;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets overall indexer status. Possible values include: 'unknown',
        /// 'error', 'running'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public IndexerStatus Status { get; private set; }

        /// <summary>
        /// Gets the result of the most recent or an in-progress indexer
        /// execution.
        /// </summary>
        [JsonProperty(PropertyName = "lastResult")]
        public IndexerExecutionResult LastResult { get; private set; }

        /// <summary>
        /// Gets history of the recent indexer executions, sorted in reverse
        /// chronological order.
        /// </summary>
        [JsonProperty(PropertyName = "executionHistory")]
        public IList<IndexerExecutionResult> ExecutionHistory { get; private set; }

        /// <summary>
        /// Gets the execution limits for the indexer.
        /// </summary>
        [JsonProperty(PropertyName = "limits")]
        public IndexerLimits Limits { get; private set; }

    }
}
