// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents an item- or document-level indexing error.
    /// </summary>
    public partial class ItemError
    {
        /// <summary>
        /// Initializes a new instance of the ItemError class.
        /// </summary>
        public ItemError()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ItemError class.
        /// </summary>
        /// <param name="key">The key of the item for which indexing
        /// failed.</param>
        /// <param name="errorMessage">The message describing the error that
        /// occurred while processing the item.</param>
        /// <param name="statusCode">The status code indicating why the
        /// indexing operation failed. Possible values include: 400 for a
        /// malformed input document, 404 for document not found, 409 for a
        /// version conflict, 422 when the index is temporarily unavailable, or
        /// 503 for when the service is too busy.</param>
        /// <param name="name">The name of the source at which the error
        /// originated. For example, this could refer to a particular skill in
        /// the attached skillset. This may not be always available.</param>
        /// <param name="details">Additional, verbose details about the error
        /// to assist in debugging the indexer. This may not be always
        /// available.</param>
        /// <param name="documentationLink">A link to a troubleshooting guide
        /// for these classes of errors. This may not be always
        /// available.</param>
        public ItemError(string key = default(string), string errorMessage = default(string), int statusCode = default(int), string name = default(string), string details = default(string), string documentationLink = default(string))
        {
            Key = key;
            ErrorMessage = errorMessage;
            StatusCode = statusCode;
            Name = name;
            Details = details;
            DocumentationLink = documentationLink;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the key of the item for which indexing failed.
        /// </summary>
        [JsonProperty(PropertyName = "key")]
        public string Key { get; private set; }

        /// <summary>
        /// Gets the message describing the error that occurred while
        /// processing the item.
        /// </summary>
        [JsonProperty(PropertyName = "errorMessage")]
        public string ErrorMessage { get; private set; }

        /// <summary>
        /// Gets the status code indicating why the indexing operation failed.
        /// Possible values include: 400 for a malformed input document, 404
        /// for document not found, 409 for a version conflict, 422 when the
        /// index is temporarily unavailable, or 503 for when the service is
        /// too busy.
        /// </summary>
        [JsonProperty(PropertyName = "statusCode")]
        public int StatusCode { get; private set; }

        /// <summary>
        /// Gets the name of the source at which the error originated. For
        /// example, this could refer to a particular skill in the attached
        /// skillset. This may not be always available.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets additional, verbose details about the error to assist in
        /// debugging the indexer. This may not be always available.
        /// </summary>
        [JsonProperty(PropertyName = "details")]
        public string Details { get; private set; }

        /// <summary>
        /// Gets a link to a troubleshooting guide for these classes of errors.
        /// This may not be always available.
        /// </summary>
        [JsonProperty(PropertyName = "documentationLink")]
        public string DocumentationLink { get; private set; }

    }
}
