// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents an item-level warning.
    /// </summary>
    public partial class ItemWarning
    {
        /// <summary>
        /// Initializes a new instance of the ItemWarning class.
        /// </summary>
        public ItemWarning()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ItemWarning class.
        /// </summary>
        /// <param name="key">The key of the item which generated a
        /// warning.</param>
        /// <param name="message">The message describing the warning that
        /// occurred while processing the item.</param>
        /// <param name="name">The name of the source at which the warning
        /// originated. For example, this could refer to a particular skill in
        /// the attached skillset. This may not be always available.</param>
        /// <param name="details">Additional, verbose details about the warning
        /// to assist in debugging the indexer. This may not be always
        /// available.</param>
        /// <param name="documentationLink">A link to a troubleshooting guide
        /// for these classes of warnings. This may not be always
        /// available.</param>
        public ItemWarning(string key = default(string), string message = default(string), string name = default(string), string details = default(string), string documentationLink = default(string))
        {
            Key = key;
            Message = message;
            Name = name;
            Details = details;
            DocumentationLink = documentationLink;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the key of the item which generated a warning.
        /// </summary>
        [JsonProperty(PropertyName = "key")]
        public string Key { get; private set; }

        /// <summary>
        /// Gets the message describing the warning that occurred while
        /// processing the item.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; private set; }

        /// <summary>
        /// Gets the name of the source at which the warning originated. For
        /// example, this could refer to a particular skill in the attached
        /// skillset. This may not be always available.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets additional, verbose details about the warning to assist in
        /// debugging the indexer. This may not be always available.
        /// </summary>
        [JsonProperty(PropertyName = "details")]
        public string Details { get; private set; }

        /// <summary>
        /// Gets a link to a troubleshooting guide for these classes of
        /// warnings. This may not be always available.
        /// </summary>
        [JsonProperty(PropertyName = "documentationLink")]
        public string DocumentationLink { get; private set; }

    }
}
