// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Marks terms as keywords. This token filter is implemented using Apache
    /// Lucene.
    /// <see
    /// href="http://lucene.apache.org/core/4_10_3/analyzers-common/org/apache/lucene/analysis/miscellaneous/KeywordMarkerFilter.html"
    /// />
    /// </summary>
    [Newtonsoft.Json.JsonObject("#Microsoft.Azure.Search.KeywordMarkerTokenFilter")]
    public partial class KeywordMarkerTokenFilter : TokenFilter
    {
        /// <summary>
        /// Initializes a new instance of the KeywordMarkerTokenFilter class.
        /// </summary>
        public KeywordMarkerTokenFilter()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the KeywordMarkerTokenFilter class.
        /// </summary>
        /// <param name="name">The name of the token filter. It must only
        /// contain letters, digits, spaces, dashes or underscores, can only
        /// start and end with alphanumeric characters, and is limited to 128
        /// characters.</param>
        /// <param name="keywords">A list of words to mark as keywords.</param>
        /// <param name="ignoreCase">A value indicating whether to ignore case.
        /// If true, all words are converted to lower case first. Default is
        /// false.</param>
        public KeywordMarkerTokenFilter(string name, IList<string> keywords, bool? ignoreCase = default(bool?))
            : base(name)
        {
            Keywords = keywords;
            IgnoreCase = ignoreCase;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a list of words to mark as keywords.
        /// </summary>
        [JsonProperty(PropertyName = "keywords")]
        public IList<string> Keywords { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether to ignore case. If true,
        /// all words are converted to lower case first. Default is false.
        /// </summary>
        [JsonProperty(PropertyName = "ignoreCase")]
        public bool? IgnoreCase { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (Keywords == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Keywords");
            }
        }
    }
}
