// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A skill for merging two or more strings into a single unified string,
    /// with an optional user-defined delimiter separating each component part.
    /// <see
    /// href="https://docs.microsoft.com/azure/search/cognitive-search-skill-textmerger"
    /// />
    /// </summary>
    [Newtonsoft.Json.JsonObject("#Microsoft.Skills.Text.MergeSkill")]
    public partial class MergeSkill : Skill
    {
        /// <summary>
        /// Initializes a new instance of the MergeSkill class.
        /// </summary>
        public MergeSkill()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MergeSkill class.
        /// </summary>
        /// <param name="inputs">Inputs of the skills could be a column in the
        /// source data set, or the output of an upstream skill.</param>
        /// <param name="outputs">The output of a skill is either a field in a
        /// search index, or a value that can be consumed as an input by
        /// another skill.</param>
        /// <param name="name">The name of the skill which uniquely identifies
        /// it within the skillset. A skill with no name defined will be given
        /// a default name of its 1-based index in the skills array, prefixed
        /// with the character '#'.</param>
        /// <param name="description">The description of the skill which
        /// describes the inputs, outputs, and usage of the skill.</param>
        /// <param name="context">Represents the level at which operations take
        /// place, such as the document root or document content (for example,
        /// /document or /document/content). The default is /document.</param>
        /// <param name="insertPreTag">The tag indicates the start of the
        /// merged text. By default, the tag is an empty space.</param>
        /// <param name="insertPostTag">The tag indicates the end of the merged
        /// text. By default, the tag is an empty space.</param>
        public MergeSkill(IList<InputFieldMappingEntry> inputs, IList<OutputFieldMappingEntry> outputs, string name = default(string), string description = default(string), string context = default(string), string insertPreTag = default(string), string insertPostTag = default(string))
            : base(inputs, outputs, name, description, context)
        {
            InsertPreTag = insertPreTag;
            InsertPostTag = insertPostTag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the tag indicates the start of the merged text. By
        /// default, the tag is an empty space.
        /// </summary>
        [JsonProperty(PropertyName = "insertPreTag")]
        public string InsertPreTag { get; set; }

        /// <summary>
        /// Gets or sets the tag indicates the end of the merged text. By
        /// default, the tag is an empty space.
        /// </summary>
        [JsonProperty(PropertyName = "insertPostTag")]
        public string InsertPostTag { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
