// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Output field mapping for a skill.
    /// <see
    /// href="https://docs.microsoft.com/rest/api/searchservice/naming-rules"
    /// />
    /// </summary>
    public partial class OutputFieldMappingEntry
    {
        /// <summary>
        /// Initializes a new instance of the OutputFieldMappingEntry class.
        /// </summary>
        public OutputFieldMappingEntry()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OutputFieldMappingEntry class.
        /// </summary>
        /// <param name="name">The name of the output defined by the
        /// skill.</param>
        /// <param name="targetName">The target name of the output. It is
        /// optional and default to name.</param>
        public OutputFieldMappingEntry(string name, string targetName = default(string))
        {
            Name = name;
            TargetName = targetName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the output defined by the skill.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the target name of the output. It is optional and
        /// default to name.
        /// </summary>
        [JsonProperty(PropertyName = "targetName")]
        public string TargetName { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
        }
    }
}
