// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Text analytics positive-negative sentiment analysis, scored as a
    /// floating point value in a range of zero to 1.
    /// <see
    /// href="https://docs.microsoft.com/azure/search/cognitive-search-skill-sentiment"
    /// />
    /// </summary>
    [Newtonsoft.Json.JsonObject("#Microsoft.Skills.Text.SentimentSkill")]
    public partial class SentimentSkill : Skill
    {
        /// <summary>
        /// Initializes a new instance of the SentimentSkill class.
        /// </summary>
        public SentimentSkill()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SentimentSkill class.
        /// </summary>
        /// <param name="inputs">Inputs of the skills could be a column in the
        /// source data set, or the output of an upstream skill.</param>
        /// <param name="outputs">The output of a skill is either a field in a
        /// search index, or a value that can be consumed as an input by
        /// another skill.</param>
        /// <param name="name">The name of the skill which uniquely identifies
        /// it within the skillset. A skill with no name defined will be given
        /// a default name of its 1-based index in the skills array, prefixed
        /// with the character '#'.</param>
        /// <param name="description">The description of the skill which
        /// describes the inputs, outputs, and usage of the skill.</param>
        /// <param name="context">Represents the level at which operations take
        /// place, such as the document root or document content (for example,
        /// /document or /document/content). The default is /document.</param>
        /// <param name="defaultLanguageCode">A value indicating which language
        /// code to use. Default is en. Possible values include: 'da', 'nl',
        /// 'en', 'fi', 'fr', 'de', 'el', 'it', 'no', 'pl', 'pt-PT', 'ru',
        /// 'es', 'sv', 'tr'</param>
        public SentimentSkill(IList<InputFieldMappingEntry> inputs, IList<OutputFieldMappingEntry> outputs, string name = default(string), string description = default(string), string context = default(string), SentimentSkillLanguage? defaultLanguageCode = default(SentimentSkillLanguage?))
            : base(inputs, outputs, name, description, context)
        {
            DefaultLanguageCode = defaultLanguageCode;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a value indicating which language code to use. Default
        /// is en. Possible values include: 'da', 'nl', 'en', 'fi', 'fr', 'de',
        /// 'el', 'it', 'no', 'pl', 'pt-PT', 'ru', 'es', 'sv', 'tr'
        /// </summary>
        [JsonProperty(PropertyName = "defaultLanguageCode")]
        public SentimentSkillLanguage? DefaultLanguageCode { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
