// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Search.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Removes stop words from a token stream. This token filter is
    /// implemented using Apache Lucene.
    /// <see
    /// href="http://lucene.apache.org/core/4_10_3/analyzers-common/org/apache/lucene/analysis/core/StopFilter.html"
    /// />
    /// </summary>
    [Newtonsoft.Json.JsonObject("#Microsoft.Azure.Search.StopwordsTokenFilter")]
    public partial class StopwordsTokenFilter : TokenFilter
    {
        /// <summary>
        /// Initializes a new instance of the StopwordsTokenFilter class.
        /// </summary>
        public StopwordsTokenFilter()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the StopwordsTokenFilter class.
        /// </summary>
        /// <param name="name">The name of the token filter. It must only
        /// contain letters, digits, spaces, dashes or underscores, can only
        /// start and end with alphanumeric characters, and is limited to 128
        /// characters.</param>
        /// <param name="stopwords">The list of stopwords. This property and
        /// the stopwords list property cannot both be set.</param>
        /// <param name="stopwordsList">A predefined list of stopwords to use.
        /// This property and the stopwords property cannot both be set.
        /// Default is English. Possible values include: 'arabic', 'armenian',
        /// 'basque', 'brazilian', 'bulgarian', 'catalan', 'czech', 'danish',
        /// 'dutch', 'english', 'finnish', 'french', 'galician', 'german',
        /// 'greek', 'hindi', 'hungarian', 'indonesian', 'irish', 'italian',
        /// 'latvian', 'norwegian', 'persian', 'portuguese', 'romanian',
        /// 'russian', 'sorani', 'spanish', 'swedish', 'thai',
        /// 'turkish'</param>
        /// <param name="ignoreCase">A value indicating whether to ignore case.
        /// If true, all words are converted to lower case first. Default is
        /// false.</param>
        /// <param name="removeTrailingStopWords">A value indicating whether to
        /// ignore the last search term if it's a stop word. Default is
        /// true.</param>
        public StopwordsTokenFilter(string name, IList<string> stopwords = default(IList<string>), StopwordsList? stopwordsList = default(StopwordsList?), bool? ignoreCase = default(bool?), bool? removeTrailingStopWords = default(bool?))
            : base(name)
        {
            Stopwords = stopwords;
            StopwordsList = stopwordsList;
            IgnoreCase = ignoreCase;
            RemoveTrailingStopWords = removeTrailingStopWords;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the list of stopwords. This property and the stopwords
        /// list property cannot both be set.
        /// </summary>
        [JsonProperty(PropertyName = "stopwords")]
        public IList<string> Stopwords { get; set; }

        /// <summary>
        /// Gets or sets a predefined list of stopwords to use. This property
        /// and the stopwords property cannot both be set. Default is English.
        /// Possible values include: 'arabic', 'armenian', 'basque',
        /// 'brazilian', 'bulgarian', 'catalan', 'czech', 'danish', 'dutch',
        /// 'english', 'finnish', 'french', 'galician', 'german', 'greek',
        /// 'hindi', 'hungarian', 'indonesian', 'irish', 'italian', 'latvian',
        /// 'norwegian', 'persian', 'portuguese', 'romanian', 'russian',
        /// 'sorani', 'spanish', 'swedish', 'thai', 'turkish'
        /// </summary>
        [JsonProperty(PropertyName = "stopwordsList")]
        public StopwordsList? StopwordsList { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether to ignore case. If true,
        /// all words are converted to lower case first. Default is false.
        /// </summary>
        [JsonProperty(PropertyName = "ignoreCase")]
        public bool? IgnoreCase { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether to ignore the last search
        /// term if it's a stop word. Default is true.
        /// </summary>
        [JsonProperty(PropertyName = "removeTrailing")]
        public bool? RemoveTrailingStopWords { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
