// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The altered data of the recommended VM/server group policy
    /// </summary>
    public partial class AppWhitelistingPutGroupData
    {
        /// <summary>
        /// Initializes a new instance of the AppWhitelistingPutGroupData
        /// class.
        /// </summary>
        public AppWhitelistingPutGroupData()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AppWhitelistingPutGroupData
        /// class.
        /// </summary>
        /// <param name="enforcementMode">The enforcement mode of the group.
        /// Can also be defined per collection type by using ProtectionMode.
        /// Possible values include: 'Audit', 'Enforce', 'None'</param>
        /// <param name="protectionMode">The protection mode of the group per
        /// collection type. Can also be defined for all collection types by
        /// using EnforcementMode</param>
        public AppWhitelistingPutGroupData(string enforcementMode = default(string), ProtectionMode protectionMode = default(ProtectionMode), IList<VmRecommendation> vmRecommendations = default(IList<VmRecommendation>), IList<PathRecommendation> pathRecommendations = default(IList<PathRecommendation>))
        {
            EnforcementMode = enforcementMode;
            ProtectionMode = protectionMode;
            VmRecommendations = vmRecommendations;
            PathRecommendations = pathRecommendations;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the enforcement mode of the group. Can also be defined
        /// per collection type by using ProtectionMode. Possible values
        /// include: 'Audit', 'Enforce', 'None'
        /// </summary>
        [JsonProperty(PropertyName = "enforcementMode")]
        public string EnforcementMode { get; set; }

        /// <summary>
        /// Gets or sets the protection mode of the group per collection type.
        /// Can also be defined for all collection types by using
        /// EnforcementMode
        /// </summary>
        [JsonProperty(PropertyName = "protectionMode")]
        public ProtectionMode ProtectionMode { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "vmRecommendations")]
        public IList<VmRecommendation> VmRecommendations { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "pathRecommendations")]
        public IList<PathRecommendation> PathRecommendations { get; set; }

    }
}
