// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Auto provisioning setting
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class AutoProvisioningSetting : Resource
    {
        /// <summary>
        /// Initializes a new instance of the AutoProvisioningSetting class.
        /// </summary>
        public AutoProvisioningSetting()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AutoProvisioningSetting class.
        /// </summary>
        /// <param name="autoProvision">Describes what kind of security agent
        /// provisioning action to take. Possible values include: 'On',
        /// 'Off'</param>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        public AutoProvisioningSetting(string autoProvision, string id = default(string), string name = default(string), string type = default(string))
            : base(id, name, type)
        {
            AutoProvision = autoProvision;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets describes what kind of security agent provisioning
        /// action to take. Possible values include: 'On', 'Off'
        /// </summary>
        [JsonProperty(PropertyName = "properties.autoProvision")]
        public string AutoProvision { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (AutoProvision == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AutoProvision");
            }
        }
    }
}
