// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes the allowed inbound and outbound traffic of an Azure resource
    /// </summary>
    public partial class ConnectableResource
    {
        /// <summary>
        /// Initializes a new instance of the ConnectableResource class.
        /// </summary>
        public ConnectableResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ConnectableResource class.
        /// </summary>
        /// <param name="id">The Azure resource id</param>
        /// <param name="inboundConnectedResources">The list of Azure resources
        /// that the resource has inbound allowed connection from</param>
        /// <param name="outboundConnectedResources">The list of Azure
        /// resources that the resource has outbound allowed connection
        /// to</param>
        public ConnectableResource(string id = default(string), IList<ConnectedResource> inboundConnectedResources = default(IList<ConnectedResource>), IList<ConnectedResource> outboundConnectedResources = default(IList<ConnectedResource>))
        {
            Id = id;
            InboundConnectedResources = inboundConnectedResources;
            OutboundConnectedResources = outboundConnectedResources;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the Azure resource id
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets the list of Azure resources that the resource has inbound
        /// allowed connection from
        /// </summary>
        [JsonProperty(PropertyName = "inboundConnectedResources")]
        public IList<ConnectedResource> InboundConnectedResources { get; private set; }

        /// <summary>
        /// Gets the list of Azure resources that the resource has outbound
        /// allowed connection to
        /// </summary>
        [JsonProperty(PropertyName = "outboundConnectedResources")]
        public IList<ConnectedResource> OutboundConnectedResources { get; private set; }

    }
}
