// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The device security group resource
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class DeviceSecurityGroup : Resource
    {
        /// <summary>
        /// Initializes a new instance of the DeviceSecurityGroup class.
        /// </summary>
        public DeviceSecurityGroup()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DeviceSecurityGroup class.
        /// </summary>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="thresholdRules">The list of custom alert threshold
        /// rules.</param>
        /// <param name="timeWindowRules">The list of custom alert time-window
        /// rules.</param>
        /// <param name="allowlistRules">The allow-list custom alert
        /// rules.</param>
        /// <param name="denylistRules">The deny-list custom alert
        /// rules.</param>
        public DeviceSecurityGroup(string id = default(string), string name = default(string), string type = default(string), IList<ThresholdCustomAlertRule> thresholdRules = default(IList<ThresholdCustomAlertRule>), IList<TimeWindowCustomAlertRule> timeWindowRules = default(IList<TimeWindowCustomAlertRule>), IList<AllowlistCustomAlertRule> allowlistRules = default(IList<AllowlistCustomAlertRule>), IList<DenylistCustomAlertRule> denylistRules = default(IList<DenylistCustomAlertRule>))
            : base(id, name, type)
        {
            ThresholdRules = thresholdRules;
            TimeWindowRules = timeWindowRules;
            AllowlistRules = allowlistRules;
            DenylistRules = denylistRules;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the list of custom alert threshold rules.
        /// </summary>
        [JsonProperty(PropertyName = "properties.thresholdRules")]
        public IList<ThresholdCustomAlertRule> ThresholdRules { get; set; }

        /// <summary>
        /// Gets or sets the list of custom alert time-window rules.
        /// </summary>
        [JsonProperty(PropertyName = "properties.timeWindowRules")]
        public IList<TimeWindowCustomAlertRule> TimeWindowRules { get; set; }

        /// <summary>
        /// Gets or sets the allow-list custom alert rules.
        /// </summary>
        [JsonProperty(PropertyName = "properties.allowlistRules")]
        public IList<AllowlistCustomAlertRule> AllowlistRules { get; set; }

        /// <summary>
        /// Gets or sets the deny-list custom alert rules.
        /// </summary>
        [JsonProperty(PropertyName = "properties.denylistRules")]
        public IList<DenylistCustomAlertRule> DenylistRules { get; set; }

    }
}
