// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Statistical information about the number of alerts per alert type
    /// during last set number of days
    /// </summary>
    public partial class IoTSecurityDeviceAlert
    {
        /// <summary>
        /// Initializes a new instance of the IoTSecurityDeviceAlert class.
        /// </summary>
        public IoTSecurityDeviceAlert()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IoTSecurityDeviceAlert class.
        /// </summary>
        /// <param name="alertDisplayName">Display name of the alert</param>
        /// <param name="reportedSeverity">Assessed Alert severity. Possible
        /// values include: 'Informational', 'Low', 'Medium', 'High'</param>
        /// <param name="alertsCount">Number of alerts raised for this alert
        /// type.</param>
        public IoTSecurityDeviceAlert(string alertDisplayName = default(string), string reportedSeverity = default(string), int? alertsCount = default(int?))
        {
            AlertDisplayName = alertDisplayName;
            ReportedSeverity = reportedSeverity;
            AlertsCount = alertsCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets display name of the alert
        /// </summary>
        [JsonProperty(PropertyName = "alertDisplayName")]
        public string AlertDisplayName { get; private set; }

        /// <summary>
        /// Gets assessed Alert severity. Possible values include:
        /// 'Informational', 'Low', 'Medium', 'High'
        /// </summary>
        [JsonProperty(PropertyName = "reportedSeverity")]
        public string ReportedSeverity { get; private set; }

        /// <summary>
        /// Gets number of alerts raised for this alert type.
        /// </summary>
        [JsonProperty(PropertyName = "alertsCount")]
        public int? AlertsCount { get; private set; }

    }
}
