// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Security analytics of your IoT Security solution
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class IoTSecuritySolutionAnalyticsModel : Resource
    {
        /// <summary>
        /// Initializes a new instance of the IoTSecuritySolutionAnalyticsModel
        /// class.
        /// </summary>
        public IoTSecuritySolutionAnalyticsModel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IoTSecuritySolutionAnalyticsModel
        /// class.
        /// </summary>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="metrics">Security analytics of your IoT Security
        /// solution.</param>
        /// <param name="unhealthyDeviceCount">Number of unhealthy devices
        /// within your IoT Security solution.</param>
        /// <param name="devicesMetrics">List of device metrics by the
        /// aggregation date.</param>
        /// <param name="topAlertedDevices">List of the 3 devices with the most
        /// alerts.</param>
        /// <param name="mostPrevalentDeviceAlerts">List of the 3 most
        /// prevalent device alerts.</param>
        /// <param name="mostPrevalentDeviceRecommendations">List of the 3 most
        /// prevalent device recommendations.</param>
        public IoTSecuritySolutionAnalyticsModel(string id = default(string), string name = default(string), string type = default(string), IoTSeverityMetrics metrics = default(IoTSeverityMetrics), int? unhealthyDeviceCount = default(int?), IList<IoTSecuritySolutionAnalyticsModelPropertiesDevicesMetricsItem> devicesMetrics = default(IList<IoTSecuritySolutionAnalyticsModelPropertiesDevicesMetricsItem>), IList<IoTSecurityAlertedDevice> topAlertedDevices = default(IList<IoTSecurityAlertedDevice>), IList<IoTSecurityDeviceAlert> mostPrevalentDeviceAlerts = default(IList<IoTSecurityDeviceAlert>), IList<IoTSecurityDeviceRecommendation> mostPrevalentDeviceRecommendations = default(IList<IoTSecurityDeviceRecommendation>))
            : base(id, name, type)
        {
            Metrics = metrics;
            UnhealthyDeviceCount = unhealthyDeviceCount;
            DevicesMetrics = devicesMetrics;
            TopAlertedDevices = topAlertedDevices;
            MostPrevalentDeviceAlerts = mostPrevalentDeviceAlerts;
            MostPrevalentDeviceRecommendations = mostPrevalentDeviceRecommendations;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets security analytics of your IoT Security solution.
        /// </summary>
        [JsonProperty(PropertyName = "properties.metrics")]
        public IoTSeverityMetrics Metrics { get; private set; }

        /// <summary>
        /// Gets number of unhealthy devices within your IoT Security solution.
        /// </summary>
        [JsonProperty(PropertyName = "properties.unhealthyDeviceCount")]
        public int? UnhealthyDeviceCount { get; private set; }

        /// <summary>
        /// Gets list of device metrics by the aggregation date.
        /// </summary>
        [JsonProperty(PropertyName = "properties.devicesMetrics")]
        public IList<IoTSecuritySolutionAnalyticsModelPropertiesDevicesMetricsItem> DevicesMetrics { get; private set; }

        /// <summary>
        /// Gets or sets list of the 3 devices with the most alerts.
        /// </summary>
        [JsonProperty(PropertyName = "properties.topAlertedDevices")]
        public IList<IoTSecurityAlertedDevice> TopAlertedDevices { get; set; }

        /// <summary>
        /// Gets or sets list of the 3 most prevalent device alerts.
        /// </summary>
        [JsonProperty(PropertyName = "properties.mostPrevalentDeviceAlerts")]
        public IList<IoTSecurityDeviceAlert> MostPrevalentDeviceAlerts { get; set; }

        /// <summary>
        /// Gets or sets list of the 3 most prevalent device recommendations.
        /// </summary>
        [JsonProperty(PropertyName = "properties.mostPrevalentDeviceRecommendations")]
        public IList<IoTSecurityDeviceRecommendation> MostPrevalentDeviceRecommendations { get; set; }

    }
}
