// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class JitNetworkAccessRequest
    {
        /// <summary>
        /// Initializes a new instance of the JitNetworkAccessRequest class.
        /// </summary>
        public JitNetworkAccessRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JitNetworkAccessRequest class.
        /// </summary>
        /// <param name="startTimeUtc">The start time of the request in
        /// UTC</param>
        /// <param name="requestor">The identity of the person who made the
        /// request</param>
        /// <param name="justification">The justification for making the
        /// initiate request</param>
        public JitNetworkAccessRequest(IList<JitNetworkAccessRequestVirtualMachine> virtualMachines, System.DateTime startTimeUtc, string requestor, string justification = default(string))
        {
            VirtualMachines = virtualMachines;
            StartTimeUtc = startTimeUtc;
            Requestor = requestor;
            Justification = justification;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "virtualMachines")]
        public IList<JitNetworkAccessRequestVirtualMachine> VirtualMachines { get; set; }

        /// <summary>
        /// Gets or sets the start time of the request in UTC
        /// </summary>
        [JsonProperty(PropertyName = "startTimeUtc")]
        public System.DateTime StartTimeUtc { get; set; }

        /// <summary>
        /// Gets or sets the identity of the person who made the request
        /// </summary>
        [JsonProperty(PropertyName = "requestor")]
        public string Requestor { get; set; }

        /// <summary>
        /// Gets or sets the justification for making the initiate request
        /// </summary>
        [JsonProperty(PropertyName = "justification")]
        public string Justification { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VirtualMachines == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "VirtualMachines");
            }
            if (Requestor == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Requestor");
            }
            if (VirtualMachines != null)
            {
                foreach (var element in VirtualMachines)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
