// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Azure Security Center is provided in two pricing tiers: free and
    /// standard, with the standard tier available with a trial period. The
    /// standard tier offers advanced security capabilities, while the free
    /// tier offers basic security features.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class Pricing : Resource
    {
        /// <summary>
        /// Initializes a new instance of the Pricing class.
        /// </summary>
        public Pricing()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Pricing class.
        /// </summary>
        /// <param name="pricingTier">The pricing tier value. Azure Security
        /// Center is provided in two pricing tiers: free and standard, with
        /// the standard tier available with a trial period. The standard tier
        /// offers advanced security capabilities, while the free tier offers
        /// basic security features. Possible values include: 'Free',
        /// 'Standard'</param>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="freeTrialRemainingTime">The duration left for the
        /// subscriptions free trial period - in ISO 8601 format (e.g.
        /// P3Y6M4DT12H30M5S).</param>
        public Pricing(string pricingTier, string id = default(string), string name = default(string), string type = default(string), System.TimeSpan? freeTrialRemainingTime = default(System.TimeSpan?))
            : base(id, name, type)
        {
            PricingTier = pricingTier;
            FreeTrialRemainingTime = freeTrialRemainingTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the pricing tier value. Azure Security Center is
        /// provided in two pricing tiers: free and standard, with the standard
        /// tier available with a trial period. The standard tier offers
        /// advanced security capabilities, while the free tier offers basic
        /// security features. Possible values include: 'Free', 'Standard'
        /// </summary>
        [JsonProperty(PropertyName = "properties.pricingTier")]
        public string PricingTier { get; set; }

        /// <summary>
        /// Gets the duration left for the subscriptions free trial period - in
        /// ISO 8601 format (e.g. P3Y6M4DT12H30M5S).
        /// </summary>
        [JsonProperty(PropertyName = "properties.freeTrialRemainingTime")]
        public System.TimeSpan? FreeTrialRemainingTime { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (PricingTier == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PricingTier");
            }
        }
    }
}
