// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents the publisher information of a process/rule
    /// </summary>
    public partial class PublisherInfo
    {
        /// <summary>
        /// Initializes a new instance of the PublisherInfo class.
        /// </summary>
        public PublisherInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PublisherInfo class.
        /// </summary>
        /// <param name="publisherName">The Subject field of the x.509
        /// certificate used to sign the code, using the following fields -  O
        /// = Organization, L = Locality, S = State or Province, and C =
        /// Country</param>
        /// <param name="productName">The product name taken from the file's
        /// version resource</param>
        /// <param name="binaryName">The "OriginalName" field taken from the
        /// file's version resource</param>
        /// <param name="version">The binary file version taken from the file's
        /// version resource</param>
        public PublisherInfo(string publisherName = default(string), string productName = default(string), string binaryName = default(string), string version = default(string))
        {
            PublisherName = publisherName;
            ProductName = productName;
            BinaryName = binaryName;
            Version = version;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Subject field of the x.509 certificate used to
        /// sign the code, using the following fields -  O = Organization, L =
        /// Locality, S = State or Province, and C = Country
        /// </summary>
        [JsonProperty(PropertyName = "publisherName")]
        public string PublisherName { get; set; }

        /// <summary>
        /// Gets or sets the product name taken from the file's version
        /// resource
        /// </summary>
        [JsonProperty(PropertyName = "productName")]
        public string ProductName { get; set; }

        /// <summary>
        /// Gets or sets the "OriginalName" field taken from the file's version
        /// resource
        /// </summary>
        [JsonProperty(PropertyName = "binaryName")]
        public string BinaryName { get; set; }

        /// <summary>
        /// Gets or sets the binary file version taken from the file's version
        /// resource
        /// </summary>
        [JsonProperty(PropertyName = "version")]
        public string Version { get; set; }

    }
}
