// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Regulatory compliance control details and state
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class RegulatoryComplianceControl : Resource
    {
        /// <summary>
        /// Initializes a new instance of the RegulatoryComplianceControl
        /// class.
        /// </summary>
        public RegulatoryComplianceControl()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RegulatoryComplianceControl
        /// class.
        /// </summary>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="description">The description of the regulatory
        /// compliance control</param>
        /// <param name="state">Aggregative state based on the control's
        /// supported assessments states. Possible values include: 'Passed',
        /// 'Failed', 'Skipped', 'Unsupported'</param>
        /// <param name="passedAssessments">The number of supported regulatory
        /// compliance assessments of the given control with a passed
        /// state</param>
        /// <param name="failedAssessments">The number of supported regulatory
        /// compliance assessments of the given control with a failed
        /// state</param>
        /// <param name="skippedAssessments">The number of supported regulatory
        /// compliance assessments of the given control with a skipped
        /// state</param>
        public RegulatoryComplianceControl(string id = default(string), string name = default(string), string type = default(string), string description = default(string), string state = default(string), int? passedAssessments = default(int?), int? failedAssessments = default(int?), int? skippedAssessments = default(int?))
            : base(id, name, type)
        {
            Description = description;
            State = state;
            PassedAssessments = passedAssessments;
            FailedAssessments = failedAssessments;
            SkippedAssessments = skippedAssessments;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the description of the regulatory compliance control
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; private set; }

        /// <summary>
        /// Gets or sets aggregative state based on the control's supported
        /// assessments states. Possible values include: 'Passed', 'Failed',
        /// 'Skipped', 'Unsupported'
        /// </summary>
        [JsonProperty(PropertyName = "properties.state")]
        public string State { get; set; }

        /// <summary>
        /// Gets the number of supported regulatory compliance assessments of
        /// the given control with a passed state
        /// </summary>
        [JsonProperty(PropertyName = "properties.passedAssessments")]
        public int? PassedAssessments { get; private set; }

        /// <summary>
        /// Gets the number of supported regulatory compliance assessments of
        /// the given control with a failed state
        /// </summary>
        [JsonProperty(PropertyName = "properties.failedAssessments")]
        public int? FailedAssessments { get; private set; }

        /// <summary>
        /// Gets the number of supported regulatory compliance assessments of
        /// the given control with a skipped state
        /// </summary>
        [JsonProperty(PropertyName = "properties.skippedAssessments")]
        public int? SkippedAssessments { get; private set; }

    }
}
