// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Security sub-assessment on a resource
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class SecuritySubAssessment : Resource
    {
        /// <summary>
        /// Initializes a new instance of the SecuritySubAssessment class.
        /// </summary>
        public SecuritySubAssessment()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SecuritySubAssessment class.
        /// </summary>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="securitySubAssessmentId">Vulnerability ID</param>
        /// <param name="displayName">User friendly display name of the
        /// sub-assessment</param>
        /// <param name="remediation">Information on how to remediate this
        /// sub-assessment</param>
        /// <param name="impact">Description of the impact of this
        /// sub-assessment</param>
        /// <param name="category">Category of the sub-assessment</param>
        /// <param name="description">Human readable description of the
        /// assessment status</param>
        /// <param name="timeGenerated">The date and time the sub-assessment
        /// was generated</param>
        public SecuritySubAssessment(string id = default(string), string name = default(string), string type = default(string), string securitySubAssessmentId = default(string), string displayName = default(string), SubAssessmentStatus status = default(SubAssessmentStatus), string remediation = default(string), string impact = default(string), string category = default(string), string description = default(string), System.DateTime? timeGenerated = default(System.DateTime?), ResourceDetails resourceDetails = default(ResourceDetails), AdditionalData additionalData = default(AdditionalData))
            : base(id, name, type)
        {
            SecuritySubAssessmentId = securitySubAssessmentId;
            DisplayName = displayName;
            Status = status;
            Remediation = remediation;
            Impact = impact;
            Category = category;
            Description = description;
            TimeGenerated = timeGenerated;
            ResourceDetails = resourceDetails;
            AdditionalData = additionalData;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets vulnerability ID
        /// </summary>
        [JsonProperty(PropertyName = "properties.id")]
        public string SecuritySubAssessmentId { get; private set; }

        /// <summary>
        /// Gets user friendly display name of the sub-assessment
        /// </summary>
        [JsonProperty(PropertyName = "properties.displayName")]
        public string DisplayName { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public SubAssessmentStatus Status { get; set; }

        /// <summary>
        /// Gets information on how to remediate this sub-assessment
        /// </summary>
        [JsonProperty(PropertyName = "properties.remediation")]
        public string Remediation { get; private set; }

        /// <summary>
        /// Gets description of the impact of this sub-assessment
        /// </summary>
        [JsonProperty(PropertyName = "properties.impact")]
        public string Impact { get; private set; }

        /// <summary>
        /// Gets category of the sub-assessment
        /// </summary>
        [JsonProperty(PropertyName = "properties.category")]
        public string Category { get; private set; }

        /// <summary>
        /// Gets human readable description of the assessment status
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; private set; }

        /// <summary>
        /// Gets the date and time the sub-assessment was generated
        /// </summary>
        [JsonProperty(PropertyName = "properties.timeGenerated")]
        public System.DateTime? TimeGenerated { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceDetails")]
        public ResourceDetails ResourceDetails { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.additionalData")]
        public AdditionalData AdditionalData { get; set; }

    }
}
