// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Security task that we recommend to do in order to strengthen security
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class SecurityTask : Resource
    {
        /// <summary>
        /// Initializes a new instance of the SecurityTask class.
        /// </summary>
        public SecurityTask()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SecurityTask class.
        /// </summary>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="state">State of the task (Active, Resolved
        /// etc.)</param>
        /// <param name="creationTimeUtc">The time this task was discovered in
        /// UTC</param>
        /// <param name="lastStateChangeTimeUtc">The time this task's details
        /// were last changed in UTC</param>
        /// <param name="subState">Additional data on the state of the
        /// task</param>
        public SecurityTask(string id = default(string), string name = default(string), string type = default(string), string state = default(string), System.DateTime? creationTimeUtc = default(System.DateTime?), SecurityTaskParameters securityTaskParameters = default(SecurityTaskParameters), System.DateTime? lastStateChangeTimeUtc = default(System.DateTime?), string subState = default(string))
            : base(id, name, type)
        {
            State = state;
            CreationTimeUtc = creationTimeUtc;
            SecurityTaskParameters = securityTaskParameters;
            LastStateChangeTimeUtc = lastStateChangeTimeUtc;
            SubState = subState;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets state of the task (Active, Resolved etc.)
        /// </summary>
        [JsonProperty(PropertyName = "properties.state")]
        public string State { get; private set; }

        /// <summary>
        /// Gets the time this task was discovered in UTC
        /// </summary>
        [JsonProperty(PropertyName = "properties.creationTimeUtc")]
        public System.DateTime? CreationTimeUtc { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.securityTaskParameters")]
        public SecurityTaskParameters SecurityTaskParameters { get; set; }

        /// <summary>
        /// Gets the time this task's details were last changed in UTC
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastStateChangeTimeUtc")]
        public System.DateTime? LastStateChangeTimeUtc { get; private set; }

        /// <summary>
        /// Gets additional data on the state of the task
        /// </summary>
        [JsonProperty(PropertyName = "properties.subState")]
        public string SubState { get; private set; }

    }
}
