// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Status of the sub-assessment
    /// </summary>
    public partial class SubAssessmentStatus
    {
        /// <summary>
        /// Initializes a new instance of the SubAssessmentStatus class.
        /// </summary>
        public SubAssessmentStatus()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SubAssessmentStatus class.
        /// </summary>
        /// <param name="code">Programmatic code for the status of the
        /// assessment. Possible values include: 'Healthy', 'Unhealthy',
        /// 'NotApplicable'</param>
        /// <param name="cause">Programmatic code for the cause of the
        /// assessment status</param>
        /// <param name="description">Human readable description of the
        /// assessment status</param>
        /// <param name="severity">The sub-assessment severity level. Possible
        /// values include: 'Low', 'Medium', 'High'</param>
        public SubAssessmentStatus(string code = default(string), string cause = default(string), string description = default(string), string severity = default(string))
        {
            Code = code;
            Cause = cause;
            Description = description;
            Severity = severity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets programmatic code for the status of the assessment. Possible
        /// values include: 'Healthy', 'Unhealthy', 'NotApplicable'
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; private set; }

        /// <summary>
        /// Gets programmatic code for the cause of the assessment status
        /// </summary>
        [JsonProperty(PropertyName = "cause")]
        public string Cause { get; private set; }

        /// <summary>
        /// Gets human readable description of the assessment status
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; private set; }

        /// <summary>
        /// Gets the sub-assessment severity level. Possible values include:
        /// 'Low', 'Medium', 'High'
        /// </summary>
        [JsonProperty(PropertyName = "severity")]
        public string Severity { get; private set; }

    }
}
