// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Properties of the IoT Security solution's user defined resources.
    /// </summary>
    public partial class UserDefinedResourcesProperties
    {
        /// <summary>
        /// Initializes a new instance of the UserDefinedResourcesProperties
        /// class.
        /// </summary>
        public UserDefinedResourcesProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the UserDefinedResourcesProperties
        /// class.
        /// </summary>
        /// <param name="query">Azure Resource Graph query which represents the
        /// security solution's user defined resources. Required to start with
        /// "where type != "Microsoft.Devices/IotHubs""</param>
        /// <param name="querySubscriptions">List of Azure subscription ids on
        /// which the user defined resources query should be executed.</param>
        public UserDefinedResourcesProperties(string query, IList<string> querySubscriptions)
        {
            Query = query;
            QuerySubscriptions = querySubscriptions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets azure Resource Graph query which represents the
        /// security solution's user defined resources. Required to start with
        /// "where type != "Microsoft.Devices/IotHubs""
        /// </summary>
        [JsonProperty(PropertyName = "query")]
        public string Query { get; set; }

        /// <summary>
        /// Gets or sets list of Azure subscription ids on which the user
        /// defined resources query should be executed.
        /// </summary>
        [JsonProperty(PropertyName = "querySubscriptions")]
        public IList<string> QuerySubscriptions { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Query == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Query");
            }
            if (QuerySubscriptions == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "QuerySubscriptions");
            }
        }
    }
}
