// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for PricingsOperations.
    /// </summary>
    public static partial class PricingsOperationsExtensions
    {
            /// <summary>
            /// Lists Security Center pricing configurations in the subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static PricingList List(this IPricingsOperations operations)
            {
                return operations.ListAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists Security Center pricing configurations in the subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<PricingList> ListAsync(this IPricingsOperations operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets a provided Security Center pricing configuration in the subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='pricingName'>
            /// name of the pricing configuration
            /// </param>
            public static Pricing Get(this IPricingsOperations operations, string pricingName)
            {
                return operations.GetAsync(pricingName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets a provided Security Center pricing configuration in the subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='pricingName'>
            /// name of the pricing configuration
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Pricing> GetAsync(this IPricingsOperations operations, string pricingName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(pricingName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Updates a provided Security Center pricing configuration in the
            /// subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='pricingName'>
            /// name of the pricing configuration
            /// </param>
            /// <param name='pricingTier'>
            /// The pricing tier value. Azure Security Center is provided in two pricing
            /// tiers: free and standard, with the standard tier available with a trial
            /// period. The standard tier offers advanced security capabilities, while the
            /// free tier offers basic security features. Possible values include: 'Free',
            /// 'Standard'
            /// </param>
            public static Pricing Update(this IPricingsOperations operations, string pricingName, string pricingTier)
            {
                return operations.UpdateAsync(pricingName, pricingTier).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates a provided Security Center pricing configuration in the
            /// subscription.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='pricingName'>
            /// name of the pricing configuration
            /// </param>
            /// <param name='pricingTier'>
            /// The pricing tier value. Azure Security Center is provided in two pricing
            /// tiers: free and standard, with the standard tier available with a trial
            /// period. The standard tier offers advanced security capabilities, while the
            /// free tier offers basic security features. Possible values include: 'Free',
            /// 'Standard'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Pricing> UpdateAsync(this IPricingsOperations operations, string pricingName, string pricingTier, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(pricingName, pricingTier, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
