// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Security
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for SettingsOperations.
    /// </summary>
    public static partial class SettingsOperationsExtensions
    {
            /// <summary>
            /// Settings about different configurations in security center
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            public static IPage<Setting> List(this ISettingsOperations operations)
            {
                return operations.ListAsync().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Settings about different configurations in security center
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Setting>> ListAsync(this ISettingsOperations operations, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Settings of different configurations in security center
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='settingName'>
            /// Name of setting: (MCAS/WDATP). Possible values include: 'MCAS', 'WDATP'
            /// </param>
            public static Setting Get(this ISettingsOperations operations, string settingName)
            {
                return operations.GetAsync(settingName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Settings of different configurations in security center
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='settingName'>
            /// Name of setting: (MCAS/WDATP). Possible values include: 'MCAS', 'WDATP'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Setting> GetAsync(this ISettingsOperations operations, string settingName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(settingName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// updating settings about different configurations in security center
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='settingName'>
            /// Name of setting: (MCAS/WDATP). Possible values include: 'MCAS', 'WDATP'
            /// </param>
            /// <param name='kind'>
            /// the kind of the settings string (DataExportSetting). Possible values
            /// include: 'DataExportSetting', 'AlertSuppressionSetting'
            /// </param>
            public static Setting Update(this ISettingsOperations operations, string settingName, string kind)
            {
                return operations.UpdateAsync(settingName, kind).GetAwaiter().GetResult();
            }

            /// <summary>
            /// updating settings about different configurations in security center
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='settingName'>
            /// Name of setting: (MCAS/WDATP). Possible values include: 'MCAS', 'WDATP'
            /// </param>
            /// <param name='kind'>
            /// the kind of the settings string (DataExportSetting). Possible values
            /// include: 'DataExportSetting', 'AlertSuppressionSetting'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Setting> UpdateAsync(this ISettingsOperations operations, string settingName, string kind, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateWithHttpMessagesAsync(settingName, kind, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Settings about different configurations in security center
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            public static IPage<Setting> ListNext(this ISettingsOperations operations, string nextPageLink)
            {
                return operations.ListNextAsync(nextPageLink).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Settings about different configurations in security center
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='nextPageLink'>
            /// The NextLink from the previous successful call to List operation.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IPage<Setting>> ListNextAsync(this ISettingsOperations operations, string nextPageLink, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListNextWithHttpMessagesAsync(nextPageLink, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
