// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ServerManagement.Models
{
    using System.Linq;

    /// <summary>
    /// collection of parameters for operations on a gateway resource
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class GatewayParameters
    {
        /// <summary>
        /// Initializes a new instance of the GatewayParameters class.
        /// </summary>
        public GatewayParameters() { }

        /// <summary>
        /// Initializes a new instance of the GatewayParameters class.
        /// </summary>
        /// <param name="location">location of the resource</param>
        /// <param name="tags">resource tags</param>
        /// <param name="upgradeMode">The upgradeMode property gives the
        /// flexibility to gateway to auto upgrade itself. If properties
        /// value not specified, then we assume upgradeMode = Automatic.
        /// Possible values include: 'Manual', 'Automatic'</param>
        public GatewayParameters(string location = default(string), object tags = default(object), UpgradeMode? upgradeMode = default(UpgradeMode?))
        {
            Location = location;
            Tags = tags;
            UpgradeMode = upgradeMode;
        }

        /// <summary>
        /// Gets or sets location of the resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets resource tags
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "tags")]
        public object Tags { get; set; }

        /// <summary>
        /// Gets or sets the upgradeMode property gives the flexibility to
        /// gateway to auto upgrade itself. If properties value not
        /// specified, then we assume upgradeMode = Automatic. Possible
        /// values include: 'Manual', 'Automatic'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.upgradeMode")]
        public UpgradeMode? UpgradeMode { get; set; }

    }
}
