// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ServerManagement.Models
{
    using System.Linq;

    /// <summary>
    /// JSON properties that the gateway service uses know how to communicate
    /// with the resource.
    /// </summary>
    public partial class GatewayProfile
    {
        /// <summary>
        /// Initializes a new instance of the GatewayProfile class.
        /// </summary>
        public GatewayProfile() { }

        /// <summary>
        /// Initializes a new instance of the GatewayProfile class.
        /// </summary>
        /// <param name="dataPlaneServiceBaseAddress">the Dataplane connection
        /// URL</param>
        /// <param name="gatewayId">the ID of the gateway</param>
        /// <param name="environment">the environment for the gateway (DEV,
        /// DogFood, or Production)</param>
        /// <param name="upgradeManifestUrl">Gateway upgrade manifest
        /// URL</param>
        /// <param name="messagingNamespace">Messaging namespace</param>
        /// <param name="messagingAccount">Messaging Account</param>
        /// <param name="messagingKey">Messaging Key</param>
        /// <param name="requestQueue">Request queue name</param>
        /// <param name="responseTopic">Response topic name</param>
        /// <param name="statusBlobSignature">The gateway status blob SAS
        /// url</param>
        public GatewayProfile(string dataPlaneServiceBaseAddress = default(string), string gatewayId = default(string), string environment = default(string), string upgradeManifestUrl = default(string), string messagingNamespace = default(string), string messagingAccount = default(string), string messagingKey = default(string), string requestQueue = default(string), string responseTopic = default(string), string statusBlobSignature = default(string))
        {
            DataPlaneServiceBaseAddress = dataPlaneServiceBaseAddress;
            GatewayId = gatewayId;
            Environment = environment;
            UpgradeManifestUrl = upgradeManifestUrl;
            MessagingNamespace = messagingNamespace;
            MessagingAccount = messagingAccount;
            MessagingKey = messagingKey;
            RequestQueue = requestQueue;
            ResponseTopic = responseTopic;
            StatusBlobSignature = statusBlobSignature;
        }

        /// <summary>
        /// Gets or sets the Dataplane connection URL
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "dataPlaneServiceBaseAddress")]
        public string DataPlaneServiceBaseAddress { get; set; }

        /// <summary>
        /// Gets or sets the ID of the gateway
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "gatewayId")]
        public string GatewayId { get; set; }

        /// <summary>
        /// Gets or sets the environment for the gateway (DEV, DogFood, or
        /// Production)
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "environment")]
        public string Environment { get; set; }

        /// <summary>
        /// Gets or sets gateway upgrade manifest URL
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "upgradeManifestUrl")]
        public string UpgradeManifestUrl { get; set; }

        /// <summary>
        /// Gets or sets messaging namespace
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "messagingNamespace")]
        public string MessagingNamespace { get; set; }

        /// <summary>
        /// Gets or sets messaging Account
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "messagingAccount")]
        public string MessagingAccount { get; set; }

        /// <summary>
        /// Gets or sets messaging Key
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "messagingKey")]
        public string MessagingKey { get; set; }

        /// <summary>
        /// Gets or sets request queue name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "requestQueue")]
        public string RequestQueue { get; set; }

        /// <summary>
        /// Gets or sets response topic name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "responseTopic")]
        public string ResponseTopic { get; set; }

        /// <summary>
        /// Gets or sets the gateway status blob SAS url
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "statusBlobSignature")]
        public string StatusBlobSignature { get; set; }

    }
}
