// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ServerManagement.Models
{
    using System.Linq;

    /// <summary>
    /// parameter collection for operations on arm node resource
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class NodeParameters
    {
        /// <summary>
        /// Initializes a new instance of the NodeParameters class.
        /// </summary>
        public NodeParameters() { }

        /// <summary>
        /// Initializes a new instance of the NodeParameters class.
        /// </summary>
        /// <param name="location">location of the resource?</param>
        /// <param name="tags">resource tags</param>
        /// <param name="gatewayId">Gateway id which will manage this
        /// node</param>
        /// <param name="connectionName">myhost.domain.com</param>
        /// <param name="userName">User name to be used to connect to
        /// node</param>
        /// <param name="password">Password associated with user name</param>
        public NodeParameters(string location = default(string), object tags = default(object), string gatewayId = default(string), string connectionName = default(string), string userName = default(string), string password = default(string))
        {
            Location = location;
            Tags = tags;
            GatewayId = gatewayId;
            ConnectionName = connectionName;
            UserName = userName;
            Password = password;
        }

        /// <summary>
        /// Gets or sets location of the resource?
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets resource tags
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "tags")]
        public object Tags { get; set; }

        /// <summary>
        /// Gets or sets gateway id which will manage this node
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.gatewayId")]
        public string GatewayId { get; set; }

        /// <summary>
        /// Gets or sets myhost.domain.com
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.connectionName")]
        public string ConnectionName { get; set; }

        /// <summary>
        /// Gets or sets user name to be used to connect to node
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.userName")]
        public string UserName { get; set; }

        /// <summary>
        /// Gets or sets password associated with user name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.password")]
        public string Password { get; set; }

    }
}
