// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ServerManagement.Models
{
    using System.Linq;

    /// <summary>
    /// results from invoking a powershell command
    /// </summary>
    public partial class PowerShellCommandResult
    {
        /// <summary>
        /// Initializes a new instance of the PowerShellCommandResult class.
        /// </summary>
        public PowerShellCommandResult() { }

        /// <summary>
        /// Initializes a new instance of the PowerShellCommandResult class.
        /// </summary>
        /// <param name="messageType">the type of message</param>
        /// <param name="foregroundColor">the HTML color string representing
        /// the foreground color.</param>
        /// <param name="backgroundColor">the HTML color string representing
        /// the background color.</param>
        /// <param name="value">actual result text from the PowerShell
        /// Command</param>
        /// <param name="prompt">The interactive prompt message</param>
        /// <param name="exitCode">the exit code from a executable that was
        /// called from powershell.</param>
        /// <param name="id">ID of the prompt message</param>
        /// <param name="caption">text that precedes the prompt.</param>
        /// <param name="message">text of the prompt.</param>
        /// <param name="descriptions">collection of PromptFieldDescription
        /// objects that contains the user input</param>
        public PowerShellCommandResult(int? messageType = default(int?), string foregroundColor = default(string), string backgroundColor = default(string), string value = default(string), string prompt = default(string), int? exitCode = default(int?), int? id = default(int?), string caption = default(string), string message = default(string), System.Collections.Generic.IList<PromptFieldDescription> descriptions = default(System.Collections.Generic.IList<PromptFieldDescription>))
        {
            MessageType = messageType;
            ForegroundColor = foregroundColor;
            BackgroundColor = backgroundColor;
            Value = value;
            Prompt = prompt;
            ExitCode = exitCode;
            Id = id;
            Caption = caption;
            Message = message;
            Descriptions = descriptions;
        }

        /// <summary>
        /// Gets or sets the type of message
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "messageType")]
        public int? MessageType { get; set; }

        /// <summary>
        /// Gets or sets the HTML color string representing the foreground
        /// color.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "foregroundColor")]
        public string ForegroundColor { get; set; }

        /// <summary>
        /// Gets or sets the HTML color string representing the background
        /// color.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "backgroundColor")]
        public string BackgroundColor { get; set; }

        /// <summary>
        /// Gets or sets actual result text from the PowerShell Command
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

        /// <summary>
        /// Gets or sets the interactive prompt message
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "prompt")]
        public string Prompt { get; set; }

        /// <summary>
        /// Gets or sets the exit code from a executable that was called from
        /// powershell.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "exitCode")]
        public int? ExitCode { get; set; }

        /// <summary>
        /// Gets or sets ID of the prompt message
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "id")]
        public int? Id { get; set; }

        /// <summary>
        /// Gets or sets text that precedes the prompt.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "caption")]
        public string Caption { get; set; }

        /// <summary>
        /// Gets or sets text of the prompt.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

        /// <summary>
        /// Gets or sets collection of PromptFieldDescription objects that
        /// contains the user input
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "descriptions")]
        public System.Collections.Generic.IList<PromptFieldDescription> Descriptions { get; set; }

    }
}
