// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ServerManagement.Models
{
    using System.Linq;

    /// <summary>
    /// result status from invoking a powershell command
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class PowerShellCommandStatus : Resource
    {
        /// <summary>
        /// Initializes a new instance of the PowerShellCommandStatus class.
        /// </summary>
        public PowerShellCommandStatus() { }

        /// <summary>
        /// Initializes a new instance of the PowerShellCommandStatus class.
        /// </summary>
        /// <param name="id">ARM Resource ID</param>
        /// <param name="type">ARM Resource Type</param>
        /// <param name="name">ARM Resource Name</param>
        /// <param name="location">ARM Resource Location</param>
        /// <param name="tags">ARM Resource Tags</param>
        public PowerShellCommandStatus(string id = default(string), string type = default(string), string name = default(string), string location = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), string etag = default(string), System.Collections.Generic.IList<PowerShellCommandResult> results = default(System.Collections.Generic.IList<PowerShellCommandResult>), string pssession = default(string), string command = default(string), bool? completed = default(bool?))
            : base(id, type, name, location, tags, etag)
        {
            Results = results;
            Pssession = pssession;
            Command = command;
            Completed = completed;
        }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.results")]
        public System.Collections.Generic.IList<PowerShellCommandResult> Results { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.pssession")]
        public string Pssession { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.command")]
        public string Command { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.completed")]
        public bool? Completed { get; set; }

    }
}
