// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ServerManagement.Models
{
    using System.Linq;

    /// <summary>
    /// A powershell session resource (practically equivalent to a runspace
    /// instance)
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class PowerShellSessionResource : Resource
    {
        /// <summary>
        /// Initializes a new instance of the PowerShellSessionResource class.
        /// </summary>
        public PowerShellSessionResource() { }

        /// <summary>
        /// Initializes a new instance of the PowerShellSessionResource class.
        /// </summary>
        /// <param name="id">ARM Resource ID</param>
        /// <param name="type">ARM Resource Type</param>
        /// <param name="name">ARM Resource Name</param>
        /// <param name="location">ARM Resource Location</param>
        /// <param name="tags">ARM Resource Tags</param>
        /// <param name="sessionId">the PowerShell Session Id.</param>
        /// <param name="state">The runspace state.</param>
        /// <param name="runspaceAvailability">The availability of the
        /// runspace.</param>
        /// <param name="disconnectedOn">Timestamp of last time the service
        /// disconnected from the runspace.</param>
        /// <param name="expiresOn">Timestamp when the runspace
        /// expires.</param>
        /// <param name="powerShellSessionResourceName">Name of the
        /// runspace</param>
        public PowerShellSessionResource(string id = default(string), string type = default(string), string name = default(string), string location = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), string etag = default(string), string sessionId = default(string), string state = default(string), string runspaceAvailability = default(string), System.DateTime? disconnectedOn = default(System.DateTime?), System.DateTime? expiresOn = default(System.DateTime?), Version version = default(Version), string powerShellSessionResourceName = default(string))
            : base(id, type, name, location, tags, etag)
        {
            SessionId = sessionId;
            State = state;
            RunspaceAvailability = runspaceAvailability;
            DisconnectedOn = disconnectedOn;
            ExpiresOn = expiresOn;
            Version = version;
            PowerShellSessionResourceName = powerShellSessionResourceName;
        }

        /// <summary>
        /// Gets or sets the PowerShell Session Id.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.sessionId")]
        public string SessionId { get; set; }

        /// <summary>
        /// Gets or sets the runspace state.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.state")]
        public string State { get; set; }

        /// <summary>
        /// Gets or sets the availability of the runspace.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.runspaceAvailability")]
        public string RunspaceAvailability { get; set; }

        /// <summary>
        /// Gets or sets timestamp of last time the service disconnected from
        /// the runspace.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.disconnectedOn")]
        public System.DateTime? DisconnectedOn { get; set; }

        /// <summary>
        /// Gets or sets timestamp when the runspace expires.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.expiresOn")]
        public System.DateTime? ExpiresOn { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.version")]
        public Version Version { get; set; }

        /// <summary>
        /// Gets or sets name of the runspace
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.name")]
        public string PowerShellSessionResourceName { get; set; }

    }
}
