// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ServerManagement.Models
{
    using System.Linq;

    /// <summary>
    /// Field description for the implementation of PSHostUserInterface.Prompt
    /// </summary>
    public partial class PromptFieldDescription
    {
        /// <summary>
        /// Initializes a new instance of the PromptFieldDescription class.
        /// </summary>
        public PromptFieldDescription() { }

        /// <summary>
        /// Initializes a new instance of the PromptFieldDescription class.
        /// </summary>
        /// <param name="name">the name of the prompt</param>
        /// <param name="label">the label text of the prompt</param>
        /// <param name="helpMessage">the help message of the prompt</param>
        /// <param name="promptFieldTypeIsList">when set to 'true' the prompt
        /// field type is a list of values</param>
        /// <param name="promptFieldType">Possible values include: 'String',
        /// 'SecureString', 'Credential'</param>
        public PromptFieldDescription(string name = default(string), string label = default(string), string helpMessage = default(string), bool? promptFieldTypeIsList = default(bool?), PromptFieldType? promptFieldType = default(PromptFieldType?))
        {
            Name = name;
            Label = label;
            HelpMessage = helpMessage;
            PromptFieldTypeIsList = promptFieldTypeIsList;
            PromptFieldType = promptFieldType;
        }

        /// <summary>
        /// Gets or sets the name of the prompt
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the label text of the prompt
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "label")]
        public string Label { get; set; }

        /// <summary>
        /// Gets or sets the help message of the prompt
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "helpMessage")]
        public string HelpMessage { get; set; }

        /// <summary>
        /// Gets or sets when set to 'true' the prompt field type is a list of
        /// values
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "promptFieldTypeIsList")]
        public bool? PromptFieldTypeIsList { get; set; }

        /// <summary>
        /// Gets or sets possible values include: 'String', 'SecureString',
        /// 'Credential'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "promptFieldType")]
        public PromptFieldType? PromptFieldType { get; set; }

    }
}
