// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceBus.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Description of Rule Resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class Rule : Resource
    {
        /// <summary>
        /// Initializes a new instance of the Rule class.
        /// </summary>
        public Rule()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Rule class.
        /// </summary>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="action">Represents the filter actions which are
        /// allowed for the transformation of a message that have been matched
        /// by a filter expression.</param>
        /// <param name="filterType">Filter type that is evaluated against a
        /// BrokeredMessage. Possible values include: 'SqlFilter',
        /// 'CorrelationFilter'</param>
        /// <param name="sqlFilter">Properties of sqlFilter</param>
        /// <param name="correlationFilter">Properties of
        /// correlationFilter</param>
        public Rule(string id = default(string), string name = default(string), string type = default(string), Action action = default(Action), FilterType? filterType = default(FilterType?), SqlFilter sqlFilter = default(SqlFilter), CorrelationFilter correlationFilter = default(CorrelationFilter))
            : base(id, name, type)
        {
            Action = action;
            FilterType = filterType;
            SqlFilter = sqlFilter;
            CorrelationFilter = correlationFilter;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets represents the filter actions which are allowed for
        /// the transformation of a message that have been matched by a filter
        /// expression.
        /// </summary>
        [JsonProperty(PropertyName = "properties.action")]
        public Action Action { get; set; }

        /// <summary>
        /// Gets or sets filter type that is evaluated against a
        /// BrokeredMessage. Possible values include: 'SqlFilter',
        /// 'CorrelationFilter'
        /// </summary>
        [JsonProperty(PropertyName = "properties.filterType")]
        public FilterType? FilterType { get; set; }

        /// <summary>
        /// Gets or sets properties of sqlFilter
        /// </summary>
        [JsonProperty(PropertyName = "properties.sqlFilter")]
        public SqlFilter SqlFilter { get; set; }

        /// <summary>
        /// Gets or sets properties of correlationFilter
        /// </summary>
        [JsonProperty(PropertyName = "properties.correlationFilter")]
        public CorrelationFilter CorrelationFilter { get; set; }

    }
}
