// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceBus.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Description of queue Resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class SBQueue : Resource
    {
        /// <summary>
        /// Initializes a new instance of the SBQueue class.
        /// </summary>
        public SBQueue()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SBQueue class.
        /// </summary>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="countDetails">Message Count Details.</param>
        /// <param name="createdAt">The exact time the message was
        /// created.</param>
        /// <param name="updatedAt">The exact time the message was
        /// updated.</param>
        /// <param name="accessedAt">Last time a message was sent, or the last
        /// time there was a receive request to this queue.</param>
        /// <param name="sizeInBytes">The size of the queue, in bytes.</param>
        /// <param name="messageCount">The number of messages in the
        /// queue.</param>
        /// <param name="lockDuration">ISO 8601 timespan duration of a
        /// peek-lock; that is, the amount of time that the message is locked
        /// for other receivers. The maximum value for LockDuration is 5
        /// minutes; the default value is 1 minute.</param>
        /// <param name="maxSizeInMegabytes">The maximum size of the queue in
        /// megabytes, which is the size of memory allocated for the queue.
        /// Default is 1024.</param>
        /// <param name="requiresDuplicateDetection">A value indicating if this
        /// queue requires duplicate detection.</param>
        /// <param name="requiresSession">A value that indicates whether the
        /// queue supports the concept of sessions.</param>
        /// <param name="defaultMessageTimeToLive">ISO 8601 default message
        /// timespan to live value. This is the duration after which the
        /// message expires, starting from when the message is sent to Service
        /// Bus. This is the default value used when TimeToLive is not set on a
        /// message itself.</param>
        /// <param name="deadLetteringOnMessageExpiration">A value that
        /// indicates whether this queue has dead letter support when a message
        /// expires.</param>
        /// <param name="duplicateDetectionHistoryTimeWindow">ISO 8601 timeSpan
        /// structure that defines the duration of the duplicate detection
        /// history. The default value is 10 minutes.</param>
        /// <param name="maxDeliveryCount">The maximum delivery count. A
        /// message is automatically deadlettered after this number of
        /// deliveries. default value is 10.</param>
        /// <param name="status">Enumerates the possible values for the status
        /// of a messaging entity. Possible values include: 'Active',
        /// 'Disabled', 'Restoring', 'SendDisabled', 'ReceiveDisabled',
        /// 'Creating', 'Deleting', 'Renaming', 'Unknown'</param>
        /// <param name="enableBatchedOperations">Value that indicates whether
        /// server-side batched operations are enabled.</param>
        /// <param name="autoDeleteOnIdle">ISO 8061 timeSpan idle interval
        /// after which the queue is automatically deleted. The minimum
        /// duration is 5 minutes.</param>
        /// <param name="enablePartitioning">A value that indicates whether the
        /// queue is to be partitioned across multiple message brokers.</param>
        /// <param name="enableExpress">A value that indicates whether Express
        /// Entities are enabled. An express queue holds a message in memory
        /// temporarily before writing it to persistent storage.</param>
        /// <param name="forwardTo">Queue/Topic name to forward the
        /// messages</param>
        /// <param name="forwardDeadLetteredMessagesTo">Queue/Topic name to
        /// forward the Dead Letter message</param>
        public SBQueue(string id = default(string), string name = default(string), string type = default(string), MessageCountDetails countDetails = default(MessageCountDetails), System.DateTime? createdAt = default(System.DateTime?), System.DateTime? updatedAt = default(System.DateTime?), System.DateTime? accessedAt = default(System.DateTime?), long? sizeInBytes = default(long?), long? messageCount = default(long?), System.TimeSpan? lockDuration = default(System.TimeSpan?), int? maxSizeInMegabytes = default(int?), bool? requiresDuplicateDetection = default(bool?), bool? requiresSession = default(bool?), System.TimeSpan? defaultMessageTimeToLive = default(System.TimeSpan?), bool? deadLetteringOnMessageExpiration = default(bool?), System.TimeSpan? duplicateDetectionHistoryTimeWindow = default(System.TimeSpan?), int? maxDeliveryCount = default(int?), EntityStatus? status = default(EntityStatus?), bool? enableBatchedOperations = default(bool?), System.TimeSpan? autoDeleteOnIdle = default(System.TimeSpan?), bool? enablePartitioning = default(bool?), bool? enableExpress = default(bool?), string forwardTo = default(string), string forwardDeadLetteredMessagesTo = default(string))
            : base(id, name, type)
        {
            CountDetails = countDetails;
            CreatedAt = createdAt;
            UpdatedAt = updatedAt;
            AccessedAt = accessedAt;
            SizeInBytes = sizeInBytes;
            MessageCount = messageCount;
            LockDuration = lockDuration;
            MaxSizeInMegabytes = maxSizeInMegabytes;
            RequiresDuplicateDetection = requiresDuplicateDetection;
            RequiresSession = requiresSession;
            DefaultMessageTimeToLive = defaultMessageTimeToLive;
            DeadLetteringOnMessageExpiration = deadLetteringOnMessageExpiration;
            DuplicateDetectionHistoryTimeWindow = duplicateDetectionHistoryTimeWindow;
            MaxDeliveryCount = maxDeliveryCount;
            Status = status;
            EnableBatchedOperations = enableBatchedOperations;
            AutoDeleteOnIdle = autoDeleteOnIdle;
            EnablePartitioning = enablePartitioning;
            EnableExpress = enableExpress;
            ForwardTo = forwardTo;
            ForwardDeadLetteredMessagesTo = forwardDeadLetteredMessagesTo;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets message Count Details.
        /// </summary>
        [JsonProperty(PropertyName = "properties.countDetails")]
        public MessageCountDetails CountDetails { get; private set; }

        /// <summary>
        /// Gets the exact time the message was created.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdAt")]
        public System.DateTime? CreatedAt { get; private set; }

        /// <summary>
        /// Gets the exact time the message was updated.
        /// </summary>
        [JsonProperty(PropertyName = "properties.updatedAt")]
        public System.DateTime? UpdatedAt { get; private set; }

        /// <summary>
        /// Gets last time a message was sent, or the last time there was a
        /// receive request to this queue.
        /// </summary>
        [JsonProperty(PropertyName = "properties.accessedAt")]
        public System.DateTime? AccessedAt { get; private set; }

        /// <summary>
        /// Gets the size of the queue, in bytes.
        /// </summary>
        [JsonProperty(PropertyName = "properties.sizeInBytes")]
        public long? SizeInBytes { get; private set; }

        /// <summary>
        /// Gets the number of messages in the queue.
        /// </summary>
        [JsonProperty(PropertyName = "properties.messageCount")]
        public long? MessageCount { get; private set; }

        /// <summary>
        /// Gets or sets ISO 8601 timespan duration of a peek-lock; that is,
        /// the amount of time that the message is locked for other receivers.
        /// The maximum value for LockDuration is 5 minutes; the default value
        /// is 1 minute.
        /// </summary>
        [JsonProperty(PropertyName = "properties.lockDuration")]
        public System.TimeSpan? LockDuration { get; set; }

        /// <summary>
        /// Gets or sets the maximum size of the queue in megabytes, which is
        /// the size of memory allocated for the queue. Default is 1024.
        /// </summary>
        [JsonProperty(PropertyName = "properties.maxSizeInMegabytes")]
        public int? MaxSizeInMegabytes { get; set; }

        /// <summary>
        /// Gets or sets a value indicating if this queue requires duplicate
        /// detection.
        /// </summary>
        [JsonProperty(PropertyName = "properties.requiresDuplicateDetection")]
        public bool? RequiresDuplicateDetection { get; set; }

        /// <summary>
        /// Gets or sets a value that indicates whether the queue supports the
        /// concept of sessions.
        /// </summary>
        [JsonProperty(PropertyName = "properties.requiresSession")]
        public bool? RequiresSession { get; set; }

        /// <summary>
        /// Gets or sets ISO 8601 default message timespan to live value. This
        /// is the duration after which the message expires, starting from when
        /// the message is sent to Service Bus. This is the default value used
        /// when TimeToLive is not set on a message itself.
        /// </summary>
        [JsonProperty(PropertyName = "properties.defaultMessageTimeToLive")]
        public System.TimeSpan? DefaultMessageTimeToLive { get; set; }

        /// <summary>
        /// Gets or sets a value that indicates whether this queue has dead
        /// letter support when a message expires.
        /// </summary>
        [JsonProperty(PropertyName = "properties.deadLetteringOnMessageExpiration")]
        public bool? DeadLetteringOnMessageExpiration { get; set; }

        /// <summary>
        /// Gets or sets ISO 8601 timeSpan structure that defines the duration
        /// of the duplicate detection history. The default value is 10
        /// minutes.
        /// </summary>
        [JsonProperty(PropertyName = "properties.duplicateDetectionHistoryTimeWindow")]
        public System.TimeSpan? DuplicateDetectionHistoryTimeWindow { get; set; }

        /// <summary>
        /// Gets or sets the maximum delivery count. A message is automatically
        /// deadlettered after this number of deliveries. default value is 10.
        /// </summary>
        [JsonProperty(PropertyName = "properties.maxDeliveryCount")]
        public int? MaxDeliveryCount { get; set; }

        /// <summary>
        /// Gets or sets enumerates the possible values for the status of a
        /// messaging entity. Possible values include: 'Active', 'Disabled',
        /// 'Restoring', 'SendDisabled', 'ReceiveDisabled', 'Creating',
        /// 'Deleting', 'Renaming', 'Unknown'
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public EntityStatus? Status { get; set; }

        /// <summary>
        /// Gets or sets value that indicates whether server-side batched
        /// operations are enabled.
        /// </summary>
        [JsonProperty(PropertyName = "properties.enableBatchedOperations")]
        public bool? EnableBatchedOperations { get; set; }

        /// <summary>
        /// Gets or sets ISO 8061 timeSpan idle interval after which the queue
        /// is automatically deleted. The minimum duration is 5 minutes.
        /// </summary>
        [JsonProperty(PropertyName = "properties.autoDeleteOnIdle")]
        public System.TimeSpan? AutoDeleteOnIdle { get; set; }

        /// <summary>
        /// Gets or sets a value that indicates whether the queue is to be
        /// partitioned across multiple message brokers.
        /// </summary>
        [JsonProperty(PropertyName = "properties.enablePartitioning")]
        public bool? EnablePartitioning { get; set; }

        /// <summary>
        /// Gets or sets a value that indicates whether Express Entities are
        /// enabled. An express queue holds a message in memory temporarily
        /// before writing it to persistent storage.
        /// </summary>
        [JsonProperty(PropertyName = "properties.enableExpress")]
        public bool? EnableExpress { get; set; }

        /// <summary>
        /// Gets or sets queue/Topic name to forward the messages
        /// </summary>
        [JsonProperty(PropertyName = "properties.forwardTo")]
        public string ForwardTo { get; set; }

        /// <summary>
        /// Gets or sets queue/Topic name to forward the Dead Letter message
        /// </summary>
        [JsonProperty(PropertyName = "properties.forwardDeadLetteredMessagesTo")]
        public string ForwardDeadLetteredMessagesTo { get; set; }

    }
}
