// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceBus.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// SKU of the namespace.
    /// </summary>
    public partial class SBSku
    {
        /// <summary>
        /// Initializes a new instance of the SBSku class.
        /// </summary>
        public SBSku()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SBSku class.
        /// </summary>
        /// <param name="name">Name of this SKU. Possible values include:
        /// 'Basic', 'Standard', 'Premium'</param>
        /// <param name="tier">The billing tier of this particular SKU.
        /// Possible values include: 'Basic', 'Standard', 'Premium'</param>
        /// <param name="capacity">The specified messaging units for the tier.
        /// For Premium tier, capacity are 1,2 and 4.</param>
        public SBSku(SkuName name, SkuTier? tier = default(SkuTier?), int? capacity = default(int?))
        {
            Name = name;
            Tier = tier;
            Capacity = capacity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of this SKU. Possible values include: 'Basic',
        /// 'Standard', 'Premium'
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public SkuName Name { get; set; }

        /// <summary>
        /// Gets or sets the billing tier of this particular SKU. Possible
        /// values include: 'Basic', 'Standard', 'Premium'
        /// </summary>
        [JsonProperty(PropertyName = "tier")]
        public SkuTier? Tier { get; set; }

        /// <summary>
        /// Gets or sets the specified messaging units for the tier. For
        /// Premium tier, capacity are 1,2 and 4.
        /// </summary>
        [JsonProperty(PropertyName = "capacity")]
        public int? Capacity { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
