// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceFabric
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ClusterVersionsOperations.
    /// </summary>
    public static partial class ClusterVersionsOperationsExtensions
    {
            /// <summary>
            /// Gets information about a Service Fabric cluster code version available in
            /// the specified location.
            /// </summary>
            /// <remarks>
            /// Gets information about an available Service Fabric cluster code version.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The location for the cluster code versions. This is different from cluster
            /// location.
            /// </param>
            /// <param name='clusterVersion'>
            /// The cluster code version.
            /// </param>
            public static ClusterCodeVersionsListResult Get(this IClusterVersionsOperations operations, string location, string clusterVersion)
            {
                return operations.GetAsync(location, clusterVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets information about a Service Fabric cluster code version available in
            /// the specified location.
            /// </summary>
            /// <remarks>
            /// Gets information about an available Service Fabric cluster code version.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The location for the cluster code versions. This is different from cluster
            /// location.
            /// </param>
            /// <param name='clusterVersion'>
            /// The cluster code version.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ClusterCodeVersionsListResult> GetAsync(this IClusterVersionsOperations operations, string location, string clusterVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(location, clusterVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets information about a Service Fabric cluster code version available for
            /// the specified environment.
            /// </summary>
            /// <remarks>
            /// Gets information about an available Service Fabric cluster code version by
            /// environment.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The location for the cluster code versions. This is different from cluster
            /// location.
            /// </param>
            /// <param name='environment'>
            /// The operating system of the cluster. The default means all. Possible values
            /// include: 'Windows', 'Linux'
            /// </param>
            /// <param name='clusterVersion'>
            /// The cluster code version.
            /// </param>
            public static ClusterCodeVersionsListResult GetByEnvironment(this IClusterVersionsOperations operations, string location, string environment, string clusterVersion)
            {
                return operations.GetByEnvironmentAsync(location, environment, clusterVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets information about a Service Fabric cluster code version available for
            /// the specified environment.
            /// </summary>
            /// <remarks>
            /// Gets information about an available Service Fabric cluster code version by
            /// environment.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The location for the cluster code versions. This is different from cluster
            /// location.
            /// </param>
            /// <param name='environment'>
            /// The operating system of the cluster. The default means all. Possible values
            /// include: 'Windows', 'Linux'
            /// </param>
            /// <param name='clusterVersion'>
            /// The cluster code version.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ClusterCodeVersionsListResult> GetByEnvironmentAsync(this IClusterVersionsOperations operations, string location, string environment, string clusterVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetByEnvironmentWithHttpMessagesAsync(location, environment, clusterVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the list of Service Fabric cluster code versions available for the
            /// specified location.
            /// </summary>
            /// <remarks>
            /// Gets all available code versions for Service Fabric cluster resources by
            /// location.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The location for the cluster code versions. This is different from cluster
            /// location.
            /// </param>
            public static ClusterCodeVersionsListResult List(this IClusterVersionsOperations operations, string location)
            {
                return operations.ListAsync(location).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the list of Service Fabric cluster code versions available for the
            /// specified location.
            /// </summary>
            /// <remarks>
            /// Gets all available code versions for Service Fabric cluster resources by
            /// location.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The location for the cluster code versions. This is different from cluster
            /// location.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ClusterCodeVersionsListResult> ListAsync(this IClusterVersionsOperations operations, string location, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListWithHttpMessagesAsync(location, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the list of Service Fabric cluster code versions available for the
            /// specified environment.
            /// </summary>
            /// <remarks>
            /// Gets all available code versions for Service Fabric cluster resources by
            /// environment.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The location for the cluster code versions. This is different from cluster
            /// location.
            /// </param>
            /// <param name='environment'>
            /// The operating system of the cluster. The default means all. Possible values
            /// include: 'Windows', 'Linux'
            /// </param>
            public static ClusterCodeVersionsListResult ListByEnvironment(this IClusterVersionsOperations operations, string location, string environment)
            {
                return operations.ListByEnvironmentAsync(location, environment).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the list of Service Fabric cluster code versions available for the
            /// specified environment.
            /// </summary>
            /// <remarks>
            /// Gets all available code versions for Service Fabric cluster resources by
            /// environment.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The location for the cluster code versions. This is different from cluster
            /// location.
            /// </param>
            /// <param name='environment'>
            /// The operating system of the cluster. The default means all. Possible values
            /// include: 'Windows', 'Linux'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ClusterCodeVersionsListResult> ListByEnvironmentAsync(this IClusterVersionsOperations operations, string location, string environment, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByEnvironmentWithHttpMessagesAsync(location, environment, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
