// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceFabric.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// An application type version resource for the specified application type
    /// name resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ApplicationTypeVersionResource : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the ApplicationTypeVersionResource
        /// class.
        /// </summary>
        public ApplicationTypeVersionResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ApplicationTypeVersionResource
        /// class.
        /// </summary>
        /// <param name="appPackageUrl">The URL to the application
        /// package</param>
        /// <param name="id">Azure resource identifier.</param>
        /// <param name="name">Azure resource name.</param>
        /// <param name="type">Azure resource type.</param>
        /// <param name="location">It will be deprecated in New API, resource
        /// location depends on the parent resource.</param>
        /// <param name="tags">Azure resource tags.</param>
        /// <param name="etag">Azure resource etag.</param>
        /// <param name="provisioningState">The current deployment or
        /// provisioning state, which only appears in the response</param>
        /// <param name="defaultParameterList">List of application type
        /// parameters that can be overridden when creating or updating the
        /// application.</param>
        public ApplicationTypeVersionResource(string appPackageUrl, string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string etag = default(string), string provisioningState = default(string), IDictionary<string, string> defaultParameterList = default(IDictionary<string, string>))
            : base(id, name, type, location, tags, etag)
        {
            ProvisioningState = provisioningState;
            AppPackageUrl = appPackageUrl;
            DefaultParameterList = defaultParameterList;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the current deployment or provisioning state, which only
        /// appears in the response
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets the URL to the application package
        /// </summary>
        [JsonProperty(PropertyName = "properties.appPackageUrl")]
        public string AppPackageUrl { get; set; }

        /// <summary>
        /// Gets list of application type parameters that can be overridden
        /// when creating or updating the application.
        /// </summary>
        [JsonProperty(PropertyName = "properties.defaultParameterList")]
        public IDictionary<string, string> DefaultParameterList { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (AppPackageUrl == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AppPackageUrl");
            }
        }
    }
}
