// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceFabric.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents the health policy used to evaluate the health of services
    /// belonging to a service type.
    ///
    /// </summary>
    public partial class ArmServiceTypeHealthPolicy
    {
        /// <summary>
        /// Initializes a new instance of the ArmServiceTypeHealthPolicy class.
        /// </summary>
        public ArmServiceTypeHealthPolicy()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ArmServiceTypeHealthPolicy class.
        /// </summary>
        /// <param name="maxPercentUnhealthyServices">The maximum percentage of
        /// services allowed to be unhealthy before your application is
        /// considered in error.
        /// </param>
        /// <param name="maxPercentUnhealthyPartitionsPerService">The maximum
        /// percentage of partitions per service allowed to be unhealthy before
        /// your application is considered in error.
        /// </param>
        /// <param name="maxPercentUnhealthyReplicasPerPartition">The maximum
        /// percentage of replicas per partition allowed to be unhealthy before
        /// your application is considered in error.
        /// </param>
        public ArmServiceTypeHealthPolicy(int? maxPercentUnhealthyServices = default(int?), int? maxPercentUnhealthyPartitionsPerService = default(int?), int? maxPercentUnhealthyReplicasPerPartition = default(int?))
        {
            MaxPercentUnhealthyServices = maxPercentUnhealthyServices;
            MaxPercentUnhealthyPartitionsPerService = maxPercentUnhealthyPartitionsPerService;
            MaxPercentUnhealthyReplicasPerPartition = maxPercentUnhealthyReplicasPerPartition;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the maximum percentage of services allowed to be
        /// unhealthy before your application is considered in error.
        ///
        /// </summary>
        [JsonProperty(PropertyName = "maxPercentUnhealthyServices")]
        public int? MaxPercentUnhealthyServices { get; set; }

        /// <summary>
        /// Gets or sets the maximum percentage of partitions per service
        /// allowed to be unhealthy before your application is considered in
        /// error.
        ///
        /// </summary>
        [JsonProperty(PropertyName = "maxPercentUnhealthyPartitionsPerService")]
        public int? MaxPercentUnhealthyPartitionsPerService { get; set; }

        /// <summary>
        /// Gets or sets the maximum percentage of replicas per partition
        /// allowed to be unhealthy before your application is considered in
        /// error.
        ///
        /// </summary>
        [JsonProperty(PropertyName = "maxPercentUnhealthyReplicasPerPartition")]
        public int? MaxPercentUnhealthyReplicasPerPartition { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (MaxPercentUnhealthyServices > 100)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "MaxPercentUnhealthyServices", 100);
            }
            if (MaxPercentUnhealthyServices < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "MaxPercentUnhealthyServices", 0);
            }
            if (MaxPercentUnhealthyPartitionsPerService > 100)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "MaxPercentUnhealthyPartitionsPerService", 100);
            }
            if (MaxPercentUnhealthyPartitionsPerService < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "MaxPercentUnhealthyPartitionsPerService", 0);
            }
            if (MaxPercentUnhealthyReplicasPerPartition > 100)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "MaxPercentUnhealthyReplicasPerPartition", 100);
            }
            if (MaxPercentUnhealthyReplicasPerPartition < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "MaxPercentUnhealthyReplicasPerPartition", 0);
            }
        }
    }
}
