// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceFabric.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the client certificate details using thumbprint.
    /// </summary>
    public partial class ClientCertificateThumbprint
    {
        /// <summary>
        /// Initializes a new instance of the ClientCertificateThumbprint
        /// class.
        /// </summary>
        public ClientCertificateThumbprint()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ClientCertificateThumbprint
        /// class.
        /// </summary>
        /// <param name="isAdmin">Indicates if the client certificate has admin
        /// access to the cluster. Non admin clients can perform only read only
        /// operations on the cluster.</param>
        /// <param name="certificateThumbprint">The thumbprint of the client
        /// certificate.</param>
        public ClientCertificateThumbprint(bool isAdmin, string certificateThumbprint)
        {
            IsAdmin = isAdmin;
            CertificateThumbprint = certificateThumbprint;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets indicates if the client certificate has admin access
        /// to the cluster. Non admin clients can perform only read only
        /// operations on the cluster.
        /// </summary>
        [JsonProperty(PropertyName = "isAdmin")]
        public bool IsAdmin { get; set; }

        /// <summary>
        /// Gets or sets the thumbprint of the client certificate.
        /// </summary>
        [JsonProperty(PropertyName = "certificateThumbprint")]
        public string CertificateThumbprint { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (CertificateThumbprint == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CertificateThumbprint");
            }
        }
    }
}
