// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceFabric.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The detail of the Service Fabric runtime version result
    /// </summary>
    public partial class ClusterVersionDetails
    {
        /// <summary>
        /// Initializes a new instance of the ClusterVersionDetails class.
        /// </summary>
        public ClusterVersionDetails()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ClusterVersionDetails class.
        /// </summary>
        /// <param name="codeVersion">The Service Fabric runtime version of the
        /// cluster.</param>
        /// <param name="supportExpiryUtc">The date of expiry of support of the
        /// version.</param>
        /// <param name="environment">Indicates if this version is for Windows
        /// or Linux operating system. Possible values include: 'Windows',
        /// 'Linux'</param>
        public ClusterVersionDetails(string codeVersion = default(string), string supportExpiryUtc = default(string), string environment = default(string))
        {
            CodeVersion = codeVersion;
            SupportExpiryUtc = supportExpiryUtc;
            Environment = environment;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Service Fabric runtime version of the cluster.
        /// </summary>
        [JsonProperty(PropertyName = "codeVersion")]
        public string CodeVersion { get; set; }

        /// <summary>
        /// Gets or sets the date of expiry of support of the version.
        /// </summary>
        [JsonProperty(PropertyName = "supportExpiryUtc")]
        public string SupportExpiryUtc { get; set; }

        /// <summary>
        /// Gets or sets indicates if this version is for Windows or Linux
        /// operating system. Possible values include: 'Windows', 'Linux'
        /// </summary>
        [JsonProperty(PropertyName = "environment")]
        public string Environment { get; set; }

    }
}
