// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceFabric.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The storage account information for storing Service Fabric diagnostic
    /// logs.
    /// </summary>
    public partial class DiagnosticsStorageAccountConfig
    {
        /// <summary>
        /// Initializes a new instance of the DiagnosticsStorageAccountConfig
        /// class.
        /// </summary>
        public DiagnosticsStorageAccountConfig()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DiagnosticsStorageAccountConfig
        /// class.
        /// </summary>
        /// <param name="storageAccountName">The Azure storage account
        /// name.</param>
        /// <param name="protectedAccountKeyName">The protected diagnostics
        /// storage key name.</param>
        /// <param name="blobEndpoint">The blob endpoint of the azure storage
        /// account.</param>
        /// <param name="queueEndpoint">The queue endpoint of the azure storage
        /// account.</param>
        /// <param name="tableEndpoint">The table endpoint of the azure storage
        /// account.</param>
        public DiagnosticsStorageAccountConfig(string storageAccountName, string protectedAccountKeyName, string blobEndpoint, string queueEndpoint, string tableEndpoint)
        {
            StorageAccountName = storageAccountName;
            ProtectedAccountKeyName = protectedAccountKeyName;
            BlobEndpoint = blobEndpoint;
            QueueEndpoint = queueEndpoint;
            TableEndpoint = tableEndpoint;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Azure storage account name.
        /// </summary>
        [JsonProperty(PropertyName = "storageAccountName")]
        public string StorageAccountName { get; set; }

        /// <summary>
        /// Gets or sets the protected diagnostics storage key name.
        /// </summary>
        [JsonProperty(PropertyName = "protectedAccountKeyName")]
        public string ProtectedAccountKeyName { get; set; }

        /// <summary>
        /// Gets or sets the blob endpoint of the azure storage account.
        /// </summary>
        [JsonProperty(PropertyName = "blobEndpoint")]
        public string BlobEndpoint { get; set; }

        /// <summary>
        /// Gets or sets the queue endpoint of the azure storage account.
        /// </summary>
        [JsonProperty(PropertyName = "queueEndpoint")]
        public string QueueEndpoint { get; set; }

        /// <summary>
        /// Gets or sets the table endpoint of the azure storage account.
        /// </summary>
        [JsonProperty(PropertyName = "tableEndpoint")]
        public string TableEndpoint { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (StorageAccountName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "StorageAccountName");
            }
            if (ProtectedAccountKeyName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ProtectedAccountKeyName");
            }
            if (BlobEndpoint == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "BlobEndpoint");
            }
            if (QueueEndpoint == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "QueueEndpoint");
            }
            if (TableEndpoint == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TableEndpoint");
            }
        }
    }
}
