// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceFabric.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the server certificate details using common name.
    /// </summary>
    public partial class ServerCertificateCommonName
    {
        /// <summary>
        /// Initializes a new instance of the ServerCertificateCommonName
        /// class.
        /// </summary>
        public ServerCertificateCommonName()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServerCertificateCommonName
        /// class.
        /// </summary>
        /// <param name="certificateCommonName">The common name of the server
        /// certificate.</param>
        /// <param name="certificateIssuerThumbprint">The issuer thumbprint of
        /// the server certificate.</param>
        public ServerCertificateCommonName(string certificateCommonName, string certificateIssuerThumbprint)
        {
            CertificateCommonName = certificateCommonName;
            CertificateIssuerThumbprint = certificateIssuerThumbprint;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the common name of the server certificate.
        /// </summary>
        [JsonProperty(PropertyName = "certificateCommonName")]
        public string CertificateCommonName { get; set; }

        /// <summary>
        /// Gets or sets the issuer thumbprint of the server certificate.
        /// </summary>
        [JsonProperty(PropertyName = "certificateIssuerThumbprint")]
        public string CertificateIssuerThumbprint { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (CertificateCommonName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CertificateCommonName");
            }
            if (CertificateIssuerThumbprint == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CertificateIssuerThumbprint");
            }
        }
    }
}
