// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceFabric.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes a list of server certificates referenced by common name that
    /// are used to secure the cluster.
    /// </summary>
    public partial class ServerCertificateCommonNames
    {
        /// <summary>
        /// Initializes a new instance of the ServerCertificateCommonNames
        /// class.
        /// </summary>
        public ServerCertificateCommonNames()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServerCertificateCommonNames
        /// class.
        /// </summary>
        /// <param name="commonNames">The list of server certificates
        /// referenced by common name that are used to secure the
        /// cluster.</param>
        /// <param name="x509StoreName">The local certificate store location.
        /// Possible values include: 'AddressBook', 'AuthRoot',
        /// 'CertificateAuthority', 'Disallowed', 'My', 'Root',
        /// 'TrustedPeople', 'TrustedPublisher'</param>
        public ServerCertificateCommonNames(IList<ServerCertificateCommonName> commonNames = default(IList<ServerCertificateCommonName>), string x509StoreName = default(string))
        {
            CommonNames = commonNames;
            X509StoreName = x509StoreName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the list of server certificates referenced by common
        /// name that are used to secure the cluster.
        /// </summary>
        [JsonProperty(PropertyName = "commonNames")]
        public IList<ServerCertificateCommonName> CommonNames { get; set; }

        /// <summary>
        /// Gets or sets the local certificate store location. Possible values
        /// include: 'AddressBook', 'AuthRoot', 'CertificateAuthority',
        /// 'Disallowed', 'My', 'Root', 'TrustedPeople', 'TrustedPublisher'
        /// </summary>
        [JsonProperty(PropertyName = "x509StoreName")]
        public string X509StoreName { get; set; }

    }
}
