// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.ServiceFabric.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The service resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ServiceResource : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the ServiceResource class.
        /// </summary>
        public ServiceResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServiceResource class.
        /// </summary>
        /// <param name="id">Azure resource identifier.</param>
        /// <param name="name">Azure resource name.</param>
        /// <param name="type">Azure resource type.</param>
        /// <param name="location">It will be deprecated in New API, resource
        /// location depends on the parent resource.</param>
        /// <param name="tags">Azure resource tags.</param>
        /// <param name="etag">Azure resource etag.</param>
        /// <param name="placementConstraints">The placement constraints as a
        /// string. Placement constraints are boolean expressions on node
        /// properties and allow for restricting a service to particular nodes
        /// based on the service requirements. For example, to place a service
        /// on nodes where NodeType is blue specify the following: "NodeColor
        /// == blue)".</param>
        /// <param name="correlationScheme">A list that describes the
        /// correlation of the service with other services.</param>
        /// <param name="serviceLoadMetrics">The service load metrics is given
        /// as an array of ServiceLoadMetricDescription objects.</param>
        /// <param name="servicePlacementPolicies">A list that describes the
        /// correlation of the service with other services.</param>
        /// <param name="defaultMoveCost">Specifies the move cost for the
        /// service. Possible values include: 'Zero', 'Low', 'Medium',
        /// 'High'</param>
        /// <param name="provisioningState">The current deployment or
        /// provisioning state, which only appears in the response</param>
        /// <param name="serviceTypeName">The name of the service type</param>
        /// <param name="partitionDescription">Describes how the service is
        /// partitioned.</param>
        /// <param name="servicePackageActivationMode">The activation Mode of
        /// the service package. Possible values include: 'SharedProcess',
        /// 'ExclusiveProcess'</param>
        public ServiceResource(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string etag = default(string), string placementConstraints = default(string), IList<ServiceCorrelationDescription> correlationScheme = default(IList<ServiceCorrelationDescription>), IList<ServiceLoadMetricDescription> serviceLoadMetrics = default(IList<ServiceLoadMetricDescription>), IList<ServicePlacementPolicyDescription> servicePlacementPolicies = default(IList<ServicePlacementPolicyDescription>), string defaultMoveCost = default(string), string provisioningState = default(string), string serviceTypeName = default(string), PartitionSchemeDescription partitionDescription = default(PartitionSchemeDescription), string servicePackageActivationMode = default(string))
            : base(id, name, type, location, tags, etag)
        {
            PlacementConstraints = placementConstraints;
            CorrelationScheme = correlationScheme;
            ServiceLoadMetrics = serviceLoadMetrics;
            ServicePlacementPolicies = servicePlacementPolicies;
            DefaultMoveCost = defaultMoveCost;
            ProvisioningState = provisioningState;
            ServiceTypeName = serviceTypeName;
            PartitionDescription = partitionDescription;
            ServicePackageActivationMode = servicePackageActivationMode;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the placement constraints as a string. Placement
        /// constraints are boolean expressions on node properties and allow
        /// for restricting a service to particular nodes based on the service
        /// requirements. For example, to place a service on nodes where
        /// NodeType is blue specify the following: "NodeColor == blue)".
        /// </summary>
        [JsonProperty(PropertyName = "properties.placementConstraints")]
        public string PlacementConstraints { get; set; }

        /// <summary>
        /// Gets or sets a list that describes the correlation of the service
        /// with other services.
        /// </summary>
        [JsonProperty(PropertyName = "properties.correlationScheme")]
        public IList<ServiceCorrelationDescription> CorrelationScheme { get; set; }

        /// <summary>
        /// Gets or sets the service load metrics is given as an array of
        /// ServiceLoadMetricDescription objects.
        /// </summary>
        [JsonProperty(PropertyName = "properties.serviceLoadMetrics")]
        public IList<ServiceLoadMetricDescription> ServiceLoadMetrics { get; set; }

        /// <summary>
        /// Gets or sets a list that describes the correlation of the service
        /// with other services.
        /// </summary>
        [JsonProperty(PropertyName = "properties.servicePlacementPolicies")]
        public IList<ServicePlacementPolicyDescription> ServicePlacementPolicies { get; set; }

        /// <summary>
        /// Gets or sets specifies the move cost for the service. Possible
        /// values include: 'Zero', 'Low', 'Medium', 'High'
        /// </summary>
        [JsonProperty(PropertyName = "properties.defaultMoveCost")]
        public string DefaultMoveCost { get; set; }

        /// <summary>
        /// Gets the current deployment or provisioning state, which only
        /// appears in the response
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets the name of the service type
        /// </summary>
        [JsonProperty(PropertyName = "properties.serviceTypeName")]
        public string ServiceTypeName { get; set; }

        /// <summary>
        /// Gets or sets describes how the service is partitioned.
        /// </summary>
        [JsonProperty(PropertyName = "properties.partitionDescription")]
        public PartitionSchemeDescription PartitionDescription { get; set; }

        /// <summary>
        /// Gets or sets the activation Mode of the service package. Possible
        /// values include: 'SharedProcess', 'ExclusiveProcess'
        /// </summary>
        [JsonProperty(PropertyName = "properties.servicePackageActivationMode")]
        public string ServicePackageActivationMode { get; set; }

    }
}
