// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.SignalR.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Parameters for SignalR service update operation
    /// </summary>
    public partial class SignalRUpdateParameters
    {
        /// <summary>
        /// Initializes a new instance of the SignalRUpdateParameters class.
        /// </summary>
        public SignalRUpdateParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SignalRUpdateParameters class.
        /// </summary>
        /// <param name="tags">A list of key value pairs that describe the
        /// resource.</param>
        /// <param name="sku">The billing information of the resource.(e.g.
        /// basic vs. standard)</param>
        /// <param name="properties">Settings used to provision or configure
        /// the resource</param>
        public SignalRUpdateParameters(IDictionary<string, string> tags = default(IDictionary<string, string>), ResourceSku sku = default(ResourceSku), SignalRCreateOrUpdateProperties properties = default(SignalRCreateOrUpdateProperties))
        {
            Tags = tags;
            Sku = sku;
            Properties = properties;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a list of key value pairs that describe the resource.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets or sets the billing information of the resource.(e.g. basic
        /// vs. standard)
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public ResourceSku Sku { get; set; }

        /// <summary>
        /// Gets or sets settings used to provision or configure the resource
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public SignalRCreateOrUpdateProperties Properties { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Sku != null)
            {
                Sku.Validate();
            }
        }
    }
}
