// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A long term retention policy.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class BackupLongTermRetentionPolicy : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the BackupLongTermRetentionPolicy
        /// class.
        /// </summary>
        public BackupLongTermRetentionPolicy()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BackupLongTermRetentionPolicy
        /// class.
        /// </summary>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="weeklyRetention">The weekly retention policy for an
        /// LTR backup in an ISO 8601 format.</param>
        /// <param name="monthlyRetention">The monthly retention policy for an
        /// LTR backup in an ISO 8601 format.</param>
        /// <param name="yearlyRetention">The yearly retention policy for an
        /// LTR backup in an ISO 8601 format.</param>
        /// <param name="weekOfYear">The week of year to take the yearly backup
        /// in an ISO 8601 format.</param>
        public BackupLongTermRetentionPolicy(string id = default(string), string name = default(string), string type = default(string), string weeklyRetention = default(string), string monthlyRetention = default(string), string yearlyRetention = default(string), int? weekOfYear = default(int?))
            : base(id, name, type)
        {
            WeeklyRetention = weeklyRetention;
            MonthlyRetention = monthlyRetention;
            YearlyRetention = yearlyRetention;
            WeekOfYear = weekOfYear;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the weekly retention policy for an LTR backup in an
        /// ISO 8601 format.
        /// </summary>
        [JsonProperty(PropertyName = "properties.weeklyRetention")]
        public string WeeklyRetention { get; set; }

        /// <summary>
        /// Gets or sets the monthly retention policy for an LTR backup in an
        /// ISO 8601 format.
        /// </summary>
        [JsonProperty(PropertyName = "properties.monthlyRetention")]
        public string MonthlyRetention { get; set; }

        /// <summary>
        /// Gets or sets the yearly retention policy for an LTR backup in an
        /// ISO 8601 format.
        /// </summary>
        [JsonProperty(PropertyName = "properties.yearlyRetention")]
        public string YearlyRetention { get; set; }

        /// <summary>
        /// Gets or sets the week of year to take the yearly backup in an ISO
        /// 8601 format.
        /// </summary>
        [JsonProperty(PropertyName = "properties.weekOfYear")]
        public int? WeekOfYear { get; set; }

    }
}
