// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The max per-database performance level capability.
    /// </summary>
    public partial class ElasticPoolPerDatabaseMaxPerformanceLevelCapability
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ElasticPoolPerDatabaseMaxPerformanceLevelCapability class.
        /// </summary>
        public ElasticPoolPerDatabaseMaxPerformanceLevelCapability()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ElasticPoolPerDatabaseMaxPerformanceLevelCapability class.
        /// </summary>
        /// <param name="limit">The maximum performance level per
        /// database.</param>
        /// <param name="unit">Unit type used to measure performance level.
        /// Possible values include: 'DTU', 'VCores'</param>
        /// <param name="supportedPerDatabaseMinPerformanceLevels">The list of
        /// supported min database performance levels.</param>
        /// <param name="status">The status of the capability. Possible values
        /// include: 'Visible', 'Available', 'Default', 'Disabled'</param>
        /// <param name="reason">The reason for the capability not being
        /// available.</param>
        public ElasticPoolPerDatabaseMaxPerformanceLevelCapability(double? limit = default(double?), string unit = default(string), IList<ElasticPoolPerDatabaseMinPerformanceLevelCapability> supportedPerDatabaseMinPerformanceLevels = default(IList<ElasticPoolPerDatabaseMinPerformanceLevelCapability>), CapabilityStatus? status = default(CapabilityStatus?), string reason = default(string))
        {
            Limit = limit;
            Unit = unit;
            SupportedPerDatabaseMinPerformanceLevels = supportedPerDatabaseMinPerformanceLevels;
            Status = status;
            Reason = reason;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the maximum performance level per database.
        /// </summary>
        [JsonProperty(PropertyName = "limit")]
        public double? Limit { get; private set; }

        /// <summary>
        /// Gets unit type used to measure performance level. Possible values
        /// include: 'DTU', 'VCores'
        /// </summary>
        [JsonProperty(PropertyName = "unit")]
        public string Unit { get; private set; }

        /// <summary>
        /// Gets the list of supported min database performance levels.
        /// </summary>
        [JsonProperty(PropertyName = "supportedPerDatabaseMinPerformanceLevels")]
        public IList<ElasticPoolPerDatabaseMinPerformanceLevelCapability> SupportedPerDatabaseMinPerformanceLevels { get; private set; }

        /// <summary>
        /// Gets the status of the capability. Possible values include:
        /// 'Visible', 'Available', 'Default', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public CapabilityStatus? Status { get; private set; }

        /// <summary>
        /// Gets or sets the reason for the capability not being available.
        /// </summary>
        [JsonProperty(PropertyName = "reason")]
        public string Reason { get; set; }

    }
}
