// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The Elastic Pool performance level capability.
    /// </summary>
    public partial class ElasticPoolPerformanceLevelCapability
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ElasticPoolPerformanceLevelCapability class.
        /// </summary>
        public ElasticPoolPerformanceLevelCapability()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ElasticPoolPerformanceLevelCapability class.
        /// </summary>
        /// <param name="performanceLevel">The performance level for the
        /// pool.</param>
        /// <param name="sku">The sku.</param>
        /// <param name="supportedLicenseTypes">List of supported license
        /// types.</param>
        /// <param name="maxDatabaseCount">The maximum number of databases
        /// supported.</param>
        /// <param name="includedMaxSize">The included (free) max size for this
        /// performance level.</param>
        /// <param name="supportedMaxSizes">The list of supported max
        /// sizes.</param>
        /// <param name="supportedPerDatabaseMaxSizes">The list of supported
        /// per database max sizes.</param>
        /// <param name="supportedPerDatabaseMaxPerformanceLevels">The list of
        /// supported per database max performance levels.</param>
        /// <param name="status">The status of the capability. Possible values
        /// include: 'Visible', 'Available', 'Default', 'Disabled'</param>
        /// <param name="reason">The reason for the capability not being
        /// available.</param>
        public ElasticPoolPerformanceLevelCapability(PerformanceLevelCapability performanceLevel = default(PerformanceLevelCapability), Sku sku = default(Sku), IList<LicenseTypeCapability> supportedLicenseTypes = default(IList<LicenseTypeCapability>), int? maxDatabaseCount = default(int?), MaxSizeCapability includedMaxSize = default(MaxSizeCapability), IList<MaxSizeRangeCapability> supportedMaxSizes = default(IList<MaxSizeRangeCapability>), IList<MaxSizeRangeCapability> supportedPerDatabaseMaxSizes = default(IList<MaxSizeRangeCapability>), IList<ElasticPoolPerDatabaseMaxPerformanceLevelCapability> supportedPerDatabaseMaxPerformanceLevels = default(IList<ElasticPoolPerDatabaseMaxPerformanceLevelCapability>), CapabilityStatus? status = default(CapabilityStatus?), string reason = default(string))
        {
            PerformanceLevel = performanceLevel;
            Sku = sku;
            SupportedLicenseTypes = supportedLicenseTypes;
            MaxDatabaseCount = maxDatabaseCount;
            IncludedMaxSize = includedMaxSize;
            SupportedMaxSizes = supportedMaxSizes;
            SupportedPerDatabaseMaxSizes = supportedPerDatabaseMaxSizes;
            SupportedPerDatabaseMaxPerformanceLevels = supportedPerDatabaseMaxPerformanceLevels;
            Status = status;
            Reason = reason;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the performance level for the pool.
        /// </summary>
        [JsonProperty(PropertyName = "performanceLevel")]
        public PerformanceLevelCapability PerformanceLevel { get; private set; }

        /// <summary>
        /// Gets the sku.
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public Sku Sku { get; private set; }

        /// <summary>
        /// Gets list of supported license types.
        /// </summary>
        [JsonProperty(PropertyName = "supportedLicenseTypes")]
        public IList<LicenseTypeCapability> SupportedLicenseTypes { get; private set; }

        /// <summary>
        /// Gets the maximum number of databases supported.
        /// </summary>
        [JsonProperty(PropertyName = "maxDatabaseCount")]
        public int? MaxDatabaseCount { get; private set; }

        /// <summary>
        /// Gets the included (free) max size for this performance level.
        /// </summary>
        [JsonProperty(PropertyName = "includedMaxSize")]
        public MaxSizeCapability IncludedMaxSize { get; private set; }

        /// <summary>
        /// Gets the list of supported max sizes.
        /// </summary>
        [JsonProperty(PropertyName = "supportedMaxSizes")]
        public IList<MaxSizeRangeCapability> SupportedMaxSizes { get; private set; }

        /// <summary>
        /// Gets the list of supported per database max sizes.
        /// </summary>
        [JsonProperty(PropertyName = "supportedPerDatabaseMaxSizes")]
        public IList<MaxSizeRangeCapability> SupportedPerDatabaseMaxSizes { get; private set; }

        /// <summary>
        /// Gets the list of supported per database max performance levels.
        /// </summary>
        [JsonProperty(PropertyName = "supportedPerDatabaseMaxPerformanceLevels")]
        public IList<ElasticPoolPerDatabaseMaxPerformanceLevelCapability> SupportedPerDatabaseMaxPerformanceLevels { get; private set; }

        /// <summary>
        /// Gets the status of the capability. Possible values include:
        /// 'Visible', 'Available', 'Default', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public CapabilityStatus? Status { get; private set; }

        /// <summary>
        /// Gets or sets the reason for the capability not being available.
        /// </summary>
        [JsonProperty(PropertyName = "reason")]
        public string Reason { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Sku != null)
            {
                Sku.Validate();
            }
        }
    }
}
