// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The managed server family capability.
    /// </summary>
    public partial class ManagedInstanceFamilyCapability
    {
        /// <summary>
        /// Initializes a new instance of the ManagedInstanceFamilyCapability
        /// class.
        /// </summary>
        public ManagedInstanceFamilyCapability()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ManagedInstanceFamilyCapability
        /// class.
        /// </summary>
        /// <param name="name">Family name.</param>
        /// <param name="sku">SKU name.</param>
        /// <param name="supportedLicenseTypes">List of supported license
        /// types.</param>
        /// <param name="supportedVcoresValues">List of supported virtual cores
        /// values.</param>
        /// <param name="includedMaxSize">Included size.</param>
        /// <param name="supportedStorageSizes">Storage size ranges.</param>
        /// <param name="status">The status of the capability. Possible values
        /// include: 'Visible', 'Available', 'Default', 'Disabled'</param>
        /// <param name="reason">The reason for the capability not being
        /// available.</param>
        public ManagedInstanceFamilyCapability(string name = default(string), string sku = default(string), IList<LicenseTypeCapability> supportedLicenseTypes = default(IList<LicenseTypeCapability>), IList<ManagedInstanceVcoresCapability> supportedVcoresValues = default(IList<ManagedInstanceVcoresCapability>), MaxSizeCapability includedMaxSize = default(MaxSizeCapability), IList<MaxSizeRangeCapability> supportedStorageSizes = default(IList<MaxSizeRangeCapability>), CapabilityStatus? status = default(CapabilityStatus?), string reason = default(string))
        {
            Name = name;
            Sku = sku;
            SupportedLicenseTypes = supportedLicenseTypes;
            SupportedVcoresValues = supportedVcoresValues;
            IncludedMaxSize = includedMaxSize;
            SupportedStorageSizes = supportedStorageSizes;
            Status = status;
            Reason = reason;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets family name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets SKU name.
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public string Sku { get; private set; }

        /// <summary>
        /// Gets list of supported license types.
        /// </summary>
        [JsonProperty(PropertyName = "supportedLicenseTypes")]
        public IList<LicenseTypeCapability> SupportedLicenseTypes { get; private set; }

        /// <summary>
        /// Gets list of supported virtual cores values.
        /// </summary>
        [JsonProperty(PropertyName = "supportedVcoresValues")]
        public IList<ManagedInstanceVcoresCapability> SupportedVcoresValues { get; private set; }

        /// <summary>
        /// Gets included size.
        /// </summary>
        [JsonProperty(PropertyName = "includedMaxSize")]
        public MaxSizeCapability IncludedMaxSize { get; private set; }

        /// <summary>
        /// Gets storage size ranges.
        /// </summary>
        [JsonProperty(PropertyName = "supportedStorageSizes")]
        public IList<MaxSizeRangeCapability> SupportedStorageSizes { get; private set; }

        /// <summary>
        /// Gets the status of the capability. Possible values include:
        /// 'Visible', 'Available', 'Default', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public CapabilityStatus? Status { get; private set; }

        /// <summary>
        /// Gets or sets the reason for the capability not being available.
        /// </summary>
        [JsonProperty(PropertyName = "reason")]
        public string Reason { get; set; }

    }
}
