// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.SqlVirtualMachine
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// The SQL virtual machine management API provides a RESTful set of web
    /// APIs that interact with Azure Compute, Network &amp; Storage services
    /// to manage your SQL Server virtual machine. The API enables users to
    /// create, delete and retrieve a SQL virtual machine, SQL virtual machine
    /// group or availability group listener.
    /// </summary>
    public partial interface ISqlVirtualMachineManagementClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// Subscription ID that identifies an Azure subscription.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// API version to use for the request.
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IAvailabilityGroupListenersOperations.
        /// </summary>
        IAvailabilityGroupListenersOperations AvailabilityGroupListeners { get; }

        /// <summary>
        /// Gets the IOperations.
        /// </summary>
        IOperations Operations { get; }

        /// <summary>
        /// Gets the ISqlVirtualMachineGroupsOperations.
        /// </summary>
        ISqlVirtualMachineGroupsOperations SqlVirtualMachineGroups { get; }

        /// <summary>
        /// Gets the ISqlVirtualMachinesOperations.
        /// </summary>
        ISqlVirtualMachinesOperations SqlVirtualMachines { get; }

    }
}
