// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.SqlVirtualMachine.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Configure your SQL virtual machine to be able to connect to the Azure
    /// Key Vault service.
    /// </summary>
    public partial class KeyVaultCredentialSettings
    {
        /// <summary>
        /// Initializes a new instance of the KeyVaultCredentialSettings class.
        /// </summary>
        public KeyVaultCredentialSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the KeyVaultCredentialSettings class.
        /// </summary>
        /// <param name="enable">Enable or disable key vault credential
        /// setting.</param>
        /// <param name="credentialName">Credential name.</param>
        /// <param name="azureKeyVaultUrl">Azure Key Vault url.</param>
        /// <param name="servicePrincipalName">Service principal name to access
        /// key vault.</param>
        /// <param name="servicePrincipalSecret">Service principal name secret
        /// to access key vault.</param>
        public KeyVaultCredentialSettings(bool? enable = default(bool?), string credentialName = default(string), string azureKeyVaultUrl = default(string), string servicePrincipalName = default(string), string servicePrincipalSecret = default(string))
        {
            Enable = enable;
            CredentialName = credentialName;
            AzureKeyVaultUrl = azureKeyVaultUrl;
            ServicePrincipalName = servicePrincipalName;
            ServicePrincipalSecret = servicePrincipalSecret;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets enable or disable key vault credential setting.
        /// </summary>
        [JsonProperty(PropertyName = "enable")]
        public bool? Enable { get; set; }

        /// <summary>
        /// Gets or sets credential name.
        /// </summary>
        [JsonProperty(PropertyName = "credentialName")]
        public string CredentialName { get; set; }

        /// <summary>
        /// Gets or sets azure Key Vault url.
        /// </summary>
        [JsonProperty(PropertyName = "azureKeyVaultUrl")]
        public string AzureKeyVaultUrl { get; set; }

        /// <summary>
        /// Gets or sets service principal name to access key vault.
        /// </summary>
        [JsonProperty(PropertyName = "servicePrincipalName")]
        public string ServicePrincipalName { get; set; }

        /// <summary>
        /// Gets or sets service principal name secret to access key vault.
        /// </summary>
        [JsonProperty(PropertyName = "servicePrincipalSecret")]
        public string ServicePrincipalSecret { get; set; }

    }
}
