// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.SqlVirtualMachine.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A SQL virtual machine group.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class SqlVirtualMachineGroup : TrackedResource
    {
        /// <summary>
        /// Initializes a new instance of the SqlVirtualMachineGroup class.
        /// </summary>
        public SqlVirtualMachineGroup()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SqlVirtualMachineGroup class.
        /// </summary>
        /// <param name="location">Resource location.</param>
        /// <param name="id">Resource ID.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="tags">Resource tags.</param>
        /// <param name="provisioningState">Provisioning state to track the
        /// async operation status.</param>
        /// <param name="sqlImageOffer">SQL image offer. Examples may include
        /// SQL2016-WS2016, SQL2017-WS2016.</param>
        /// <param name="sqlImageSku">SQL image sku. Possible values include:
        /// 'Developer', 'Enterprise'</param>
        /// <param name="scaleType">Scale type. Possible values include:
        /// 'HA'</param>
        /// <param name="clusterManagerType">Type of cluster manager: Windows
        /// Server Failover Cluster (WSFC), implied by the scale type of the
        /// group and the OS type. Possible values include: 'WSFC'</param>
        /// <param name="clusterConfiguration">Cluster type. Possible values
        /// include: 'Domainful'</param>
        /// <param name="wsfcDomainProfile">Cluster Active Directory domain
        /// profile.</param>
        public SqlVirtualMachineGroup(string location, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string provisioningState = default(string), string sqlImageOffer = default(string), string sqlImageSku = default(string), string scaleType = default(string), string clusterManagerType = default(string), string clusterConfiguration = default(string), WsfcDomainProfile wsfcDomainProfile = default(WsfcDomainProfile))
            : base(location, id, name, type, tags)
        {
            ProvisioningState = provisioningState;
            SqlImageOffer = sqlImageOffer;
            SqlImageSku = sqlImageSku;
            ScaleType = scaleType;
            ClusterManagerType = clusterManagerType;
            ClusterConfiguration = clusterConfiguration;
            WsfcDomainProfile = wsfcDomainProfile;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets provisioning state to track the async operation status.
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets SQL image offer. Examples may include SQL2016-WS2016,
        /// SQL2017-WS2016.
        /// </summary>
        [JsonProperty(PropertyName = "properties.sqlImageOffer")]
        public string SqlImageOffer { get; set; }

        /// <summary>
        /// Gets or sets SQL image sku. Possible values include: 'Developer',
        /// 'Enterprise'
        /// </summary>
        [JsonProperty(PropertyName = "properties.sqlImageSku")]
        public string SqlImageSku { get; set; }

        /// <summary>
        /// Gets scale type. Possible values include: 'HA'
        /// </summary>
        [JsonProperty(PropertyName = "properties.scaleType")]
        public string ScaleType { get; private set; }

        /// <summary>
        /// Gets type of cluster manager: Windows Server Failover Cluster
        /// (WSFC), implied by the scale type of the group and the OS type.
        /// Possible values include: 'WSFC'
        /// </summary>
        [JsonProperty(PropertyName = "properties.clusterManagerType")]
        public string ClusterManagerType { get; private set; }

        /// <summary>
        /// Gets cluster type. Possible values include: 'Domainful'
        /// </summary>
        [JsonProperty(PropertyName = "properties.clusterConfiguration")]
        public string ClusterConfiguration { get; private set; }

        /// <summary>
        /// Gets or sets cluster Active Directory domain profile.
        /// </summary>
        [JsonProperty(PropertyName = "properties.wsfcDomainProfile")]
        public WsfcDomainProfile WsfcDomainProfile { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
