// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.SqlVirtualMachine.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Domain credentials for setting up Windows Server Failover Cluster for
    /// SQL availability group.
    /// </summary>
    public partial class WsfcDomainCredentials
    {
        /// <summary>
        /// Initializes a new instance of the WsfcDomainCredentials class.
        /// </summary>
        public WsfcDomainCredentials()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the WsfcDomainCredentials class.
        /// </summary>
        /// <param name="clusterBootstrapAccountPassword">Cluster bootstrap
        /// account password.</param>
        /// <param name="clusterOperatorAccountPassword">Cluster operator
        /// account password.</param>
        /// <param name="sqlServiceAccountPassword">SQL service account
        /// password.</param>
        public WsfcDomainCredentials(string clusterBootstrapAccountPassword = default(string), string clusterOperatorAccountPassword = default(string), string sqlServiceAccountPassword = default(string))
        {
            ClusterBootstrapAccountPassword = clusterBootstrapAccountPassword;
            ClusterOperatorAccountPassword = clusterOperatorAccountPassword;
            SqlServiceAccountPassword = sqlServiceAccountPassword;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets cluster bootstrap account password.
        /// </summary>
        [JsonProperty(PropertyName = "clusterBootstrapAccountPassword")]
        public string ClusterBootstrapAccountPassword { get; set; }

        /// <summary>
        /// Gets or sets cluster operator account password.
        /// </summary>
        [JsonProperty(PropertyName = "clusterOperatorAccountPassword")]
        public string ClusterOperatorAccountPassword { get; set; }

        /// <summary>
        /// Gets or sets SQL service account password.
        /// </summary>
        [JsonProperty(PropertyName = "sqlServiceAccountPassword")]
        public string SqlServiceAccountPassword { get; set; }

    }
}
