// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.SqlVirtualMachine.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Active Directory account details to operate Windows Server Failover
    /// Cluster.
    /// </summary>
    public partial class WsfcDomainProfile
    {
        /// <summary>
        /// Initializes a new instance of the WsfcDomainProfile class.
        /// </summary>
        public WsfcDomainProfile()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the WsfcDomainProfile class.
        /// </summary>
        /// <param name="domainFqdn">Fully qualified name of the
        /// domain.</param>
        /// <param name="ouPath">Organizational Unit path in which the nodes
        /// and cluster will be present.</param>
        /// <param name="clusterBootstrapAccount">Account name used for
        /// creating cluster (at minimum needs permissions to 'Create Computer
        /// Objects' in domain).</param>
        /// <param name="clusterOperatorAccount">Account name used for
        /// operating cluster i.e. will be part of administrators group on all
        /// the participating virtual machines in the cluster.</param>
        /// <param name="sqlServiceAccount">Account name under which SQL
        /// service will run on all participating SQL virtual machines in the
        /// cluster.</param>
        /// <param name="fileShareWitnessPath">Optional path for fileshare
        /// witness.</param>
        /// <param name="storageAccountUrl">Fully qualified ARM resource id of
        /// the witness storage account.</param>
        /// <param name="storageAccountPrimaryKey">Primary key of the witness
        /// storage account.</param>
        public WsfcDomainProfile(string domainFqdn = default(string), string ouPath = default(string), string clusterBootstrapAccount = default(string), string clusterOperatorAccount = default(string), string sqlServiceAccount = default(string), string fileShareWitnessPath = default(string), string storageAccountUrl = default(string), string storageAccountPrimaryKey = default(string))
        {
            DomainFqdn = domainFqdn;
            OuPath = ouPath;
            ClusterBootstrapAccount = clusterBootstrapAccount;
            ClusterOperatorAccount = clusterOperatorAccount;
            SqlServiceAccount = sqlServiceAccount;
            FileShareWitnessPath = fileShareWitnessPath;
            StorageAccountUrl = storageAccountUrl;
            StorageAccountPrimaryKey = storageAccountPrimaryKey;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets fully qualified name of the domain.
        /// </summary>
        [JsonProperty(PropertyName = "domainFqdn")]
        public string DomainFqdn { get; set; }

        /// <summary>
        /// Gets or sets organizational Unit path in which the nodes and
        /// cluster will be present.
        /// </summary>
        [JsonProperty(PropertyName = "ouPath")]
        public string OuPath { get; set; }

        /// <summary>
        /// Gets or sets account name used for creating cluster (at minimum
        /// needs permissions to 'Create Computer Objects' in domain).
        /// </summary>
        [JsonProperty(PropertyName = "clusterBootstrapAccount")]
        public string ClusterBootstrapAccount { get; set; }

        /// <summary>
        /// Gets or sets account name used for operating cluster i.e. will be
        /// part of administrators group on all the participating virtual
        /// machines in the cluster.
        /// </summary>
        [JsonProperty(PropertyName = "clusterOperatorAccount")]
        public string ClusterOperatorAccount { get; set; }

        /// <summary>
        /// Gets or sets account name under which SQL service will run on all
        /// participating SQL virtual machines in the cluster.
        /// </summary>
        [JsonProperty(PropertyName = "sqlServiceAccount")]
        public string SqlServiceAccount { get; set; }

        /// <summary>
        /// Gets or sets optional path for fileshare witness.
        /// </summary>
        [JsonProperty(PropertyName = "fileShareWitnessPath")]
        public string FileShareWitnessPath { get; set; }

        /// <summary>
        /// Gets or sets fully qualified ARM resource id of the witness storage
        /// account.
        /// </summary>
        [JsonProperty(PropertyName = "storageAccountUrl")]
        public string StorageAccountUrl { get; set; }

        /// <summary>
        /// Gets or sets primary key of the witness storage account.
        /// </summary>
        [JsonProperty(PropertyName = "storageAccountPrimaryKey")]
        public string StorageAccountPrimaryKey { get; set; }

    }
}
