// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Storage.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The URIs that are used to perform a retrieval of a public blob, queue,
    /// table, web or dfs object.
    /// </summary>
    public partial class Endpoints
    {
        /// <summary>
        /// Initializes a new instance of the Endpoints class.
        /// </summary>
        public Endpoints()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Endpoints class.
        /// </summary>
        /// <param name="blob">Gets the blob endpoint.</param>
        /// <param name="queue">Gets the queue endpoint.</param>
        /// <param name="table">Gets the table endpoint.</param>
        /// <param name="file">Gets the file endpoint.</param>
        /// <param name="web">Gets the web endpoint.</param>
        /// <param name="dfs">Gets the dfs endpoint.</param>
        /// <param name="microsoftEndpoints">Gets the microsoft routing storage
        /// endpoints.</param>
        /// <param name="internetEndpoints">Gets the internet routing storage
        /// endpoints</param>
        public Endpoints(string blob = default(string), string queue = default(string), string table = default(string), string file = default(string), string web = default(string), string dfs = default(string), StorageAccountMicrosoftEndpoints microsoftEndpoints = default(StorageAccountMicrosoftEndpoints), StorageAccountInternetEndpoints internetEndpoints = default(StorageAccountInternetEndpoints))
        {
            Blob = blob;
            Queue = queue;
            Table = table;
            File = file;
            Web = web;
            Dfs = dfs;
            MicrosoftEndpoints = microsoftEndpoints;
            InternetEndpoints = internetEndpoints;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the blob endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "blob")]
        public string Blob { get; private set; }

        /// <summary>
        /// Gets the queue endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "queue")]
        public string Queue { get; private set; }

        /// <summary>
        /// Gets the table endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "table")]
        public string Table { get; private set; }

        /// <summary>
        /// Gets the file endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "file")]
        public string File { get; private set; }

        /// <summary>
        /// Gets the web endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "web")]
        public string Web { get; private set; }

        /// <summary>
        /// Gets the dfs endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "dfs")]
        public string Dfs { get; private set; }

        /// <summary>
        /// Gets the microsoft routing storage endpoints.
        /// </summary>
        [JsonProperty(PropertyName = "microsoftEndpoints")]
        public StorageAccountMicrosoftEndpoints MicrosoftEndpoints { get; set; }

        /// <summary>
        /// Gets the internet routing storage endpoints
        /// </summary>
        [JsonProperty(PropertyName = "internetEndpoints")]
        public StorageAccountInternetEndpoints InternetEndpoints { get; set; }

    }
}
