// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Storage.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties of File services in storage account.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class FileServiceProperties : Resource
    {
        /// <summary>
        /// Initializes a new instance of the FileServiceProperties class.
        /// </summary>
        public FileServiceProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the FileServiceProperties class.
        /// </summary>
        /// <param name="id">Fully qualified resource Id for the resource. Ex -
        /// /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="type">The type of the resource. Ex-
        /// Microsoft.Compute/virtualMachines or
        /// Microsoft.Storage/storageAccounts.</param>
        /// <param name="cors">Specifies CORS rules for the File service. You
        /// can include up to five CorsRule elements in the request. If no
        /// CorsRule elements are included in the request body, all CORS rules
        /// will be deleted, and CORS will be disabled for the File
        /// service.</param>
        /// <param name="shareDeleteRetentionPolicy">The file service
        /// properties for share soft delete.</param>
        /// <param name="sku">Sku name and tier.</param>
        public FileServiceProperties(string id = default(string), string name = default(string), string type = default(string), CorsRules cors = default(CorsRules), DeleteRetentionPolicy shareDeleteRetentionPolicy = default(DeleteRetentionPolicy), Sku sku = default(Sku))
            : base(id, name, type)
        {
            Cors = cors;
            ShareDeleteRetentionPolicy = shareDeleteRetentionPolicy;
            Sku = sku;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies CORS rules for the File service. You can
        /// include up to five CorsRule elements in the request. If no CorsRule
        /// elements are included in the request body, all CORS rules will be
        /// deleted, and CORS will be disabled for the File service.
        /// </summary>
        [JsonProperty(PropertyName = "properties.cors")]
        public CorsRules Cors { get; set; }

        /// <summary>
        /// Gets or sets the file service properties for share soft delete.
        /// </summary>
        [JsonProperty(PropertyName = "properties.shareDeleteRetentionPolicy")]
        public DeleteRetentionPolicy ShareDeleteRetentionPolicy { get; set; }

        /// <summary>
        /// Gets sku name and tier.
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public Sku Sku { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ShareDeleteRetentionPolicy != null)
            {
                ShareDeleteRetentionPolicy.Validate();
            }
            if (Sku != null)
            {
                Sku.Validate();
            }
        }
    }
}
