// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Storage.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Routing preference defines the type of network, either microsoft or
    /// internet routing to be used to deliver the user data, the default
    /// option is microsoft routing
    /// </summary>
    public partial class RoutingPreference
    {
        /// <summary>
        /// Initializes a new instance of the RoutingPreference class.
        /// </summary>
        public RoutingPreference()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RoutingPreference class.
        /// </summary>
        /// <param name="routingChoice">Routing Choice defines the kind of
        /// network routing opted by the user. Possible values include:
        /// 'MicrosoftRouting', 'InternetRouting'</param>
        /// <param name="publishMicrosoftEndpoints">A boolean flag which
        /// indicates whether microsoft routing storage endpoints are to be
        /// published</param>
        /// <param name="publishInternetEndpoints">A boolean flag which
        /// indicates whether internet routing storage endpoints are to be
        /// published</param>
        public RoutingPreference(string routingChoice = default(string), bool? publishMicrosoftEndpoints = default(bool?), bool? publishInternetEndpoints = default(bool?))
        {
            RoutingChoice = routingChoice;
            PublishMicrosoftEndpoints = publishMicrosoftEndpoints;
            PublishInternetEndpoints = publishInternetEndpoints;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets routing Choice defines the kind of network routing
        /// opted by the user. Possible values include: 'MicrosoftRouting',
        /// 'InternetRouting'
        /// </summary>
        [JsonProperty(PropertyName = "routingChoice")]
        public string RoutingChoice { get; set; }

        /// <summary>
        /// Gets or sets a boolean flag which indicates whether microsoft
        /// routing storage endpoints are to be published
        /// </summary>
        [JsonProperty(PropertyName = "publishMicrosoftEndpoints")]
        public bool? PublishMicrosoftEndpoints { get; set; }

        /// <summary>
        /// Gets or sets a boolean flag which indicates whether internet
        /// routing storage endpoints are to be published
        /// </summary>
        [JsonProperty(PropertyName = "publishInternetEndpoints")]
        public bool? PublishInternetEndpoints { get; set; }

    }
}
