// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorageCache
{
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for StorageTargets.
    /// </summary>
    public static partial class StorageTargetsExtensions
    {
            /// <summary>
            /// Returns a list of Storage Targets for the specified Cache.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Target resource group.
            /// </param>
            /// <param name='cacheName'>
            /// Name of Cache.
            /// </param>
            public static StorageTargetsResult ListByCache(this IStorageTargets operations, string resourceGroupName, string cacheName)
            {
                return operations.ListByCacheAsync(resourceGroupName, cacheName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns a list of Storage Targets for the specified Cache.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Target resource group.
            /// </param>
            /// <param name='cacheName'>
            /// Name of Cache.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<StorageTargetsResult> ListByCacheAsync(this IStorageTargets operations, string resourceGroupName, string cacheName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListByCacheWithHttpMessagesAsync(resourceGroupName, cacheName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Removes a Storage Target from a Cache. This operation is allowed at any
            /// time, but if the Cache is down or unhealthy, the actual removal of the
            /// Storage Target may be delayed until the Cache is healthy again. Note that
            /// if the Cache has data to flush to the Storage Target, the data will be
            /// flushed before the Storage Target will be deleted.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Target resource group.
            /// </param>
            /// <param name='cacheName'>
            /// Name of Cache.
            /// </param>
            /// <param name='storageTargetName'>
            /// Name of Storage Target.
            /// </param>
            public static object Delete(this IStorageTargets operations, string resourceGroupName, string cacheName, string storageTargetName)
            {
                return operations.DeleteAsync(resourceGroupName, cacheName, storageTargetName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Removes a Storage Target from a Cache. This operation is allowed at any
            /// time, but if the Cache is down or unhealthy, the actual removal of the
            /// Storage Target may be delayed until the Cache is healthy again. Note that
            /// if the Cache has data to flush to the Storage Target, the data will be
            /// flushed before the Storage Target will be deleted.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Target resource group.
            /// </param>
            /// <param name='cacheName'>
            /// Name of Cache.
            /// </param>
            /// <param name='storageTargetName'>
            /// Name of Storage Target.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> DeleteAsync(this IStorageTargets operations, string resourceGroupName, string cacheName, string storageTargetName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteWithHttpMessagesAsync(resourceGroupName, cacheName, storageTargetName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns a Storage Target from a Cache.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Target resource group.
            /// </param>
            /// <param name='cacheName'>
            /// Name of Cache.
            /// </param>
            /// <param name='storageTargetName'>
            /// Name of the Storage Target.
            /// </param>
            public static StorageTarget Get(this IStorageTargets operations, string resourceGroupName, string cacheName, string storageTargetName)
            {
                return operations.GetAsync(resourceGroupName, cacheName, storageTargetName).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns a Storage Target from a Cache.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Target resource group.
            /// </param>
            /// <param name='cacheName'>
            /// Name of Cache.
            /// </param>
            /// <param name='storageTargetName'>
            /// Name of the Storage Target.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<StorageTarget> GetAsync(this IStorageTargets operations, string resourceGroupName, string cacheName, string storageTargetName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, cacheName, storageTargetName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Create or update a Storage Target. This operation is allowed at any time,
            /// but if the Cache is down or unhealthy, the actual creation/modification of
            /// the Storage Target may be delayed until the Cache is healthy again.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Target resource group.
            /// </param>
            /// <param name='cacheName'>
            /// Name of Cache.
            /// </param>
            /// <param name='storageTargetName'>
            /// Name of the Storage Target.
            /// </param>
            /// <param name='storagetarget'>
            /// Object containing the definition of a Storage Target.
            /// </param>
            public static StorageTarget CreateOrUpdate(this IStorageTargets operations, string resourceGroupName, string cacheName, string storageTargetName, StorageTarget storagetarget = default(StorageTarget))
            {
                return operations.CreateOrUpdateAsync(resourceGroupName, cacheName, storageTargetName, storagetarget).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or update a Storage Target. This operation is allowed at any time,
            /// but if the Cache is down or unhealthy, the actual creation/modification of
            /// the Storage Target may be delayed until the Cache is healthy again.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Target resource group.
            /// </param>
            /// <param name='cacheName'>
            /// Name of Cache.
            /// </param>
            /// <param name='storageTargetName'>
            /// Name of the Storage Target.
            /// </param>
            /// <param name='storagetarget'>
            /// Object containing the definition of a Storage Target.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<StorageTarget> CreateOrUpdateAsync(this IStorageTargets operations, string resourceGroupName, string cacheName, string storageTargetName, StorageTarget storagetarget = default(StorageTarget), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, cacheName, storageTargetName, storagetarget, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
