// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorageSync.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Post Restore Request
    /// </summary>
    public partial class PostRestoreRequest
    {
        /// <summary>
        /// Initializes a new instance of the PostRestoreRequest class.
        /// </summary>
        public PostRestoreRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PostRestoreRequest class.
        /// </summary>
        /// <param name="partition">Post Restore partition.</param>
        /// <param name="replicaGroup">Post Restore replica group.</param>
        /// <param name="requestId">Post Restore request id.</param>
        /// <param name="azureFileShareUri">Post Restore Azure file share
        /// uri.</param>
        /// <param name="status">Post Restore Azure status.</param>
        /// <param name="sourceAzureFileShareUri">Post Restore Azure source
        /// azure file share uri.</param>
        /// <param name="failedFileList">Post Restore Azure failed file
        /// list.</param>
        /// <param name="restoreFileSpec">Post Restore restore file spec
        /// array.</param>
        public PostRestoreRequest(string partition = default(string), string replicaGroup = default(string), string requestId = default(string), string azureFileShareUri = default(string), string status = default(string), string sourceAzureFileShareUri = default(string), string failedFileList = default(string), IList<RestoreFileSpec> restoreFileSpec = default(IList<RestoreFileSpec>))
        {
            Partition = partition;
            ReplicaGroup = replicaGroup;
            RequestId = requestId;
            AzureFileShareUri = azureFileShareUri;
            Status = status;
            SourceAzureFileShareUri = sourceAzureFileShareUri;
            FailedFileList = failedFileList;
            RestoreFileSpec = restoreFileSpec;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets post Restore partition.
        /// </summary>
        [JsonProperty(PropertyName = "partition")]
        public string Partition { get; set; }

        /// <summary>
        /// Gets or sets post Restore replica group.
        /// </summary>
        [JsonProperty(PropertyName = "replicaGroup")]
        public string ReplicaGroup { get; set; }

        /// <summary>
        /// Gets or sets post Restore request id.
        /// </summary>
        [JsonProperty(PropertyName = "requestId")]
        public string RequestId { get; set; }

        /// <summary>
        /// Gets or sets post Restore Azure file share uri.
        /// </summary>
        [JsonProperty(PropertyName = "azureFileShareUri")]
        public string AzureFileShareUri { get; set; }

        /// <summary>
        /// Gets or sets post Restore Azure status.
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets post Restore Azure source azure file share uri.
        /// </summary>
        [JsonProperty(PropertyName = "sourceAzureFileShareUri")]
        public string SourceAzureFileShareUri { get; set; }

        /// <summary>
        /// Gets or sets post Restore Azure failed file list.
        /// </summary>
        [JsonProperty(PropertyName = "failedFileList")]
        public string FailedFileList { get; set; }

        /// <summary>
        /// Gets or sets post Restore restore file spec array.
        /// </summary>
        [JsonProperty(PropertyName = "restoreFileSpec")]
        public IList<RestoreFileSpec> RestoreFileSpec { get; set; }

    }
}
