// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorageSync.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Pre Restore request object.
    /// </summary>
    public partial class PreRestoreRequest
    {
        /// <summary>
        /// Initializes a new instance of the PreRestoreRequest class.
        /// </summary>
        public PreRestoreRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PreRestoreRequest class.
        /// </summary>
        /// <param name="partition">Pre Restore partition.</param>
        /// <param name="replicaGroup">Pre Restore replica group.</param>
        /// <param name="requestId">Pre Restore request id.</param>
        /// <param name="azureFileShareUri">Pre Restore Azure file share
        /// uri.</param>
        /// <param name="status">Pre Restore Azure status.</param>
        /// <param name="sourceAzureFileShareUri">Pre Restore Azure source
        /// azure file share uri.</param>
        /// <param name="backupMetadataPropertyBag">Pre Restore backup metadata
        /// property bag.</param>
        /// <param name="restoreFileSpec">Pre Restore restore file spec
        /// array.</param>
        /// <param name="pauseWaitForSyncDrainTimePeriodInSeconds">Pre Restore
        /// pause wait for sync drain time period in seconds.</param>
        public PreRestoreRequest(string partition = default(string), string replicaGroup = default(string), string requestId = default(string), string azureFileShareUri = default(string), string status = default(string), string sourceAzureFileShareUri = default(string), string backupMetadataPropertyBag = default(string), IList<RestoreFileSpec> restoreFileSpec = default(IList<RestoreFileSpec>), int? pauseWaitForSyncDrainTimePeriodInSeconds = default(int?))
        {
            Partition = partition;
            ReplicaGroup = replicaGroup;
            RequestId = requestId;
            AzureFileShareUri = azureFileShareUri;
            Status = status;
            SourceAzureFileShareUri = sourceAzureFileShareUri;
            BackupMetadataPropertyBag = backupMetadataPropertyBag;
            RestoreFileSpec = restoreFileSpec;
            PauseWaitForSyncDrainTimePeriodInSeconds = pauseWaitForSyncDrainTimePeriodInSeconds;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets pre Restore partition.
        /// </summary>
        [JsonProperty(PropertyName = "partition")]
        public string Partition { get; set; }

        /// <summary>
        /// Gets or sets pre Restore replica group.
        /// </summary>
        [JsonProperty(PropertyName = "replicaGroup")]
        public string ReplicaGroup { get; set; }

        /// <summary>
        /// Gets or sets pre Restore request id.
        /// </summary>
        [JsonProperty(PropertyName = "requestId")]
        public string RequestId { get; set; }

        /// <summary>
        /// Gets or sets pre Restore Azure file share uri.
        /// </summary>
        [JsonProperty(PropertyName = "azureFileShareUri")]
        public string AzureFileShareUri { get; set; }

        /// <summary>
        /// Gets or sets pre Restore Azure status.
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets pre Restore Azure source azure file share uri.
        /// </summary>
        [JsonProperty(PropertyName = "sourceAzureFileShareUri")]
        public string SourceAzureFileShareUri { get; set; }

        /// <summary>
        /// Gets or sets pre Restore backup metadata property bag.
        /// </summary>
        [JsonProperty(PropertyName = "backupMetadataPropertyBag")]
        public string BackupMetadataPropertyBag { get; set; }

        /// <summary>
        /// Gets or sets pre Restore restore file spec array.
        /// </summary>
        [JsonProperty(PropertyName = "restoreFileSpec")]
        public IList<RestoreFileSpec> RestoreFileSpec { get; set; }

        /// <summary>
        /// Gets or sets pre Restore pause wait for sync drain time period in
        /// seconds.
        /// </summary>
        [JsonProperty(PropertyName = "pauseWaitForSyncDrainTimePeriodInSeconds")]
        public int? PauseWaitForSyncDrainTimePeriodInSeconds { get; set; }

    }
}
