// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorageSync.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters used when creating a registered server.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class RegisteredServerCreateParameters : ProxyResource
    {
        /// <summary>
        /// Initializes a new instance of the RegisteredServerCreateParameters
        /// class.
        /// </summary>
        public RegisteredServerCreateParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RegisteredServerCreateParameters
        /// class.
        /// </summary>
        /// <param name="id">Fully qualified resource Id for the resource. Ex -
        /// /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="type">The type of the resource. Ex-
        /// Microsoft.Compute/virtualMachines or
        /// Microsoft.Storage/storageAccounts.</param>
        /// <param name="serverCertificate">Registered Server
        /// Certificate</param>
        /// <param name="agentVersion">Registered Server Agent Version</param>
        /// <param name="serverOSVersion">Registered Server OS Version</param>
        /// <param name="lastHeartBeat">Registered Server last heart
        /// beat</param>
        /// <param name="serverRole">Registered Server serverRole</param>
        /// <param name="clusterId">Registered Server clusterId</param>
        /// <param name="clusterName">Registered Server clusterName</param>
        /// <param name="serverId">Registered Server serverId</param>
        /// <param name="friendlyName">Friendly Name</param>
        public RegisteredServerCreateParameters(string id = default(string), string name = default(string), string type = default(string), string serverCertificate = default(string), string agentVersion = default(string), string serverOSVersion = default(string), string lastHeartBeat = default(string), string serverRole = default(string), string clusterId = default(string), string clusterName = default(string), string serverId = default(string), string friendlyName = default(string))
            : base(id, name, type)
        {
            ServerCertificate = serverCertificate;
            AgentVersion = agentVersion;
            ServerOSVersion = serverOSVersion;
            LastHeartBeat = lastHeartBeat;
            ServerRole = serverRole;
            ClusterId = clusterId;
            ClusterName = clusterName;
            ServerId = serverId;
            FriendlyName = friendlyName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets registered Server Certificate
        /// </summary>
        [JsonProperty(PropertyName = "properties.serverCertificate")]
        public string ServerCertificate { get; set; }

        /// <summary>
        /// Gets or sets registered Server Agent Version
        /// </summary>
        [JsonProperty(PropertyName = "properties.agentVersion")]
        public string AgentVersion { get; set; }

        /// <summary>
        /// Gets or sets registered Server OS Version
        /// </summary>
        [JsonProperty(PropertyName = "properties.serverOSVersion")]
        public string ServerOSVersion { get; set; }

        /// <summary>
        /// Gets or sets registered Server last heart beat
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastHeartBeat")]
        public string LastHeartBeat { get; set; }

        /// <summary>
        /// Gets or sets registered Server serverRole
        /// </summary>
        [JsonProperty(PropertyName = "properties.serverRole")]
        public string ServerRole { get; set; }

        /// <summary>
        /// Gets or sets registered Server clusterId
        /// </summary>
        [JsonProperty(PropertyName = "properties.clusterId")]
        public string ClusterId { get; set; }

        /// <summary>
        /// Gets or sets registered Server clusterName
        /// </summary>
        [JsonProperty(PropertyName = "properties.clusterName")]
        public string ClusterName { get; set; }

        /// <summary>
        /// Gets or sets registered Server serverId
        /// </summary>
        [JsonProperty(PropertyName = "properties.serverId")]
        public string ServerId { get; set; }

        /// <summary>
        /// Gets or sets friendly Name
        /// </summary>
        [JsonProperty(PropertyName = "properties.friendlyName")]
        public string FriendlyName { get; set; }

    }
}
