// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorageSync.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Server endpoint cloud tiering status object.
    /// </summary>
    public partial class ServerEndpointCloudTieringStatus
    {
        /// <summary>
        /// Initializes a new instance of the ServerEndpointCloudTieringStatus
        /// class.
        /// </summary>
        public ServerEndpointCloudTieringStatus()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServerEndpointCloudTieringStatus
        /// class.
        /// </summary>
        /// <param name="health">Cloud tiering health state. Possible values
        /// include: 'Healthy', 'Error'</param>
        /// <param name="lastUpdatedTimestamp">Last updated timestamp</param>
        /// <param name="lastCloudTieringResult">Last cloud tiering result
        /// (HResult)</param>
        /// <param name="lastSuccessTimestamp">Last cloud tiering success
        /// timestamp</param>
        public ServerEndpointCloudTieringStatus(string health = default(string), System.DateTime? lastUpdatedTimestamp = default(System.DateTime?), int? lastCloudTieringResult = default(int?), System.DateTime? lastSuccessTimestamp = default(System.DateTime?))
        {
            Health = health;
            LastUpdatedTimestamp = lastUpdatedTimestamp;
            LastCloudTieringResult = lastCloudTieringResult;
            LastSuccessTimestamp = lastSuccessTimestamp;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets cloud tiering health state. Possible values include:
        /// 'Healthy', 'Error'
        /// </summary>
        [JsonProperty(PropertyName = "health")]
        public string Health { get; private set; }

        /// <summary>
        /// Gets last updated timestamp
        /// </summary>
        [JsonProperty(PropertyName = "lastUpdatedTimestamp")]
        public System.DateTime? LastUpdatedTimestamp { get; private set; }

        /// <summary>
        /// Gets last cloud tiering result (HResult)
        /// </summary>
        [JsonProperty(PropertyName = "lastCloudTieringResult")]
        public int? LastCloudTieringResult { get; private set; }

        /// <summary>
        /// Gets last cloud tiering success timestamp
        /// </summary>
        [JsonProperty(PropertyName = "lastSuccessTimestamp")]
        public System.DateTime? LastSuccessTimestamp { get; private set; }

    }
}
