// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorageSync.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Parameters for updating an Server Endpoint.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ServerEndpointUpdateParameters
    {
        /// <summary>
        /// Initializes a new instance of the ServerEndpointUpdateParameters
        /// class.
        /// </summary>
        public ServerEndpointUpdateParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServerEndpointUpdateParameters
        /// class.
        /// </summary>
        /// <param name="cloudTiering">Cloud Tiering. Possible values include:
        /// 'on', 'off'</param>
        /// <param name="volumeFreeSpacePercent">Level of free space to be
        /// maintained by Cloud Tiering if it is enabled.</param>
        /// <param name="tierFilesOlderThanDays">Tier files older than
        /// days.</param>
        /// <param name="offlineDataTransfer">Offline data transfer. Possible
        /// values include: 'on', 'off'</param>
        /// <param name="offlineDataTransferShareName">Offline data transfer
        /// share name</param>
        public ServerEndpointUpdateParameters(string cloudTiering = default(string), int? volumeFreeSpacePercent = default(int?), int? tierFilesOlderThanDays = default(int?), string offlineDataTransfer = default(string), string offlineDataTransferShareName = default(string))
        {
            CloudTiering = cloudTiering;
            VolumeFreeSpacePercent = volumeFreeSpacePercent;
            TierFilesOlderThanDays = tierFilesOlderThanDays;
            OfflineDataTransfer = offlineDataTransfer;
            OfflineDataTransferShareName = offlineDataTransferShareName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets cloud Tiering. Possible values include: 'on', 'off'
        /// </summary>
        [JsonProperty(PropertyName = "properties.cloudTiering")]
        public string CloudTiering { get; set; }

        /// <summary>
        /// Gets or sets level of free space to be maintained by Cloud Tiering
        /// if it is enabled.
        /// </summary>
        [JsonProperty(PropertyName = "properties.volumeFreeSpacePercent")]
        public int? VolumeFreeSpacePercent { get; set; }

        /// <summary>
        /// Gets or sets tier files older than days.
        /// </summary>
        [JsonProperty(PropertyName = "properties.tierFilesOlderThanDays")]
        public int? TierFilesOlderThanDays { get; set; }

        /// <summary>
        /// Gets or sets offline data transfer. Possible values include: 'on',
        /// 'off'
        /// </summary>
        [JsonProperty(PropertyName = "properties.offlineDataTransfer")]
        public string OfflineDataTransfer { get; set; }

        /// <summary>
        /// Gets or sets offline data transfer share name
        /// </summary>
        [JsonProperty(PropertyName = "properties.offlineDataTransferShareName")]
        public string OfflineDataTransferShareName { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VolumeFreeSpacePercent > 100)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "VolumeFreeSpacePercent", 100);
            }
            if (VolumeFreeSpacePercent < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "VolumeFreeSpacePercent", 0);
            }
            if (TierFilesOlderThanDays > 2147483647)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "TierFilesOlderThanDays", 2147483647);
            }
            if (TierFilesOlderThanDays < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "TierFilesOlderThanDays", 0);
            }
        }
    }
}
