// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorageSync.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Storage Sync Service object.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class StorageSyncService : TrackedResource
    {
        /// <summary>
        /// Initializes a new instance of the StorageSyncService class.
        /// </summary>
        public StorageSyncService()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the StorageSyncService class.
        /// </summary>
        /// <param name="location">The geo-location where the resource
        /// lives</param>
        /// <param name="id">Fully qualified resource Id for the resource. Ex -
        /// /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}</param>
        /// <param name="name">The name of the resource</param>
        /// <param name="type">The type of the resource. Ex-
        /// Microsoft.Compute/virtualMachines or
        /// Microsoft.Storage/storageAccounts.</param>
        /// <param name="tags">Resource tags.</param>
        /// <param name="storageSyncServiceStatus">Storage Sync service
        /// status.</param>
        /// <param name="storageSyncServiceUid">Storage Sync service
        /// Uid</param>
        public StorageSyncService(string location, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), int? storageSyncServiceStatus = default(int?), string storageSyncServiceUid = default(string))
            : base(location, id, name, type, tags)
        {
            StorageSyncServiceStatus = storageSyncServiceStatus;
            StorageSyncServiceUid = storageSyncServiceUid;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets storage Sync service status.
        /// </summary>
        [JsonProperty(PropertyName = "properties.storageSyncServiceStatus")]
        public int? StorageSyncServiceStatus { get; private set; }

        /// <summary>
        /// Gets storage Sync service Uid
        /// </summary>
        [JsonProperty(PropertyName = "properties.storageSyncServiceUid")]
        public string StorageSyncServiceUid { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
