// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorageSync
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for OperationStatusOperations.
    /// </summary>
    public static partial class OperationStatusOperationsExtensions
    {
            /// <summary>
            /// Get Operation status
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group. The name is case insensitive.
            /// </param>
            /// <param name='locationName'>
            /// The desired region to obtain information from.
            /// </param>
            /// <param name='workflowId'>
            /// workflow Id
            /// </param>
            /// <param name='operationId'>
            /// operation Id
            /// </param>
            public static OperationStatus Get(this IOperationStatusOperations operations, string resourceGroupName, string locationName, string workflowId, string operationId)
            {
                return operations.GetAsync(resourceGroupName, locationName, workflowId, operationId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get Operation status
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group. The name is case insensitive.
            /// </param>
            /// <param name='locationName'>
            /// The desired region to obtain information from.
            /// </param>
            /// <param name='workflowId'>
            /// workflow Id
            /// </param>
            /// <param name='operationId'>
            /// operation Id
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<OperationStatus> GetAsync(this IOperationStatusOperations operations, string resourceGroupName, string locationName, string workflowId, string operationId, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, locationName, workflowId, operationId, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
