// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorSimple1200Series
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// </summary>
    public partial interface IStorSimpleManagementClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// The api version
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// The subscription id
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IManagersOperations.
        /// </summary>
        IManagersOperations Managers { get; }

        /// <summary>
        /// Gets the IAvailableProviderOperationsOperations.
        /// </summary>
        IAvailableProviderOperationsOperations AvailableProviderOperations { get; }

        /// <summary>
        /// Gets the IAccessControlRecordsOperations.
        /// </summary>
        IAccessControlRecordsOperations AccessControlRecords { get; }

        /// <summary>
        /// Gets the IAlertsOperations.
        /// </summary>
        IAlertsOperations Alerts { get; }

        /// <summary>
        /// Gets the IBackupsOperations.
        /// </summary>
        IBackupsOperations Backups { get; }

        /// <summary>
        /// Gets the IDevicesOperations.
        /// </summary>
        IDevicesOperations Devices { get; }

        /// <summary>
        /// Gets the IBackupScheduleGroupsOperations.
        /// </summary>
        IBackupScheduleGroupsOperations BackupScheduleGroups { get; }

        /// <summary>
        /// Gets the IChapSettingsOperations.
        /// </summary>
        IChapSettingsOperations ChapSettings { get; }

        /// <summary>
        /// Gets the IIscsiDisksOperations.
        /// </summary>
        IIscsiDisksOperations IscsiDisks { get; }

        /// <summary>
        /// Gets the IFileServersOperations.
        /// </summary>
        IFileServersOperations FileServers { get; }

        /// <summary>
        /// Gets the IFileSharesOperations.
        /// </summary>
        IFileSharesOperations FileShares { get; }

        /// <summary>
        /// Gets the IIscsiServersOperations.
        /// </summary>
        IIscsiServersOperations IscsiServers { get; }

        /// <summary>
        /// Gets the IJobsOperations.
        /// </summary>
        IJobsOperations Jobs { get; }

        /// <summary>
        /// Gets the IStorageAccountCredentialsOperations.
        /// </summary>
        IStorageAccountCredentialsOperations StorageAccountCredentials { get; }

        /// <summary>
        /// Gets the IStorageDomainsOperations.
        /// </summary>
        IStorageDomainsOperations StorageDomains { get; }

    }
}
