// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorSimple1200Series.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Alert class
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class Alert : BaseModel
    {
        /// <summary>
        /// Initializes a new instance of the Alert class.
        /// </summary>
        public Alert()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Alert class.
        /// </summary>
        /// <param name="title">Title of the alert</param>
        /// <param name="scope">Device or Resource alert. Possible values
        /// include: 'Resource', 'Device'</param>
        /// <param name="alertType">Type of the alert</param>
        /// <param name="appearedAtTime">UTC time at which the alert
        /// appeared</param>
        /// <param name="appearedAtSourceTime">UTC time at which the alert
        /// appeared on the source</param>
        /// <param name="source">Source at which the alert was cleared</param>
        /// <param name="severity">Severity of the alert. Possible values
        /// include: 'Informational', 'Warning', 'Critical'</param>
        /// <param name="status">Current status of the alert. Possible values
        /// include: 'Active', 'Cleared'</param>
        /// <param name="id">The identifier.</param>
        /// <param name="name">The name.</param>
        /// <param name="type">The type.</param>
        /// <param name="clearedAtTime">UTC time at which the alert got
        /// cleared</param>
        /// <param name="clearedAtSourceTime">UTC time at which the alert was
        /// cleared on the source</param>
        /// <param name="recommendation">Recommendation for acting on the
        /// alert</param>
        /// <param name="resolutionReason">Reason for resolving the
        /// alert</param>
        /// <param name="errorDetails">ErrorDetails of the alert</param>
        /// <param name="detailedInformation">Other information about the
        /// alert</param>
        public Alert(string title, AlertScope scope, string alertType, System.DateTime appearedAtTime, System.DateTime appearedAtSourceTime, AlertSource source, AlertSeverity severity, AlertStatus status, string id = default(string), string name = default(string), string type = default(string), System.DateTime? clearedAtTime = default(System.DateTime?), System.DateTime? clearedAtSourceTime = default(System.DateTime?), string recommendation = default(string), string resolutionReason = default(string), AlertErrorDetails errorDetails = default(AlertErrorDetails), IDictionary<string, string> detailedInformation = default(IDictionary<string, string>))
            : base(id, name, type)
        {
            Title = title;
            Scope = scope;
            AlertType = alertType;
            AppearedAtTime = appearedAtTime;
            AppearedAtSourceTime = appearedAtSourceTime;
            ClearedAtTime = clearedAtTime;
            ClearedAtSourceTime = clearedAtSourceTime;
            Source = source;
            Recommendation = recommendation;
            ResolutionReason = resolutionReason;
            Severity = severity;
            Status = status;
            ErrorDetails = errorDetails;
            DetailedInformation = detailedInformation;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets title of the alert
        /// </summary>
        [JsonProperty(PropertyName = "properties.title")]
        public string Title { get; set; }

        /// <summary>
        /// Gets or sets device or Resource alert. Possible values include:
        /// 'Resource', 'Device'
        /// </summary>
        [JsonProperty(PropertyName = "properties.scope")]
        public AlertScope Scope { get; set; }

        /// <summary>
        /// Gets or sets type of the alert
        /// </summary>
        [JsonProperty(PropertyName = "properties.alertType")]
        public string AlertType { get; set; }

        /// <summary>
        /// Gets or sets UTC time at which the alert appeared
        /// </summary>
        [JsonProperty(PropertyName = "properties.appearedAtTime")]
        public System.DateTime AppearedAtTime { get; set; }

        /// <summary>
        /// Gets or sets UTC time at which the alert appeared on the source
        /// </summary>
        [JsonProperty(PropertyName = "properties.appearedAtSourceTime")]
        public System.DateTime AppearedAtSourceTime { get; set; }

        /// <summary>
        /// Gets or sets UTC time at which the alert got cleared
        /// </summary>
        [JsonProperty(PropertyName = "properties.clearedAtTime")]
        public System.DateTime? ClearedAtTime { get; set; }

        /// <summary>
        /// Gets or sets UTC time at which the alert was cleared on the source
        /// </summary>
        [JsonProperty(PropertyName = "properties.clearedAtSourceTime")]
        public System.DateTime? ClearedAtSourceTime { get; set; }

        /// <summary>
        /// Gets or sets source at which the alert was cleared
        /// </summary>
        [JsonProperty(PropertyName = "properties.source")]
        public AlertSource Source { get; set; }

        /// <summary>
        /// Gets or sets recommendation for acting on the alert
        /// </summary>
        [JsonProperty(PropertyName = "properties.recommendation")]
        public string Recommendation { get; set; }

        /// <summary>
        /// Gets or sets reason for resolving the alert
        /// </summary>
        [JsonProperty(PropertyName = "properties.resolutionReason")]
        public string ResolutionReason { get; set; }

        /// <summary>
        /// Gets or sets severity of the alert. Possible values include:
        /// 'Informational', 'Warning', 'Critical'
        /// </summary>
        [JsonProperty(PropertyName = "properties.severity")]
        public AlertSeverity Severity { get; set; }

        /// <summary>
        /// Gets or sets current status of the alert. Possible values include:
        /// 'Active', 'Cleared'
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public AlertStatus Status { get; set; }

        /// <summary>
        /// Gets or sets errorDetails of the alert
        /// </summary>
        [JsonProperty(PropertyName = "properties.errorDetails")]
        public AlertErrorDetails ErrorDetails { get; set; }

        /// <summary>
        /// Gets or sets other information about the alert
        /// </summary>
        [JsonProperty(PropertyName = "properties.detailedInformation")]
        public IDictionary<string, string> DetailedInformation { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Title == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Title");
            }
            if (AlertType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AlertType");
            }
            if (Source == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Source");
            }
        }
    }
}
