// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorSimple1200Series.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Filters that can be specified on the alert
    /// </summary>
    public partial class AlertFilter
    {
        /// <summary>
        /// Initializes a new instance of the AlertFilter class.
        /// </summary>
        public AlertFilter()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AlertFilter class.
        /// </summary>
        /// <param name="status">Status of the alert. Possible values include:
        /// 'Active', 'Cleared'</param>
        /// <param name="severity">Severity of the alert. Possible values
        /// include: 'Informational', 'Warning', 'Critical'</param>
        /// <param name="sourceType">Source of the alert. Possible values
        /// include: 'Resource', 'Device'</param>
        /// <param name="sourceName">Source name of the alert</param>
        /// <param name="appearedOnTime">UTC time on which the alert
        /// appeared</param>
        public AlertFilter(AlertStatus? status = default(AlertStatus?), AlertSeverity? severity = default(AlertSeverity?), AlertSourceType? sourceType = default(AlertSourceType?), string sourceName = default(string), System.DateTime? appearedOnTime = default(System.DateTime?))
        {
            Status = status;
            Severity = severity;
            SourceType = sourceType;
            SourceName = sourceName;
            AppearedOnTime = appearedOnTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets status of the alert. Possible values include:
        /// 'Active', 'Cleared'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public AlertStatus? Status { get; set; }

        /// <summary>
        /// Gets or sets severity of the alert. Possible values include:
        /// 'Informational', 'Warning', 'Critical'
        /// </summary>
        [JsonProperty(PropertyName = "severity")]
        public AlertSeverity? Severity { get; set; }

        /// <summary>
        /// Gets or sets source of the alert. Possible values include:
        /// 'Resource', 'Device'
        /// </summary>
        [JsonProperty(PropertyName = "sourceType")]
        public AlertSourceType? SourceType { get; set; }

        /// <summary>
        /// Gets or sets source name of the alert
        /// </summary>
        [JsonProperty(PropertyName = "sourceName")]
        public string SourceName { get; set; }

        /// <summary>
        /// Gets or sets UTC time on which the alert appeared
        /// </summary>
        [JsonProperty(PropertyName = "appearedOnTime")]
        public System.DateTime? AppearedOnTime { get; set; }

    }
}
