// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorSimple1200Series.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The job error items.
    /// </summary>
    public partial class JobErrorItem
    {
        /// <summary>
        /// Initializes a new instance of the JobErrorItem class.
        /// </summary>
        public JobErrorItem()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JobErrorItem class.
        /// </summary>
        /// <param name="code">The code intended for programmatic
        /// access</param>
        /// <param name="message">The message intended to describe the error in
        /// detail</param>
        /// <param name="recommendations">The recommended actions.</param>
        public JobErrorItem(string code, string message, IList<string> recommendations = default(IList<string>))
        {
            Recommendations = recommendations;
            Code = code;
            Message = message;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the recommended actions.
        /// </summary>
        [JsonProperty(PropertyName = "recommendations")]
        public IList<string> Recommendations { get; set; }

        /// <summary>
        /// Gets or sets the code intended for programmatic access
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; set; }

        /// <summary>
        /// Gets or sets the message intended to describe the error in detail
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Code == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Code");
            }
            if (Message == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Message");
            }
        }
    }
}
