// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorSimple1200Series.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The extended info of the manager.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ManagerExtendedInfo : BaseModel
    {
        /// <summary>
        /// Initializes a new instance of the ManagerExtendedInfo class.
        /// </summary>
        public ManagerExtendedInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ManagerExtendedInfo class.
        /// </summary>
        /// <param name="integrityKey">Represents the CIK of the
        /// resource</param>
        /// <param name="algorithm">Represents the encryption algorithm used to
        /// encrypt the other keys. None - if EncryptionKey is saved in plain
        /// text format. AlgorithmName - if encryption is used</param>
        /// <param name="id">The identifier.</param>
        /// <param name="name">The name.</param>
        /// <param name="type">The type.</param>
        /// <param name="version">Represents the version of the ExtendedInfo
        /// object being persisted</param>
        /// <param name="encryptionKey">Represents the CEK of the
        /// resource</param>
        /// <param name="encryptionKeyThumbprint">Represents the Cert
        /// thumbprint that was used to encrypt the CEK</param>
        /// <param name="portalCertificateThumbprint">Represents the portal
        /// thumbprint which can be used optionally to encrypt the entire data
        /// before storing it.</param>
        /// <param name="etag">ETag of the Resource</param>
        public ManagerExtendedInfo(string integrityKey, string algorithm, string id = default(string), string name = default(string), string type = default(string), string version = default(string), string encryptionKey = default(string), string encryptionKeyThumbprint = default(string), string portalCertificateThumbprint = default(string), string etag = default(string))
            : base(id, name, type)
        {
            Version = version;
            IntegrityKey = integrityKey;
            EncryptionKey = encryptionKey;
            EncryptionKeyThumbprint = encryptionKeyThumbprint;
            PortalCertificateThumbprint = portalCertificateThumbprint;
            Algorithm = algorithm;
            Etag = etag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets represents the version of the ExtendedInfo object
        /// being persisted
        /// </summary>
        [JsonProperty(PropertyName = "properties.version")]
        public string Version { get; set; }

        /// <summary>
        /// Gets or sets represents the CIK of the resource
        /// </summary>
        [JsonProperty(PropertyName = "properties.integrityKey")]
        public string IntegrityKey { get; set; }

        /// <summary>
        /// Gets or sets represents the CEK of the resource
        /// </summary>
        [JsonProperty(PropertyName = "properties.encryptionKey")]
        public string EncryptionKey { get; set; }

        /// <summary>
        /// Gets or sets represents the Cert thumbprint that was used to
        /// encrypt the CEK
        /// </summary>
        [JsonProperty(PropertyName = "properties.encryptionKeyThumbprint")]
        public string EncryptionKeyThumbprint { get; set; }

        /// <summary>
        /// Gets or sets represents the portal thumbprint which can be used
        /// optionally to encrypt the entire data before storing it.
        /// </summary>
        [JsonProperty(PropertyName = "properties.portalCertificateThumbprint")]
        public string PortalCertificateThumbprint { get; set; }

        /// <summary>
        /// Gets or sets represents the encryption algorithm used to encrypt
        /// the other keys. None - if EncryptionKey is saved in plain text
        /// format. AlgorithmName - if encryption is used
        /// </summary>
        [JsonProperty(PropertyName = "properties.algorithm")]
        public string Algorithm { get; set; }

        /// <summary>
        /// Gets or sets eTag of the Resource
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (IntegrityKey == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "IntegrityKey");
            }
            if (Algorithm == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Algorithm");
            }
        }
    }
}
