// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.StorSimple1200Series.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This class can be used as the Type for any secret entity represented as
    /// Value, ValueCertificateThumbprint, EncryptionAlgorithm. In this case,
    /// "Value" is a secret and the "valueThumbprint" represents the
    /// certificate thumbprint of the value. The algorithm field is mainly for
    /// future usage to potentially allow different entities encrypted using
    /// different algorithms.
    /// </summary>
    public partial class SymmetricEncryptedSecret
    {
        /// <summary>
        /// Initializes a new instance of the SymmetricEncryptedSecret class.
        /// </summary>
        public SymmetricEncryptedSecret()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SymmetricEncryptedSecret class.
        /// </summary>
        /// <param name="value">The value of the secret itself. If the secret
        /// is in plaintext or null then EncryptionAlgorithm will be
        /// none</param>
        /// <param name="encryptionAlgorithm">Algorithm used to encrypt
        /// "Value". Possible values include: 'None', 'AES256',
        /// 'RSAES_PKCS1_v_1_5'</param>
        /// <param name="valueCertificateThumbprint">Thumbprint cert that was
        /// used to encrypt "Value"</param>
        public SymmetricEncryptedSecret(string value, EncryptionAlgorithm encryptionAlgorithm, string valueCertificateThumbprint = default(string))
        {
            Value = value;
            ValueCertificateThumbprint = valueCertificateThumbprint;
            EncryptionAlgorithm = encryptionAlgorithm;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the value of the secret itself. If the secret is in
        /// plaintext or null then EncryptionAlgorithm will be none
        /// </summary>
        [JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

        /// <summary>
        /// Gets or sets thumbprint cert that was used to encrypt "Value"
        /// </summary>
        [JsonProperty(PropertyName = "valueCertificateThumbprint")]
        public string ValueCertificateThumbprint { get; set; }

        /// <summary>
        /// Gets or sets algorithm used to encrypt "Value". Possible values
        /// include: 'None', 'AES256', 'RSAES_PKCS1_v_1_5'
        /// </summary>
        [JsonProperty(PropertyName = "encryptionAlgorithm")]
        public EncryptionAlgorithm EncryptionAlgorithm { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Value == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Value");
            }
        }
    }
}
