// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters needed to retrieve the default function definition for
    /// an Azure Machine Learning web service function.
    /// </summary>
    [Newtonsoft.Json.JsonObject("Microsoft.MachineLearning/WebService")]
    [Rest.Serialization.JsonTransformation]
    public partial class AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters : FunctionRetrieveDefaultDefinitionParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters
        /// class.
        /// </summary>
        public AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters
        /// class.
        /// </summary>
        /// <param name="executeEndpoint">The Request-Response execute endpoint
        /// of the Azure Machine Learning web service. Find out more here:
        /// https://docs.microsoft.com/en-us/azure/machine-learning/machine-learning-consume-web-services#request-response-service-rrs</param>
        /// <param name="udfType">The function type. Possible values include:
        /// 'Scalar'</param>
        public AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters(string executeEndpoint = default(string), UdfType? udfType = default(UdfType?))
        {
            ExecuteEndpoint = executeEndpoint;
            UdfType = udfType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Request-Response execute endpoint of the Azure
        /// Machine Learning web service. Find out more here:
        /// https://docs.microsoft.com/en-us/azure/machine-learning/machine-learning-consume-web-services#request-response-service-rrs
        /// </summary>
        [JsonProperty(PropertyName = "bindingRetrievalProperties.executeEndpoint")]
        public string ExecuteEndpoint { get; set; }

        /// <summary>
        /// Gets or sets the function type. Possible values include: 'Scalar'
        /// </summary>
        [JsonProperty(PropertyName = "bindingRetrievalProperties.udfType")]
        public UdfType? UdfType { get; set; }

    }
}
