// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes an input column for the Azure Machine Learning web service
    /// endpoint.
    /// </summary>
    public partial class AzureMachineLearningWebServiceInputColumn
    {
        /// <summary>
        /// Initializes a new instance of the
        /// AzureMachineLearningWebServiceInputColumn class.
        /// </summary>
        public AzureMachineLearningWebServiceInputColumn()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// AzureMachineLearningWebServiceInputColumn class.
        /// </summary>
        /// <param name="name">The name of the input column.</param>
        /// <param name="dataType">The (Azure Machine Learning supported) data
        /// type of the input column. A list of valid  Azure Machine Learning
        /// data types are described at
        /// https://msdn.microsoft.com/en-us/library/azure/dn905923.aspx
        /// .</param>
        /// <param name="mapTo">The zero based index of the function parameter
        /// this input maps to.</param>
        public AzureMachineLearningWebServiceInputColumn(string name = default(string), string dataType = default(string), int? mapTo = default(int?))
        {
            Name = name;
            DataType = dataType;
            MapTo = mapTo;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the input column.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the (Azure Machine Learning supported) data type of
        /// the input column. A list of valid  Azure Machine Learning data
        /// types are described at
        /// https://msdn.microsoft.com/en-us/library/azure/dn905923.aspx .
        /// </summary>
        [JsonProperty(PropertyName = "dataType")]
        public string DataType { get; set; }

        /// <summary>
        /// Gets or sets the zero based index of the function parameter this
        /// input maps to.
        /// </summary>
        [JsonProperty(PropertyName = "mapTo")]
        public int? MapTo { get; set; }

    }
}
