// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The inputs for the Azure Machine Learning web service endpoint.
    /// </summary>
    public partial class AzureMachineLearningWebServiceInputs
    {
        /// <summary>
        /// Initializes a new instance of the
        /// AzureMachineLearningWebServiceInputs class.
        /// </summary>
        public AzureMachineLearningWebServiceInputs()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// AzureMachineLearningWebServiceInputs class.
        /// </summary>
        /// <param name="name">The name of the input. This is the name provided
        /// while authoring the endpoint.</param>
        /// <param name="columnNames">A list of input columns for the Azure
        /// Machine Learning web service endpoint.</param>
        public AzureMachineLearningWebServiceInputs(string name = default(string), IList<AzureMachineLearningWebServiceInputColumn> columnNames = default(IList<AzureMachineLearningWebServiceInputColumn>))
        {
            Name = name;
            ColumnNames = columnNames;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the input. This is the name provided while
        /// authoring the endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets a list of input columns for the Azure Machine Learning
        /// web service endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "columnNames")]
        public IList<AzureMachineLearningWebServiceInputColumn> ColumnNames { get; set; }

    }
}
