// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes how data from an input is serialized or how data is
    /// serialized when written to an output in CSV format.
    /// </summary>
    [Newtonsoft.Json.JsonObject("Csv")]
    [Rest.Serialization.JsonTransformation]
    public partial class CsvSerialization : Serialization
    {
        /// <summary>
        /// Initializes a new instance of the CsvSerialization class.
        /// </summary>
        public CsvSerialization()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CsvSerialization class.
        /// </summary>
        /// <param name="fieldDelimiter">Specifies the delimiter that will be
        /// used to separate comma-separated value (CSV) records. See
        /// https://docs.microsoft.com/en-us/rest/api/streamanalytics/stream-analytics-input
        /// or
        /// https://docs.microsoft.com/en-us/rest/api/streamanalytics/stream-analytics-output
        /// for a list of supported values. Required on PUT (CreateOrReplace)
        /// requests.</param>
        /// <param name="encoding">Specifies the encoding of the incoming data
        /// in the case of input and the encoding of outgoing data in the case
        /// of output. Required on PUT (CreateOrReplace) requests. Possible
        /// values include: 'UTF8'</param>
        public CsvSerialization(string fieldDelimiter = default(string), string encoding = default(string))
        {
            FieldDelimiter = fieldDelimiter;
            Encoding = encoding;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies the delimiter that will be used to separate
        /// comma-separated value (CSV) records. See
        /// https://docs.microsoft.com/en-us/rest/api/streamanalytics/stream-analytics-input
        /// or
        /// https://docs.microsoft.com/en-us/rest/api/streamanalytics/stream-analytics-output
        /// for a list of supported values. Required on PUT (CreateOrReplace)
        /// requests.
        /// </summary>
        [JsonProperty(PropertyName = "properties.fieldDelimiter")]
        public string FieldDelimiter { get; set; }

        /// <summary>
        /// Gets or sets specifies the encoding of the incoming data in the
        /// case of input and the encoding of outgoing data in the case of
        /// output. Required on PUT (CreateOrReplace) requests. Possible values
        /// include: 'UTF8'
        /// </summary>
        [JsonProperty(PropertyName = "properties.encoding")]
        public string Encoding { get; set; }

    }
}
