// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Condition applicable to the resource, or to the job overall, that
    /// warrant customer attention.
    /// </summary>
    public partial class DiagnosticCondition
    {
        /// <summary>
        /// Initializes a new instance of the DiagnosticCondition class.
        /// </summary>
        public DiagnosticCondition()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DiagnosticCondition class.
        /// </summary>
        /// <param name="since">The UTC timestamp of when the condition
        /// started. Customers should be able to find a corresponding event in
        /// the ops log around this time.</param>
        /// <param name="code">The opaque diagnostic code.</param>
        /// <param name="message">The human-readable message describing the
        /// condition in detail. Localized in the Accept-Language of the client
        /// request.</param>
        public DiagnosticCondition(string since = default(string), string code = default(string), string message = default(string))
        {
            Since = since;
            Code = code;
            Message = message;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the UTC timestamp of when the condition started. Customers
        /// should be able to find a corresponding event in the ops log around
        /// this time.
        /// </summary>
        [JsonProperty(PropertyName = "since")]
        public string Since { get; private set; }

        /// <summary>
        /// Gets the opaque diagnostic code.
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public string Code { get; private set; }

        /// <summary>
        /// Gets the human-readable message describing the condition in detail.
        /// Localized in the Accept-Language of the client request.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; private set; }

    }
}
