// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes conditions applicable to the Input, Output, or the job
    /// overall, that warrant customer attention.
    /// </summary>
    public partial class Diagnostics
    {
        /// <summary>
        /// Initializes a new instance of the Diagnostics class.
        /// </summary>
        public Diagnostics()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Diagnostics class.
        /// </summary>
        /// <param name="conditions">A collection of zero or more conditions
        /// applicable to the resource, or to the job overall, that warrant
        /// customer attention.</param>
        public Diagnostics(IList<DiagnosticCondition> conditions = default(IList<DiagnosticCondition>))
        {
            Conditions = conditions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets a collection of zero or more conditions applicable to the
        /// resource, or to the job overall, that warrant customer attention.
        /// </summary>
        [JsonProperty(PropertyName = "conditions")]
        public IList<DiagnosticCondition> Conditions { get; private set; }

    }
}
