// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the output of a function.
    /// </summary>
    public partial class FunctionOutput
    {
        /// <summary>
        /// Initializes a new instance of the FunctionOutput class.
        /// </summary>
        public FunctionOutput()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the FunctionOutput class.
        /// </summary>
        /// <param name="dataType">The (Azure Stream Analytics supported) data
        /// type of the function output. A list of valid Azure Stream Analytics
        /// data types are described at
        /// https://msdn.microsoft.com/en-us/library/azure/dn835065.aspx</param>
        public FunctionOutput(string dataType = default(string))
        {
            DataType = dataType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the (Azure Stream Analytics supported) data type of
        /// the function output. A list of valid Azure Stream Analytics data
        /// types are described at
        /// https://msdn.microsoft.com/en-us/library/azure/dn835065.aspx
        /// </summary>
        [JsonProperty(PropertyName = "dataType")]
        public string DataType { get; set; }

    }
}
