// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// An input object, containing all information associated with the named
    /// input. All inputs are contained under a streaming job.
    /// </summary>
    public partial class Input : SubResource
    {
        /// <summary>
        /// Initializes a new instance of the Input class.
        /// </summary>
        public Input()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Input class.
        /// </summary>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="properties">The properties that are associated with an
        /// input. Required on PUT (CreateOrReplace) requests.</param>
        public Input(string id = default(string), string name = default(string), string type = default(string), InputProperties properties = default(InputProperties))
            : base(id, name, type)
        {
            Properties = properties;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the properties that are associated with an input.
        /// Required on PUT (CreateOrReplace) requests.
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public InputProperties Properties { get; set; }

    }
}
