// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters needed to retrieve the default function definition for a
    /// JavaScript function.
    /// </summary>
    [Newtonsoft.Json.JsonObject("Microsoft.StreamAnalytics/JavascriptUdf")]
    [Rest.Serialization.JsonTransformation]
    public partial class JavaScriptFunctionRetrieveDefaultDefinitionParameters : FunctionRetrieveDefaultDefinitionParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// JavaScriptFunctionRetrieveDefaultDefinitionParameters class.
        /// </summary>
        public JavaScriptFunctionRetrieveDefaultDefinitionParameters()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// JavaScriptFunctionRetrieveDefaultDefinitionParameters class.
        /// </summary>
        /// <param name="script">The JavaScript code containing a single
        /// function definition. For example: 'function (x, y) { return x + y;
        /// }'.</param>
        /// <param name="udfType">The function type. Possible values include:
        /// 'Scalar'</param>
        public JavaScriptFunctionRetrieveDefaultDefinitionParameters(string script = default(string), UdfType? udfType = default(UdfType?))
        {
            Script = script;
            UdfType = udfType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the JavaScript code containing a single function
        /// definition. For example: 'function (x, y) { return x + y; }'.
        /// </summary>
        [JsonProperty(PropertyName = "bindingRetrievalProperties.script")]
        public string Script { get; set; }

        /// <summary>
        /// Gets or sets the function type. Possible values include: 'Scalar'
        /// </summary>
        [JsonProperty(PropertyName = "bindingRetrievalProperties.udfType")]
        public UdfType? UdfType { get; set; }

    }
}
