// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the status of the test operation along with error
    /// information, if applicable.
    /// </summary>
    public partial class ResourceTestStatus
    {
        /// <summary>
        /// Initializes a new instance of the ResourceTestStatus class.
        /// </summary>
        public ResourceTestStatus()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceTestStatus class.
        /// </summary>
        /// <param name="status">The status of the test operation.</param>
        /// <param name="error">Describes the error that occurred.</param>
        public ResourceTestStatus(string status = default(string), ErrorResponse error = default(ErrorResponse))
        {
            Status = status;
            Error = error;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the status of the test operation.
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; private set; }

        /// <summary>
        /// Gets describes the error that occurred.
        /// </summary>
        [JsonProperty(PropertyName = "error")]
        public ErrorResponse Error { get; private set; }

    }
}
