// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties that are associated with a scalar function.
    /// </summary>
    [Newtonsoft.Json.JsonObject("Scalar")]
    [Rest.Serialization.JsonTransformation]
    public partial class ScalarFunctionProperties : FunctionProperties
    {
        /// <summary>
        /// Initializes a new instance of the ScalarFunctionProperties class.
        /// </summary>
        public ScalarFunctionProperties()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ScalarFunctionProperties class.
        /// </summary>
        /// <param name="etag">The current entity tag for the function. This is
        /// an opaque string. You can use it to detect whether the resource has
        /// changed between requests. You can also use it in the If-Match or
        /// If-None-Match headers for write operations for optimistic
        /// concurrency.</param>
        /// <param name="inputs">A list of inputs describing the parameters of
        /// the function.</param>
        /// <param name="output">The output of the function.</param>
        /// <param name="binding">The physical binding of the function. For
        /// example, in the Azure Machine Learning web service’s case, this
        /// describes the endpoint.</param>
        public ScalarFunctionProperties(string etag = default(string), IList<FunctionInput> inputs = default(IList<FunctionInput>), FunctionOutput output = default(FunctionOutput), FunctionBinding binding = default(FunctionBinding))
            : base(etag)
        {
            Inputs = inputs;
            Output = output;
            Binding = binding;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a list of inputs describing the parameters of the
        /// function.
        /// </summary>
        [JsonProperty(PropertyName = "properties.inputs")]
        public IList<FunctionInput> Inputs { get; set; }

        /// <summary>
        /// Gets or sets the output of the function.
        /// </summary>
        [JsonProperty(PropertyName = "properties.output")]
        public FunctionOutput Output { get; set; }

        /// <summary>
        /// Gets or sets the physical binding of the function. For example, in
        /// the Azure Machine Learning web service’s case, this describes the
        /// endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "properties.binding")]
        public FunctionBinding Binding { get; set; }

    }
}
