// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.StreamAnalytics;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the current quota for the subscription.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class SubscriptionQuota : SubResource
    {
        /// <summary>
        /// Initializes a new instance of the SubscriptionQuota class.
        /// </summary>
        public SubscriptionQuota()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SubscriptionQuota class.
        /// </summary>
        /// <param name="id">Resource Id</param>
        /// <param name="name">Resource name</param>
        /// <param name="type">Resource type</param>
        /// <param name="maxCount">The max permitted usage of this
        /// resource.</param>
        /// <param name="currentCount">The current usage of this
        /// resource.</param>
        public SubscriptionQuota(string id = default(string), string name = default(string), string type = default(string), int? maxCount = default(int?), int? currentCount = default(int?))
            : base(id, name, type)
        {
            MaxCount = maxCount;
            CurrentCount = currentCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the max permitted usage of this resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.maxCount")]
        public int? MaxCount { get; private set; }

        /// <summary>
        /// Gets the current usage of this resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.currentCount")]
        public int? CurrentCount { get; private set; }

    }
}
