// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.StreamAnalytics
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for SubscriptionsOperations.
    /// </summary>
    public static partial class SubscriptionsOperationsExtensions
    {
            /// <summary>
            /// Retrieves the subscription's current quota information in a particular
            /// region.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The region in which to retrieve the subscription's quota information. You
            /// can find out which regions Azure Stream Analytics is supported in here:
            /// https://azure.microsoft.com/en-us/regions/
            /// </param>
            public static SubscriptionQuotasListResult ListQuotas(this ISubscriptionsOperations operations, string location)
            {
                return operations.ListQuotasAsync(location).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Retrieves the subscription's current quota information in a particular
            /// region.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The region in which to retrieve the subscription's quota information. You
            /// can find out which regions Azure Stream Analytics is supported in here:
            /// https://azure.microsoft.com/en-us/regions/
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<SubscriptionQuotasListResult> ListQuotasAsync(this ISubscriptionsOperations operations, string location, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListQuotasWithHttpMessagesAsync(location, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
