// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Subscription.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The parameters required to create a new subscription.
    /// </summary>
    public partial class ModernSubscriptionCreationParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ModernSubscriptionCreationParameters class.
        /// </summary>
        public ModernSubscriptionCreationParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ModernSubscriptionCreationParameters class.
        /// </summary>
        /// <param name="displayName">The friendly name of the
        /// subscription.</param>
        /// <param name="billingProfileId">The ARM ID of the billing profile
        /// for which you want to create the subscription.</param>
        /// <param name="skuId">The SKU ID of the Azure plan. Azure plan
        /// determines the pricing and service-level agreement of the
        /// subscription.  Use 001 for Microsoft Azure Plan and 002 for
        /// Microsoft Azure Plan for DevTest.</param>
        /// <param name="costCenter">If set, the cost center will show up on
        /// the Azure usage and charges file.</param>
        /// <param name="owner">If specified, the AD principal will get owner
        /// access to the subscription, along with the user who is performing
        /// the create subscription operation</param>
        /// <param name="managementGroupId">The identifier of the management
        /// group to which this subscription will be associated.</param>
        /// <param name="additionalParameters">Additional, untyped parameters
        /// to support custom subscription creation scenarios.</param>
        public ModernSubscriptionCreationParameters(string displayName, string billingProfileId, string skuId, string costCenter = default(string), AdPrincipal owner = default(AdPrincipal), string managementGroupId = default(string), IDictionary<string, object> additionalParameters = default(IDictionary<string, object>))
        {
            DisplayName = displayName;
            BillingProfileId = billingProfileId;
            SkuId = skuId;
            CostCenter = costCenter;
            Owner = owner;
            ManagementGroupId = managementGroupId;
            AdditionalParameters = additionalParameters;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the friendly name of the subscription.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the ARM ID of the billing profile for which you want
        /// to create the subscription.
        /// </summary>
        [JsonProperty(PropertyName = "billingProfileId")]
        public string BillingProfileId { get; set; }

        /// <summary>
        /// Gets or sets the SKU ID of the Azure plan. Azure plan determines
        /// the pricing and service-level agreement of the subscription.  Use
        /// 001 for Microsoft Azure Plan and 002 for Microsoft Azure Plan for
        /// DevTest.
        /// </summary>
        [JsonProperty(PropertyName = "skuId")]
        public string SkuId { get; set; }

        /// <summary>
        /// Gets or sets if set, the cost center will show up on the Azure
        /// usage and charges file.
        /// </summary>
        [JsonProperty(PropertyName = "costCenter")]
        public string CostCenter { get; set; }

        /// <summary>
        /// Gets or sets if specified, the AD principal will get owner access
        /// to the subscription, along with the user who is performing the
        /// create subscription operation
        /// </summary>
        [JsonProperty(PropertyName = "owner")]
        public AdPrincipal Owner { get; set; }

        /// <summary>
        /// Gets or sets the identifier of the management group to which this
        /// subscription will be associated.
        /// </summary>
        [JsonProperty(PropertyName = "managementGroupId")]
        public string ManagementGroupId { get; set; }

        /// <summary>
        /// Gets or sets additional, untyped parameters to support custom
        /// subscription creation scenarios.
        /// </summary>
        [JsonProperty(PropertyName = "additionalParameters")]
        public IDictionary<string, object> AdditionalParameters { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (DisplayName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DisplayName");
            }
            if (BillingProfileId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "BillingProfileId");
            }
            if (SkuId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SkuId");
            }
            if (Owner != null)
            {
                Owner.Validate();
            }
        }
    }
}
