// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Subscription.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Subscription Creation Parameters required to create a new Azure
    /// subscription.
    /// </summary>
    public partial class SubscriptionCreationParameters
    {
        /// <summary>
        /// Initializes a new instance of the SubscriptionCreationParameters
        /// class.
        /// </summary>
        public SubscriptionCreationParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SubscriptionCreationParameters
        /// class.
        /// </summary>
        /// <param name="displayName">The display name of the
        /// subscription.</param>
        /// <param name="owners">The list of principals that should be granted
        /// Owner access on the subscription. Principals should be of type
        /// User, Service Principal or Security Group.</param>
        /// <param name="offerType">The offer type of the subscription. For
        /// example, MS-AZR-0017P (EnterpriseAgreement) and MS-AZR-0148P
        /// (EnterpriseAgreement devTest) are available. Only valid when
        /// creating a subscription in a enrollment account scope. Possible
        /// values include: 'MS-AZR-0017P', 'MS-AZR-0148P'</param>
        /// <param name="additionalParameters">Additional, untyped parameters
        /// to support custom subscription creation scenarios.</param>
        public SubscriptionCreationParameters(string displayName = default(string), IList<AdPrincipal> owners = default(IList<AdPrincipal>), string offerType = default(string), IDictionary<string, object> additionalParameters = default(IDictionary<string, object>))
        {
            DisplayName = displayName;
            Owners = owners;
            OfferType = offerType;
            AdditionalParameters = additionalParameters;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the display name of the subscription.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the list of principals that should be granted Owner
        /// access on the subscription. Principals should be of type User,
        /// Service Principal or Security Group.
        /// </summary>
        [JsonProperty(PropertyName = "owners")]
        public IList<AdPrincipal> Owners { get; set; }

        /// <summary>
        /// Gets or sets the offer type of the subscription. For example,
        /// MS-AZR-0017P (EnterpriseAgreement) and MS-AZR-0148P
        /// (EnterpriseAgreement devTest) are available. Only valid when
        /// creating a subscription in a enrollment account scope. Possible
        /// values include: 'MS-AZR-0017P', 'MS-AZR-0148P'
        /// </summary>
        [JsonProperty(PropertyName = "offerType")]
        public string OfferType { get; set; }

        /// <summary>
        /// Gets or sets additional, untyped parameters to support custom
        /// subscription creation scenarios.
        /// </summary>
        [JsonProperty(PropertyName = "additionalParameters")]
        public IDictionary<string, object> AdditionalParameters { get; set; }

    }
}
