// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Support.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Contact information associated with support ticket.
    /// </summary>
    public partial class ContactProfile
    {
        /// <summary>
        /// Initializes a new instance of the ContactProfile class.
        /// </summary>
        public ContactProfile()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ContactProfile class.
        /// </summary>
        /// <param name="firstName">First name.</param>
        /// <param name="lastName">Last name.</param>
        /// <param name="preferredContactMethod">Preferred contact method.
        /// Possible values include: 'email', 'phone'</param>
        /// <param name="primaryEmailAddress">Primary email address.</param>
        /// <param name="preferredTimeZone">Time zone of the user. This is the
        /// name of the time zone from &lt;a  target='_blank'
        /// href='https://support.microsoft.com/en-us/help/973627/microsoft-time-zone-index-values'&gt;Microsoft
        /// Time Zone Index Values&lt;/a&gt;.</param>
        /// <param name="country">Country of the user. This is the ISO 3166-1
        /// alpha-3 code.</param>
        /// <param name="preferredSupportLanguage">Preferred language of
        /// support from Azure. Support languages vary based on the severity
        /// you choose for your support ticket. Learn more at &lt;a
        /// target='_blank'
        /// href='https://azure.microsoft.com/support/plans/response/'&gt;Azure
        /// Severity and responsiveness&lt;/a&gt;. Use the standard
        /// language-country code. Valid values are 'en-us' for English,
        /// 'zh-hans' for Chinese, 'es-es' for Spanish, 'fr-fr' for French,
        /// 'ja-jp' for Japanese, 'ko-kr' for Korean, 'ru-ru' for Russian,
        /// 'pt-br' for Portuguese, 'it-it' for Italian, 'zh-tw' for Chinese
        /// and 'de-de' for German.</param>
        /// <param name="additionalEmailAddresses">Additional email addresses
        /// listed will be copied on any correspondence about the support
        /// ticket.</param>
        /// <param name="phoneNumber">Phone number. This is required if
        /// preferred contact method is phone.</param>
        public ContactProfile(string firstName, string lastName, string preferredContactMethod, string primaryEmailAddress, string preferredTimeZone, string country, string preferredSupportLanguage, IList<string> additionalEmailAddresses = default(IList<string>), string phoneNumber = default(string))
        {
            FirstName = firstName;
            LastName = lastName;
            PreferredContactMethod = preferredContactMethod;
            PrimaryEmailAddress = primaryEmailAddress;
            AdditionalEmailAddresses = additionalEmailAddresses;
            PhoneNumber = phoneNumber;
            PreferredTimeZone = preferredTimeZone;
            Country = country;
            PreferredSupportLanguage = preferredSupportLanguage;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets first name.
        /// </summary>
        [JsonProperty(PropertyName = "firstName")]
        public string FirstName { get; set; }

        /// <summary>
        /// Gets or sets last name.
        /// </summary>
        [JsonProperty(PropertyName = "lastName")]
        public string LastName { get; set; }

        /// <summary>
        /// Gets or sets preferred contact method. Possible values include:
        /// 'email', 'phone'
        /// </summary>
        [JsonProperty(PropertyName = "preferredContactMethod")]
        public string PreferredContactMethod { get; set; }

        /// <summary>
        /// Gets or sets primary email address.
        /// </summary>
        [JsonProperty(PropertyName = "primaryEmailAddress")]
        public string PrimaryEmailAddress { get; set; }

        /// <summary>
        /// Gets or sets additional email addresses listed will be copied on
        /// any correspondence about the support ticket.
        /// </summary>
        [JsonProperty(PropertyName = "additionalEmailAddresses")]
        public IList<string> AdditionalEmailAddresses { get; set; }

        /// <summary>
        /// Gets or sets phone number. This is required if preferred contact
        /// method is phone.
        /// </summary>
        [JsonProperty(PropertyName = "phoneNumber")]
        public string PhoneNumber { get; set; }

        /// <summary>
        /// Gets or sets time zone of the user. This is the name of the time
        /// zone from &amp;lt;a  target='_blank'
        /// href='https://support.microsoft.com/en-us/help/973627/microsoft-time-zone-index-values'&amp;gt;Microsoft
        /// Time Zone Index Values&amp;lt;/a&amp;gt;.
        /// </summary>
        [JsonProperty(PropertyName = "preferredTimeZone")]
        public string PreferredTimeZone { get; set; }

        /// <summary>
        /// Gets or sets country of the user. This is the ISO 3166-1 alpha-3
        /// code.
        /// </summary>
        [JsonProperty(PropertyName = "country")]
        public string Country { get; set; }

        /// <summary>
        /// Gets or sets preferred language of support from Azure. Support
        /// languages vary based on the severity you choose for your support
        /// ticket. Learn more at &amp;lt;a  target='_blank'
        /// href='https://azure.microsoft.com/support/plans/response/'&amp;gt;Azure
        /// Severity and responsiveness&amp;lt;/a&amp;gt;. Use the standard
        /// language-country code. Valid values are 'en-us' for English,
        /// 'zh-hans' for Chinese, 'es-es' for Spanish, 'fr-fr' for French,
        /// 'ja-jp' for Japanese, 'ko-kr' for Korean, 'ru-ru' for Russian,
        /// 'pt-br' for Portuguese, 'it-it' for Italian, 'zh-tw' for Chinese
        /// and 'de-de' for German.
        /// </summary>
        [JsonProperty(PropertyName = "preferredSupportLanguage")]
        public string PreferredSupportLanguage { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (FirstName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "FirstName");
            }
            if (LastName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LastName");
            }
            if (PreferredContactMethod == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PreferredContactMethod");
            }
            if (PrimaryEmailAddress == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PrimaryEmailAddress");
            }
            if (PreferredTimeZone == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PreferredTimeZone");
            }
            if (Country == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Country");
            }
            if (PreferredSupportLanguage == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PreferredSupportLanguage");
            }
        }
    }
}
