// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.Support.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Service Level Agreement details for a support ticket.
    /// </summary>
    public partial class ServiceLevelAgreement
    {
        /// <summary>
        /// Initializes a new instance of the ServiceLevelAgreement class.
        /// </summary>
        public ServiceLevelAgreement()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServiceLevelAgreement class.
        /// </summary>
        /// <param name="startTime">Time in UTC (ISO 8601 format) when service
        /// level agreement starts.</param>
        /// <param name="expirationTime">Time in UTC (ISO 8601 format) when
        /// service level agreement expires.</param>
        /// <param name="slaMinutes">Service Level Agreement in minutes</param>
        public ServiceLevelAgreement(System.DateTime? startTime = default(System.DateTime?), System.DateTime? expirationTime = default(System.DateTime?), int? slaMinutes = default(int?))
        {
            StartTime = startTime;
            ExpirationTime = expirationTime;
            SlaMinutes = slaMinutes;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets time in UTC (ISO 8601 format) when service level agreement
        /// starts.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; private set; }

        /// <summary>
        /// Gets time in UTC (ISO 8601 format) when service level agreement
        /// expires.
        /// </summary>
        [JsonProperty(PropertyName = "expirationTime")]
        public System.DateTime? ExpirationTime { get; private set; }

        /// <summary>
        /// Gets service Level Agreement in minutes
        /// </summary>
        [JsonProperty(PropertyName = "slaMinutes")]
        public int? SlaMinutes { get; private set; }

    }
}
