// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Azure.Management.WebSites.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Container settings validation request context
    /// </summary>
    public partial class ValidateContainerSettingsRequest
    {
        /// <summary>
        /// Initializes a new instance of the ValidateContainerSettingsRequest
        /// class.
        /// </summary>
        public ValidateContainerSettingsRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ValidateContainerSettingsRequest
        /// class.
        /// </summary>
        /// <param name="baseUrl">Base URL of the container registry</param>
        /// <param name="username">Username for to access the container
        /// registry</param>
        /// <param name="password">Password for to access the container
        /// registry</param>
        /// <param name="repository">Repository name (image name)</param>
        /// <param name="tag">Image tag</param>
        /// <param name="platform">Platform (windows or linux)</param>
        public ValidateContainerSettingsRequest(string baseUrl = default(string), string username = default(string), string password = default(string), string repository = default(string), string tag = default(string), string platform = default(string))
        {
            BaseUrl = baseUrl;
            Username = username;
            Password = password;
            Repository = repository;
            Tag = tag;
            Platform = platform;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets base URL of the container registry
        /// </summary>
        [JsonProperty(PropertyName = "baseUrl")]
        public string BaseUrl { get; set; }

        /// <summary>
        /// Gets or sets username for to access the container registry
        /// </summary>
        [JsonProperty(PropertyName = "username")]
        public string Username { get; set; }

        /// <summary>
        /// Gets or sets password for to access the container registry
        /// </summary>
        [JsonProperty(PropertyName = "password")]
        public string Password { get; set; }

        /// <summary>
        /// Gets or sets repository name (image name)
        /// </summary>
        [JsonProperty(PropertyName = "repository")]
        public string Repository { get; set; }

        /// <summary>
        /// Gets or sets image tag
        /// </summary>
        [JsonProperty(PropertyName = "tag")]
        public string Tag { get; set; }

        /// <summary>
        /// Gets or sets platform (windows or linux)
        /// </summary>
        [JsonProperty(PropertyName = "platform")]
        public string Platform { get; set; }

    }
}
